module(...,package.seeall)
local date = require ( tweety_modules_prefix .. "tweety_date" )
local rpwidget = require ( tweety_modules_prefix .. "rpwidget" )

datasource = require (tweety_modules_prefix .. "datasource")

local function _T ( str ) return str end

local function iff(cond,iftrue,iffalse)
	if cond then
		return iftrue
	else
		return iffalse
	end
end
local function deepcopy(object)
	local lookup_table = {}
	local function _copy(object)
		if type(object) ~= "table" then
			return object
		elseif lookup_table[object] then
			return lookup_table[object]
		end
		local new_table = {}
		lookup_table[object] = new_table
		for index, value in pairs(object) do
			new_table[_copy(index)] = _copy(value)
		end
		return setmetatable(new_table, getmetatable(object))
	end
	return _copy(object)
end

local lineColor = "#c0c0c0";
--local lineColor = "black";

local grayColor = "#d0d0d0";
local grandTotalKey = "grandtotal";
local tinsert = table.insert
local tconcat = table.concat
local tonumber = tonumber;
local ipairs = ipairs;
function BIBuckets (self)
	self = self or {}

	local dataBuckets = {	}

	local mink ={}
	local maxk ={}

	function self:buckets(locations)
		local res={}
		for _,k in pairs(locations) do
			local t = dataBuckets[k];
			if not t then
				t = {}
				dataBuckets[k] = t
			end
			tinsert(res,t)
		end
		return res;
	end

	function self:locations (...)

		local t = {grandTotalKey}
		local res = {}
		local args = {...}
		local ckmin=true
		local ckmax=true
		tinsert(res,tconcat(t,":"))
		for p,v in ipairs(args) do

			if ckmin and mink ~= args then
				if not mink[p] or mink[p]> v then
					mink=args
				else
					if mink[p] < v then
						ckmin=false;
					end
				end
			end
			if ckmax and maxk ~= args then
				if not maxk[p] or maxk[p]< v then
					maxk=args
				else
					if maxk[p] > v then
						ckmax=false;
					end
				end
			end

			tinsert(t,tostring(v))
			tinsert(res,tconcat(t,":"))

		end
		return res;
	end
	function self:minKey ()
		return mink
	end
	function self:maxKey ()
		return maxk
	end
	return self;
end


function BITimeScale ( self )
	self = rpwidget.panel(self)
	self.isTimeScale = true;
	local days = {_T("Sunday"),_T("Monday"),_T("Tuesday"),_T("Wednesday"),_T("Thursday"),_T("Friday"),_T("Saturday")};
	local months = {_T("January"),_T("February"),_T("March"),_T("April"),_T("May"),_T("June"),_T("July"),_T("August"),_T("September"),_T("October"),_T("November"),_T("December")};

	self.daysOddColor=self.daysOddColor or 'white'
	self.daysEvenColor=self.daysEvenColor or grayColor
	self.dailyTotalBackColor=self.dailyTotalBackColor or '#fafffa'
	self.hoursOddColor=self.hoursOddColor or 'white'
	self.hoursEvenColor=self.hoursEvenColor or grayColor

	self.monthsOddColor=self.monthsOddColor or 'white'
	self.monthsEvenColor=self.monthsEvenColor or grayColor
	self.monthlyTotalBackColor=self.monthlyTotalBackColor or  grayColor
	self.yearsOddColor=self.yearsOddColor or 'white'
	self.yearsEvenColor=self.yearsEvenColor or grayColor

	if not self.hourly and not self.daily and  not self.monthly and not self.yearly then
		self.daily = true;
	end
	local columns ={}
	local guiLayer

	function self:getGui (minWidth,startKey,endKey,bottomBorder)
		local spaceLeft;
		local hourCellWidth = 40;
		local dayCellWidth = 40;
		local dailyTotalCellWidth = 70;
		local dayOfWeekCellWidth = 80; -- para cuando es dayOfWeek
		local monthCellWidth=40;
		local monthlyTotalCellWidth=70;
		local yearCellWidth=40;
		local yearlyTotalCellWidth=70;
		local monthCellWidthWithName=80;
		local grandTotalCellWidth=70;

		local hoursCount=0;
		local daysCount=0;
		local monthsCount=0;
		local yearsCount=0;

		local hoursPanel;
		local daysPanel;
		local monthsPanel;
		local yearsPanel;
		local startTime,endTime;


--		if not self.grandTotal then
			startTime =  date(startKey[1],startKey[2],startKey[3],startKey[4]);
			endKey = endKey  or { startKey[1],startKey[2],startKey[3],startKey[4]}
			endTime = date(endKey[1],endKey[2],endKey[3],endKey[4]);
--		end

--[[
		else
			startTime =  date(startKey[2],startKey[3],startKey[4],startKey[5]);
			if endKey then
				endKey = { endKey[2],endKey[3],endKey[4],endKey[5]}
			else
				endKey = { startKey[2],startKey[3],startKey[4],startKey[5]}
			end
		end
--]]
		endTime = date(endKey[1],endKey[2],endKey[3],endKey[4]);

		local firstMonthCellWidth; -- para calcular el desplazamiento de la linea de tiempo en aos


		local insertTotal = function(w,rows)
			local  tg
			for  _,row in ipairs(rows)  do
				if row ~=-1 then
					tg = row;
				end
			end
			tinsert(tg.childs,w)
			w.gaps = {}
			w.isTotal = true;
			local c =0;
			for n,row in ipairs(rows) do
				if tg~=row and row ~=-1 then
					c=c+1
					local g = rpwidget.label({
						caption=_T("."),
						sideBottom=true,
						grandTotal = w.grandTotal,
						gap = true,
						rowType = row.rowType,
						align='center',width=w.width,foreColor=w.backColor,backColor=w.backColor})
					table.insert(w.gaps,g);
					tinsert(row.childs,g);
				end
			end
		end


		local dateCounter = date(startTime)


		local res = rpwidget.panel({backColor='white'});

		if self.yearly then
			yearsPanel = rpwidget.panel({hs=0,pl=0,layoutMode='horizontal',rowType="year"})
		end
		if	self.monthly then
			monthsPanel = rpwidget.panel({hs=0,pl=0,layoutMode='horizontal',rowType="month"})
		end
		if self.daily then
			daysPanel = rpwidget.panel({pl=0,hs=0,layoutMode='horizontal',rowType="day"})
		end
		if self.hourly then
			hoursPanel = rpwidget.panel({hs=0,pl=0,layoutMode='horizontal',rowType="hour"});
		end

		spaceLeft = 0;--minWidth;


		local pd,pm,py;
		local dayCol,monthCol,yearCol;
		local firstHourOfDay = true;
		local  firstDayOfMonth=true;
		if self.grandTotal then
			insertTotal(
				rpwidget.label({	caption=_T("Total"),
						sideBottom=true,
						align='center',
						grandTotal = true,
						borderWidth=0,
						borderColor=lineColor,
						width=grandTotalCellWidth,
						backColor="white"
				}),
				{yearsPanel or -1,monthsPanel or -1,daysPanel or -1,hoursPanel or -1},true
			)
			tinsert(columns,{width=grandTotalCellWidth,keys={}})
		end

		while spaceLeft>0 or (dateCounter < endTime or dateCounter == endTime) do -- dateCounter <= endTime no funciona bien
			local y = dateCounter:getyear();
			local m = dateCounter:getmonth();
			local d = dateCounter:getday();
			local h = dateCounter:gethours();
			if((self.daily or self.hourly or self.monthly) and self.yearlyTotals and py ~= y) then

				insertTotal(

					rpwidget.label({	caption=_T("Total"),

							sideBottom=true,
							align='center',
							width=yearlyTotalCellWidth,
							backColor=iff(math.fmod(yearsCount,2)==0,self.yearsOddColor,self.yearsEvenColor),
							totalOfCell = iff(self.yearly,"year")
					}),
					{yearsPanel or -1,monthsPanel or -1,daysPanel or -1,hoursPanel or -1}
				)
				tinsert(columns,{width=yearlyTotalCellWidth,keys={y}})
				if not self.yearly then
					py=y;
				end
			end

			if self.yearly and py ~= y then
				py=y;
				if self.hourly or self.daily or self.monthly then
					yearCellWidth=0;
				end
				yearCol = rpwidget.label({
					caption=y,
					align='center',
					sideBottom=true,
					width=yearCellWidth,
					backColor=iff(math.fmod(yearsCount,2)==0,self.yearsOddColor,self.yearsEvenColor),
					colType = "year";
				})
				if not self.monthly and not self.daily and not self.hourly then
					tinsert(columns,{width=yearCellWidth,keys={y}})
				end

				tinsert(yearsPanel.childs,yearCol)
				yearsCount = yearsCount+1;
			end

			if (self.daily or self.hourly) and self.monthlyTotals and pm ~= m then
				insertTotal(
					rpwidget.label({caption=_T("Total"),multiLine=true,align='center',sideBottom=true,width=monthlyTotalCellWidth,backColor=iff(math.fmod(monthsCount,2)==0,self.monthsOddColor,self.monthsEvenColor),
					totalOfCell = iff(self.monthly,"month")

					}),

					{monthsPanel or -1,daysPanel or -1,hoursPanel or -1}
				)
				tinsert(columns,{width=monthlyTotalCellWidth,keys={y,m}})

				if not self.monthly then
					pm=m;
				end
			end

			if self.monthly and pm ~= m then
				pm=m;
				if self.hourly or self.daily then
					monthCellWidth=0;
				else
					if self.monthName then
						monthCellWidth=monthCellWidthWithName;
					end
				end
				if self.monthName then
					monthCol = rpwidget.label({caption=months[m],align='center',sideBottom=true,width=monthCellWidth,backColor=iff(math.fmod(monthsCount,2)==0,self.monthsOddColor,self.monthsEvenColor),
						colType = "month"
					})
				else
					monthCol = rpwidget.label({caption='' .. (m),align='center',sideBottom=true,width=monthCellWidth,backColor=iff(math.fmod(monthsCount,2)==0,self.monthsOddColor,self.monthsEvenColor),
						colType = "month"
					})
				end
				tinsert(monthsPanel.childs,monthCol)
				if not self.daily and not self.hourly then
					tinsert(columns,{width=monthCellWidth,keys={y,m}})
				end
				monthsCount = monthsCount+1;
			end

			if self.hourly and self.dailyTotals and pd~=d then
				insertTotal(
					rpwidget.label({caption=_T("Total"),sideBottom=true,align='center',width=dailyTotalCellWidth,backColor=iff(math.fmod(daysCount,2)==0,self.daysOddColor,self.daysEvenColor),
						totalOfCell = iff(self.daily,"day")

					}),
					{daysPanel or -1,hoursPanel or -1}
				)
				tinsert(columns,{width=dailyTotalCellWidth,keys={y,m,d}})

				if not self.daily then
					pd=d;

				end
			end

			if self.daily and pd ~= d then
				pd=d;
				if self.hourly then
					dayCellWidth=0;
				else
					if self.dayOfWeek then
						dayCellWidth=dayOfWeekCellWidth;
					end
				end

				if self.dayOfWeek then
					local dw = dateCounter:getweekday();
					dayCol = rpwidget.label({toolTip=days[dw] ..  " " .. d,sideBottom=true,caption=days[dw] ..  " " .. d,align='center',width=dayCellWidth,backColor=iff(math.fmod(daysCount,2)==0,
						self.daysOddColor,self.daysEvenColor),
						colType = "day"
					});
				else
					dayCol = rpwidget.label({caption='' .. d,align='center',sideBottom=true,width=dayCellWidth,backColor=iff(math.fmod(daysCount,2)==0,self.daysOddColor,self.daysEvenColor),
						colType = "day"
					});
				end
				if not self.hourly then
					tinsert(columns,{width=dayCellWidth,keys={y,m,d}})

				end
				tinsert(daysPanel.childs,dayCol)
				daysCount = daysCount+1;
			end



			if self.hourly then
				tinsert(hoursPanel.childs,rpwidget.label({caption=h,align='center',sideBottom=true,width=hourCellWidth,backColor=iff(math.fmod(hoursCount,2)==0,self.hoursOddColor,self.hoursEvenColor),colType = "hour"}));
				tinsert(columns,{width=hourCellWidth,keys={y,m,d,h}})
				if dayCol then
					dayCol.width = dayCol.width + hourCellWidth;
				end

				if monthCol then
					monthCol.width = monthCol.width + hourCellWidth;
					if self.dailyTotals and firstHourOfDay  then
						monthCol.width = monthCol.width+dailyTotalCellWidth;
					end
				end
				if yearCol then
					yearCol.width =yearCol.width + hourCellWidth;

					if self.dailyTotals and firstHourOfDay  then
						yearCol.width = yearCol.width+ dailyTotalCellWidth;
					end

					if self.monthlyTotals and firstDayOfMonth then
						yearCol.width=yearCol.width+monthlyTotalCellWidth;
					end
				end
				hoursCount=hoursCount+1;
				spaceLeft = spaceLeft-hourCellWidth;
				dateCounter:sethours(h+1);


			elseif self.daily then

				if monthCol then
					monthCol.width=monthCol.width+dayCellWidth;
				end

				if yearCol then
					yearCol.width = yearCol.width + dayCellWidth;
					if self.monthlyTotals and firstDayOfMonth then
						yearCol.width = yearCol.width + monthlyTotalCellWidth;
					end
				end

				spaceLeft=spaceLeft-dayCellWidth;
				dateCounter:setday(d+1);

			elseif self.monthly then
				if yearCol then
					yearCol.width= yearCol.width+ monthCellWidth;
				end
				spaceLeft= spaceLeft - monthCellWidth;
				dateCounter:setmonth(m+1);
			elseif self.yearly  then
				spaceLeft= spaceLeft- yearCellWidth;
				dateCounter:setyear(y+1);
			end
			firstHourOfDay=dateCounter:gethours()==0;
			firstDayOfMonth=dateCounter:getday()==1;
			firstMonthOfYear = dateCounter:getmonth()==1;
		end
		local function setBorders ( row )
			local p
			for n,c in ipairs(row.childs) do
				if c.grandTotal then
					c.borderColor = lineColor;
					c.borderWidth =1
					if not c.gap then
						c.borderLeft = true;
						c.borderTop = true;
					end
					c.borderRight=true;
				elseif c.isTotal then

					-- es la primera ?
					c.borderColor = lineColor;
					if n == 1 then
						c.borderWidth =1
						c.borderLeft=true
					end
					c.borderWidth=1;
					c.borderRight=true;
					if c.totalOfCell then
						for m,g in ipairs(c.gaps) do

							g.borderColor=lineColor;
							if n == 1 then
								g.borderWidth=1;
								g.borderLeft=true;
							end
							if g.rowType ~= c.totalOfCell then
								g.borderWidth=1;
								g.borderRight=true;

							end
							if m == 1 then
								g.borderWidth=1;
								g.borderTop = true;
							end
						end
					else
						c.borderWidth=1;
						c.borderTop = true;
						local ne = row.childs[n+1]
				--		if ne and not ne.isTotal then

							for m,g in ipairs(c.gaps or {}) do
								g.borderColor=lineColor;
								g.borderWidth=1;
								g.borderRight=true;
							end
				--		end
					

					end
				elseif not c.gap then
					c.borderColor = lineColor;
					c.borderWidth=1;
					c.borderTop = true;
					c.borderRight=true;
					if n == 1 then
						c.borderLeft = true;
					end

				end
				p = c;
			end
		end
		if yearsPanel then
			setBorders(yearsPanel);
			tinsert(res.childs,yearsPanel)
		end

		if monthsPanel then
			setBorders(monthsPanel);
			tinsert(res.childs,monthsPanel)
		end

		if daysPanel then
			setBorders(daysPanel);
			tinsert(res.childs,daysPanel);
		end

		if hoursPanel then
			setBorders(hoursPanel);
			tinsert(res.childs,hoursPanel);
		end
		if bottomBorder then
			for idx,child in ipairs(res.childs[#res.childs].childs) do
				child.borderWidth=1;
				child.borderColor=lineColor;
				child.borderBottom=true;
			end
		end
--		for idx,child in ipairs(res.childs) do
--			child.borderBottom = iff(idx < #res.childs,true,false)
--			child.borderWidth = iff(idx < #res.childs,1,0)

--			child.borderBottom = true
--			child.borderWidth = 1
--			child.borderColor = lineColor;

--		end
		res.height = res:getHeight();
		res.width  = res:getWidth();
		res:layout();
		return res;
	end
	function self:keysForData(rec,map)
		local d = rec[map['timeStamp']]
		if d then
			local r,d = pcall(date,d)
			local res = {}
			if r then
--				return {
--					(d:getyear()*8928)+ (d:getmonth() * 744 ) +  (d:getday() * 24) ,
--					d:gethours()
--				}

				return {d:getyear(),d:getmonth(),d:getday(),d:gethours()}
			end
		end
		return {}
	end
	function self:getColumns()
		return columns;
	end

	return self

end
local buildWidget;
-------------------------------------------------------------------------------------
local function buildPanel (widgetData)
	local childs = widgetData.childs or {}
	local self = rpwidget.panel(widgetData)
	self.childs = {}
	for _,cl in ipairs(childs) do
		tinsert(self.childs,buildWidget(cl))
	end
	return self
end

buildWidget = function (widgetData)
	widgetData = deepcopy(widgetData);
	if widgetData.type == "ui.panel" then
		return buildPanel(widgetData)
	elseif widgetData.type == "ui.label" or widgetData.type == "ui.row" or widgetData.type == "calculatedField" then
		return rpwidget.label(widgetData)
	elseif widgetData.type == "ui.image" then
		return rpwidget.image(widgetData)
	elseif widgetData.type == "ui.hline" then
		return rpwidget.hline(widgetData)
	elseif widgetData.type == "ui.vline" then
		return rpwidget.vline(widgetData)
	else
		LogDebug("Unknown node type %s",widgetData.type)
	end

end

function BIRow(self,Application,scale,rowId)

	local function sum (entity,value,buckets)
		value = tonumber(value) or 0
		for _,b in ipairs(buckets) do
			b[entity] = b[entity] or {}
			b[entity].value = (b[entity].value or 0)+value;
			b[rowId] = b[entity].value;
		end
	end

	local  function min (entity, value , buckets)
		value = tonumber(value) or 0
		for _,b in ipairs(buckets) do
			b[entity] = b[entity] or {}
			if b[entity].value then
				if b[entity].value > value then
				   b[entity].value = value
				end
			else
				b[entity].value = value
			end
			b[rowId] = b[entity].value;
		end
	end

	local function max ( entity,value , buckets)
		value = tonumber(value) or 0
		for _,b in ipairs(buckets) do
			b[entity] = b[entity] or {}

			if b[entity].value then
				if b[entity].value < value then
					b[entity].value = value
				end
			else
				b[entity].value = value
			end
			b[rowId] = b[entity].value;
		end
	end

	local function avg ( entity,value , buckets)
		value = tonumber(value) or 0
		for idx,b in ipairs(buckets) do
			b[entity] = b[entity] or {}
			b[entity].count = b[entity].count or 0
			b[entity].count = b[entity].count+1
			b[entity].total = b[entity].total or 0
			b[entity].total = b[entity].total + value
			b[entity].value = b[entity].total / b[entity].count
			b[rowId] = b[entity].value;
		end

	end
	local subrows ={}
	function self:getSubRows()
		local res = {}
		for _,subrow in pairs(subrows) do
			tinsert(res,
				BIRow{
					type = "labelsubrow",
					width=self.width,
					id = subrow.id,
					rowid = self.id,
					caption=" " .. subrow.caption,
					expresion = self.expresion,
--					font = self.font,
					format = self.format,
					decimals = self.decimals

				}
			);
		end
		table.sort(res,function(a,b) return a.caption < b.caption end)
		return res;
	end
	function self:getGui(captionColumnWidth,BIBuckets,dataColumns,rowNum,islastRow,rowHeader)

		if self.type == "ui.row" and (self.source and self.source.datasource) or self.type == "labelsubrow" or self.expresion then
			local subRows = self:getSubRows()
			local res
			if #subRows>0 then

				res = rpwidget.panel({
					x=self.x,
					layoutMode="vertical",
				});
				if self.header and rowNum ~= 1 then

					local h = deepcopy(rowHeader)
					h.x = nil;
					h.y = nil;
					h.borderWidth=1;
					h.borderColor=lineColor;
					h.borderBottom=true;
					h.overflow="hidden";
					table.insert(res.childs,rpwidget.panel({
						layoutMode="horizontal",
						childs={
							rpwidget.label({
								caption= self.caption,
								width=captionColumnWidth,
								backColor=self.backColor,
								foreColor=self.foreColor,
								font = self.font,
								borderColor=lineColor,
								borderWidth=1,
								borderTop=true,
								borderLeft=true,
								borderRight=true

							}),
							h
						}
					}))
				else
					tinsert(res.childs,rpwidget.label({
						caption= self.caption,
						fillWidth=true,
						backColor=self.backColor,
						foreColor=self.foreColor,
						font = self.font,
						height=self.height,
						align=self.align,
						borderWidth=1,
						borderTop=true,
						borderLeft=true,
						borderRight=true,
						borderColor=lineColor

					}))
				end

				for idx,subrow in ipairs(subRows) do
					tinsert(res.childs,subrow:getGui(captionColumnWidth,BIBuckets,dataColumns,rowNum-1+idx,idx == #subRows))
				end
				if self.grandTotal then
					tinsert(res.childs,
						BIRow{
							type = "labelsubrow",
							width=self.width,
							x=0;
							id = self.id,
							rowid = self.id,
							caption= _T("Total"),
							expresion = self.expresion,
							backColor=self.backColor,
							foreColor=self.foreColor,
							font = self.font,
							format = self.format,
							decimals = self.decimals
						}:getGui(captionColumnWidth,BIBuckets,dataColumns,#subRows+1,false))
				end
				for n,c in ipairs(res.childs) do
					if c.layoutMode == "horizontal" then
						for m,cc in ipairs(c.childs or {}) do
							cc.borderWidth=1;
							cc.borderRight = true;
							cc.borderTop=true;
							cc.borderColor = lineColor;
							if m == 1 then
								cc.borderLeft = true;
							end
							if n == #res.childs then
								cc.borderBottom = true;
							end

						end
					end
				end
			else
				local cnt;
				if self.header and rowNum > 1 then
					local h = deepcopy(rowHeader)
					
					h.x = captionColumnWidth;
					h.y = nil;
					h.overflow="hidden";
					for _,c in ipairs(h.childs) do
						c.borderBottom=false;
						c.borderTop=true;
					end
					res = rpwidget.panel({
						x=self.x,
						haveHeader=true,
						backColor=self.backColor,
						foreColor=self.foreColor,
						layoutMode="vertical",
						pt=3,
						childs={
							h
						}
					});
					cnt = rpwidget.panel({
						x=self.x,
					
						backColor=self.backColor,
						foreColor=self.foreColor,
						layoutMode="horizontal"
					});
					table.insert(res.childs,cnt);
				else
					res = rpwidget.panel({
						x=self.x,
					
						backColor=self.backColor,
						foreColor=self.foreColor,
						layoutMode="horizontal"
					});
					cnt = res;
				end
				self.caption =  (self.caption or "" )
				local col1 = rpwidget.label(self)
				col1.width = captionColumnWidth;
				tinsert(cnt.childs,col1)

				for _,colData in ipairs(dataColumns) do
					local keys = colData.keys;
					local buckets = BIBuckets:buckets(BIBuckets:locations(unpack(keys)))
					tinsert(cnt.childs,
						rpwidget.label({
							align="right",
							caption=((buckets[#keys+1] or {})[self.id] or {}).value or "",
							width=colData.width,
							height=self:getHeight(),
							format = self.format,
							decimals = self.decimals,
							font = self.font,
	--						borderColor = lineColor,
	--						borderRight=true,
	--						borderTop=true;
	--						borderWidth=1
						})
					)
				end
			end


			return res;
		else
			local width = captionColumnWidth;
			for _,c in ipairs(dataColumns) do
				width = width + c.width;
			end
			self.width = width;
			self.x = nil
			self.y = nil
			if self.type ~= "ui.hline" and self.type ~= "ui.vline" then
				self.borderTop = true;
				--self.borderLeft = true;
				--self.borderRight = true;
				self.borderWidth=1;
				self.borderColor = lineColor;
			end
			return buildWidget(self);
		end


	end
	local proc;
	function self:validateRecord(rec)
		local err
		if self.source.dataValid == "always" then
			return true
		elseif self.source.dataValid == "field" and self.source.validFieldName and self.source.dataValidFieldOperator and self.source.dataValidFieldExpr then
			local l = tonumber(rec[self.source.validFieldName]) or rec[self.source.validFieldName]
			local r
			if type (l) == "number" then
				r = tonumber(self.source.dataValidFieldExpr) or self.source.dataValidFieldExpr
				if type(r) ~= "number" then
					l = rec[self.source.validFieldName]
				end
			else
				r = self.source.dataValidFieldExpr
			end
			if self.source.dataValidFieldOperator == "==" then
				return l == r
			elseif self.source.dataValidFieldOperator == ">" then
				return l > r
			elseif self.source.dataValidFieldOperator == ">=" then
				return l >= r
			elseif self.source.dataValidFieldOperator == "<" then
				return l < r
			elseif self.source.dataValidFieldOperator == "<=" then
				return l <= r
			elseif self.source.dataValidFieldOperator == "!=" then
				return l ~= r
			end
		elseif self.source.dataValid == "expr" and self.source.dataValidExpr then
			local env = {
				tostring = tostring;
				tonumber = tonumber;
				str = tostring;
				num = tonumber;
				type = type;
				fmt = string.format,
				iif = function(cond,rtrue,rfalse)
					if cond == true then
						return rtrue
					else
						return rfalse
					end
				end;
			}

			for k,v in pairs(rec) do
				env[k] = v;
			end

			if not proc then
				proc,err = loadstring("return " .. self.source.dataValidExpr )
			end

			if proc then
				setfenv(proc,env)
				local result,value = pcall(proc)
				if result then
					return value
				end
			end
		end
		return false;
	end
	local function buildDatasourceParameters(ds,reportParams)
		local content = {}
		local res = {parameters=content}
		local hparams = {}
		for _,param in ipairs(reportParams) do
			hparams[param.name] = param.value
		end

		if ds.description.retrieve.enabled then
			-- buscamos los parametros de retrieve que
			-- sean obligatorios
			for _,param in ipairs(ds.description.retrieve.inputParams) do
				-- si no esta mapeado a una columna y no permite nulos
				-- es requerido siempre
				local found = false;

				if param.column then
					for _,criteria in ipairs(
						(((ds.description.filters or {{}})[1] or {}).criteria or {})

						) do
						if param.column == criteria.column  then --
							if criteria.expr and string.sub(criteria.expr,1,1) == "@"  then
								tinsert(content,{name=criteria.column .. criteria.expr,value = hparams[criteria.expr],type=param.type})
								tinsert(content,{name=criteria.column,value = hparams[criteria.expr],type=param.type})

								found = true;
							end
						end
					end
				end
				if not found then
					tinsert(content,{name=param.column,value = hparams[param.column],type = param.type})
				end
			end
		end

		if ds.description.filters and ds.description.filters[1] then
			res.filter = ds.description.filters[1].name
		end
		return res;
	end

	local processfn;
	function self:processRecord(rec,dataBuckets)
		local source = self.source;
		if not processfn then
			if source.datasource then
				if source.fieldDataOperation == "sum" or source.sourceType == "recordCount" then
					processfn = sum
				elseif source.fieldDataOperation == "min" then
					processfn = min
				elseif source.fieldDataOperation == "max" then
					processfn = max
				elseif source.fieldDataOperation == "avg" then
					processfn = avg;
				end
			end
		end
		local keys = scale:keysForData(rec,source.scaleFields)
		local locations = dataBuckets:locations(unpack(keys))
		local buckets = dataBuckets:buckets(locations)
		local subrowid;
		if  self:validateRecord(rec) then -- VALIDACION del registro
			if source.subCategoryField then
				subrowid  = self.id .. "." .. (rec[source.subCategoryField] or "")
				subrows[subrowid] = {id=subrowid,caption = rec[source.subCategoryField] or ""};
			end
			if source.sourceType == "recordCount" then
				if subrowid then
					processfn(subrowid,1,buckets)
				end
				processfn(self.id,1,buckets)
			else
				if subrowid then
					processfn(subrowid,tonumber(rec[source.fieldName] or 0),buckets)
				end
				processfn(self.id,tonumber(rec[source.fieldName] or 0),buckets)
			end
		end
	end

	function self:loadData(reportParams,dataBuckets)
		local fn
		if self.source then
			local source = self.source;
			if source.datasource then
				if source.fieldDataOperation == "sum" or source.sourceType == "recordCount" then
					fn = sum
				elseif source.fieldDataOperation == "min" then
					fn = min
				elseif source.fieldDataOperation == "max" then
					fn = max
				elseif source.fieldDataOperation == "avg" then
					fn = avg;
				end
				local id = self.id;
				local status,ds = datasource.buildDatasource(Application:getVCCName(),Application:getName(),source.datasource,"retrieve")
				if status then


					if ds.description.retrieve.enabled and ds.cursor then	-- si se puede hacer retrieve ,y ademas tiene el nuevo metodo cursor lo damos como valido
						local rec
						local params = buildDatasourceParameters(ds,reportParams)
						if scale.isTimeScale then	-- por cada parametro de tipo date o datetime
													-- hace una marca en la escala de tiempo para que quede bien delimitada
							for _,param in ipairs(params.parameters) do
								if param.type == "date" or param.type == "datetime" then
									local r,d = pcall(date,param.value)
									if r then
										dataBuckets:locations(d:getyear(),d:getmonth(),d:getday(),d:gethours());
									end
								end
							end
						end

						local status,ite = ds:cursor(params)
						if status then

							while not ite.eof() do
								rec =ite.next();

								local keys = scale:keysForData(rec,source.scaleFields)
								local locations = dataBuckets:locations(unpack(keys))
								local buckets = dataBuckets:buckets(locations)
								local subrowid;
								if  self:validateRecord(rec) then -- VALIDACION del registro

									if source.subCategoryField then
										subrowid  = self.id .. "." .. (rec[source.subCategoryField] or "")
										subrows[subrowid] = {id=subrowid,caption = rec[source.subCategoryField] or ""};
									end

									if source.sourceType == "recordCount" then
										if subrowid then
											fn(subrowid,1,buckets)
										end
										fn(id,1,buckets)
									else
										if subrowid then
											fn(subrowid,tonumber(rec[source.fieldName] or 0),buckets)
										end
										fn(id,tonumber(rec[source.fieldName] or 0),buckets)
									end
								end

							end
						end

					end

				end
			end
		end

	end
	function self:evalExpresion(reportParams,BIBuckets,dataColumns)
		-- quita la jerarquia que pueda tener la expresion objeto.objeto
		-- y la convierte a objeto_objeto dejando fuera las expresiones
		-- entre comillas y apostrofes
		local function plainexpr(expr)
			local strs={}
			string.gsub(expr,"()([\"'][^\"']*[\"'])",function(pos,str)
				strs[pos] = str
			end)
			expr =string.gsub(expr,"([%a%d])([%.])([%a])","%1_%3");
--			expr =string.gsub(expr," ","_");

			expr= string.gsub(expr,"()([\"'][^\"']*[\"'])",function(pos,str)
				return strs[pos]
			end)
			return expr;
		end



		if self.expresion then
			for _,colData in ipairs(dataColumns) do
				local keys = colData.keys;
				local buckets = BIBuckets:buckets(BIBuckets:locations(unpack(keys)))
--				if buckets[#keys][rowId] then -- si ya hay un valor es porque fue resuelto
--					break
--				end
				local env = {
					tostring = tostring;
					tonumber = tonumber;
					str = tostring;
					num = tonumber;
					type = type;
					fmt = string.format,
					iif = function(cond,rtrue,rfalse)
						if cond == true then
							return rtrue
						else
							return rfalse
						end
					end;
					getmetatable = getmetatable
				}
				for _,param in ipairs(reportParams) do
					env[string.gsub(param.name,"@","")] = param.value;
				end
				self.expresion = string.gsub(self.expresion or "","@","");
				for k,v in pairs(buckets[#keys+1] or {}) do
					k = plainexpr(k)
					if type(v) ~= "table" then
						env[k] = v
					else
						env[k] = v.value;
					end
				end

				if self.type == "labelsubrow" then
					env[self.rowid] = env[plainexpr(self.id)];
				end
				local proc,err = loadstring("return " .. plainexpr(self.expresion))
				if proc then
					local mt = getmetatable("")
					local __add = mt.__add
					mt.__sadd = function(a,b)
						if tonumber(a) and tonumber(b) then
							return tostring(tonumber(a) + tonumber(b))
						else
							if a and b then
								return tostring(a) .. tostring(b)
							end
						end
					end
					setfenv(proc,env)
					local result,value = pcall(proc)
					mt.__add = __add
					if not result then
						value = ""
					end
					if rowId then
						buckets[#keys+1][rowId]=value;
					end
					buckets[#keys+1][self.id] = buckets[#keys+1][self.id] or {}
					(buckets[#keys+1][self.id]).value = value;
				else
					buckets[#keys+1][self.id] = buckets[#keys+1][self.id] or {}
					(buckets[#keys+1][self.id]).value = ""

				end

			end
		end
	end

	return self;
end

function dataTable(vccName,appName,entityList)
	local self = BIBuckets{}

	function self:buildData(reportParams)


		for _,entity in ipairs(entityList) do
			entity:loadData(reportParams,self);
		end
	end
	local function buildDatasourceParameters(ds,reportParams)
		local content = {}
		local res = {parameters=content}
		local hparams = {}
		for _,param in ipairs(reportParams) do
			hparams[param.name] = param.value
		end
		if ds.description.retrieve.enabled then
			-- buscamos los parametros de retrieve que
			-- sean obligatorios
			for _,param in ipairs(ds.description.retrieve.inputParams) do
				-- si no esta mapeado a una columna y no permite nulos
				-- es requerido siempre
				local found = false;

				if param.column then
					for _,criteria in ipairs(
						(((ds.description.filters or {{}})[1] or {}).criteria or {})

						) do
						if param.column == criteria.column  then --
							if criteria.expr and string.sub(criteria.expr,1,1) == "@"  then
								tinsert(content,{name=criteria.column .. criteria.expr,value = hparams[criteria.expr],type=param.type})
								tinsert(content,{name=criteria.column,value = hparams[criteria.expr],type=param.type})

								found = true;
							end
						end
					end
				end
				if not found then
					tinsert(content,{name=param.column,value = hparams[param.column],type = param.type})
				end
			end
		end

		if ds.description.filters and ds.description.filters[1] then
			res.filter = ds.description.filters[1].name
		end
		return res;
	end

	function self:buildData(reportParams,scale)
		local datasources = {}
		for _,entity in ipairs(entityList) do
			--entity:loadData(reportParams,self);
			local source = entity.source;
			if source and source.datasource then
				local id = self.id;
				local ds,status;
				status = true
				ds = datasources[source.datasource]
				if not ds then
					status,ds = datasource.buildDatasource(vccName,appName,source.datasource,"retrieve")
					if status then
						if ds.description.retrieve.enabled and ds.cursor then	-- si se puede hacer retrieve ,y ademas tiene el nuevo metodo cursor lo damos como valido
							datasources[source.datasource]=ds
						end
					end
				end
				if status then
					ds.entityList = ds.entityList or {}
				end
				tinsert(ds.entityList,entity)
			end
		end
		for _,ds in pairs(datasources) do
			local params = buildDatasourceParameters(ds,reportParams)
			if scale.isTimeScale then	-- por cada parametro de tipo date o datetime
										-- hace una marca en la escala de tiempo para que quede bien delimitada
				for _,param in ipairs(params.parameters) do
					if param.type == "date" or param.type == "datetime" then
						local r,d = pcall(date,param.value)
						if r then
							self:locations(d:getyear(),d:getmonth(),d:getday(),d:gethours());
						end
					end
				end
			end
			local status,ite = ds:cursor(params)
			local rec;
			if status then
				while not ite.eof() do
					rec =ite.next();
					for _,entity in ipairs(ds.entityList) do
						entity:processRecord(rec,self);
					end
				end
			end
		end

	end
	function self:evalExpresions(reportParams,dataColumns)
		for i=1,1 do
			for _,entity in ipairs(entityList) do
				entity:evalExpresion(reportParams,self,dataColumns)
				for _,entity in ipairs(entity:getSubRows()) do
					entity:evalExpresion(reportParams,self,dataColumns)
				end
			end
		end
	end
	function self:getGui(captionColumnWidth,dataColumns,rowHeader)
		local col
		local res = rpwidget.panel ({layoutMode="vertical"})

		for idx,entity in ipairs(entityList) do
			if entity.rowvisibility ~= false then
				tinsert(res.childs,entity:getGui(captionColumnWidth,self,dataColumns,idx,idx == #entityList,rowHeader))
			end	
		end

		for n,c in ipairs(res.childs) do
--			c.borderWidth=1;
--			c.borderBottom = true;
--			c.borderColor = lineColor;
			local ne = res.childs[n+1]
			local bbottom = false
			if ne  then

				if ne.haveHeader then
				  bbottom = true
				end
			end
			if c.layoutMode == "horizontal" or c.haveHeader then
				c.overflow = "visible";
				local t = c;
				if c.haveHeader then
					t = c.childs[2];
				end
				for m,cc in ipairs(t.childs or {}) do
					cc.borderWidth=1;
					cc.borderRight = true;
					cc.borderTop=true;
					cc.borderColor = lineColor;

					if m == 1 then
						cc.borderLeft = true;
					end
					if n == #res.childs or bbottom then
						cc.borderBottom = true;
					end

				end
			else
				if n == #res.childs then
					c.borderBottom = true;
				end
			end
		end

		res:layout();
		return res;
	end

	return self
end

function addBandContent(band,pageData,app,pageOffset,process,inputData)
	local scale = BITimeScale({
		x=0,
		y=0,
		yearly=band.yearly,
		monthly=band.monthly,
		monthName=band.monthName,
		monthlyTotals=band.monthlyTotals,
		yearlyTotals=band.yearlyTotals,
		hourly=band.hourly,
		dayOfWeek=band.dayOfWeek,
		dailyTotals=band.dailyTotals,
		daily=band.daily,
		grandTotal = band.grandTotal
	})
	local entityList = {}

	t = os.time();
	for id,entityData in ipairs(band.childs[1].childs) do
		entityData.x = nil
		entityData.y = nil
		tinsert(entityList,BIRow(entityData,app,scale,"R" .. id))
	end

	local datatable  = dataTable(app:getVCCName(),app:getName(),entityList)
	datatable:buildData(inputData.parameters,scale);
	print("build data ",os.time() - t)
	local scalegui = scale:getGui(band.width-band.rowWidth,datatable:minKey(),datatable:maxKey(),#band.childs[1].childs ==0);
	datatable:evalExpresions({},scale:getColumns());
	local rowheader = deepcopy(scalegui.childs[#scalegui.childs])
	rowheader.x = 0;
	rowheader.y = 0;

	local datatablegui = datatable:getGui(band.rowWidth,scale:getColumns(),rowheader);

	scalegui.x=0;
	scalegui.y=0;
	datatablegui.x=0;
	datatablegui.y=scalegui.height;
	scalegui.x = band.rowWidth;

	tinsert(pageData,{
		type="ui.panel",
		['band-type'] = band['band-type'],
		x=0,
		y = pageOffset,
		width = scalegui:getWidth()+band.rowWidth,
		height= scalegui:getHeight() + datatablegui:getHeight(),
--		backColor = backColor,
		borderWidth = 0,
		borderColor = lineColor,
		childs={
			scalegui,
			datatablegui
			--datatable:getGui(scale:getColumns())
		}
	})
	return 1000;
end


