
module(..., package.seeall)

function New (params)
	local fetchFunction = params.fetchFunction
	local destroyFunction = params.destroyFunction
	local timeout = params.timeout or 30
	local cache = {}
	local get = function(key, ...)
		local entry = cache[key]
		if entry and (entry.timestamp + timeout > os.time()) then
			return entry.data
		end

		if entry and destroyFunction then
			destroyFunction(entry.data, key, ...)
		end
		local data = fetchFunction(key, ...)
		if data ~= nil then
			cache[key] = {
				data = data,
				timestamp = os.time()
			}
		end
		return data
	end
	return {
		get = get
	}
end