
__icc__ = (function(){
	if (window.undefined == window.icc) {
		window.icc = {};
	}
	icc.console = {
		log:function(tx){
			
		}
	};
	let stringify = function (obj) {
		let cache = [];
		let str = JSON.stringify(obj, function(key, value) {
		  if (typeof value === "object" && value !== null) {
			if (cache.indexOf(value) !== -1) {
			  // Circular reference found, discard key
			  return;
			}
			// Store value in our collection
			cache.push(value);
		  }
		  return value;
		});
		cache = null; // reset the cache
		return str;
	}	
	let methods = ["log","debug","error","info"];
	for (let i in methods){
		let method = methods[i];
		let nativef = window.console[method];
		window.console[method]=function(){
			var args = [];
  			for(var k=0;k<arguments.length;k++){
				args.push(arguments[k]);
  			}
  			window.parent.postMessage({type: 'log-message',method:method,arguments: stringify(args)},"*")
  			nativef.apply(null,arguments)  	
		}
	}
	return window.icc;
})();

(function(icc){
	icc.cache = {};
	rhino=false;
// Temporary variables to hold mouse x-y pos.s
	var mouseX = 0;
	var mouseY = 0;

	icc.utils = {
	// Deteccion del browser
		browser: {}
	};

	/**
	 * Gets the browser name or returns an empty string if unknown. 
	 * This function also caches the result to provide for any 
	 * future calls this function has.
	 *
	 * @returns {string}

	 * Referncia: https://stackoverflow.com/questions/9847580/how-to-detect-safari-chrome-ie-firefox-and-opera-browser
	 */
	var browserDetect = function()
	{
		var browser = icc.utils.browser;

		// Return cached result if avalible, else get result then cache it.
		if (browser.__cached_result) {
			return browser.__cached_result;
		}

		var create_result = function(name) {
			browser.__cached_result = {
				name: name
			};
			return browser.__cached_result;
		};

		// Opera 8.0+
		var isOpera = (!!window.opr && !!opr.addons) || !!window.opera || navigator.userAgent.indexOf(" OPR/") >= 0;
		if (isOpera) {
			return create_result("OPERA");
		}

		// Firefox 1.0+
		var isFirefox = typeof InstallTrigger !== "undefined";
		if (isFirefox) {
			return create_result("FIREFOX");
		}

		// Safari 3.0+ "[object HTMLElementConstructor]" 
		var isSafari = /constructor/i.test(window.HTMLElement) || (function (p) { return p.toString() === "[object SafariRemoteNotification]"; })(!window.safari || safari.pushNotification);
		if (isSafari) {
			return create_result("SAFARI");
		}

		// Internet Explorer 6-11
		var isIE = !!document.documentMode;
		if (isIE) {
			return create_result("IE");
		}

		// Edge 20+
		var isEdge = !isIE && !!window.StyleMedia;
		if (isEdge) {
			return create_result("EDGE");
		}

		// Chrome 1+
		var isChrome = !!window.chrome && !!window.chrome.webstore;
		if (isChrome) {
			return create_result("CHROME");
		}

		// Blink engine detection
		var isBlink = (isChrome || isOpera) && !!window.CSS;
		if (isBlink) {
			return create_result("BLINK");
		}

		// Desconocido
		return create_result("UNKNOW");
	};

	var current_browser_name = browserDetect().name;

	// Deteccion del browser
	icc.utils.browser.is_ie7       = false,
	icc.utils.browser.is_ie        = current_browser_name === "IE",
	icc.utils.browser.is_chrome    = current_browser_name === "CHROME",
	icc.utils.browser.is_opera     = current_browser_name === "OPERA",
	icc.utils.browser.is_firefox   = current_browser_name === "FIREFOX",
	icc.utils.browser.is_safari    = current_browser_name === "SAFARI",
	icc.utils.browser.is_edge      = current_browser_name === "EDGE",
	icc.utils.browser.is_ie_lt9    = ( new RegExp("msie","i").test(navigator.userAgent) && !new RegExp("opera","i").test(navigator.userAgent) ) && document.all!=null && !document.addEventListener,
	icc.utils.browser.is_khtml     = new RegExp("Konqueror|Safari|KHTML","i").test(navigator.userAgent),
	icc.utils.browser.is_konqueror = new RegExp("Konqueror","i").test(navigator.userAgent),
	icc.utils.browser.is_gecko     = new RegExp("Gecko","i").test(navigator.userAgent),
	icc.utils.browser.is_iphone    = (navigator.userAgent.match(/iPhone/i) !=null || navigator.userAgent.match(/iPod/i)!=null || navigator.userAgent.match(/iPad/i)!=null),
	icc.utils.browser.is_android   = navigator.userAgent.toLowerCase().indexOf("android") > -1,
	icc.utils.browser.is_adobeair  = navigator.userAgent.toLowerCase().indexOf("adobeair") > -1

	var language = "en";	// default language
	try {
		language = (navigator.languages && navigator.languages.length ? 
			   navigator.languages[0] 
			: (navigator.language || navigator.userLanguage))
			.slice(0, 2)
			.toLowerCase();
	}
	catch(e) {
		language = "en";
	}

	icc.utils.userLanguage = language;

	// Herencia 
	icc.utils.combobox_nbsp = icc.utils.browser.is_ie?'':(icc.utils.browser.is_adobeair?'&nbsp;':'&#160');

	icc.utils.inherit=function (objSubClass, objSuperClass){
		// Duplicate prototype of superclass
		var Inheritance = function() {};
		Inheritance.prototype = objSuperClass.prototype;
		objSubClass.prototype = new Inheritance();
		// Fix constructor property to point to the self constructor because it is
		// pointing to the nested Inheritance function
		objSubClass.prototype.constructor = objSubClass;
		// Reference to constructor of superclass to be able to invoke it
		objSubClass.SUPERconstructor = objSuperClass;
		// Reference to prototype of superclass to be able to invoke its methods
		objSubClass.SUPERclass = objSuperClass.prototype;
	};
	icc.utils.makeTextNode = function(text,parent){
		var t = document.createTextNode(text);
		var winEl=t;
		if (parent)
			parent.appendChild(winEl);
		return winEl;
	}
	// Crea un elemento del dom del typo pasado  y adicionalement lo inserta en un objeto padre.
	icc.utils.makeElement = function(type,unselectable,parent){
		var winEl = document.createElement(type);
		if (parent) {
			parent.appendChild(winEl);
		}
		return winEl;
	};
	
	icc.utils.documentSize = function(){
		var res = icc.utils.windowSize();
		var h = res.height
		if(document.body.scrollWidth)
			res.width = document.body.scrollWidth;
			if (window.scrollMaxX)
				res.width += window.scrollMaxX;
		if(document.body.scrollHeight)
			res.height = document.body.scrollHeight;
		//	if (window.scrollMaxY)
		//		res.height += window.scrollMaxY;
		

			
		
		return res;		
	};

	// Devuelve un objeto que tiene el tamaï¿½o de la ventana del browser ( no el del documento )
	
	icc.utils.windowSize = function()
	{
		var res = {width:0, height:0,scrollX:0,scrollY:0};
		try{
		if (typeof window.innerWidth != 'undefined'){
			res ={
				width:window.innerWidth,
				height:window.innerHeight
			};
		}else if (typeof document.documentElement != 'undefined' &&
				  typeof document.documentElement.clientWidth != 'undefined' &&
				  document.documentElement.clientWidth != 0){
			res = {
				width:document.documentElement.clientWidth,
				height:document.documentElement.clientHeight
			};
		}else {
			res = {
				width:document.getElementsByTagName('body')[0].clientWidth,
				height:document.getElementsByTagName('body')[0].clientHeight
			};
		}
		var scrOfX = 0, scrOfY = 0;
		if( typeof( window.pageYOffset ) == 'number' ) {
		//Netscape compliant
			scrOfY = window.pageYOffset;
			scrOfX = window.pageXOffset;
		} else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
		//DOM compliant
			scrOfY = document.body.scrollTop;
			scrOfX = document.body.scrollLeft;
		} else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
		//IE6 standards compliant mode
			scrOfY = document.documentElement.scrollTop;
			scrOfX = document.documentElement.scrollLeft;
		}
		res.scrollX= scrOfX;
		res.scrollY= scrOfY;
		}catch(e){} 
		return res;
	};
	icc.utils.cssAddRule = function (id,properties,cssindex){
		if (cssindex == window.undefined)
			cssindex = document.styleSheets.length -1;
		var val = "";
		for (idx in properties) 
			val = val + idx+":"+properties[idx]+";";
		var ss = document.styleSheets[cssindex];
		try{
			if(icc.utils.browser.is_ie)
				ss.addRule(id,val);
			else{
				ss.insertRule(id + "{" + val + "}", ss.cssRules.length);
			}
			
		}catch(e){
			// si falla puede deberse a un css proveniente
			// de un complemento como por ejemplo skype
			// Reducimos el cssindex para tomar una hoja
			// anterior y reintentamos.
			cssindex --;
			if(cssindex>=0)
				icc.utils.cssAddRule(id,properties,cssindex);
		}

	}
	icc.utils.setSelector = function (id,property,value,cssindex){
		if (cssindex == window.undefined)
			cssindex = document.styleSheets.length -1;
		var val = property+':'+ value+';';
		var ss = document.styleSheets[cssindex];
		try{
			if(icc.utils.browser.is_ie)
				ss.addRule(id,val);
			else{
				ss.insertRule(id + "{" + val + "}", ss.cssRules.length);
			}
			
		}catch(e){
			// si falla puede deberse a un css proveniente
			// de un complemento como por ejemplo skype
			// Reducimos el cssindex para tomar una hoja
			// anterior y reintentamos.
			cssindex --;
			if(cssindex>=0)
				icc.utils.setSelector(id,property,value,cssindex);
		}
	};
	icc.utils.isArray = function (array){
		return !!(array && array.constructor == Array); 
	};
	icc.utils.getTextSize = function ( text , fontFamily,fontSize,fontWeight,boundingWidth,boundingHeight){
		var w,h;
		var ea = document.createElement("span");
		ea.innerHTML =  text;
		
		ea.style.fontFamily = fontFamily;
		ea.style.fontSize = fontSize+"px";
		ea.style.fontWeight=fontWeight;
		ea.style.position="absolute";
		ea.style.left = "-10000px";
		if(boundingWidth!==undefined)
			ea.style.width = boundingWidth+"px";
		if(boundingHeight!==undefined)
			ea.style.height = boundingHeight+"px";
		document.body.appendChild(ea);
		w = ea.offsetWidth;
		h = ea.offsetHeight;
		document.body.removeChild(ea);			
		return {width:w,height:h};
	};
	icc.utils.ucFirst = function (string){
		return string.substr(0,1).toUpperCase()+string.substr(1,string.length);
	}	
	jQuery(document).mousemove(function(ev){
		mouseX=ev.pageX;
		mouseY=ev.pageY;
		return true;
	})
	icc.utils.getMousePosition = function(){
		return {x:mouseX,y:mouseY}
	}
	
	icc.utils.clone = function (o,recursive){
		if(recursive ==undefined)
			recursive = true;
		if(typeof(o) !== "object")
			return o;
		var newObj = (o instanceof Array) ? [] : {};
		for (i in o) {
			if(i!="widgetid"){
			
				if (o[i] && typeof o[i] == "object") {
					if(recursive)
						newObj[i] = icc.utils.clone(o[i],recursive);
					else 
						newObj[i] = o[i];
				} else 
					newObj[i] = o[i]
			}
		}
		return newObj;
	}
	icc.utils.trim = function (s){
		if (typeof (s) === "string"){
		
			var l=0;var r=s.length -1;
			while(l < s.length && (s[l] == ' ' || s[l]=='\n' || s[l]=='\r'))
			{l++;}
			while(r > l && (s[r] == ' ' || s[l]=='\n' || s[l]=='\r'))
			{r-=1;}
			return s.substring(l, r+1);
		}
		return s;
	}
	icc.utils.isNumeric = function (strString)
	//  check for valid numeric strings
	{
		var strValidChars = "0123456789.-";
		var strChar;
		var blnResult = true;

		if (strString == undefined || strString.length == 0) return false;

		//  test strString consists of valid characters listed above
		for (var i = 0; i < strString.length && blnResult == true; i++)
		{
			strChar = strString.charAt(i);
			if (strValidChars.indexOf(strChar) == -1)
			{
				blnResult = false;
			}
		}
		return blnResult;
	}
	icc.utils.isValidFilename = function(str){
		str = icc.utils.trim(str);
		str = str.toUpperCase();
		if(str.length>0){
			if (/^[^\\\/\:\*\?\"\<\>\|\.]+(\.[^\\\/\:\*\?\"\<\>\|\.]+)*$/.test(str)) {
				
				if (jQuery.inArray(str,["CON","PRN","AUX","NUL","DESIGNER","DEFAULT",
					"COM1","COM2","COM3","COM4","COM5","COM6","COM7","COM8","COM9",
					"LPT1","LPT2","LPT3","LPT4","LPT5","LPT6","LPT7","LPT8","LPT9"
				])<0){
					return true;
				}
			}
		}
		return false;
		
	};
	icc.utils.isValidFilenameAgtMens = function(str){
		str = icc.utils.trim(str);
		str = str.toUpperCase();
		if(str.length>0){
			if (/^[^\\\/\:\*\?\"\<\>\|\.]+(\.[^\\\/\:\*\?\"\<\>\|\.]+)*$/.test(str)) {
				
				if (jQuery.inArray(str,["CON","PRN","AUX","NUL","DESIGNER","DEFAULT",
					"COM1","COM2","COM3","COM4","COM5","COM6","COM7","COM8","COM9",
					"LPT1","LPT2","LPT3","LPT4","LPT5","LPT6","LPT7","LPT8","LPT9"
				])<0){
					return true;
				}
			}
		}
		return false;
		
	};	
	// 
	icc.utils.ISO2Date = function (str){
		var parser,d;
		parser = new DateParser("yyyy-MM-dd HH:mm:ss.SSS",false);
		d=  parser.parse(str);
		if (!d){
			parser =new DateParser("yyyy-MM-ddTHH:mm:ss.SSS",false);
			d = parser.parse(str);
			if(!d){
				parser =new DateParser("yyyy-MM-dd",false);
				d = parser.parse(str);
			}
		}
		return d;
	};
	icc.utils.iso2LocalDate = function (str){
		var format = icc.ui.getApplication().localeSettings()['dateformat']
		var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
		var d = icc.utils.ISO2Date(str);
		if(d){
			switch(format){

				case "dd-MM-yyyy":
					return (d.getDate()>9?d.getDate():'0'+d.getDate())+"-"+(d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"-"+d.getFullYear();
				break;
				case "dd-MMM-yyyy":
					return (d.getDate()>9?d.getDate():'0'+d.getDate())+"-"+months[d.getMonth()]+"-"+d.getFullYear();
				break;

				case "dd/MM/yyyy":
					return (d.getDate()>9?d.getDate():'0'+d.getDate())+"/"+(d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"/"+d.getFullYear();
				break;

				case "MM-dd-yyyy":
					return (d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"-"+(d.getDate()>9?d.getDate():'0'+d.getDate())+"-"+d.getFullYear();
				break;

				case "MM/dd/yyyy":
					return (d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"/"+(d.getDate()>9?d.getDate():'0'+d.getDate())+"/"+d.getFullYear();
				break;
				
			}
		}
	};
	icc.utils.cleanDateStr = function (dateStr){
		if (!dateStr)
			return dateStr;
		var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
		dateStr = dateStr.toLowerCase();
		for (k in months){
			var r = months[k]
			dateStr = dateStr.replace(r.toLowerCase(),k<=9?'0'+(parseInt(k)+1):parseInt(k)+1);
		};
		return dateStr;
		
	};
	icc.utils.iso2LocalDateTime = function (str){
		var format = icc.ui.getApplication().localeSettings()['datetimeformat']
		var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
		var d = icc.utils.ISO2Date(str);
		if(d){
			switch(format){

				case "dd-MMM-yyyy HH:mm:ss":
					return (d.getDate()>9?d.getDate():'0'+d.getDate())+"-"+months[d.getMonth()]+"-"+d.getFullYear()+ " " +(d.getHours()>9?d.getHours():"0"+d.getHours())+":"+(d.getMinutes()>9?d.getMinutes():"0"+d.getMinutes())+":"+(d.getSeconds()>9?d.getSeconds():"0"+d.getSeconds());
				break
			
				case "dd-MM-yyyy HH:mm:ss":
					return (d.getDate()>9?d.getDate():'0'+d.getDate())+"-"+(d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"-"+d.getFullYear()+ " " +(d.getHours()>9?d.getHours():"0"+d.getHours())+":"+(d.getMinutes()>9?d.getMinutes():"0"+d.getMinutes())+":"+(d.getSeconds()>9?d.getSeconds():"0"+d.getSeconds());
				break
				case "dd/MM/yyyy HH:mm:ss":
					return (d.getDate()>9?d.getDate():'0'+d.getDate())+"/"+(d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"/"+d.getFullYear()+ " " +(d.getHours()>9?d.getHours():"0"+d.getHours())+":"+(d.getMinutes()>9?d.getMinutes():"0"+d.getMinutes())+":"+(d.getSeconds()>9?d.getSeconds():"0"+d.getSeconds());
				break
				case "MM-dd-yyyy HH:mm:ss":
					return (d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"-"(d.getDate()>9?d.getDate():'0'+d.getDate())+"-"+d.getFullYear()+ " " +(d.getHours()>9?d.getHours():"0"+d.getHours())+":"+(d.getMinutes()>9?d.getMinutes():"0"+d.getMinutes())+":"+(d.getSeconds()>9?d.getSeconds():"0"+d.getSeconds());
				break;
				case "MM/dd/yyyy HH:mm:ss":
					return (d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"/"(d.getDate()>9?d.getDate():'0'+d.getDate())+"/"+d.getFullYear()+ " " +(d.getHours()>9?d.getHours():"0"+d.getHours())+":"+(d.getMinutes()>9?d.getMinutes():"0"+d.getMinutes())+":"+(d.getSeconds()>9?d.getSeconds():"0"+d.getSeconds());
				break;
			}		
		}
	};
	icc.utils.now = function ( asUTC ,serverTime) {
		var now = new Date();
		if(asUTC!==false && asUTC!==undefined){
			now = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate(),  now.getUTCHours(), now.getUTCMinutes(), now.getUTCSeconds());
		}
		if(serverTime){
			if(asUTC!==false && asUTC!==undefined)
				now.setTime(now.getTime() + icc.ui.getApplication().timeOffsetUTC);
			else
				now.setTime(now.getTime() + icc.ui.getApplication().timeOffsetLocal);
		}
		
		if (typeof(asUTC) == "number"){
			now.setTime(now.getTime()+ (parseInt(asUTC) * (3600 * 1000)));
		}
		return icc.utils.date2ISO(now)
	};
	icc.utils.date2ISO = function ( d ){
		return d.getFullYear()+"-"+(d.getMonth()+1>9?d.getMonth()+1:'0'+(d.getMonth()+1))+"-" + (d.getDate()>9?d.getDate():'0'+d.getDate())+ " " +(d.getHours()>9?d.getHours():"0"+d.getHours())+":"+(d.getMinutes()>9?d.getMinutes():"0"+d.getMinutes())+":"+(d.getSeconds()>9?d.getSeconds():"0"+d.getSeconds())+"."+icc.utils.sprintf("%03d",d.getMilliseconds());
	};
	icc.utils.guid = function (){
		icc.console.log("generando guid");
		return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
			var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
				return v.toString(16);
			});
	};

	icc.utils.validateColor=function(colorcode){
		var validcolorNames={
			  transparent:true,
			  aliceblue:true,  antiquewhite:true,  aqua:true,  aquamarine:true,  azure:true,  beige:true,  bisque:true,  black:true,  blanchedalmond:true,  blue:true,  blueviolet:true,  brown:true,  burlywood:true,
			  cadetblue:true,  chartreuse:true,  chocolate:true,   coral:true,   cornflowerblue:true,  cornsilk:true,  crimson:true,
			  cyan:true,  darkblue:true,  darkcyan:true,  darkgoldenrod:true,  darkgray:true,  darkgreen:true,  darkkhaki:true,  darkmagenta:true,
			  darkolivegreen:true,  darkorange:true,  darkorchid:true,  darkred:true,  darksalmon:true,  darkseagreen:true,  darkslateblue:true,  darkslategray:true,
			  darkturquoise:true,  darkviolet:true,  deeppink:true,  deepskyblue:true,  dimgray:true,  dodgerblue:true,  firebrick:true,  floralwhite:true,  forestgreen:true,
			  fuchsia:true,  gainsboro:true,  ghostwhite:true,  gold:true,  goldenrod:true,  gray:true,  green:true,  greenyellow:true,  honeydew:true,
			  hotpink:true,  indianred:true,  indigo:true,  ivory:true,  khaki:true,  lavender:true,  lavenderblush:true,  lawngreen:true,  lemonchiffon:true,
			  lightblue:true,  lightcoral:true,  lightcyan:true,  lightgoldenrodyellow:true,  lightgreen:true,  lightgray:true,  lightpink:true,  lightsalmon:true,
			  lightseagreen:true,  lightskyblue:true,  lightslategray:true,  lightsteelblue:true,  lightyellow:true,  lime:true,
			  limegreen:true,  linen:true,  magenta:true,  maroon:true,  mediumaquamarine:true,  mediumblue:true,  mediumorchid:true,  mediumpurple:true,  mediumseagreen:true,
			  mediumslateblue:true,  mediumspringgreen:true,  mediumturquoise:true,  mediumvioletred:true,  midnightblue:true,  mintcream:true,  mistyrose:true,  moccasin:true,
			  navajowhite:true,  navy:true,  oldlace:true,  olive:true,  olivedrab:true,  orange:true,  orangered:true,  orchid:true,  palegoldenrod:true,
			  palegreen:true,  paleturquoise:true,  palevioletred:true,  papayawhip:true,  peachpuff:true,  peru:true,  pink:true,  plum:true,  powderblue:true,
			  purple:true,  red:true,  rosybrown:true,  royalblue:true,  saddlebrown:true,  salmon:true,  sandybrown:true,  seagreen:true,  seashell:true,  sienna:true,
			  silver:true,  skyblue:true,  slateblue:true,  slategray:true,  snow:true,  springgreen:true,  steelblue:true,  tan:true,  teal:true,  thistle:true,
			  tomato:true,  turquoise:true,  violet:true,  wheat:true,  white:true,  whitesmoke:true,  yellow:true,  yellowgreen:true
		}
	    var regColorcode = /^(#)+([0-9a-fA-F]{3})([0-9a-fA-F]{3})?$/;

		if(regColorcode.test(colorcode) == false){
			return validcolorNames[colorcode.toLowerCase()]!==undefined;
		}
		return true;
	}
	icc.utils.opacity = function(element,opacity){
		if(icc.utils.browser.is_ie){
			if(opacity==1)
				element.style.filter="";
			else{
				element.style.filter="alpha(opacity:"+opacity*100+")";
			}
			
		}else{
			jQuery(element).css({
				opacity:opacity
			})
		}
	}
	icc.utils.boolFromString = function(str) {
		if (str == undefined)
			return false;
		str = ''+str
		switch(str.toLowerCase()){
			case "true": case "yes": case "1": return true;
			case "false": case "no": case "0": case null: return false;
            default: return Boolean(str);
        }
	
	};
	icc.utils.dateFromString = function(str) {
		str = icc.utils.cleanDateStr(str);
		var fmt = icc.ui.getApplication().localeSettings()['datetimeformat']
		if(fmt == "dd-MMM-yyyy")
			fmt = "dd-MM-yyyy"
		parser = new DateParser(fmt,false);
		d = parser.parse(str);
		return d;
	};

    icc.utils.isValidVariableName=function(data) {
		if (/^[a-z$_][\w$]*$/i.test(data))
			return true;
		return false;
    }
	icc.utils.copyProperties = function (props,tgt){
		var t;
		for (var k in props){
			if(props[k]!==undefined && props[k]!==null && k!== "styles"){
				if( k === 'font' || k == "captionFont"){ // casos especiales como font 
					if(!tgt[k]){
						tgt[k]={};	// se crea un nuevo objeto si este no existe
					}
					t = props[k];		// y se copian las propiedades
					for (var j in t){
						tgt[k][j]=t[j];
					}
				}else{
					tgt[k]=props[k];
				}
			}
		}
	};

	icc.utils.sprintf =function() {
		// http://kevin.vanzonneveld.net
		// +   original by: Ash Searle (http://hexmen.com/blog/)
		// + namespaced by: Michael White (http://getsprink.com)
		// +    tweaked by: Jack
		// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// +      input by: Paulo Freitas
		// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// +      input by: Brett Zamir (http://brett-zamir.me)
		// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// *     example 1: sprintf("%01.2f", 123.1);
		// *     returns 1: 123.10
		// *     example 2: sprintf("[%10s]", 'monkey');
		// *     returns 2: '[    monkey]'
		// *     example 3: sprintf("[%'#10s]", 'monkey');
		// *     returns 3: '[####monkey]'

		var regex = /%%|%(\d+\$)?([-+\'#0 ]*)(\*\d+\$|\*|\d+)?(\.(\*\d+\$|\*|\d+))?([scboxXuidfegEG])/g;
		var a = arguments, i = 0, format = a[i++];

		// pad()
		var pad = function (str, len, chr, leftJustify) {
			if (!chr) {chr = ' ';}
			var padding = (str.length >= len) ? '' : Array(1 + len - str.length >>> 0).join(chr);
			return leftJustify ? str + padding : padding + str;
		};

		// justify()
		var justify = function (value, prefix, leftJustify, minWidth, zeroPad, customPadChar) {
			var diff = minWidth - value.length;
			if (diff > 0) {
				if (leftJustify || !zeroPad) {
					value = pad(value, minWidth, customPadChar, leftJustify);
				} else {
					value = value.slice(0, prefix.length) + pad('', diff, '0', true) + value.slice(prefix.length);
				}
			}
			return value;
		};

		// formatBaseX()
		var formatBaseX = function (value, base, prefix, leftJustify, minWidth, precision, zeroPad) {
			// Note: casts negative numbers to positive ones
			var number = value >>> 0;
			prefix = prefix && number && {'2': '0b', '8': '0', '16': '0x'}[base] || '';
			value = prefix + pad(number.toString(base), precision || 0, '0', false);
			return justify(value, prefix, leftJustify, minWidth, zeroPad);
		};

		// formatString()
		var formatString = function (value, leftJustify, minWidth, precision, zeroPad, customPadChar) {
			if (precision != null) {
				value = value.slice(0, precision);
			}
			return justify(value, '', leftJustify, minWidth, zeroPad, customPadChar);
		};

		// doFormat()
		var doFormat = function (substring, valueIndex, flags, minWidth, _, precision, type) {
			var number;
			var prefix;
			var method;
			var textTransform;
			var value;

			if (substring == '%%') {return '%';}

			// parse flags
			var leftJustify = false, positivePrefix = '', zeroPad = false, prefixBaseX = false, customPadChar = ' ';
			var flagsl = flags.length;
			for (var j = 0; flags && j < flagsl; j++) {
				switch (flags.charAt(j)) {
					case ' ': positivePrefix = ' '; break;
					case '+': positivePrefix = '+'; break;
					case '-': leftJustify = true; break;
					case "'": customPadChar = flags.charAt(j+1); break;
					case '0': zeroPad = true; break;
					case '#': prefixBaseX = true; break;
				}
			}

			// parameters may be null, undefined, empty-string or real valued
			// we want to ignore null, undefined and empty-string values
			if (!minWidth) {
				minWidth = 0;
			} else if (minWidth == '*') {
				minWidth = +a[i++];
			} else if (minWidth.charAt(0) == '*') {
				minWidth = +a[minWidth.slice(1, -1)];
			} else {
				minWidth = +minWidth;
			}

			// Note: undocumented perl feature:
			if (minWidth < 0) {
				minWidth = -minWidth;
				leftJustify = true;
			}

			if (!isFinite(minWidth)) {
				throw new Error('sprintf: (minimum-)width must be finite');
			}

			if (!precision) {
				precision = 'fFeE'.indexOf(type) > -1 ? 6 : (type == 'd') ? 0 : undefined;
			} else if (precision == '*') {
				precision = +a[i++];
			} else if (precision.charAt(0) == '*') {
				precision = +a[precision.slice(1, -1)];
			} else {
				precision = +precision;
			}

			// grab value using valueIndex if required?
			value = valueIndex ? a[valueIndex.slice(0, -1)] : a[i++];

			switch (type) {
				case 's': return formatString(String(value), leftJustify, minWidth, precision, zeroPad, customPadChar);
				case 'c': return formatString(String.fromCharCode(+value), leftJustify, minWidth, precision, zeroPad);
				case 'b': return formatBaseX(value, 2, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
				case 'o': return formatBaseX(value, 8, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
				case 'x': return formatBaseX(value, 16, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
				case 'X': return formatBaseX(value, 16, prefixBaseX, leftJustify, minWidth, precision, zeroPad).toUpperCase();
				case 'u': return formatBaseX(value, 10, prefixBaseX, leftJustify, minWidth, precision, zeroPad);
				case 'i':
				case 'd':
					number = parseInt(+value, 10);
					prefix = number < 0 ? '-' : positivePrefix;
					value = prefix + pad(String(Math.abs(number)), precision, '0', false);
					return justify(value, prefix, leftJustify, minWidth, zeroPad);
				case 'e':
				case 'E':
				case 'f':
				case 'F':
				case 'g':
				case 'G':
					number = +value;
					prefix = number < 0 ? '-' : positivePrefix;
					method = ['toExponential', 'toFixed', 'toPrecision']['efg'.indexOf(type.toLowerCase())];
					textTransform = ['toString', 'toUpperCase']['eEfFgG'.indexOf(type) % 2];
					value = prefix + Math.abs(number)[method](precision);
					return justify(value, prefix, leftJustify, minWidth, zeroPad)[textTransform]();
				default: return substring;
			}
		};

		return format.replace(regex, doFormat);
	}
	
	//replaces with statement declaring variables before
	icc.utils.evaluateStatement = function(statement, statementContext) {
		//this global is because compiler changes params names
		window.__statementContext = statementContext || {};
		var code = "(function() { ";
		$.each(statementContext, function(key) {
			code += "var " + key + " = window.__statementContext[\"" + key + "\"]; ";
		});
		code += "return " + statement + " })()";
		var result = eval(code);
		window.__statementContext = null;
		return result;
	};

	/*
	Object.prototype.duplicate = function() {
	  var newObj = (this instanceof Array) ? [] : {};
	  for (i in this) {
		if (i == 'clone') continue;
		if (this[i] && typeof this[i] == "object") {
		  newObj[i] = this[i].clone();
		} else newObj[i] = this[i]
	  } return newObj;
	};
	*/
})(__icc__);



/*jslint evil:true */
/*global jQuery unescape window escape __icc__ setTimeout
*/

(function(icc){

	/*	
		ui -		Espacio de nombres de los elementos de la interface de usuario.
		themes -	Este objeto almacena seteos graficos para los widgets que son accedidos segun el themeName y el argumento wClass 
				themes.silver={	// nombre del tema
					label:{		// wClass para el label
						color:'lightgray'
					}
				}
					Los valores para el tema 'base' son asignados en la clase del control.
					
		layouts -	Segun la propiedad layoutMode de un objeto container se elige una de estas estructuras que contienen 3 metodos		
					layout: Tomando en cuenta las posiciones de los controles y algunas propiedades adicionales
							realiza el posicionamiento de los widgets
					getDefaultWidth:
							Tomando en cuenta las posiciones de los controles y algunas propiedades adicionales retorna
							el ancho necesario para que el contenedor muestre todos su contenido.
					getDefaultHeight:
							Tomando en cuenta las posiciones de los controles y algunas propiedades adicionales retorna
							el alto necesario para que el contenedor muestre todos su contenido.
					
		
	*/
	if (icc.ui === undefined){
		icc.ui = {
			designer:{},
			themes:{
				base:{}
			},
			layouts:{},
			themeName:'',
			enableRequestWindow:true
		};
		
	}
	icc.ui.getApplication = function (){
		return icc.ui._app;
	};

	var sender;
	var lastSender;
	var object; 
	icc.ui.invalidValue = ['ad51c93e-d1cb-4bc6-883a-80515d1f419f'];
	
	icc.ui.sender = function(){
		return sender;
	}
	icc.ui.lastSender = function(l){
		if(l)
			lastSender=l;
		return lastSender;
	}
	
	icc.ui.displayMessage = function ( error){
		
		if(lastSender && error != undefined && typeof error != "string"  && error.datasource!=undefined ){
			lastSender.displayMessage(error,true);
		}else{
			icc.ui._app.displayMessage(error);
		}
	};	
	object = function(){
		this.eventListeners={};
		this.eventsEnabled =true;
		this.listenerId = 0;
		this.knownListeners = [];
		this.tw_object = true;
		
	};
	object.prototype.addListener = function(evtName,fn){
		this.listenerId++;
		if (!this.eventListeners[evtName]){
			this.eventListeners[evtName]={};
		}
		this.eventListeners[evtName][this.listenerId]=fn;
		return this.listenerId;
	};
	object.prototype.destroy = function(){
	    for(var idx = 0;idx<this.knownListeners.length;idx++){
			this.knownListeners[idx].object.rmvListener(this.knownListeners[idx].listenerId,this.knownListeners[idx].evtName);
	    }
	}	
	object.prototype.rmvListener = function(evtId,evtName){
		if(evtName === undefined){
			for (k in this.eventListeners){
				var l = this.eventListeners[k];
				if(l){
					for (id in this.eventListeners[k]){
						if(id == evtId){
							evtName = k;
							break;
						}
					}
				}
				if(evtName!==undefined)
					break;
			}
		}
		if(evtName!==undefined){
			if (!this.eventListeners[evtName]){
				this.eventListeners[evtName]={};
			}
			this.eventListeners[evtName][evtId]=null;
		}
	};
	object.prototype.fireEventAsync = async function (evtName){
		var args = [];
		var listeners;
		var res;
		//icc.console.log("fireEvent "+evtName);
		if(this.eventsEnabled){
			listeners = this.eventListeners[evtName];
			if(listeners ){
				for(var i = 1; i < arguments.length; i++){
					args.push(arguments[i]);
				}
				
				for(var idx in listeners){
					if(typeof(listeners[idx])==="function"){
						res = await listeners[idx].apply(this,args);
						if(res!==undefined && res!==true){
							return res;
						}
					}
				}
			}
		}
		
	};
	object.prototype.fireEvent = function (evtName){
		var args = [];
		var listeners;
		var res;
		//icc.console.log("fireEvent "+evtName);
		if(this.eventsEnabled){
			listeners = this.eventListeners[evtName];
			if(listeners ){
				for(var i = 1; i < arguments.length; i++){
					args.push(arguments[i]);
				}
				
				for(var idx in listeners){
					if(typeof(listeners[idx])==="function"){
						res = listeners[idx].apply(this,args);
						if(res!==undefined && res!==true){
							return res;
						}
					}
				}
			}
		}
		
	};
	object.prototype.disableEvents = function(){
		this.eventsEnabled = false;
	};
	object.prototype.enableEvents = function(){
		this.eventsEnabled = true;
	};
	object.prototype.addDatasourceListener=function(evtName,fn){
		 var listenerId = this.registerListener(this.datasource,evtName,fn);
		 return listenerId;
	};
	object.prototype.registerListener=function(object,evtName,fn){
		var listenerId = object.addListener(evtName,fn);
		this.knownListeners.push({object:object,evtName:evtName,listenerId:listenerId});
		return listenerId;
	}
	
	icc.ui.object = object;
	
	/*  ******************************************************************************************************************
		widget class
		La clase base para todos los controles idget.
		*******************************************************************************************************************/
		
	var  widgetid = 0;
	var  widget;
	
	icc.ui.initializeWidgetData = function ( wClass,args,tgt){
		var cData;
		var cStyle;
		var t;
		if(wClass == "fixedLayoutDesigner" && args.style)
			wClass = "panel";
		var app = icc.ui.getApplication();
		var appName = args._appName || (app?app.getName():undefined)
		jQuery.each(
			[
				icc.ui.themes.base[wClass],
				icc.ui.themeName !== 'base'?
					(icc.ui.themes[icc.ui.themeName]?icc.ui.themes[icc.ui.themeName][wClass]:undefined):undefined,
					appName &&
					icc.ui.themeName !== 'base' &&
					icc.ui.themes[icc.ui.themeName]&&
					icc.ui.themes[icc.ui.themeName].apps &&
					icc.ui.themes[icc.ui.themeName].apps[appName] && 
					icc.ui.themes[icc.ui.themeName].apps[appName][wClass]?icc.ui.themes[icc.ui.themeName].apps[appName][wClass]:undefined,
				args
			],
			function(idx,cData)
			{
				if(cData){
					icc.utils.copyProperties(cData, tgt);
					if(cData.styles && args.style){
						cStyle = cData.styles[args.style];
						if(cStyle){
							icc.utils.copyProperties(cStyle, tgt);
						}
					}
					if (tgt && tgt.caption && tgt.mustTranslate) {
						tgt.caption = _T(tgt.caption);
					}
				}
			}
		);
	};

	widget = function(args,environment,wClass) {
		var self = this;
		var cStyle,t;
		this.cloneInfo = args;
		widget.SUPERconstructor.call(this);	
		args = args?args:{};
		// Se obtienen los settings correspondientes al tema y la clase y se copian estos datos al objeto
		widgetid++;
		this.tooltipicons={};
		this.uiclass = wClass;
		this.environment = environment || {arguments:{},datasources:{},controls:{},forms:{},changed_datasources:{}};
		this.widgetid = "iccw"+widgetid;
		// En el constructor se obtienen los datos del tema y se mixean con los argumentos
		icc.ui.initializeWidgetData(wClass,args,this);
		// Valores por defecto de algunas variables.	
		this.visible = (this.visible!==undefined?this.visible:true);
	
		if(!this.visible){
			if(this.environment && this.environment.designer){// para el designer siempre es visible{
				this.visible = true;
				this.dimmed = 40;
			}
		}

		this.initialVisibility = this.visible;
		 
		this.data = args.data || {}; // Atributo data: Objeto de datos customs
		this.enabled = (this.enabled!==undefined?this.enabled:true);
		this._x = this._y = this._w = this._h = 0;
		this.nc_left = this.nc_left!==undefined?this.nc_left:0;
		this.nc_right = this.nc_right!==undefined?this.nc_right:0;
		this.nc_top = this.nc_top!==undefined?this.nc_top:0;
		this.nc_bottom = this.nc_bottom!==undefined?this.nc_bottom:0;
		if(this.force_width !== undefined)
			this.width = this.force_width;
		if(this.force_height !== undefined)
			this.height = this.force_height;
			
		if(typeof (this.datasource)==="string"){
				if(environment){
					this.datasource = environment.datasources[this.datasource];
				}else{
					this.datasource = undefined;
				}
		}
	};

	icc.utils.inherit(widget, icc.ui.object);

	icc.ui.widget = widget;
	widget.prototype.clone = function(){
		var copy = function (o,first){
			if(typeof(o) !== "object")
				return o;
			if(typeof(o) == "function")
				return null;
				
			if(o.tw_object && o!==this && !first)
				return null;
			var newObj = (o instanceof Array) ? [] : {};
			for (i in o) {
				if (o[i] && typeof o[i] == "object") {
						newObj[i] = copy(o[i]);
				} else 
					newObj[i] = o[i]
			}
			return newObj;
		}
		return new this.constructor(copy(this,true),this.environment);
	}
	widget.prototype.addDatasourceListener=function(evtName,fn){
		 var listenerId = this.registerListener(this.datasource,evtName,fn);
		 return listenerId;
	};
	widget.prototype.registerListener=function(object,evtName,fn){
		var listenerId = object.addListener(evtName,fn);
		this.knownListeners.push({object:object,evtName:evtName,listenerId:listenerId});
		return listenerId;
	}
	widget.prototype.getDefaultWidth=function(){
		return 80;
	};
	// Retorna el alto por defcto del control 
	widget.prototype.getDefaultHeight=function(){
		return 20;
	};

	widget.prototype.getData = function(){ //Getter custom data

		return this.data || {};
	};

	widget.prototype.setData = function(data){ //Setter custom data
		
		if (typeof data === Object) {
			this.data = data;
		}
	};

	widget.prototype.enable = function(){};
	widget.prototype.disable = function(){};
	widget.prototype.show = function(){
		this.setVisible( true );
	};
	widget.prototype.hide = function(){
		this.setVisible( false );
	};
	widget.prototype.create = function(params){
		var self = this;
		if(!this.visible){
			this.setVisible(false);
		}
		if(this.dimmed !==undefined){ // esto solo para cuando queremos mostar un disabled en el designer
			jQuery(this.wnd).css({
				opacity:this.dimmed /100
			})

		}

		if(this.opacity!==undefined && !icc.utils.browser.is_ie){
			jQuery(this.wnd).css({
				opacity:this.opacity /100
			})
		}
		/*
		if(this.fillWidth)
			this.width = undefined;
			
		if(this.fillHeight)
			this.height = undefined;
			
		if(this.centerX || this.sideRight || this.sideLeft)
			this.x = undefined;
			
		if(this.centerY || this.sideTop || this.sideBottom)
			this.y = undefined;
		*/	
	};
	widget.prototype.destroy = function(){
		widget.SUPERclass.destroy.call(this);
		this.fireEvent("onDestroy");
	};
	widget.prototype.onDestroy = function(fn){
		this.addListener("onDestroy",fn);
	};
	widget.prototype.getProperties=function(formDoc,res){
		if(res){
			return res;
		}else {
			return [];
		}
	};

	widget.prototype.screenToClient = function(position){
		var offset = jQuery(this.getWnd()).offset();
		
		return {x:position.x-offset.left-this.borderWidth-this.nc_left,y:(position.y - offset.top) -this.borderWidth-this.nc_top};
	};
	widget.prototype.clientToScreen=function(position){
		var offset = jQuery(this.getWnd()).offset();
		
		return {x:position.x+offset.left+this.borderWidth+this.nc_left,y:(position.y + offset.top)+this.borderWidth+this.nc_top};
	};

	widget.prototype.onCreate=function(cb){
		this.addListener("onCreate",cb);
	};
	widget.prototype.getWnd = function(){
		return this.wnd;
	};
	widget.prototype.getClient = function(){
		return this.client!==undefined?this.client:this.wnd;
	};
	widget.prototype.getApplication = function(){
		return icc.ui.getApplication();
	};
	// propaga un error a mostrar al usuario en el gui
	
	widget.prototype.displayMessage = function (err,parentPropagation){
		if(parentPropagation!=false){
			if(this.parent){
				return this.parent.displayMessage(err,parentPropagation,this);
			}else{
				icc.ui.getApplication().displayMessage(err);
			}
		}
	};
	widget.prototype.getSize = function(){
		return {width:this._w,height:this._h};
	};
	widget.prototype.properties = function (p){
		for (var idx in p ){
			this[idx]=p[idx];
		}
	};
	widget.prototype._T = function(caption) {
		if (!caption) {
			return caption;
		}
		if (!this.mustTranslate) {
			return caption;
		}
		return _T(caption);
	}

	//  tooltipicon es a nivel de widget porque cualquier control podria querer llamar la atencion de
	// alguna manera
	icc.ui.themes.base.tooltipicon={
		width:16,
		height:16,
		offsetx:0,
		offsety:0,
		location:'inner-right',
		icon:'!info.png',
		styles:{
			error:{
				offsety:2,
				offsetx:2,
				location:'inner-right',
				icon:'!field_error.png'
			},

			warning:{
				location:'inner-right',
				width:2,
				offsety:3,
				offsetx:-2,
				height:9,
				icon:'!exclamationmark.png'
			},			
			"required":{
				location:'outer-left',
				width:2,
				height:8,
				offsetx:-2,
				offsety:6,
				icon:'!required.png'
			}
		}
		
	};
	widget.prototype.hidetooltipicon = function(name){
		if(name === undefined){
			name='default';
		}
		this.tooltipicons[name]=this.tooltipicons[name]?this.tooltipicons[name]:{};
		
		if(this.tooltipicons[name].image){
			try{
			this.tooltipicons[name].parent.removeChild(this.tooltipicons[name].image.getWnd());
			}catch(e){} // no se porque en el label explota
			this.tooltipicons[name].image=undefined;
			this.tooltipicons[name].parent=undefined;
		}
	};
	widget.prototype.showtooltipicon = function(msg,style,name,cfg,parentWnd){//superpone el icon y adicionalmente usa un estilo
												// que le da el icono etc etc
		if (name===undefined){
			name = 'default';
		}
		cfg = cfg!==undefined?cfg:{};
		cfg.style = style;
		this.tooltipicons[name]=this.tooltipicons[name]?this.tooltipicons[name]:{};
		var config;
		var wnd;
		this.hidetooltipicon(name);
		this.tooltipicons[name].config={};
		icc.ui.initializeWidgetData("tooltipicon",cfg,this.tooltipicons[name].config);
		config = this.tooltipicons[name].config;
			
		this.tooltipicons[name].image = new icc.ui.image({image:config.icon,width:config.width,height:config.height,tooltip:msg});
		this.tooltipicons[name].parent = parentWnd || this.wnd;
		this.tooltipicons[name].image.create();
		wnd = this.tooltipicons[name].image.getWnd();
		jQuery(wnd).css({position:'absolute',zIndex:10001});
		this.tooltipicons[name].parent.appendChild(wnd);
		this.tooltipicon_position(this.tooltipicons[name]);
	};
	widget.prototype.tooltipicon_position=function(tooltipicon){
		var w = this._w;
		w = tooltipicon.parent.offsetWidth;
		switch(tooltipicon.config.location){
			case 'inner-right':
				tooltipicon.image.position(w-tooltipicon.config.width+tooltipicon.config.offsetx,tooltipicon.config.offsety,tooltipicon.config.width,tooltipicon.config.height);
			break;
			case 'outer-right':
				tooltipicon.image.position(w+tooltipicon.config.offsetx,tooltipicon.config.offsety,tooltipicon.config.width,tooltipicon.config.height);
			break;
			case 'outer-left':
				tooltipicon.image.position(-tooltipicon.config.width+tooltipicon.config.offsetx,tooltipicon.config.offsety,tooltipicon.config.width,tooltipicon.config.height);				
			break;
		}
	};
	// Cuando se ejecuta el metodo layout de un contenedor, este llama
	// a este metodo para posicionar el objeto del DOM correspondiente a este control.
	
	widget.prototype.position = function(x,y,w,h){
		try{ // IE
		var self=this;
		if(w<0)w=0;// IE exception if width or height<0
		if(h<0)h=0;
		if(this.offsetx !==undefined)
			x+=this.offsetx;
		if(this.offsety !==undefined)
			y+=this.offsety;
			
		this.wnd.style.left = x+"px";
		this.wnd.style.top = y+"px";
		this.wnd.style.width = w+"px";
		this.wnd.style.height = h+"px";
		this._x = x;
		this._y = y;
		this._w = w;
		this._h = h;
		
		// reposiciona los tooltipicon por si cambio el ancho
		jQuery.each(this.tooltipicons,function(idx,tooltipicon){
			if(tooltipicon && tooltipicon.image){
				self.tooltipicon_position(tooltipicon);
			}
		});
		}catch(e){}
	};
	widget.prototype.setEnabled=function(value){
		if(value)
			value=true;
		else
			value = false;

		if(this.wnd && this.enabled !== value){
			this.wnd.disabled = !value;	
		}
		this.enabled = value;
	};
	widget.prototype.getEnabled=function(){
		return this.enabled;
	};

	widget.prototype.getObjData = function(){
		return this.objData;
	};

	widget.prototype.setVisible=function(value){
		this.visible = value;
		
		if(this.wnd){
			if(value){
				if(this.initialVisibility === false && this.parent && this.parent._layoutData == icc.ui.layouts.scalable ){
					delete this.initialVisibility;
					this.parent.layout();
				}
				this.wnd.style.visibility = "visible";
				this.wnd.style.display = "inline";
				
			}else{
				this.wnd.style.visibility = "hidden";
				this.wnd.style.display = "none";
			}
		}
		
	};
	widget.prototype.getVisible=function(){
		return this.visible;
	};
	widget.prototype.getApplication = function(){
		if(this.environment && this.environment._app){
			return this.environment._app;
		}else{
			return icc.ui.getApplication();
		}
	};
	widget.prototype.fireEventAsync = async function (evtName){	
		var res;
		if(this.eventsEnabled){
		
			if(evtName == "onClick" || ((evtName == "onChange" || evtName =="_onChange" ) && this.uiclass !== "tabpanel")  || evtName=="beforeClick"){
				sender = this;// para saber donde arrancar a buscar los controles cuando se produce un error
							// porque un usuario hizo click ejem para guardar nos quedamos con el ultimo objeto
							// que disparo un onClick
				lastSender = this;
				var frm
				var c = this;
				while (!frm && c){
					if (c.environment && c.environment.form)
						frm = c.environment.form
					else
						c=c.parent;
				}
				if(frm)
					frm.displayMessage(icc.ui.message('noerror'));
				else
					icc.ui.displayMessage(icc.ui.message('noerror'));
			}
		}
		res= await widget.SUPERclass.fireEventAsync.apply(this,arguments);
		sender = undefined;
		return res;
		
	};
	widget.prototype.fireEvent = function (evtName){	
		var res;
		if(this.eventsEnabled){
		
			if(evtName == "onClick" || ((evtName == "onChange" || evtName =="_onChange" ) && this.uiclass !== "tabpanel")  || evtName=="beforeClick"){
				sender = this;// para saber donde arrancar a buscar los controles cuando se produce un error
							// porque un usuario hizo click ejem para guardar nos quedamos con el ultimo objeto
							// que disparo un onClick
				lastSender = this;
				var frm
				var c = this;
				while (!frm && c){
					if (c.environment && c.environment.form)
						frm = c.environment.form
					else
						c=c.parent;
				}
				if(frm)
					frm.displayMessage(icc.ui.message('noerror'));
				else
					icc.ui.displayMessage(icc.ui.message('noerror'));
			}
		}
		res= widget.SUPERclass.fireEvent.apply(this,arguments);
		sender = undefined;
		return res;
		
	};
})(__icc__);




/* global rhino, $LAB, __icc__ */

(function (icc) {

	var requestWindow;
	var wCount = 0;
	var hideRequestWindow = function () {
		if (requestWindow) {

			setTimeout(function () {

				if (jQuery.active === 0 && !wCount && requestWindow) {
					jQuery(requestWindow).css({
						cursor: 'default'
					});
					var rw = requestWindow;
					setTimeout(function () {

						try {
							document.body.removeChild(rw);
						} catch (e) {
						}
					}, 100);
					requestWindow = undefined;

				}
			}, 100);
		}
	};
	var showRequestWindow = function () {

		if (!requestWindow) {
			var wz = icc.utils.windowSize();
			if (wz.width === 0)
				wz.width = 800;
			if (wz.height === 0)
				wz.height = 600;

			requestWindow = icc.utils.makeElement("div", false);
			requestWindow.innerHTML = "&nbsp;";
			jQuery(requestWindow).css({
				position: 'absolute',
				top: '0px',
				left: '0px',
				width: wz.width - 20 + "px", //document.offsetWidth + "px",
				height: wz.height - 3 + "px", //document.offsetHeight + "px",
				background: 'white',
				zIndex: 200000,
				cursor: 'wait',
				opacity: 0
			});
			try {
				document.body.appendChild(requestWindow);
			} catch (e) {
			}


		}
	};
	if (!rhino) {

		setInterval(function () {
			if ((jQuery.active > 0 || wCount > 0) && icc.ui.enableRequestWindow /*&& !icc.utils.browser.is_ie*/)
				showRequestWindow();
			else
				hideRequestWindow();
		}, 100);
	}

	var Application = function (name, vcc, user, settings, environment) {
		Application.SUPERconstructor.call(this);
		this._name = name;
		this._vcc = vcc;
		this._user = user;
		this._usergroup = settings.usergroup;
		this._vccgroup = settings.vccgroup;
		this._authToken = settings.authToken;

		this._ajax_count = 0;
		this.settings = settings;
		this._app_folder = settings.tweety_folder;

		icc.ui._app = this;
		icc.ui.theApp = this;
		this.timeOffsetUTC = icc.utils.ISO2Date(settings.serverTimeUTC) - icc.utils.ISO2Date(icc.utils.now(true));
		this.timeOffsetLocal = icc.utils.ISO2Date(settings.serverTimeLocal) - icc.utils.ISO2Date(icc.utils.now());
		environment.arguments = this.getParameters();

		this.initialEnvironment = environment;
		this.datasources = {};

		if (!rhino) {

			setInterval(function () {
				jQuery.ajax({
					url: "alive/",
					cache: false
				});
			}, 20000);
		}
	};
	icc.utils.inherit(Application, icc.ui.object);

	Application.prototype.localeSettings = function () {
		var res = {
			datetimeformat: 'dd/MM/yyyy HH:mm:ss',
			datetimemask: "00/00/0000 00:00:00",
			dateformat: 'dd/MM/yyyy',
			datemask: "00/00/0000",
			decimals: this.settings.decimals !== undefined ? this.settings.decimals : 2,
			dhtmlxcaldateformat: "%d/%m/%Y"

		};
		var dateSettings = {
			'dd-mm-yyyy': {
				text: 'dd-mm-yyyy',
				datetimeformat: 'dd-MM-yyyy HH:mm:ss',
				datetimemask: "00-00-0000 00:00:00",
				dateformat: 'dd-MM-yyyy',
				datemask: "00-00-0000",
				dhtmlxcaldateformat: "%d-%m-%Y"
			},
			'dd/mm/yyyy': {
				text: 'dd/mm/yyyy',
				datetimeformat: 'dd/MM/yyyy HH:mm:ss',
				datetimemask: "00/00/0000 00:00:00",
				dateformat: 'dd/MM/yyyy',
				datemask: "00/00/0000",
				dhtmlxcaldateformat: "%d/%m/%Y"
			},
			'mm/dd/yyyy': {
				text: 'mm/dd/yyyy',
				datetimeformat: 'MM/dd/yyyy HH:mm:ss',
				datetimemask: "00/00/0000 00:00:00",
				dateformat: 'MM/dd/yyyy',
				datemask: "00/00/0000",
				dhtmlxcaldateformat: "%m/%d/%Y"
			},
			'mm-dd-yyyy': {
				text: 'mm-dd-yyyy',
				datetimeformat: 'MM-dd-yyyy HH:mm:ss',
				datetimemask: "00-00-0000 00:00:00",
				dateformat: 'MM-dd-yyyy',
				datemask: "00-00-0000",
				dhtmlxcaldateformat: "%m-%d-%Y"
			},
			'dd-Dec-yyyy': {
				readOnlyInput: true,
				text: 'dd-Dec-yyyy',
				datetimemask: "00-LLL-0000 00:00:00",
				dateformat: 'dd-MMM-yyyy',
				datetimeformat: 'dd-MMM-yyyy HH:mm:ss',
				datemask: "00-LLL-0000",
				dhtmlxcaldateformat: "%d-%b-%Y"

			}


		};
		var d = dateSettings[this.settings.dateFormat];
		if (d) {
			for (var k in d)
				res[k] = d[k];

		}
		return res;
	};
	Application.prototype.waitCursor = function (bState) {
		if (bState) {
			wCount++;
			if (icc.ui.enableRequestWindow) {

				showRequestWindow();
			}
		} else {
			if (wCount)
				wCount--;
		}
	};
	Application.prototype.getParameters = function () {
		var match,
				pl = /\+/g, // Regex for replacing addition symbol with a space
				search = /([^&=]+)=?([^&]*)/g,
				decode = function (s) {
					return decodeURIComponent(s.replace(pl, " "));
				},
				query = window.location.search.substring(1);
		urlParams = {};
		while (match = search.exec(query))
			urlParams[decode(match[1])] = decode(match[2]);
		return urlParams;
	};
	Application.prototype.eachForm = function (fn) {
		var root = this.getMainWindow();
		for (var k in root.childs) {
			if (root.childs[k].isForm)
				r = fn(root.childs[k]);
			if (!r)
				return r;
		}
	};
	Application.prototype.getBaseUrl = function () {
		return "designer/applications/" + this._authToken + "/" + this._name + "/";
	};
	Application.prototype.resourceUrl = function (name) {
		return "url(designer/applications/" + this._name + "/resources/" + name + ")";
	};
	Application.prototype.backgroundImage = function (imageName, repeatMode, backColor, backgroundPosition) {
		var url;
		if (!repeatMode)
			repeatMode = "repeat";
		if (!backColor)
			backColor = "";
		if (!backgroundPosition)
			backgroundPosition = "";
		if (imageName.substring(0, 1) === '!') {
			url = "resources/images/" + imageName.substring(1);
		} else {
			if (imageName.substring(0, 1) === '@') {
				var pos = imageName.substring(1).indexOf('@');
				var appName = imageName.substring(1, pos + 1);
				url = "designer/applications/" + this._authToken + "/" + appName + "/resources/" + imageName.substring(pos + 2);
			} else {
				url = this.getBaseUrl() + "resources/" + imageName;
			}
		}
		return "url(" + url + ") " + repeatMode + " " + backColor + " " + backgroundPosition;

	};
	Application.prototype.getVCCName = function () {
		return this._vcc;
	};
	Application.prototype.setVCCName = function (value) {
		this._vcc = value;
	};
	Application.prototype.getUser = function () {
		return this._user;
	};
	Application.prototype.getName = function () {
		return this._name;
	};
	Application.prototype.setName = function (value) {
		this._name = value;
	};
	Application.prototype.getSettings = function () {
		return this.settings;
	};
	Application.prototype.setSettings = function (params) {
		for (var k in params) {
			this.settings[k] = params[k];
		}
	};
	Application.prototype.getIdWithoutVCC = function(id) {
		if (typeof id !== "string") {
			return "";
		}
		var match = id.match(new RegExp(/^(.+)@([^@]+)$/));
		return match ? match[1] : id;
	};
	Application.prototype.ajaxCall = function (method, dataType, url, body, headers, parameters, cb) {
		var self = this;
		var res;
		method = method || "POST",
				url = url || "127.0.0.1",
				body = body || "",
				dataType = dataType || "",
				header = headers || {};
		parameters = parameters || {};
		var parseXML = function (txt) {
			if (window.DOMParser)
			{
				parser = new DOMParser();
				xmlDoc = parser.parseFromString(txt, "text/xml");
			} else // Internet Explorer
			{
				xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
				xmlDoc.async = false;
				xmlDoc.loadXML(txt);
			}
			return xmlDoc;
		};
		jQuery.ajaxSetup({scriptCharset: "utf-8"});
		jQuery.ajax({
			url: "runtime/ajax_call",
			dataType: 'json',
			type: 'POST',
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			contentType: "application/json",
			data: JSON.stringify({
				method: method || "POST",
				url: url,
				data: body,
				headers: headers,
				parameters: parameters
			}),
			async: cb != undefined,
			success: function (ajaxResponse) {
				result = ajaxResponse.result;
				if (ajaxResponse.status) {
					try {
						switch (dataType) {
							case 'xml':
								result = parseXML(result);
								break;
							case 'json':
								result = JSON.parse(result);
								break;
						}
					} catch (e) {
						result = ajaxResponse.result;
					}
				}
				if (ajaxResponse.status) {
					res = result;
				} else {
					self.lastError = ajaxResponse.result;
					res = false;
				}
				if (cb) {
					cb(ajaxResponse.status, result);
				}

			},
			error: function (ajaxError) {

				self.lastError = icc.ui.message('ajax_error', {status: ajaxError.status, statusText: ajaxError.statusText});
				if (cb) {
					cb(false, self.lastError);
				}
				res = false;
			}
		});
		return res;
	};
	Application.prototype.buildForm = function (formName, cb, envdata) {
		var app = this;
		var self = this;
		var govcccb = function () {
			var sformName = formName.replace(new RegExp("[%.~ ]", 'g'), "_");
			var frmdef = icc.cache[formName] || icc.cache[sformName];
			if (frmdef) {
				// envdata es un environment pasado que puede por  tener otros datasources
				icc.console.log(envdata);
				envdata = envdata ? envdata : {};
				envdata.datasources = envdata.datasources ? envdata.datasources : {};

				// nuevo environment para el formulario
				var env = self.createEnvironment();
				for (var idx in envdata.datasources)
					env.datasources[idx] = envdata.datasources[idx];
				var appargs = self.getParameters();
				for (var idx in appargs)
					env.arguments[idx] = appargs[idx];

				for (var idx in envdata.arguments)
					env.arguments[idx] = envdata.arguments[idx];
				if (envdata.changed_datasources)
					env.changed_datasources = envdata.changed_datasources;
				var form;
//				try{
				form = frmdef(icc, env);
//				}catch(e){
//					alert(e);
//				}
				/* inicializa los ds creados por el formulario */

				env.form = form;
				form.isForm = true;
				var t = [];
				for (var idx in env.datasources) {
					if (!envdata.datasources[idx]) {
						t.push(env.datasources[idx]);
					}
				}
				var initNext = function (cb) {
					var ds = t.pop();
					if (ds) {
						ds.init(function (status, result) {
							if (status) {
								initNext(cb);
							} else {
								icc.console.log(result.description);
								cb(status, result);
							}
						});
					} else {
						cb(true);
					}

				};
				initNext(function (status, result) {
					if (status) {
						for (var idx in env.datasources) {
							if (envdata.datasources[idx]) {
								env.datasources[idx].environmentStack.push(env.datasources[idx].environment);// guarda una ref al environment original
								env.datasources[idx].rebindEnvironment(env);
							} else {
								env.datasources[idx].rebindEnvironment(env);
							}
						}
						form.onCreate(function () {
							icc.console.log("onCreate " + form.id);
							var readyList = [];// datasources a los que se inicializara normalmente
							var updateList = [];// datasources a los que se le hara un updateChildRelationships
							for (var idx in env.datasources) {
								if (!envdata.datasources[idx]) {
									readyList.push(env.datasources[idx]);
								} else {
									// Al iniciar en el nuevo environmente se 
									// los pone en una lista para hacerles updateChildRelationships
									// si un datasource del nuevo environment es gobernado 
									// por una relacion se popula y trae datos
									updateList.push(envdata.datasources[idx]);
								}
							}

							var readyNext = function (cb) {
								var ds = readyList.pop();
								if (ds) {
									ds.ready(function (status, result) {
										if (status) {
											readyNext(cb);
										} else {
											cb(status, result);
										}
									});
								} else {
									cb(true);
								}
							};


							var updateNext = function (cb) {
								var ds = updateList.pop();
								if (ds) {
									ds.updateChildRelationships(function (status, result) {
										if (status) {
											updateNext(cb);
										} else {
											cb(status, result);
										}
									});
								} else {
									cb(true);
								}

							};
							readyNext(function (status, result) {
								if (status) {
									updateNext(function (status, result) {
										if (status) {
											icc.console.log("fire onready");
											form.fireEvent("onReady");
											self.waitCursor(false);
										} else {
											self.waitCursor(false);
											icc.ui.displayMessage(result);
										}
									});
								} else {
									self.waitCursor(false);
									icc.ui.displayMessage(result);
								}
							});
						});
						form.onDestroy(function () {
							// destruye los ds creados por el form
							icc.console.log("onDestroy " + form.id);
							for (var idx in env.datasources) {
								if (envdata.datasources[idx] == undefined) {
									if (env.datasources[idx] !== undefined) {
										env.datasources[idx].destroy();

									}
								}
							}

							// luego rebindea los pasados en el environment padre al environment original
							for (var idx in envdata.datasources) {
								var oldenv = envdata.datasources[idx].environmentStack.pop();
								if (oldenv) {
									envdata.datasources[idx].rebindEnvironment(oldenv);
								}
							}

						});

						if (cb)
							cb(true, form);

					} else {
						if (cb) {
							cb(false, result);
						}
					}
				});
			} else {
				self.waitCursor(false);
				if (cb)
					cb(false);
			}
		};
		this.waitCursor(true);
		var loadFormScript = function () {
			if (!icc.cache[formName]) {
				if (icc.utils.browser.is_ie)
					$LAB.script("buildform/" + self._authToken + "/" + self._name + "/" + formName + "?g=" + icc.utils.guid()).wait(function () {
						setTimeout(govcccb, 1);
					});
				else
					$LAB.script("buildform/" + self._authToken + "/" + self._name + "/" + formName).wait(function () {
						setTimeout(govcccb, 1);
					});
			} else {
				setTimeout(govcccb, 1);
			}
		};
		if (self.isCtiEmbeed()) {
			var testForBridge;
			var startTime = new Date();
			testForBridge = function () {																	/* 30 segundos esperando el bridge sino pateara el control despues */
				if ((window.bridge && window.bridge.GetMethodNames && window.bridge.GetEventNames) || Math.floor(((new Date()).getTime() - startTime.getTime()) / 1000) > 30) {
					loadFormScript();
				} else {
					setTimeout(testForBridge, 10);
				}
			};
			testForBridge();
		} else
			loadFormScript();
	};

	Application.prototype.showModal = function (formName, params, cb) {
		var environment = this.createEnvironment();
		if (typeof (params) === "object") {
			jQuery.each(params, function (name, value) {
				if (typeof (value) === "object") {
					if (value.className === "datasource") {
						environment.datasources[name] = value;
						return true;
					}
					environment.arguments[name] = value;
				} else
					environment.arguments[name] = value;
			});

		}


		this.buildForm(formName, function (status, form) {
			if (status) {
				var closeFn;
				form.onClose = function (fn) {
					closeFn = fn;
				};
				var dlg = new icc.ui.dialog({
					childs: [
						form
					]
				});
				form.close = function (data) {
					dlg.close(data);
				};
				dlg.create();
				dlg.onClose(function (result) {
					var c = true;
					if (closeFn)
						c = closeFn();

					if (c && cb) {
						cb(result, form);
					}
				});
				dlg.showModal();

			} else {
				if (cb) {
					cb(status, form);
				}
			}
		}, environment);
	};
	Application.prototype.show = function (formName, params) {
		var self = this;


		var environment = this.createEnvironment();
		if (typeof (params) === "object") {
			jQuery.each(params, function (name, value) {
				if (typeof (value) === "object") {
					if (value.className === "datasource") {
						environment.datasources[name] = value;
						return true;
					}
				}
				environment.arguments[name] = value;
			});

		}
		if (params && params.arguments) {
			environment.arguments = params.arguments;
		}

		this.buildForm(formName, function (status, form) {
			if (status) {
				var root = self.getMainWindow();
				root.rmvAll();
				form.create();
				form.isForm = true;
				root.addChild(form);
				root.layout();
			}
		}, environment);
	};

	Application.prototype.createEnvironment = function () {
		var res = {arguments: {}, datasources: {}, controls: {}, forms: {}, changed_datasources: {}};
		if (this.initialEnvironment && this.initialEnvironment.arguments) {
			for (var k in this.initialEnvironment.arguments) {
				res.arguments[k] = this.initialEnvironment.arguments[k];
			}
		}

		return res;

	};
	Application.prototype.datasource = function (datasourceName, environment) {
		var res;
		var self = this;
		if (environment == undefined)
			environment = self.createEnvironment();
		jQuery.ajax({
			url: this._authToken + "/" + this._name + "/" + this.getDatasourceApp() + "/" + datasourceName,
			dataType: "json",
			async: false,
			success: function (ajaxResponse) {
				if (ajaxResponse.status) {
					ajaxResponse.result.name = datasourceName;
					ajaxResponse.result.alias = datasourceName;
					res = new icc.ui.datasource(ajaxResponse.result, environment);
					res.init(function (status, result) {
						if (!status) {
							res = undefined;
							self.lastError = result;
						}

					});
				} else
					self.lastError = ajaxResponse.result;
			},
			error: function (ajaxError) {
				self.lastError = icc.ui.message('ajax_error', {status: ajaxError.status, statusText: ajaxError.statusText});
			}
		});
		return res;
	};

	Application.prototype.hasAllegroIntegration = function () {
		return this.initialEnvironment.arguments.__allegro === "true";
	};

	Application.prototype.isCti = function () {
		return this.initialEnvironment.arguments.__cti && true || false;
	};

	Application.prototype.isCtiEmbeed = function () {
		return this.initialEnvironment.arguments.__ctiembeed && true || false;
	};

	Application.prototype.getDatasourceApp = function () {
		return this.isCti() ? "datasource_cti" : "datasource";
	};

	Application.prototype.loadDatasource = function (datasourceName, alias, environment, cb) {
		var self = this;
		var result;
		if (typeof (environment) === "function") {
			cb = environment;
			environment = undefined;
		}

		jQuery.ajax({
			async: cb !== undefined,
			url: this._name + "/" + this.getDatasourceApp() + "/" + datasourceName,
			dataType: "json",
			success: function (ajaxResponse) {
				if (ajaxResponse.status) {
					ajaxResponse.result.name = datasourceName;
					ajaxResponse.result.alias = alias;
					var ds = new icc.ui.datasource(ajaxResponse.result, environment);
					self.lastError = undefined;
					if (cb)
						cb(true, ds);
					else
						result = ds;
				} else {
					if (cb)
						cb(false, ajaxResponse.result);
					else {
						result = false;
						self.lastError = ajaxResponse.result;
					}
				}
			},
			error: function (ajaxError) {
				self.lastError = icc.ui.message('ajax_error', {status: ajaxError.status, statusText: ajaxError.statusText});
				result = false;
				if (cb) {
					cb(false, self.lastError);
				}
			}
		});
		return result;
	};
	Application.prototype.getMainWindow = function () {
		return icc.ui._mainWindow;
	};
	Application.prototype.registerDatasource = function (datasource) {
		this.datasources[datasource.getName()] = datasource;
	};
	Application.prototype.getDatasource = function (datasourceName) {
		return this.datasources[datasourceName];
	};
	var prevLevel;
	var code1030;
	Application.prototype.displayMessage = function (msg) {
		if (!msg)
			return;
		if (msg.code === 1019) { // ajax error		
			// si es msgor de ajax el waitwindow puede no mostrarse correctamente
			// asi que mejor mostramos una alert
			if (msg.status === 403) { // forbiden , la sesion expiro o paso algo
				alert(_T('Your session has expired. Please logging in the system again.'));
			} else {
				//alert(_T('Connection error.'));
			}

		} else {
			if (this.errorBox) {

				this.errorBox._displayMessage(msg);
				icc.ui.lastMsg = msg;
				this.errorBox = undefined;

			} else {

				if (msg.level === 8 || prevLevel === 8) {
					icc.ui.waitwindow();
					prevLevel = undefined;
					code1030 = false;
				}

				if (typeof msg === "string") {
					icc.ui.waitwindow(msg);
					return;
				}
				prevLevel = msg.level;

				if (msg.field_errors) {
					var c = 0;
					jQuery.each(msg.field_errors, function (idx, msg) {
						if (!msg.displayed) {
							c++;
							icc.ui.waitwindow(msg.description);
						}
					});
					if (!c) {
						if ((msg.code === 1030 && !code1030) || msg.code !== 1030)
							icc.ui.waitwindow(msg.description);
					}
				} else {
					if (!msg.displayed) {
						if ((msg.code === 1030 && !code1030) || msg.code !== 1030)
							icc.ui.waitwindow(msg.description);

					}
				}
				if (msg.code === 1030)
					code1030 = true;

			}
		}
	};
	Application.prototype.getImageSRC = function (imageName) {
		if (imageName.substring(0, 1) === '!') {
			return "resources/images/" + imageName.substring(1);
		} else {
			if (imageName.substring(0, 1) === '@') {
				var pos = imageName.substring(1).indexOf('@');
				var appName = imageName.substring(1, pos + 1);
				return "designer/applications/" + this._authToken + "/" + appName + "/resources/" + imageName.substring(pos + 2);
			} else {
				return this.getBaseUrl() + "resources/" + imageName;
			}
		}
	};
	Application.prototype.submit = function (url, method, values, target) {
		if (typeof method === "undefined")
			method = "GET";
		if (target == undefined)
			target = "_self";
		var dv = icc.utils.makeElement("div");
		dv.innerHTML = "<form id='submitform' method='" + method + "' enctype='multipart/form-data' " +
				"action='" + url + "' target='" + target + "'></form>";
		jQuery("#submitform", dv).each(function (i, v) {
			if (typeof values === "object") {
				for (var idx in values) {
					var f = icc.utils.makeElement("input");
					f.name = idx;
					f.value = values[idx];
					jQuery(v).append(f);
				}
			}
			document.body.appendChild(v);
			v.submit();
		});
	};
	
	Application.prototype.getDispositions = function(campaignId, callback) {
		jQuery.ajax({
			url: "/inconcert/apps/agent/campaigns/get_dispositions/" + campaignId,
			type: "GET",
			dataType: "json",
			success: function (dispositions) {
				callback(jQuery.isArray(dispositions)? dispositions : []);
			},
			error: function (ajaxError) {
				callback(false, ajaxError);
			}
		});
	};
	
	Application.prototype.getInteraction = function(interactionId, callback) {
		const self = this;
		jQuery.ajax({
			url: "/inconcert/apps/agent/interactions/get_interaction/",
			type: "POST",
			contentType: "application/json",
			dataType: "json",
			data: JSON.stringify({
				interactionID : interactionId,
				inflate : true
			}),
			success: function (interaction) {
				//const redialId = interaction?.interactionData?.redialInteractionID;
				const redialId = interaction && interaction.interactionData && interaction.interactionData.redialInteractionID;
				if (redialId)
					return self.getInteraction(redialId, callback);

				callback(interaction);
			},
			error: function () {
				callback(null);
			}
		});
	};
	
	var wrapupProxies = {
		CHAT : true,
		CALL : true,
		VOICEMAIL : true
	};
	Application.prototype.proxyHasWrapup = function(proxyType) {
		return wrapupProxies[proxyType] || false;
	};
	
	var allegroProxies = {
		CALL : true,
		VOICEMAIL : true
	};
	Application.prototype.proxyIsAllegro = function(proxyType) {
		return (this.hasAllegroIntegration() && allegroProxies[proxyType]) || false;
	};
	
	Application.prototype.interactionIsClosed = function(state) {
		return state === "FINISHED" || state === "CANCELED" || state === "INCONSISTENT";
	};
	
	Application.prototype.canCloseInteraction = function(interactionId, callback) {
		var self = this;
		self.getInteraction(interactionId, function(interaction) {
			if (!interaction) {
				return callback(false, "interaction_not_found");
			}
			if (self.interactionIsClosed(interaction.state)) {
				//closed
				return callback(false, "interaction_closed");
			}
			if (interaction.state !== "TAKEN" && interaction.state !== "WRAPUP") {
				//invalid state like LOCKED
				return callback(false, "interaction_invalid_state");
			}
			if (self.proxyHasWrapup(interaction.type) && interaction.state === "TAKEN") {
				//ACTIVE but has WRAPUP state
				return callback(false, "interaction_is_active");
			}
			callback(true);
		});
	};
	
	Application.prototype.closeAllegroInteraction = function(interactionId, callback) {
		var ba = new Baragent();
		ba.Wrapup(interactionId,
			function(result) {
				if(result.internalCode === 1) {
					callback(true);
				}
				else {
					callback(false, "wrapup_error");
				}
			},
			function(error) {
				if(error.code === 200) {
					callback(true);
				}
				else {
					callback(false, "wrapup_error");
				}
			}
		);
	};
	
	Application.prototype.closeInteraction = function(interactionId, proxyType, campaign, callback) {
		var self = this;
		if (self.proxyIsAllegro(proxyType)) {
			return self.closeAllegroInteraction(interactionId, callback);
		}
		self.getInteraction(interactionId, function(interaction) {
			if (!interaction) {
				return callback(false, "interaction_not_found");
			}
			jQuery.ajax({
				url: "/inconcert/apps/agent/interactions/archive_interactions/",
				type: "POST",
				contentType: "application/json",
				dataType: "json",
				data: JSON.stringify({
					interactions : [{ id : interaction.id }],
					campaignId : campaign + "@" + self.getVCCName(),
					app_id : "interaction"
				}),
				success: function () {
					callback(true);
				},
				error: function () {
					callback(false, "wrapup_error");
				}
			});
		});
	};
	
	Application.prototype.getUserCampaigns = function(callback) {
		jQuery.ajax({
			url: "/inconcert/apps/agent/campaigns/get_campaigns",
			type: "GET",
			contentType: "application/json",
			success: function (campaigns) {
				callback(campaigns);
			},
			error: function () {
				callback({});
			}
		});
	};
	
	Application.prototype.getUserOutgoingCampaigns = function(proxyType, callback) {
		jQuery.ajax({
			url: "/inconcert/apps/agent/campaigns/get_outgoing_campaigns/" + (proxyType || ""),
			type: "GET",
			contentType: "application/json",
			success: function (campaigns) {
				callback(campaigns);
			},
			error: function () {
				callback({});
			}
		});
	};
	
	Application.prototype.getNewContactId = function() {
		return icc.utils.guid() + "@" + this.getVCCName();
	};
	
	Application.prototype.loadForm = Application.prototype.buildForm;
	icc.ui.application = Application;
})(__icc__);


/*jslint evil:true */
/*global   __icc__ 
*/
/* ********************************************************************
 *	vertical layout                                                   *
 *	                                                                  *
 **********************************************************************/
 
(function(icc){

	var MAXNUM=128; // Maximo numero de filas o columnas para el layout matrix 
	icc.ui.layouts.vertical = {
		init:function(){
		},
		
		layout:function(){
			var left,right,top,bottom,remain,extra_space,total_space,t,x,y,w,h;
			var child;
			var sumexpand=0;
			var numexpand=0;
			var mw=0;
			var mh=0;
			var e=0;
			var ocx = this.ocx!==undefined?this.ocx:0
			var ocy = this.ocy!==undefined?this.ocy:0
			
			// Placement rectangle; right/bottom non-inclusive
			left=this.pl;
			right=(this._w!==undefined?this._w:this.width);
			top=this.pt;
			bottom=(this._h!==undefined?this._h:this.height);
			bottom -=this.pb;
			right -=this.pr;
			remain=bottom-top;
			if(this.uniformWidth){
				mw=this.maxChildWidth();
			}
			if(this.uniformHeight){
				mh=this.maxChildHeight();
			}	
			// Find number of paddable children and total height
			for(var iChild=0;iChild<this.childs.length;iChild++){
		
				child = this.childs[iChild];
		
				if(child.visible){
					if(!child.centerY && !child.sideBottom){
						if (child.height!==undefined){
							h=child.height;
						}else if(this.uniformHeight){
							h=mh;
						
						}else {
							h = child.getDefaultHeight();
						}
						if((child.centerY || child.fillHeight) && (child.height===undefined)){
							numexpand+=1;
							//remain-=h;
						}else{
							if(child.y === undefined)
								remain-=h;
						}
			
						remain-=this.vs;
							
					}
						
				}
			}
	
			remain+=this.vs;
			// Do the layout
			for(iChild=0;iChild<this.childs.length;iChild++){
				child = this.childs[iChild];
				if(child.visible){
				// Determine child width
					if(child.width!==undefined){
						w=child.width;
					}
					else if(this.uniformWidth){
						w=mw;
					}else if(child.fillWidth) {
						w=right-left;
						if(child.x!==undefined){
							w-=child.x;
						}
					}else {
						w=child.getDefaultWidth();
					}
				// Determine child x-position
					if(child.x!==undefined){
						x=child.x;
					}else if(child.centerX){
						x=left+(right-left-w)/2;
					}else if(child.sideRight){
						x=right-w;
					}else {
						x=left;
					}
				// Layout child in Y
					y=(child.y===undefined)?0:child.y;
					
					if(child.height!==undefined){
						h=child.height;
					}else if(this.uniformHeight){
						h=mh;
					}else{
						h=child.getDefaultHeight();
					}
					if(child.y===undefined){   
						extra_space=0;
						total_space=0;
						if(child.fillHeight && child.height===undefined){
							if(sumexpand>0){                            // Divide space proportionally to height
								t=h*remain;
								h=t/sumexpand;
								e+=t%sumexpand;
								if(e>=sumexpand){h++;e-=sumexpand;}
							}
							else{// Divide the space equally
								h=remain/numexpand;
								e+=remain%numexpand;
								if(e>=numexpand){h++;e-=numexpand;}
							}
							
						}else if(child.centerY){
							if(sumexpand>0){                            // Divide space proportionally to height
								t=h*remain;
								total_space=t/sumexpand-h;
								e+=t%sumexpand;
								if(e>=sumexpand){total_space++;e-=sumexpand;}
							}
							else{                                       // Divide the space equally
								total_space=remain/numexpand-h;
								e+=remain%numexpand;
								if(e>=numexpand){total_space++;e-=numexpand;}
							}
							extra_space=total_space/2;
						}
						if(child.sideBottom){
							y=bottom-h-extra_space;
							bottom=bottom-(h+this.vs+total_space);
							
							remain=bottom-top;
						}
						else{
							y=top+extra_space;
							top=top+h+this.vs+total_space;
						}
					}else{
						
						if(child.fillHeight && child.height===undefined){
							h = remain-y;
						}
					}
					child.position(x+ocx,y+ocy,w,h);
					
					if (child.zIndex===undefined){
						child.getWnd().style.zIndex=iChild+1;
					}else{
						child.getWnd().style.zIndex=child.zIndex;
					}
				}else{
					if(child.x != undefined && child.y != undefined && child.width !=undefined && child.height!=undefined){
						child.position(child.x,child.y,child.width,child.height);
						
						if (child.zIndex===undefined){
							child.getWnd().style.zIndex=iChild+1;
						}else{
							child.getWnd().style.zIndex=child.zIndex;
						}
					}
					child.getWnd().style.visibility="hidden";
				}
			}
		},
		_layout:function(){
			var left, right, top, bottom, remain, extra_space, total_space, t, x, y, w, h;
			var child;
			var sumexpand = 0;
			var numexpand = 0;
			var mw = 0;
			var mh = 0;
			var e = 0;
			var width = this._w != undefined ? this._w : this.width;
			var height = this._h != undefined ? this._h : this.height;
			var ocx = this.ocx !== undefined ? this.ocx : 0
			var ocy = this.ocy !== undefined ? this.ocy : 0
			// Placement rectangle; right/bottom non-inclusive
			left = this.pl;
			right = width - this.pr;
			top = this.pt;
			bottom = height - this.pb;
			remain = bottom - top;

			// Get maximum child size
			if (this.uniformWidth) mw = this.maxChildWidth();
			if (this.uniformHeight) mh = this.maxChildHeight();
			for (var n = 0; n < this.childs.length; n++) {
				child = this.childs[n];
				if (child.visible) {

					// Find number of paddable children and total height
					if (child.y ==undefined) {
						if (child.height != undefined) h = child.height;
						else if (this.uniformHeight) h = mh;
						else h = child.getDefaultHeight();
						if ((child.centerY) || (child.fillHeight)) {
							sumexpand += h;
							numexpand += 1;
						} else {
							remain -= h;
						}
						remain -= this.vs;
					}
				}
			}

			// Child spacing correction
			remain += this.vs;

			// Do the layout
			for (var n = 0; n < this.childs.length; n++) {
				child = this.childs[n];
				if (child.visible) {

					// Determine child width
					if (child.width != undefined) w = child.width;
					else if (this.uniformWidth) w = mw;
					else if (child.fillWidth) w = right - left;
					else w = child.getDefaultWidth();

					// Determine child x-position
					if (child.x != undefined) x = child.x;
					else if (child.centerX) x = left + (right - left - w) / 2;
					else if (child.sideRight) x = right - w;
					else x = left;

					// Layout child in Y
					y = child.y
					if (child.height != undefined) h = child.height
					else if (this.uniformHeight) h = mh;
					else h = child.getDefaultHeight();
					if (!((child.sideBottom) && (child.centerY))) { // LAYOUT_FIX_Y
						extra_space = 0;
						total_space = 0;
						if ((child.fillHeight) && (child.height == undefined)) {
							if (sumexpand > 0) { // Divide space proportionally to height
								t = h * remain;
								h = t / sumexpand;
								e += t % sumexpand;
								if (e >= sumexpand) {
									h++;
									e -= sumexpand;
								}
							} else { // Divide the space equally
								h = remain / numexpand;
								e += remain % numexpand;
								if (e >= numexpand) {
									h++;
									e -= numexpand;
								}
							}
						}else if (child.centerY) {
							if (sumexpand > 0) { // Divide space proportionally to height
								t = h * remain;
								total_space = t / sumexpand - h;
								e += t % sumexpand;
								if (e >= sumexpand) {
									total_space++;
									e -= sumexpand;
								}
							} else { // Divide the space equally
								total_space = remain / numexpand - h;
								e += remain % numexpand;
								if (e >= numexpand) {
									total_space++;
									e -= numexpand;
								}
							}
							extra_space = total_space / 2;
						}
						if (child.sideBottom) {
							y = bottom - h - extra_space;
							bottom = bottom - h - this.vs - total_space;
						} else {
							if(y==undefined){
								y = top + extra_space;
								top = top + h + this.vs + total_space;
							}
						}
					}
					child.position(x + ocx, y + ocy, w, h);

					if (child.zIndex === undefined) {
						child.getWnd().style.zIndex = n + 1;
					} else {
						child.getWnd().style.zIndex = child.zIndex;
					}

				}
			}
		},
		getDefaultWidth:function(){
			var w,wmax,wcum,mw;
			var child;
			wmax=wcum=mw=0;
			if(this.uniformWidth){
				mw=this.maxChildWidth();
			}
			for(var n=0;n<this.childs.length;n++){
				child = this.childs[n];
				if(child.visible){
					if(child.width){ w=child.width;}
					else if(this.uniformWidth){ w=mw;}
//					else if(child.fillWidth) w= 0;
					else {w=child.getDefaultWidth();}
					if(child.x){        // LAYOUT_FIX_X
						w=child.x+w;
						if(w>wmax){
							wmax=w;
						}
					}
					else{
						if(w>wcum){
							wcum=w;
						}
					}
				}
			}
			
			return ((wcum>wmax)?wcum:wmax)+this.pl+this.pr;
		},
		getDefaultHeight:function(){
			var h,hcum,hmax,mh;
			var child;
			hcum=hmax=mh=0;
			if(this.uniformHeight) {mh=this.maxChildHeight();}
			for(var n=0;n<this.childs.length;n++){
				child=this.childs[n];
				if(child.visible){
					if(child.height!==undefined){
						h=child.height;
						
					}else if(this.uniformHeight){ 
						h=mh;
	//				else if(child.fillHeight) h=0;
					}else{
						h=child.getDefaultHeight();
					}
					if(child.y!==undefined){       // LAYOUT_FIX_Y
						h=child.y+h;
						if(h>hmax){
							hmax=h;
						}
					}
					else{
						if(hcum){
							hcum+=this.vs;
						}
						
						hcum+=h;
					}
				}
			}
			return ((hcum>hmax)?hcum:hmax)+this.pb+this.pt;
		}
	};
	icc.ui.layouts.horizontal = {
		init:function(){
		},
		layout:function(){
			var left,right,top,bottom,remain,extra_space,total_space,t,x,y,w,h;
			var child;
			var sumexpand=0;
			var numexpand=0;
			var mw=0;
			var mh=0;
			var e=0;
			//document.write("THorizontal Frame Layout<br>")
			// Placement rectangle; right/bottom non-inclusive
			left=this.pl;
			right=(this._w!==undefined?this._w:this.width);
			top=this.pt;
			bottom=(this._h!==undefined?this._h:this.height);
			if(bottom === undefined || right === undefined){
				return;
			}
			right-=this.pr;
			bottom -=this.pb;

			remain=right-left;
			// Get maximum child size
			if(this.uniformWidth){
				mw=this.maxChildWidth();
			}
			if(this.uniformHeight){
				mh=this.maxChildHeight();
			}
			
			// Find number of paddable children and total width
			for(var iChild=0;iChild<this.childs.length;iChild++){
				child= this.childs[iChild];
				if(child.visible){
					if(!child.x){     // LAYOUT_FIX_X
						if(child.width){ w=child.width;}
						else if(this.uniformWidth){ w=mw;}
						else {w=child.getDefaultWidth();}
						if(child.centerX || ((child.fillWidth) && !(child.width))) {
							sumexpand+=w;
							numexpand+=1;
						}
						else{
							remain-=w;
						}
						remain-=this.hs;
					}
				}
				}
				// Child spacing correction
			remain+=this.hs;
			// Do the layout
			for(iChild=0;iChild<this.childs.length;iChild++){
				child=this.childs[iChild];
				if(child.visible){
					// Determine child height
					if(child.height){ h=child.height;
					}else if(this.uniformHeight){
						h=mh;
					}else if(child.fillHeight){
						h=bottom-top;
					}else {
						h=child.getDefaultHeight();
					}
					// Determine child y-position
					if(child.y){
						y=child.y;
					}
					
					else if(child.centerY){y=top+(bottom-top-h)/2;}
					else if(child.sideBottom){ y=bottom-h;}
					else {y=top;}
					// Layout child in X
					x=child.x;
					if(child.width){ w=child.width;}
					else if(this.uniformWidth){ w=mw;}
					else {w=child.getDefaultWidth();}
					if(!(child.x)){     // LAYOUT_FIX_X
						extra_space=0;
						total_space=0;
						if(child.fillWidth && !child.width){
							if(sumexpand>0){  // Divide space proportionally to width
								t=w*remain;
								w=t/sumexpand;
								e+=t%sumexpand;
								if(e>=sumexpand){w++;e-=sumexpand;}
							}else{  // Divide the space equally
								w=remain/numexpand;
								e+=remain%numexpand;
								if(e>=numexpand){w++;e-=numexpand;}
							}
						}
						else if(child.centerX){
							if(sumexpand>0){ // Divide space proportionally to width
								t=w*remain;
								total_space=t/sumexpand-w;
								e+=t%sumexpand;
								if(e>=sumexpand){total_space++;e-=sumexpand;}
							}
							else{   // Divide the space equally
								total_space=remain/numexpand-w;
								e+=remain%numexpand;
								if(e>=numexpand){total_space++;e-=numexpand;}
							}
							extra_space=total_space/2;
						}
						if(child.sideRight){
							x=right-w-extra_space;
							right=right-w-this.hs-total_space;
						}
						else{
							x=left+extra_space;
							left=left+w+this.hs+total_space;
						}
					}
					if(child.fillHeight){
						h-=y;
						h+=this.pt;
					}
					if (child.zIndex===undefined){
						child.getWnd().style.zIndex=iChild+1;
					}else{
						child.getWnd().style.zIndex=child.zIndex;
					}
					
					child.position(x,y,w,h);
				}else{
					if(child.x != undefined && child.y != undefined && child.width !=undefined && child.height!=undefined){
						child.position(child.x,child.y,child.width,child.height);
						
						if (child.zIndex===undefined){
							child.getWnd().style.zIndex=iChild+1;
						}else{
							child.getWnd().style.zIndex=child.zIndex;
						}
					}
					child.getWnd().style.visibility="hidden";
				}
			}

		
		},
		getDefaultWidth:function(){
			var w,wcum,wmax,mw;
			var child;
			wcum=wmax=mw=0;
			if(this.uniformWidth){
				 mw=this.maxChildWidth();
			}
			for(var n=0;n<this.childs.length;n++){
				child=this.childs[n];
				if(child.visible){
					if(child.width){
						 w=child.width;
					}else if(this.uniformWidth){
						 w=mw;
					}else {
						w=child.getDefaultWidth();
					}
					if(child.x){        // LAYOUT_FIX_X
						w=child.x+w;
						if(w>wmax){
							wmax=w;
						}
					}
					else{
						if(wcum){
							wcum+=this.hs;
						}
						wcum+=w;
					}
				}
			}
			return ((wcum>wmax)?wcum:wmax)+this.pl+this.pr;
		},
		getDefaultHeight:function(){
			var h,hmax,hcum,mh;
			var child;
			hmax=hcum=mh=0;
			if(this.uniformWidth){
				mh=this.maxChildHeight();
			}
			
			for(var n=0;n<this.childs.length;n++){
				child=this.childs[n];
				if(child.visible){
					if(child.height){
						h=child.height;
					}else if(this.uniformHeight){
						 h=mh;
					}else {
						h=child.getDefaultHeight();
					}
			
					if(child.y){       // LAYOUT_FIX_Y
						h=child.y+h;
						if(h>hmax){
							hmax=h;
						}
					}
					else{
						if(h>hcum){
							hcum=h;
						}
					}
				}
			}
			
			return ((hcum>hmax)?hcum:hmax)+this.pt+this.pb;		
		}
		
		
	};
	icc.ui.layouts.matrix = {
		init:function(){

			if (this.columns){
				if(this.columns == "auto"){
					this.num = 2;
				}else{
					this.num = this.columns;
				}
				this._matrix_by_columns = true;
			} else if( this.rows) {
				if(this.rows == "auto"){
					this.num = 2;
				}else				
					this.num = this.rows;
				this._matrix_by_rows = true;
			}else
			{
				this.num=2;
				this._matrix_by_columns = true;
			}

		},
		layout:function(){
			var ncol,nrow,nzcol,nzrow,r,c,x,y,w,h,n,e,t;
			var rowh = new Array(MAXNUM);
			var colw = new Array(MAXNUM);
			var srow = new Array(MAXNUM);
			var scol = new Array (MAXNUM);
			var left,right,top,bottom,cw,rh;
			var mw=0,mh=0;
			var hremain,vremain;
			var hsumexpand,hnumexpand;
			var vsumexpand,vnumexpand;
			var child;



			if (this.columns){
				if(this.columns == "auto"){
					var l=this._w;
					var cols = 0;
					for (nChild=0;nChild<this.childs.length ;nChild++){
						if(l>(this.childs[nChild].width!=undefined?this.childs[nChild].width:this.childs[nChild].getDefaultWidth())){
							l-=this.childs[nChild].width!=undefined?this.childs[nChild].width:this.childs[nChild].getDefaultWidth();
							cols++;
						}else
							break;
					}
					this.num = cols;
				}else{
					this.num = this.columns;
				}
				this._matrix_by_columns = true;
			} else if( this.rows) {
				if(this.rows == "auto"){
					var l=this._h;
					var rows = 0;
					for (nChild=0;nChild<this.childs.length ;nChild++){
						if(l>(this.childs[nChild].height!=undefined?this.childs[nChild].height:this.childs[nChild].getDefaultHeight())){
							l-=this.childs[nChild].height!=undefined?this.childs[nChild].height:this.childs[nChild].getDefaultHeight()
							rows++;
						}else
							break;
					}
					this.num = rows;
				}else				
					this.num = this.rows;
				this._matrix_by_rows = true;
			}else
			{
				this.num=2;
				this._matrix_by_columns = true;
			}


			// Placement rectangle; right/bottom non-inclusive
			left=this.pl;
			right=(this._w!==undefined?this._w:this.width)-(this.pr+this.pl);
			top=this.pt;
			bottom=(this._h!==undefined?this._h:this.height)-(this.pb+this.pt);
			hremain=right-left;
			vremain=bottom-top;
			// Non-zero rows/columns
			nzrow=0;
			nzcol=0;
			// Clear column/row sizes
			for(n=0; n<MAXNUM; n++){
				colw[n]=rowh[n]=0;          // Columns may be 0 size
				srow[n]=scol[n]=1;

			}

			// Get maximum child size
			if(this.uniformWidth) {mw=this.maxChildWidth();}
			if(this.uniformHeight) {mh=this.maxChildHeight();}
			// Find expandable columns and rows
			for(n=0; n<this.childs.length;n++){
				child=this.childs[n];
				if(child.visible){
					if(this._matrix_by_columns){
						r=parseInt(n/this.num,10);
						c=parseInt(n%this.num,10);
					
					}else{
						r=parseInt(n%this.num,10);
						c=parseInt(n/this.num,10);
						
					}
					if(child.width){w=child.width;}
					else if(this.uniformWidth) {w=mw;}
					else {w=child.getDefaultWidth();}
					if(child.height) {h=child.height;}
					else if(this.uniformHeight) {h=mh;}
					else {h=child.getDefaultHeight();}
					if(w>colw[c]){
						if(colw[c]===0){
							 nzcol++; 
						}
						colw[c]=w; 
					}
					if(h>rowh[r]){
						if(rowh[r]===0){
							nzrow++; 
						}
						rowh[r]=h;
					}
					if(!child.fillWidth) {scol[c]=0;}
					if(!child.fillHeight) {srow[r]=0;}
				}
			}
			  // Get number of rows and columns
			if(this._matrix_by_columns){
				ncol=this.num;
				nrow=parseInt((n+this.num-1)/this.num,10);
			}
			else{
				ncol=parseInt((n+this.num-1)/this.num,10);
				nrow=this.num;
			}
			// Find stretch in columns
			for(c=hsumexpand=hnumexpand=0; c<ncol; c++){
				if(colw[c]){
					if(scol[c]){
						hsumexpand+=colw[c];
						hnumexpand++;
					}
					else{
						hremain-=colw[c];
					}
				}
			}
			// Find stretch in rows
			for(r=vsumexpand=vnumexpand=0; r<nrow; r++){
				if(rowh[r]){
					if(srow[r]){
						vsumexpand+=rowh[r];
						vnumexpand++;
						}
					else{
						vremain-=rowh[r];
					}
				}
			}
			// Substract spacing for non-zero rows/columns
			if(nzcol>1) {hremain-=(nzcol-1)*this.hs;}
			if(nzrow>1) {vremain-=(nzrow-1)*this.vs;}
			// Disburse space horizontally
			x=this.pl;
			for(c=e=0; c<ncol; c++){
				w=colw[c];
				colw[c]=x;
				if(w){
					if(scol[c]){
						if(hsumexpand>0){                         // Divide proportionally
							t=w*hremain;
							w=parseInt(t/hsumexpand,10);
							e+=parseInt(t%hsumexpand,10);
							if(e>=hsumexpand){
								w++;
								e-=hsumexpand;
							}
						}
						else{                                     // Divide equally
							w=parseInt(hremain/hnumexpand,10);
							e+=parseInt(hremain%hnumexpand,10);
							if(e>=hnumexpand){
								w++;
								e-=hnumexpand;
							}
						}
						}
					x+=w+this.hs;
				}
			}
			colw[ncol]=x;
			// Disburse space vertically
			y=this.pt;
			for(r=e=0; r<nrow; r++){
				h=rowh[r];
				rowh[r]=y;
				if(h){
					if(srow[r]){
						if(vsumexpand>0){                         // Divide proportionally
							t=h*vremain;
							h=parseInt(t/vsumexpand,10);
							e+=parseInt(t%vsumexpand,10);
							if(e>=vsumexpand){
								h++;e-=vsumexpand;
							}
						}
						else{                                     // Divide equally
							h=parseInt(vremain/vnumexpand,10);
							e+=parseInt(vremain%vnumexpand,10);
							if(e>=vnumexpand){
								h++;
								e-=vnumexpand;
							}
						}
					}
					y+=h+this.vs;
				}
			}
			rowh[nrow]=y;
			// Do the layout
			for(n=0;n<this.childs.length;n++){
				child = this.childs[n];
				if(child.visible){
					if(this._matrix_by_columns){
						r=parseInt(n/this.num,10);
						c=parseInt(n%this.num,10);
					}else{
						r=parseInt(n%this.num,10);
						c=parseInt(n/this.num,10);
					}
					cw=colw[c+1]-colw[c]-this.hs;
					rh=rowh[r+1]-rowh[r]-this.vs;
					if(child.width) {w=child.width;}
					else if(child.fillWidth) {w=cw;}
					else if(this.uniformWidth) {w=mw;}
					else {w=child.getDefaultWidth();}
					if(child.centerX) {
						x=parseInt(colw[c]+(cw-w)/2,10);
					}else if(child.sideRight) {x=colw[c]+cw-w;}
					else {x=colw[c];}
					if(child.height) {h=child.height;}
					else if(child.fillHeight) {h=rh;}
					else if(this.uniformHeight) {h=mh;}
					else {h=child.getDefaultHeight();}
					if(child.centerY) {y=parseInt(rowh[r]+(rh-h)/2,10);}
					else if(child.sideBottom) {y=rowh[r]+rh-h;}
					else {y=rowh[r];}
					if (child.zIndex===undefined){
						child.getWnd().style.zIndex=n+1;
					}else{
						child.getWnd().style.zIndex=child.zIndex;
					}
					child.position(x,y,w,h);
				}else{
				
					if(child.x != undefined && child.y != undefined && child.width !=undefined && child.height!=undefined){
						child.position(child.x,child.y,child.width,child.height);
						
						if (child.zIndex===undefined){
							child.getWnd().style.zIndex=iChild+1;
						}else{
							child.getWnd().style.zIndex=child.zIndex;
						}
					}
					child.getWnd().style.visibility="hidden";
					
				}
			}		
		},
		getDefaultWidth:function(){
			var c,n,w,nzcol=0,wmax=0,mw=0;
			var child;
			var colw =new Array(MAXNUM);
			for(c=0; c<MAXNUM; c++){
				colw[c]=0;
			}
			if(this.uniformWidth) {mw=this.maxChildWidth();}
			for(n=0;n<this.childs.length;n++){
				child = this.childs[n];
				if(child.visible){
					
					if(child.width) {w=child.width;}
					else if(this.uniformWidth) {w=mw;}
					else {w=child.getDefaultWidth();}
					c=(this._matrix_by_columns)?parseInt(n%this.num,10):parseInt(n/this.num,10);
					if(w>colw[c]){
						if(colw[c]===0) {nzcol++;}                             // Count non-zero columns
							wmax+=w-colw[c];
						colw[c]=w;
						}
				}
			}
			if(nzcol>1) {wmax+=(nzcol-1)*this.hs;}
			return this.pl+this.pr+wmax;
		},
		getDefaultHeight:function(){
			var r,n,h,nzrow=0,hmax=0,mh=0;
			var child;
			var rowh= new Array(MAXNUM);
			for(r=0; r<MAXNUM; r++){
				rowh[r]=0;
			}
			if(this.uniformHeight) {mh=this.maxChildHeight();}
			for(n=0; n<this.childs.length;n++){
				child = this.childs[n];
				if(child.visible){
					if(child.height) {h=child.height;}
					else if(this.uniformHeight) {h=mh;}
					else {h=child.getDefaultHeight();}
				
					
					r=(this._matrix_by_columns)?parseInt(n/this.num,10):parseInt(n%this.num,10);
					if(h>rowh[r]){
						if(rowh[r]===0) {nzrow++;}                             // Count non-zero rows
							hmax+=h-rowh[r];
						rowh[r]=h;
					}
				}
			}
			
			if(nzrow>1) {hmax+=(nzrow-1)*this.vs;}
			//hmax+=(this.childs.length-2)*this.vs;
			return this.pt+this.pb+hmax;
		}
		
	};
	var valueInRange = function (value, min, max){
		return (value <= max) && (value >= min);
	}

	var Overlap = function (A, B){
		var xOverlap = valueInRange(A.x, B.x, B.x + B.w) ||
					   valueInRange(B.x, A.x, A.x + A.w);
 
		var yOverlap = valueInRange(A.y, B.y, B.y + B.h) ||
					   valueInRange(B.y, A.y, A.y + A.h);
 
		return xOverlap && yOverlap;
	};
	var OverlapArea = function ( A, B) {
		
		if (Overlap(A,B)){
			var left=Math.max(A.x,B.x);
			var right=Math.min(A.x + A.w,B.x + B.w);
			var top=Math.max(A.y,B.y);
			var bottom=Math.min(A.y + A.h,B.y + B.h);
			return {x:left,y:top,w:right-left,h:bottom - top};
		}

	};
	var Colindant = function (A,B){
		var intersect = OverlapArea(A,B)
		if(intersect){
			return intersect.w<=1 || intersect.h<=1;
		}else{
			return false;
		}
	}
	var OverlapNoColindant = function (A,B){
		return Overlap(A,B) && !Colindant(A,B);
	}

	icc.ui.layouts.scalable = {
		init:function(){
		},
		layout:function(){
			var self = this;

			var ctrlpositions = {}
			var ctrls=[];
			var ctrlsh=[];
			var ctrlsv=[];
			var left,right,top,bottom;
			
			var child;
			var left=this.pl;
			var right=(this._w!==undefined?this._w:this.width) ;
			var top=this.pt;
			var bottom=(this._h!==undefined?this._h:this.height);
		
			bottom -=this.pb;
			right -=this.pr;
			var minRight = function (pos){
				var minx = right;
				for (var i = ctrlsh.length-1;i>=0;i--){
					var ctrl = ctrlsh[i]
					if(pos.ctrl != ctrl){
						if (OverlapNoColindant({x:pos.x,y:pos.y,w:1e15,h:pos.h},ctrlpositions[ctrl.widgetid])){
							minx = minx > ctrlpositions[ctrl.widgetid].x?ctrlpositions[ctrl.widgetid].x:minx;
						}
					}else
						break;
				}		
				return minx;
			}
			var minBottom = function (pos){
				var miny = bottom;
				for (var i = ctrlsv.length-1;i>=0;i--){
					var ctrl = ctrlsv[i]
					if(pos.ctrl != ctrl){
						if (OverlapNoColindant({x:pos.x,y:pos.y,w:pos.w,h:1e15},ctrlpositions[ctrl.widgetid])){
							miny = miny > ctrlpositions[ctrl.widgetid].y?ctrlpositions[ctrl.widgetid].y:miny;
						}
					}else
						break;
				}		
				return miny;
			}
			var minLeft = function (pos){
				var minx = left;
				for (var i = 0;i<ctrlsh.length;i++){
					var ctrl = ctrlsh[i]
					if(pos.ctrl != ctrl){
						if (OverlapNoColindant({x:pos.x-1e14,y:pos.y,w:pos.w+1e15,h:pos.h},ctrlpositions[ctrl.widgetid])){
							minx = minx < ctrlpositions[ctrl.widgetid].x+ctrlpositions[ctrl.widgetid].w?ctrlpositions[ctrl.widgetid].x+ctrlpositions[ctrl.widgetid].w:minx;
						}
					}else
						break;
				}		
				return minx;
			}
			var minTop = function (pos){
				var miny = top;
				for (var i = 0;i<ctrlsv.length;i++){
					var ctrl = ctrlsv[i]
					if(pos.ctrl != ctrl){
						if (OverlapNoColindant({x:pos.x,y:pos.y-1e15,w:pos.w,h:pos.h+1e15},ctrlpositions[ctrl.widgetid])){
							miny = miny < ctrlpositions[ctrl.widgetid].y+ctrlpositions[ctrl.widgetid].h?ctrlpositions[ctrl.widgetid].y+ctrlpositions[ctrl.widgetid].h:miny;
						}
					}else
						break;
				}		
				return miny;
			}

			for(var iChild=0;iChild<this.childs.length;iChild++){
				var child = this.childs[iChild];
				if(child.visible){
					ctrls.push(child);
					ctrlsh.push(child);
					ctrlsv.push(child);
				}else{
					var cwnd = child.getWnd();
					if(cwnd){
						cwnd.style.visibility = "hidden";
					}
				}
			}
			ctrls.sort(function(a,b){
				var r = a.y - b.y;
				if(r==0)
					r= a.x - b.x
				return r;
			});

			ctrlsh.sort(function(a,b){
				return a.x - b.x;
			});

			ctrlsv.sort(function(a,b){
				return a.y - b.y;
			});

			for(i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				
				ctrlpositions[ctrl.widgetid] = {ctrl:ctrl,
					x:(ctrl.x || 0)+(ctrl.paddingLeft || 0),
					y:(ctrl.y || 0)+(ctrl.paddingTop || 0),
					index:i,
					w:(ctrl.paddingRight || 0)+(ctrl.width!=undefined?ctrl.width:ctrl.getDefaultWidth()),
					h:(ctrl.paddingBottom || 0)+(ctrl.height!=undefined?ctrl.height:ctrl.getDefaultHeight())
				};
			}
			/* deja sin tamaÃ±o los fillHeight para que no jodan a los demas en tamaÃ±os chicos*/
			for(var i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.fillHeight){
					pos._th = pos.h;
					pos.h=0;
				}
				if (ctrl.fillWidth){
					pos._tw = pos.w;
					pos.w=0;
				}
			}

			// side right
			for(var i=0;i<ctrlsh.length;i++){
				var ctrl = ctrlsh[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideRight && !ctrl.sideLeft){
					pos.x = minLeft(pos);
				}
			}
			
			for(var i=ctrlsh.length-1;i>=0;i--){
				var ctrl = ctrlsh[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideRight && !ctrl.sideLeft){
					pos.x = minRight(pos)- pos.w -self.hs-(ctrl.paddingRight || 0);					
				}
			}
			for(var i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.fillWidth)
					pos.w = pos._tw;
			}

			

			// side left
			for(var i=0;i<ctrlsh.length;i++){
				var ctrl = ctrlsh[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideLeft && !ctrl.sideRight){
					pos.x = minLeft(pos)+(ctrl.paddingLeft || 0);
				}
			
			}
			
			// side bottom
			for(var i=0;i<ctrlsv.length;i++){

				var ctrl = ctrlsv[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideBottom && !ctrl.sideTop){
					pos.y = minTop(pos);
				}
			}
			for(var i=ctrlsv.length-1;i>=0;i--){
				var ctrl = ctrlsv[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideBottom && !ctrl.sideTop){
					pos.y = minBottom(pos) - pos.h - self.vs - (ctrl.paddingBottom || 0);					
				}
			}
			for(var i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.fillHeight)
					pos.h = pos._th;
			}
			
			// side top
			for(var i=0;i<ctrlsv.length;i++){
				var ctrl = ctrlsv[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideTop && !ctrl.sideBottom){
					pos.y = minTop(pos) +(ctrl.paddingTop || 0);
				}
			}
			for(var i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.fillWidth ){
				    if(ctrl.fillHeight){ // hace fillHeight luego fillWidth y sigue con otro
    					pos.h = minBottom(pos) - self.vs - pos.y - (ctrl.paddingBottom || 0);
    					pos.w = minRight(pos) - pos.x;
    					pos.w = Math.max(pos.w,ctrl.minWidth || 0)
    					pos.h = Math.max(pos.h,ctrl.minHeight || 0)
                        continue;
				    }    					
					pos.w = minRight(pos) - pos.x;
					pos.w = Math.max(pos.w,ctrl.minWidth || 0)
				}
				if (ctrl.fillHeight){
					pos.h = minBottom(pos) - self.vs - pos.y - (ctrl.paddingBottom || 0);
					pos.h = Math.max(pos.h,ctrl.minHeight || 0)
				}
			}
			
			for(i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var deltaH,deltaW;
				deltaH=0;deltaW=0;
				var pos = ctrlpositions[ctrl.widgetid];
				if(ctrl.canGrowVertically || ctrl.canShrinkVertically){
					var h = ctrl.height;
					ctrl.height=undefined;
					var w = ctrl.width;
					ctrl.width = pos.w
					deltaH = ctrl.getDefaultHeight()-h;
					ctrl.height = h;
					ctrl.width = w;
					if(ctrl.fillHeight || !ctrl.canGrowVertically && deltaH > 0)
						deltaH=0;
					if(ctrl.fillHeight || !ctrl.canShrinkVertically && deltaH < 0)
						deltaH=0;
					
				}
				if(ctrl.canGrowHorizontally || ctrl.canShrinkHorizontally){
					var w = ctrl.width;
					ctrl.width = undefined;
					var h = ctrl.height;
					ctrl.height= pos.h;
					deltaW = ctrl.getDefaultWidth()-w;
					ctrl.width = w;
					ctrl.height = h;
					if(ctrl.fillWidth || !ctrl.canGrowHorizontally && deltaW > 0)
						deltaW=0;
					if(ctrl.fillWidth || !ctrl.canShrinkHorizontally&& deltaW < 0)
						deltaW=0;
	
				}
					
				var pw = pos.w
				var ph = pos.h
				pos.w += deltaW;
				pos.h += deltaH;		
				if(deltaW)
					pos.w = Math.max(pos.w,ctrl.minWidth || 0)+(ctrl.paddingRight || 0)
				if(deltaH)
					pos.h = Math.max(pos.h,ctrl.minHeight || 0)+(ctrl.paddingBottom || 0)
				
				deltaW = pos.w - pw;
				deltaH = pos.h - ph;
				
				if(ctrl.sideRight)
					pos.x -=deltaW;
				if(ctrl.sideBottom)
					pos.y -=deltaH;
				

				if(deltaH){
					jQuery(ctrls).each(function(idx,downctrl){
						if(!downctrl.sideBottom && downctrl.y > ctrl.y && OverlapNoColindant({x:downctrl.x,y:downctrl.y,w:downctrl.width,h:downctrl.height},{x:ctrl.x,y:ctrl.y,w:ctrl.width,h:1e15})){
							if(deltaH<0){
								var top = minTop(ctrlpositions[downctrl.widgetid]);
								if(ctrlpositions[downctrl.widgetid].y+deltaH<top)
									deltaH = Math.max(deltaH,(ctrlpositions[downctrl.widgetid].y+deltaH)-top);
								ctrlpositions[downctrl.widgetid].y+=deltaH;
							}else
								ctrlpositions[downctrl.widgetid].y+=deltaH;
						}
					});
				}
				if(deltaW){
					jQuery(ctrls).each(function(idx,rightctrl){
						if(!rightctrl.sideRight && rightctrl.x > ctrl.x && OverlapNoColindant({x:rightctrl.x,y:rightctrl.y,w:rightctrl.width,h:rightctrl.height},{x:ctrl.x,y:ctrl.y,w:1e15,h:ctrl.height})){
							ctrlpositions[rightctrl.widgetid].x+=deltaW;
						}
					});
				}
				if (ctrl.centerX && !ctrl.sideLeft && !ctrl.sideRight && !ctrl.fillWidth){
					var l = minLeft(pos) ;
					var r = minRight(pos);
					var c = ((r - l) /2 )+ l;
					pos.x = parseInt(c - (pos.w/2));

				}
				if (ctrl.centerY && !ctrl.sideTop && !ctrl.sideBottom && !ctrl.fillHeight){
					var t = minTop(pos) + self.vs + (ctrl.paddingTop || 0);
					var b = minBottom(pos) - self.vs - (ctrl.paddingTop || 0);
					var c = ((b - t) /2 )+ t;
					pos.y = parseInt(c - (pos.h/2));

				}
			}
			
			for (var idx=0;idx<ctrls.length;idx++){
				var ctrl = ctrls[idx];
				var pos = ctrlpositions[ctrl.widgetid]
				ctrl.position(pos.x,pos.y,pos.w-(pos.ctrl.paddingRight || 0),pos.h-(pos.ctrl.paddingBottom || 0));
				if (ctrl.zIndex===undefined){
					ctrl.getWnd().style.zIndex=parseInt(idx)+1;
				}else{				
					ctrl.getWnd().style.zIndex=ctrl.zIndex;
				}
				
			}		
/*			
			}else {
				var maxX = 0;
				var maxY = 0;
				for (idx=0;idx<ctrls.length;idx++){
					var ctrl = ctrls[idx];
					var pos = ctrlpositions[ctrl.widgetid];
					maxX = Math.max(maxX,pos.x + pos.w);
					maxY = Math.max(maxY,pos.y + pos.h);
				}		
				return {width:maxX,height:maxY}
			}
*/
		},
		getDefaultWidth:function(){

			var ctrlpositions = {}
			var ctrls=[];
			var ctrlsh=[];
			var ctrlsv=[];
			var left=this.pl;
			var child;
			var minLeft = function (pos){
				var minx = left;
				for (var i = 0;i<ctrlsh.length;i++){
					var ctrl = ctrlsh[i]
					if(pos.ctrl != ctrl){
						if (OverlapNoColindant({x:pos.x-1e15,y:pos.y,w:pos.w+1e15,h:pos.h},ctrlpositions[ctrl.widgetid])){
							minx = minx < ctrlpositions[ctrl.widgetid].x+ctrlpositions[ctrl.widgetid].w?ctrlpositions[ctrl.widgetid].x+ctrlpositions[ctrl.widgetid].w:minx;
						}
					}else
						break;
				}		
				return minx;
			}

			for(var iChild=0;iChild<this.childs.length;iChild++){
				var child = this.childs[iChild];
				if(child.visible){
					ctrls.push(child);
					ctrlsh.push(child);
				}
			}
			ctrls.sort(function(a,b){
				var r = a.y - b.y;
				if(r==0)
					r= a.x - b.x
				return r;
			});

			ctrlsh.sort(function(a,b){
				return a.x - b.x;
			});

			for(i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				ctrlpositions[ctrl.widgetid] = {ctrl:ctrl,x:(ctrl.paddingLeft || 0)+(ctrl.x || 0),y:ctrl.y || 0,index:i,w:(ctrl.paddingRight || 0) + (ctrl.width!=undefined?ctrl.width:ctrl.getDefaultWidth()),h:ctrl.height!=undefined?ctrl.height:ctrl.getDefaultHeight()};
			}
			// side left
			for(var i=0;i<ctrlsh.length;i++){
				var ctrl = ctrlsh[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideLeft && !ctrl.sideRight){
					pos.x = minLeft(pos) ;
				}
			
			}
			for(var i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.fillWidth ){
					if (ctrl.minWidth)
						pos.w = ctrl.minWidth + (ctrl.paddingRight || 0)
					else
						pos.w = (ctrl.paddingRight || 0) ;
				}
			}
				
			for(i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var deltaW;
				deltaW=0;
				var pos = ctrlpositions[ctrl.widgetid];
				if(ctrl.canGrowHorizontally || ctrl.canShrinkHorizontally){
					var w = ctrl.width;
					ctrl.width = undefined;
					var h = ctrl.height;
					ctrl.height= pos.h;
					deltaW = ctrl.getDefaultWidth()-w;
					ctrl.width = w;
					ctrl.height = h;
					if(ctrl.fillWidth || !ctrl.canGrowHorizontally && deltaW > 0)
						deltaW=0;
					if(ctrl.fillWidth || !ctrl.canShrinkHorizontally&& deltaW < 0)
						deltaW=0;
	
				}
				if(ctrl.sideRight)
					pos.x -=deltaW;
				pos.w += deltaW;
				if(deltaW){
					jQuery(ctrls).each(function(idx,rightctrl){
						if(!rightctrl.sideRight && rightctrl.x > ctrl.x && OverlapNoColindant({x:rightctrl.x,y:rightctrl.y,w:rightctrl.width,h:rightctrl.height},{x:ctrl.x,y:ctrl.y,w:1e15,h:ctrl.height})){
							ctrlpositions[rightctrl.widgetid].x+=deltaW;
						}
					});
				}
			}

			var maxX = 0;
			for (idx=0;idx<ctrls.length;idx++){
				var ctrl = ctrls[idx];
				var pos = ctrlpositions[ctrl.widgetid];
				maxX = Math.max(maxX,pos.x + pos.w);
			}		
			return maxX;

		},
		getDefaultHeight:function(){
			var self = this;

			var ctrlpositions = {}
			var ctrls=[];
			var ctrlsv=[];
			var top;
			
			var child;
			var top=this.pt;
			var minTop = function (pos){
				var miny = top;
				for (var i = 0;i<ctrlsv.length;i++){
					var ctrl = ctrlsv[i]
					if(pos.ctrl != ctrl){
						if (OverlapNoColindant({x:pos.x,y:pos.y-1e15,w:pos.w,h:pos.h+1e15},ctrlpositions[ctrl.widgetid])){
							miny = miny < ctrlpositions[ctrl.widgetid].y+ctrlpositions[ctrl.widgetid].h?ctrlpositions[ctrl.widgetid].y+ctrlpositions[ctrl.widgetid].h:miny;
						}
					}else
						break;
				}		
				return miny;
			}

			for(var iChild=0;iChild<this.childs.length;iChild++){
				var child = this.childs[iChild];
				if(child.visible){
					ctrls.push(child);
					ctrlsv.push(child);
				}
			}
			ctrls.sort(function(a,b){
				var r = a.y - b.y;
				if(r==0)
					r= a.x - b.x
				return r;
			});


			ctrlsv.sort(function(a,b){
				return a.y - b.y;
			});

			for(i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				ctrlpositions[ctrl.widgetid] = {ctrl:ctrl,x:ctrl.x || 0,y:(ctrl.y || 0)+(ctrl.paddingTop || 0) ,index:i,w:ctrl.width!=undefined?ctrl.width:ctrl.getDefaultWidth(),h:(ctrl.paddingBottom || 0)+(ctrl.height!=undefined?ctrl.height:ctrl.getDefaultHeight())};
			}
				
			// side top
			for(var i=0;i<ctrlsv.length;i++){
				var ctrl = ctrlsv[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.sideTop && !ctrl.sideBottom){
					pos.y = minTop(pos) ;
				}
			
			}
			for(var i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var pos = ctrlpositions[ctrl.widgetid];
				if (ctrl.fillHeight ){
					if(ctrl.minHeight){
						pos.h = ctrl.minHeight + (ctrl.paddingBottom || 0);
					}else
						pos.h = 0;
				}
			}
			
			for(i=0;i<ctrls.length;i++){
				var ctrl = ctrls[i];
				var deltaH;
				deltaH=0;
				var pos = ctrlpositions[ctrl.widgetid];
				if(ctrl.canGrowVertically || ctrl.canShrinkVertically){
					var h = ctrl.height;
					ctrl.height=undefined;
					var w = ctrl.width;
					ctrl.width = pos.w
					deltaH = ctrl.getDefaultHeight()-h;
					ctrl.height = h;
					ctrl.width = w;
					if(ctrl.fillHeight || !ctrl.canGrowVertically && deltaH > 0)
						deltaH=0;
					if(ctrl.fillHeight || !ctrl.canShrinkVertically && deltaH < 0)
						deltaH=0;
					
				}
				if(ctrl.sideBottom)
					pos.y -=deltaH;
			
				pos.h += deltaH;		
				if(deltaH){
					jQuery(ctrls).each(function(idx,downctrl){
						if(!downctrl.sideBottom && downctrl.y > ctrl.y && OverlapNoColindant({x:downctrl.x,y:downctrl.y,w:downctrl.width,h:downctrl.height},{x:ctrl.x,y:ctrl.y,w:ctrl.width,h:1e15})){
							if(deltaH<0){
								var top = minTop(ctrlpositions[downctrl.widgetid]);
								if(ctrlpositions[downctrl.widgetid].y+deltaH<top)
									deltaH = Math.max(deltaH,(ctrlpositions[downctrl.widgetid].y+deltaH)-top);
								ctrlpositions[downctrl.widgetid].y+=deltaH;
							}else
								ctrlpositions[downctrl.widgetid].y+=deltaH;
						}
					});
				}
			}
			var maxY = 0;
			for (idx=0;idx<ctrls.length;idx++){
				var ctrl = ctrls[idx];
				var pos = ctrlpositions[ctrl.widgetid];
				maxY = Math.max(maxY,pos.y + pos.h);
			}		
			return maxY;
		}
	};
})(__icc__);


/*jslint evil:true */
/*global jQuery unescape window escape __icc__ dhtmlXWindows
*/

/* ********************************************************************
 *	container                                                         *
 *	                                                                  *
 **********************************************************************/
 
(function(icc){
	var  container;
	container = function(args,environment,uiclass){
		var child;
		
		this.pl=this.pt=this.pr=this.pb = 0;						// Padding left , top , right y bottom respectivamente.
		this.hs=this.vs = 0;										// Espaciado horizontal y vertical.
		
		 container.SUPERconstructor.call(this, args,environment,uiclass?uiclass:'panel-base');
																	// Recorre sus hijos y si tiene nombre lo copia sobre si mismo
																	// para facilitar la sintaxis tipo  
																	// this.btnAceptar.enabled = true;
		if (this.childs === undefined){
			this.childs = [];
		}
		
		for (var k in this.childs){
			child = this.childs[k];
			if (child.name !== undefined){
				this[child.name]=child;
			}
		}
		if(!environment || (environment && !environment.designer)){
			if(this.fillWidth == undefined)
				this.fillWidth = this.designer_fillWidth;
			if(this.fillHeight == undefined)
				this.fillHeight = this.designer_fillHeight;
			//if(this.fillWidth || this.fillHeight)
			//	alert(this.fillWidth +" "+ this.fillHeight);
		}
	};
	icc.utils.inherit(container,icc.ui.widget);
	container.prototype.getClient = function(){
		return this.getWnd();
	};
	// este metodo se llama desde un control . hoy un label para actualizar el layout cuando cambie su contenido
	// el unico layout en que es util llamarlo es el escalable
	container.prototype.updateLayout = function(){
		var self = this;
		if (self._layoutData == icc.ui.layouts.scalable){
			if (this.updateLayoutTimeout){
				clearTimeout(this.updateLayoutTimeout);
				
			}
			if(this.parent && (this.canGrowVertically || this.canGrowHorizontally || this.canShrinkVertically || this.canShrinkHorizontally || this.height==undefined || this.width==undefined)){
				this._x = undefined;this._y = undefined;this._w = undefined;this._h = undefined;
				this.parent.updateLayout();
			}else{
				this.updateLayoutTimeout = setTimeout(function(){
					self.updateLayoutTimeout=undefined;
					self.layout();	
				},40)	
			}
			
		}
	}
	
	container.prototype.__sortChildsByCordenates = function() {
		var sorted = [];
		$.each(this.childs, function(_, child) {
			sorted.push(child);
		});
		sorted.sort(function(a, b) {
			var aX = a && a.x || 0;
			var bX = b && b.x || 0;
			var aY = a && a.y || 0;
			var bY = b && b.y || 0;
			return aY === bY? (aX - bX) : (aY - bY);
		});
		return sorted;
	};

	container.prototype.create = function(params){						// Este metodo asume que el elemento del DOM ya fue creado
		var self = this;

		if(this.layoutMode !== undefined)							// Obtiene el layout a utilizar o pone por defecto el vertical.
		{
			this._layoutData = icc.ui.layouts[this.layoutMode];
			
		}
		if(!this._layoutData){
			this._layoutData = icc.ui.layouts.vertical;
			
			if (icc.ui.getApplication() && icc.ui.getApplication().getSettings().appVersion >= 2){
				this._layoutData = icc.ui.layouts.scalable;
			}
		}
		
		this._layoutData.init.call(this);			
		var wnd = this.getClient();									// Recorre los childs llamandoles al metodo create para que creen su objeto DOM
		if(this.id !== undefined){
			this.getWnd().setAttribute("id",this.id);
		}
		
		var c,child;														// y los agrega.
		var sorted = this.__sortChildsByCordenates();
		for (var k in sorted){
			child = sorted[k];
			child.parent=this;
			c=child.getWnd();
			if(!c){
				child.create();
				c = child.getWnd();
			}
			c.style.position = "absolute";
			wnd.appendChild(c);
		}

//	    setTimeout(function(){
//			self.fireEvent("onCreate",params);
//	    },10);			
		container.SUPERclass.create.call(this,params);
	    setTimeout(function(){
			self.fireEvent("onCreate",params);
	    },10);			

	};
	container.prototype.position = function(x,y,w,h){				// Cuando un contenedor es reposicionado llama al layout para recalcular automaticamente.
		if(	this._w !== w ||	this._h !== h){
			container.SUPERclass.position.call(this,x,y,w,h);
			this.layout();
		}else{
			container.SUPERclass.position.call(this,x,y,w,h);
		}
	};
	// Get maximum child width
	container.prototype.maxChildWidth = function () {				// Calcula el tamaÃ±o del child mas grande para ser usado por UniformWidth
		var child;
		var t,m;
		m=0;
		for(var i=0;i<this.childs.length;i++){
			child=this.childs[i];
			if(child.visible){
				if(child.width){
					t=child.width;
				}else{
					t=child.getDefaultWidth();
				}
				if(m<t){
					m=t;
				}
			}
		}
		return m;
	};

	// Get maximum child height
	container.prototype.maxChildHeight = function(){				// Calcula el tamaÃ±o del child mas grande para ser usado por Uniformheight
		var child;
		var t,m;
		m=0;
		for(var i=0;i<this.childs.length;i++){
			child = this.childs[i];
			if(child.visible){
				if(child.height){
					t=child.height;
				}else {
					t=child.getDefaultHeight();
				}
				if(m<t){
					m=t;
				}
				
			}
		}
		return m;
	};

	container.prototype.layout = function (){
		this._layoutData.layout.call(this);
	};
	container.prototype.hasChild = function (child){
		for(var i=0;i<this.childs.length;i++){
			if(this.childs[i]===child){
				return true;
			}
		}
		return false;
	};
	container.prototype.eachCtrl = function (fn){
		var ctrlcall = function(ctrl){
			var r
			if(ctrl.childs){
				for(k in ctrl.childs){
					r = ctrlcall(ctrl.childs[k])
					if(r == false)
						return r;
				}
			}
			return fn(ctrl)
		}
		return ctrlcall(this)
	}					
	
	container.prototype.replaceChild = function ( old,newchild){
		for(var idx = 0;idx<this.childs.length;idx++){
			if(this.childs[idx]===old){
				old.parent=null;
				this.childs[idx]=newchild;
				newchild.parent = this;
				this.getClient().removeChild(old.getWnd());
				this.getClient().appendChild(newchild.getWnd());
				jQuery(newchild.getWnd()).css({
					position:'absolute'
				});
				break;
			}
		}
	};
	container.prototype.addChild = function (newChild,zIndex){
		newChild.parent=this;
		if (zIndex !== undefined)
		{
			this.childs.splice(zIndex,0,newChild);
			newChild.getWnd().style.zIndex = zIndex;
		}else{
			this.childs.push(newChild);
			newChild.getWnd().style.zIndex = this.childs.length;
		}
		newChild.getWnd().style.position = "absolute";
		this.getClient().appendChild(newChild.getWnd());
	};
	container.prototype.onInitialize= function(cb){
		this.onCreate(cb);
	};
	container.prototype.rmvChild = function (child,destroy){
		child.parent=null;
		for (var iChild=0;iChild < this.childs.length; iChild++){
			
			if(this.childs[iChild]===child){
				this.childs.splice(iChild,1);
			}
		}
		this.getClient().removeChild(child.getWnd());
		if(destroy === true || destroy === undefined){
			child.destroy();
		}
	};
	container.prototype.rmvAll =function(destroy){
		for (var iChild=0;iChild < this.childs.length; iChild++){
			this.getClient().removeChild(this.childs[iChild].getWnd());
			if(destroy === true || destroy === undefined){
				this.childs[iChild].destroy();
			}

		}
		this.childs=[];
	
	};
	
	container.prototype.getDefaultWidth = function(){
		if(this.overflow == "auto" || this.overflowx=="auto" && this._x !==undefined){
			return this._x
		}else
			return this._layoutData.getDefaultWidth.call(this);
	};
	container.prototype.getDefaultHeight = function(){
		if(this.overflow == "auto" || this.overflowy=="auto" && this._y !==undefined){
			return this._y
		}else
			return this._layoutData.getDefaultHeight.call(this);
	};
	container.prototype.destroy = function(){
		container.SUPERclass.destroy.call(this);
		for (var iChild=0;iChild < this.childs.length; iChild++){
			this.childs[iChild].destroy();
		}
		this.fireEvent("onDestroy");

	};
	container.prototype.onDestroy = function (cb){
		this.addListener("onDestroy",cb);
	};
	container.prototype.displayMessage = function(err,parentPropagation,sender){
		// recorre sus childs ejecutandoles la funcion y si alguno 
		// devuelve un valor rompe el bucle
		var r;
		for (var iChild=0;iChild < this.childs.length; iChild++){
			if(sender != this.childs[iChild]){
				r=this.childs[iChild].displayMessage(err,false);
				if (r !== undefined && r !== false){
					return r;
				}
			}
		}
		return container.SUPERclass.displayMessage.call(this,err,parentPropagation);
	};
	container.prototype.closePopup = function(){
		var self = this;
		if(self.popupDiv){
			if(self.blocker)
				document.body.removeChild(self.blocker);
			document.body.removeChild(self.popupDiv);
			self.popupDiv=undefined;
		}
	}
	
	container.prototype.showPopup = function(options){
		options = options || {}
		options.modal = options.modal !== undefined?options.modal:true
		var self = this;
		if(!self.popupDiv){
			this.setVisible(true);
			var ww=options.width!==undefined?this.width:this.getDefaultWidth();
			var wh=options.height!==undefined?this.height:this.getDefaultHeight();
			var absx,absy;
			absx = options.x!==undefined?options.x:icc.utils.getMousePosition().x
			absy = options.y!==undefined?options.y:icc.utils.getMousePosition().y
			var div;
			div = this.getWnd();
			self.popupDiv = div;
			this.position(0,0,ww,wh);
			var wndData = icc.utils.windowSize();
			if(absx+ww > wndData.width)
				absx-=ww-20
				
			if(absy+wh > wndData.height)
				absy-=wh-20
			if(options.modal){
				self.blocker = icc.utils.makeElement("div")
				
				jQuery(self.blocker).css({
					position:'absolute',
					left:0+"px",
					top:0+"px",
					width:wndData.width+"px",
					height:wndData.height+"px",
					zIndex:9999,
					background:'white',
					opacity:0
				});
				document.body.appendChild(self.blocker);
				jQuery(self.blocker).mousedown(function(){
					self.closePopup();
					return true;
				})
				
			}
			
			jQuery(div).css({
				position:'absolute',
				left:absx+"px",
				top:absy+"px",
				zIndex:10000
		
			});
			
			document.body.appendChild(div);
			
			
		}
		
		
	}
	// se prodria querer capturar el onClose de un form cuando se corre modal
	// pero si no es modal no existe el metodo por eso se pone este metodo vacio aqui
	container.prototype.onClose =function(fn){
		this.addListener("onClose",fn);
	}
	icc.ui.container = container;
	

})(__icc__);
(function(icc){
	var  panel;
	var panel_slices  = {
	
	};
	icc.ui.themes.base.panel ={
		backColor:'transparent',
		foreColor:'black',
		borderColor:'#BFBFBF',	
		borderWidth:0,
		overflow:'hidden',
		borderType:'solid',
		opacity:100,
		nc_left:0,
		nc_right:0,
		nc_top:0,
		nc_bottom:0,
		styles:{
			"application/toolbar":{
				borderWidth:1,
				round:3,
				gradient:true,
				reverseGradient:true,
				foreColor:'white',
				backColor:'lightGray',
				pl:2,
				pr:2,
				pt:2,
				pb:2
			}
		}
	};	
	panel = function(args,environment,uiclass){
		panel.SUPERconstructor.call(this, args,environment,uiclass?uiclass:'panel');
		
		if(this.padding !== undefined){
			this.pl = this.padding;
			this.pr = this.padding;
			this.pb = this.padding;
			this.pt = this.padding;
		}
	};
	icc.utils.inherit(panel,icc.ui.container);
	panel.prototype.createSlicePanel = function(sliceData){
		
		var tb = icc.utils.makeElement("table",false);
		
		this.tb = tb;
		tb.setAttribute("border",0);
		tb.setAttribute("cellPadding",0);
		tb.setAttribute("cellSpacing",0);
		tb.setAttribute("width","100%");
		tb.setAttribute("height","100%");
		tb.style.zIndex=-1;
		var winbody = icc.utils.makeElement("tbody",false,tb);
		var tr,td,dv;
		//fila de arriba
		tr = icc.utils.makeElement("tr",false,winbody);
		tr.setAttribute("vAlign","top");
	//esquina superior izquierdo
		td = icc.utils.makeElement("td",false,tr);
	
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.width=sliceData.slices.r1.w +"px";
		dv.style.height=sliceData.slices.r1.h +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r1"+")";
	//borde superior
		td = icc.utils.makeElement("td",false,tr);
		td.style.width = "100%";	
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.height=sliceData.slices.r2.h +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r2"+")";
	//esquina superiorderecho
		td = icc.utils.makeElement("td",false,tr);
		dv = icc.utils.makeElement("div",false,td);
	
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.width=sliceData.slices.r3.w +"px";
		dv.style.height=sliceData.slices.r3.h +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r3"+")";

	
	//fila central
		tr = icc.utils.makeElement("tr",false,winbody);
		tr.setAttribute("vAlign","top");
	
	//borde  izquierdo
		td = icc.utils.makeElement("td",false,tr);
		td.style.height= "100%";	
	
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.width=sliceData.slices.r4.w +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r4"+")";
		dv.style.height="100%";
	
		//area contenido
		td = icc.utils.makeElement("td",false,tr);
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		td.style.height= "100%";	

		dv.style.background="url(render/slget/"+this.slice+"/r5"+")";
		dv.style.height="100%";
		dv.style.width="100%";

		
		//borde derecho
		td = icc.utils.makeElement("td",false,tr);

		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		td.style.height= "100%";	
		
		dv.style.overflow="hidden";
		dv.style.width=sliceData.slices.r6.w +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r6"+")";
		dv.style.height="100%";
	
	
		//fila inferior
		tr = icc.utils.makeElement("tr",false,winbody);
		tr.setAttribute("vAlign","top");
		
		//borde  inferior izquierdo
		td = icc.utils.makeElement("td",false,tr);
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.width=sliceData.slices.r7.w +"px";
		dv.style.height=sliceData.slices.r7.h +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r7"+")";
		
		//borde inferior
		td = icc.utils.makeElement("td",false,tr);
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.height=sliceData.slices.r8.h +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r8"+")";
		
		//borde inferior derecho
		td = icc.utils.makeElement("td",false,tr);
		
		dv = icc.utils.makeElement("div",false,td);
		dv.innerHTML="&nbsp;";
		dv.style.overflow="hidden";
		dv.style.width=sliceData.slices.r9.w +"px";
		dv.style.height=sliceData.slices.r9.h +"px";
		dv.style.background="url(render/slget/"+this.slice+"/r9"+")";
		this.sliceTable = tb;
		
		if (sliceData.slices.r1){
			this.nc_left+=sliceData.client.x - sliceData.slices.r1.x;
		
		}
		if (sliceData.slices.r2){
			this.nc_top+=sliceData.client.y - sliceData.slices.r2.y;
		}
		if (sliceData.slices.r3){
			this.nc_right+=(sliceData.slices.r3.x+sliceData.slices.r3.w)-(sliceData.client.x+sliceData.client.w);
		}
		if (sliceData.slices.r7){
			this.nc_bottom+=(sliceData.slices.r7.y+sliceData.slices.r7.h)-(sliceData.client.y+sliceData.client.h) ;
		}
		this.pr += (this.nc_right+this.nc_left);
		this.pb += (this.nc_bottom+this.nc_top);
		
		return tb;
	};
	panel.prototype.getClient = function(params){
		if(this.client){
			return this.client;
		}else{
			return this.wnd;
		}
	};
	
	panel.prototype.__makeWnd = function() {
		this.wnd = icc.utils.makeElement("div");
		this.wnd.className = this.className!=undefined?this.className:"twPanel";
	};

	panel.prototype.create = function(params){
		var self = this;
		if(this.marginLeft !== undefined)
			this.pl = this.marginLeft;
		if(this.marginTop !== undefined)
			this.pt = this.marginTop;
		if(this.marginRight !== undefined)
			this.pr = this.marginRight;
		if(this.marginBottom !== undefined)
			this.pb = this.marginBottom;
		
		this.__makeWnd();
		
		this.client=icc.utils.makeElement("div",false,this.wnd);
		this.client.style.position = "absolute";
		
		this.client.style.visibility = "hidden";
		jQuery(this.client).css({
			position:'absolute',
			top:'0px',
			left:'0px'
		});
		panel.SUPERclass.create.call(this,params);
		if(!rhino){
			/*
				Funcion que convierte el valor "visible" a "auto" en la propiedad "overflow"
				Esto es utilizado para que de forma automatica se visualicen las barras de "scroll" si es necesario.
				Cuando tenemos un slice (imagen de fondo) el mismo no tiene barras de scroll con el plugin "GoldenLayout".

				Ref: http://redmine.inconcert/issues/8464
			*/
			var convert_overflow_to_auto = function() {
				let overflow = self.overflow;
				if (typeof self.overflow === "string" && self.overflow.toLowerCase() === "visible") {
					overflow = "auto";
				}
				return overflow;
			};

			if (!this.slice ){
				this.setStyle(this.wnd);
				if(this.background){
					var imagename;
					if(this._appName && this.background.substring(0,1)!=='!'){
						imagename = '@'+this._appName+'@'+this.background;
					}else{
						imagename = this.background;
					}
					this.wnd.style.background=icc.ui.getApplication().backgroundImage(imagename,this.backgroundRepeat,this.backColor,this.backgroundPosition)
					
				}
			}else{
				if(!panel_slices[this.slice]){
					jQuery.ajax({
						async: true,
						dataType:"json",
						url: "render/slinfo/"+this.slice,
						success: function(ajaxResponse){
							panel_slices[self.slice]=ajaxResponse;
							
							self.createSlicePanel(ajaxResponse);
							
							self.wnd.appendChild(self.sliceTable);
							self.wnd.style.overflow = "hidden";
							self.client.style.overflow = convert_overflow_to_auto();

							if(self.lastpos){
							
								self._w = undefined;
								self._h = undefined;
								self.position(self.lastpos[0],self.lastpos[1],self.lastpos[2],self.lastpos[3]);
							}
							self.layout();
				
						},
						error:function(ajaxError){
							// creamos como si no estuviera y listo
							self.slice = undefined;
							self.setStyle(self.wnd);
							if(self.lastpos){
								self._w = undefined;
								self._h = undefined;
								self.position(self.lastpos[0],self.lastpos[1],self.lastpos[2],self.lastpos[3]);
							}
							try{ // IE aunque siendo asincrona no deberia tener 0,0,0,0 el w,h
								self.layout();
							}catch(e){

							}
						}
					
					});
				}else{
					setTimeout(function(){
						self.createSlicePanel(panel_slices[self.slice]);
						self.wnd.style.overflow = "hidden";
						self.client.style.overflow = convert_overflow_to_auto();
						self.wnd.appendChild(self.sliceTable);
						if(self.lastpos){
							self._w = undefined;
							self._h = undefined;
							self.position(self.lastpos[0],self.lastpos[1],self.lastpos[2],self.lastpos[3]);
						}
						try{ // IE esta explotaba si el slice ya estaba cargado en ie ahora con el setTimeout es asincrona 
							 // por las dudas try catcheamos
							self.layout();

						}catch(e){

						}

					},1);
				}
			}
		}
		this.hwnd = this.wnd;
		return this.wnd;
	};
	
	panel.prototype.setStyle=function(wnd)
	{
		this.borderType = "solid";
		if(!this.slice){// todo normal color con js o fondo renderizado
			wnd.style.color = this.foreColor;
			if((this.gradient!==undefined && this.gradient!==false)|| (this.round !== undefined && this.round>0)){
				if(this.opacity !==undefined){
					this.background_opacity = this.opacity;
					this.opacity = undefined;
			
				}
				if(this.dimmed == undefined && !icc.utils.browser.is_ie)
					jQuery(wnd).css({opacity:1});
					
				this.rendBackground = {
					backcolor:this.foreColor!=='transparent'?this.foreColor:'white',
					color:this.backColor!=='transparent'?this.backColor:'white',
					gradient:this.gradient,
					gradientheight:this.gradientHeight,
					reversegradient:this.reverseGradient,
					round:this.round,
					borderwidth:this.borderWidth,
					bordercolor:this.borderColor,
					opacity:''+(this.background_opacity!==undefined?this.background_opacity:100)+"%"
				};

			}else{

				this.renderBackground = undefined;
				if(!this.background){

					wnd.style.background="";
					wnd.style.backgroundColor = this.backColor;
				}
//				try{//IE
				wnd.style.border="none";
				
				if(this.borderTop == true){
					wnd.style.borderTop = this.borderWidth + "px "+this.borderType + " "+this.borderColor;
				}
				if (this.borderBottom == true){
					wnd.style.borderBottom = this.borderWidth + "px "+this.borderType + " "+this.borderColor;
				}
				if (this.borderLeft == true){
					
					wnd.style.borderLeft = this.borderWidth + "px "+this.borderType + " "+this.borderColor;

				}
				if (this.borderRight == true){
					
					wnd.style.borderRight = this.borderWidth + "px "+this.borderType + " "+this.borderColor;
					//alert(this.borderWidth + "px "+this.borderType + " "+this.borderColor)
				}
				if(!this.borderTop && !this.borderBottom && !this.borderRight && !this.borderLeft)
					wnd.style.border = this.borderWidth + "px "+this.borderType + " "+this.borderColor;
			
				
				
			//	}catch(e){};
			}
		}
		try{
			if(this.overflow)
				wnd.style.overflow = this.overflow;
			if (this.overflowx){
				wnd.style['overflowX'] = this.overflowx;
			}
			if (this.overflowy){
				wnd.style['overflowY'] = this.overflowy;
			}
		}catch(e){}
		//	wnd.className="ui-corner-all"
	};	
	panel.prototype.position = function(x,y,w,h){
		this.lastpos = [x,y,w,h];
	//	if(this.slice && !this.sliceTable)
	//		return;
		
	    if (this.rendBackground){
			if(this.hwnd === this.wnd){
				this.rendBackground.width = w;
				this.rendBackground.height=h;
				this.wnd.style.background = 'url(render/panel/'+Base64.encode(JSON.stringify(this.rendBackground))+') no-repeat';
			}
			panel.SUPERclass.position.call(this,x,y,w,h);
	    }else if(this.sliceTable){
			panel.SUPERclass.position.call(this,x,y,w,h);
		}else{
			panel.SUPERclass.position.call(this,x,y,w-(this.borderWidth*2),h-(this.borderWidth*2));
		}
		
		this.client.style.visibility = "visible";
		this.client.style.left = this.nc_left+"px";
		this.client.style.top = this.nc_top+"px";
		try{	// IE a veces en el inici viene _h = 0 y negativos disparan excepciones en IE
			this.client.style.height = this._h-(this.nc_top+this.nc_bottom)+"px";
			
			this.client.style.width = this._w-(this.nc_right+this.nc_left)+"px";
		}catch(e){}
		

	};
	panel.prototype.getDefaultWidth=function(){
	    if(this.rendBackground){
			return panel.SUPERclass.getDefaultWidth.call(this)+this.nc_left+this.nc_right;
	    }else{
			var bsize = 0;
			if (this.borderLeft )
				bsize+= this.borderWidth;
			if (this.borderRight )
				bsize+= this.borderWidth;
			if (!this.borderLeft && !this.borderRight)
				bsize = this.borderWidth * 2;		
				
			return panel.SUPERclass.getDefaultWidth.call(this)+bsize+this.nc_left+this.nc_right;
		}
	};
	panel.prototype.getDefaultHeight=function(){
	    if(this.rendBackground){
			return panel.SUPERclass.getDefaultHeight.call(this)+this.nc_top+this.nc_bottom;
	    }else{
		var bsize = 0;
			if (this.borderTop )
				bsize+= this.borderWidth;
			if (this.borderBottom )
				bsize+= this.borderWidth;
			
			if (!this.borderBottom && !this.borderTop)
				bsize = this.borderWidth * 2;
			
		
			return panel.SUPERclass.getDefaultHeight.call(this)+bsize+this.nc_top+this.nc_bottom;
		}
	};
	//onReady solo es disparado por un form durante el buildform de icc.ui.application, pero como un form no es otra cosa que un 
	// panel el api reside aqui.
	panel.prototype.onReady=function(fn){
		return this.addListener("onReady",fn)
	};
	
	icc.ui.themes.base.iframe ={
		borderColor:'gray',
		borderWidth:0,
		borderStyle:'solid',
		nc_left:0,
		nc_right:0,
		nc_top:0,
		nc_bottom:0
	};	
	
	
	
	var iframe;
	iframe = function(args,environment,uiclass){
		iframe.SUPERconstructor.call(this, args,environment,uiclass?uiclass:'iframe');
		
	};
	icc.utils.inherit(iframe,icc.ui.container);
	iframe.prototype.create = function (params){
		this.wnd = icc.utils.makeElement("div");
		iframe.SUPERclass.create.call(this,params);
			
		this.ifr = icc.utils.makeElement("iframe",false,this.wnd);
		this.ifr.setAttribute("frameBorder",0);
		
		if(this.src){
			this.ifr.setAttribute("src",this.src);
		}
		return this.wnd
	};
	iframe.prototype.setSrc = function(src){
		this.src = src;
		if(this.wnd){
			this.wnd.removeChild(this.ifr);
			this.ifr= icc.utils.makeElement("iframe",false,this.wnd);
			this.ifr.setAttribute("frameBorder",0);

			if(this.src){
				this.ifr.setAttribute("src",this.src);
				
			}
				
			jQuery(this.ifr).css({
				border:'none',
				position:'absolute',
				width:this._w-1+'px',
				height:this._h+'px',
				top:0+'px',
				left:0+'px'
			});
		}
	}
	iframe.prototype.position = function(x,y,w,h){
		iframe.SUPERclass.position.call(this,x,y,w,h);
		try{
		jQuery(this.ifr).css({
			
			position:'absolute',
			width:this._w-2+'px',
			height:this._h+'px',
			top:0+'px',
			left:0+'px'
		});
		}catch(e){} // IE
	}
	
	icc.ui.iframe = iframe;
	icc.ui.panel = panel;
	icc.ui.tabitem = panel;
})(__icc__);
(function(icc){
	var  dialog;
	var dhxWins;
	var wins={}
	var modalCount=0;
	vpwidth=0;
	vpheight=0;
	var wz;
	var recalcViewportSize = function(){
		var w,h
		w=0;
		h=0;
		//var wz = new icc.utils.windowSize();		
		vpwidth=wz.width;
		vpheight=wz.height;
		var dz = icc.utils.documentSize();
		vpheight=vpheight>dz.height?vpheight:dz.height;
		vpwidth=vpwidth>dz.width?vpwidth:dz.width;	
		
		dhxWins.forEachWindow(function (win){
			var whs = win.getDimension();
			var wpos = win.getPosition();
			vpwidth=vpwidth>wpos[0]+whs[0]?vpwidth:wpos[0]+whs[0];
			vpheight=vpheight>wpos[1]+whs[1]?vpheight:wpos[1]+whs[1];
			
		});
		vpheight=vpheight>wz.height?vpheight:wz.height;
		vpwidth=vpwidth>wz.width?vpwidth:wz.width;
		if(vpwidth==wz.width && vpheight>wz.height)
			vpwidth-=18;
	//	alert(wz.width);
	//	alert(wz.width + "   " +vpwidth);
	}
		
	
	icc.ui.themes.base.dialog ={
	};	
	dialog = function(args,environment,uiclass){
		this.isDialog=true;
		dialog.SUPERconstructor.call(this, args,environment,uiclass?uiclass:'dialog');
	};
	icc.utils.inherit(dialog,icc.ui.container);
	dialog.prototype.create = function(params){
		this.wnd = icc.utils.makeElement("div",true);
		var self = this;
		dialog.SUPERclass.create.call(this,params);
		this.width = this.width?this.width:this.getDefaultWidth();
		this.wnd.className = this.className!=undefined?this.className:"twDialog";

		this.height= this.height?this.height:this.getDefaultHeight();
		if (self.version >=2 || (self.childs[0] && self.childs[0].version>=2)){
			self.width=0;
			self.height=0;
			this.eachCtrl(function(ctrl){
				self.width = Math.max(self.width,(ctrl.x || 0) + (ctrl.width || ctrl.getDefaultWidth()))
				self.height = Math.max(self.height,(ctrl.y || 0) + (ctrl.height || ctrl.getDefaultHeight()))
			})
			self.width=self.width || 320
			self.height=self.height || 200
		}
		jQuery(this.wnd).css({
			width:(this.width+8)+"px",
			height:(this.height+40)+"px",
			overflow:'hidden'
			
		});
		return this.wnd;
	};
	
	var viewPortInitialized = false;
	var initViewPort = function() {
		var wz;
		if (!viewPortInitialized) {
			dhxWins= new dhtmlXWindows();
			dhxWins.setImagePath("/weblibs/lib/dhtmlx/windows/imgs/");
			dhxWins.enableAutoViewport(false);
			recalcViewportSize();
			dhxWins.setViewport(0, 0, vpwidth,vpheight);
			dhxWins.setSkin("clear_silver");
			window.onresize = function(){
				wz = icc.utils.windowSize();
				recalcViewportSize();
				if(modalCount>0){
					
					//setTimeout(function(){
						dhxWins.setViewport(0, 0, vpwidth,vpheight);
						
					//},100);
				}
			};
		    dhxWins.attachEvent("onMoveFinish", function(win) {
				recalcViewportSize();
				dhxWins.setViewport(0, 0, vpwidth,vpheight);
			
				
			});
			viewPortInitialized = true;
		}
	};
	
	dialog.prototype.showModal = function(cb){
		var self=this;
		wz = icc.utils.windowSize();
	
		initViewPort();
		recalcViewportSize();
		dhxWins.setViewport(0, 0, vpwidth,vpheight);
		var x,y;
		modalCount++;
		x = wz.width/2-this.width/2;
		x+=wz.scrollX
		y = wz.height/2-this.height/2;
		y+=wz.scrollY;
		if (y< 10)
			y = 10;
			
		if(cb){
			self.onClose(cb)
		}
		
		dhxWins._makeActive = function(win) {
		
			for (var a in this.wins) {
				if (this.wins[a] == win) {
					var needEvent = false;
					if (this.wins[a].className != "dhtmlx_window_active") {

						needEvent = true; 
						this.wins[a].className = "dhtmlx_window_active";
					}
					
					this.wins[a].childNodes[1].src = this.wins[a].icons[0];
					if (needEvent == true) {
						if (win.checkEvent("onFocus")) {
							win.callEvent("onFocus",[win]);
						} else {
							this.callEvent("onFocus",[win]);
						}
					}
				} else {
					this.wins[a].className = "dhtmlx_window_inactive";
					this.wins[a].childNodes[1].src = this.wins[a].icons[1];
				}
			}
		}		
		this.dhwnd=dhxWins.createWindow("windows-"+(this.name!==undefined?this.name:(this.id!==undefined?this.id:this.widgetid)), x, y,this.width+8,this.height+36);
		this.dhwnd.id = this.name!==undefined?this.name:(this.id!==undefined?this.id:this.widgetid);
		
		this.dhwnd.setText(this.caption?this.caption:'');
		this.dhwnd.button("minmax1").hide();
		this.dhwnd.button("minmax2").hide();
		this.dhwnd.button("park").hide();

		this.wnd.style.position = "absolute";
		this.position(-2,0,this.width,this.height);
		
		this.dhwnd.denyResize();
		this.dhwnd._content.appendChild(this.wnd);
		this.dhwnd.attachEvent("onClose",function(){
			icc.console.log("dhtmlx window onClose")
			try{
				if(self.firedClose!=true){
					self.firedClose=true;
					var res = self.fireEvent("onClose",false);
				}
			}catch(e){
				
			}
			if(res===undefined || res===true){
				modalCount--;
				
			    self.destroy();
				if(!modalCount){
					dhxWins.setViewport(0, 0, 1,1);
				}else{
					recalcViewportSize();
					dhxWins.setViewport(0, 0, vpwidth,vpheight);
				}

			    return true;
			}
			return res;
		});
	
		this.dhwnd.setModal(true);
		recalcViewportSize();
		dhxWins.setViewport(0, 0, vpwidth,vpheight);
		this.dhwnd.style.zIndex = "10000";
	};
	dialog.prototype.onClose = function(cb){
		this.addListener("onClose",cb);
	};
	dialog.prototype.close = function(resvalue){
		var res;
		var self = this;
		if(!this.closed){
			if(self.firedClose!=true){
				res = this.fireEvent("onClose",resvalue);
				self.firedClose=true;
			}else
				res=true;
			if(res !=false){
			
				this.closed=true;
				this.disableEvents();
				this.dhwnd.close();
				this.enableEvents();
			
//				this.destroy();
			}
/*			modalCount--;
			if(!modalCount)
				dhxWins.setViewport(0, 0, 0,0);
*/			
		}
	};
	dialog.prototype.modeless=function(cb){
	};
	
	icc.ui.dialog = dialog;
	

	
})(__icc__);


/*jslint evil:true */
/*global jQuery document  __icc__ window
*/
/* ********************************************************************
 *	rootwindow                                                        *
 *	                                                                  *
 **********************************************************************/
/* Representa la ventana principal de la aplicacion cuando esta es
   exclusiva.
   El tamaño calculado para hacer el layout depende del tamaño
   de los elementos que la componen y del tamaño de la ventana
   del browser
 
 
*/
   
 
(function(icc){
	var  rootwindow;

	rootwindow = function(args,environment,uiclass){
		icc.ui._mainWindow = this;
		rootwindow.SUPERconstructor.call(this, args,environment,uiclass);
	};
	icc.utils.inherit(rootwindow,icc.ui.container);
	var prevWSize;
	rootwindow.prototype.create = function(){
		var self = this;
		this.wnd = icc.utils.makeElement("div",true);
		this.wnd.className = this.className!=undefined?this.className:"twRootwindow";

		this.wnd.style.position = "absolute";
		this.wnd.style.left = "0px";
		this.wnd.style.top = "0px";
		this.wnd.style.overflow="auto";
		rootwindow.SUPERclass.create.call(this);

		window.onresize = function(){
			setTimeout(function(){
				var wz = icc.utils.windowSize();

				var settings = icc.ui.getApplication().getSettings();
				if(settings.forceFullResize){
					self.autofit()
				}else
				if(settings.isMobile){
					if (!prevWSize || (prevWSize.width != wz.width && prevWSize.height!=wz.height))
						self.autofit();
				}else
					self.autofit();
				prevWSize=wz;
			},300);
		};
		return this.wnd;
	};
	/* Recalcula el layout usando como tamaño el mayor valor
		entre los elementos de la ventana y el de la ventana del browser */
		
	rootwindow.prototype.show = function(){
		var wnd = this.getWnd();
		var wz = icc.utils.windowSize();
		prevWSize=wz;
		var minx = this.getDefaultWidth();
		var miny = this.getDefaultHeight();
		
		this._w = wz.width>minx?wz.width:minx;
		this._h = wz.height>miny?wz.height:miny;
	//	if(this._h>wz.height && this._w==wz.width && window==window.top)
	//		this._w-=20;
			
		document.offsetHeight=wz.height;
		
		this.layout();
		document.body.appendChild(wnd);
			jQuery(wnd).css({
				height:this._h+"px",
				width:this._w+"px"
			});
		jQuery(wnd).css({
			width:wz.width+"px",
			height:wz.height+"px"
		});
	};
	rootwindow.prototype.autofit = function(){
		var wnd = this.getWnd();
		var wz = icc.utils.windowSize();
		var minx = this.getDefaultWidth();
		var miny = this.getDefaultHeight();

		this._w = wz.width>minx?wz.width:minx;
		this._h = wz.height>miny?wz.height:miny;
		var app = icc.ui.getApplication();
		if(app){
			var settings = app.getSettings();
			if(settings.minScreenHeight)
				this._h = this._h > settings.minScreenHeight?this._h:settings.minScreenHeight;
			if(settings.minScreenWidth)
				this._w = this._w > settings.minScreenWidth?this._w:settings.minScreenWidth;
		}
//		if(this._h>wz.height && window==window.top)
//			this._w-=17;
		jQuery(wnd).css({
			width:this._w+"px",
			height:this._h+"px"
		});
		jQuery(wnd).css({
			width:wz.width+"px",
			height:wz.height+"px"
		});
///		document.offsetWidth=this._w;
		this.layout();
	};

	rootwindow.prototype.hide = function(){
		document.body.removeChild(this.getWnd());
	};

	icc.ui.rootwindow = rootwindow;

})(__icc__);

