/* ********************************************************************
 *  chatctrl                                                          *
 *                                                                    *
 **********************************************************************/

/* global __icc__, $LAB, chatctrl, inConcert, iFrameEventListener, autosize, chatLocalStorage, Storage */

(function (icc) {

//*************************************	Auxiliar Functions

	var SHOW_EFFECTS = [
		{ value : 'slideup',		caption : 'Blind Up'		},
		{ value : 'slidedown',		caption : 'Blind Down'		},
		{ value : 'slideleft',		caption : 'Blind Left'		},
		{ value : 'slideright',		caption : 'Blind Right'		},
		{ value : 'clip',			caption : 'Clip'			},
		{ value : 'fade',			caption : 'Fade'			},
		{ value : 'fold',			caption : 'Fold'			},
		{ value : 'puff',			caption : 'Puff'			},
		{ value : 'scale',			caption : 'Scale'			}
	];

	var HIDE_EFFECTS = [
		{ value : 'slideup',		caption : 'Blind Up'		},
		{ value : 'slidedown',		caption : 'Blind Down'		},
		{ value : 'slideleft',		caption : 'Blind Left'		},
		{ value : 'slideright',		caption : 'Blind Right'		},
		{ value : 'clip',			caption : 'Clip'			},
		{ value : 'fade',			caption : 'Fade'			},
		{ value : 'fold',			caption : 'Fold'			},
		{ value : 'puff',			caption : 'Puff'			},
		{ value : 'scale',			caption : 'Scale'			}
	];
	
	function showEffect($control, effect, duration, callback) {
		callback = callback || function() {};
		if (!effect) {
			return $control.show({ duration : 0, complete : callback});
		}
		duration = duration || 200;
		var options = {};
		switch(effect) {
			case "slideup":
			case "slidedown":
			case "slideleft":
			case "slideright":
				options.direction = effect.replace("slide", "");
				effect = "slide";
				break;
		}
		$control.show(effect, options, duration, callback);
	}
	
	function hideEffect($control, effect, duration, callback) {
		callback = callback || function() {};
		if (!effect) {
			return $control.hide({ duration : 0, complete : callback});
		}
		duration = duration || 200;
		var options = {};
		switch(effect) {
			case "slideup":
			case "slidedown":
			case "slideleft":
			case "slideright":
				options.direction = effect.replace("slide", "");
				effect = "slide";
				break;
		}
		$control.hide(effect, options, duration, callback);
	}
	
	function setFont($control, properties) {
		if (!properties) {
			return;
		}
		$control.css({
			fontStyle		: properties.italic? "italic" : undefined,
			fontFamily		: properties.family,
			fontSize		: properties.size? (properties.size + "px") : undefined,
			fontWeight		: properties.weight
		});
	}
	
	function initCssRules() {
		$("#webchatStyleRules").remove();
		$("head").append("<style id='webchatStyleRules'></style>");
	}
	
	function addCssRule(scope, rule) {
		try {
			var styleTag = document.getElementById("webchatStyleRules");
			var sheet = styleTag.sheet ? styleTag.sheet : styleTag.styleSheet;
            if (sheet.insertRule) {   // all browsers, except IE before version 9
                sheet.insertRule (scope + " { " + rule + " }", 0);
            }
            else {  // Internet Explorer before version 9
                if (sheet.addRule) {
                    sheet.addRule (scope, rule, 0);
                }
            }
		}
		catch(e) {
			
		}
	}
	
	function maximizeAllParents($object) {
		function maximize($object) {
			if (!$object.length) {
				return;
			}
			$object.css({
				width	: "100%",
				height	: "100%"
			});
			maximize($object.parent());
		}
		
		var times = 10;
		var wait = 500;
		
		(function call() {
			if (!times) {
				return;
			}
			times--;
			maximize($object);
			window.setTimeout(call, wait);
		})();
	}
	
	//esto es totalmente a pedal y fuera del designer
	function _setPropertyInsideTable(label, value, disabled, containerLabels, disableButton) {
		try {
			var $control = $("#appExplorer");
			if (containerLabels) {
				$.each(containerLabels, function(_, containerLabel) {
					$control = $control.find("div").filter(function() {
						return $(this).text() === containerLabel;
					}).next();
				});
			}
			$control = $control.find("div").filter(function() {
				return $(this).text() === label;
			}).next();
			
			if (disableButton !== undefined) {
				$control
					.find("button")
					.prop("disabled", !!disableButton);
			}
			
			$control = $control.find("select, input").first();
			if (value !== undefined) {
				$control.val(value);
			}
			if (!not(disabled)) {
				$control.prop("disabled", disabled);
			}
		}
		catch(e) {
			
		}
	}
	
//*************************************	Chat Minimized Control
	var chatminimized = function (args, environment, uiclass) {
		chatminimized.SUPERconstructor.call(this, args, environment, uiclass ? uiclass : 'chatminimizedctrl');
		this.immovable = true;
		this.nameable = false;
		this.erasable = false;
	};
	icc.utils.inherit(chatminimized, icc.ui.widget);
	icc.ui.chatminimizedctrl = chatminimized;
	
	chatminimized.prototype.getProperties = function (formDoc) {
		var res = [];
		res.push(
			//Size
			{ caption:	'Size',						type: 'group',	brief_fn:function(data){ return ""; }			},
				{ caption:	'',						type: 'option',	name: 'windowSize', 
					values : [
						{ value : 'FLAT_SMALL',			caption : 'Flat Small'			},
						{ value : 'FLAT_MEDIUM',		caption : 'Flat Medium'			},
						{ value : 'FLAT_BIG',			caption : 'Flat Big'			},
						{ value : 'SQUARE_SMALL',		caption : 'Square Small'		},
						{ value : 'SQUARE_MEDIUM',		caption : 'Square Medium'		},
						{ value : 'SQUARE_BIG',			caption : 'Square Big'			},
						{ value : 'CUSTOM',				caption : 'Custom'				}
					]	
				},
				{ caption:	'Values',				type: 'group',	brief_fn:function(data){ return ""; }			},
					{ caption:	'Width',				type: 'geometry', name: 'width'								},
					{ caption:	'Height',				type: 'geometry', name: 'height'							},
				{ type:	'endgroup' },
			{ type:	'endgroup' },
			//Position
			{ caption:	'Position',					type: 'group',	brief_fn:function(data){ return ""; }			},
				{ caption:	'Horizontal',			type: 'option',	name: 'horizontalPosition', 
					values : [
						{ value : 'LEFT',		caption : 'Left'		},
						{ value : 'RIGHT',		caption : 'Right'		},
						{ value : 'CENTER',		caption : 'Center'		},
						{ value : 'CUSTOM',		caption : 'Custom'		}
					]	
				},
				{ caption:	'Vertical',			type: 'option',	name: 'verticalPosition', 
					values : [
						{ value : 'TOP',		caption : 'Top'			},
						{ value : 'BOTTOM',		caption : 'Bottom'		},
						{ value : 'CENTER',		caption : 'Center'		},
						{ value : 'CUSTOM',		caption : 'Custom'		}
					]	
				},
				{ caption:	'Values',					type: 'group',	brief_fn:function(data){ return ""; }		},
					{ caption:	'Left',					type: 'string', name: 'leftPosition'						},
					{ caption:	'Right',				type: 'string', name: 'rightPosition'						},
					{ caption:	'Top',					type: 'string', name: 'topPosition'							},
					{ caption:	'Bottom',				type: 'string', name: 'bottomPosition'						},
				{ type:	'endgroup' },
			{ type:	'endgroup' },
			{ caption:	'Active',					type: 'group',	brief_fn:function(data){ return ""; }			},
				{ caption:	'Visible',					type: 'bool',	name: 'windowVisible'						},
				{ caption:	'Icon', type: 'bool-group', name: 'iconEnabled', brief_fn:function(data){ return "";  }	},
					{ caption:	'Image',				type: 'image',  name: 'iconImage'							},
					{ caption:	'Color',				type: 'color', name: 'iconColor'							},
					{ caption:	'Position',				type: 'option',	name: 'iconPosition', 
						values : [
							{ value : 'LEFT',		caption : 'Left'		},
							{ value : 'RIGHT',		caption : 'Right'		},
							{ value : 'TOP',		caption : 'Top'			},
							{ value : 'BOTTOM',		caption : 'Bottom'		}
						]	
					},
				{ type:	'endgroup' },
				{ caption:	'Text', type: 'bool-group', name: 'textEnabled', brief_fn:function(data){ return "";  }	},
					{ caption:	'Content',				type: 'string', name: 'textContent'							},
					{ caption:	'Color',				type: 'color', name: 'textColor'							},
					{ caption:	'Font',					type: 'font',   name: 'textFont'							},
					{ caption:	'Align',				type: 'option',	name: 'textAlign', 
						values : [
							{ value : 'LEFT',		caption : 'Left'		},
							{ value : 'RIGHT',		caption : 'Right'		},
							{ value : 'CENTER',		caption : 'Center'		}
						]	
					},
				{ type:	'endgroup' },
				{ caption:	'Background', type: 'bool-group', name: 'backgroundEnabled', brief_fn:function(data){ return "";  }	},
					{ caption:	'Background',				type: 'color', name: 'background'							},
				{ type:	'endgroup' },
				{ caption:	'Round',						type: 'group',	brief_fn:function(data){ return ""; }		},
					{ caption:	'Top Left',		type: 'integer',	name: 'roundTopLeft'								},
					{ caption:	'Top Right',	type: 'integer',	name: 'roundTopRight'								},
					{ caption:	'Bottom Left',	type: 'integer',	name: 'roundBottomLeft'								},
					{ caption:	'Bottom Right',	type: 'integer',	name: 'roundBottomRight'							},
				{ type:	'endgroup' },
				{ caption:	'Shadow', type: 'bool-group', name: 'shadow', brief_fn:function(data){ return "";  }		},
					{ caption:	'Color',		type: 'color',		name: 'shadowColor'									},
					{ caption:	'Size',			type: 'integer',	name: 'shadowSize'									},
				{ type:	'endgroup' });
		if (!this.mobile) {
			res.push(
				{ caption:	'Hover',					type: 'group',	brief_fn:function(data){ return ""; }		},
					{ caption:	'Change', type: 'bool-group', name: 'hoverChange', brief_fn:function(data){ return "";  } },
						{ caption:	'Icon', type: 'bool-group', name: 'hoverIconEnabled', brief_fn:function(data){ return "";  }},
							{ caption:	'Image',				type: 'image',  name: 'hoverIconImage'				},
							{ caption:	'Color',				type: 'color', name: 'hoverIconColor'				},
							{ caption:	'Position',				type: 'option',	name: 'hoverIconPosition', 
								values : [
									{ value : 'LEFT',		caption : 'Left'		},
									{ value : 'RIGHT',		caption : 'Right'		},
									{ value : 'TOP',		caption : 'Top'			},
									{ value : 'BOTTOM',		caption : 'Bottom'		}
								]	
							},
						{ type:	'endgroup' },
						{ caption:	'Text', type: 'bool-group', name: 'hoverTextEnabled', brief_fn:function(data){ return "";  }},
							{ caption:	'Content',				type: 'string', name: 'hoverTextContent'			},
							{ caption:	'Color',				type: 'color', name: 'hoverTextColor'				},
							{ caption:	'Font',					type: 'font',   name: 'hoverTextFont'				},
							{ caption:	'Align',				type: 'option',	name: 'hoverTextAlign', 
								values : [
									{ value : 'LEFT',		caption : 'Left'		},
									{ value : 'RIGHT',		caption : 'Right'		},
									{ value : 'CENTER',		caption : 'Center'		}
								]	
							},
						{ type:	'endgroup' },
						{ caption:	'H.Size',						type: 'group',	brief_fn:function(data){ return ""; }},
							{ caption:	'Width',				type: 'geometry', name: 'hoverWidth'				},
							{ caption:	'Height',				type: 'geometry', name: 'hoverHeight'				},
						{ type:	'endgroup' },
						{ caption:	'Resize',					type: 'option',	name: 'hoverResize', 
							values : [
								{ value : 'LEFT',		caption : 'To Left'		},
								{ value : 'RIGHT',		caption : 'To Right'	},
								{ value : 'TOP',		caption : 'To Top'		},
								{ value : 'BOTTOM',		caption : 'To Bottom'	},
								{ value : 'EXPAND',		caption : 'Expand'		}
							]	
						},
						{ caption:	'Effect',					type: 'group',	brief_fn:function(data){ return ""; }},
							{ caption:	'Show', type: 'bool-group', name: 'hoverShowEffect', brief_fn:function(data){ return "";  }},
								{ caption:	'Effect',			type: 'option',	 name: 'hoverShowEffectType', values : SHOW_EFFECTS	},
								{ caption:	'Duration',			type: 'integer', name: 'hoverShowEffectDuration'			},
							{ type:	'endgroup' },
							{ caption:	'Hide', type: 'bool-group', name: 'hoverHideEffect', brief_fn:function(data){ return "";  }},
								{ caption:	'Effect',			type: 'option',	 name: 'hoverHideEffectType', values : SHOW_EFFECTS	},
								{ caption:	'Duration',			type: 'integer', name: 'hoverHideEffectDuration'			},
							{ type:	'endgroup' },
						{ type:	'endgroup' },
						{ caption:	'Round',						type: 'group',	brief_fn:function(data){ return ""; }		},
							{ caption:	'Top Left',		type: 'integer',	name: 'hoverRoundTopLeft'							},
							{ caption:	'Top Right',	type: 'integer',	name: 'hoverRoundTopRight'							},
							{ caption:	'Bot. Left',	type: 'integer',	name: 'hoverRoundBottomLeft'						},
							{ caption:	'Bot. Right',	type: 'integer',	name: 'hoverRoundBottomRight'						},
						{ type:	'endgroup' },
						{ caption:	'Shadow', type: 'bool-group', name: 'hoverShadow', brief_fn:function(data){ return "";  }		},
							{ caption:	'Color',		type: 'color',		name: 'hoverShadowColor'								},
							{ caption:	'Size',			type: 'integer',	name: 'hoverShadowSize'									},
						{ type:	'endgroup' },
					{ type:	'endgroup' },
					{ caption:	'Background', type: 'bool-group', name: 'hoverBackgroundEnabled', brief_fn:function(data){ return "";  }	},
						{ caption:	'Background',				type: 'color', name: 'hoverBackground'							},
					{ type:	'endgroup' },
				{ type:	'endgroup' }
			);
		}
		res.push(
				{ caption:	'New msgs',					type: 'group',	brief_fn:function(data){ return ""; }		},
					{ caption:	'Background',				type: 'color', name: 'newMsgsBackground'				},
					{ caption:	'Blink', type: 'bool-group', name: 'newMsgsBlink', brief_fn:function(data){ return ""; }},
						{ caption:	'Duration (ms)',	type: 'integer', name: 'newMsgsBlinkDuration'				},
					{ type:	'endgroup' },
					{ caption:	'Number', type: 'bool', name: 'newMsgsNumber' },
				{ type:	'endgroup' },
			{ type:	'endgroup' },
			{ caption:	'Out of Hours',					type: 'group',	brief_fn:function(data){ return ""; }		},
				{ caption:	'Visible',					type: 'bool',	name: 'out_windowVisible'						},
				{ caption:	'Icon', type: 'bool-group', name: 'out_iconEnabled', brief_fn:function(data){ return "";  }	},
					{ caption:	'Image',				type: 'image',  name: 'out_iconImage'							},
					{ caption:	'Color',				type: 'color', name: 'out_iconColor'							},
					{ caption:	'Position',				type: 'option',	name: 'out_iconPosition', 
						values : [
							{ value : 'LEFT',		caption : 'Left'		},
							{ value : 'RIGHT',		caption : 'Right'		},
							{ value : 'TOP',		caption : 'Top'			},
							{ value : 'BOTTOM',		caption : 'Bottom'		}
						]	
					},
				{ type:	'endgroup' },
				{ caption:	'Text', type: 'bool-group', name: 'out_textEnabled', brief_fn:function(data){ return "";  }	},
					{ caption:	'Content',				type: 'string', name: 'out_textContent'							},
					{ caption:	'Color',				type: 'color', name: 'out_textColor'							},
					{ caption:	'Font',					type: 'font',   name: 'out_textFont'							},
					{ caption:	'Align',				type: 'option',	name: 'out_textAlign', 
						values : [
							{ value : 'LEFT',		caption : 'Left'		},
							{ value : 'RIGHT',		caption : 'Right'		},
							{ value : 'CENTER',		caption : 'Center'		}
						]	
					},
				{ type:	'endgroup' },
				{ caption:	'Background', type: 'bool-group', name: 'out_backgroundEnabled', brief_fn:function(data){ return "";  }	},
					{ caption:	'Background',				type: 'color', name: 'out_background'							},
				{ type:	'endgroup' },
				{ caption:	'Round',						type: 'group',	brief_fn:function(data){ return ""; }		},
					{ caption:	'Top Left',		type: 'integer',	name: 'out_roundTopLeft'							},
					{ caption:	'Top Right',	type: 'integer',	name: 'out_roundTopRight'							},
					{ caption:	'Bottom Left',	type: 'integer',	name: 'out_roundBottomLeft'							},
					{ caption:	'Bottom Right',	type: 'integer',	name: 'out_roundBottomRight'						},
				{ type:	'endgroup' },
				{ caption:	'Shadow', type: 'bool-group', name: 'out_shadow', brief_fn:function(data){ return "";  }	},
					{ caption:	'Color',		type: 'color',		name: 'out_shadowColor'								},
					{ caption:	'Size',			type: 'integer',	name: 'out_shadowSize'								},
				{ type:	'endgroup' }
		);
		if (!this.mobile) {
			res.push(
				{ caption:	'Hover',					type: 'group',	brief_fn:function(data){ return ""; }		},
					{ caption:	'Change', type: 'bool-group', name: 'out_hoverChange', brief_fn:function(data){ return "";  } },
						{ caption:	'Icon', type: 'bool-group', name: 'out_hoverIconEnabled', brief_fn:function(data){ return "";  }},
							{ caption:	'Image',				type: 'image',  name: 'out_hoverIconImage'				},
							{ caption:	'Color',				type: 'color', name: 'out_hoverIconColor'				},
							{ caption:	'Position',				type: 'option',	name: 'out_hoverIconPosition', 
								values : [
									{ value : 'LEFT',		caption : 'Left'		},
									{ value : 'RIGHT',		caption : 'Right'		},
									{ value : 'TOP',		caption : 'Top'			},
									{ value : 'BOTTOM',		caption : 'Bottom'		}
								]	
							},
						{ type:	'endgroup' },
						{ caption:	'Text', type: 'bool-group', name: 'out_hoverTextEnabled', brief_fn:function(data){ return "";  }},
							{ caption:	'Content',				type: 'string', name: 'out_hoverTextContent'			},
							{ caption:	'Color',				type: 'color', name: 'out_hoverTextColor'				},
							{ caption:	'Font',					type: 'font',   name: 'out_hoverTextFont'				},
							{ caption:	'Align',				type: 'option',	name: 'out_hoverTextAlign', 
								values : [
									{ value : 'LEFT',		caption : 'Left'		},
									{ value : 'RIGHT',		caption : 'Right'		},
									{ value : 'CENTER',		caption : 'Center'		}
								]	
							},
						{ type:	'endgroup' },
						{ caption:	'H.Size',						type: 'group',	brief_fn:function(data){ return ""; }},
							{ caption:	'Width',				type: 'geometry', name: 'out_hoverWidth'				},
							{ caption:	'Height',				type: 'geometry', name: 'out_hoverHeight'				},
						{ type:	'endgroup' },
						{ caption:	'Resize',					type: 'option',	name: 'out_hoverResize', 
							values : [
								{ value : 'LEFT',		caption : 'To Left'		},
								{ value : 'RIGHT',		caption : 'To Right'	},
								{ value : 'TOP',		caption : 'To Top'		},
								{ value : 'BOTTOM',		caption : 'To Bottom'	},
								{ value : 'EXPAND',		caption : 'Expand'		}
							]	
						},
						{ caption:	'Effect',					type: 'group',	brief_fn:function(data){ return ""; }},
							{ caption:	'Show', type: 'bool-group', name: 'out_hoverShowEffect', brief_fn:function(data){ return "";  }},
								{ caption:	'Effect',			type: 'option',	 name: 'out_hoverShowEffectType', values : SHOW_EFFECTS	},
								{ caption:	'Duration',			type: 'integer', name: 'out_hoverShowEffectDuration'			},
							{ type:	'endgroup' },
							{ caption:	'Hide', type: 'bool-group', name: 'hoverHideEffect', brief_fn:function(data){ return "";  }},
								{ caption:	'Effect',			type: 'option',	 name: 'out_hoverHideEffectType', values : SHOW_EFFECTS	},
								{ caption:	'Duration',			type: 'integer', name: 'out_hoverHideEffectDuration'			},
							{ type:	'endgroup' },
						{ type:	'endgroup' },
						{ caption:	'Round',						type: 'group',	brief_fn:function(data){ return ""; }		},
							{ caption:	'Top Left',		type: 'integer',	name: 'out_hoverRoundTopLeft'							},
							{ caption:	'Top Right',	type: 'integer',	name: 'out_hoverRoundTopRight'							},
							{ caption:	'Bot. Left',	type: 'integer',	name: 'out_hoverRoundBottomLeft'						},
							{ caption:	'Bot. Right',	type: 'integer',	name: 'out_hoverRoundBottomRight'						},
						{ type:	'endgroup' },
						{ caption:	'Shadow', type: 'bool-group', name: 'out_hoverShadow', brief_fn:function(data){ return "";  }	},
							{ caption:	'Color',		type: 'color',		name: 'out_hoverShadowColor'							},
							{ caption:	'Size',			type: 'integer',	name: 'out_hoverShadowSize'								},
						{ type:	'endgroup' },
					{ type:	'endgroup' },
					{ caption:	'Background', type: 'bool-group', name: 'out_hoverBackgroundEnabled', brief_fn:function(data){ return "";  }	},
						{ caption:	'Background',				type: 'color', name: 'out_hoverBackground'							},
					{ type:	'endgroup' },
				{ type:	'endgroup' }
			);
		}
		res.push(
			{ type:	'endgroup' },
			{ caption:	'Effects',						type: 'group',	brief_fn:function(data){ return ""; }		},
				{ caption:	'First Show', type: 'bool-group', name: 'firstShowEffect', brief_fn:function(data){ return "";  }	},
					{ caption:	'Effect',			type: 'option',	 name: 'firstShowEffectType', values : SHOW_EFFECTS	},
					{ caption:	'Duration (ms)',	type: 'integer', name: 'firstShowEffectDuration'						},
				{ type:	'endgroup' },
				{ caption:	'Don\'t Hide',			type: 'bool',	name: 'windowDontHide'							},
				{ caption:	'Show', type: 'bool-group', name: 'showEffect', brief_fn:function(data){ return "";  }	},
					{ caption:	'Effect',			type: 'option',	 name: 'showEffectType', values : SHOW_EFFECTS	},
					{ caption:	'Duration (ms)',	type: 'integer', name: 'showEffectDuration'						},
				{ type:	'endgroup' },
				{ caption:	'Hide', type: 'bool-group', name: 'hideEffect', brief_fn:function(data){ return "";  }	},
					{ caption:	'Effect',			type: 'option',	 name: 'hideEffectType', values : HIDE_EFFECTS	},
					{ caption:	'Duration (ms)',	type: 'integer', name: 'hideEffectDuration'						},
				{ type:	'endgroup' },
				{ caption:	'Scroll', type: 'bool-group', name: 'scrollEffect', brief_fn:function(data){ return "";  }	},
					{ caption:	'Duration (ms)',	type: 'integer', name: 'scrollEffectDuration'					},
				{ type:	'endgroup' },
			{ type:	'endgroup' },
			{ caption:	'Preview',						type: 'group',	brief_fn:function(data){ return ""; }		},
				{ caption:	'Mode',						type: 'option',	name: 'preview_mode', 
					values : [
						{ value : 'ACTIVE',		caption : 'Active'			},
						{ value : 'OUT_HOURS',	caption : 'Out of Hours'	}
					]	
				},
			{ type:	'endgroup' }
		);
		
		this._setProperties();
		
		return res;
	};

	chatminimized.prototype.destroy = function () {
		chatminimized.SUPERclass.destroy.call(this);
	};
	
	chatminimized.prototype._designer = function() {
		return (this.environment && (this.environment.designer || this.environment.arguments.debug));
	};
	
	chatminimized.prototype._designerPreview = function() {
		return (this.environment && this.environment.arguments.debug);
	};
	
	chatminimized.prototype._designerGrid = function() {
		return (this.environment && this.environment.designer);
	};
	
	chatminimized.prototype.isMobile = function() {
		return this.environment && this.environment.arguments && this.environment.arguments.mobile && true || false;
	};
	
	chatminimized.prototype.outOfHours = function() {
		if (this._designer()) {
			return this.preview_mode === "OUT_HOURS";
		}
		return this.environment && this.environment.arguments && this.environment.arguments.outOfHours && true || false;
	};
	
	chatminimized.prototype.inactive = function() {
		return this.environment && this.environment.arguments && this.environment.arguments.inactive && true || false;
	};
	
	chatminimized.prototype._getProperty = function(key) {
		return this[(this.outOfHours()? "out_" : "") + key];
	};
	
	chatminimized.prototype._setProperty = function(key, value) {
		this[(this.outOfHours()? "out_" : "") + key] = this._T(value);
	};
	
	chatminimized.prototype._makeUI = function() {
		this.wnd = icc.utils.makeElement("div", false);
		this.wnd.className = this._designer()? "chatMinimizedCtrlDesigner" : "chatMinimizedCtrl";
		if (this.isMobile()) {
			$("body").addClass("mobile");
		}
		if (this.outOfHours()) {
			this.wnd.className += " outOfHours";
		}
		
		var inactive = this.inactive();
		
		if (this.id !== undefined) {
			this.wnd.id = this.id;
		}		
		var control = 
			"<div class='chatMinimizedContainer'>" +
				"<div class='chatMinimizedTitle " + (inactive? "inactive" : "active") + "'>" +
					"<span class='chatUnreadedMessages' style='display:none;'></span>" +
					"<i class='chatMinimizedIcon iconChatHeader' " + (!this._getProperty("iconEnabled")? "style='display:none;'" : "") + "></i>" +
					"<label class='chatMinimizedText' " + (!this._getProperty("textEnabled")? "style='display:none;'" : "") + "></label>" +
				"</div>" +
				`<div style="position:absolute;width:100%;height:100%;opacity:0;${inactive?"":"cursor:pointer"}" role="button" ${this._aria_label()} > ${this._getProperty("textContent")}</div>` +
			"</div>";
		$(this.wnd).html(control);
		
		if (this._getProperty("hoverChange")) {
			var hoverControl = 
				"<div class='chatMinimizedHoverContainer'>" +
					"<div class='chatMinimizedTitle " + (inactive? "inactive" : "active") + "'>" +
						"<span class='chatUnreadedMessages' style='display:none;'></span>" +
						"<i class='chatMinimizedIcon iconChatHeader' " + (!this._getProperty("hoverIconEnabled")? "style='display:none;'" : "") + "></i>" +
						"<label class='chatMinimizedText' " + (!this._getProperty("hoverTextEnabled")? "style='display:none;'" : "") + "></label>" +
					"</div>" +
				"</div>";
			$(this.wnd).append(hoverControl);
			
			if (this._designerPreview()) {
				var css = {
					width:		this.width,
					height:		this.height,
					position:	"absolute"
				};
				var hoverCss = {
					width:		this._getProperty("hoverWidth")  || this.width,
					height:		this._getProperty("hoverHeight") || this.height
				};

				//horizontal
				switch(this._getProperty("hoverResize")) {
					case "LEFT":
						css["right"] = "0px";
						break;
					case "RIGHT":
						css["left"] = "0px";
						break;
					default:
						css["left"] = "calc( 50% - " + (this.width / 2) + "px)";
				}
				//vertical
				switch(this._getProperty("hoverResize")) {
					case "TOP":
						css["bottom"] = "0px";
						break;
					case "BOTTOM":
						css["top"] = "0px";
						break;
					default:
						css["top"] = "calc( 50% - " + (this.height / 2) + "px)";
				}

				$(".chatMinimizedContainer", this.wnd).css(css);
				$(".chatMinimizedHoverContainer", this.wnd).css(hoverCss);

				addCssRule(".chatMinimizedCtrlDesigner", 
					"width: " + (this._getProperty("hoverWidth") || this.width) + "!important; " + 
					"height: " + (this._getProperty("hoverHeight") || this.height) + "!important;");
			}
			
			this.setHoverIcon();
			this.setHoverText();
		}
		
		this._setStyle();
		this.setIcon();
		this.setText();
	};
	chatminimized.prototype._aria_label = function(){
		return this._getProperty("textContent")  || this._getProperty("textContent") !== undefined
				?`arial-label="${this._getProperty("textContent")}"`
				:"";
	}
	chatminimized.prototype._setStyle = function() {
		var self = this;
		
		function setStyle($container, hover) {
			function getProperty(property) {
				if (hover) {
					property = "hover" + property.charAt(0).toUpperCase() + property.slice(1);
				}
				return self._getProperty(property);
			}
			
			var backgroundEnabled = getProperty("backgroundEnabled");
			if (!backgroundEnabled) {
				$container.addClass("backgroundDisabled");
			}
			
			if (self._designer() && getProperty("shadow")) {
				var shadowProperty = "0px 0px " + 
					(getProperty("shadowSize") || 12) + "px " + 
					(getProperty("shadowColor") || "#aaaaaa");
				$($container).css({
					"-webkit-box-shadow" : shadowProperty,
					"-moz-box-shadow" : shadowProperty,
					"box-shadow" : shadowProperty
				});
			}
			
			var titleCss = {
				"background-color"		: backgroundEnabled && getProperty("background") || undefined,
				color					: getProperty("textColor") || undefined
			};
			var iconCss = {
				color					: getProperty("iconColor")	|| undefined
			};
			var labelCss = {};

			var iconPosition = getProperty("iconPosition") || "LEFT";
			var textAlign = getProperty("textAlign") || "LEFT";
			
			var textEnabled = getProperty("textEnabled");
			var iconEnabled = getProperty("iconEnabled");
			
			var font = getProperty("textFont");
			if (font && font.size && parseInt(font.size)) {
				var fontSize = parseInt(font.size) * 2;
				iconCss["font-size"] = "" + fontSize + "px";
				iconCss["width"] = fontSize;
				iconCss["height"] = fontSize;
				if (iconPosition === "LEFT" || iconPosition === "RIGHT") {
					labelCss["margin-top"] = "" + (fontSize / 4) + "px";
				}
			}

			if (textEnabled) {
				
				switch(iconPosition) {
					case "LEFT":
						iconCss["margin-right"] = "6px";
						break;
					case "RIGHT":
						$(".chatMinimizedIcon", $container)
							.remove()
							.appendTo($(".chatMinimizedTitle", $container));
						iconCss["margin-left"] = "6px";
						break;
					case "TOP":
					case "BOTTOM":
						if (iconPosition === "BOTTOM") {
							$(".chatMinimizedIcon", $container)
								.remove()
								.appendTo($(".chatMinimizedTitle", $container));
						}
						iconCss["display"] = iconEnabled? "block" : "none";
						iconCss["width"] = "100%";
						iconCss["clear"] = "both";
						labelCss["clear"] = "both";
						labelCss["width"] = "100%";
						break;
				}

				switch(textAlign) {
					case "LEFT":
						iconCss["float"] = "left";
						iconCss["text-align"] = "left";
						labelCss["float"] = "left";
						labelCss["text-align"] = "left";
						break;
					case "RIGHT":
						iconCss["float"] = "right";
						iconCss["text-align"] = "right";
						labelCss["float"] = "right";
						labelCss["text-align"] = "right";
						if (iconPosition === "LEFT") {
							$(".chatMinimizedIcon", $container)
								.remove()
								.appendTo($(".chatMinimizedTitle", $container));
						}
						else if (iconPosition === "RIGHT") {
							$(".chatMinimizedText", $container)
								.remove()
								.appendTo($(".chatMinimizedTitle", $container));
						}
						break;
					case "CENTER":
						if (iconPosition === "TOP" || iconPosition === "BOTTOM") {
							titleCss["text-align"] = "center";
							iconCss["width"] = "100%";
							labelCss["text-align"] = "center";
						}
						else {
							iconCss["float"] = "left";
							iconCss["text-align"] = "left";
							labelCss["float"] = "left";
							labelCss["text-align"] = "left";
							
							var $minContainer = $(".chatMinimizedCenterContainer", $container);
							if (!$minContainer.length) {
								$(".chatMinimizedTitle", $container).append("<div class='chatMinimizedCenterContainer'></div>");
								$minContainer = $(".chatMinimizedCenterContainer", $container);
							}
							
							var $icon = $(".chatMinimizedIcon", $container);
							var $text = $(".chatMinimizedText", $container);
							
							if (iconPosition === "LEFT") {
								$icon.remove().appendTo($minContainer);
								$text.remove().appendTo($minContainer);
							}
							else {
								$text.remove().appendTo($minContainer);
								$icon.remove().appendTo($minContainer);
							}
						}
						break;
				}
			}
			else {
				iconCss["width"] = "auto";
				iconCss["height"] = "100%";
				iconCss["font-size"] = Math.min((hover && getProperty("width") || self.width) - 30, 
					(hover && getProperty("height") || self.height) - 20);
			}
			
			if (!iconEnabled) {
				labelCss["margin-top"] = "0px";
			}

			$(".chatMinimizedTitle", $container).css(titleCss);
			$(".chatMinimizedIcon", $container).css(iconCss);
			$(".chatMinimizedText", $container).css(labelCss);
			setFont($(".chatMinimizedText", $container), font);

			if (backgroundEnabled && (getProperty("roundTopLeft") || getProperty("roundTopRight"))) {
				var css = {
					"border-top-left-radius"	: getProperty("roundTopLeft")? (getProperty("roundTopLeft") + "px") : null,
					"border-top-right-radius"	: getProperty("roundTopRight")? (getProperty("roundTopRight") + "px") : null
				};
				$container.css(css);
				$(".chatMinimizedTitle", $container).css(css);
			}

			if (backgroundEnabled && (getProperty("roundBottomLeft") || getProperty("roundBottomRight"))) {
				var css = {
					"border-bottom-left-radius"		: getProperty("roundBottomLeft")? (getProperty("roundBottomLeft") + "px") : null,
					"border-bottom-right-radius"	: getProperty("roundBottomRight")? (getProperty("roundBottomRight") + "px") : null
				};
				$container.css(css);
				$(".chatMinimizedTitle", $container).css(css);
			}
		}
		
		setStyle($(".chatMinimizedContainer", this.wnd));
		
		if (!this.isMobile()) {
			if (this._getProperty("hoverChange")) {
				setStyle($(".chatMinimizedHoverContainer", this.wnd), true);

				var $container = $(".chatMinimizedContainer", this.wnd);
				var $hover = $(".chatMinimizedHoverContainer", this.wnd);
				$(this.wnd).hover(
					function() {
						hideEffect($container, 
							self._getProperty("hoverHideEffect") && self._getProperty("hoverHideEffectType"), 
							self._getProperty("hoverHideEffectDuration"), 
							function() {
								self.__fit(true, true, function() {
									showEffect($hover, 
										self._getProperty("hoverShowEffect") && self._getProperty("hoverShowEffectType"), 
										self._getProperty("hoverShowEffectDuration"), 
										function() {
											iFrameEventListener.showMinimizedShadow();
										});
								});
							});
					},
					function() {
						hideEffect($hover, 
							self._getProperty("hoverHideEffect") && self._getProperty("hoverHideEffectType"), 
							self._getProperty("hoverHideEffectDuration"), 
							function() {
								self.__fit(true, false, function() {
									showEffect($container, 
										self._getProperty("hoverShowEffect") && self._getProperty("hoverShowEffectType"), 
										self._getProperty("hoverShowEffectDuration"), 
										function() {
											iFrameEventListener.showMinimizedShadow();
										});
								});
							});
					}
				);
			}
			else {
				if (!this.inactive() && this._getProperty("hoverBackgroundEnabled") && this._getProperty("hoverBackground")) {
					$(".chatMinimizedTitle", $(".chatMinimizedContainer", this.wnd)).hover(
						function() {
							$(this).css({
								"background-color" : self._getProperty("hoverBackground") || undefined
							});
						},
						function() {
							$(this).css({
								"background-color" : self._getProperty("backgroundEnabled") && 
									self._getProperty("background") || ""
							});
						}
					);
				}
			}
		}

		if (this._getProperty("newMsgsBackground")) {
			addCssRule(".newMessages .chatMinimizedTitle", 
				"background-color: " + this._getProperty("newMsgsBackground") + "!important;");
		}

		addCssRule("#startButton, #tw-root, #startButton > div", 
			"overflow: hidden!important; width: 100%!important; height: 100%!important;");
	};

	chatminimized.prototype.setText = function(textContent) {
		this._setProperty("textContent", textContent === undefined? this._getProperty("textContent") : (textContent || ""));
		var $container = $(".chatMinimizedContainer", this.wnd);
		$(".chatMinimizedText", $container).text(this._getProperty("textContent"));
	};

	chatminimized.prototype.getText = function() {
		return this._getProperty("textContent");
	};

	chatminimized.prototype.setHoverText = function(textContent) {
		this._setProperty("hoverTextContent", textContent === undefined? this._getProperty("hoverTextContent") : (textContent || ""));
		var $container = $(".chatMinimizedHoverContainer", this.wnd);
		$(".chatMinimizedText", $container).text(this._getProperty("hoverTextContent"));
	};

	chatminimized.prototype.getHoverText = function() {
		return this._getProperty("hoverTextContent");
	};

	chatminimized.prototype._getCustomImagePath = function (imageName) {
		if(this._appName && imageName.substring(0,1)!=='!'){
			imageName = '@'+this._appName+'@'+imageName;
		}
		return icc.ui.getApplication().getImageSRC(imageName);
	};
	
	chatminimized.prototype.setIcon = function(iconImage) {
		this._setProperty("iconImage", iconImage === undefined? this._getProperty("iconImage") : (iconImage || null));
		var $iconImage = null;
		if (this._getProperty("iconImage")) {
			var iconPath = this._getCustomImagePath(this._getProperty("iconImage"));
			$iconImage = $('<div class="chatMinimizedIconImage"></div>');
			$iconImage.css("background-image", "url(\"" + encodeURI(iconPath) + "\")"); 
			$iconImage.css("background-position", "center"); 
		}
		var $container = $(".chatMinimizedContainer", this.wnd);
		$(".chatMinimizedIcon", $container)
			.toggleClass("iconChatHeader", !$iconImage)
			.html("")
			.append($iconImage);
		
		var iconPosition = this._getProperty("iconPosition") || "LEFT";
		var textAlign = this._getProperty("textAlign") || "LEFT";
		if (iconPosition === "TOP" || iconPosition === "BOTTOM") {
			$(".chatMinimizedIconImage", $container).css("background-position-x",
					textAlign === "LEFT"? "0px"
				:	textAlign === "RIGHT"? "100%"
				:	undefined);
		}
		$(".chatMinimizedIconImage", $container)
		.attr("aria-label",this._getProperty("textContent"))
		.attr("role","button")

	};
	
	chatminimized.prototype.getIcon = function() {
		return this._getProperty("iconImage");
	};
	
	chatminimized.prototype.setHoverIcon = function(iconImage) {
		this._setProperty("hoverIconImage", iconImage === undefined? this._getProperty("hoverIconImage") : (iconImage || null));
		var $iconImage = null;
		if (this._getProperty("hoverIconImage")) {
			var iconPath = this._getCustomImagePath(this._getProperty("hoverIconImage"));
			$iconImage = $('<div class="chatMinimizedIconImage"></div>');
			$iconImage.css("background-image", "url(\"" + encodeURI(iconPath) + "\")"); 
			$iconImage.css("background-position", "center"); 
		}
		var $container = $(".chatMinimizedHoverContainer", this.wnd);
		$(".chatMinimizedIcon", $container)
			.toggleClass("iconChatHeader", !$iconImage)
			.html("")
			.append($iconImage);
		
		var iconPosition = this._getProperty("hoverIconPosition") || "LEFT";
		var textAlign = this._getProperty("hoverTextAlign") || "LEFT";
		if (iconPosition === "TOP" || iconPosition === "BOTTOM") {
			$(".chatMinimizedIconImage", $container).css("background-position-x",
					textAlign === "LEFT"? "0px"
				:	textAlign === "RIGHT"? "100%"
				:	undefined);
		}
	};
	
	chatminimized.prototype.getHoverIcon = function() {
		return this._getProperty("hoverIconImage");
	};
	
	chatminimized.prototype.showChat = function() {
		iFrameEventListener.openChat();
	};
	
	chatminimized.prototype._bindEvents = function() {
		if (this._designer()) {
			return;
		}
		
		var self = this;
		$(this.wnd)
			.off("click")
			.on("click", function() {
				self.showChat();
			});
	};
	
	var minimizedSizes = {
		FLAT_SMALL			: { width : 260,		height: 40		},
		FLAT_MEDIUM			: { width : 280,		height: 40		},
		FLAT_BIG			: { width : 300,		height: 40		},
		SQUARE_SMALL		: { width : 80,			height: 80		},
		SQUARE_MEDIUM		: { width : 120,		height: 120		},
		SQUARE_BIG			: { width : 160,		height: 160		}
	};
	
	var minimizedSizes_mobile = {
		FLAT_SMALL			: { width : 60,			height: 40		},
		FLAT_MEDIUM			: { width : 80,			height: 40		},
		FLAT_BIG			: { width : 100,		height: 40		},
		SQUARE_SMALL		: { width : 60,			height: 60		},
		SQUARE_MEDIUM		: { width : 80,			height: 80		},
		SQUARE_BIG			: { width : 120,		height: 120		}
	};
	
	chatminimized.prototype._setSize = function() {
		var sizes = (this.mobile? minimizedSizes_mobile : minimizedSizes)[this.windowSize];
		if (sizes) {
			this.width = sizes.width;
			this.height = sizes.height;
			this.resizable = false;
		}
		else {
			this.windowSize = "CUSTOM";
			this.resizable = true;
		}
	};
	
	chatminimized.prototype._getSize = function(hover) {
		var size = {
			width	: this.width,
			height	: this.height
		};
		
		if (hover && this._getProperty("hoverChange")) {
			var hoverWidth = this._getProperty("hoverWidth") || size.width;
			var hoverHeight = this._getProperty("hoverHeight") || size.height;
			if (this._designer()) {
				size.width = (hoverWidth && hoverWidth > size.width)? hoverWidth : size.width;
				size.height = (hoverHeight && hoverHeight > size.height)? hoverHeight : size.height;
			}
			else {
				size.resize = this._getProperty("hoverResize");
				size.widthDiff = hoverWidth - size.width;
				size.heightDiff = hoverHeight - size.height;
				size.width = hoverWidth;
				size.height = hoverHeight;
			}
		}
		return size;
	};
	
	chatminimized.prototype._setPosition = function() {
		switch(this.horizontalPosition) {
			case "LEFT":
				this.leftPosition = "5%";
				this.rightPosition = "";
				break;
			case "RIGHT":
				this.leftPosition = "";
				this.rightPosition = "5%";
				break;
			case "CENTER":
				//dinamic
				this.leftPosition = "";
				this.rightPosition = "";
				break;
			default:
				this.horizontalPosition = "CUSTOM";
				break;
		}
		switch(this.verticalPosition) {
			case "TOP":
				this.topPosition = "0px";
				this.bottomPosition = "";
				break;
			case "BOTTOM":
				this.topPosition = "";
				this.bottomPosition = "0px";
				break;
			case "CENTER":
				//dinamic
				this.topPosition = "";
				this.bottomPosition = "";
				break;
			default:
				this.verticalPosition = "CUSTOM";
				break;
		}
	};
	
	chatminimized.prototype._demoPosition = function() {
		var css = {
			position : "fixed"
		};
		var size = this._getSize(true);
		
		if (this.horizontalPosition === "CENTER") {
			css.left = "calc( 50% - " + (size.width / 2) + "px)";
			css.right = "";
		}
		else {
			css.left = this.leftPosition || "";
			css.right = this.rightPosition || "";
		}
		
		if (this.verticalPosition === "CENTER") {
			css.top = "calc( 50% - " + (size.height / 2) + "px)";
			css.bottom = "";
		}
		else {
			css.top = this.topPosition || "";
			css.bottom = this.bottomPosition || "";
		}
		
		$(this.wnd).css(css);
	};
	
	chatminimized.prototype._setProperties = function() {
		var self = this;
		(function setProperties() {
			var loaded = $("#appExplorer").first().find("input").filter(function() {
				return $(this).val() === "chatminimizedctrl";
			}).length > 0;
			if (!loaded) {
				return window.setTimeout(setProperties, 300);
			}
			_setPropertyInsideTable("", self.windowSize, null, ["Size"]);
			var disabled = self.windowSize !== "CUSTOM";
			_setPropertyInsideTable("Width", self.width, disabled, ["Size", "Values"]);
			_setPropertyInsideTable("Height", self.height, disabled, ["Size", "Values"]);
			
			_setPropertyInsideTable("Horizontal", self.horizontalPosition, null, ["Position"]);
			var disabled = self.horizontalPosition !== "CUSTOM";
			_setPropertyInsideTable("Left", self.leftPosition, disabled, ["Position", "Values"]);
			_setPropertyInsideTable("Right", self.rightPosition, disabled, ["Position", "Values"]);
			
			_setPropertyInsideTable("Vertical", self.verticalPosition, null, ["Position"]);
			var disabled = self.verticalPosition !== "CUSTOM";
			_setPropertyInsideTable("Top", self.topPosition, disabled, ["Position", "Values"]);
			_setPropertyInsideTable("Bottom", self.bottomPosition, disabled, ["Position", "Values"]);
			
			var disabled = !!self.windowDontHide;
			_setPropertyInsideTable("Show", undefined, disabled, ["Effects"], disabled);
			_setPropertyInsideTable("Hide", undefined, disabled, ["Effects"], disabled);
		})();
	};
	
	chatminimized.prototype._loadDesginer = function() {
		this._setProperties();
		
		(function _hideDesignerAddButton() {	
			if (!$("#startButton").length) {
				return window.setTimeout(_hideDesignerAddButton, 300);
			}
			$("#startButton").parent().siblings().hide();
		})();
	};

	chatminimized.prototype.create = function () {
		var self = this;
		initCssRules();
		
		self._setSize();
		self._setPosition();
		if (self.environment && self.environment.designer) {
			self._loadDesginer();
		}
		chatminimized.SUPERclass.create.call(this);
		
		self._makeUI();
		self._bindEvents();
		
		if (self._designer()) {
			if (self.environment.arguments.debug) {
				$(self.wnd).hide();
				window.setTimeout(function() {
					self._demoPosition();
					$(self.wnd).show();
				}, 1);
			}
		}
		else {
			$(self.wnd).hide();
		}
	};
	
	chatminimized.prototype.__onDesignerResize = function() {
		this._setStyle();
	};
	
	chatminimized.prototype._show = function(callback) {
		callback = callback || function() {};
		if (this.wasShown) {
			showEffect($(this.wnd), !this.windowDontHide && this.showEffect && this.showEffectType, this.showEffectDuration, callback);
		}
		else {
			this.wasShown = true;
			showEffect($(this.wnd), this.firstShowEffect && this.firstShowEffectType, this.firstShowEffectDuration, callback);
		}
	};
	
	chatminimized.prototype._hide = function(callback) {
		callback = callback || function() {};
		if (this.windowDontHide) {
			return callback();
		}
		hideEffect($(this.wnd), this.hideEffect && this.hideEffectType, this.hideEffectDuration, callback);
	};
	
	chatminimized.prototype.onNewMessage = function() {
		if (!this._newMessages) {
			this._newMessages = 0;
			var $chatContainer = $(".chatMinimizedContainer", this.wnd);
			$chatContainer.addClass("newMessages");
			if (this.newMsgsBlink) {
				this._newMsgsBlickInterval = window.setInterval(function() {
					$chatContainer.toggleClass("newMessages");
				}, this.newMsgsBlinkDuration || 500);
			}
			if (this.newMsgsNumber) {
				$(".chatUnreadedMessages", this.wnd).show();
			}
		}
		this._newMessages++;
		$(".chatUnreadedMessages", this.wnd).text(this._newMessages);
	};
	
	chatminimized.prototype.onMessagesReaded = function() {
		this._newMessages = 0;
		$(".chatMinimizedContainer", this.wnd).removeClass("newMessages");
		if (this._newMsgsBlickInterval) {
			window.clearInterval(this._newMsgsBlickInterval);
			this._newMsgsBlickInterval = null;
		}
		$(".chatUnreadedMessages", this.wnd)
			.hide()
			.text("");
	};
	
	chatminimized.prototype.__fit = function(resize, hover, callback) {
		callback = callback || function() {};
		var self = this;
		
		if (self._designer()) {
			return callback();
		}
		
		function getProperty(property) {
			if (hover) {
				property = "hover" + property.charAt(0).toUpperCase() + property.slice(1);
			}
			return self._getProperty(property);
		}
		
		var size = this._getSize(hover);
		var configuration = {
			size : {
				width	: "" + size.width + "px",
				height	: "" + size.height + "px"
			},
			position : {},
			resize : resize
		};
		
		var diff = {};
		if (size.resize) {
			if (size.widthDiff > 0 && size.resize !== "LEFT" && size.resize !== "RIGHT") {
				diff.left = size.widthDiff / 2;
			}
			if (size.heightDiff > 0 && size.resize !== "TOP" && size.resize !== "BOTTOM") {
				diff.top = size.heightDiff / 2;
			}
		}
		
		if (this.horizontalPosition === "CENTER") {
			configuration.position.left = "calc( 50%" + 
				" - " + (size.width / 2) + "px" +
				")";
		}
		else {
			if (this.leftPosition) {
				if (diff.left) {
					configuration.position.left = "calc( " + this.leftPosition +
						" - " + diff.left + "px)";
				}
				else {
					configuration.position.left = this.leftPosition;
				}
			}
			else if (this.rightPosition) {
				configuration.position.left = "calc( 100%" + 
					" - " + this.rightPosition +
					" - " + configuration.size.width +
					(diff.left? (" + " + diff.left + "px") : "") +
					")";
			}
		}
		
		if (this.verticalPosition === "CENTER") {
			configuration.position.top = "calc( 50%" + 
				" - " + (size.height / 2) + "px" +
				")";
		}
		else {
			if (this.topPosition) {
				if (diff.top) {
					configuration.position.top = "calc( " + this.topPosition +
						" - " + diff.top + "px)";
				}
				else {
					configuration.position.top = this.topPosition;
				}
			}
			else if (this.bottomPosition) {
				configuration.position.top = "calc( 100%" + 
					" - " + this.bottomPosition +
					" - " + configuration.size.height +
					(diff.top? (" + " + diff.top + "px") : "") +
					")";
			}
		}
		
		if (self._getProperty(hover? "hoverShadow" : "shadow")) {
			configuration.shadow = {
				color		: self._getProperty(hover? "hoverShadowColor" : "shadowColor") || "#aaaaaa",
				size		: self._getProperty(hover? "hoverShadowSize" : "shadowSize") || 12
			};
		}

		if (getProperty("backgroundEnabled") && (
				getProperty("roundTopLeft") || getProperty("roundTopRight") ||
				getProperty("roundBottomLeft") || getProperty("roundBottomRight")
		)) {
			configuration.round = {
				"border-top-left-radius"		: getProperty("roundTopLeft")? (getProperty("roundTopLeft") + "px") : null,
				"border-top-right-radius"		: getProperty("roundTopRight")? (getProperty("roundTopRight") + "px") : null,
				"border-bottom-left-radius"		: getProperty("roundBottomLeft")? (getProperty("roundBottomLeft") + "px") : null,
				"border-bottom-right-radius"	: getProperty("roundBottomRight")? (getProperty("roundBottomRight") + "px") : null
			};
		}
		
		configuration.dontHide = !!self.windowDontHide;
		
		configuration.scroll = this.scrollEffect? { duration : this.scrollEffectDuration || 500 } : null;
		
		iFrameEventListener.fitMinimizedChat(self, configuration, callback);
	};
	
	chatminimized.prototype.start = function () {
		var self = this;
		
		if (self._designer()) {
			return;
		}
		
		maximizeAllParents($(self.wnd));
		
		self.__fit(false, false, function(show) {
			if (self._getProperty("windowVisible") && show > 0) {
				self._show(function() {
					iFrameEventListener.showMinimizedShadow();
				});
			}
			else if (show < 0) {
				self.wasShown = true;
			}
		});
	};

})(__icc__);
