module(...,package.seeall)

local function platform()
	local osstr = os.getenv("OS") or ""
	osstr =string.lower(osstr)
	if string.find(osstr,"windows") then
		return "WINDOWS"
	else
		return "LINUX"
	end
end
local function iff(cond,t,f)
	if cond then return t else return f end
end
local function isInconcert6()
	return iff(platform()=="WINDOWS",false,true);
end
local cfg = {
	platform = platform();
	
	tweety_folder = "inconcert/apps/webdesigner";
	tweety_modules_prefix = "apps.webdesigner.";

	tweety_permisions_actionId = 'designwebdesigner';

	mainAppFile = "application.properties";-- El archivo principal de la aplicacion
											-- puede contener simplemente el catalogo o puede ser un bundle completo

	catalogFile = "catalog.properties"; 	-- Contiene informacion util para el catalogo del usuario, como por ejemplo la version , el estado de actualizacion
											-- contra el repositorio etc.
											-- Es un archivo aparte de la aplicacion porque es dependiente de cada usuario.

	templateFile = "template.properties"; 	-- Contiene informacion para llenar el menu "Create new"
	pathSeparator = iff(platform()=="WINDOWS","\\","/");
	formFileExtention=".form";
	formCodeFileExtention=".form.js";
	
	datasourceFileExtention=".ds";
	inConcert6=isInconcert6();
	platform = platform();
	--------------------------------------------------------------------------------------------------
	templateDirPath="." .. iff(platform()=="WINDOWS","\\","/") .."templates";
	usersPath = "." .. iff(platform()=="WINDOWS","\\","/") .."scpusers";
	tempPath=iff(platform()=="WINDOWS",os.getenv("TMP"),"/tmp");
	rsvgconvert=iff(platform()=="WINDOWS",".\\rsvg\\rsvg-convert.exe","/usr/bin/rsvg-convert");
	resourcePath = "." .. iff(platform()=="WINDOWS","\\","/") .. "resources";
	weblibs = iff(isInconcert6(),"weblibs","inconcert");
	-------------------------------------------------------------------------------------------------
	appbundle_magic = "inconcert.tweety.application_bundle_1_0";

	-------------------------------------------------------------------------------------------------
	-- SQL SERVER --

	dataBase = {
		driver = "{SQL Server}",
		server = "127.0.0.1",
		database = "mmprodat",
		uid = "UsrAccMW",
		pwd = "inc2001"--"0461d2f7484c338e7d90fc7a"
	};
	
	-- REPOSITORY FOR PROMPTS
	repository ={
		{
			host = "127.0.0.1";
			port = 8082;
		}
	};
	
	
	
	-- CASSANDRA FOR SUMMARIZER
	cassandra_host = "192.168.65.10";
	cassandra_port = 9160;
	
	-- REDIS FOR SESSIONS
	redis_host = "127.0.0.1";
	redis_port = 6377;
	-------------------------------------------------------------------------------------------------
	-- MONGODB
	mongodb_connection_string = "127.0.0.1";
	mongodb_namespace_prefix = "tweety_";

	-- GENERAL TIMEOUT FOR HTTP SOCKET OPERATIONS

	sockethttp_timeout = 300; -- SEGUNDOS

	-------------------------------------------------------------------------------------------------
	-- INTEGRATION
	integration_address = "127.0.0.1";
	integration_port = 8082;

	-------------------------------------------------------------------------------------------------
	-- FLOW WEBSERVICE
	icc_flow_webservice_uri = "http://127.0.0.1/MiddleWareWSs/MiddleWareWS_SOAP.dll?Handler=MiddleWareWS";

	--------------------------------------------------------------------------------------------------
	cluster="inconcert6",
	config_server={
		ip = "192.168.65.10";
		port = 18082;
		myIp="127.0.0.1";
		myPort = 23182;
	};
	
	
	inconcertPoolTimeout=30;
	checkPermisions=false;
	IOSystem="cassandra";
	myself="http://127.0.0.1:23182";
	base_domain="127.0.0.1";
}

local function relativizePath(path,appLocation)
	if  string.sub(path,1,1) == '.' then
		path = appLocation .. string.sub(path,2)
	end
	return path
end

local function mergeTable(t1,t2)
	for k,v in pairs(t1) do
		local t
--		LogDebug("MERGE CONFIG ",k)
		if type(v) == "table" then
			t = t2[k]
			if type(t) == "nil" then
				t={}
				mergeTable(v,t)
				t2[k]=t
			elseif type(t) == "table" then
				mergeTable(v,t)
			end
		else

			t2[k]=v
		end
	end
end
function cfg.initialize(appcfg,appLocation)

	LogDebug("**************************************************************************************")

	mergeTable(appcfg,cfg);
	cfg.templateDirPath = relativizePath(cfg.templateDirPath,appLocation)
	cfg.usersPath = relativizePath(cfg.usersPath,appLocation)
	cfg.tempPath = relativizePath(cfg.tempPath,appLocation)
	cfg.rsvgconvert = relativizePath(cfg.rsvgconvert,appLocation)
	cfg.resourcePath = relativizePath(cfg.resourcePath,appLocation)
end

return cfg

