module(..., package.seeall)
local messages = require (tweety_modules_prefix .. "messages");
local runtime = require (tweety_modules_prefix .. "runtime");
local ws = require (tweety_modules_prefix .. "ws")
local config = require (tweety_modules_prefix .. "config")
local built_in_XSLT_executeDirect2ToTweetyRS =[[
<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:c="urn:MiddleWareWS_SOAPService">
<xsl:output method="xml"/>
<xsl:strip-space elements="*"/>
<xsl:template match="/">
	<xsl:element name="response">
	<xsl:element name="row">
			<xsl:element name="return">
				<xsl:value-of select="//c:return[1]"/>
			</xsl:element>
		</xsl:element>
	</xsl:element>
</xsl:template>
</xsl:stylesheet>
]]
local built_in_XSLT_IXMLToFlowRequest =[[
<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" indent="yes"/>
<xsl:strip-space elements="*"/>
	<xsl:template match="/">
		<xsl:element name="{/request/header/idOperativa/text()}" namespace="Repositorio.xml" >
			<xsl:element name="HEADER" namespace="Repositorio.xml">
				<xsl:element name="IDOPERATIVA" namespace="Repositorio.xml">
					<xsl:value-of select="/request/header/idOperativa"/>
				</xsl:element>
				<xsl:element name="IDUSUARIO" namespace="Repositorio.xml">
					<xsl:value-of select="/request/header/virtualUser"/>
				</xsl:element>
				<xsl:element name="IDSISTEMA" namespace="Repositorio.xml">
					<xsl:value-of select="/request/header/system"/>
				</xsl:element>
				<xsl:element name="ESTADO" namespace="Repositorio.xml">0</xsl:element>
			    <xsl:element name="IDOPERACION" namespace="Repositorio.xml">0</xsl:element>
			</xsl:element>
			<xsl:element name="BODY" namespace="Repositorio.xml">
				<xsl:for-each select="/request/parameters/*">
					<xsl:element name="{name()}" namespace="Repositorio.xml">
						<xsl:value-of select="value"/>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>
		</xsl:element>   
	</xsl:template>
</xsl:stylesheet>
]]
function new(self)

	self = ws.new(self)
	local webservice = ws.new({
		applicationName = self.applicationName,
		description= {
			columns={
				{
					type="string",
					name = "result"
				}
			},
			retrieve={
				enabled= true,
				inputParams={
					{
						name = "bstrMessage",
						type = "string",
					}
				},
				resourceURI=config.icc_flow_webservice_uri,
				requestMethod="POST",
				requestMessageType="soap",
				soapAction="#ExecuteDirect2",
				requestOperation="ExecuteDirect2",
				
				requestNamespace="urn:MiddleWareWS_SOAPService",
				responseMessageType="text/xml",
				requestXSLT="",
				responseXSLT=built_in_XSLT_executeDirect2ToTweetyRS
			},
			update={
				enabled= true,
				inputParams={
					{
						name = "bstrMessage",
						type = "string",
					}
				},
				resourceURI=config.icc_flow_webservice_uri,
				requestMethod="POST",
				requestMessageType="soap",
				soapAction="#ExecuteDirect2",
				requestOperation="ExecuteDirect2",
				
				requestNamespace="urn:MiddleWareWS_SOAPService",
				responseMessageType="text/xml",
				requestXSLT="",
				responseXSLT=built_in_XSLT_executeDirect2ToTweetyRS
			},
			delete={
				enabled= true,
				inputParams={
					{
						name = "bstrMessage",
						type = "string",
					}
				},
				resourceURI=config.icc_flow_webservice_uri,
				requestMethod="POST",
				requestMessageType="soap",
				soapAction="#ExecuteDirect2",
				requestOperation="ExecuteDirect2",
				
				requestNamespace="urn:MiddleWareWS_SOAPService",
				responseMessageType="text/xml",
				requestXSLT="",
				responseXSLT=built_in_XSLT_executeDirect2ToTweetyRS
			},
			store={
				enabled= true,
				inputParams={
					{
						name = "bstrMessage",
						type = "string",
					}
				},
				resourceURI=config.icc_flow_webservice_uri,
				requestMethod="POST",
				requestMessageType="soap",
				soapAction="#ExecuteDirect2",
				requestOperation="ExecuteDirect2",
				requestNamespace="urn:MiddleWareWS_SOAPService",
				responseMessageType="text/xml",
				requestXSLT="",
				responseXSLT=built_in_XSLT_executeDirect2ToTweetyRS
			}	
		}
	});
	
	function self:callws (data,context,opfn,operationDescription)
		local hdata = {}
		local session = tweetyio.session();
		if not session.wsresponses then session.wsresponses = {} end
		for _,param in ipairs(data) do
			hdata[param.name]=param;
		end
		local _rowid
		if hdata._rowid then
			_rowid= tonumber(hdata._rowid.value)
			hdata._rowid.value = nil; -- para no mandarlo al ws
		end
		

	
		operationDescription.requestMessageType = "text/xml"
		operationDescription.responseMessageType="text/xml"
		operationDescription.responseXSLT="<xsl:stylesheet version=\"1.0\"\n\txmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n\txmlns:icc=\"RepositorioXml\"\n\t>\n<xsl:output method=\"xml\"/>\n\n\n\t<xsl:template match=\"/\">\n\t\t<xsl:if test=\"not(icc:RESPUESTA_MW)\">\n\t\t\t<xsl:call-template name=\"cpy\"/>\n\t\t</xsl:if>\n\t\t<xsl:for-each select=\"/icc:RESPUESTA_MW/icc:BODY/icc:RESPUESTA\">\n\t\t\t<xsl:element name=\"response\">\n\t\t\t\t<xsl:element name=\"status\">\n\t\t\t\t\t<xsl:element name=\"value\">false</xsl:element>\n\t\t\t\t\t<xsl:element name=\"message\">\n\t\t\t\t\t\t<xsl:value-of select=\"icc:DESCRIPCION\"/>\n\t\t\t\t\t</xsl:element>\n\t\t\t\t\t<xsl:element name=\"nativeCode\">\n\t\t\t\t\t\t<xsl:value-of select=\"icc:CODIGO\"/>\n\t\t\t\t\t</xsl:element>\n\t\t\t\t</xsl:element>\n\t\t\t</xsl:element>\n\n\t\t</xsl:for-each>\n\t</xsl:template>\n\t<xsl:template name=\"cpy\">\n\t\t<xsl:copy-of select=\"/\" />\n\t</xsl:template>\n</xsl:stylesheet>\n\n"
		if not operationDescription.requestXSLT or operationDescription.requestXSLT=="" then
			operationDescription.requestXSLT = built_in_XSLT_IXMLToFlowRequest
		end
		context.idOperativa = operationDescription.idOperativa
		
		local status,message = self:buildRequestBody(data,context,operationDescription)

		if status then
			LogInfo("REQUEST TO INCONCERT WEBSERVICE\n%s",message);
			status,message =opfn({
					{name="bstrMessage",value=message}
				},context);
			if status then
				message.rows = message.rows or {}
				message.rows[1] = message.rows[1] or {}
				message.rows[1][1] = message.rows[1][1] or ""
				
				
				
				LogInfo("INCONCERT RESPONSE\n%s",message.rows[1][1]);
				return self:parseResponse(message.rows[1][1],context,operationDescription,_rowid);
				
			else
				return status,message -- fail
			end
		else
			session.wsresponses[self.name]=nil
			return status,message -- fail
		end
		
	end
	function self:get(data,context)
		return self:callws(data,context or {},
			function(param,context)
				return webservice:get(param,context)
			end,self.description.retrieve);
	end
	function self:update(data,context)
		return self:callws(data,context or {},
			function(param,context)
				return webservice:update(param,context)
			end,
			self.description.update);
	end
	function self:save(data,context)
		LogInfo("Flow webservice store");
		return self:callws(data,context or {},
			function(param,context)
				return webservice:save(param,context)
			end,
			self.description.store);
	end
	
	function self:delete(data,context)
		return self:callws(data,context,
			function(param,context)
				return webservice:save(param,context)
			end,
			self.description.delete
		);
	end
	return self
end
