/*jslint  evil:true */
/*global $, jQuery window

inconcert
*/

var SOA_URI = "/inconcert/apps/allegro/soaintegration";

var g_callbackSuccess = null;
var g_callbackError = null;

var responseCallback = {code : undefined,
						internalCode : undefined,
						message : undefined,
						data : undefined,
						func : undefined};

function IsTypeOf(obj, key) {
 return((obj.constructor.toString().indexOf(key) === -1)?false:true);
}

function IsNumeric(sText) {
	return((sText.match(/^\d+$/) === null)?true:false);
}

String.prototype.trim = function(){ return this.replace(/^\s+|\s+$/g,''); };


///////////////////////////////////////////////////////////////////////////////////////////
//function ConvertToUtc
function ConvertToUtc(originalDate, originalTimezone) {
    var utc = new Date(originalDate.getTime() - (originalTimezone.getTimezone() * 3600000) - (originalTimezone.getTimezoneMinutes() * 60000));
    return utc;
}

///////////////////////////////////////////////////////////////////////////////////////////
//function ProcessingXmlResponse
function ProcessingXmlResponse(sRet, code, func, data, messageOK, messageFail, callbackSuccess, callbackError){

	var success = (callbackSuccess === undefined)?g_callbackSuccess:callbackSuccess;
	var error = (callbackError === undefined)?g_callbackError:callbackError;

	if (sRet === "1" || sRet === "true"){
		if(typeof(success) === "function") {
			responseCallback.code = code;
			responseCallback.internalCode = sRet;
			responseCallback.func = func;
			responseCallback.data = data;
			responseCallback.message = messageOK;
			success(responseCallback);
		}
	}
	else {
		if(typeof(error) === "function") {
			responseCallback.code = code;
			responseCallback.internalCode = sRet;
			responseCallback.func = func;
			responseCallback.data = data;
			responseCallback.message = messageFail;
			error(responseCallback);
		}
	}
}
				
///////////////////////////////////////////////////////////////////////////////////////////
//function ProcessingResponse
function ProcessingResponse(response, callbackSuccess, callbackError){

	var success = (callbackSuccess === undefined)?g_callbackSuccess:callbackSuccess;
	var error = (callbackError === undefined)?g_callbackError:callbackError;

	responseCallback.code = response.code;
	responseCallback.internalCode = response.internalCode;
	responseCallback.func = response.func;
	responseCallback.data = response.data;
	responseCallback.message = response.message;
			
	if (response.internalCode === 1){
		if(typeof(success) === "function") {
			success(responseCallback);
		}
	}
	else {
		if(typeof(error) === "function") {
			error(responseCallback);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////
//function ProcessingErrorResponse
function ProcessingErrorResponse (response, statusText,  func, callbackError){

	var error = (callbackError === undefined)?g_callbackError:callbackError;
	if(typeof(error) === "function") {
		responseCallback.code = (response.status === undefined)?(statusText === "timeout")?408:-1:response.status;
		responseCallback.internalCode = 0;
		responseCallback.func = func;
		responseCallback.data = undefined;
		responseCallback.message = (response.statusText === undefined)?statusText:response.statusText;
		error(responseCallback);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////
//Public Object SOAIntegration
function SOAIntegration(callbackSuccess, callbackError) {

	///////////////////////////////////////////////////////////////////////////////////////////
	//Public Method Get Video Call Session Id
	this.GetVideoStreamingServiceIp = function (vcc, callbackSuccess, callbackError){
	$.ajax({
			url: SOA_URI + "/get_videostreaming_serviceip/" + vcc,
			type: 'GET',
			timeout: 60000,
			dataType: "json",
			success: function(response) {
									response.func = "get_videostreaming_serviceip";
									ProcessingResponse(response, callbackSuccess, callbackError);
				},
			error: function(response, statusText) {
									ProcessingErrorResponse(response, statusText, "GetVideoStreamingServiceIp", callbackError);
				}
			});
			
	};
	
	///////////////////////////////////////////////////////////////////////////////////////////
	//Public Method Get Video Call Session Id
	this.GetVideoStreamingSessionId = function (vcc, callbackSuccess, callbackError){
	$.ajax({
			url: SOA_URI + "/get_videostreaming_sessionid/" + vcc,
			type: 'GET',
			timeout: 60000,
			dataType: "json",
			success: function(response) {
									response.func = "get_videostreaming_sessionid";
									ProcessingResponse(response, callbackSuccess, callbackError);
				},
			error: function(response, statusText) {
									ProcessingErrorResponse(response, statusText, "GetVideoStreamingSessionId", callbackError);
				}
			});
			
	};
	
	///////////////////////////////////////////////////////////////////////////////////////////
	//Public Method manual CallBack
	this.ManualCallBack = function (vcc, campaignId, clientName, phoneToCall, extraData, callbackSuccess, callbackError){
	
		//Valido que los datos enviados no sean vacios.
		if (vcc === "" || vcc === undefined) {
			var response = {"code":-1,"internalCode":-6,"message":"vcc is empty."};
			ProcessingResponse(response, callbackSuccess, callbackError);
		}
		
		if (campaignId === "" || campaignId === undefined) {
			var response = {"code":-1,"internalCode":-6,"message":"CampaignId is empty."};
			ProcessingResponse(response, callbackSuccess, callbackError);
		}
		
		if (phoneToCall === "" || phoneToCall === undefined) {
			var response = {"code":-1,"internalCode":-6,"message":"PhoneToCall is empty."};
			ProcessingResponse(response, callbackSuccess, callbackError);
		}
		
		var xml = '<data>' +
					'<vcc>' + vcc  + '</vcc>'   +
					'<campaignid>' + campaignId  + '</campaignid>'   +
					'<clientname>' + clientName  + '</clientname>'   +
					'<phonetocall>' + phoneToCall + '</phonetocall>';

		if (extraData)  {
			for (var iuff in extraData) {
				if (iuff) {
					xml = xml + '<extradata>';
					xml = xml + '<name>' + iuff + '</name>';
					xml = xml + '<value>' + extraData[iuff] + '</value>';
					xml = xml + '</extradata>';
				}
			}
		}
		xml = xml + '</data>';

		$.ajax({
			url: SOA_URI + "/manual_callback/",
			type: 'POST',
			contentType: "application/json",
			data: xml,
			timeout: 60000,
			dataType: "json",
			success: function(response) {
									response.func = "manual_callback";
									ProcessingResponse(response, callbackSuccess, callbackError);
				},
			error: function(response, statusText) {
									ProcessingErrorResponse(response, statusText, "ManualCallBack", callbackError);
				}
			});
	};
	

	///////////////////////////////////////////////////////////////////////////////////////////
	//Public Method Dialer CallBack
	this.DialerCallBack = function (vcc, campaignId, importId, batchId, contactId, phoneType, countryId, areaId, number, contactName, contactPriority, extraData, scheduleDate, timeZone, agentId, batchPriority, callbackSuccess, callbackError, isProgressiveType){
	
		var isVip = 0;
		var isClient = 0;
		var zip = "-1";
		var extension = "";
		var contactPriority = (contactPriority === undefined)?0:contactPriority;
		var batchPriority = (batchPriority === undefined)?1:batchPriority;
		var agentId = (agentId === undefined)?'':agentId;
		var isProgressiveType = (isProgressiveType === undefined)?0:isProgressiveType;
		
		var xml = '<data>' + 
					'<vcc>' + vcc + '</vcc>' +
					'<campaignid>' + campaignId + '</campaignid>' +
					'<importid>' + importId + '</importid>' +
					'<batchid>' + batchId + '</batchid>' +
					'<batchPriority>' + batchPriority + '</batchPriority>' +
				'</data>' +
				'<contact>';
				
		if (contactId !== "" && contactId !== undefined) {
					xml = xml  + '<contactId>' + contactId + '</contactId>';
		}
		xml = xml + '<name>' + contactName + '</name>' +
					'<accountOfficer />' +
					'<accountGroup />' +
					'<category />' +
					'<campaign />' +
					'<VIP>' + isVip + '</VIP>' +
					'<IsClient>' + isClient + '</IsClient>' +
					'<lastManagementResult />' +
					'<agentId>' + agentId + '</agentId>' +
					'<newPriority>' + contactPriority + '</newPriority>' +
					'<isProgressiveType>' + isProgressiveType + '</isProgressiveType>'
		
		if (scheduleDate !== undefined && scheduleDate !== "" && isNaN(scheduleDate.valueOf()) === false) {
		
			var month = scheduleDate.getMonth() + 1;
			
			xml = xml + '<year>' + scheduleDate.getFullYear() + '</year>' +
						'<month>' + month + '</month>' +
						'<day>' + scheduleDate.getDate() + '</day>' +
						'<hour>' + scheduleDate.getHours() + '</hour>' +
						'<minute>' + scheduleDate.getMinutes() + '</minute>';
		}
		
		if (timeZone !== undefined && timeZone !== "") {
			xml = xml + '<timeZone>' + timeZone + '</timeZone>';
		}			
		xml = xml + '<phones>' + 
						'<phone>' + 
							'<phoneType>' + phoneType + '</phoneType>' +
							'<countryId>' + countryId + '</countryId>' +
							'<areaId>' + areaId + '</areaId>' +
							'<ZIP>' + zip + '</ZIP>' +
							'<phoneNumber>' + number + '</phoneNumber>' +
							'<phoneExtension>' + extension + '</phoneExtension>' +
							'<importName>Telefono</importName>' +
						'</phone>' + 
					'</phones>';
		
		if (extraData) {
			xml = xml + '<data>';
			for (var iuff in extraData) {
				if (iuff) {
					xml = xml + '<item>' +
									'<name>' + iuff + '</name>' +
									'<value>' + extraData[iuff] +'</value>' +
									'<index>1</index>' +
								'</item>';
				}
			}
			xml = xml + '</data>';

			}
		xml = xml + '</contact>';
		
		$.ajax({
			url: SOA_URI + "/dialer_callback/",
			type: 'POST',
			contentType: "application/json",
			data: xml,
			timeout: 60000,
			dataType: "json",
			success: function(response) {
								response.func = "dialer_callback";
								ProcessingResponse(response, callbackSuccess, callbackError);
				},
			error: function(response, statusText) {
								ProcessingErrorResponse(response, statusText, "DialerCallBack", callbackError);
				}
			});
	};
	
	///////////////////////////////////////////////////////////////////////////////////////////
	//Public Method RecognizePhone
	this.RecognizePhone = function (country, area, number, extension, callbackSuccess, callbackError){

		if (String(extension).trim().length >0){
			number = number + "," + String(extension).trim();
		}
		var xml = '<phone>' +
							'<country>' + country + '</country>' +
							'<area>' + area + '</area>' +
							'<number>' + number + '</number>' +
							'</phone>';
	$.ajax({
		url: SOA_URI + "/recognize_phone/",
		type: 'POST',
		contentType: "text/json",
		data: xml,
		timeout: 60000,
		dataType: "json",
		success: function(response) {
							response.func = "recognize_phone";
							ProcessingResponse(response, callbackSuccess, callbackError);
			},
		error: function(response, statusText) {
							ProcessingErrorResponse(response, statusText, "RecognizePhone", callbackError);
			}
		});
	};

	///////////////////////////////////////////////////////////////////////////////////////////
	//Public Method ExecuteFlowState
	this.ExecuteFlowState = function (vcc, state, extraData, callbacks){
	
		var res;
		var xml = '<data>' + 
					'<vcc>' + vcc + '</vcc>' +
					'<state>' + state + '</state>';

		if (extraData)  {
			for (var iuff in extraData) {
				if (iuff) {
					xml = xml + '<extradata>';
					xml = xml + '<name>' + iuff + '</name>';
					xml = xml + '<value>' + extraData[iuff] + '</value>';
					xml = xml + '</extradata>';
				}
			}
		}
		xml = xml + '</data>';
		
		$.ajax({
			url: SOA_URI + "/execute_flow_state/",
			type: 'POST',
			contentType: "application/json",
			data: xml,
			timeout: 60000,
			dataType: "json",
			async:callbacks!==undefined,
			success: function(response) {
					res = response;
					response.func = "execute_flow_state";
					if(callbacks){
						ProcessingResponse(response, callbackSuccess, callbackError);
					}
				},
			error: function(response, statusText) {
					res = false;
					if(callbacks){
						ProcessingErrorResponse(response, statusText, "ExecuteFlowState", callbackError);
					}
				}
			});
	return res;
	};
	
	if(typeof(callbackSuccess) === "function") {
		g_callbackSuccess = callbackSuccess;
	}

	if(typeof(callbackError) === "function") {
		g_callbackError = callbackError;
	}
}

