
tweety_modules_prefix = "";--apps.webdesigner."
local mrequire = require
LogDebug = function (...)
end
LogError = function (...)
end


require = function (mname)
--	print("mname",mname)
	local pre ={
		['inconcert.orbit.application']=true;
		['luasql.inconcertPool']={
			inconcertPool = function() end
		};
		['xml.ltxml']=true;
		['luaxslt']=true;
	}
	return pre[mname] or mrequire(mname)
end

package.preload['inconcert.orbit.application']=true
inconcert = {
	session={
	},
	orbit ={
		application = {
			Decorate=function() end;
		}
	},
	authUser = {
		virtualContactCenter="designer",
		userName="test",
		timezone={
			offset=-3
		}

	}
}

local _;
_ = {
	each = function(tbl, iterator)
		for k,v in pairs(tbl) do
			if iterator(v, k) == false then
				return false;
			end
		end
		return true;
	end,
	map = function(tbl, iterator)
		local result = {};
		_.each(tbl, function(v, k)
			table.insert(result, iterator(v, k));
		end);
		return result;
	end,
	reject = function(tbl, iterator)
		if type(iterator) ~= "function" then
			local toReject = iterator;
			iterator = function(v)
				return v == toReject;
			end
		end
		local result = {};
		_.each(tbl, function(v, k)
			if not iterator(v, k) then
				table.insert(result, v);
			end
		end);
		return result;
	end,
	contains = function(tbl, item)
		for _,v in ipairs(tbl) do
			if v == item then
				return true
			end
		end
		return false
	end
};

local config = require "config"
local tweetyio = require "tweetyio"

tweetyio:set("filesystem")
local basepath = "/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner"
config.initialize({},basepath);
local application = require "application"
local cassandra = require "lua_cassandra"
local summarizer_ds = require "icc_summarizer_ds"
local reporter  = require "reporter"
local manage = require "reporter.manage"

summarizer_ds.old_new = summarizer_ds.new
summarizer_ds.new = function (args)
	self = summarizer_ds.old_new(args)
	local initialized=false
	local function initialize()
		LogDebug("SUMMARIZER DS Initialize CLUSTER %s",config.cluster);
		summarizerKS = cassandra:CassandraConnection("SummarizerData")
		return true;

	end
	local function buildReportConfig(dsdata,outstream)
		local queryData;
		local tbinsert = table.insert;
		if outstream.type == "summary" then
			-- completamos info necesaria para las funciones base

			queryData = {
				category = "Custom",
				sliceSize= outstream.description.sliceSize or "Day",
				filter={},
				indicators={},
				columnDetails={}
			}
			if (dsdata.description.dataType or "cti") == "survey" then
				queryData.surveyProject = self.appName
			else
				queryData.ctiProject = self.appName
			end
			local cut_key = {self.appName,dsdata.name,outstream.id}

			queryData.cut = table.concat(cut_key,".");

			for __,indicator in ipairs(outstream.description.indicators) do
				if indicator.name == "Slice" and indicator.cutID then
					queryData.cut = indicator.cutID
				end
				if indicator.name == "Slice" or indicator.indicatorType=="cut" or indicator.indicatorType == "indicator" or (indicator.indicatorSource == "fieldData" and indicator.fieldDataOperation == "avg") then
					if indicator.name == "Slice" then
						--table.insert(queryData.indicators,indicator.id);
					elseif indicator.indicatorType=="cut" then
						--table.insert(queryData.indicators,indicator.cutFieldName);
					elseif  indicator.external  then -- or (indicator.indicatorSource == "fieldData" and indicator.fieldDataOperation == "avg") then
						table.insert(queryData.indicators,indicator.id);
					else
						table.insert(queryData.indicators,self.appName .. "." .. dsdata.name .. "." .. indicator.id)
					end
				end
			end

			for __,indicator in ipairs(outstream.description.indicators) do

				if indicator.external or (indicator.indicatorSource == "cutField" and indicator.cutFieldName) or (indicator.indicatorSource == "fieldData" and indicator.fieldName) or indicator.indicatorSource == "recordCount" then
					if indicator.indicatorType == "cut" or  indicator.external then
						-- no va nada
						if indicator.name ~= "Slice" then
							if indicator.external then
								queryData.columnDetails[indicator.id]={
									columnName=indicator.name
								}

							else
								if indicator.cutFieldName then
									if string.sub(indicator.cutFieldName,1,11)=="Interaction" then
										local fieldName = string.sub(indicator.cutFieldName,13);
										queryData.columnDetails[fieldName]={
											columnName=fieldName;
										}

									else
										queryData.columnDetails[dsdata.description.dataType .. "." .. indicator.cutFieldName]={
											columnName= indicator.name
										}
									end
								end
							end
						else
							queryData.columnDetails['Slice']={
								columnName=indicator.name
							}
						end

					else
						if indicator.indicatorSource == "fieldData" and indicator.fieldDataOperation == "avg" then
							queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id]={
								columnName=indicator.name,
								composite = {indicators={},formula=""}
							}
							table.insert(queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id].composite.indicators,self.appName .. "." .. dsdata.name .. "." .. indicator.id ..  "."  ..  "__sum_of_" .. indicator.fieldName);
							table.insert(queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id].composite.indicators,self.appName .. "." .. dsdata.name .. "." .. indicator.id ..  "." .. "__count_of_" .. indicator.fieldName);
							queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id].composite.formula = 'return base["'.. self.appName .. "." .. dsdata.name .. "." .. indicator.id .. "." .. "__sum_of_" .. indicator.fieldName .. '"] / base["' .. self.appName .. "." .. dsdata.name .. "." .. indicator.id .. "." .. "__count_of_" .. indicator.fieldName .. '"]'
							-- el formato viene de cuando se determina el tipo del indicador base del composite "sum" que graba el indicatorType para usar aca
							queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id].composite.format = indicator.indicatorType;
						else
							if indicator.indicatorSource == "fieldData" and indicator.fieldDataOperation == "min" then
								queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id]={
									columnName=indicator.name,
									min=true
								}
							else
								queryData.columnDetails[self.appName .. "." .. dsdata.name .. "." .. indicator.id]={
									columnName=indicator.name
								}
							end
						end
					end
				end
			end
		else
		end
		return queryData

	end

	function self:cleanUnused(dsdata)

		local status,result
		local vccName = runtime.getCurrentVCCName();
		-- QUe deberia borrar
		local toClean = {}
		for __,outstream in ipairs(self.description.outstreams or {}) do
			if outstream.type == "summary" then
				local cut_key = {self.appName,self.name ,outstream.id}
				local isExternalCut = false;
				local sliceInd;
				for __,indicator in ipairs(outstream.description.indicators or {}) do
					if indicator.id == "Slice" then
						sliceInd = indicator;
						if indicator.cutID then
							isExternalCut=true;
						end
					end
				end
				if not isExternalCut then
					toClean["cut:" .. table.concat(cut_key,".")]={id=table.concat(cut_key,"."),type="cut"}
				end
				local t = outstream.description.indicators or {};
				local outstream_indicators = {}
				-- recorre insertando los indicadores y cuando encuentra un promedio inserta uno para sumar las ocurrencias y otro para sumar los valores
				-- Ya aprovecha y saltea los cutfields copiando solamente recordcount y fieldData

				for __,indicator in ipairs(t) do
					if indicator.indicatorType == "indicator" and indicator.indicatorSource == "recordCount" or indicator.indicatorSource == "fieldData" then
						if indicator.fieldDataOperation == "avg" then
							local ind = {}
							ind.name=indicator.id .. "." .. "__sum_of_" .. indicator.fieldName;
							ind.id = ind.name;

							table.insert(outstream_indicators,ind);
							ind = {};
							ind.name=indicator.id .. "." .. "__count_of_" .. indicator.fieldName;
							ind.id = ind.name;
							table.insert(outstream_indicators,ind);
						else
							table.insert(outstream_indicators,indicator)
						end
					end
				end
				for __,indicator in ipairs(outstream_indicators) do
					local key = self.appName .. "." .. self.name .. "." .. indicator.id
					toClean["ind:" .. key] = {id=key,type="ind"}
				end


			else -- details filter and report
				toClean['filter:' .. self.appName .. "." .. outstream.id]={id=self.appName .. "." .. outstream.id,type="filter"}

			end
		end
		-- que va a crear nuevo
		for __,outstream in ipairs(dsdata.description.outstreams or {}) do
			if outstream.type == "summary" then
				local cut_key = {self.appName,dsdata.name ,outstream.id}
				local isExternalCut = false;
				local sliceInd;
				for __,indicator in ipairs(outstream.description.indicators or {}) do
					if indicator.id == "Slice" then
						sliceInd = indicator;
						if indicator.cutID then
							isExternalCut=true;
						end
					end
				end
				if not isExternalCut then
					toClean["cut:" .. table.concat(cut_key,".")]=nil;
				end
				local t = outstream.description.indicators or {};
				local outstream_indicators = {}
				-- recorre insertando los indicadores y cuando encuentra un promedio inserta uno para sumar las ocurrencias y otro para sumar los valores
				-- Ya aprovecha y saltea los cutfields copiando solamente recordcount y fieldData

				for __,indicator in ipairs(t) do
					if indicator.indicatorType == "indicator" and indicator.indicatorSource == "recordCount" or indicator.indicatorSource == "fieldData" then
						if indicator.fieldDataOperation == "avg" then
							local ind = {}
							ind.name=indicator.id .. "." .. "__sum_of_" .. indicator.fieldName;
							ind.id = ind.name

							table.insert(outstream_indicators,ind);
							ind = {};
							ind.name=indicator.id .. "." .. "__count_of_" .. indicator.fieldName;
							ind.id = ind.name
							table.insert(outstream_indicators,ind);
						else
							table.insert(outstream_indicators,indicator)
						end
					end
				end
				for __,indicator in ipairs(outstream_indicators) do
					local key = self.appName .. "." .. dsdata.name .. "." .. indicator.id
					toClean["ind:" .. key] = nil;
				end
			else -- details filter and report
				toClean['filter:' .. self.appName .. "." .. outstream.id]=nil;
			end
		end
		local deleteList = {}
		for __,v in pairs(toClean) do
			table.insert(deleteList,v)
		end
		table.sort(deleteList,
			function(a,b)
				return b.type == "cut" and a.type == "ind"
			end
		)
		for __,v in ipairs(deleteList) do
			status,result = pcall(
				function()
					if v.type == "ind" then

						LogDebug("Deleting indicator %s",v.id);
						manage.deleteSummaryIndicator(summarizerKS,vccName,v.id);

					elseif v.type == "cut" then
						LogDebug("Deleting cut %s",v.id);
						manage.deleteCut(summarizerKS,vccName,v.id);
					elseif v.type == "filter" then
						LogDebug("Deleting filter %s",v.id);
						manage.deleteFilter(summarizerKS,vccName,v.id);
					end
				end
			)
			if not status then
				return status,messages.messageKey('database_error',{description=result})
			end
		end
		return true,nil
	end

	function self:cleanReports()
		local status,result
		local vccName = runtime.getCurrentVCCName();
		for __,outstream in ipairs(self.description.outstreams or {}) do
			if outstream.type == "summary" then
				status,result = pcall(function()
					LogDebug("Deleting summary report %s",self.appName .. "." .. outstream.name);
					manage.deleteReport(summarizerKS,vccName,self.appName .. "." .. outstream.name,true);
				end)
				if not status then
					return status,messages.messageKey('database_error',{description=result})
				end
			else -- details report
				status,result = pcall(function()
					LogDebug("Deleting details report %s",self.appName .. "." .. outstream.name);
					manage.deleteReport(summarizerKS,vccName,self.appName .. "." .. outstream.name,true);
				end)
				if not status then
					return status,messages.messageKey('database_error',{description=result})
				end

			end
		end
		return true,nil
	end
	local function iff(cond,trueres,falseres)
		if cond then return trueres else return falseres end
	end
	function self:configure(dsdata)
		LogDebug = function (...)
			print(string.format(...))
		end
		LogError = function (...)
			print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> " .. string.format(...))
		end

		print("MI CONFIGURE");
		local interactionColumns ={
			['Interaction.AttentionTime']={type='duration'},
			['Interaction.EndDate']={type='datetime'},
			['Interaction.StartDate']={type='datetime'},
			['Interaction.WaitingTime']={type='duration'},
			['Interaction.WrapupTime']={type='duration'},
			['Interaction.DurationTime']={type='duration'}
		}
		local comparatorMap = {
			['==']='=',
			['!=']='<>'
		}
		local chash={}
		local indicators={}
		local sliceInd;
		local status,result = initialize();
 		local vccName = runtime.getCurrentVCCName();
		-- borra todas las dimensiones que tiene
		for __,param in ipairs(self.description.columns) do
			if not param.hidden then
				LogDebug("deleteDimension %s, %s",vccName,self.appName .. "." .. self.name .. "." .. param.name);
				manage.deleteDimension(summarizerKS,vccName,self.appName .. "." .. self.name .. "." .. param.name);
			end
		end
		for __,param in ipairs(dsdata.description.columns) do
			if not param.hidden then

				local dimension = {
					scope=dsdata.description.dataType or "cti";
					type=param.type=="integer" and "number" or param.type,
					name=param.name,
					projectId=self.appName,
					requiredFieldName=(dsdata.description.dataType or "cti") .. '.__SID',
					requiredFieldValue=self.appName .. "_" .. dsdata.name,
					sourceName=dsdata.name
				};
				LogDebug("setDimension %s, %s,%s",vccName,self.appName .. "." .. self.name .. "." .. param.name,json.encode(dimension,true));
				manage.setDimension(summarizerKS, vccName,self.appName .. "." .. self.name .. "." .. param.name,dimension);
			end
		end

		if status then
			status,result = self:cleanReports()
		end
		if not status then
			return status,result
		end
		dsdata.description.dataType = dsdata.description.dataType or "cti";
		---------------------------------------------------------------------------------------------------------------
		LogDebug("NewName %s OldName %s",dsdata.name,self.name);
		for __,column in ipairs(dsdata.description.columns) do
			chash[column.name] = column;
		end

		for __,outstream in ipairs(dsdata.description.outstreams or {}) do
			local cuts = {}
			LogDebug("Outstream %s - %s",outstream.name,outstream.type);
			if outstream.type == "summary" then
				local cut = {
					columns={},
					filter={},
					metadata = {
						columns={},
						filter={},
					},
					[dsdata.description.dataType.."Project"] = self.appName
				}
				LogDebug("appName %s",tostring(self.appName))
				LogDebug("Name %s",tostring(dsdata.name))
				LogDebug("ID %s",tostring(outstream.id))


				local cut_key = {self.appName,dsdata.name ,outstream.id}
				for __,indicator in ipairs(outstream.description.indicators or {}) do
					if indicator.id == "Slice" then
						sliceInd = indicator;
						if indicator.cutID then
							cut_key = {indicator.cutID}
							cut.external = true;
						end
					end
					if indicator.indicatorType=="cut" and indicator.cutFieldName then
						if indicator.cutFieldName=="Slice" then
							table.insert(cut.columns, "Slice");
							table.insert(cut.metadata.columns, { id = "Slice" });
						elseif string.sub(indicator.cutFieldName,1,11)=="Interaction" then
							table.insert(cut.columns, string.sub(indicator.cutFieldName, 13));
							table.insert(cut.metadata.columns, {
								id = string.sub(indicator.cutFieldName, 13)
							});
						else
							table.insert(cut.columns,dsdata.description.dataType .. "." .. indicator.cutFieldName);
							table.insert(cut.metadata.columns, {
								id = self.appName ..".".. self.name ..".".. indicator.cutFieldName;
							});
						end

					end
				end
				local detailType = "Interaction";
				for __,column in ipairs(dsdata.description.columns) do
				--	LogDebug("Column Name %s",column.name)

					if column.name == "Agent" and column.cutsID and column.cutsID[table.concat(cut_key,".")] then
						detailType = "InteractionAgent"
					end
				end
				-- este es el caso en que se corta por un campo del combo que es campo de la interaccion
				for __,indicator in ipairs(outstream.description.indicators) do
					if indicator.indicatorType == "cut" and indicator.cutFieldName=="Interaction.Agent" then
						detailType = "InteractionAgent"
					end
				end

				-- este es el caso en que se filtra por un campo del combo que es campo de la interaccion
				for __,segment in ipairs(outstream.description.filters[1].criteria) do
					if segment.column == "Interaction.Agent" and segment.expr then
						detailType = "InteractionAgent"
					end
				end


				LogDebug("---------------------- Detail type for indicators and cuts %s--------------",detailType)
				if sliceInd.cutID then -- es un corte externo lo recuperamos y pisamos la basura que tenemos
					cut = manage.getCut(summarizerKS,self.inconcert_authUser.virtualContactCenter,sliceInd.cutID);
					if not cut then
						return false,messages.messageKey('database_error',{description="Invalid external cut " .. sliceInd.cutID})
					end
					cut.external = true;
				end
				local filter = (outstream.description.filters or {{}})[1]
				if not cut.external then
					cut.scope = detailType --dsdata.description.dataType
					--cut.sub_scope = self.appName
					cut.name = self.appName .. ".SummaryFilter"
					for __,segment in ipairs(filter.criteria or {}) do
						if segment.column and segment.expr and (segment.column ~= "DateFrom" and segment.column ~= "DateTo") then
							if string.sub(segment.column,1,11)=="Interaction" then
								table.insert(cut.filter,string.sub(segment.column,13));
								table.insert(cut.metadata.filter, { id = string.sub(segment.column,13) });
							else
								table.insert(cut.filter, dsdata.description.dataType .. "." .. segment.column);
								table.insert(cut.metadata.filter, {
									id = self.appName ..".".. self.name ..".".. segment.column;
								});
							end
						end
					end
					if #cut.filter > 0 then
						cut.name = cut.name .." (".. table.concat(cut.filter, ",")..")";
					elseif #cut.columns > 0 then
						local withoutSlice = _.map(_.reject(cut.columns, "Slice"), function(item)
							local idx = string.find(item, "%.") or 0;
							return idx > 0 and item:sub(idx+1) or item;
						end);
						if #withoutSlice > 0 then
							cut.name = cut.name .." (".. table.concat(withoutSlice, ",")..")";
						end
					end
					if not _.contains(cut.filter, "VCC") then
						table.insert(cut.filter, "VCC")
					end
				end
				if #cut.columns > 0 or sliceInd.cutID then
					cuts[table.concat(cut_key,".")] = cut;
				end

				LogDebug("Cuts ==>\n %s \n===================================================",json.encode(cuts,true));
				for ID, cut in pairs(cuts) do
					status,result = pcall(function()
						if not cut.external then
							manage.setCut(summarizerKS,cut,self.inconcert_authUser.virtualContactCenter,ID);
						end
					end)
					if not status then
						return status,messages.messageKey('database_error',{description=result})
					end
				end

				local indicators = {}
				local requiredFieldsExtra = {}
				local requiredFieldsMapping = {}

				local function parseExpression(expression)

					local function unquote(value)
						return string.match(value, '^\"(.+)\"') or value;
					end

					local validComparators = {
						["=="] = "=",
						["~="] = "<>",
						[">" ] = ">",
						["<" ] = "<",
						[">="] = ">=",
						["<="] = "<="
					};

					-- split the expression into words
					local words = {};
					for word in expression:gmatch('[^ ]+') do
						table.insert(words, word);
					end

					local idx = 1
					local fields = {}

					while idx <= #words do

						local operator = words[idx+3]
						if operator and operator ~= "and" then
							LogError("UNSUPPORTED EXPRESSION %s", expression)
							return nil;
						end

						local field = {
							dimension  = words[idx],
							comparator = words[idx+1],
							value      = words[idx+2],
						};

						local validComparator = validComparators[field.comparator];
						if validComparator then
							field.comparator = validComparator
							idx = idx + 4
						else
							if field.comparator:sub(1, 2) == "==" and #field.comparator > 2 then
								field.value = field.comparator:sub(3);
								field.comparator = "=";
								idx = idx + 3;
							else
								LogError("INVALID COMPARATOR IN EXPRESSION %s - %s", expression, json.encode(field));
								return nil;
							end
						end

						field.value = unquote(field.value);

						local cleanedName = field.dimension:match("^detail%['(.+)'%]") or field.dimension
						local idx = string.find(cleanedName, "%.") or 0;
						field.dimension = idx > 0 and cleanedName:sub(idx+1) or cleanedName;
						field.dataType  = idx > 0 and cleanedName:sub(1, idx-1) or nil;
						table.insert(fields, field);
					end

					return fields;
				end

				local buildCondition = function(indicator)
					local res = {}
					table.insert(res,"local context = {");
					for __,col in ipairs(dsdata.description.columns) do
						if not col.cutID then
							table.insert(res,"\t['" .. col.name .. "'] = detail['" .. dsdata.description.dataType .. "."  .. col.name .. "'],")
						end
					end

					table.insert(res,"}");
					table.insert(res,"\tfor k,v in pairs(detail) do context[k] = v end");
					table.insert(res,"context.detail = detail");

					if indicator.dataValid == "field" and indicator.dataValidFieldOperator and indicator.dataValidFieldExpr and indicator.validFieldName and chash[indicator.validFieldName] then
						local expr = indicator.dataValidFieldExpr;
						local expr_rptmgr = expr;
						if chash[indicator.validFieldName].type == "string" or chash[indicator.validFieldName].type == "date" or chash[indicator.validFieldName].type == "datetime" then
							expr = "[[" .. indicator.dataValidFieldExpr .. "]]"
						elseif chash[indicator.validFieldName].type == "boolean" then
							if expr == "true" then
								expr = true
							else
								expr = false
							end
							expr_rptmgr = expr;
						end
						--if not interactionColumns[indicator.validFieldName] then
							requiredFieldsMapping[dsdata.description.dataType .. "." .. indicator.validFieldName]= self.appName .. "." .. dsdata.name .. "." .. indicator.validFieldName
						--end
						table.insert(
							requiredFieldsExtra,
							{
								dimension=self.appName .. "." .. self.name .. "." .. indicator.validFieldName,
								comparator=comparatorMap[indicator.dataValidFieldOperator] or indicator.dataValidFieldOperator,
								value=expr_rptmgr,
								validName= dsdata.description.dataType .. "." .. indicator.validFieldName
							}
						)
						table.insert(res,"local f = function() return " .. indicator.validFieldName .. indicator.dataValidFieldOperator .. tostring(expr) .. " end")
						table.insert(res,"setfenv(f,context)");
						table.insert(res,"if f() then ");

					elseif indicator.dataValid == "expr" and indicator.dataValidExpr then
						--assert(false,dataValidExpr)
						table.insert(res,"local f = function() return " .. indicator.dataValidExpr .. " end")
						table.insert(res,"setfenv(f,context)");
						table.insert(res,"if f() then ");

						local fields = parseExpression(indicator.dataValidExpr);
						if fields then
							LogError	("PARSE EXPRESSION %s ====>>>> %s", indicator.dataValidExpr, json.encode(fields))
							_.each(fields, function(field)
								-- dimension may be builtin
								local dimensionId = field.dimension;
								local dimensionName = field.dimension;

								-- cope with booleans, optimize
								if (field.value == "true" or field.value == "false") then
									field.value = field.value == "true"

									if field.comparator == "<>" then
										field.comparator = "=";
										field.value = not field.value
									end
								elseif (tonumber(field.value)) then
									field.value = tonumber(field.value);
								end

								local dimension = manage.getDimension(summarizerKS, "system", field.dimension);
								if not dimension then

									if _.contains({"_HasLogin", "_HasPreSurvey", "_HasPostSurvey"}, field.dimension) then
										-- special fields for survey
										dimensionId   = field.dimension:sub(2); -- map the real field
										dimensionName = dimensionId;
									else
										-- not builtin, means it belong to this project
										dimensionId   = self.appName ..".".. self.name ..".".. dimensionName -- blah
										dimensionName = (field.dataType or dsdata.description.dataType)  ..".".. dimensionName -- survey.Something
										if field.dataType and field.dataType ~= dsdata.description.dataType then
											LogError("MIXED SURVEY AND CTI %s", (self.appName .. "." .. dsdata.name .. "." .. indicator.id))

											indicator.orphanedFields = indicator.orphanedFields or {};
											table.insert(indicator.orphanedFields, {
												field = dimensionName,
												value = field.value
											});
											dimensionId = dimensionName
										end
									end
								end

								table.insert(requiredFieldsExtra, {
									dimension  = dimensionId,
									comparator = field.comparator,
									value      = field.value,
									validName  = dimensionName
								});
							end);

						else
							LogError("INVALID EXPRESSION %s indicator: %s)", indicator.dataValidExpr, (self.appName .. "." .. dsdata.name .. "." .. indicator.id) )
							os.execute('echo "' .. indicator.dataValidExpr ..'" >> conditions.txt');
							indicator.mutable = false;
						end
					else
						-- Tiene todo completo pero el chash no da nada , puede ser un campo de la interaccion lo tomamos como string
						if indicator.dataValid == "field" and indicator.dataValidFieldOperator and indicator.dataValidFieldExpr and indicator.validFieldName then
							local col = interactionColumns[indicator.validFieldName] or interactionColumns["Interaction." .. indicator.validFieldName]
							local expr;
							local expr_rptmgr;
							if col then
								if col.type == "numeric" or "duration" then
									expr = indicator.dataValidFieldExpr
									expr_rptmgr=expr;
								elseif col.type == "boolean" then
									if indicator.dataValidFieldExpr == "true" then
										expr = true
									else
										expr = false
									end
									expr_rptmgr=expr;
								else
									expr = "[[" .. indicator.dataValidFieldExpr  .. "]]"
									expr_rptmgr=indicator.dataValidFieldExpr
								end

							else	-- es un campo desconocido, nodeberia andar por aca
								expr = indicator.dataValidFieldExpr
								expr_rptmgr=expr;
							end
							table.insert(
								requiredFieldsExtra,
								{
									dimension=self.appName .. "." .. self.name .. "." .. indicator.validFieldName,
									comparator=comparatorMap[indicator.dataValidFieldOperator] or indicator.dataValidFieldOperator,
									value= expr_rptmgr,
									validName= dsdata.description.dataType .. "." .. indicator.validFieldName
								}
							)
							table.insert(res,"local f = function() return " .. indicator.validFieldName .. indicator.dataValidFieldOperator .. expr .. " end")
							table.insert(res,"setfenv(f,context)");
							table.insert(res,"if f() then ");
						else

							table.insert(res,"if true then ");
						end
					end
					return table.concat(res,"\n");
				end


				local t = outstream.description.indicators or {};
				local outstream_indicators = {}
				-- recorre insertando los indicadores y cuando encuentra un promedio inserta uno para sumar las ocurrencias y otro para sumar los valores
				-- Ya aprovecha y saltea los cutfields copiando solamente recordcount y fieldData

				for __,indicator in ipairs(t) do
					if indicator.indicatorType == "indicator" and indicator.indicatorSource == "recordCount" or indicator.indicatorSource == "fieldData" then
						if indicator.fieldDataOperation == "avg" then
							local ind = json.decode(json.encode(indicator))
							ind.fieldDataOperation = "sum";
							ind.indicator_source_ptr = indicator;  -- medio cochino pero luego cuando determinemos el indicator type de la suma
																	-- se lo ponemos a indicator para que luego al hacerl el composite en el buildreport pueda poner
																	-- el formato.
							ind.name=indicator.id .. "." .. "__sum_of_" .. indicator.fieldName;
							ind.id = ind.name

							table.insert(outstream_indicators,ind);
							ind = json.decode(json.encode(indicator))
							ind.indicatorSource = "recordCount";
							ind.name=indicator.id .. "." .. "__count_of_" .. indicator.fieldName;
							ind.id = ind.name
							table.insert(outstream_indicators,ind);
						else
							table.insert(outstream_indicators,indicator)
						end
					end
				end
				for __,indicator in ipairs(outstream_indicators) do
					indicator.mutable = true;
					local key = self.appName .. "." .. dsdata.name .. "." .. indicator.id
					local indicatorType;
					-- script para cada tipo
					local script = {}
					local groupFieldHash={}
					requiredFieldsExtra = {}
					requiredFieldsMapping={}
					for __,param in ipairs(dsdata.description.columns) do
						if not param.hidden then
							groupFieldHash[dsdata.description.dataType .. "." .. param.name]=dsdata.description.dataType .. "." .. param.name
						end
					end

					if indicator.dataValid ~= "always" then
						table.insert(script,buildCondition(indicator))
					end
					table.insert(script,[[
						table.insert(results, {
						fields = {
							VCC = detail.VCC,
							Campaign = detail.Campaign,
							Date = extras.EndDateDouble;]]);
					local fields = {}
					for __,cut in pairs(cuts) do
						for __,columnName in ipairs(cut.columns) do
							fields[columnName]=cut;
						end
						for __,columnName in ipairs(cut.filter) do
							fields[columnName]=cut;
						end
					end

					for fieldName,cut in pairs(fields) do

						local col =chash[string.sub(fieldName,1,#dsdata.description.dataType+1)] or {type="string"}
						if fieldName ~= "Slice" then --and chash[dsdata.description.dataType .. "." .. fieldName] or string.sub(fieldName,1,11)=="Interaction"  then
							groupFieldHash[fieldName]=fieldName;
							if col.type == "integer" or col.type == "numeric" or col.type == "boolean" or col.type == "duration" then
								table.insert(script,"\t\t['" .. fieldName .. "'] = tostring(detail['" .. fieldName .. "']);")
							else
								table.insert(script,"\t\t['" .. fieldName .. "'] = detail['"  .. fieldName .. "'];")
							end
						end
					end
					table.insert(script,"\t},");
					if indicator.indicatorSource == "recordCount" then
						table.insert(script,"\tincrement=1");
					elseif indicator.indicatorSource == "fieldData" and indicator.fieldName then
						if indicator.fieldDataOperation == "sum" or indicator.fieldDataOperation == "min" or indicator.fieldDataOperation == "max" then
							local col = chash[indicator.fieldName]
							if col and col.type == "duration" then
								table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  dsdata.description.dataType .. "." .. indicator.fieldName .."']) or 0)*1000))");
								indicatorType = {type="Time",multiplier=0.001};
							elseif col and col.type == "numeric" then
								table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  dsdata.description.dataType .. "." .. indicator.fieldName .."']) or 0)*1000))");
								indicatorType = {type="Decimal",multiplier=0.001};
							elseif col and col.type == "boolean" then
								-- only tested with _HasPostSurvey
								indicator.incrementBy = "default";
								local dimensionId = indicator.fieldName;
								if _.contains({"_HasLogin", "_HasPreSurvey", "_HasPostSurvey"}, dimensionId) then
									dimensionId = dimensionId:sub(2);
									table.insert(requiredFieldsExtra, {
										dimension  = dimensionId,
										comparator = "=",
										value      = true,
										validName  = dimensionId
									});
									table.insert(script,"\tincrement=1");
								else
								-- if anything else fails
									table.insert(script,"\tincrement=detail['" .. dsdata.description.dataType .. "." ..  indicator.fieldName .. "'] and 1 or 0");
								end
							elseif col then
								table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  dsdata.description.dataType .. "." .. indicator.fieldName .."']) or 0)))");
							else
								LogError("UNKNOW FIELD ".. indicator.fieldName);
								col = interactionColumns[indicator.fieldName]
								if col and col.type == "duration" then
									table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  string.sub(indicator.fieldName,13) .."']) or 0)*1000))");
									indicatorType = {type="Time",multiplier=0.001};
								elseif col and col.type == "numeric" then
									table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  string.sub(indicator.fieldName,13) .."']) or 0)*1000))");
									indicatorType = {type="Decimal",multiplier=0.001};
								elseif col and col.type == "boolean" then
									-- never happened while testing
									indicator.incrementBy = "default";
									local dimensionId = string.sub(indicator.fieldName,13);
									if _.contains({"_HasLogin", "_HasPreSurvey", "_HasPostSurvey"}, dimensionId) then
										dimensionId = dimensionId:sub(2);
										table.insert(requiredFieldsExtra, {
											dimension  = dimensionId,
											comparator = "=",
											value      = true,
											validName  = dimensionId
										});
										table.insert(script,"\tincrement=1");
									else
									-- if anything else fails
										table.insert(script,"\tincrement=detail['" .. string.sub(indicator.fieldName,13) .. "'] and 1 or 0");
									end

								elseif col then
									table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  string.sub(indicator.fieldName,13) .."']) or 0)))");
								else
									-- es un campo que se ve que no existe mas lo tomamos como si estuviera y no es de la interaccion
									table.insert(script,"\tincrement=tonumber(string.format('%d',(tonumber(detail['" ..  dsdata.description.dataType .. "." .. indicator.fieldName .."']) or 0)))");
								end
							end
						end
					end
					table.insert(script,"})")
					if indicator.dataValid ~= "always" then
						table.insert(script,"end")
					end
					local groupFields={
					}
					for k,v in pairs(groupFieldHash) do
						if interactionColumns[v] then
							table.insert(groupFields,string.sub(indicator.fieldName,13));
						else
							table.insert(groupFields,v);
						end
					end
					if not _.contains(groupFields, "VCC") then
						table.insert(groupFields, "VCC");
					end
					if not _.contains(groupFields, "Campaign") then
						table.insert(groupFields, "Campaign");
					end
					if detailType == "InteractionAgent" and not _.contains(groupFields, "Agent") then
						table.insert(groupFields, "Agent");
					end

					LogDebug("Indicator %s",key)
					indicators[key] = {
						mutable = indicator.mutable,
						description = indicator.id,
						increment = iff(indicator.indicatorSource == "recordCount" or indicator.incrementBy == "default","default",iff(interactionColumns[indicator.fieldName or "-1"],string.sub(indicator.fieldName or "",13),self.appName .. "." .. self.name .. "." .. (indicator.fieldName or ""))),
						requiredFields={
							[dsdata.description.dataType .. '.__SID'] = self.appName .. "_" .. dsdata.name;
						},
						requiredFieldsMapping=requiredFieldsMapping,
						scope = detailType, -- InteractionAgent or Interaction
						sub_scope = "CHAT", --dsdata.description.dataType, -- survey or cti
						dataType = dsdata.description.dataType,
						orphanedFields = indicator.orphanedFields,
						script = table.concat(script,"\n"),
						requiredFieldsExtra=requiredFieldsExtra,
						groupFields = groupFields
					}

					-- composite
					if indicator.fieldDataOperation ~= "avg" then
						indicators[key].composite = false
					else
						indicators[key].composite = true
					end


					if	indicator.fieldDataOperation == "min" or indicator.fieldDataOperation == "max" then
						indicators[key].MinMaxIndicator = true
					end

					LogDebug("Indicator " .. key)
					LogDebug("script:")
					LogDebug("%s",table.concat(script,"\n"));
					LogDebug("Required Fields:" .. json.encode(indicators[key].requiredFields,true));

					LogDebug("================================================================================")
					if indicators[key].MinMaxIndicator then
						LogDebug("MinMaxIndicator =" .. tostring(indicators[key].MinMaxIndicator));
					end
					if indicatorType then
						LogDebug("IndicatorType =" .. json.encode(indicatorType));
						if indicator.indicator_source_ptr then
							indicator.indicator_source_ptr.indicatorType = indicatorType; -- no tenemos otra manera de pasar esto a buildReportConfig
																			-- es lo que hay.
						end
					end

				end
				for ID, indicator in pairs(indicators) do
					LogDebug("Guardando Indicador %s ",ID);
					status,result = pcall(function()

						local index = 1;
						while index <= #indicator.requiredFieldsExtra do
							local field = indicator.requiredFieldsExtra[index];
							if field.comparator == "=" then
								indicator.requiredFields[field.validName] = field.value;
								if field.validName ~= field.dimension then
									indicator.requiredFieldsMapping[field.validName] = field.dimension;
								end
								table.remove(indicator.requiredFieldsExtra, index);
							else
								field.validName = nil; -- not needed anymore
								index = index + 1; -- not equal, skip
							end
						end

						indicator.requiredFields['Type'] = "CHAT";

						local indicatorData = {
							id			   = ID,
							mutable        = indicator.mutable,
							name		   = indicator.sub_scope ..".".. self.appName ..".".. indicator.description,
							scope          = indicator.scope, -- InteractionAgent or Interaction
							sub_scope      = indicator.sub_scope, -- CHAT
							--composite 	   = indicator.composite, -- doesn't belong here
							description    = indicator.description,

							requiredFields = indicator.requiredFields,
							script         = indicator.script,
							vcc            = vccName,
							extras         = {
								MinMaxIndicator = indicator.MinMaxIndicator
							},
							metadata       = {
								by_agent   				=  iff(detailType == "InteractionAgent",true,false),
								by_campaign     		=  true,
								requiredFieldsHidden 	=  {
									[dsdata.description.dataType .. '.__SID'] = true
								},
								increment 				= indicator.increment,
								requiredFieldsMapping   = indicator.requiredFieldsMapping,
								requiredFieldsExtra     = indicator.requiredFieldsExtra,
								groupFields				= indicator.groupFields,
								interactionType         = indicator.sub_scope, -- CHAT,
								orphanedFields          = indicator.orphanedFields
							},
							format         = indicatorType
						};

						indicatorData.metadata[indicator.dataType.. "Project"] = self.appName;

						manage.setSummaryIndicator(summarizerKS, self.inconcert_authUser.virtualContactCenter, ID, indicatorData)

					end)
					if not status then
						return status,messages.messageKey('database_error',{description=result})
					end
				end

				local reportConfig = buildReportConfig(dsdata,outstream);
				reportConfig.mutable= true;
				reportConfig.type="summary";
				reportConfig.name =  outstream.name;
				reportConfig.description = outstream.description.description or outstream.name;
				reportConfig[dsdata.description.dataType.."Project"] = self.appName

				LogDebug("REPORT :" .. self.appName .. "." .. outstream.name)
				LogDebug("%s",json.encode(reportConfig,true))
				status,result = pcall(function()
				status,result = manage.setReport(summarizerKS,reportConfig,self.inconcert_authUser.virtualContactCenter,self.appName .. "." .. outstream.name,true);
					if not status then
						error(result)
					end
				end)
				if not status then
					return status,messages.messageKey('database_error',{description=result})
				end
			elseif outstream.type == "details" then
				local detailType="Interaction"
				local mandatoryFields={}
				local optionalFields={}
				local sortFields={}
				local projectedFields={}
				local requiredFields={
					[dsdata.description.dataType .. '.__SID'] = self.appName .. "_" .. dsdata.name;
				}
				local fixColumnName = function(columnName)
					if columnName ==  "Interaction.Agent" then
						detailType = "InteractionAgent"
					end
					if string.find(string.lower(columnName),"interaction%.")==1 then
						return string.sub(columnName,13)
					elseif string.find(columnName,"%.")~= nil then
						return columnName
					else
						return dsdata.description.dataType .. "." .. columnName;
					end
				end

				local function getDimensionId(columnName)
					columnName = fixColumnName(columnName);
					local idx = columnName:find('%.');
					if idx then
						return self.appName ..".".. self.name ..".".. columnName:sub(idx + 1), columnName;
					end
					return columnName, columnName;
				end

				for __,filterSegment in ipairs((outstream.description.filters[1] or {}).criteria or {}) do
					if filterSegment.column and filterSegment.expr then
						if filterSegment.column ~= "DateFrom" and filterSegment.column ~= "DateTo" then
							local id, name = getDimensionId(filterSegment.column);
							table.insert(
								filterSegment.nullable and optionalFields or mandatoryFields,
								{ id = id, name = name }
							);
							--if filterSegment.nullable then
								--table.insert(optionalFields,fixColumnName(filterSegment.column));
							--else
								--table.insert(mandatoryFields,fixColumnName(filterSegment.column));
							--end
						end
					end
				end
				for __,orderColumn in ipairs((outstream.description.filters[1] or {}).order or {}) do
					if orderColumn.column then
						local id, name = getDimensionId(orderColumn.column);
						table.insert(sortFields, { id = id, name = name });
						--table.insert(sortFields,fixColumnName(orderColumn.column))
					end
				end

				for __,column in ipairs((outstream.description.projectedcolumns or {})) do
					local col = chash[column.id] or interactionColumns[column.id]
					if col and (col.type == "date" or col.type=="datetime") then
						table.insert(projectedFields,{name=fixColumnName(column.id), type="Date",format=""});
					elseif col and col.type == "numeric" then
						table.insert(projectedFields,{name=fixColumnName(column.id), type="Decimal",multiplier=1});
					elseif col and col.type == "duration" then
						table.insert(projectedFields,{name=fixColumnName(column.id), type="Time",multiplier=1});
					else
						table.insert(projectedFields,fixColumnName(column.id));
					end
				end

				local function mapDimensionId(d)
					return { id = d.id };
				end
				local function mapDimensionName(d)
					return d.name;
				end
				local filter = {
					scope           = detailType;
					dateField       = "EndDate";
					requiredFields  = requiredFields;
					name            = self.appName .. ".DetailFilter",
					mandatoryFields = _.map(mandatoryFields, mapDimensionName),
					optionalFields  = _.map(optionalFields, mapDimensionName),
					sortFields      = _.map(sortFields, mapDimensionName),
					metadata        = {
						mandatoryFields = _.map(mandatoryFields, mapDimensionId),
						optionalFields  = _.map(optionalFields, mapDimensionId),
						sortFields      = _.map(sortFields, mapDimensionId),
					},
					[dsdata.description.dataType.."Project"] = self.appName
				}
				if not _.contains(filter.mandatoryFields, "Type") then
					table.insert(filter.mandatoryFields, "Type");
					table.insert(filter.metadata.mandatoryFields, { id = "Type" } );
				end

				LogDebug("DETAILS FILTER %s",json.encode(filter,true));
				status,result = pcall(function()
					status,result = manage.setFilter(summarizerKS,filter,self.inconcert_authUser.virtualContactCenter,self.appName .. "." .. outstream.id)
					if not status then
						error(result);
					end
				end)
				if not status then
					return status,messages.messageKey('database_error',{description=result})
				end
				if #projectedFields >0 then
					local detailQueryTable = {
						projectFields = projectedFields,
						filterName    = self.appName .. "." .. outstream.id,
						type = "detail",
						mutable=true,
						category="Custom",
						description = outstream.description.description or outstream.name;
						name =  outstream.name,
						[dsdata.description.dataType.."Project"] = self.appName,
						filters = {
							Type = "CHAT"
						}
					}
					LogDebug("DETAILS REPORT %s %s",self.appName .. "." .. outstream.name,json.encode(detailQueryTable,true));
					status,result = pcall(function()
						status,result = manage.setReport(summarizerKS,detailQueryTable,self.inconcert_authUser.virtualContactCenter,self.appName .. "." .. outstream.name,true)
						if not status then
							error(result);
						end

					end)
					if not status then
						return status,messages.messageKey('database_error',{description=result})
					end

				end
			end
		end
		--LogDebug("Retorno %s",tostring(status));
		LogDebug = function (...)
		end

		return self:cleanUnused(dsdata);
	end

	print("constructor")
	return self
end


local args = {...}
cassandra_host = args[1] or "127.0.0.1"
cassandra_port = args[2] or 9160

print("Conecting  cassandra ",cassandra_host,cassandra_port)
cassandra.seed(cassandra_host,cassandra_port)

function eachVCC(cb)
	if args[3] then
		cb(args[3])
		return
	end

	local iter, dir_obj = tweetyio.dir (config.usersPath)
	local dir_entry = iter(dir_obj)
	while  dir_entry do
		if dir_entry ~= "." and dir_entry ~= ".." then
			local attrs = tweetyio.attributes(config.usersPath .. config.pathSeparator .. dir_entry)
			if attrs.mode == 'directory' then
				cb(dir_entry);
			end
		end
		dir_entry = iter(dir_obj)
	end
end

function eachProyect(vccName,cb)
	if args[4] then
		cb(args[4])
		return
	end
	local iter, dir_obj = tweetyio.dir (config.usersPath .. config.pathSeparator .. vccName)
	local dir_entry = iter(dir_obj)
	while  dir_entry do
		if dir_entry ~= "." and dir_entry ~= ".." then
			cb(dir_entry);
		end
		dir_entry = iter(dir_obj)
	end
end



eachVCC(
	function(vccName)
		--if vccName ~= "system" then
			inconcert.authUser.virtualContactCenter = vccName;
			eachProyect(vccName,
				function(appName)
					if appName ~= "designer" then

						print("VCC",vccName,"App",appName)
						local app = application.new{vccName = vccName}
						print("Initializing app ",appName)
						local status,result=  app:initialize(appName);
						if status then
							local hidden = false;
							print("Exporting bundle");
							status,result = app:buildExportBundle();
							if status then
								local fh = tweetyio.open(config.usersPath .. config.pathSeparator .. vccName .. config.pathSeparator .. appName .. config.pathSeparator .. config.catalogFile,"rb");

								if not fh then
									hidden=true
								else
									local catalog = json.decode(fh:read("*a"));
									hidden = catalog.hidden;
									fh:close()
								end
								tweetyio:set("cassandra")
								tweetyio.mkdir("/tmp");
								tweetyio.mkdir(config.usersPath);
								tweetyio.mkdir(config.usersPath .. config.pathSeparator .. vccName);

								local bundlePath = "/tmp/" .. vccName .. "-" .. appName .. ".bundle"

								print("Writing bundle into cassandra ",bundlePath);

								local fh = tweetyio.open(bundlePath,"wb");
								if not fh then
									error ("Can't create file ",bundlePath);
								end
								fh:write(result)
								fh:close();
								print("Import bundle into cassandra");
								local newApp = application.new{vccName = vccName}
								status,result = newApp:importFromBundle(bundlePath,appName,true,hidden)
								tweetyio.remove(bundlePath);
								if not status then
									error(json.encode(result));
								end
								tweetyio:set("filesystem")
							else
								error(json.encode(result))
							end
						else
							error(json.encode(result))
						end
					end
				end
			)
		--end
	end
)
