
tweety_modules_prefix = "";--apps.webdesigner." 
local mrequire = require 
LogDebug = function (...)
  print(...)
end
LogError = function (...)
	print(...)
end
LogInfo = function (...)
	print(...)
end
LogWarning = function (...)
	print(...)
end



require = function (mname)
--	print("mname",mname)
	local pre ={
		['inconcert.orbit.application']=true;
		['luasql.inconcertPool']={
			inconcertPool = function() end
		};
		['xml.ltxml']=true;
		['luaxslt']=true;
	}
	return pre[mname] or mrequire(mname)
end


package.preload['inconcert.orbit.application']=true
inconcert = {
	session={
	},
	orbit ={
		application = {
			Decorate=function() end;
		}
	},
	authUser = {
		virtualContactCenter="designer",
		userName="test",
		timezone={
			offset=-3
		}

	}
}

local config = require "config"
local tweetyio = require "tweetyio"

tweetyio:set("filesystem")
local basepath = "/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner"
config.initialize({},basepath);
local application = require "application"
local cassandra = require "lua_cassandra"


local args = {...}
cassandra_host = args[1] or "127.0.0.1"
cassandra_port = args[2] or 9160

print("Conecting  cassandra ",cassandra_host,cassandra_port)
cassandra.seed(cassandra_host,cassandra_port)

function eachVCC(cb)
	if args[3] then
		cb(args[3])
		return
	end

	local iter, dir_obj = tweetyio.dir (config.usersPath)
	local dir_entry = iter(dir_obj)
	while  dir_entry do
		if dir_entry ~= "." and dir_entry ~= ".." then
			local attrs = tweetyio.attributes(config.usersPath .. config.pathSeparator .. dir_entry)
			if attrs.mode == 'directory' then
				cb(dir_entry);
			end
		end
		dir_entry = iter(dir_obj)
	end
end

function eachProyect(vccName,cb)
	if args[4] then
		cb(args[4])
		return
	end
	local iter, dir_obj = tweetyio.dir (config.usersPath .. config.pathSeparator .. vccName)
	local dir_entry = iter(dir_obj)
	while  dir_entry do
		if dir_entry ~= "." and dir_entry ~= ".." then
			cb(dir_entry);
		end
		dir_entry = iter(dir_obj)
	end
end



eachVCC(
	function(vccName)
		if vccName ~= "system" then
			inconcert.authUser.virtualContactCenter = vccName;
			eachProyect(vccName,
				function(appName)
					if appName ~= "designer" then

						print("VCC",vccName,"App",appName)
						local app = application.new{vccName = vccName}
						print("Initializing app ",appName)
						local status,result=  app:initialize(appName);
						if status then
							local hidden = false;
							print("Exporting bundle");
							status,result = app:buildExportBundle();
							if status then
								local fh = tweetyio.open(config.usersPath .. config.pathSeparator .. vccName .. config.pathSeparator .. appName .. config.pathSeparator .. config.catalogFile,"rb");

								if not fh then
									hidden=true
								else
									local catalog = json.decode(fh:read("*a"));
									hidden = catalog.hidden;
									fh:close()				
								end			
								tweetyio:set("cassandra")
								tweetyio.mkdir("/tmp");
								tweetyio.mkdir(config.usersPath);
								tweetyio.mkdir(config.usersPath .. config.pathSeparator .. vccName);

								local bundlePath = "/tmp/" .. vccName .. "-" .. appName .. ".bundle"

								print("Writing bundle into cassandra ",bundlePath);	

								local fh = tweetyio.open(bundlePath,"wb");
								if not fh then
									error ("Can't create file ",bundlePath);
								end
								local bundleData = json.decode(result);
								if not bundleData.catalog.appClass or bundleData.catalog.appClass == "cti" then
									LogDebug("***** %s ",bundleData.catalog.appClass or "nada")
									bundleData.catalog.appClass = "cci"
									bundleData.catalog['icc-summarizer-dataType'] = "dscci"
								elseif bundleData.catalog.appClass == "cci" then
									bundleData.catalog['icc-summarizer-dataType'] = "dscci"
								elseif bundleData.catalog.appClass == "contactform" then
									bundleData.catalog['icc-summarizer-dataType'] = "dscontactform"
								elseif bundleData.catalog.appClass == "webchat" then
									bundleData.catalog['icc-summarizer-dataType'] = "dswebchat"
								end
								
								if bundleData.catalog['icc-summarizer-dataType'] == "survey" then
									bundleData.catalog['icc-summarizer-dataType'] = "dswebchat"
								end
								
								for _,ds in pairs( bundleData.data.datasources) do
									-- MIGRACION DE CTI A CCI
									if ds.description.dataType == "cti" or ds.description.dataType == "cci" then
										ds.description.dataType = "dscci"
									elseif ds.description.dataType == "survey" then
										ds.description.dataType = "dswebchat" 
									elseif ds.description.dataType == "contactform" then
										ds.description.dataType = "dscontactform" 
									end
									
								end
								-- Migracion  de variables built-in de los flow
								if bundleData.catalog.appClass == "flow" and bundleData.catalog.appSubClass == "call" then
									for _,child in ipairs(bundleData.data.views.main.childs) do
										if child.type == "ui.flowactivity.incomingCall" then
											child.variables = {
												varlist={
													{varname =  "interactionId",readonly=true},
													{varname =  "Contact",readonly=true},
													{varname =  "Contact.Id",readonly=true},
													{varname =  "Contact.Name",readonly=true},
													{varname =  "Address",readonly=true},
													{varname =  "Address.Country",readonly=true},
													{varname =  "Address.Area",readonly=true},
													{varname =  "Address.Number",readonly=true},
													{varname =  "Address.Extension",readonly=true}
												}
											}
										end
									end
								end
								if bundleData.catalog.appClass == "flow" and bundleData.catalog.appSubClass == "chat" then
									for _,child in ipairs(bundleData.data.views.main.childs) do
										if child.type == "ui.flowactivity.incomingChat" then
											child.variables = {
												varlist={
													{varname =  "interactionId" ,readonly=true},
													{varname =  "Contact" ,readonly=true},
													{varname =  "Contact.Id" ,readonly=true},
													{varname =  "Contact.Name" ,readonly=true}
												}
											}
										end
									end
								end
								-----------------------------------------------------------------
								result = json.encode(bundleData);
								fh:write(result)
								fh:close();
								print("Import bundle into cassandra");
								local newApp = application.new{vccName = vccName}
								status,result = newApp:importFromBundle(bundlePath,appName,true,hidden)
								tweetyio.remove(bundlePath);
								if not status then
									error(json.encode(result));
								end
								tweetyio:set("filesystem")
							else
								error(json.encode(result))
							end
						else
							error(json.encode(result))
						end
					end
				end
			)
		end
	end
)
