module(..., package.seeall)

local initialized
local function initModule()
	if not initialized then
		require "LuaOrm.Mapper"
		m_connectionManager = require("LuaOrm.Connection")
		ok, permissionModule = pcall(require, "shared.permissions")
	
		if ok then
			m_permissionMng = permissionModule.new("designer")
		end

		config = require (_G['tweety_modules_prefix'] .. "config")
		m_dataSource = LuaOrm.DBMS.DataSource()
		m_models = {}
		initialized = true;
	end
end



--///////////////////////////////////////////////////////////////////////////////////
-- 
local function GetConfigDataBase()
	initModule()
	if inconcert.environment.apps.tweety and inconcert.environment.apps.tweety.dataBase then
		return inconcert.environment.apps.tweety.dataBase
	end
	return config.dataBase
end

--///////////////////////////////////////////////////////////////////////////////////
-- 
local function CreateModelTable()
	-- TODO: agregar las tablas que se necesiten al modelo
end

--///////////////////////////////////////////////////////////////////////////////////
-- 
function GetModels()
	initModule()
	return m_models
end

--///////////////////////////////////////////////////////////////////////////////////
-- 
function LoadUserPermissions()
	initModule()
	if not m_permissionMng then
		return
	end
	m_permissionMng:LoadActions()
end

--///////////////////////////////////////////////////////////////////////////////////
-- 
function BuildModels()
	initModule()
	if not m_permissionMng then
		return
	end
	local dataBase = GetConfigDataBase()
	if not m_connectionManager.Connect(m_dataSource, dataBase) then
		return false, LogError("Failure connecting to database")
	end
	CreateModelTable()
	local permissionTables = m_permissionMng:GetPermissionsModel(m_dataSource)
	if permissionTables then
		m_connectionManager.AddTables(permissionTables, m_models)
	else
		return false, LogError("Unable to start application without permissions model")
	end
	m_mapper = LuaOrm.Mapper.new()
	local status, err = pcall(m_connectionManager.ValidateDataSources, {m_dataSource})
	if not status then
		return false, LogError(err)
	end
	m_mapper.models = m_models
	return true
end

