local args = {...}
version = args[1] or "dev"
weblibsprefix = args[2] or "/usr/lib/inconcert/weblibs/inconcert/"

require "oldjson"

--designer files
designer_files = {
	"documentView.js",
	"designer.js",
	"designerApplication.js",
	"designerWorkspace.js",
	"designerJslib.js",
	"designerCore.js",
	"fixedLayoutDesigner.js",
	"webchatDesigner.js",
	"controlProperties.js",
	"designerForm.js",
	"propertiesView.js",
	"dsintrospection.js",
	"designerDatasource.js",
	"datasourceWizard.js",
	"viewWizard.js",
	"csvutils.js",
	"dsNativeImportExport.js",
	"applicationWizard.js",
	"reportWizard.js",
	"designerReport.js",
	"designerBIReport.js",
	"dialogDesigner.js",
	"flowactivity.js",
	"designerLines.js",
	"flowPromptsCtrl.js"
}

form_libs = {
	--basic libs
	basic = {
		corelib_js = {
			"icc-ui-base.js",
			"icc-ui-widget.js",
			"icc-ui-application.js",
			"icc-ui-layouts.js",
			"icc-ui-container.js",
			"icc-ui-rootwindow.js",
		},
		weblibs_js = {
			"/lib/LAB/LAB-src.js",
			"/lib/javascriptools2/JavaScriptUtil.js",
			"/lib/javascriptools2/Parsers.js"
		},
		weblibs_css = {
		}
	},
	--default form libs
	default = {
		corelib_js = {
			"icc-ui-i18n.js",
			"icc-ui-desktop-notifications.js",
			"icc-ui-maskinput.js",
			"icc-ui-tooltip.js",
			"icc-ui-button.js",
			"icc-ui-image.js",
			"icc-ui-text.js",
			"icc-ui-dhtmlx-tabpanel.js",
			"icc-ui-dhtmlx-combobox.js",
			"icc-ui-dhtmlx-tree.js",
			"icc-ui-dhtmlx-grid.js",
			"icc-ui-dhtmlx-menu.js",
			"icc-ui-progressbar.js",
			"icc-ui-imagelist.js",
			"icc-ui-separators.js",
			"icc-ui-codeeditor.js",
			"icc-ui-msgbox.js",
			"icc-ui-datasource.js",
			"icc-ui-wizarddialog.js",
			"icc-ui-uploader.js",
			"icc-ui-sdk-dispositioncode.js",
			"icc-ui-reportcontrols.js",
			"icc-ui-chat-old.js",
			"icc-ui-chat.js",
			"icc-ui-chat-minimized.js",
			"icc-cti-control.js",
			"icc-ui-captcha.js"
		},
		weblibs_js = {
			"/lib/jquery-caret/jquery.caret-1.3.1.js",
			"/lib/autosize/autosize.js",
			"/lib/jquery-rightclick/jquery.rightClick.js",
			"/lib/emoji-picker/js/nanoscroller.js",
			"/lib/emoji-picker/js/tether.js",
			"/lib/emoji-picker/js/config.js",
			"/lib/emoji-picker/js/util.js",
			"/lib/emoji-picker/js/jquery.emojiarea.js",
			"/lib/emoji-picker/js/emoji-picker.js",
			"/lib/webtoolkit/webtoolkit.md5.js",
			"/lib/webtoolkit/webtoolkit.base64.js",
			"/shared/cookies/cookies.js",
			"/lib/dhtmlx/menu/dhtmlxprotobar.js",
			"/lib/dhtmlx/menu/dhtmlxmenubar.js",
			"/lib/dhtmlx/menu/dhtmlxmenubar_cp.js",
			"/shared/scripts/inconcert.session_storage.js",
			"/lib/jquery/jquery.jsonp-2.2.0.js",
			"/lib/dhtmlx/tree/dhtmlxcommon.js",
			"/lib/dhtmlx/tree/dhtmlxtree.js",
			"/lib/dhtmlx/tree/dhtmlxtree_kn.js",
			"/lib/dhtmlx/tabbar/dhtmlxtabbar.js",
			"/lib/dhtmlx/calendar/dhtmlxcalendar.js",
			"/lib/dhtmlx/grid/dhtmlxgrid.js",
			"/lib/dhtmlx/grid/dhtmlxgridcell.js",
			"/lib/dhtmlx/windows/dhtmlxwindows.js",
			"/lib/codemirror/lib/codemirror.js",
			"/lib/codemirror/mode/javascript/javascript.js",
			"/lib/codemirror/mode/lua/lua.js"
		},
		weblibs_css = {
			"/lib/emoji-picker/css/nanoscroller.css",
			"/lib/emoji-picker/css/emoji.css",
			"/lib/dhtmlx/tree/dhtmlxtree.css",
			"/lib/dhtmlx/grid/dhtmlxgrid.css",
			"/lib/dhtmlx/tabbar/dhtmlxtabbar.css",
			"/lib/dhtmlx/calendar/dhtmlxcalendar.css",
			"/lib/dhtmlx/menu/dhtmlxmenu.css",
			"/lib/dhtmlx/menu/context.css",
			"/lib/dhtmlx/menu/dhtmlxmenu_xp.css",
			"/lib/dhtmlx/windows/dhtmlxwindows.css",
			"/lib/dhtmlx/windows/skins/dhtmlxwindows_standard.css",
			"/lib/dhtmlx/windows/skins/dhtmlxwindows_clear_silver.css",
			"/lib/codemirror/lib/codemirror.css",
			"/lib/codemirror/theme/default.css"
		}
	},
	--chat form libs
	chat = {
		corelib_js = {
			"icc-ui-i18n.js",
			"icc-ui-desktop-notifications.js",
			"icc-ui-maskinput.js",
			"icc-ui-tooltip.js",
			"icc-ui-button.js",
			"icc-ui-image.js",
			"icc-ui-text.js",
			"icc-ui-dhtmlx-combobox.js",
			"icc-ui-separators.js",
			"icc-ui-msgbox.js",
			"icc-ui-datasource.js",
			"icc-ui-chat.js",
			"icc-ui-captcha.js"
		},
		weblibs_js = {
			"/lib/jquery-caret/jquery.caret-1.3.1.js",
			"/lib/jquery/jquery.jsonp-2.2.0.js",
			"/lib/autosize/autosize.js",
			"/lib/emoji-picker/js/nanoscroller.js",
			"/lib/emoji-picker/js/tether.js",
			"/lib/emoji-picker/js/config.js",
			"/lib/emoji-picker/js/util.js",
			"/lib/emoji-picker/js/jquery.emojiarea.js",
			"/lib/emoji-picker/js/emoji-picker.js",
			"/lib/webtoolkit/webtoolkit.base64.js",
			"/lib/dhtmlx/tree/dhtmlxcommon.js",
			"/lib/dhtmlx/calendar/dhtmlxcalendar.js"
		},
		weblibs_css = {
			"/lib/emoji-picker/css/nanoscroller.css",
			"/lib/emoji-picker/css/emoji.css",
			"/lib/dhtmlx/calendar/dhtmlxcalendar.css"
		}
	},
	--minimized chat libs
	minimizedchat = {
		corelib_js = {
			"icc-ui-chat-minimized.js",
		},
		weblibs_js = {
		},
		weblibs_css = {
		}
	}
}
local all_form_libs = {}
for _, form in pairs(form_libs) do
	for groupName, libs in pairs(form) do
		all_form_libs[groupName] = all_form_libs[groupName] or {}
		all_form_libs[groupName .. "_d"] = all_form_libs[groupName .. "_d"] or {}
		for _, lib in pairs(libs) do
			if not all_form_libs[groupName .. "_d"][lib] then
				all_form_libs[groupName .. "_d"][lib] = true
				table.insert(all_form_libs[groupName], lib)
			end
		end
	end
end

local function concat_files(prefix,file_list)
	local all_content = {}
	for _,name in ipairs(file_list) do
		print("Concat ",prefix .. name)
		local f = io.open(prefix .. name,"rb");
		table.insert(all_content,f:read("*a"));
		io.close(f)
	end
	return table.concat(all_content,"\n\n")
end
local function process_designer_app_properties()
	local f = io.open("scpusers/system/designer/application.properties","rb")
	local app = json.decode(f:read("*a"))
	f:close();
	local fhash={}
	for _,v in ipairs(designer_files) do
		fhash[v]=v
	end
	newres = {}
	
	for _,v in ipairs(app.catalog.resources) do
		if not fhash[v.src] then
			table.insert(newres,v)
		end
	end
	table.insert(newres,{mimeType =  "text/javascript",src= "core-" .. version .. ".js"})
	app.catalog.resources = newres;
	f = io.open("scpusers/system/designer/application.properties","wb")
	f:write(json.encode(app,true));
	f:close()
end
local function process_singleform_html()
	local f = io.open("singleform.html","rb")
	local html = f:read("*a")
	local newhtml={}
	f:close();
	local fhash={}
	for _,v in ipairs(all_form_libs.corelib_js) do
		fhash["clientlib/" .. v]=v
	end
	for line in html:gmatch("[^\r\n]+") do
		libname = line:gmatch("clientlib/[%w-_%.]+")()
		if not libname or not fhash[libname] then
			table.insert(newhtml,line)
		end
	end
	html = table.concat(newhtml,"\r\n")
	newhtml={} 
	fhash = {}
	for _,v in ipairs(all_form_libs.weblibs_js) do
		fhash["/$weblibs" .. v]=v
	end
	for line in html:gmatch("[^\r\n]+") do
		libname = line:gmatch("/%$%weblibs/[%w-_%./]+")()
		if not libname or not fhash[libname] then
			table.insert(newhtml,line)
		end
	end
	
	html = table.concat(newhtml,"\r\n")
	newhtml={} 
	fhash = {}
	for _,v in ipairs(all_form_libs.weblibs_css) do
		fhash["/$weblibs" .. v]=v
	end
	for line in html:gmatch("[^\r\n]+") do
		libname = line:gmatch("/%$%weblibs/[%w-_%./]+")()
		if not libname or not fhash[libname] then
			table.insert(newhtml,line)
		end
	end

	newhtml = table.concat(newhtml,"\r\n")
	newhtml = newhtml:gsub("%<%!%-%- CLIENTLIB %-%-%>",
			"<script language=\"javascript\" src=\"clientlib/corelib-" .. version .. "-basic$min.js\"></script>" ..
			"\n<script language=\"javascript\" src=\"clientlib/corelib-" .. version .. "-$libtype$min.js\"></script>")
	newhtml = newhtml:gsub("%<%!%-%- WEBLIBSCSS %-%-%>",
		"<link rel=\"stylesheet\" href=\"clientlib/weblibs-" .. version .. "-basic$min.css\" type=\"text/css\"/>" ..
		"\n<link rel=\"stylesheet\" href=\"clientlib/weblibs-" .. version .. "-$libtype$min.css\" type=\"text/css\"/>")
	newhtml = newhtml:gsub("%<%!%-%- WEBLIBS %-%-%>",
		"<script language=\"javascript\" src=\"clientlib/weblibs-" .. version .. "-basic$min.js\"></script>" ..
		"\n<script language=\"javascript\" src=\"clientlib/weblibs-" .. version .. "-$libtype$min.js\"></script>")
	f = io.open("singleform.html","wb")
	f:write(newhtml)
	f:close()
	
	
end
local function remove_files(prefix,file_list)
	for _,v in ipairs(file_list) do
		os.remove(prefix .. v)
	end
end

f = io.open("scpusers/system/designer/core-" .. version .. ".js","wb")
f:write(concat_files("scpusers/system/designer/",designer_files))
f:close()

process_designer_app_properties()
remove_files("scpusers/system/designer/",designer_files)

for libtype, files in pairs(form_libs) do
	f = io.open("clientlib/corelib-" .. version .. "-" .. libtype .. ".js","wb")
	f:write(concat_files("clientlib/", files.corelib_js))
	f:close()
	
	f = io.open("clientlib/weblibs-" .. version .. "-" .. libtype .. ".js","wb")
	f:write(concat_files(weblibsprefix, files.weblibs_js))
	f:close()

	f = io.open("clientlib/weblibs-" .. version .. "-" .. libtype .. ".css","wb")
	f:write(concat_files(weblibsprefix, files.weblibs_css))
	f:close()
end

remove_files("clientlib/", all_form_libs.corelib_js)

process_singleform_html()

