local args = {...}
local cassandra = require "lua_cassandra"

require "json"
cassandra_host = args[1] or "127.0.0.1"
cassandra_port = args[2] or 9160

print("Conecting  cassandra ",cassandra_host,cassandra_port)
cassandra.seed(cassandra_host,cassandra_port)

function Get(campaignId, keyspace)
	local campaign = {}
	local release = false
	if (not keyspace) then
		release = true
		keyspace = cassandra:CassandraConnection("Agent")
	end
	
	local campaignColumns = keyspace:GetSliceRange(campaignId, 
										   "Campaigns", 
										   "", { 
												column_names = {},
												slice_range = { 
															start = "", 
															finish = "", 
															reversed = true, 
															count = 200
														}
												}
											)

	if (campaignColumns) then
		for k, v in ipairs(campaignColumns) do
			if (v.name == "Integration") then
				campaign[v.name] = json.decode(v.value)
			else
				campaign[v.name] = v.value
			end
		end
		if not campaign.Id then
			--this is a stub!
            if (release) then
                keyspace:Close()
            end
			return
		end
		campaign.Avatar = nil --TODO this is UGLY, fix it


		--now go fetch the account information
		local rows = keyspace:GetSuperRangeSlices("CampaignAccounts",  --column family
											   "",  --supercolumn
											   campaignId, --startkey
											   campaignId, --endkey
													{ 
													column_names = {},
													slice_range = { 
																start = "", 
																finish = "", 
																reversed = false, 
																count = 200}
													},
												200 --total keys
									) or {}		
		campaign.accounts = {}
		for key, campaignAccounts in rows:Iterator() do
			if (key == campaignId) then
				--estoy en la que pedi, no deberia volver mas de un row anyway
				for k, v in pairs(campaignAccounts) do
					local account = {}
					--v es la supercolumn de cada entrada con la pareja name/subcolumns
					for colid, column in pairs(v.columns) do
						account[column.name] = column.value
					end
					--las accounts tiene un id v.name que no me interesa, armo array nomas
					table.insert(campaign.accounts, account)
				end
				break
			end
		end
	end
	if (release) then
		keyspace:Close()
	end
	return campaign
end

function FindAll()
	local results = {}
	
	local keyspace = cassandra:CassandraConnection("Agent")
	
	--TODO this should be paginating cause ain't working with more than 1000 campaigns configured
	local campaignList = keyspace:GetRangeSlices("Campaigns",  --column family
										   "",  --supercolumn
										   "", --startkey
										   "", --endkey
												{ --predicate
												column_names = {}, 
												slice_range = { 
															start = "", 
															finish = "", 
															reversed = false, 
															count = 100}
												},
											1000 --total keys
							) 
	if (campaignList) then
		for campaignId, campaignRow in campaignList:Iterator() do
			results[campaignId] = Get(campaignId, keyspace)
		end
	end
	keyspace:Close()
	return results
end

local r = FindAll();

print(json.encode(r,true));

