/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global designer, resizePopup, icc, self, args, chatctrl, environment,
	updatePresurveyArgs, validateDatasources, haveScreen, setSurveyID, savePartialDataToSummarizer, iFrameEventListener, googleAnalyticsHelper
*/

if(!designer){
	
	//check if has reportingData datasource
	if (!environment.datasources['reportingData']) {
		icc.ui.getApplication().datasource("reportingData",environment); 
	}
	
	//google analytics
	if (args.google_key) {
		var view = args.google_bysections === "1"? "chat" : null;
		googleAnalyticsHelper.registerView(args.google_key, view);
	}
    
	resizePopup();
	var displayMessage = icc.ui.getApplication().displayMessage;

	if( !icc.utils.browser.is_iphone ) {
		icc.ui.getApplication().setSettings({forceFullResize:true});
	}

	icc.ui.getApplication().displayMessage = function(msg ){
		if(!msg) {
			return;
		}
		var code = parseInt( msg.code, 10);
		if( code === 1028 || code === 1029) {
			return;
		}
		displayMessage.call(icc.ui.getApplication(),msg);
	};
	updatePresurveyArgs(self,args);
	chatctrl.token = args.token;
	chatctrl.type = args.type || "popup";
	chatctrl.transferrerId = args.transferrer_id || null;
	var addressHash={};
	args.NAME = icc.utils.trim(args.NAME);
	args.EMAIL = icc.utils.trim(args.EMAIL);

	args.NAME = args.NAME !== ""?args.NAME:undefined;
	args.EMAIL = args.EMAIL !== ""?args.EMAIL:undefined;
	var __SID = icc.ui.getApplication().getName();
	if (["chat{9CA752E9-3BA3-4FEB-931D-3E61734151D8}",
		"chatbottest{9CA752E9-3BA3-4FEB-931D-3E61734151D8}",
	    ].includes(__SID)) {
		__SID = "default";
	}

	chatctrl.userData = {
		applicationID:__SID
	};
	if (args.NAME  || args.EMAIL){
		chatctrl.userData.contact={};
		chatctrl.userData.contact.name = args.NAME;
		if (args.EMAIL){
			chatctrl.userData.contact.addresses =  chatctrl.userData.contact.addresses || [];
			addressHash["MAIL:"+args.EMAIL]=true;
			chatctrl.userData.contact.addresses.push({
				"address": args.EMAIL,
				"type": "MAIL"
			
			});
		}
	}
	var email;
	//console.log(JSON.stringify(args))
	jQuery.each([[args.params || [],"params"],[args.login || [],"login"],[args.preSurvey || [],"pre_survey"]],function(index,d){
		var fields = d[0];var tgt = d[1];

		for ( var idx = 0; idx < fields.length; idx++ )
		{
			var field = fields[idx];
			if ( field.type === "EMAIL" ) {
				field.type = "MAIL";
			}

			field.value = icc.utils.trim( field.value );

			if ( !field.other_values ) {
				field.value = field.value.length !== 0 ? field.value : undefined;
				if( field.value === undefined ) {
					continue;
				}
			}

			var fieldType = field.type.toUpperCase();
			if((fieldType === "MAIL" || fieldType === "CELLULAR" || fieldType === "HOME" || fieldType === "OFFICE" || fieldType === "TWITTER")){
				if(field.type === "MAIL"){
					email = field.value;
				}
				chatctrl.userData.contact= chatctrl.userData.contact || {};
				chatctrl.userData.contact.addresses = chatctrl.userData.contact.addresses || [];
				if ( !addressHash[field.type +":"+field.value]){
					chatctrl.userData.contact.addresses.push({
						type:field.type,
						address:field.value,
						countryCode: field.other_values?.countryCode,
						areaCode: field.other_values?.areaCode,
					});
					addressHash[field.type +":"+field.value]=true;
				}
			}else
			if( fieldType === "ID" ){
				chatctrl.userData.contact=chatctrl.userData.contact || {};
				chatctrl.userData.contact.externalId = field.value;
			}else if( fieldType === "NAME" ){
				chatctrl.userData.contact=chatctrl.userData.contact || {};
				chatctrl.userData.contact.name = field.value;
			}else{
			
				chatctrl.userData.data = chatctrl.userData.data || {};
				chatctrl.userData.data[ tgt ] = chatctrl.userData.data[ tgt ] || {__SID:__SID,fields:[]};

				var field_data = {
					name         : field.name,
					value        : field.value,
					displayName  : field.alias,
					other_values : field.other_values
				};
				if (field.hidden) {
					field_data.hidden = true;
				}
				chatctrl.userData.data[ tgt ].fields.push( field_data );
			}
		}
	});

	chatctrl.userName = (chatctrl.userData.contact || {}).name;
	chatctrl.userEmail = email;
	var saveAll = new icc.ui.button({action:"save-all",visible:false,width:1,height:1,x:0,y:0},self.environment);
	saveAll.onClick(function(){
		for (var k in environment.datasources){
			if ( environment.datasources.hasOwnProperty( k )) {
				var ds = environment.datasources[k];
				environment.changed_datasources[ds.config.name]=ds.mode;
			}
		}
	});
	self.childs.push(saveAll);

	chatctrl.onClientLogout(function(/*reason*/){
		updatePresurveyArgs(self,args);
		var r=validateDatasources(self);
		for (var k in environment.datasources) {
			if ( environment.datasources.hasOwnProperty( k ) ) {
				args[k] = environment.datasources[k];
			}
		}
		if ( r ){
			if(haveScreen("postSurvey") && chatctrl.isPostSurveyEnabled()){
				function jump() {
					self.fireEvent("onGotoPostSurvey");
				}
				
				if (args.type === "embedded") {
					iFrameEventListener.minimizeChat(true, function() {
						jump();
					});
				}
				else {
					jump();
				}
			}else{
				saveAll.fireEvent("onClick");
				if (args.type !== "embedded") {
					window.close();
					//este mensaje va por si el popup se levanto de una forma que no puede cerrarse
					chatctrl.notify(_T("The conversation has terminated."), "error");
				}
				else {
					iFrameEventListener.closeChat();
				}
			}
		}
	});
	self.onGotoPostSurvey = function(fn){
		self.addListener("onGotoPostSurvey",fn);
	};
	chatctrl.onAgentLogout(function(/*reason*/){
		updatePresurveyArgs(self,args);
		var r=validateDatasources(self);
		for (var k in environment.datasources) {
			if ( environment.datasources.hasOwnProperty( k ) ) {
				args[k] = environment.datasources[k];
			}
		}
		if ( r ){
			saveAll.fireEvent("onClick");
		}
	});

	chatctrl.onNewSession(function(sessionId){
		args.SESSIONID = sessionId;
		setSurveyID(self,sessionId);
		savePartialDataToSummarizer(self,sessionId);
	});
	self.onReady(function(){
		self.onGotoPostSurvey(function(){
			var app = icc.ui.getApplication();
			app.show("postSurvey",args);
		});
	
		if (args.type === "embedded" && !args.debug) {
			iFrameEventListener.setCurrentForm("chat");
		}
	});
}    
    
    