
/* global designer, self, k, goToChat, environment, iFrameEventListener, googleAnalyticsHelper, chatformcontainer */

if (!designer) {
	
	function getCaptcha(form){
		var res = {};
		var checkincontrol = function(c){
			if (c.visible && c.uiclass === "captcha"){
				res.challenge = c.getChallenge();
				res.response = c.getResponse();
				res.control = c;
			}
			if(c.childs){
				jQuery.each(c.childs,function(idx,child){
					checkincontrol(child);
				});
			}
		};
		checkincontrol(form);
		return res;
	}

	//google analytics
	if (args.google_key && args.google_bysections === "1") {
		googleAnalyticsHelper.registerView(args.google_key, "presurvey");
	}

	resizePopup();
	var saveAll = new icc.ui.button({action: 'save-all', visible: false, width: 1, height: 1, x: 0, y: 0}, self.environment);
	self.childs.push(saveAll);
	self.onReady(function () {
		function init() {
			for (k in self.environment.datasources) {
				var ds = self.environment.datasources[k];
				if (ds.mode === "edit" || ds.mode === "new") {
					ds.set("_HasPreSurvey", true);
					ds.environment.form = self;
				}
			}
			if (eval("try { chatformcontainer !== undefined } catch(e) { false }")) {
				if (args.type === "embedded" && !args.debug) {
					iFrameEventListener.setCurrentForm("presurvey");
				}
				chatformcontainer.start();
				LoadTransferContext(self, "pre_survey");
			}
		}
		
		if (args.go_chat) {
			for (var k in environment.datasources) {
				args[k] = environment.datasources[k];
			}
			var app = icc.ui.getApplication();
			var screen = findChatScreen();
			app.show(screen, args);
		}

		if (args.type !== "embedded" || args.debug) {
			return init();
		}

		iFrameEventListener.getArgs(function (storedContext) {
			if (!storedContext || storedContext.form !== "preSurvey") {
				return init();
			}
			setDatasourcesContext(self, storedContext);
			var storedArgs = storedContext.args;
			for (var k in environment.datasources) {
				storedArgs[k] = environment.datasources[k];
			}
			var app = icc.ui.getApplication();
			var screen = findChatScreen();
			app.show(screen, storedArgs);
		});
	});
	
	var captcha = {};
	
	goToChat.beforeClick(function () {
		captcha = getCaptcha(self);
		if(captcha.challenge){
			if(!captcha.response) {
				icc.ui.displayMessage(icc.ui.message("missing_captcha_response",
					{challenge:captcha.challenge,datasource:'__none__'}));
				return false;
			}
		}
		return true;
	});

	goToChat.onClick(function () {
		if (args.debug) {
			return;
		}

		function go() {
			var app = icc.ui.getApplication();
			updatePresurveyArgs(self, args);
			var r = validateDatasources(self);
			if (r) {
				function jump() {
					for (var k in environment.datasources) {
						args[k] = environment.datasources[k];
					}
					var screen = findChatScreen();
					app.show(screen, args);
				}


				if (args.type === "embedded") {
					var context = {
						args:			args,
						datasources:	getDatasourcesContext(self),
						form:			"preSurvey"
					};
					iFrameEventListener.setArgs(context);
					iFrameEventListener.minimizeChat(true, function() {
						jump();
					});
				}
				else {
					jump();
				}
			}
		}

		if (captcha && captcha.control) {
			captcha.control.validate(function(status, result) {
				if (status) {
					go();
				}
				else {
					icc.ui.displayMessage(result);
				}
			});
		}
		else {
			go();
		}
	});
}
