/* global iFrameEventListener, googleAnalyticsHelper, chatformcontainer, self, finish, k, environment, designer */

if (!designer) {
	
	function getCaptcha(form){
		var res = {};
		var checkincontrol = function(c){
			if (c.visible && c.uiclass === "captcha"){
				res.challenge = c.getChallenge();
				res.response = c.getResponse();
				res.control = c;
			}
			if(c.childs){
				jQuery.each(c.childs,function(idx,child){
					checkincontrol(child);
				});
			}
		};
		checkincontrol(form);
		return res;
	}

	//google analytics
	if (args.google_key && args.google_bysections === "1") {
		googleAnalyticsHelper.registerView(args.google_key, "postsurvey");
	}

	resizePopup();
	var displayMessage = icc.ui.getApplication().displayMessage;
	icc.ui.getApplication().displayMessage = function (msg) {
		if (!msg)
			return;
		if (msg.code === 1028 || msg.code === 1029)
			return;
		displayMessage.call(icc.ui.getApplication(), msg);
	};
	function send_postSurveyData(interactionID, cb) {
		var contact;
		var data;
		var addressHash = {};
		var __SID = icc.ui.getApplication().getName();
		if (["chat{9CA752E9-3BA3-4FEB-931D-3E61734151D8}",
			"chatbottest{9CA752E9-3BA3-4FEB-931D-3E61734151D8}",
			"webcall{9CA752E9-3BA3-4FEB-931D-3E61734151D8}",
		    ].includes(__SID)) {
			__SID = "default";
		}

		jQuery.each([[args.postSurvey || [], "post_survey"]], function (idx, d) {
			var fields = d[0];
			var tgt = d[1];
			for (var idx = 0; idx < fields.length; idx++) {
				var field = fields[idx];
				if (field.type === "EMAIL")
					field.type = "MAIL";
				field.value = icc.utils.trim(field.value);

				if (!field.other_values) {
					field.value = field.value.length !== 0 ? field.value : undefined;
					if (field.value === undefined) {
						continue;
					}
				}

				if ((field.type === "MAIL" || field.type === "CELLULAR" || field.type === "HOME" || field.type === "OFFICE" || field.type === "TWITTER")) {
					if (field.type === "MAIL") {

						email = field.value;
					}
					contact = contact || {};
					contact.addresses = contact.addresses || [];
					if (!addressHash[field.type + ":" + field.value]) {
						contact.addresses.push({
							type: field.type,
							address: field.value,
							countryCode: field.other_values?.countryCode,
							areaCode: field.other_values?.areaCode,
						});
						addressHash[field.type + ":" + field.value] = true;
					}
				} else
				if (field.type === "ID") {
					contact = contact || {};
					contact.externalId = field.value;
				} else if (field.type === "NAME") {
					contact = contact || {};
					contact.name = field.value;
				} else {
					data = data || {};
					data[tgt] = data[tgt] || {__SID: __SID, fields: []};
					var field_data = {
						name: field.name,
						value: field.value,
						displayName: field.alias,
						other_values: field.other_values
					};
					if (field.hidden) {
						field_data.hidden = true;
					}
					data[tgt].fields.push(field_data);
				}
			}
		});
		if (contact || data) {

			jQuery.ajax({
				url: "runtime/save_postsurvey_data",
				cache: false,
				dataType: 'json',
				type: 'POST',
				contentType: "application/json",
				beforeSend: function (request) {
					request.setRequestHeader('Content-Encoding', 'utf-8');
				},
				data: JSON.stringify({interactionID: interactionID, contact: contact, data: data}),
				async: true,
				success: function (ajaxResponse) {
					if (cb)
						cb(ajaxResponse.status, ajaxResponse.result);
				},
				error: function (ajaxError) {
					if (cb) {
						cb(false, icc.ui.message('ajax_error', {status: ajaxError.status, statusText: ajaxError.statusText}));
					}
				}
			});
		} else {
			if (cb) {
				cb(true, null);
			}
		}
	}

	var saveAll = new icc.ui.button({action: 'save-all', visible: false, width: 1, height: 1, x: 0, y: 0}, self.environment);
	self.onReady(function () {
		icc.ui.getApplication().setSettings({forceFullResize: false});// Saca el resize para la post encuesta que se puso durante el chat.
		for (k in self.environment.datasources) {
			var ds = self.environment.datasources[k];
			ds.set("_HasPostSurvey", true);
			ds.environment.form = self;
		}
		if (eval("try { chatformcontainer !== undefined } catch(e) { false }")) {
			if (args.type === "embedded" && !args.debug) {
				iFrameEventListener.setCurrentForm("postsurvey");
			}
			chatformcontainer.start();
		}
	});

	saveAll.onClick(function () {
		for (k in environment.datasources) {
			var ds = environment.datasources[k];
			environment.changed_datasources[ds.config.name] = ds.mode;
		}
	});
	saveAll.onPostExecute(function (status) {
		if (status) {
			self.eachCtrl(function (ctrl) {
				if (ctrl.setEnabled)
					ctrl.setEnabled(false);
			});
			if (eval("try { chatformcontainer !== undefined } catch(e) { false }") && chatformcontainer.closeOnFinish) {
				if (args.type !== "embedded") {
					window.close();
				}
				else {
					iFrameEventListener.closeChat();
				}
			}
		}
	});
	self.childs.push(saveAll);
	finish.onPostExecute = function (fn) {
		saveAll.onPostExecute(fn);
	};

	self.onReady(function () {
		finish.onClick(function () {
			if (args.debug) {
				return;
			}
			function go() {
				var r = validateDatasources(self);
				setSurveyID(self, args.SESSIONID);
				updatePresurveyArgs(self, args);
				if (r) {
					send_postSurveyData(args.SESSIONID, function (status, result) {
						if (status) {
							saveAll.fireEvent("onClick");
						} else {
							icc.ui.displayMessage(result);
						}
					});
				}
			}
			var captcha = getCaptcha(self);
			if (captcha && captcha.control) {
				captcha.control.validate(function(status, result) {
					if (status) {
						go();
					}
					else {
						icc.ui.displayMessage(result);
					}
				});
			}
			else {
				go();
			}
		});
	});
}
