/*jslint evil:true nomen:false regexp: false */
/*global $ jQuery window*/

(function(global) {

/**
* Utilites namespace.
*/
var util = {};

/**
* Executes the given function when the page is loaded.
*/
var pageLoaded = false;

util.onload = function (fn)
{
	if("document" in global && document.readyState === "complete" || pageLoaded) {
		return fn();
	}

	util.on(global, "load", fn, false);
};

/**
* Adds an event.
*/
util.on = function (element, event, fn, capture)
{
	if(element.attachEvent) {
		element.attachEvent("on" + event, fn);
	}
	else if(element.addEventListener) {
		element.addEventListener(event, fn, capture);
	}
};


var container_id = "$container_id";
var token = "$token";
var proyect_id = "$projectid";
/**
* Build the address according to wether the script is hosted on an https site or an http site.
*/
var address;

address = "$protocol://$hostname"
if("$protocol" === "http" && $hostport !== 80)
	address+=":"+$hostport
if("$protocol" === "https" && $hostport !== 443)
	address+=":"+$hostport


// load json.js if needed (yes, you, IE7)
if(!("JSON" in global)) {
	(function() {
		var node = document.createElement('script'); node.type = 'text/javascript'; node.async = true;
		node.src = address + '/weblibs/lib/json/json2.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(node, s);
	})();
}


var got_jquery = function() {

	var $ = jQuery;
	// load jquery bpopup
	(function() {
		var node = document.createElement('script'); node.type = 'text/javascript'; node.async = true;
		node.src = address + '/inconcert/apps/webdesigner/lib/jquery-bpopup/jquery.bpopup.min.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(node, s);
	})();

	function gatherParameters() {
			var snippet_parameters = $snippet_parameters;
			var parameters = [];
			for (var i = 0; i < snippet_parameters.length; i++) {
				var param = snippet_parameters[i];
				// we use short names so we don't exceed the GET url limit
				parameters[i] = {
					v: $("#" + param.controlId).val() || "",
					t: param.type,//"custom",
					a: param.alias,// "el alias"
					h: param.hidden
				};
			}
			return parameters;
	}


	$(document).ready(function() {
		
		var current_text = $("#" + container_id).text();
		$("#" + container_id).
			addClass("contactform").
			unbind("click").
			html("<a href='javascript:void(0)' style='display: block; height: 100%; width: 100%;'>" + current_text + "</a>");
		
		var bFirst=true;
		var win,ifr;
		var startup_arrived = false;
		
		$("#" + container_id + "").
			click(function() {
			
				var url = address + "/inconcert/apps/webdesigner/"+encodeURIComponent(proyect_id)+"?token=" + token;
				var gatheredParameters = gatherParameters();
				if(gatheredParameters.length > 0) {
					url = url + "&params=" + encodeURIComponent(JSON.stringify(gatheredParameters)) + "&campaignAtVCC=$campaignAtVCC"
				}
				win = document.createElement("div");
				// Here "addEventListener" is for standards-compliant web browsers and "attachEvent" is for IE Browsers.
				var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
				var eventer = window[eventMethod];
				var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";
				// Listen to message from child IFrame window

				$(win).css({
					'height':($popupHeight || 200)+"px",
					width:'31px',
					height:'31px',
					overflow:'visible',
					'background-image':"url('"+address + "/inconcert/apps/webdesigner/images/loading.gif" +"')",
					'background-repeat':'no-repeat',
				});
				
				ifr=document.createElement("iframe")
				ifr.setAttribute("src",url);
				if(bFirst){
					eventer(messageEvent, function (e) {
						switch(e.data.action){
							case "close":
								$(win).bPopup().close();
								startup_arrived=false;
							break;
							
							case "startup":
								if(startup_arrived)
									return;
								startup_arrived=true;
								$(ifr).css({
									left:"0px",
									zIndex:1
								});
								$(win).css({
									'background':'none',
									'left': ($(window).width() / 2 - $popupWidth / 2) + 'px',
									'top': ($(window).height() / 2 - $popupHeight / 2) + 'px',
									'width':($popupWidth || 320)+"px",
									'height':($popupHeight || 200)+"px"
								});
								var close = document.createElement("div");
								$(close).css({
									'background-image':"url('"+address + "/inconcert/apps/webdesigner/images/close-button.png" +"')",
									'background-repeat':'no-repeat',
									left:($popupWidth-13)+"px",
									top:"-13px",
									cursor:'pointer',
									position:'absolute',
									width:'26px',
									height:'26px',
									zIndex:50000,
								});
								$(close).click(function(){
									$(win).bPopup().close();
									startup_arrived=false;

								});
								
								win.appendChild(close);
							break;
						}

					}, false);
					bFirst=false;
				};
				$(ifr).css({
					position:'absolute',
					border:'none',
					width:'100%',
					height:'100%',
					left:"-10000px"
				});
				win.appendChild(ifr);
				
				$(win).bPopup({
					modalClose: false,
					escClose:false,
					follow: [false, false],
					opacity:0.8
				});	
				return false;
			});


	});
};

// checks that jquery has loaded. Tests explictly for 'jQuery' since other libraries like MooTools use $ too.
var checker = function () { return ("jQuery" in global); };
if(checker()) {
	got_jquery();
}
else {
	// load jquery
	(function() {
		var node = document.createElement('script'); node.type = 'text/javascript'; node.async = true;
		node.src = address + '/inconcert/apps/webdesigner/lib/jquery/jquery-1.10.2.min.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(node, s);
	})();
	
	
	var intId = setInterval(function(){
		if(checker()) {
			clearInterval(intId);
			got_jquery();
		}
	}, 100);
}

})(this);
