#!/usr/local/lua-5.1.3/bin/lua



tmppath = os.getenv("TMP") .. "\\"

convert = "\"C:\\ImageMagick-6.6.8-6\\convert.exe\""
rsvgconvert ="..\\rsvg\\rsvg-convert.exe"

package.path = package.path .. ";C:\\Users\\Fabian\\Documents\\shared\\rocks\\?\\sscm-1\\lua\\?.lua"
lom =require "lom"
json = require "json"
function domiterator(domNode,fn)

	for _,node in ipairs(domNode) do
		if type(node) == "table" then
			fn(node)
		end
	end
	
end
function toint(x)
--	return x
	return tonumber(string.format("%d",x))
end
function domsearch(tagName,domNode,fn)
	local _s;

	tagName=string.lower(tagName or "")
	if type(domNode)=="table" then
		if string.lower(domNode.tag or "") == tagName then
				local at = {}
				for k,v in pairs(domNode._attr or domNode.attr) do
					at[string.lower(k)]=v;
				end
				domNode._attr=domNode.attr;
				domNode.attr = at;
				local res
				res = fn(domNode)
				if type(res)~= "nil" then
					return res
				end
		else
			local res
			for _,v in ipairs(domNode) do
				res = domsearch(tagName,v,fn)
				if type(res) ~= "nil" then
					return res
				end
			end
		end
	end
end
function testid(domNode,regexp)
	local _,n
	_,n = string.gsub(domNode.attr["id"],regexp,"",1)
	return n==1
end
function testlabel(domNode,regexp)
	local _,n = string.gsub(domNode.attr["inkscape:label"] or "",regexp,"",1)
	return n==1

end

function makePanelFromSVG(svgfile,pkgname,pngfile)
	if not svgfile or not pkgname then
		print([[usage:
			 svgpanel.lua inputfile.svg pkgname [pngfile]
		]])
		return;
	end
	local out ={
		svgsource=svgfile;
		type="slices";
		slices={
		};
		data={
		
		}
	}
	local cvt=true;
	if pngfile then cvt = false end
	outputformat = outputformat or "png"
	pngfile = pngfile or (tmppath .. svgfile .. ".png");
	local f = io.open(svgfile,"r");
	if not f then
		error("Can't open input file" .. svgfile);
	end
	local xml = f:read("*a");
	dom= lom.parse(xml);
	if not dom then
		io.close(f);
		error("Error parsing input file" .. svgfile);
	end
	io.close(f);
	if cvt then
		local cmd = string.format("\"" .. rsvgconvert .. " " .. svgfile .. " -o "  .. pngfile .."\"")
		print(cmd)
		local r = os.execute(cmd);
		print ("RESULT ",r)
	end
	local ox=0;
	local oy=0;
	domsearch("g",dom,
		function(domNode)
			local cx = 0;
			local cy = 0;
			transform = domNode.attr["transform"]
			if transform then
				cx,cy = string.match(transform,"translate%(([%w%-]+),([%w%-]+)%)")
				cx = tonumber(cx) or 0
				cy = tonumber(cy) or 0
			end

			if domNode.attr["inkscape:groupmode"] == "layer" and testlabel(domNode,"slices") then
				
				local wx,wy,wx2,wy2;
				local cx2,cyw;
				local layer=""
				if domNode.attr["inkscape:label"] ~= "slices" then
					layer = string.gsub(domNode.attr["inkscape:label"],"slices%-","");
				end
				domsearch("rect",domNode,
					function(domNode)
						--print("Slice Id",domNode.attr["id"]);
						local width = toint(domNode.attr["width"]);
						local height = toint(domNode.attr["height"]);
						local x=	toint(domNode.attr["x"])+cx;
						local y=	toint(domNode.attr["y"])+cy;
						local cmd = string.format("\"" .. convert .. "  " .. pngfile .. " -type TrueColorMatte -background transparent -crop %sx%s+%s+%s! " .. tmppath .. "%s." .. "png"  .. "\"",
							width,
							height,
							x,y,
							domNode.attr["id"])
						local r = os.execute(cmd);
						print(cmd)
						print ("RESULT ",r)
						if r == 0 then
							local id = domNode.attr["id"]
							local mimeType="image/png";
							local slice={
								id = domNode.attr["id"];
									
								format=outputformat;
								x=x;
								y=y;
								width=width;
								height=height;
								mimeType = mimeType;
								
							}
							local sname = string.format(tmppath .. "%s." .. outputformat,domNode.attr["id"])
							local f = io.open(sname,"rb")
							if f then
								slice.data = f:read("*a")
								io.close(f)
								--os.remove(sname)
							end
							if slice.data then
								table.insert(out.slices,slice)
								out.slices[slice.id]=slice;
							end
						end
					end
				)
			elseif domNode.attr["inkscape:groupmode"] == "layer" and testlabel(domNode,"data") then
			
				domsearch("rect",domNode,
					function(domNode)
						out.data[domNode.attr["id"]]={
							width = toint(domNode.attr["width"]);
							height = toint(domNode.attr["height"]);
							x=	toint(tonumber(domNode.attr["x"]))+cx;
							y=	toint(tonumber(domNode.attr["y"]))+cy;
						}
					end)
			end
	end);
	if cvt then
		os.remove(pngfile );
	end
	if #out.slices >0 then
		local f = io.open(pkgname,"w");
		if not f then
			error("can't create output file " .. pkgname)
		end
		f:write(json.encode(out))
		io.close(f)
	else
		error("slices count == 0!")
	end
end

function main(params)
	makePanelFromSVG(unpack(params));
end

main(arg)
