function haveScreen(screenName){
    var app = icc.ui.getApplication()
    var views = app.getSettings().views || [];
    for (i = 0;i<views.length;i++){
	var view = views[i];
	if (view.name == screenName){
		return true;
	}
    }
}

function resizePopup(){
    var app = icc.ui.getApplication()
    app.setSettings({minScreenHeight:140});

    var config = getAppConfig()
    try{
    	document.title = "Chat";
    	if (window==window.top){
	    	if (config.wWidth && config.wHeight){
				window.resizeTo(config.wWidth ,config.wHeight);
			}
		}
    }catch(e){}
}


function validateDatasources(form){
    var r = true;
    for (k in form.environment.datasources){
	var ds = form.environment.datasources[k];
	if(ds.mode == "edit" || ds.mode == "new"){
		var currentId;
		if( ds.config.store.type == "icc_summarizer_ds"){
			currentId = ds.row().ID
			ds.set("ID","__temp__")
		}
			
		if(!ds.readyToExecute("save")){

			var field_errors = {};
			var c=0;
			for (k in ds.lastError.field_errors){
				if (ds.checkForField(k)){
					
					field_errors[k] = ds.lastError.field_errors[k];
					c++;
				}
			}
			ds.lastError.field_errors = field_errors;
			if(c){
				icc.ui.displayMessage(ds.lastError);
				r = false;
			}
		}
		if(ds.config.store.type == "icc_summarizer_ds"){
			ds.set("ID",currentId)
		}
		
	}
    }
    form.eachCtrl(function(ctrl){
	if(ctrl.datasource==undefined || ctrl.field == undefined){
		if (ctrl.performValidation )
			r = ctrl.performValidation (true).code == 0
	}
    })
    return r;
}
function updatePresurveyArgs(form,args){

    var typehash={}
    var namehash={}
    args.pre_survey = args.pre_survey || []
    for(k in args.pre_survey){
		var param = args.pre_survey[k];
		typehash[param.type || "custom"]=param;
		namehash[param.name] = param;
		args[param.type]=param.value;
		if (param.alias && param.alias != "pre_survey")
			args[param.alias]=param.value;
    }
    form.eachCtrl(function(ctrl){
	var name = ctrl.id;
	var value;
	var ds;
	if(ctrl.getCaption && ctrl.uiclass !== "label"){
		var t = icc.utils.trim(ctrl.getCaption())
		if(t!="")
			name=t;
	}
	if (ctrl.getText && !ctrl.chatctrl_input){
	    value = ctrl.getText();
	}else if(ctrl.getChecked){
	    value = ctrl.getChecked()
	if(value && ctrl.checkedValue != undefined)
	    value =ctrl.checkedValue
	if(!value && ctrl.uncheckedValue != undefined)
	    value =ctrl.uncheckedValue
        }

	var param = typehash[ctrl.id] || namehash[name];
		
        if(value!==undefined){
		if(param)
			param.value = value
		else{
			var t = "CUSTOM";
			if(ctrl.id=="EMAIL" 
				|| ctrl.id == "NAME" 
				|| ctrl.id == "ID" 
				|| ctrl.id == "PHONE"){
				t= ctrl.id
				if(value!==undefined)
					args[ctrl.id]=value;
			}
			
			args.pre_survey.push({type:t,alias:name,value:value})
		}		

	}
	

    });
}
function setSurveyID(form,sessionID){
  
    for (k in form.environment.datasources){
	var ds = form.environment.datasources[k];
	if(ds.mode == "edit" || ds.mode == "new"){
		if( ds.config.store.type == "icc_summarizer_ds"){
			ds.set("ID",sessionID)
		}
		
	}
    }
}

function savePartialDataToSummarizer(form,sessionID){
    var r = true;
    var invalidFields=[]
    var summarizerDSs = [];
    for (k in form.environment.datasources){
	var ds = form.environment.datasources[k];
	if(ds.mode == "edit" || ds.mode == "new" && ds.config.store.type == "icc_summarizer_ds"){
	    var currentId;
	    summarizerDSs.push(ds);	
	    if(!ds.readyToExecute("save")){
		    var field_errors = {};
		    var c=0;
		    for (k in ds.lastError.field_errors){
			    if (ds.checkForField(k)){
				    
				    field_errors[k] = ds.lastError.field_errors[k];
				    c++;
			    }else
				    invalidFields.push({ds:ds,name:k});
		    }
		    ds.lastError.field_errors = field_errors;
		    if(c){
			    icc.ui.displayMessage(ds.lastError);
			    r = false;
		    }
	    }
	}
    }
    if(r){ 
	var dslist = []
	for (var idx in summarizerDSs)
		dslist.push(summarizerDSs[idx]);
	for (var idx in invalidFields){
		var f = invalidFields[idx]
		f.ds.setFieldEnabled(f.name,false);
	}
	var saveNext = function(){
		var ds = dslist.pop();
		if (ds){
			ds.save(function(status,result){
				if (!status)
					icc.ui.displayMessage(result);
				saveNext();
			});
		}else{
		    for (var idx in invalidFields){
			    var f = invalidFields[idx]
			    f.ds.setFieldEnabled(f.name,true);
		    }
		    for (var idx in summarizerDSs){
			if (summarizerDSs[idx].mode == "browse"){
				summarizerDSs[idx].editCurrent();
			}
		    }
				
		}
	}
	saveNext();

    }

}

