module ("Contact phones")

var contactData = {"colnames":["contactId","name","accountOfficer","accountGroup","category","campaign","isVIP","isClient","lastManagementResult","importation","phones","dataitems","(rowdata)","eMail"],"rows":[["9","Fabian Pe\u00F1a","","","","",false,false,null,null,[{"countryId":"598","importName":"","phoneExtension":"","ZIP":"-1","phoneNumber":"099609642","phoneType":"CELLULAR","areaId":"99","contactId":"9"},{"countryId":"598","importName":"","phoneExtension":"2","ZIP":"-1","phoneNumber":"099532031","phoneType":"CELLULAR","areaId":"99","contactId":"9"},{"countryId":"598","importName":"","phoneExtension":"","ZIP":"-1","phoneNumber":"095458160","phoneType":"OFFICE","areaId":"94","contactId":"9"},{"countryId":"598","importName":"","phoneExtension":"3","ZIP":"-1","phoneNumber":"49290986","phoneType":"HOME","areaId":"1","contactId":"9"},{"countryId":"598","importName":"","phoneExtension":"","ZIP":"-1","phoneNumber":"27397105","phoneType":"FAX","areaId":"1","contactId":"9"}],[{"value":"fapenia@gmail.com","name":"eMail","index":0}],{"__keep":true},"fapenia@gmail.com"]],"coltypes":["string","string","string","string","string","string","boolean","boolean","integer","string","phonelist","dataitems","(rowdata)","string"]};

test("Lectura desde el array de telefonos a campos discretos",
	function(){
		expect(12)	
		stop();
		loadForm("frmTest31",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest31")
			var ds = form.environment.datasources['dsTest23']
			ok(ds != undefined,"dsTest23 está presente en el formulario");
			form.environment.arguments.dsTest23={contactId:'9'}
			var requestParams;
			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    requestParams = JSON.parse(request.data);
				    
				    setTimeout(function(){
					    request.success({"status":true,"result":icc.utils.clone(contactData)})
				    })
					
			    }
			}
			stop();
			form.onReady(function(){
			    start();
	
			    ok(ds.row(),"Datasource dsTest23 (Contactos 5.5) tiene un row activo")
			    ok(ds.row().Home=="49290986","Campo discreto Home tiene el valor del numero del 4to telefono");
			    ok(ds.row().Mobile=="099609642","Campo discreto Mobile tiene el valor del numero del 1er telefono");
			    ok(ds.row().Fax=="27397105","Campo discreto Fax tiene el valor del numero del 5to telefono");
			    ok(ds.row().Office=="095458160","Campo discreto Fax tiene el valor del numero del 3er telefono");
			    ok(ds.row().Mobile2Country=="598","Campo discreto CountryId de telefono celular 2 tiene el valor 598");

			    ok(ds.row().Mobile2AreaId=="99","Campo discreto AreaId de telefono celular 2 tiene el valor 99");
			    ok(ds.row().Mobile2Number=="099532031","Campo discreto phoneNumber de telefono celular 2 tiene el valor 099532031");
			    ok(ds.row().Mobile2Ext=="2","Campo discreto phoneExtention de telefono celular 2 tiene el valor 2");
			    ok(ds.row().MobileFull=="598099609642","Campo discreto fullNumber de telefono celular 1 tiene el valor 2");

			});

		})
	}
)
test("Modificacion de campos discretos al array de telefonos",
	function(){
		expect(20)	
		stop();
		loadForm("frmTest31",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest31")
			var ds = form.environment.datasources['dsTest23']
			ok(ds != undefined,"dsTest23 está presente en el formulario");
			form.environment.arguments.dsTest23={contactId:'9'}
			var requestParams;
			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    requestParams = JSON.parse(request.data);
				    
				    setTimeout(function(){
					    request.success({"status":true,"result":icc.utils.clone(contactData)})
				    })
					
			    }
			}
			stop();
			form.onReady(function(){
			    start();
			    ok(ds.row(),"Datasource dsTest23 (Contactos 5.5) tiene un row activo");
			    ds.editCurrent()
			    ds.set("Home","1111");
			    ds.set("Fax","3333");
			    ds.set("Office","4444");
			    ds.set("Mobile2Country","1");
			    ds.set("Mobile2AreaId","2");
			    ds.set("Mobile2Number","3");
			    ds.set("Mobile2Ext","4");
			    ds.ajax = function(request){
				    requestParams = JSON.parse(request.data);
				    request.success({"status":true,result:{rows:[],colnames:[],coltypes:[]}})
			    };
			    ok(ds.save(),"Update de datasource dsTest23 (Contactos 5.5)");
			    var hdata = {}
			    jQuery.each(requestParams.content,function(idx,param){
				hdata[param.name]=param.value
			    })
			    ok(hdata.phones,"Campo phones enviado en el update");
			    ok(hdata.phones[0].countryId == "598", "countryId telefono 0 == 598")
			    ok(hdata.phones[0].areaId == "99","areaId telefono 0 == 99")
			    ok(hdata.phones[0].phoneNumber == "+598099609642","phoneNumber telefono 0 == +598099609642 debido a la regla fullNumber de campo MobileFull")

			    ok(hdata.phones[1].countryId == "1", "countryId telefono 1 == 1")
			    ok(hdata.phones[1].areaId == "2","areaId telefono 1 == 2")
			    ok(hdata.phones[1].phoneNumber == "3","phoneNumber telefono 1 == 3")
			    ok(hdata.phones[1].phoneExtension == "4","phoneExtension telefono 1 == 4")

			    ok(hdata.phones[2].countryId == "598", "countryId telefono 2 == 498")
			    ok(hdata.phones[2].areaId == "94","areaId telefono 2 == 94")
			    ok(hdata.phones[2].phoneNumber == "4444","phoneNumber telefono 2 == 4444")
			    ok(hdata.phones[2].phoneExtension == "","phoneExtension telefono 2 == vacio")

			    ok(hdata.phones[3].countryId == "598", "countryId telefono 3 == 498")
			    ok(hdata.phones[3].areaId == "1","areaId telefono 3 == 1")
			    ok(hdata.phones[3].phoneNumber == "1111","phoneNumber telefono 3 == 1111")
			    ok(hdata.phones[3].phoneExtension == "3","phoneExtension telefono 3 == 3")

				
			});

		})
	}
)

test("Creacion de telefonos en el array a partir de campos discretos",
	function(){
		expect(14)	
		stop();
		loadForm("frmTest31",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest31")
			var ds = form.environment.datasources['dsTest23']
			ok(ds != undefined,"dsTest23 está presente en el formulario");
			var requestParams;
		    ds.ajax = function(request){
			    requestParams = JSON.parse(request.data);
			    request.success({"status":true,result:{rows:[],colnames:[],coltypes:[]}})
		    };

			ok(requestParams==undefined,"No hay request de ajax al iniciar")
			
			stop();
			form.onReady(function(){
			    start();
			    ok(!ds.row(),"Datasource dsTest23 (Contactos 5.5) no tiene un row activo");
			    ds.appendNew()
				ds.set("contactId","123")
				ds.set("name","test")
			    ds.set("MobileFull","2222");
				
			    ds.set("Home","1111");
			    ds.set("Fax","3333");
			    ds.set("Office","4444");
			    ds.set("Mobile2Country","1");
			    ds.set("Mobile2AreaId","2");
			    ds.set("Mobile2Number","3");
			    ds.set("Mobile2Ext","4");
			    ds.ajax = function(request){
				    requestParams = JSON.parse(request.data);
				    request.success({"status":true,result:{rows:[],colnames:[],coltypes:[]}})
			    };
			    ok(ds.save(),"Save de datasource dsTest23 (Contactos 5.5)");
			    var hdata = {}
			    jQuery.each(requestParams.content,function(idx,param){
					hdata[param.name]=param.value
			    })
			    ok(hdata.phones,"Campo phones enviado en el save");
			    ok(hdata.phones[0].phoneNumber == "1111","phoneNumber telefono 0 == 1111")
				
				ok(hdata.phones[1].phoneNumber == "+2222","phoneNumber telefono 1 == +2222")
				
			    ok(hdata.phones[2].phoneNumber == "3333","phoneNumber telefono 2 == 3333")
			    ok(hdata.phones[3].phoneNumber == "4444","phoneNumber telefono 3 == 1111")

			    ok(hdata.phones[4].countryId == "1","countryId telefono 3 == 1")
			    ok(hdata.phones[4].areaId 	 == "2","areaId telefono 3 == 2")
			    ok(hdata.phones[4].phoneNumber == "3","phoneNumber telefono 3 == 3")
			    ok(hdata.phones[4].phoneExtension == "4","phoneExtension telefono 3 == 4")
				
				
			});

		})
	}
)