
module("Datasource - Copy from testing module")

test("Datasource principal y de prueba iniciados en modo new - copy from durante el inicio en new",
	function(){
		expect(9);
		stop();
		loadForm("frmTest19",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest19");
			
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			var dstest = form.environment.datasources['dsTest11'];
			ok(dstest != undefined,"dsTest11 está presente en el formulario");

			stop();		
			form.onReady(function(){
			    start();	
			    ok(dstest.mode == "new","Inicio de datasource de test en modo new")
			    ok(ds.mode == "new","Inicio de datasource principal en modo new")
			    ok(ds.row()['integerField1']==1,"integerField1 de datasource principal inicializado a 1")
			    ok(dstest.row()['integerField1']==1,"integerField1 de datasource test con valor 1 debido a copy from")
			    ok(ds.row()['stringField1']=='hello1',"stringField1 de datasource principal inicializado a hello1")
			    ok(dstest.row()['stringField1']==undefined,"stringField1 de datasource de test es undefined porque no tiene copyfrom")

		
			})
		});
	}

)


test("Datasource principal iniciado en browse con registro activo y de prueba iniciado en modo new - copy from durante el inicio en new",
	function(){
		expect(9);
		stop();
		loadForm("frmTest19",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest19");
			
			var ds = form.environment.datasources['dsTest1'];
			form.environment.arguments.dsTest1={stringField1:'string'};
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			// parametro
			form.environment.arguments.dsTest1={stringField1:'string'};			
			
			var dstest = form.environment.datasources['dsTest11'];
			ok(dstest != undefined,"dsTest11 está presente en el formulario");
			var url=""
			var requestParams = {content:[]}
 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}

			stop();		
			form.onReady(function(){
			    start();	
			    ok(dstest.mode == "new","Inicio de datasource de test en modo new")
			    ok(ds.mode == "browse","Inicio de datasource principal en modo browse")
				
			    ok(ds.row()['integerField1']==11,"integerField1 de datasource principal tiene valor 11 debido al query")
			    ok(dstest.row()['integerField1']==11,"integerField1 de datasource test con valor 11 debido a copy from")
			    ok(ds.row()['stringField1']=='string1',"stringField1 de datasource principal convalor 'string1' debido al query")
			    ok(dstest.row()['stringField1']==undefined,"stringField1 de datasource de test es undefined porque no tiene copyfrom")

		
			})
		});
	}

)


test("Copia datos cuando ambos se encuentram en modo new y el campo del datasource principal es modificado",
	function(){
		expect(13);
		stop();
		loadForm("frmTest20",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest20");
			
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var dstest = form.environment.datasources['dsTest12'];
			ok(dstest != undefined,"dsTest12 está presente en el formulario");
			stop();		
			form.onReady(function(){
			    start();	
			    ok(dstest.mode == "new","Inicio de datasource de test en modo new")
			    ok(ds.mode == "new","Inicio de datasource principal en modo new")
			    ok(ds.row()['integerField1']==1,"integerField1 de datasource principal tiene valor 1 = initialValue")
			    ok(dstest.row()['integerField1']==1,"integerField1 de datasource test con valor 1 debido a copy from")
			    ok(ds.row()['stringField1']=='hello1',"stringField1 de datasource principal tiene valor 'hello1' = initialValue")
			    ok(dstest.row()['stringField1']=='hello1',"stringField1 de datasource de test tiene valor 'hello1' debido a copy from")
				dstest.set('stringField1','hello2');
				ok(dstest.row()['stringField1']=='hello2',"stringField1 de datasource de test tiene valor 'hello2' luego de hacerle set")				
				ds.set("integerField1",28)
			    ok(ds.row()['integerField1']==28,"integerField1 de datasource principal tiene valor 28 luego de hacer un set")
			    ok(dstest.row()['integerField1']==28,"integerField1 de datasource test con valor 28 debido a copy from")
			    ok(dstest.row()['stringField1']=='hello2',"stringField1 de datasource test no es afectado por un set de un campo con copy from que no le corresponta")
			})
		});
	}

)

test("Grabacion de datasource principal seguido de datasource de test",
	function(){
		expect(13);
		stop();
		loadForm("frmTest20",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest20");
			
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var dstest = form.environment.datasources['dsTest12'];
			ok(dstest != undefined,"dsTest12 está presente en el formulario");
			var ds_requestParams;
			var dstest_requestParams;
			
 			if(ds){
			    ds.ajax = function(request){
				    ds_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}
 			if(dstest){
			    dstest.ajax = function(request){
				    dstest_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}

			
			stop();		
			form.onReady(function(){
			    start();	
				ok(ds.save() == true,"save de datasource principal retorna true");
			    jQuery(ds_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource principal request param "+param.name + " Tiene el valor 11 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello1',"datasource principal request param "+param.name + " Tiene el valor 'hello1' esperado");
						break;
						
					}
			    });
				ok(ds.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(ds.transaction_data.length == 0,"Datasource principal queda sin transacciones pendientes")
				

				ok(dstest.save() == true,"save de datasource de test retorna true");
				
			    jQuery(dstest_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource test request param "+param.name + " Tiene el valor 1 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello1',"datasource test request param "+param.name + " Tiene el valor 'hello1' esperado");
						break;
						
					}
			    });
				ok(dstest.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(dstest.transaction_data.length == 0,"Datasource de test queda sin transacciones pendientes")
				
			})
		});
	}

)

test("Grabacion de datasource de test encolado seguido de datasource de principal",
	function(){
		expect(15);
		stop();
		loadForm("frmTest20",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest20");
			
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var dstest = form.environment.datasources['dsTest12'];
			ok(dstest != undefined,"dsTest12 está presente en el formulario");
			var ds_requestParams;
			var dstest_requestParams;
			
 			if(ds){
			    ds.ajax = function(request){
				    ds_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}
 			if(dstest){
			    dstest.ajax = function(request){
				    dstest_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}

			
			stop();		
			form.onReady(function(){
			    start();	

				ok(dstest.save() == true,"save de datasource de test retorna true");
				ok(dstest_requestParams==undefined,"No se ejecuto ninguna operacion de save hacia el servidor");
				ok(dstest.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(dstest.transaction_data.length == 1,"Datasource de test queda con 1 transaccion pendiente")


				ok(ds.save() == true,"save de datasource principal retorna true");
			    jQuery(ds_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource principal request param "+param.name + " Tiene el valor 11 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello1',"datasource principal request param "+param.name + " Tiene el valor 'hello1' esperado");
						break;
						
					}
			    });
				ok(ds.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(ds.transaction_data.length == 0,"Datasource principal queda sin transacciones pendientes")

			    jQuery(dstest_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource test request param "+param.name + " Tiene el valor 1 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello1',"datasource test request param "+param.name + " Tiene el valor 'hello1' esperado");
						break;
						
					}
			    });
				ok(ds.transaction_data.length == 0,"Datasource test queda sin transacciones pendientes")
			})
		});
	}

)

test("Grabacion de datasource de test encolado seguido de datasource de principal con modificacion de datos posteriores a la grabacion",
	function(){
		expect(15);
		stop();
		loadForm("frmTest20",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest20");
			
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var dstest = form.environment.datasources['dsTest12'];
			ok(dstest != undefined,"dsTest12 está presente en el formulario");
			var ds_requestParams;
			var dstest_requestParams;
			
 			if(ds){
			    ds.ajax = function(request){
				    ds_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}
 			if(dstest){
			    dstest.ajax = function(request){
				    dstest_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}

			
			stop();		
			form.onReady(function(){
			    start();	

				ok(dstest.save() == true,"save de datasource de test retorna true");
				ok(dstest_requestParams==undefined,"No se ejecuto ninguna operacion de save hacia el servidor");
				ok(dstest.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(dstest.transaction_data.length == 1,"Datasource de test queda con 1 transaccion pendiente")

				ds.set("stringField1","hello3");
				ok(ds.save() == true,"save de datasource principal retorna true");
			    jQuery(ds_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource principal request param "+param.name + " Tiene el valor 11 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello3',"datasource principal request param "+param.name + " Tiene el valor 'hello3' esperado");
						break;
						
					}
			    });
				ok(ds.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(ds.transaction_data.length == 0,"Datasource principal queda sin transacciones pendientes")

			    jQuery(dstest_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource test request param "+param.name + " Tiene el valor 1 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello3',"datasource test request param "+param.name + " Tiene el valor 'hello3' esperado");
						break;
						
					}
			    });
				ok(ds.transaction_data.length == 0,"Datasource test queda sin transacciones pendientes")
			})
		});
	}

)
test("Grabacion de multiples registros del datasource de test encolados seguido de datasource de principal con modificacion de datos posteriores a la grabacion",
	function(){
		expect(24);
		stop();
		loadForm("frmTest20",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest20");
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			var dstest = form.environment.datasources['dsTest12'];
			ok(dstest != undefined,"dsTest12 está presente en el formulario");
			var ds_requestParams;
			var dstest_requestParams=[];
 			if(ds){
			    ds.ajax = function(request){
				    ds_requestParams = JSON.parse(request.data);
				    request.success({"status":true})
			    }
			}
 			if(dstest){
			    dstest.ajax = function(request){
					dstest_requestParams.push(JSON.parse(request.data))
				    request.success({"status":true})
			    }
			}
			stop();		
			form.onReady(function(){
			    start();	
				ok(dstest.save() == true,"save de datasource de test retorna true");
				ok(dstest_requestParams.length==0,"No se ejecuto ninguna operacion de save hacia el servidor");
				ok(dstest.mode == "browse", "Datasource test queda en modo browse luego del save")
				ok(dstest.transaction_data.length == 1,"Datasource de test queda con 1 transaccion pendiente")
				
				dstest.appendNew()
				ok(dstest.mode == "new", "Datasource test queda en modo new luego de hacer appendNew")
				ok(dstest.save() == true,"save de datasource de test retorna true");
				
				dstest.appendNew()
				ok(dstest.mode == "new", "Datasource test queda en modo new luego de hacer appendNew")
				dstest.set("integerField1",15);
				ok(dstest.save() == true,"save de datasource de test retorna true");
				
				ds.set("stringField1","hello3");
				ok(ds.save() == true,"save de datasource principal retorna true");
				
			    jQuery(ds_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 1,"datasource principal request param "+param.name + " Tiene el valor 11 esperado");
						break;
						case 'stringField1':
							ok(param.value === 'hello3',"datasource principal request param "+param.name + " Tiene el valor 'hello1' esperado");
						break;
						
					}
			    });
				ok(ds.mode == "browse", "Datasource principal queda en modo browse luego del save")
				ok(ds.transaction_data.length == 0,"Datasource principal queda sin transacciones pendientes")
				
				ok(dstest_requestParams.length == 3,"Datasource test hace 3 envios al server");
				
				jQuery([dstest_requestParams[0].content,dstest_requestParams[1].content]).each(function(n,requestParams){
					jQuery(requestParams).each(function(idx,param){
						switch(param.name){
							case 'integerField1':
								ok(param.value === 1,"datasource test request param "+param.name + " Tiene el valor 1 esperado");
							break;
							case 'stringField1':
								ok(param.value === 'hello3',"datasource test request param "+param.name + " Tiene el valor 'hello1' esperado");
							break;
							
						}
					});
				});
				

			    jQuery(dstest_requestParams[2].content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 15,"datasource test request param "+param.name + " Tiene el valor 15 seteado por el usuario no afectado por el copy from");
						break;
						case 'stringField1':
							ok(param.value === 'hello3',"datasource test request param "+param.name + " Tiene el valor 'hello1' esperado");
						break;
					}
			    });
				
				ok(ds.transaction_data.length == 0,"Datasource test queda sin transacciones pendientes");
				
			})
		});
	}

)


test("editCurrent automatico cuando el datasource principal es editado y no hay boton de edit explicito",
	function(){
		expect(10);
		stop();
		loadForm("frmTest19",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest19");
			
			var ds = form.environment.datasources['dsTest1'];
			// parametro

			form.environment.arguments.dsTest1={stringField1:'string'};
			
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			// parametro
			form.environment.arguments.dsTest11={stringField1:'string'};			
			
			var dstest = form.environment.datasources['dsTest11'];
			ok(dstest != undefined,"dsTest11 está presente en el formulario");
			var url=""
			var requestParams = {content:[]}
 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}
			
 			if(dstest){
			    dstest.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}
			

			stop();		
			form.onReady(function(){
			    start();	
			    ok(dstest.mode == "browse","Inicio de datasource de test en modo browse")
				ok(dstest.row() != undefined,"Datasource de test tiene registro activo")
				
			    ok(ds.mode == "browse","Inicio de datasource principal en modo browse")
				ok(ds.row() != undefined,"Datasource principal tiene registro activo")
				
				ds.set("stringField1",'hello2');
			    ok(ds.mode == "edit","Datasource principal cambia a modo edit debido a un set")
			    ok(dstest.mode == "browse","Datasource test sigue en modo browse porque el campo no esta vinculado")
				
				ds.set("integerField1",28);
				
			    ok(dstest.mode == "edit","Datasource cambia a modo edit porque se editó el campo del datasource principal que esta vinculado")
		
			})
		});
	}

)

test("editCurrent automatico no se realiza por haber un boton de edit",
	function(){
		expect(10);
		stop();
		loadForm("frmTest21",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest21");
			
			var ds = form.environment.datasources['dsTest1'];
			// parametro

			form.environment.arguments.dsTest1={stringField1:'string'};
			
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			// parametro
			form.environment.arguments.dsTest11={stringField1:'string'};			
			
			var dstest = form.environment.datasources['dsTest11'];
			ok(dstest != undefined,"dsTest11 está presente en el formulario");
			var url=""
			var requestParams = {content:[]}
 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}
			
 			if(dstest){
			    dstest.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}
			

			stop();		
			form.onReady(function(){
			    start();	
			    ok(dstest.mode == "browse","Inicio de datasource de test en modo browse")
				ok(dstest.row() != undefined,"Datasource de test tiene registro activo")
				
			    ok(ds.mode == "browse","Inicio de datasource principal en modo browse")
				ok(ds.row() != undefined,"Datasource principal tiene registro activo")
				
				ds.set("stringField1",'hello2');
			    ok(ds.mode == "edit","Datasource principal cambia a modo edit debido a un set")
			    ok(dstest.mode == "browse","Datasource test sigue en modo browse porque el campo no esta vinculado")
				
				ds.set("integerField1",28);
				
			    ok(dstest.mode == "browse","Datasource sigue en modo browse aunque se editó el campo del datasource principal que esta vinculado.")
		
			})
		});
	}

)

test("grabacion de datasource de test modificado sin copiar campos porque no han sido modificados",
	function(){
		expect(11);
		stop();
		loadForm("frmTest20",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest19");
			
			var ds = form.environment.datasources['dsTest1'];
			// parametro

			form.environment.arguments.dsTest1={stringField1:'string'};
			
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			// parametro
			form.environment.arguments.dsTest12={stringField1:'string'};			
			
			var dstest = form.environment.datasources['dsTest12'];
			ok(dstest != undefined,"dsTest12 está presente en el formulario");
			var url=""
			var requestParams = {content:[]}
 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}
			
 			if(dstest){
			    dstest.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,14,'string10'],
							[2,24,'string20']
						],"count":2,"coltypes":[]}})

				    })
			    }
			}
			

			stop();		
			form.onReady(function(){
			    start();	
			    ok(dstest.mode == "browse","Inicio de datasource de test en modo browse")
				ok(dstest.row() != undefined,"Datasource de test tiene registro activo")
				
			    ok(ds.mode == "browse","Inicio de datasource principal en modo browse")
				ok(ds.row() != undefined,"Datasource principal tiene registro activo")
				dstest.set("integerField1",40);
			    ok(dstest.mode == "edit","Datasource test esta en modo edit luego de un set")
			    dstest.ajax = function(request){
					dstest_requestParams =JSON.parse(request.data);
				    request.success({"status":true})
			    }
				
				ok(dstest.save() == true, "Datasource test save devuelve true");
			    jQuery(dstest_requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'integerField1':
							ok(param.value === 40,"datasource test request param "+param.name + " Tiene el valor 40 seteado por el usuario no afectado por el copy from");
						break;
						case 'stringField1':
							ok(param.value === 'string10',"datasource test request param "+param.name + " Tiene el valor 'string10' esperado");
						break;
					}
			    });
			})
		});
	}

)
