
module("Datasource - Startup behavior")

test("Inicio en modo browse sin popular cuando no hay control que permita navegacion ni boton de guardado",
	function(){
		expect(7)	
		stop();
		loadForm("frmTest1",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest1")
			var ds = form.environment.datasources['dsTest1']
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var rows_populated_event = false;
			var ready_event = false;
			var serverCall=false;
			if(ds){
			    ds.ajax = function(request){
				    serverCall = true;
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event==false,"Evento rows.populated no recibido");
			    ok(ready_event,"Evento ready recibido");
			    ok(serverCall == false,"No se hizo llamado al server");	
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");	
			});
		})
			

	}
);


test("Inicio en modo browse populando por la presencia de una grilla",
	function(){
	    expect(11);
		stop();
		loadForm("frmTest2",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest2")	
			
			var ds = form.environment.datasources['dsTest1']
		    	ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicializado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
				    default:
					    ok(param.value == undefined,"request param "+param.name + " No tiene valor");
				    break;

				}
			    });

			});
		})
			

	}
);

test("Inicio en modo browse populando por la presencia de boton de navegacion Next",
	function(){
		expect(10);
		stop();		
		loadForm("frmTest3",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest3")	
			var ds = form.environment.datasources['dsTest1']
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);

				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
				    default:
					    ok(param.value == undefined,"request param "+param.name + " No tiene valor");
				    break;

				}
			    });

			});
		})
			

	}
);

test("Inicio en modo browse populando por la presencia de boton de navegacion Prev",
	function(){
  	    expect(11)
		stop();
		loadForm("frmTest4",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest4")	
			var ds = form.environment.datasources['dsTest1']
			ok(ds != undefined,"dsTest1 está presente en el formulario");
	
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;
			var url=""
			var requestParams = {content:[]}

			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);

				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
				    default:
					    ok(param.value == undefined,"request param "+param.name + " No tiene valor");
				    break;

				}
			    });

			});
		})
			

	}
);

test("Inicio en modo browse populando por la presencia de boton de browse-with",
	function(){
	    expect(11);
		stop();
		loadForm("frmTest5",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest5");
			var ds = form.environment.datasources['dsTest1'];
		    ok(ds != undefined,"dsTest1 está presente en el formulario");
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;
			var url=""
			var requestParams = {content:[]}

			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);

				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
				    default:
					    ok(param.value == undefined,"request param "+param.name + " No tiene valor");
				    break;

				}
			    });

			    
			});
		})
			

	}
);
test("Inicio en modo browse populando por la presencia de un combobox con rows source",
	function(){
		expect(11);
		stop();
		
		loadForm("frmTest6",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest6")	
			var ds = form.environment.datasources['dsTest1']
			ok(ds != undefined,"dsTest1 está presente en el formulario");
						
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}
			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);

				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	

			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
				    default:
					    ok(param.value == undefined,"request param "+param.name + " No tiene valor");
				    break;

				}
			    });

			});
		})
			

	}
);
test("Inicio en modo browse populando por encontrar parametros de entrada",
	function(){
		expect(11)
		stop();
		loadForm("frmTest1",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest1")	
			form.environment.arguments.dsTest1={stringField1:'string'}
			var ds = form.environment.datasources['dsTest1']
		    ok(ds != undefined,"dsTest1 está presente en el formulario");
						
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}
			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
					
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	

			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
					case 'stringField1':
						ok(param.value == "string","request param stringField1 tiene el valor esperado");
					break;
					default:
						ok(param.value == undefined,"request param "+param.name + " No tiene valor");
					break;

				}
			    });
			});
		})
			

	}
);
test("Inicio en modo browse populando por presencia de control \"browse\" (grilla,prev,etc) y con parametros de entrada",
	function(){
		
		expect(11)
		stop();
		loadForm("frmTest2",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest2")	
			form.environment.arguments.dsTest1={stringField1:'string'}
			var ds = form.environment.datasources['dsTest1']

		    ok(ds != undefined,"dsTest1 está presente en el formulario");
						
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}
			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
					
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")

			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");
			    jQuery(requestParams.content).each(function(idx,param){
				switch(param.name){
					case 'stringField1':
						ok(param.value == "string","request param stringField1 tiene el valor esperado");
					break;
					default:
						ok(param.value == undefined,"request param "+param.name + " No tiene valor");
					break;

				}
			    });
			});
		})
			

	}
);
test("Inicio en modo browse con grilla pero sin popular por presencia de datasource que tiene una relacion",
	function(){
		expect(6);
		stop();
		loadForm("frmTest7",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest7")	
			var ds = form.environment.datasources['dsTest3']
			ok(ds != undefined,"dsTest3 está presente en el formulario");

			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}
			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
					
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest3 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event==false,"Evento rows.populated no recibido");
			    ok(ready_event==true,"Evento ready recibido");
			    ok(serverCall == false,"No hizo llamado al server");	
			});
		})
	}
);
test("Inicio en modo browse populando por presencia de una grilla sin posicionar en el primer registro",
	function(){
		expect(12)
		stop();
		loadForm("frmTest2",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest2")	
			
			var ds = form.environment.datasources['dsTest1']
		    ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse");
				
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==2,"dsTest1 retorna 2 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
					switch(param.name){
						default:
							ok(param.value == undefined,"request param "+param.name + " No tiene valor");
						break;

					}
			    });
				ok(ds.row()==undefined,"row() Devuelve undefined no esta posicionado en el principio");
			});
		})
			

	}
);

test("Inicio en modo browse populando por parametros y no posicionadose en el primer registro por haber una grilla",
	function(){
	
		expect(12)
		stop();
		loadForm("frmTest2",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest2");	
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			form.environment.arguments.dsTest1={stringField1:'string'}
			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==2,"dsTest1 retorna 2 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'stringField1':
							ok(param.value == 'string',"request param "+param.name + " Tiene el valor esperado");
						break;
						default:
							ok(param.value == undefined,"request param "+param.name + " No tiene valor");
						break;

					}
			    });
				ok(ds.row()==undefined,"row() Devuelve undefined no esta posicionado en el principio");
				

			});
		})
			

	}
);
test("Inicio en modo browse populando por parametros y posicionado en el primero por no haber grilla",
	function(){
		expect(13);
		stop();
		loadForm("frmTest1",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest1");
			var ds = form.environment.datasources['dsTest1'];
			form.environment.arguments.dsTest1={stringField1:'string'};
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;
			var url=""
			var requestParams = {content:[]}
 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");

			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest1/get")!=-1,"La url llamada contiene 'dsTest1/get'")
			    ok(ds.records().length ==2,"dsTest1 retorna 2 rows");	
			    jQuery(requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'stringField1':
							ok(param.value == 'string',"request param "+param.name + " Tiene el valor esperado");
						break;
						default:
							ok(param.value == undefined,"request param "+param.name + " No tiene valor");
						break;

					}
			    });
				ok(ds.row()!=undefined,"row() Devuelve un registro activo");
				ok(ds.row().integerField1==11 ,"row() Devuelve el primer registro");
				
				

			});
		})
			

	}
);

test("Inicio en modo browse populando con grilla y filtro mediante una constante",
	function(){
		expect(12)
		stop();
		loadForm("frmTest8",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest8");
			var ds = form.environment.datasources['dsTest4']
		    ok(ds != undefined,"dsTest4 está presente en el formulario");
			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest4 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest4/get")!=-1,"La url llamada contiene 'dsTest4/get'")
			    ok(ds.records().length ==2,"dsTest1 retorna 2 rows");
			    ok(requestParams.context.filter == "default", "Llamada al server usando el filtro")	
			    jQuery(requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'field1':
							ok(param.value == 'pepe',"request param "+param.name + " Tiene el valor esperado");
						break;
						default:
							ok(param.value == undefined,"request param "+param.name + " No tiene valor");
						break;

					}
			    });

				

			});
		})
			

	}
);
test("Inicio en modo browse sin popular por no tener todos los datos para el filtro.",
	function(){
		expect(7)
		stop();
		loadForm("frmTest9",function(status,form,controls){
			start();
		    ok(status,"Carga del formulario frmTest9");
			var ds = form.environment.datasources['dsTest5']
		    ok(ds != undefined,"dsTest5 está presente en el formulario");
			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest5 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event==true,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == false,"No se hizo llamado al server");
			    ok(ds.records().length==0,"Inicializado con 0 rows");


			});
		})
	}
);

test("Inicio en modo browse populando al tener grilla y descartando el filtro no usado al no tener controles.",
	function(){
		expect(12)
		stop();
		loadForm("frmTest10",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest10")	
			var ds = form.environment.datasources['dsTest5']
			ok(ds != undefined,"dsTest5 está presente en el formulario");
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest5 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == true,"Se hizo llamado al server");	
			    ok(url.indexOf("dsTest5/get")!=-1,"La url llamada contiene 'dsTest5/get'")
			    ok(ds.records().length ==2,"dsTest5 retorna 2 rows");
			    ok(requestParams.context.filter == undefined, "Llamada al server no usando el filtro")	
			    jQuery(requestParams.content).each(function(idx,param){
					switch(param.name){
						default:
							ok(param.value == undefined,"request param "+param.name + " No tiene valor");
						break;

					}
			    });

				


			});
		})
	}
);


test("Inicio en modo new por presencia de boton save y sin grilla",
	function(){
		expect(8);
		stop();
		loadForm("frmTest11",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest11")	
			var ds = form.environment.datasources['dsTest1'];
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="new","dsTest1 se encuentra inicialiado en modo new")
			    ok(rows_populated_event == false,"Evento rows.populated no recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(serverCall == false,"No se hizo llamado al server");	
			    ok(ds.records().length ==0,"dsTest1 retorna 0 rows");
			    ok(ds.row() != undefined , "dsTest1 retorna un registro activo")

			});
		})
	}
);

test("Inicio en modo browse con grilla y boton de save",
	function(){
		expect(6)
		stop();
		loadForm("frmTest12",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest12")	
			var ds = form.environment.datasources['dsTest1']
			ok(ds != undefined,"dsTest1 está presente en el formulario");
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,11,'string1'],
							[2,12,'string2']
						],"count":2,"coltypes":[]}})

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(ds.mode=="browse","dsTest1 se encuentra inicialiado en modo browse")
			    ok(rows_populated_event == true,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    ok(ds.records().length ==2,"dsTest1 retorna 2 rows");

			});
		})
	}
);

test("Inicio con carga de interaccion usando INTERACTIONID y cambiando a modo edit por control de reagendado",
	function(){
		expect(7)
		stop();
		loadForm("frmTest13",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest13")	
			var ds = form.environment.datasources['dsTest6']
			ok(ds != undefined,"dsTest6 está presente en el formulario");

			form.environment.arguments={INTERACTIONID:'12324'}			
			var serverCall=false;
			var rows_populated_event = false;
			var ready_event = false;

			var url=""
			var requestParams = {content:[]}

 			if(ds){
			    ds.ajax = function(request){
				    url = request.url;
				    serverCall = true;
				    requestParams = JSON.parse(request.data);
				    setTimeout(function(){
   					    request.success(
						{"status":true,"result":{"colnames":["Id","ChannelInstance","Type","CreationDate","StartDate","EndDate","LastUpdate","QueuedDate","State","ChannelState","ContactAddress","Campaign","Agent","Initiative","Contact","ContactName","ManagementResult","Dnis","CallerId","CalledId","MailFrom","MailTo","VirtualCC","WorkitemType"],"rows":[["12324","TAPI","TAPI","2011-06-04 00:22:00.000","2011-06-04 00:22:00.000","2011-06-04 00:22:00.000","2011-06-04 00:22:00.000","2011-06-04 00:22:00.000","ENDED","ENDED","+59895458160","campania_prueba","Agent5","INBOUND",null,null,null,null,"09967892","099678921","fapenia@adinet.com.uy","gwinkler@inconcertcc.com","system","WF_USUCOL"]],"coltypes":["string","string","string","datetime","datetime","datetime","datetime","datetime","string","string","string","string","string","string","string","string","string","string","string","string","string","string","string","string"]}}
					    )

				    })
			    }
			    var h1 = ds.addListener("rows.populated",
				function(){
					rows_populated_event = true;	
					ds.rmvListener(h1);
				}
			    )	
			    var h2 = ds.addListener("ready",
				function(){
					ready_event = true;	
					ds.rmvListener(h2);
				}
			    )	

			}
			stop();
			form.onReady(function(){
			    start();	
			    ok(rows_populated_event == true,"Evento rows.populated recibido");
			    ok(ready_event==false,"Evento ready no recibido");
			    jQuery(requestParams.content).each(function(idx,param){
					switch(param.name){
						case 'Id':
							ok(param.value == '12324',"request param "+param.name + " Tiene el valor esperado");
						break;

						default:
							ok(param.value == undefined,"request param "+param.name + " No tiene valor");
						break;

					}
			    });

			    ok(ds.mode=="edit","dsTest6 se encuentra inicialiado en modo edit")
			    ok(ds.records().length ==1,"dsTest6 retorna 1 rows");
			});
		})
	}
);
