
module("Required field")

test("Save - Requerido por campo de base de datos con allowNull == false",
	function(){
		expect(6);
		stop();
		loadForm("frmTest22",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest22");
			var ds = form.environment.datasources['dsTest13'];
			ok(ds != undefined,"dsTest13 está presente en el formulario.");
 			if(ds){
			    ds.ajax = function(request){
				    request.success({"status":true})
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(ds.save() == false , "Operación save retorna false")
				ok(ds.lastError.code == 1030,"Código de error de operación save == 1030")
				ok(ds.lastError.field_errors.stringField1, "Error en el campo stringField1")
				ok(ds.lastError.field_errors.stringField1.code==1020, "Error en el campo stringField1 == 1020")
			});
		})
	}
);

test("Save - Requerido por configuracion required always",
	function(){
		expect(6);
		stop();
		loadForm("frmTest23",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest23");
			var ds = form.environment.datasources['dsTest14'];
			ok(ds != undefined,"dsTest14 está presente en el formulario.");
 			if(ds){
			    ds.ajax = function(request){
				    request.success({"status":true})
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(ds.save() == false , "Operación save retorna false")
				ok(ds.lastError.code == 1030,"Código de error de operación save == 1030")
				ok(ds.lastError.field_errors.stringField1, "Error en el campo stringField1")
				ok(ds.lastError.field_errors.stringField1.code==1020, "Error en el campo stringField1 == 1020")
			});
		})
	}
);

test("Save - Requerido por configuracion required dependiente del resultado de una expresion",
	function(){
		expect(7);
		stop();
		loadForm("frmTest25",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest25");
			var ds = form.environment.datasources['dsTest16'];
			ok(ds != undefined,"dsTest16 está presente en el formulario.");
 			if(ds){
			    ds.ajax = function(request){
				    request.success({"status":true})
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(ds.save() == false , "Operación save retorna false por no cumplir la condicion")
				ok(ds.lastError.code == 1030,"Código de error de operación save == 1030")
				ok(ds.lastError.field_errors.stringField1, "Error en el campo stringField1")
				ok(ds.lastError.field_errors.stringField1.code==1020, "Error en el campo stringField1 == 1020")
				ds.set("stringField2","test2");
				ok(ds.save() == true , "Operación save retorna true al cumplirse la condicion")
			});
		})
	}
);
test("Save - Campo requerido por datasource con campo requerido con copy from apuntando hacia él",
	function(){
		expect(6);
		stop();
		loadForm("frmTest26",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest26");
			var ds = form.environment.datasources['dsTest17'];
			ok(ds != undefined,"dsTest17 está presente en el formulario.");
			ok(form.environment.datasources['dsTest18'],"dsTest18 está presente en el formulario.")
 			if(ds){
			    ds.ajax = function(request){
				    request.success({"status":true})
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(ds.save() == false , "Operación save retorna false")
				ok(ds.lastError.code == 1030,"Código de error de operación save == 1030")
				ok(ds.lastError.field_errors.stringField1, "Error en el campo stringField1")
			});
		})
	}
);

test("Get - Requerido por campo de operacion de request con allowNull == false",
	function(){
		expect(8);
		stop();
		loadForm("frmTest27",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest27");
			var ds = form.environment.datasources['dsTest19'];
			
			ok(ds != undefined,"dsTest19 está presente en el formulario.");
			var fireRequest=false;
 			if(ds){
			    ds.ajax = function(request){
					fireRequest = true;
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
					
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(fireRequest == false,"Request inicial no realizado.")
				ok(ds.mode == "browse","Modo inicial == browse")
				ds.refresh();
				ok(fireRequest == false,"Request no realizado.")
				ok(ds.lastError.code == 1030,"Código de error de operación get == 1030")
				ok(ds.lastError.field_errors.stringField1, "Error en el campo stringField1")
				ok(ds.lastError.field_errors.stringField1.code==1020, "Error en el campo stringField1 == 1020")
			});
		})
	}
);
test("Get - Ignora filtro por no tener campos asignados en el formulario",
	function(){
		expect(4);
		stop();
		loadForm("frmTest28",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest28");
			var ds = form.environment.datasources['dsTest20'];
			
			ok(ds != undefined,"dsTest20 está presente en el formulario.");
			var fireRequest=false;
 			if(ds){
			    ds.ajax = function(request){
					fireRequest = true;
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
					
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(fireRequest == true,"Request realizado.")
				ok(ds.mode == "browse","Modo inicial == browse")
				ds.refresh();
			});
		})
	}
);

test("Get - Requerido por parametro de filtro no nullable",
	function(){
		expect(8);
		stop();
		loadForm("frmTest29",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest29");
			var ds = form.environment.datasources['dsTest20'];
			
			ok(ds != undefined,"dsTest20 está presente en el formulario.");
			var fireRequest=false;
 			if(ds){
			    ds.ajax = function(request){
					fireRequest = true;
				    setTimeout(function(){
					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[],"count":0,"coltypes":[]}})
				    })
					
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				ok(fireRequest == false,"Request inicial no realizado.")
				ok(ds.mode == "browse","Modo inicial == browse")
				ds.refresh();
				ok(fireRequest == false,"Request no realizado.")
				ok(ds.lastError.code == 1030,"Código de error de operación get == 1030")
				ok(ds.lastError.field_errors['@stringField1'], "Error en el campo @stringField1")
				ok(ds.lastError.field_errors['@stringField1'].code==1020, "Error en el campo stringField1 == 1020")
			});
		})
	}
);
test("Get - No requerido para retrieve aunque tenga un ds con copy from en un campo requerido",
	function(){
		expect(6);
		stop();
		loadForm("frmTest30",function(status,form,controls){
			start();
			ok(status,"Carga del formulario frmTest30");
			var ds = form.environment.datasources['dsTest21'];
			ok(form.environment.datasources['dsTest22'],"dsTest22 esta presente en el formulario");
			ok(ds != undefined,"dsTest21 está presente en el formulario.");
			var fireRequest=false;
 			if(ds){
			    ds.ajax = function(request){
					fireRequest = true;
				    setTimeout(function(){
   					    request.success({"status":true,"result":{"colnames":["_id","integerField1","stringField1"],"rows":[
							[1,'string1'],
							[2,'string2']
						],"count":2,"coltypes":[]}})

				    })
					
			    }
			}
			stop();
			form.onReady(function(){
			    start();	
				
				ok(fireRequest == true,"Request inicial realizado.")
				ok(ds.mode == "browse","Modo inicial == browse")
				ds.moveFirst();
				fireRequest=false;
				ds.refresh();
				ok(fireRequest == true,"Request realizado.")
			});
		})
	}
);
