module (...,package.seeall)
local svg = require (tweety_modules_prefix .. "svg")
function new(self)
	self = self or {}
	local toffset=0
	local boffset=1
	local htoffset=0;
	local hboffset=1;
	local ptoffset=0;
	local pboffset=1;
	local dtoffset=0;
	local dboffset=1;

	-- Defaults

	self.bordercolor = self.bordercolor or "gray";
	self.borderwidth=self.borderwidth or 1;
	self.background = self.background or "white";
	if self.gradient == nil then self.gradient = true end
	if self.reversegradient == nil then self.reversegradient = false end
	self.gradientheight = self.gradientheight or  1
	self.round = self.round or 0
	self.opacity = self.opacity or "100%";
	self.color = self.color or "lightgray";
	self.hovercolor = self.hovercolor or self.color;
	self.hoverbordercolor = self.hoverbordercolor or self.bordercolor;
	self.hoverbackground = self.hoverbackground or self.background;
	if self.hovergradient == nil then self.hovergradient = self.gradient end
	if self.hoverreversegradient == nil then self.hoverreversegradient = self.reversegradient end
	self.hovergradientheight = self.hovergradientheight or self.gradientheight;
	self.hoveropacity=self.hoveropacity or self.opacity;
	self.pressedcaptioncolor = self.pressedcaptioncolor or self.hovercaptioncolor;
	self.pressedfontweight = self.pressedfontweight or self.hoverfontweight;
	self.pressedcolor = self.pressedcolor or self.color;
	self.pressedbordercolor = self.pressedbordercolor or self.bordercolor;
	self.pressedbackground = self.pressedbackground or self.background;
	if self.pressedgradient == nil then self.pressedgradient = self.hovergradient end
	if self.pressedreversegradient == nil then self.pressedreversegradient = self.hoverreversegradient end
	self.pressedgradientheight = self.pressedgradientheight or self.gradientheight;
	self.pressedopacity=self.pressedopacity or self.opacity;
	self.disabledcolor = self.disabledcolor or self.color;
	self.disabledbordercolor = self.disabledbordercolor or self.bordercolor;
	self.disabledbackground = self.disabledbackground or self.background;
	if self.disabledgradient == nil then self.disabledgradient =  self.gradient end
	if self.disabledreversegradient == nil then self.disabledreversegradient = self.reversegradient end
	self.disabledgradientheight = self.disabledgradientheight or self.gradientheight;
	self.disabledopacity=self.disabledopacity or self.opacity;


	local height = self.height or 20
	local width = self.width or 70




	if self.reversegradient then toffset=1	boffset=0 end
	if self.hoverreversegradient then htoffset=1	 hboffset=0 end
	if self.pressedreversegradient then ptoffset=1	pboffset=0 end
	if self.disabledreversegradient then dtoffset=1	dboffset=0 end
	self.gradientheight= self.gradientheight or 30
	self.hovergradientheight= self.hovergradientheight or 30
	self.pressedgradientheight= self.pressedgradientheight or 30


	local margin = self.borderwidth;
	local fillcolor = self.color;
	if self.gradient then fillcolor = "url(#gradient)" end
	local hoverfillcolor = self.hovercolor;
	if self.hovergradient then hoverfillcolor = "url(#hovergradient)" end
	local pressedfillcolor = self.pressedcolor;
	if self.pressedgradient then pressedfillcolor = "url(#pressedgradient)" end

	local disabledfillcolor = self.disabledcolor;
	if self.disabledgradient then disabledfillcolor = "url(#disabledgradient)" end

	local s = svg.new{
		width=width;
		height=height*4;
		svg.defs{
			svg.linearGradient{
				id="gradient";
				svg.stop{
					offset=toffset;
					style={
						['stop-color']=self.color;
						['stop-opacity']="0%";
					}
				};
				svg.stop{
					offset=boffset;
					style={
						['stop-color']=self.color;
						['stop-opacity']="100%";
					}
				};
				x1=width/2;
				y1=2;
				x2=width/2;
				y2=12+self.gradientheight;
					gradientUnits="userSpaceOnUse"
			};

			svg.linearGradient{
				id="hovergradient";
				svg.stop{
					offset=htoffset;
					style={
						['stop-color']=self.hovercolor;
						['stop-opacity']="0%";
					}
				};
				svg.stop{
					offset=hboffset;
					style={
						['stop-color']=self.hovercolor;
						['stop-opacity']="100%";
					}
				};
				x1=width/2;
				y1=2+height;
				x2=width/2;
				y2=12+self.hovergradientheight+height;
					gradientUnits="userSpaceOnUse"
			};

			svg.linearGradient{
				id="pressedgradient";
				svg.stop{
					offset=ptoffset;
					style={
						['stop-color']=self.pressedcolor;
						['stop-opacity']="0%";
					}
				};
				svg.stop{
					offset=pboffset;
					style={
						['stop-color']=self.pressedcolor;
						['stop-opacity']="100%";
					}
				};
				x1=width/2;
				y1=2+height+height;
				x2=width/2;
				y2=12+self.pressedgradientheight+height+height;
					gradientUnits="userSpaceOnUse"
			};
			svg.linearGradient{
				id="disabledgradient";
				svg.stop{
					offset=dtoffset;
					style={
						['stop-color']=self.disabledcolor;
						['stop-opacity']="0%";
					}
				};
				svg.stop{
					offset=dboffset;
					style={
						['stop-color']=self.disabledcolor;
						['stop-opacity']="100%";
					}
				};
				x1=width/2;
				y1=2+height+height+height;
				x2=width/2;
				y2=12+self.disabledgradientheight+height+height+height;
					gradientUnits="userSpaceOnUse"
			};


		};
		--- NORMAL
		svg.layer{
			opacity=self.opacity or "100%";
			svg.rect{
				width=(width-(self.borderwidth*2 ))+self.borderwidth;
				height=(height-(self.borderwidth*2 ))+  self.borderwidth;
				x=margin-self.borderwidth*0.5;
				y=margin-self.borderwidth*0.5;
				rx=self.round;
				ry=self.round;
				style={
					stroke=self.bordercolor;
					['stroke-width']=self.borderwidth;
					fill=self.background;
				}
			};

			svg.rect{
				x=margin+1;
				y=margin+1;
				width=(width-(self.borderwidth*2 ))-2;
				height=(height-(self.borderwidth*2 ))-2;
				rx=self.round-2;
				ry=self.round-2;
				style={
					fill=fillcolor;
				}
			};

		};
		-- OVER
		svg.layer{

			opacity=self.hoveropacity or "100%";
			svg.rect{
				width=(width-(self.borderwidth*2 ))+self.borderwidth;
				height=(height-(self.borderwidth*2 ))+  self.borderwidth;
				x=margin-self.borderwidth*0.5;
				y=(margin-self.borderwidth*0.5)+height;
				rx=self.round;
				ry=self.round;
				style={
					stroke=self.hoverbordercolor;
					['stroke-width']=self.borderwidth;
					fill=self.hoverbackground;
				}
			};

			svg.rect{
				x=margin+1;
				y=(margin+1)+height;
				width=(width-(self.borderwidth*2 ))-2;
				height=(height-(self.borderwidth*2 ))-2;
				rx=self.round-2;
				ry=self.round-2;
				style={
					fill=hoverfillcolor;
				}
			};

		};
		-- PRESSED
		svg.layer{

			opacity=self.pressedopacity or "100%";
			svg.rect{
				width=(width-(self.borderwidth*2 ))+self.borderwidth;
				height=(height-(self.borderwidth*2 ))+  self.borderwidth;
				x=margin-self.borderwidth*0.5;
				y=(margin-self.borderwidth*0.5)+height+height;
				rx=self.round;
				ry=self.round;
				style={
					stroke=self.pressedbordercolor;
					['stroke-width']=self.borderwidth;
					fill=self.pressedbackground;
				}
			};

			svg.rect{
				x=margin+1;
				y=(margin+1)+height+height;
				width=(width-(self.borderwidth*2 ))-2;
				height=(height-(self.borderwidth*2 ))-2;
				rx=self.round-2;
				ry=self.round-2;
				style={
					fill=pressedfillcolor;
				}
			};

		};
		-- DISABLED
		svg.layer{

			opacity=self.disabledopacity or "100%";
			svg.rect{
				width=(width-(self.borderwidth*2 ))+self.borderwidth;
				height=(height-(self.borderwidth*2 ))+  self.borderwidth;
				x=margin-self.borderwidth*0.5;
				y=(margin-self.borderwidth*0.5)+height+height+height;
				rx=self.round;
				ry=self.round;
				style={
					stroke=self.disabledbordercolor;
					['stroke-width']=self.borderwidth;
					fill=self.disabledbackground;
				}
			};

			svg.rect{
				x=margin+1;
				y=(margin+1)+height+height+height;
				width=(width-(self.borderwidth*2 ))-2;
				height=(height-(self.borderwidth*2 ))-2;
				rx=self.round-2;
				ry=self.round-2;
				style={
					fill=disabledfillcolor;
				}
			};

		};
	}
	function self:tostring()
		return s:tostring()
	end

	return self
end



