module (...,package.seeall)
local svg = require (tweety_modules_prefix .. "svg")
function new(self)
	self = self or {}
	local toffset=0
	local boffset=1
	

	-- Defaults

	self.bordercolor = self.bordercolor or "gray";
	self.borderwidth=self.borderwidth or 1;
	self.backcolor = self.backcolor or "white";
	if self.gradient == nil then self.gradient = true end
	if self.reversegradient == nil then self.reversegradient = false end
	self.gradientheight = self.gradientheight or  1
	self.round = self.round or 0
	self.opacity = self.opacity or "100%";
	self.color = self.color or "lightgray";
	local height = self.height or 20
	local width = self.width or 70

	if self.reversegradient then toffset=1	boffset=0 end
	self.gradientheight= self.gradientheight or 30


	local margin = self.borderwidth;
	local fillcolor = self.color;
	if self.gradient then fillcolor = "url(#gradient)" end

	local s = svg.new{
		width=width;
		height=height;
		svg.defs{
			svg.linearGradient{
				id="gradient";
				svg.stop{
					offset=toffset;
					style={
						['stop-color']=self.color;
						['stop-opacity']="0%";
					}
				};
				svg.stop{
					offset=boffset;
					style={
						['stop-color']=self.color;
						['stop-opacity']="100%";
					}
				};
				x1=width/2;
				y1=2;
				x2=width/2;
				y2=12+self.gradientheight;
				gradientUnits="userSpaceOnUse"
			};



		};
		--- NORMAL
		svg.layer{
			opacity=self.opacity or "100%";
			
			svg.rect{
				width=(width-(self.borderwidth*2 ))+self.borderwidth;
				height=(height-(self.borderwidth*2 ))+  self.borderwidth;
				x=margin-self.borderwidth*0.5;
				y=margin-self.borderwidth*0.5;
				rx=self.round;
				ry=self.round;
				style={
					stroke=self.bordercolor;
					['stroke-width']=self.borderwidth;
					fill=self.backcolor;
				}
			};
			

			svg.rect{
				x=0.2+self.borderwidth;
				y=0.2+self.borderwidth;
				width=(width-(self.borderwidth*2 ))-0.4;
				height=(height-(self.borderwidth*2 ))-0.4;
				rx=self.round-2;
				ry=self.round-2;
				style={
					fill=fillcolor;
					['stroke-width']=0;
				}
			};

		};
		
	}
	function self:tostring()
		return s:tostring()
	end

	return self
end



