module(..., package.seeall)

-- local config = require ("config")
config = require (tweety_modules_prefix .. "config")
--  CREATE KEYSPACE webdesignerApps with placement_strategy = 'org.apache.cassandra.locator.SimpleStrategy' and strategy_options = {replication_factor:1};
--  create column family FileStorage with comparator=UTF8Type and key_validation_class=UTF8Type and default_validation_class=UTF8Type;[
require "json"
local cassandra = require "lua_cassandra"
local lfs = require "lfs"



local md5 = require "md5";
local socket = require "socket";
local m_IOSystem;
FILE_STORAGE = "FileStorage";
DIR_MAGIC = "__dir__3a5cb5a7-edb7-4ac4-997c-443da775467a";
local fileSystemLocations = {
--	 ["rootfs/tmp"]=true,
	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/scpusers/system"]=true,
	 
	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/templates"]=true,
--	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/templates/nada"]=true,

--	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/templates/empty"]=true,
--	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/templates/empty/nada"]=true,
--
--	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/templates/webchattemplate"]=true,
--	 ["rootfs/usr/lib/inconcert/webdesigner/inconcert/apps/webdesigner/templates/webchattemplate/nada"]=true,


}
local pidobj={}
local lwuid_count = 0;
local lwuid_pid = string.gsub(tostring(pidobj),"table: ","")
local lwuid_mcid = string.sub(md5.sumhexa(os.getenv("COMPUTERNAME") or os.getenv("HOSTNAME") or tostring(os.time())),1,8);
math.randomseed( os.time() )
function lwuid ()
	lwuid_count=lwuid_count+1
	if lwuid_count == 1e4 then
		lwuid_count=0
	end
	local res = {
		tostring(os.time()),
		string.format("%05d",lwuid_count),
		lwuid_mcid,
		lwuid_pid,
		string.format("%05d",math.random(1e4)),

	}
	return table.concat(res,"-")
end
local vmid = lwuid();
--print("Virtual ID",vmid)
local handles={
	
};
local _cassandra_ks = nil
local function cassandraKS()
	if not _cassandra_ks then
		_cassandra_ks = cassandra:CassandraConnection("webdesignerApps")
	end
	return _cassandra_ks
end
local function cassandraKSClose(cassandra_ks)
	-- nada, la conexion queda abierta para siempre mientras dure la vm de lua
end



local function splitPath(fname)
	local path = {}
	local dirsep
	local t = fname;
	--assert(fname,debug.traceback())
	fname=string.gsub(fname,"%\\",config.pathSeparator)
	
	dirsep = config.pathSeparator

	fname = fname:gsub("([^" .. dirsep .. "]+)" .. dirsep ,
		function(d)
			table.insert(path,d)
				return ""
			end)
	fname = fname:gsub(dirsep,"")
	local ext = ""
	fname = fname:gsub("%.[^%.]+$",function(e) ext = e return "" end)
	return path,fname,ext
end
local function normalizePath(path)
	if string.sub(path,1,1) == config.pathSeparator then
		return string.sub(path,2)
	else
		return path;
	end
end


local function isSystemFile(path,filename,ext)
	local fpath
	local parcialPath = {}
	for n=1,#path do
		table.insert(parcialPath,path[n])
		fpath = table.concat(parcialPath,config.pathSeparator)
		fpath=string.lower(fpath)
		
		if fileSystemLocations[fpath] then
			return true
		end
	end
	fpath = table.concat(path,config.pathSeparator);
	fpath=string.lower(fpath)
	
	fpath = fpath .. config.pathSeparator .. filename.. ext	
	fpath=string.lower(fpath)
	local res = fileSystemLocations[fpath];
	return res;
end

local function cassandra_mkdir(pathName) --lfs

	assert(pathName)
	assert(string.sub(pathName,1,1)==config.pathSeparator)
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(pathName))
	if isSystemFile(path,fname,ext) then
		return lfs.mkdir(pathName)
	end
	if fname=="" then
		return false
	end
	local webdesignerKS= cassandraKS()
	local column = webdesignerKS:GetColumn(fname .. ext,FILE_STORAGE, table.concat(path,config.pathSeparator));
	if column then
		return false,"Directory or filename already exist " .. pathName
	end
	webdesignerKS:InsertColumn(fname .. ext,FILE_STORAGE, table.concat(path,config.pathSeparator),DIR_MAGIC);
	cassandraKSClose(webdesignerKS);
	return true;
end
local function cassandra_close(handle)  -- io
	if handles[handle] then
		if  #handle.writebuffer>0 then
			local webdesignerKS= cassandraKS()
			cassandra_mkdir(config.pathSeparator .. table.concat(handle.dirPath,config.pathSeparator));
			webdesignerKS:InsertColumn(handle.fname .. handle.ext,FILE_STORAGE, table.concat(handle.path,config.pathSeparator),table.concat(handle.writebuffer));
			cassandraKSClose(webdesignerKS);
			handle.writebuffer={};
		end
		handles[handle]=nil;
	else
		io.close(handle)
	end

end

--------------------------------------------------------------------------------
local function listKeys(connection, cf, dummyColumnName)
	local startKey     = ""
	local keyRangeSize = 1e8;
	local totalKeys    = keyRangeSize
	local elements = {}
	local skipNext = false
	while keyRangeSize == totalKeys do
		local ranges = connection:GetRangeSlices(cf, "",
		               startKey, "", {
		                   column_names = {dummyColumnName},
		                   slice_range = {}
		               },keyRangeSize)
		totalKeys = 0
		for key, columns in ranges:Iterator() do
			totalKeys = totalKeys + 1
			--print(key,totalKeys)
			if skipNext then
				skipNext = false
			else
				for _, column in pairs(columns) do
					table.insert(elements, key)
				end
			end
			startKey = key
		end
		skipNext = true
	end
	return elements
end


--------------------------------------------------------------------------------

local function cassandra_open(fileName,mode) --io
	assert(fileName)
	assert(mode)
	assert(string.sub(fileName,1,1)==config.pathSeparator)
	local dirPath,dirName,dirExt = splitPath(config.pathSeparator .. normalizePath(fileName))
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(fileName));
	if isSystemFile(path,fname,ext) then
		return io.open(fileName,mode)
	end

	local column;
	if mode == "r" or mode == "rb" then
		local webdesignerKS= cassandraKS()
		column = webdesignerKS:GetColumn(fname .. ext,FILE_STORAGE, table.concat(path,config.pathSeparator));
		cassandraKSClose(webdesignerKS)
	end
	if (mode == "r" or mode == "rb" and column) or (mode == "w" or mode == "wb") then
		local handle = {
			writebuffer={},
			path=path,
			fname=fname,
			ext = ext,
			dirPath=dirPath,
			pos =0,
			lines = nil,
			seek = function(self,where,offset)
				assert(where == "end" or where == "set" or where == "cur")
				assert(offset == 0)
				if column then
					if where == "end" then

						return #column.value
					elseif where == "set" then
						
						return 0
					elseif where == "cur" then
						return self.pos;
					end
				end
			end,
			write = function(self,data)
				if mode == "w" or mode == "wb" then
					table.insert(self.writebuffer,data)
					return #data;
				end
			end,

			read = function(self,mode)
				if column then 
					if mode == "*l" then
						self.lines = self.lines or column.value:gmatch("[^\r\n]+");
						local res = self.lines();
						if res then
							self.pos = self.pos + #res +1
						end
						return res;						
					elseif mode == "*a" then
						return column.value;
					else
						assert(false,mode)
					end
				end
			end,
			close = function(self)
				cassandra_close(self);
			end
		}
		handles[handle]=handle;
		return handle;
	end
end
local function cassandra_dir ( fullPath)
	assert(fullPath)
	assert(string.sub(fullPath,1,1)==config.pathSeparator)
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(fullPath) .. config.pathSeparator .."nada")
	if isSystemFile(path,fname,ext) then
		return lfs.dir(fullPath);
	end
	
	local webdesignerKS= cassandraKS()
	local handle = {
		elements= listKeys(webdesignerKS, FILE_STORAGE,table.concat(path,config.pathSeparator)),
		index=0
	}
	cassandraKSClose(webdesignerKS)
	return function(handle) 
		if handle.index == 0 then
			handle.index = handle.index+1
			return "."
		end
		local r = handle.elements[handle.index]
		handle.index = handle.index+1
		return r;
	end,handle
end



local function cassandra_attributes(fileName)
	assert(string.sub(fileName,1,1)==config.pathSeparator)
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(fileName))
	if isSystemFile(path,fname,ext) then
		return lfs.attributes(fileName);
	end
	
	if fname=="" then
		return false
	end
	local fh = cassandra_open(fileName,"rb")
	if fh then
		local content = fh:read("*a")
		cassandra_close(fh);
		if content == DIR_MAGIC then
			return {mode="directory"}
		else
			return {mode="file"}
		end
	end
end

local function cassandra_rmdir(pathName)  -- lfs
	assert(pathName)
	assert(string.sub(pathName,1,1)==config.pathSeparator)
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(pathName))
	if isSystemFile(path,fname,ext) then
		return lfs.rmdir(pathName);
	end
	
	local webdesignerKS= cassandraKS()
	webdesignerKS:RemoveColumn(fname .. ext,FILE_STORAGE, table.concat(path,config.pathSeparator));
	cassandraKSClose(webdesignerKS);
	return true;
end

local function cassandra_remove(fileName) -- for os remove
	assert(fileName)
	assert(string.sub(fileName,1,1)==config.pathSeparator)
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(fileName))
	if isSystemFile(path,fname,ext) then
		return os.remove(fileName);
	end
	
	local webdesignerKS= cassandraKS()
	webdesignerKS:RemoveColumn(fname .. ext,FILE_STORAGE, table.concat(path,config.pathSeparator));
	cassandraKSClose(webdesignerKS);
	return true;
end
local function cassandra_rename(fileName,newName)
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(fileName))

	if isSystemFile(path,fname,ext) then
		return os.rename(fileName,newName)
	end

	local fh = cassandra_open(fileName,"rb")
	if fh then
		local data = fh:read("*a")
		fh:close();
		if data then
			local fhrest = cassandra_open(newName,"rb");
			if fhrest then
				cassandra_close(fhrest)
				return false
			end
			local fh2 = cassandra_open(newName,"wb")
			if fh2 then
				c = fh2:write(data)
				if c == #data then
					cassandra_close(fh2)
					return cassandra_remove(fileName)
				else
					cassandra_remove(newName)
				end
				cassandra_close(fh2)
			end
		end
	end
	return false
end
local function set_token_data(tokenId,data)
	local open,remove,close
	local res;
	local tokenDataPath = config.pathSeparator .. "tokens" .. config.pathSeparator.. tokenId
	
	if m_IOSystem == "cassandra" then
		open = cassandra_open
		remove = cassandra_remove
		close = cassandra_close
	else
		open = io.open
		remove = os.remove
		close = io.close
	end
	local fh = open(tokenDataPath,"wb")
	if fh then
		res = fh:write(json.encode(data));
		close(fh)
	end
	return res;
end
local function get_token_data(tokenId)
	local open,remove,close
	local res;
	local tokenDataPath = config.pathSeparator .. "tokens" .. config.pathSeparator.. tokenId
	
	if m_IOSystem == "cassandra" then
		open = cassandra_open
		remove = cassandra_remove
		close = cassandra_close
	else
		open = io.open
		remove = os.remove
		close = io.close
	end
	local fh = open(tokenDataPath,"rb")
	if fh then
		res = fh:read("*a");
		if res then
			LogDebug("getTokenData %s --> %s",tokenId,res);
			res = json.decode(res)
		end
		close(fh)
	end
	
	return res;
end

local function delete_token_data(tokenId)
	local open,remove,close
	local res;
	local tokenDataPath = config.pathSeparator .. "tokens" .. config.pathSeparator .. tokenId
	
	if m_IOSystem == "cassandra" then
		open = cassandra_open
		remove = cassandra_remove
		close = cassandra_close
	else
		open = io.open
		remove = os.remove
		close = io.close
	end
	remove(tokenDataPath);
end



local function session_get(id)
	local open,remove,close
	local res;
	if m_IOSystem == "cassandra" then
		open = cassandra_open
		remove = cassandra_remove
		close = cassandra_close
	else
		open = io.open
		remove = os.remove
		close = io.close
	end
	local fh = open(id,"rb")
	if fh then
		res = fh:read("*a");
		close(fh)
	end
	return res;
end
local function session_write(id,strData)
	local open,remove,close
	if m_IOSystem == "cassandra" then
		open = cassandra_open
		remove = cassandra_remove
		close = cassandra_close
	else
		open = io.open
		remove = os.remove
		close = io.close
	end
	local fh = open(id,"wb")
	if fh then
		res = fh:write(strData);
		close(fh)
	end
end
local self_locks = {}

local cassandra_unlock = function(id)
	self_locks[id] = self_locks[id] or 0
	if self_locks[id]<1 then
		return
	end
	if self_locks[id]> 1 then
		self_locks[id]=self_locks[id]-1
		return
	end
	self_locks[id]=0;
	local keydir = config.pathSeparator .. "locks" .. config.pathSeparator.. id
	local keypath = keydir .. config.pathSeparator .. vmid;
	local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(keypath));
	cassandra_remove(keypath);	
end

local cassandra_lock = function (id,expires)
	local st = os.clock();
	local keydir = config.pathSeparator .. "locks" .. config.pathSeparator.. id
	local keypath = keydir .. config.pathSeparator .. vmid;
	local time = os.time() + expires	
	self_locks[id]=self_locks[id] or 0
	if self_locks[id]>0 then
		return true
	end
	self_locks[id]=self_locks[id]+1
	local fh = cassandra_open(keypath,"wb");
	if fh then 
		fh:write(json.encode({expires=time}));
		fh:close();
	else
		assert(false)
	end
	while true do
		local mints;
		local minEntry		
		local mintime;
		local iter, dir_obj = cassandra_dir (keydir);
		local dir_entry = iter(dir_obj)
		local found_this=false;
		if dir_entry then
			local webdesignerKS= cassandraKS()
			while dir_entry do
				if dir_entry ~= "." and dir_entry ~= ".." then
					local path,fname,ext = splitPath(config.pathSeparator .. "rootfs" .. config.pathSeparator .. normalizePath(keydir ..  config.pathSeparator .. dir_entry ));
					
					local column = webdesignerKS:GetColumn(fname .. ext,FILE_STORAGE, table.concat(path,config.pathSeparator));
					if column then
						if dir_entry == vmid then
							found_this = true
						end
						local value;
						pcall(function()
						 	value = json.decode(column.value);
						 end)
						if not value or os.time() > value.expires and dir_entry ~= vmid then -- vencida la borramos nomas, sino somos nosotros mismos.
							cassandra_remove(keydir ..  config.pathSeparator .. dir_entry);
						else
							if not mints or mints > column.timestamp then
								minEntry = dir_entry;
								mints = column.timestamp;
								mintime = value.expires;
							end
						end

					end
				
				end
				dir_entry = iter(dir_obj)
			end
			cassandraKSClose(webdesignerKS);
		end
		
		if minEntry == vmid then
			--LogDebug("Lock time %f",os.clock()-st)
			return true
		else
			socket.sleep(.01)
		end
		if not found_this then
		--	print("Not found this")
			local fh = cassandra_open(keypath,"wb");
			if fh then 
				time = os.time() + expires;
				fh:write(json.encode({expires=time}))
				fh:close();
			end
		end
	end
end

local function lock (id,expires)
	if m_IOSystem == "cassandra" then
		return cassandra_lock(id,expires)
	else
		assert(false)
	end
end

local function unlock (id)
	if m_IOSystem == "cassandra" then
		return cassandra_unlock(id)
	else
		assert(false)
	end
end



local session = function(id)
	id = id or inconcert.authUser.authToken
	assert(id)
	local path= "/sessions/" .. id;
	local initialdata = {}
	lock(id,30)
	local locked=true;
	local content_json = session_get(path)
	if content_json and type(content_json) == "string" then 
		initialdata = json.decode(content_json)
	end
	function initialdata:release()
		if locked then
			local t = json.encode(initialdata);
			if t ~= content_json then
				content_json=t
				session_write(path,t);	
			end
		end	
		unlock(id);
		locked=false;
	end

	return initialdata
end
local discardsession = function (id)
	id = id or inconcert.authUser.authToken

	assert(id)
	lock(id,30)
	local path = "/sessions/" .. id;
	local remove
	if m_IOSystem == "cassandra" then
		remove = cassandra_remove
	else
		remove = os.remove
	end
	remove(path)
	unlock(id);
end
local interface = {
		
}

function interface:set(IOSystem)
	m_IOSystem = IOSystem;
	if IOSystem == "cassandra" then
		self.open = cassandra_open
		self.close = cassandra_close
		self.mkdir = cassandra_mkdir
		self.rmdir = cassandra_rmdir
		self.remove = cassandra_remove
		self.rename = cassandra_rename
		self.dir = cassandra_dir
		self.attributes=cassandra_attributes
		self.session = session
		self.set_token_data = set_token_data
		self.get_token_data = get_token_data
		self.write_token_data = write_token_data
		self.discardsession=discardsession
		self.lock = cassandra_lock
		self.unlock = cassandra_unlock
	elseif IOSystem == "filesystem" then
		self.open = io.open
		self.close = io.close
		self.mkdir = lfs.mkdir
		self.rmdir = lfs.rmdir
		self.remove = os.remove
		self.attributes = lfs.attributes
		self.rename = os.rename
		self.dir = function(path)
			if path == "" then
				path="." .. config.pathSeparator
			end
			return lfs.dir(path)
		end
		self.session = session
		
		self.set_token_data = set_token_data
		self.get_token_data = get_token_data
		self.write_token_data = write_token_data
		
		self.discardsession=discardsession
	end
end
interface:set(config.IOSystem)

return interface;
