module(...,package.seeall)
local config = require (tweety_modules_prefix .. "config")
local messages = require (tweety_modules_prefix .. "messages")
local application = require (tweety_modules_prefix .. "application")
require "LuaOrm.Date"
local tweetyio = require ( tweety_modules_prefix .. "tweetyio" )

function new(self)
	self = self or {}

	function self:publishedApplications(filterParams)
		local status,result,list
--		if appClass and appClass ~= "" then
--			catalogParams.includeHidden=true;
--		end

		status,result = self:getCatalog(self.vccName,filterParams);
		if status then
			list = result
--			if self.vccName ~= "system" then
--				local res
--				status,result = self:getCatalog("system")
--				if status then
--					
--					for _,app in ipairs(result) do
--						table.insert(list,app)
--					end
--			
--				else
--					return status,result -- error en lugar de la lista de apps
--				end
--			end
			table.sort(list,
				function(item1,item2)
					return item2.name > item1.name
				end
			)
			return true,list
		end
		return status,result
	end

	function self:getCatalog(vccName,filterParams)
		local result = {}
		local timeZoneDate = LuaOrm.Date()
		filterParams = filterParams or {}
		vccName = vccName or self.vccName or "system"
		-- hace un mkdir para crear el directorio del vcc si es que no existiera
		tweetyio.mkdir (config.usersPath .. config.pathSeparator .. vccName)
		
		local iter, dir_obj = tweetyio.dir (config.usersPath .. config.pathSeparator .. vccName)
		local dir_entry = iter(dir_obj)
		if dir_entry then
			local fh,txjson
			local catalogEntry
			while dir_entry do
				if dir_entry ~= "." and dir_entry ~= ".." then
					fh = tweetyio.open(config.usersPath .. config.pathSeparator .. vccName .. config.pathSeparator .. dir_entry .. config.pathSeparator .. config.catalogFile,"rb")
					if fh then
						local include = false;
						txjson = fh:read("*a");
						catalogEntry = json.decode(txjson)
						
						catalogEntry.id = dir_entry;
						
						catalogEntry.name = dir_entry;
						catalogEntry.description = dir_entry;
						catalogEntry.version = (catalogEntry.version or 0)
						catalogEntry.created_at = catalogEntry.created_at or catalogEntry.lastmod;
--						if catalogEntry.hidden and not filterParams.includeHidden then
	--						include=false
--						end
						if (not filterParams.id or filterParams.id == "" ) and
							(not filterParams.type or filterParams.type == "") and
							(not filterParams.status or  filterParams.status == "") and
							(not filterParams.created_gte or filterParams.created_gte == "") and
							(not filterParams.created_lte or filterParams.created_lte == "") then
							include = true;
						end
							
							
						if  filterParams.id and filterParams.id ~= ""  and string.find(catalogEntry.name,filterParams.id) then
							include = true
						end
						if  filterParams.status and filterParams.status~= ""  and  filterParams.status == catalogEntry.status then
							include = true
						end
						
						if filterParams.created_gte and filterParams.created_gte ~= "" and catalogEntry.created_at > LuaOrm.Date():newFromDifferentTimezone(filterParams.created_gte, inconcert.authUser.timezone):toString()  then
							include = true;
						end
						if filterParams.created_lte and filterParams.created_lte ~= "" and catalogEntry.created_at < LuaOrm.Date():newFromDifferentTimezone(filterParams.created_lte, inconcert.authUser.timezone):toString()  then
							include = true;
						end
						local app = application.new{vccName=self.vccName}
						local status,_ = app:initialize(dir_entry);
						if status then
							local catalogApp = app:getCatalog();
							catalogEntry.type = catalogApp.appClass or "cci";
							if filterParams.type and filterParams.type ~= "" and string.find(catalogEntry.type,filterParams.type) then
								include = true;
							end
						else
							include = false;
						end			
						
						catalogEntry.created_at = string.gsub(LuaOrm.Date(catalogEntry.created_at):toDifferentTimezoneString(inconcert.authUser.timezone),"%.%d*$","")
						
						if include then
							table.insert(result,catalogEntry)
						end
						tweetyio.close(fh);
					end
				end
				dir_entry = iter(dir_obj)
			end
			table.sort(result,function(a,b)
				return b.name > a.name
			end)
			return true,result
		else
			return false,messages.messageKey('path_access_error',{path=config.usersPath .. config.pathSeparator .. vccName})
		end
	end
	function self:deleteApplication(appName)

		local function deleteAppPath(path)
			local status,result
			local deltree;
			status = true;
			deltree = function (path,catalogName)
				local result = {}
				local iter, dir_obj = tweetyio.dir (path)
				local dir_entry = iter(dir_obj)
				if dir_entry then

					while dir_entry do

						if dir_entry ~= "." and dir_entry ~= ".." and dir_entry ~= catalogName then
							local filename = path .. config.pathSeparator .. dir_entry
							local attrs = tweetyio.attributes(filename)
							if not attrs then
								return false,messages.messageKey('read_file_error',{file=filename})
							end
							if attrs.mode == 'directory' then
								status,result = deltree(filename)
								if not status then
									return false,result
								end
								if not tweetyio.rmdir(filename) then
									return false,messages.messageKey('rmdir_error',{path=filename})
								end
							else
								if not tweetyio.remove(filename) then
									return false,messages.messageKey('delete_file_error',{file=filename})
								end
							end
						end
						dir_entry = iter(dir_obj)
					end
					return true
				else
					return false,messages.messageKey('path_access_error',{path=path})
				end

			end
			status,result = deltree(path,config.catalogFile)
			if status then
				local filename = path .. config.pathSeparator .. config.catalogFile
				if not tweetyio.remove(filename) then
					return false,messages.messageKey('delete_file_error',{file=filename})
				end
				if not tweetyio.rmdir(path) then
					return false,messages.messageKey('rmdir_error',{path=filename})
				end
			end
			return status,result
		end
		local appPath = config.usersPath .. config.pathSeparator .. self.vccName .. config.pathSeparator .. appName
		local app = application.new{vccName=self.vccName}
		local status, result = app:initialize(appName);
		if status then
			status,result = app:deconfigure();
			if not status then
				return status,result
			end
		end
		return deleteAppPath(appPath);


	end
	return self
end

