
local messages = require (tweety_modules_prefix .. "messages");
local runtime = require (tweety_modules_prefix .. "runtime");
require "xml.ltxml"
require "luaxslt"
local http = require("socket.http")
local ltn12 = require("ltn12")
--local json = require(tweety_modules_prefix .. "json") 
local url = require("socket.url")
local config = require(tweety_modules_prefix .. "config")
-- XSLT usada para convertir el xml intermedio de request a X-WWW-FORM-URLENCODED
module(..., package.seeall)

local built_in_XSLT_IXML2urlencoded =[[
<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>
<xsl:strip-space elements="*"/>
	<xsl:template match="/">
		<xsl:for-each select="/request/parameters/*">
		<xsl:value-of select="name()" />=<xsl:call-template name="url-encode">
          <xsl:with-param name="str" select="value/text()"/>
        </xsl:call-template>
		<xsl:if test="not(position() = last())"><xsl:text>&amp;</xsl:text></xsl:if></xsl:for-each>
	</xsl:template>
	<xsl:variable name="ascii"> !"#$%&amp;'()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~</xsl:variable>
	<!-- Characters that usually don't need to be escaped -->
	<xsl:variable name="safe">!'()*-.0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz~</xsl:variable>
	<xsl:variable name="hex">0123456789ABCDEF</xsl:variable>

	<xsl:template name="url-encode">

		<xsl:param name="str"/>
		<xsl:if test="$str">
		  <xsl:variable name="first-char" select="substring($str,1,1)"/>
		  <xsl:choose>
			<xsl:when test="contains($safe,$first-char)">
			  <xsl:value-of select="$first-char"/>
			</xsl:when>
			<xsl:otherwise>
			  <xsl:variable name="codepoint">
				<xsl:choose>
				  <xsl:when test="contains($ascii,$first-char)">
					<xsl:value-of select="string-length(substring-before($ascii,$first-char)) + 32"/>
				  </xsl:when>
				  <xsl:otherwise>
					<xsl:message terminate="no">Warning: string contains a character that is out of range! Substituting "?".</xsl:message>
					<xsl:text>63</xsl:text>
				  </xsl:otherwise>
				</xsl:choose>
			  </xsl:variable>
			<xsl:variable name="hex-digit1" select="substring($hex,floor($codepoint div 16) + 1,1)"/>
			<xsl:variable name="hex-digit2" select="substring($hex,$codepoint mod 16 + 1,1)"/>
			<xsl:value-of select="concat('%',$hex-digit1,$hex-digit2)"/>
			</xsl:otherwise>
		  </xsl:choose>
		  <xsl:if test="string-length($str) &gt; 1">
			<xsl:call-template name="url-encode">
			  <xsl:with-param name="str" select="substring($str,2)"/>
			</xsl:call-template>
		  </xsl:if>
		</xsl:if>
	</xsl:template>


</xsl:stylesheet>

]]
local built_in_XSLT_IXML2soap =[[
<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" indent="no"
		omit-xml-declaration="yes"
	 />
	<xsl:strip-space elements="*"/>
	<xsl:template match="/">
		<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/">
			<soapenv:Header/>
			<soapenv:Body>
				<xsl:element name="{/request/header/requestOperation/text()}" namespace="{/request/header/requestNamespace/text()}">
					<xsl:for-each select="/request/parameters/*">
						<xsl:element name="{name()}" namespace="{/request/header/requestNamespace/text()}">
							<xsl:value-of select="value/text()"/>
						</xsl:element>
					</xsl:for-each>
				</xsl:element>
			</soapenv:Body>
		</soapenv:Envelope></xsl:template></xsl:stylesheet>]]
local built_in_XSLT_IXML2json =[[
<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!--
  Copyright (c) 2006, Doeke Zanstra
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification,
  are permitted provided that the following conditions are met:

  Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer. Redistributions in binary
  form must reproduce the above copyright notice, this list of conditions and the
  following disclaimer in the documentation and/or other materials provided with
  the distribution.

  Neither the name of the dzLib nor the names of its contributors may be used to
  endorse or promote products derived from this software without specific prior
  written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
  THE POSSIBILITY OF SUCH DAMAGE.
-->

  <xsl:output indent="no" omit-xml-declaration="yes" method="text" encoding="UTF-8" media-type="text/x-json"/>
	<xsl:strip-space elements="*"/>
  <!--contant-->
  <xsl:variable name="d">0123456789</xsl:variable>

  <!-- ignore document text -->
  <xsl:template match="text()[preceding-sibling::node() or following-sibling::node()]"/>

  <!-- string -->
  <xsl:template match="text()">
    <xsl:call-template name="escape-string">
      <xsl:with-param name="s" select="."/>
    </xsl:call-template>
  </xsl:template>

  <!-- Main template for escaping strings; used by above template and for object-properties
       Responsibilities: placed quotes around string, and chain up to next filter, escape-bs-string -->
  <xsl:template name="escape-string">
    <xsl:param name="s"/>
    <xsl:text>"</xsl:text>
    <xsl:call-template name="escape-bs-string">
      <xsl:with-param name="s" select="$s"/>
    </xsl:call-template>
    <xsl:text>"</xsl:text>
  </xsl:template>

  <!-- Escape the backslash (\) before everything else. -->
  <xsl:template name="escape-bs-string">
    <xsl:param name="s"/>
    <xsl:choose>
      <xsl:when test="contains($s,'\')">
        <xsl:call-template name="escape-quot-string">
          <xsl:with-param name="s" select="concat(substring-before($s,'\'),'\\')"/>
        </xsl:call-template>
        <xsl:call-template name="escape-bs-string">
          <xsl:with-param name="s" select="substring-after($s,'\')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="escape-quot-string">
          <xsl:with-param name="s" select="$s"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- Escape the double quote ("). -->
  <xsl:template name="escape-quot-string">
    <xsl:param name="s"/>
    <xsl:choose>
      <xsl:when test="contains($s,'&quot;')">
        <xsl:call-template name="encode-string">
          <xsl:with-param name="s" select="concat(substring-before($s,'&quot;'),'\&quot;')"/>
        </xsl:call-template>
        <xsl:call-template name="escape-quot-string">
          <xsl:with-param name="s" select="substring-after($s,'&quot;')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="encode-string">
          <xsl:with-param name="s" select="$s"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- Replace tab, line feed and/or carriage return by its matching escape code. Can't escape backslash
       or double quote here, because they don't replace characters (&#x0; becomes \t), but they prefix
       characters (\ becomes \\). Besides, backslash should be seperate anyway, because it should be
       processed first. This function can't do that. -->
  <xsl:template name="encode-string">
    <xsl:param name="s"/>
    <xsl:choose>
      <!-- tab -->
      <xsl:when test="contains($s,'&#x9;')">
        <xsl:call-template name="encode-string">
          <xsl:with-param name="s" select="concat(substring-before($s,'&#x9;'),'\t',substring-after($s,'&#x9;'))"/>
        </xsl:call-template>
      </xsl:when>
      <!-- line feed -->
      <xsl:when test="contains($s,'&#xA;')">
        <xsl:call-template name="encode-string">
          <xsl:with-param name="s" select="concat(substring-before($s,'&#xA;'),'\n',substring-after($s,'&#xA;'))"/>
        </xsl:call-template>
      </xsl:when>
      <!-- carriage return -->
      <xsl:when test="contains($s,'&#xD;')">
        <xsl:call-template name="encode-string">
          <xsl:with-param name="s" select="concat(substring-before($s,'&#xD;'),'\r',substring-after($s,'&#xD;'))"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise><xsl:value-of select="$s"/></xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- number (no support for javascript mantise) -->
  <xsl:template match="text()[not(string(number())='NaN')]">
    <xsl:value-of select="."/>
  </xsl:template>

  <!-- boolean, case-insensitive -->
  <xsl:template match="text()[translate(.,'TRUE','true')='true']">true</xsl:template>
  <xsl:template match="text()[translate(.,'FALSE','false')='false']">false</xsl:template>

  <!-- item:null -->
  <xsl:template match="*[count(child::node())=0]">
    <xsl:call-template name="escape-string">
      <xsl:with-param name="s" select="local-name()"/>
    </xsl:call-template>
    <xsl:text>:null</xsl:text>
    <xsl:if test="following-sibling::*">,</xsl:if>
  </xsl:template>

  <!-- object -->
  <xsl:template match="*" name="base">
    <xsl:if test="not(preceding-sibling::*)">{</xsl:if>
    <xsl:call-template name="escape-string">
      <xsl:with-param name="s" select="name()"/>
    </xsl:call-template>
    <xsl:text>:</xsl:text>
    <xsl:apply-templates select="child::node()"/>
    <xsl:if test="following-sibling::*">,</xsl:if>
    <xsl:if test="not(following-sibling::*)">}</xsl:if>
  </xsl:template>

  <!-- array -->
  <xsl:template match="*[count(../*[name(../*)=name(.)])=count(../*) and count(../*)&gt;1]">
    <xsl:if test="not(preceding-sibling::*)">[</xsl:if>
    <xsl:choose>
      <xsl:when test="not(child::node())">
        <xsl:text>null</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates select="child::node()"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="following-sibling::*">,</xsl:if>
    <xsl:if test="not(following-sibling::*)">]</xsl:if>
  </xsl:template>

  <!-- convert root element to an anonymous container -->
  <xsl:template match="/">
    <xsl:apply-templates select="node()"/>
  </xsl:template>

</xsl:stylesheet>
]]
local function GetLoginToken()
	local err;
	local token = inconcert.authUser.authToken

	if token and string.len(token)>0 then
		return true,"SID=" .. token
	else
		return false,messages.messageKey('inconcert_autentication_error',{errText=err});
	end
end

function Get(url, headers, cookie)
	local response_body = {}
	headers = headers or {}
	LogInfo ("WEBSERVICE GET url=[%s]  Timeout %f seconds",url,config.sockethttp_timeout)

	if (cookie and string.len(cookie)) then
		headers["Cookie"] = cookie
	end
	socket.http.TIMEOUT = config.sockethttp_timeout;
	local b, c, h = socket.http.request{
		url = url,
		method = "GET",
		headers = headers,
		sink = ltn12.sink.table(response_body)
	}
	local response = table.concat(response_body,'')
	if (c == 200) then
		return true, response
	else
		LogDebug ("error getting url %s  result code: %d\nbody:%s",tostring(url),tonumber(c) or -1,tostring(response));
		return false, response ..  " " .. tostring(c)
	end

end

function Post( url, body, headers, cookie)
	local response_body = {}
	headers = headers or {}


--	LogInfo ("POST url=[%s] body =[%s]",url,body)
	LogInfo ("WEBSERVICE POST url=[%s]  Timeout %f seconds",url,config.sockethttp_timeout)
	headers["content-length"] = string.len(body)
	if cookie and string.len(cookie)>0 then
		headers["Cookie"] = cookie
	end
	local t = os.clock();
	socket.http.TIMEOUT = config.sockethttp_timeout;
	
	local b, c, h = socket.http.request{
		url = url,
		method = "POST",
		headers = headers,
		source = ltn12.source.string(body),
		sink = ltn12.sink.table(response_body)
	}
	local response = table.concat(response_body,'')
	print("Tiempo de respuesta %d",os.clock()-t);
	if (c == 200) then
		return true, response
	else
		return false, response .. " " .. tostring(c)
	end
end
function new(self)

	if not inconcert.session.twt_wsresponsesXml then
		inconcert.session.twt_wsresponsesXml = {}
		inconcert.session.twt_wsresponsesPath = {}
	end

	local function escapeXML(v)

		if v then
			v = string.gsub(tostring(v),"&","&amp;");
			v = string.gsub(v,"\"","&quot;")
			v = string.gsub(v,"'","&apos;");
			v = string.gsub(v,"<","&lt;");
			v = string.gsub(v,">","&gt;");
			return v
		else
			return ""
		end
	end
	
	local function table2XML(tt,indent)
		local result={}
		if type (tt) == "table" then

			for k,v in pairs(tt) do
				if type (k) == "number" then
					k = "row"
				end
				if type(v) == "table" then
					table.insert(result,string.format("%s<%s>\n\%s\n%s</%s>",(indent or ""),k,table2XML(v,(indent or "")  .. "\t"),(indent or ""),k))
				else
					table.insert(result,string.format("%s<%s>%s</%s>",(indent or ""),k,table2XML(v,(indent or "")  .. "\t"),k))
				end
			end

			return table.concat(result,"\n");
		else
			return escapeXML(tt)
		end
	end

	local function buildIntermediateXMLRequest(data,context,operationDescription)
		local parameters = {}
		local header = {}


		-- set the CRUD operation
		if operationDescription == self.description.store then
			table.insert(header,"<crud>CREATE</crud>")

		elseif operationDescription  == self.description.retrieve then
			table.insert(header,"<crud>READ</crud>")
		elseif operationDescription  == self.description.update then
			table.insert(header,"<crud>UPDATE</crud>")
		elseif opertationDescription == self.description.delete then
			table.insert(header,"<crud>DELETE</crud>")
		end
		table.insert(header,"<system>tweety</system>")
		table.insert(header,"<application>"  .. self.applicationName .. "</application>")
		table.insert(header,"<virtualCC>"  .. runtime.getCurrentVCCName() .. "</virtualCC>")
		table.insert(header,"<virtualUser>"  .. inconcert.authUser.userName .. "</virtualUser>")

		table.insert(header,"<loginToken>"  .. (context.token or "").. "</loginToken>")
		table.insert(header,"<requestOperation>" .. (operationDescription.requestOperation or "").. "</requestOperation>");
		table.insert(header,"<requestNamespace>" .. (operationDescription.requestNamespace or "").. "</requestNamespace>");

		for k,v in pairs(context or {}) do
			table.insert(header,"<" .. k  .. ">" .. escapeXML(v).. "</" .. k .. ">");
		end

		for _,param in ipairs(data) do
			if not string.find(param.name,"@") then
				if param.value or param.origvalue then
					table.insert(parameters,string.format("<%s><value>%s</value><origvalue>%s</origvalue></%s>",param.name,escapeXML(param.value),escapeXML(param.origvalue),param.name))
				end
			end
		end
		local res = table.concat({
			[[<?xml version="1.0" encoding="UTF-8"?>]],
			[[<request>]],
			[[	<header>]],
				table.concat(header,"\n\t\t"),
			[[	</header>]],
			[[	<parameters>]],
				table.concat(parameters,"\n\t\t"),
			[[	</parameters>]],
			[[</request>]]
		})
--		LogInfo("Intermediate xml request\n %s",res);
		return res;
	end
	local function applyTransformation(xmlDocStr,xsltDocStr)
--		LogInfo("applyTransformation")
--		LogInfo("XML")
--		LogInfo("%s",xmlDocStr)
--		LogInfo("-----------------------------------")

--		LogInfo("XSLT")
--		LogInfo("%s",xsltDocStr)
--		LogInfo("-----------------------------------")

		local t = os.clock();
		local status,result,result_length = pcall(luaxslt.transform,xmlDocStr,xsltDocStr);--,"string_param","'test value'","number_param",111)

		if status then
	--		LogInfo("RESULT %s",result);
			return true,result
		else
			LogInfo("Error in xslt transform");
			return false,messages.messageKey('xslt_transformation_error',{message=result});
		end
	end
	function self:buildRequestBody(data,context,operationDescription)
		local res
		local status,result,xml
		xml = buildIntermediateXMLRequest(data,context,operationDescription)
		if operationDescription.requestMessageType == "text/xml" then

			if operationDescription.requestXSLT and #operationDescription.requestXSLT>0 then
				return applyTransformation(xml,operationDescription.requestXSLT);
			else
				return true,xml
			end
		elseif operationDescription.requestMessageType == "application/json" then
			LogInfo("Apply xslt conversion to application/json")

			return applyTransformation(xml,XSLT_IXML2json);
		elseif operationDescription.requestMessageType == "x-www-form-urlencoded" then
			LogInfo("Apply xslt conversion to x-www-form-urlencoded")
			return applyTransformation(xml,built_in_XSLT_IXML2urlencoded);
		elseif operationDescription.requestMessageType == "soap" then
			LogInfo("Apply xslt conversion to soap")
			return applyTransformation(xml,built_in_XSLT_IXML2soap);

		else
			return false,messages.messageKey('invalid_operation');
		end
	end
	function self:buildRequestURL(data,context,operationDescription)
		local status,res
		if operationDescription.requestMessageType == "x-www-form-urlencoded" and operationDescription.requestMethod== "GET" then
			local xml = buildIntermediateXMLRequest(data,context,operationDescription)
			LogInfo("Apply xslt conversion to x-www-form-urlencoded")
			status,res=applyTransformation(xml,built_in_XSLT_IXML2urlencoded);
			if status then
				if #res > 0 then
					return true,operationDescription.resourceURI .. "?" .. res
				else
					return true,operationDescription.resourceURI
				end
			else
				return status,res -- fail
			end
		else
			return true,operationDescription.resourceURI
		end

	end
	
	function self:parseResponse(txtResponse,context,operationDescription,_rowid)
		local status,result
		local doc
		local txtXML
--		LogInfo("Parse response %s",txtResponse);
		local resulset = {
			colnames={},
			rows={}
		}
		if	_rowid	then
			table.insert(resulset.colnames,'_rowid');
		end

--		LogInfo("Response \n%s",txtResponse);

		if operationDescription.responseMessageType == "text/xml" then
			if operationDescription.responseXSLT and #operationDescription.responseXSLT>0 then
				status,txtXML = applyTransformation(txtResponse,operationDescription.responseXSLT)
				if not status then
					return status,txtXML --fail
				end
				status,doc = pcall(xml.parse,txtXML);
				if not status then
					 return false,messages.messageKey('xml_parsing_error',{xml=txtXMLResponse});
				end
			else
				--print(txtResponse);
				
				status,doc = pcall(xml.parse,txtResponse);
				if not status then
					 return false,messages.messageKey('xml_parsing_error',{xml=txtResponse});
				end
				txtXML=txtResponse;
			end
		elseif operationDescription.responseMessageType == "application/json" then

			local jsonResponse
			status,result = pcall(json.decode,txtResponse)
			if not status then
				return false,messages.messageKey('json_parsing_error',{json=txtResponse});
			end
			txtXML=table2XML({response=result})
			if operationDescription.responseXSLT and #operationDescription.responseXSLT>0 then
				local status,txtXML = applyTransformation(txtXML,operationDescription.responseXSLT)
				if not status then
					return status,txtXML --fail
				end
				doc = xml.parse(txtXML);
				if not doc then
					 return false,messages.messageKey('xml_parsing_error',{xml=txtXML});
				end
			else
				doc = xml.parse(txtXML);
				if not doc then
					 return false,messages.messageKey('xml_parsing_error',{xml=txtXML});
				end

			end
		end
		if doc then
			local cmap={}
			local t = os.time();
			local tbinsert = table.insert
			local status=true
			local message
			local function toboolean(v)
				if not v then
					return false
				end
				v = string.lower(tostring(v))
				if v == "1" or v == "true" then
					return true
				end
				return false

			end
			local value,name;
			local stnode =doc:select("/response/status");
			if type (stnode) == "table" then
				local childs = stnode[1]:select("child::*")
				if type (childs) == "table" then
					for i=1,#childs do
						name = childs[i]:name()
						value = childs[i]:text()
						if name == "value" then
							status = toboolean(string.lower(value))
						elseif name == "message" then
							message=value
						end
					end
				end
			end
			if status then

				local cvmap={}
				for _,col in ipairs(self.description.columns) do
					if col.type == "integer" or col.type == "numeric" then
						cvmap[col.name] = tonumber
					elseif col.type == "boolean" then
						cvmap[col.name] = toboolean
					end
				end
				local rows;
				
				if operationDescription.XPathRow and #operationDescription.XPathRow>0 then
					rows = doc:select(operationDescription.XPathRow)
				else
					rows = doc:select("/response/row")
				end
				--local fields;
				local haveAnidation
				if type ( rows ) == "table" then

					for index=1,#rows do
						local row ={}
						for k,v in ipairs(resulset.colnames) do
							if v == "_rowid" then
								row[k]=_rowid
							else
								row[k]= json.null
							end
						end
						local fields = rows[index]:select("child::*")
						if type ( fields ) == "table" then
						
							local f
							for i=1,#fields do
								name = fields[i]:name()
								value = fields[i]:text()
								f = cvmap[name]
								if f then
									value = f(value)
								end
								if not cmap[name] then
									cmap[name]=#resulset.colnames+1
									tbinsert(resulset.colnames,name)
								end
								if fields[i]:child() then
									value =index;
									haveAnidation=true;
								end
								row[cmap[name]]=value
							end
							tbinsert(resulset.rows,row);
						end
					end
				end
				if haveAnidation and self.name and operationDescription == self.description.retrieve then
					-- guarda un xml en las variables de sesion que empieza en el parent
					-- de las rows
					inconcert.session.twt_wsresponsesXml[self.name] = txtXML;
					inconcert.session.twt_wsresponsesPath[self.name] = operationDescription.XPathRow;
				end
			else
				return false, messages.messageKey('webservice_error',{description=message})
			end
		else
			return false,messages.messageKey('unsupported_mimetype',{type=operationDescription.responseMessageType});
		end
		return true,resulset
	end
	function self:request(data,context,opDescriptor)
		local status,url,body,token
		status = true

		if self.description.retrieve.requestMethod == "POST" then
			status,body = self:buildRequestBody(data,context,opDescriptor)
		end
		if status then
			status,url = self:buildRequestURL(data,context,opDescriptor)
			if status then
				if opDescriptor.requestMethod == "POST" then
					local headers = {}
					if opDescriptor.requestMessageType == "x-www-form-urlencoded" then
						headers['Content-Type'] = "application/x-www-form-urlencoded"
					elseif opDescriptor.requestMessageType == "soap" then
						headers['Content-Type'] = "text/xml;charset=UTF-8"
						headers['SOAPAction'] = "\"" .. opDescriptor.soapAction .."\""
					end
					status,response = Post(url,body,headers,token)
				else
					status,response = Get(url,nil,token)
				end

				if status then

					return self:parseResponse(response,context,opDescriptor);
				else

					return status,messages.messageKey('webservice_error',{message=response}) --fail
				end
			else
				return status,url -- fail
			end
		else
			return status,body -- fail
		end

	end
	function self:get(data,context)
		return self:request(data,context,self.description.retrieve);
	end
	function self:update(data,context)
		return self:request(data,context,self.description.update);
	end
	function self:save(data,context)
		return self:request(data,context,self.description.store);
	end
	function self:delete(data,context)
		return self:request(data,context,self.description.delete);
	end
	return self
end
