/*jslint evil:true */
/*global  __icc__
*/
(function(icc){
	var  mainFrame;
	if(!icc.ui.framework){
		icc.ui.framework = {};
	}
	if(!icc.ui.framework.documentView){
		icc.ui.framework.documentView={};
	}
	var tabController = function (tabControl){
		var self = this;
		tabController.SUPERconstructor.call(this);
		this.tabControl = tabControl;
		this.cDocument = this.getCurrentDoc();
		this.tabControl.onClose(function(idx,item){
			var doc = item.getDocument();
			if (doc.getDirty()){
				icc.ui.msgbox(_T("Changes to the document will be lost.\r\nAre you sure?"),undefined,"question",function(status){
					if(status==='ok'){
						self.rmvView(item);
						self.fireEvent("onDocChanged",undefined,undefined);
					}
				});
				return false;// siempre retorna false
			}else{
				self.fireEvent("onDocChanged",undefined,undefined);
			}
			return true;
		});
		this.tabControl.onChange(function(idx,item){
			if(self.cDocument){
				self.cDocument.detachView(self);
			}
				
			if(item){
				self.cDocument = item.getDocument();
				self.cDocument.attachView(self);
				self.fireEvent("onDocChanged",self.cDocument,item);
			}else{
				self.cDocument = null;
				self.fireEvent("onDocChanged",undefined,undefined);
			}
		});
	};
	icc.utils.inherit(tabController,icc.ui.object);
	
	// Evento disparado cuandoe el documemento actual dispara el updateAllViews
	// cosas que no son views como los botones de copy y paste usan esto para
	// updatearse
	tabController.prototype.onDocUpdate = function(fn){
		this.addListener("onDocUpdate",fn);
			
	};
	tabController.prototype.updateDocumentState=function(){
		this.fireEvent("onDocStateChanged",this.cDocument);
	};
	tabController.prototype.onUpdate = function (sender,hint,data){
		this.fireEvent("onDocUpdate",this.cDocument,sender,hint,data);
	};
	// Evento disparado cuando cambia el documento actual
	tabController.prototype.onDocChanged = function(fn){
		this.addListener("onDocChanged",fn);
		
	};
	// Evento disparado cuando el documento actual cambia de estado
	tabController.prototype.onDocStateChanged = function(fn){

		this.addListener("onDocStateChanged",fn);
	};
	tabController.prototype.hasView = function (view){
		return this.tabControl.hasChild(view);
	};
	tabController.prototype.setView = function(view){
		
		if(this.tabControl.hasChild(view)){
			this.tabControl.setItem(view);
			if(this.cDocument!==view.getDocument()){
				this.cDocument.detachView(this);
				this.cDocument = view.getDocument();
				this.cDocument.attachView(this);
			}
			this.fireEvent("onDocChanged",this.cDocument,view);
		}	
	};
	tabController.prototype.renameView = function (view,newName){	// asume que es una pestaa del tab
		view.setCaption(newName);
	};
	
	tabController.prototype.rmvView = function (view){	// asume que es una pestaa del tab
		
		this.tabControl.rmvChild(view);
		if(this.cDocument!==view.getDocument()){
			this.cDocument.detachView(this);
		}
			
		view = this.tabControl.getItem();
		if(view){
			this.cDocument = view.getDocument();
			this.cDocument.attachView(this);
			this.fireEvent("onDocChanged",this.cDocument,view);
		}else{
			this.fireEvent("onDocChanged",undefined,undefined);
		}
	};
	tabController.prototype.addView = function ( view){
		if(this.tabControl.hasChild(view)){
			this.tabControl.setItem(view);
			if(this.cDocument!==view.getDocument()){
				this.cDocument.detachView(this);
				this.cDocument = view.getDocument();
				this.cDocument.attachView(this);
			}
			this.fireEvent("onDocChanged",this.cDocument,view);
		}else{
			this.tabControl.addChild(view);
			this.tabControl.setItem(view.widgetid);
			if(this.cDocument){
				this.cDocument.detachView(this);
			}
			this.cDocument = view.getDocument();
			this.cDocument.attachView(this);
			this.fireEvent("onDocChanged",this.cDocument,view);
		}
	};
	tabController.prototype.getCurrentDoc = function(){
		var view = this.tabControl.getItem();
		if(view){
			return view.getDocument();
		}
		return undefined;
	};
	// metodo que indica que se quiere salvar el documento actual
	// cada clase derivada de tabController lo implementa.
	tabController.prototype.saveCurrentDoc = function() {
		var view = this.tabControl.getItem();
		if (!view) {
			return;
		}
		var doc = view.getDocument();
		var validation_result = view.performValidation();
		if(validation_result === true || validation_result.success){
			doc.save(function(status,result){
				if(!status){
					icc.ui.displayMessage(result);
				}
			});
		}
		else {
			if (typeof(validation_result) === "object") {
				icc.ui.displayMessage(validation_result.message);
			}
		}
	};
	icc.ui.framework.documentView.tabController = tabController;
	
	mainFrame = function(args){
		
		mainFrame.SUPERconstructor.call(this, args,'panel');
	};
	icc.utils.inherit(mainFrame,icc.ui.panel);
	mainFrame.prototype.create = function(){
		var self = this;
		this.topPanel = new icc.ui.panel({fillWidth:true,layoutMode:"horizontal"});
		this.leftPanel = new icc.ui.panel({fillHeight:true});
		this.rightPanel = new icc.ui.panel({fillHeight:true,sideRight:true});
		this.bottomPanel = new icc.ui.panel({fillWidth:true,layoutMode:"horizontal",sideBottom:true});
		if(this.tabControl ===undefined){
			this.tabControl = new icc.ui.tabpanel({"fillWidth":true,"fillHeight":true});
		}
		this.hframe= new icc.ui.panel({
			fillWidth:true,
			fillHeight:true,
			layoutMode:"horizontal",
			childs:[
				this.leftPanel,
				this.rightPanel,
				this.tabControl
			]
		});

		this.childs = [
			this.topPanel,
			this.hframe,
			this.bottomPanel
		];
		mainFrame.SUPERclass.create.call(this);
		this.cDocument = this.getCurrentDoc();
		this.tabControl.onClose(function(idx,item){
			var doc = item.getDocument();
			if (doc.getDirty()){
				icc.ui.msgbox(_T("Changes to the document will be lost.\r\nAre you sure?"),undefined,"question",function(status){
					if(status==='ok'){
						self.rmvView(item);
						
					}
				});
				return false;// siempre retorna false
			}
			return true;
		});
		this.tabControl.onChange(function(idx,item){
			if(self.cDocument){
				self.cDocument.detachView(self);
			}
				
			if(item){
				self.cDocument = item.getDocument();
				self.cDocument.attachView(self);
				self.fireEvent("onDocChanged",self.cDocument,item);
			}else{
				self.cDocument = undefined;
				self.fireEvent("onDocChanged",undefined,undefined);
			}
		});
		return this.wnd;
	};
	
	mainFrame.prototype.updateDocumentState=function(){
		this.fireEvent("onDocStateChanged",this.cDocument);
	};
	mainFrame.prototype.onUpdate = function (sender,hint,data){
		this.fireEvent("onDocUpdate",this.cDocument,sender,hint,data);
	};
	
	// Evento disparado cuando cambia el documento actual
	mainFrame.prototype.onDocUpdate = function(fn){
		this.addListener("onDocUpdate",fn);
	};
	mainFrame.prototype.onDocChanged = function(fn){
		this.addListener("onDocChanged",fn);
		
	};
	// Evento disparado cuando el documento actual cambia de estado
	mainFrame.prototype.onDocStateChanged = function(fn){

		this.addListener("onDocStateChanged",fn);
	};
	mainFrame.prototype.hasView = function (view){
		return this.tabControl.hasChild(view);
	};
	mainFrame.prototype.setView = function(view){
		
		if(this.tabControl.hasChild(view)){
			this.tabControl.setItem(view);
			if(this.cDocument!==view.getDocument()){
				this.cDocument.detachView(this);
				this.cDocument = view.getDocument();
				this.cDocument.attachView(this);
			}
			this.fireEvent("onDocChanged",this.cDocument,view);
		}	
	};
	mainFrame.prototype.rmvView = function (view){	// asume que es una pestaa del tab
		
		this.tabControl.rmvChild(view);
		if(this.cDocument!==view.getDocument()){
			this.cDocument.detachView(this);
		}
			
		view = this.tabControl.getItem();
		if(view){
			this.cDocument = view.getDocument();
			this.cDocument.attachView(this);
			this.fireEvent("onDocChanged",this.cDocument,view);
		}else{
			this.fireEvent("onDocChanged",undefined,undefined);
		}
	};
	mainFrame.prototype.addView = function ( view , opts){
		switch(opts){
			case "right":
				this.rightPanel.addChild(view);
				this.hframe.layout();
			break;
			case "left":
				this.leftPanel.addChild(view);
				this.hframe.layout();
			break;
			case "top":
				this.topPanel.addChild(view);
			break;
			case "bottom":
				this.bottomPanel.addChild(view);
			break;
			default:
				if(this.tabControl.hasChild(view)){
					this.tabControl.setItem(view);
					if(this.cDocument!==view.getDocument()){
						this.cDocument.detachView(this);
						this.cDocument = view.getDocument();
						this.cDocument.attachView(this);
					}
					this.fireEvent("onDocChanged",this.cDocument,view);
				}else{
					this.tabControl.addChild(view);
					this.tabControl.setItem(view.widgetid);
					if(this.cDocument){
						this.cDocument.detachView(this);
					}
					this.cDocument = view.getDocument();
					this.cDocument.attachView(this);
					this.fireEvent("onDocChanged",this.cDocument,view);
				}
				
		}
		
		this.layout();
	};
	mainFrame.prototype.getCurrentDoc = function(){
		var view = this.tabControl.getItem();
		if(view){
			return view.getDocument();
		}
		return undefined;
	};
	// metodo que indica que se quiere salvar el documento actual
	// cada clase derivada de mainFrame lo implementa.
	mainFrame.prototype.saveCurrentDoc = function(){
		var view = this.tabControl.getItem();
		if (!view) {
			return;
		}
		var doc = view.getDocument();
		var validation_result = view.performValidation();
		if(validation_result.success){
			doc.save(function(status,result){
				if(!status){
					icc.ui.displayMessage(result);
				}
			});
		}
		else {
			icc.ui.displayMessage(validation_result.message);
		}
	};
	icc.ui.framework.documentView.mainFrame = mainFrame;
})(__icc__);

(function(icc){
	var document;
	document = function ( args) {
		document.SUPERconstructor.call(this);
		this.views = [];
		this.args = args;
		this._dirty = false;
	};
	icc.utils.inherit(document,icc.ui.object);
	
	document.prototype.setDirty = function(newState){
		this._dirty = newState;
		for (var idx=0;idx<this.views.length;idx++){
			this.views[idx].updateDocumentState(this,newState);
		}
	};
	document.prototype.getDirty = function(){
		return this._dirty;
	};
	
	document.prototype.attachView = function ( newView){
		this.views.push(newView);
	};
	document.prototype.detachView = function ( view){
		for (var idx=0;idx<this.views.length;idx++){
			if(view === this.views[idx]){
				this.views.splice(idx,1);
				break;
			}
		}
	};
	document.prototype.save = function (cb){
		if(cb){
			cb(false,icc.ui.message('invalid_operation'))
		}
	}
	document.prototype.updateAllViews = function (sender,hint,data){
		for (var idx=0;idx<this.views.length;idx++){
			this.views[idx].onUpdate(sender,hint,data);
		}
	};
	icc.ui.framework.documentView.document = document;
})(__icc__);
(function(icc){
	var view;
	view = function ( document,args) {
		this._document = document;
		document.attachView(this);
		view.SUPERconstructor.call(this,args);
	};
	icc.utils.inherit(view,icc.ui.panel);
	view.prototype.getDocument = function (){
		return this._document;
	};
	view.prototype.updateDocumentState = function (){
	};
	view.prototype.onUpdate = function (sender,hint,data){
	};
	view.prototype.haveCopyPasteInfo = function(){
		return false;
	};
	view.prototype.acceptCopyPasteInfo = function(info){
		return false;
	};
	view.prototype.getCopyPasteInfo = function(info){
		
	};
	view.prototype.setCopyPasteInfo = function(info){
		
	};
	view.prototype.goUndo = function (){
	};
	view.prototype.getUndoCount = function (){
		return 0;
	};
	view.prototype.destroy = function(){
		this._document.detachView(this);
		view.SUPERclass.destroy.call(this);
	};
	view.prototype.performValidation = function()
	{
		var response = {
			success: true
		};
		var doc = this._document;
		if (!doc) {
			return response;
		}
		var content = doc.getContent();
		if (!content) {
			return response;
		}
		var frm = (content.childs || [])[0];
		if (!frm) {
			return response;
		}

		/* --------------------------------------------------------------
			Save - Validacion exclusiva para los controles de tipo "captcha"
					Esto debe ir en control de runtime propio de "captcha", pero de momento queda aca.
					Por ejemplo en la clase base "widget" puede exisitr una funcion "can_save" que siempre retorne "true" y
					en la clase hija "captcha" deberia implementarse y realizar las validaciones pertinentes (similares al codigo de abajo).
					...
					La proxima vez modificame please!!
		*/
		var MIN_RUNTIME_CAPTCHA_SIZE_HEIGHT = 490;
		var MIN_RUNTIME_CAPTCHA_SIZE_WIDTH = 311;

		var frm_ctrls = frm.childs || [];
		$.each(frm_ctrls, function(_, control)
		{
			if (control.type == "ui.captcha") {
				if (frm.height < MIN_RUNTIME_CAPTCHA_SIZE_HEIGHT || frm.width < MIN_RUNTIME_CAPTCHA_SIZE_WIDTH) {
					response.success = false;
					response.message = "captcha requires a minimum of form size of " + MIN_RUNTIME_CAPTCHA_SIZE_WIDTH + "px width by " + MIN_RUNTIME_CAPTCHA_SIZE_HEIGHT + "px height";
					return false; // break
				}
			}
		});
		/* ---------------------------------------------------------------- */

		return response;
	};
	icc.ui.framework.documentView.view = view;
})(__icc__);




(function(icc){
	var stdButtonSave;
	stdButtonSave = function ( mainFrame,args) {
		var self = this;
		args.enabled = false;
		stdButtonSave.SUPERconstructor.call(this,args);
		mainFrame.onDocChanged(function(currentDoc){
			self.currentDoc = currentDoc;
			self.setEnabled(currentDoc && currentDoc.getDirty());
		});
		mainFrame.onDocStateChanged(function(doc){
			if(self.currentDoc === doc){
				self.setEnabled(self.currentDoc.getDirty());
			}
		});
		this.onClick(function(){
			mainFrame.saveCurrentDoc();
		});
	};
	

	stdSaveHandler = function ( mainFrame,pButton){
		var m_currentDoc;
		pButton.setEnabled(false);
		mainFrame.onDocChanged(function(currentDoc){
			m_currentDoc = currentDoc;
			pButton.setEnabled(m_currentDoc && m_currentDoc.getDirty());
		});
		mainFrame.onDocStateChanged(function(doc){
			if(m_currentDoc === doc){
				pButton.setEnabled(m_currentDoc.getDirty());
			}
		});
		pButton.onClick(function(){
			mainFrame.saveCurrentDoc();
		});
		
		pButton.enabled = false;
		
	}
	icc.utils.inherit(stdButtonSave,icc.ui.button);
	
	
	icc.ui.framework.documentView.stdButtonSave = stdButtonSave;
	icc.ui.framework.documentView.stdSaveHandler = stdSaveHandler;
	
})(__icc__);

(function(icc){
	var stdButtonUndo;
	stdButtonUndo = function ( mainFrame,args) {
		var self = this;
		args.enabled = false;
		stdButtonUndo.SUPERconstructor.call(this,args);
		mainFrame.onDocChanged(function(currentDoc,currentView){
			self.currentDoc = currentDoc;
			self.currentView = currentView;
			self.setEnabled(self.currentView && self.currentView.getUndoCount());
		});
		mainFrame.onDocStateChanged(function(doc){
			if(self.currentDoc === doc){
				self.setEnabled(self.currentView && self.currentView.getUndoCount());
			}
		});
		
		this.onClick(function(){
			self.currentView.goUndo();
		});
	};
	icc.utils.inherit(stdButtonUndo,icc.ui.button);
	icc.ui.framework.documentView.stdButtonUndo = stdButtonUndo;
})(__icc__);

(function(icc){
	var stdButtonCopy;
	var copyPasteInfo;
	var pasteInstances = [];
	stdButtonCopy = function ( mainFrame,args) {
		var self = this;
		args.enabled = false;
		stdButtonCopy.SUPERconstructor.call(this,args);
		mainFrame.onDocUpdate(function(doc,sender,hint,data){
			if(self.currentDoc === doc){
				self.setEnabled(self.currentView && self.currentView.haveCopyPasteInfo());
			}
		
		});
		mainFrame.onDocChanged(function(doc,view){
			self.currentDoc = doc;
			self.currentView = view;
			self.setEnabled(self.currentView && self.currentView.haveCopyPasteInfo());
		});
		
		this.onClick(function(){
			copyPasteInfo = self.currentView.getCopyPasteInfo();
			for(var idx in pasteInstances){
				pasteInstances[idx].update();
			}
		});
	};
	icc.utils.inherit(stdButtonCopy,icc.ui.button);
	icc.ui.framework.documentView.stdButtonCopy = stdButtonCopy;
	var stdButtonPaste;
	stdButtonPaste = function ( mainFrame,args) {
		var self = this;
		args.enabled = false;
		stdButtonPaste.SUPERconstructor.call(this,args);
		pasteInstances.push(this);
		mainFrame.onDocChanged(function(currentDoc,currentView){
			self.currentDoc = currentDoc;
			self.currentView = currentView;
			self.setEnabled(self.currentView && copyPasteInfo !==undefined && self.currentView.acceptCopyPasteInfo(copyPasteInfo));
		});
		mainFrame.onDocUpdate(function(doc,sender,hint,data){
			if(self.currentDoc === doc){
				self.setEnabled(self.currentView && copyPasteInfo !==undefined && self.currentView.acceptCopyPasteInfo(copyPasteInfo));
			}
		
		});
		
		
		this.onClick(function(){
			if(this.currentView && copyPasteInfo !==undefined && this.currentView.acceptCopyPasteInfo(copyPasteInfo)){
				this.currentView.setCopyPasteInfo(copyPasteInfo);
			}
		});
	};
	
	icc.utils.inherit(stdButtonPaste,icc.ui.button);
	stdButtonPaste.prototype.update = function(){
		this.setEnabled(this.currentView && copyPasteInfo !==undefined && this.currentView.acceptCopyPasteInfo(copyPasteInfo));		
	};
	stdButtonPaste.prototype.destroy = function(){
		var self = this;
		jQuery.each(pasteInstances,function(idx,inst){
			if(inst === self){
				pasteInstances.splice(idx,1);
				return false;// end each
			}
		});
		
	};
	icc.ui.framework.documentView.stdButtonPaste = stdButtonPaste;
	
})(__icc__);



(function(icc){
	icc.ui.designer={
	
	
	};
	
})(__icc__);


/*jslint evil:true */
/*global jQuery unescape window escape __icc__ $LAB setTimeout _T
*/
(function(icc){
	var  applicationDoc;
	applicationDoc = function(vccName,appId){
		applicationDoc.SUPERconstructor.call(this);
		this.appId = appId;
		this.vccName = vccName;
	};
	icc.utils.inherit(applicationDoc,icc.ui.framework.documentView.document);
	
	applicationDoc.prototype.readSystemImages = function (cb){
	    jQuery.ajax({
			url: "designer/images",
			dataType:"json",
			data:'',
			success: function(ajaxResponse){
				var res = false;
				if(cb){
					
					cb(ajaxResponse.status,ajaxResponse.result);
				}
					
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});

	};
	applicationDoc.prototype.readSystemDatasources = function (cb){
	    jQuery.ajax({
			url: "designer/datasources",
			dataType:"json",
			data:'',
			success: function(ajaxResponse){
				var res = false;
				if(cb){
					
					cb(ajaxResponse.status,ajaxResponse.result);
				}
					
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});

	};
	
	
	applicationDoc.prototype.readPrivateData = function ( cb) {
	
	    jQuery.ajax({
			url: "designer/applications/"+this.appId+"/private/read",
			async: true,
			dataType:"json",
			data:'',
			success: function(ajaxResponse){
				var res = false;
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
					
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	
		
	};
	applicationDoc.prototype.savePrivateData = function ( data , cb){
	    jQuery.ajax({
			url: "designer/applications/"+this.appId+"/private/save",
			type: 'POST',
			async: true,
			dataType:"json",
			data:''.concat("content=" ,encodeURIComponent(JSON.stringify(data))),
			success: function(ajaxResponse){
				if(cb){
					icc.ui.designer.datasourceDoc.clearDSCache();
					cb(ajaxResponse.status,ajaxResponse.result);
				}
					
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	
	};
	applicationDoc.prototype.setProperties = function (properties,cb){
		var self = this;
	    jQuery.ajax({
			url: "designer/applications/"+this.appId+"/setproperties",
			type: 'POST',
			async: true,
			dataType:"json",
			data:''.concat("content=" ,encodeURIComponent(JSON.stringify(properties))),
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					for (var idx in properties){
						self.catalog[idx] = properties[idx]
					};
				}
				if(cb){
					
					cb(ajaxResponse.status,ajaxResponse.result);
				}
					
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
		
	};
	applicationDoc.prototype.readResourceFile = function(resourceName,cb){
		var self=this;
		for (var idx=0;idx<this.catalog.resources.length;idx++){
			if(resourceName === this.catalog.resources[idx].src){
				jQuery.ajax({
					type: 'GET',
					url: "designer/applications/"+ icc.ui.getApplication()._authToken+"/"+this.appId+"/resources/"+resourceName,
					success: function(ajaxResponse){
						if(cb){
							cb(ajaxResponse);
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});
				return;
			}
		}
		if(cb){
			setTimeout(function(){
				cb(false,icc.ui.message('argument_error',{module:"designerApplication.js",func:"readResourceFile",param:"resourceName",value:resourceName}));
			});
		}
	
	}
	applicationDoc.prototype.renameResource = function(resourceName,newName,cb){
		var self=this;
		for (var idx=0;idx<this.catalog.resources.length;idx++){
			if(resourceName === this.catalog.resources[idx].src){
				var index = idx;
				jQuery.ajax({
				
					dataType:'json',
					type: 'POST',
					contentType: "application/json",
					beforeSend: function (request) {
						request.setRequestHeader('Content-Encoding', 'utf-8');
					},
					data:JSON.stringify({
						componentName:resourceName,
						newName:newName,
						componentType:'resource'
					}),
					url: "designer/applications/"+this.appId+"/rename_component",
					success: function(ajaxResponse){
						if(ajaxResponse.status){
							self.catalog.resources[index].src = newName
							
						}
						if(cb){
							cb(ajaxResponse.status,ajaxResponse.result);
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});
				return;
			}
		}
		if(cb){
			setTimeout(function(){
				cb(false,icc.ui.message('argument_error',{module:"designerApplication.js",func:"renameResource",param:"resourceName",value:resourceName}));
			});
		}
		
	};
	applicationDoc.prototype.renameForm = function(formName,newName,cb){
		var self=this;
		for (var idx=0;idx<this.catalog.views.length;idx++){
			if(formName === this.catalog.views[idx].name){		
				var index = idx;
				jQuery.ajax({
				
					dataType:'json',
					type: 'POST',
					contentType: "application/json",
					beforeSend: function (request) {
						request.setRequestHeader('Content-Encoding', 'utf-8');
					},
					data:JSON.stringify({
						componentName:formName,
						newName:newName,
						componentType:'form'
					}),
					url: "designer/applications/"+this.appId+"/rename_component",
					success: function(ajaxResponse){
						if(ajaxResponse.status){
							self.catalog.views[index].name= newName
						}
						if(cb){
							cb(ajaxResponse.status,ajaxResponse.result);
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});
				return;
			}
		}
		if(cb){
			setTimeout(function(){
				cb(false,icc.ui.message('argument_error',{module:"designerApplication.js",func:"renameForm",param:"resourceName",value:resourceName}));
			});
		}
		
	};
	applicationDoc.prototype.renameDatasource = function(datasourceName,newName,cb){
		var self=this;
	    for (var idx=0;idx<this.catalog.datasources.length;idx++){
			if(datasourceName === this.catalog.datasources[idx]){
				var index = idx;
				jQuery.ajax({
				
					dataType:'json',
					type: 'POST',
					contentType: "application/json",
					beforeSend: function (request) {
						request.setRequestHeader('Content-Encoding', 'utf-8');
					},
					data:JSON.stringify({
						componentName:datasourceName,
						newName:newName,
						componentType:'datasource'
					}),
					url: "designer/applications/"+this.appId+"/rename_component",
					success: function(ajaxResponse){
						if(ajaxResponse.status){
							self.catalog.datasources[index]= newName
							icc.ui.designer.datasourceDoc.clearDSCache(self.appId,datasourceName);

						}
						if(cb){
							cb(ajaxResponse.status,ajaxResponse.result);
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});
				return;
			}
		}
		if(cb){
			setTimeout(function(){
				cb(false,icc.ui.message('argument_error',{module:"designerApplication.js",func:"renameDatasource",param:"resourceName",value:resourceName}));
			});
		}
		
	};
	
	applicationDoc.prototype.load=function(cb){
		var self = this;
		jQuery.ajax({
			dataType:"json",
			url: "designer/applications/"+this.appId+"/load",
			success: function(ajaxResponse){
				var libs;
				if(ajaxResponse.status){
					self.catalog = ajaxResponse.result;
					// se cargan las librerias javascript que la aplicacion tenga
					libs = self.getLibraries();
					if(libs.length){	// mmm , mejor no cargar nada ya que con los <% FRAME se arma flor de lio 
						var request = [];
						
						for (var idx=0;idx<libs.length;idx++){
							if(new RegExp("^designer_extensions_[a-z]+","i").test(libs[idx].src)){
								request.push({
									src:"designer/applications/"+self.appId+"/resources/"+libs[idx].src
								});
							}
						}
						if(request.length>0){
							$LAB.script(request).wait(function(){
								if(cb){
									cb(true);
								}
							});
						}else if(cb){
							cb(true)
						}
					}else if(cb){
						// le damos una precarga a los datasources asi es mas performante todo despues
						// pero principalmente se puede usar loadFromCache al cargar un ds para explorar campos y outstreams
						// el objeto del documento applicationDoc usa loadFromCache para retornar listas de datasources con 
						// outsteams
						var dslist = icc.utils.clone(self.catalog.datasources) ;
						var loadNext = function(){
							var dsname = dslist.shift();
							if(dsname){
								var dsdoc = new icc.ui.designer.datasourceDoc(self.getVCCName(), self.getId(), dsname);
								dsdoc.load(function (status) {
									loadNext();	
								})
								
							}else{
								cb(true)
							}
						}
						loadNext();
					}
				}else{
					if(cb){
						cb(false,ajaxResponse.result);
					}
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	};

	applicationDoc.prototype.getViews = function(){
		var res = [];
		$(this.catalog.views).each(function(idx,viewEntry) {
			if(viewEntry.type == "form") {
				var clonedView = icc.utils.clone(viewEntry);
//				clonedView.name = _T(clonedView.name);
				res.push(clonedView);
			}
		});
		res.sort(function(item1,item2){
			return item1.name.localeCompare(item2.name);
		});
		return res;
	};

	applicationDoc.prototype.getReports = function(){
		var res = [];
		jQuery(this.catalog.views).each(function(idx,viewEntry){
			if(viewEntry.type == "report")
				res.push(icc.utils.clone(viewEntry))
		})
		return res;
	};
	
	applicationDoc.prototype.getName=function(){
		return this.appId;
	};
	
	applicationDoc.prototype.getId = function(){
		return this.appId;
	};
	applicationDoc.prototype.getVCCName = function(){
		return this.vccName;
	};
	applicationDoc.prototype.getDefaultView = function(){
		return this.catalog.defaultView;
	};
	applicationDoc.prototype.getCatalog = function(){
		return this.catalog;
	};
	applicationDoc.prototype.getDatasources = function(opts){
		var res = [];
		opts = opts || {}
		opts.outstreams=false; //desactivados
		if(!this.catalog || !this.catalog.datasources){
			return [];
		}
		for (var idx =0;idx<this.catalog.datasources.length;idx++){
			if(opts.datasources !== false)
				res.push({name:this.catalog.datasources[idx]});
			var dsdoc = new icc.ui.designer.datasourceDoc(this.getVCCName(), this.getId(), this.catalog.datasources[idx]);
			if(opts.outstreams == true){
				if(dsdoc.loadFromCache()){
					var outstreams = dsdoc.getOutStreams();
					for (var i = 0;i< outstreams.length;i++){
						var outstream = outstreams[i]
						res.push({name:outstream.name});
					}
				}
			}
		}
		res.sort(function(item1,item2){
			return item1.name.localeCompare(item2.name)
		});
		return res;
	};
	applicationDoc.prototype.getResources = function(){
		if(!this.catalog || !this.catalog.resources){
			return [];
		}
		
		return this.catalog.resources;
	};
	applicationDoc.prototype.getLibraries = function(){
		var result = [];
		var res;
		if(!this.catalog || !this.catalog.resources){
			return [];
		}
		for (var idx=0;idx<this.catalog.resources.length;idx++){
			res = this.catalog.resources[idx];
			if(res.mimeType.substring(0,4)=='text')
				result.push(res)
		}
		return result;
	};
	applicationDoc.prototype.deleteResourceFile = function(fileName,cb){
		var self=this;
		for (var idx=0;idx<this.catalog.resources.length;idx++){
			if(fileName === this.catalog.resources[idx].src){
				jQuery.ajax({
					url: "designer/applications/"+this.appId+"/resources/delete/"+fileName,
					dataType:'json',
					success: function(ajaxResponse){
						if(ajaxResponse.status){
							self.setDirty(true);
							self.catalog.resources.splice(idx,1);
						}
						if(cb){
							cb(ajaxResponse.status,ajaxResponse.result);
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});
				return;
			}
		}
		if(cb){
			setTimeout(function(){
				cb(false,icc.ui.message('argument_error',{module:"designerApplication.js",func:"deleteResourceFile",param:"fileName",value:fileName}));
			});
		}
	};
	applicationDoc.prototype.addResourceFromFile = function(fileid,cb){
	    var self=this;
	    jQuery.ajax({
		    url: "designer/applications/"+this.appId+"/resources/addfile/"+fileid,
		    type: 'POST',
		    async: true,
		    dataType:"json",
		    data:'',
		    success: function(ajaxResponse){
				if(ajaxResponse.status){
					var r = {mimeType:ajaxResponse.result.mimeType,src:ajaxResponse.result.fileName};
					self.catalog.resources.push(r);
					if(cb){
						cb(ajaxResponse.status,r);
					}
					
				}else {
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				}
		    },
		    error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
	    });
	    return;

	};
	applicationDoc.prototype.addResourceFromFileEx = function(fileid,params,cb){
	    var self=this;
		params = params || {}
	    jQuery.ajax({
		    url: "designer/applications/"+this.appId+"/resources/addfile_ex/"+fileid,
			dataType:'json',
			type: 'POST',
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
		    data:JSON.stringify(params),
		    success: function(ajaxResponse){
				if(ajaxResponse.status){
					var r = {mimeType:ajaxResponse.result.mimeType,src:ajaxResponse.result.fileName};
					self.catalog.resources.push(r);
					if(cb){
						cb(ajaxResponse.status,r);
					}
					
				}else {
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				}
		    },
		    error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
	    });
	    return;

	};
	
	applicationDoc.prototype.createResourceFile = function(fileName,mimeType,content,cb){
	    var self=this;
	    for (var idx=0;idx<this.catalog.resources.length;idx++){
			if(fileName === this.catalog.resources[idx].src){
				if(cb){
					setTimeout(function(){
						cb(false,icc.ui.message('duplicated_entry',{
							description:_T('File already exist!'),
							entryName:fileName
						}));
					},1);
				}
				
				return;
			}
	    }
	    jQuery.ajax({
		    url: "designer/applications/"+this.appId+"/resources/add/"+fileName,
		    type: 'POST',
		    async: true,
		    dataType:"json",
		    data:''.concat("content=" ,encodeURIComponent(JSON.stringify({mimeType:mimeType,content:content}))),
		    success: function(ajaxResponse){
				if(ajaxResponse.status){
					var r = {mimeType:mimeType,src:fileName};
					self.catalog.resources.push(r);
					if(cb){
						cb(ajaxResponse.status,r);
					}
					
				}else {
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				}
		    },
		    error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
	    });
	    return;

	};

	applicationDoc.prototype.deleteForm = function(formName,cb){
		var self=this;
		for (var idx=0;idx<this.catalog.views.length;idx++){
			if(formName === this.catalog.views[idx].name){
				jQuery.ajax({
					dataType:'json',
					url: "designer/applications/"+this.appId+"/forms/delete/"+formName,
					success: function(ajaxResponse){
						if(ajaxResponse.status){
							self.setDirty(true);
							self.catalog.views.splice(idx,1);
						}
						if(cb){
							cb(ajaxResponse.status,ajaxResponse.result);
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});	
				return;
			}
		}
		if(cb){
			setTimeout(function(){
				cb(false);
			});
		}
		
	};
	applicationDoc.prototype.checkDatasourceName = function(datasourceName){
		for (var idx=0;idx<this.catalog.datasources.length;idx++){
		    if(datasourceName === this.catalog.datasources[idx]){
				return icc.ui.message('duplicated_entry',{description:_T('Datasource {entryName} already exist'),entryName:datasourceName})
		    }
		}
		return icc.ui.message('noerror');
	}
	applicationDoc.prototype.createDataSource = function(datasourceName,datasourceData,cb){

		var self=this;
		for (var idx=0;idx<this.catalog.datasources.length;idx++){
		    if(datasourceName === this.catalog.datasources[idx]){
				if(cb){
					setTimeout(function(){
						cb(false,icc.ui.message('duplicated_entry',{description:_T('Datasource {entryName} already exist'),entryName:datasourceName}));
					},1);
				}
				return;
		    }
		}
		jQuery.ajax({
			url: "designer/applications/"+this.appId+"/datasources/add/"+datasourceName,
			type: 'POST',
			async: true,
			dataType:"json",
			data:''.concat("content=" ,encodeURIComponent(JSON.stringify(datasourceData))),
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					self.catalog.datasources.push(datasourceName);
				}
				if(cb){
						
				    cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
		return;
	};
	applicationDoc.prototype.deleteDatasource = function(datasourceName,cb){
	    var self=this;
	    for (var idx=0;idx<this.catalog.datasources.length;idx++){
		if(datasourceName === this.catalog.datasources[idx]){
		    jQuery.ajax({
			url: "designer/applications/"+this.appId+"/datasources/delete/"+datasourceName,
			success: function(ajaxResponse){
				icc.ui.designer.datasourceDoc.clearDSCache(self.appId,datasourceName);
			    self.catalog.datasources.splice(idx,1);
			    self.setDirty(true);
			    if(cb){
					cb(true);
				}
				
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		    });
		    return;
		}
	    }
	    if(cb){
		    setTimeout(function(){
			    cb(false,icc.ui.message('argument_error',{module:'designerApplication',func:'deleteDatasource',param:'datasourceName',value:datasourceName}));
		    });
	    }

	};

	applicationDoc.prototype.createView = function(formName,formData,cb){
		
		var form;
		var self=this;
		for (var idx=0;idx<this.catalog.views.length;idx++){
			if(formName === this.catalog.views[idx].name){
				if(cb){
					setTimeout(function(){
						if(formData.formType == "report")
							cb(false,icc.ui.message('duplicated_entry',{description:_T("Report view {entryName} already exist")}));
						else
							cb(false,icc.ui.message('duplicated_entry',{description:_T("Form view {entryName} already exist")}));
					},1);
				}
				return;
			}
		}
		form = new icc.ui.designer.formDoc(this,formName,formData);
		form.getCtrlsTypes(function(status,ctrls){
			res = status;
			if(status){
				form.controltypes = ctrls;
				jQuery.ajax({
					url: "designer/applications/"+self.appId+"/forms/add/"+formName,
					type: 'POST',
					async: true,
					dataType:'json',
					data:''.concat("content=" ,encodeURIComponent(form.getContentJSON())),
					success: function(ajaxResponse){
						if(ajaxResponse.status){
							self.setDirty(true);
							form.setDirty(false);
							self.catalog.views.push({name:formName,type:formData.formType});
							
							if(cb){
								cb(true,form);
							}
						}else {
							if(cb){
								cb(ajaxResponse.status,ajaxResponse.result);
							}
						}
					},
					error:function(ajaxError){
						if(cb){
							cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
						}
					}
				});
			}else{
				if(cb){
					cb(false,ctrls);
				}
			}
		});
	};
	
	
	icc.ui.designer.applicationDoc = applicationDoc;
})(__icc__);


(function(icc){
	var  applicationView;

	applicationView = function(mainFrame,applicationDoc,arguments){
		var self = this;
		
		arguments = arguments || {}
		var args = arguments;
		this.mainFrame = mainFrame;
		var item_libs = [];
		var item_datasources = [];
		var item_views = [];
		var item_reports = [];
		var propertiesView;
		var t = applicationDoc.getLibraries();
		for (var idx=0;idx<t.length;idx++){
			if(!args.exclude || !args.exclude[t[idx].src])
				item_libs.push({caption:t[idx].src,ptr:t[idx],type:"library",icon:'script.png'});
		}
		t = applicationDoc.getViews();
		for (idx=0;idx<t.length;idx++){
			if(!args.exclude || !args.exclude[t[idx].name])
				item_views.push({caption:t[idx].name,ptr:t[idx],type:t[idx].type,icon:'view.png'});
		}
		t = applicationDoc.getReports();
		for (idx=0;idx<t.length;idx++){
			if(!args.exclude || !args.exclude[t[idx].name])
				item_reports.push({caption:t[idx].name,ptr:t[idx],type:t[idx].type,subtype:t[idx].subtype,icon:'report.png'});
		}
		
		
		var addButton = new icc.ui.button({icon:'addItem.png',tooltip:_T('Add Item'),width:22,height:22});
		var delButton = new icc.ui.button({icon:'rmvItem.png',tooltip:_T('Delete Item'),width:22,height:22,enabled:false});
		var svrAdrCfgButton = new icc.ui.button({icon:'settings.png',tooltip:_T('Address Settings'),width:22,height:22});
		var imageManagerButton = new icc.ui.button({icon:'picture.png',tooltip:_T('Image Managment'),width:22,height:22});
		var saveButton=new icc.ui.button({caption:'',tooltip:_T('Save'),icon:'save.png',height:22,width:22});
		<%VIEW:appExplorer%>
		if(arguments.toolbar_buttons === false){
			addButton.visible = false;
			delButton.visible = false;
			svrAdrCfgButton.visible = false;
			imageManagerButton.visible = false;
			btnMaximize.visible = false;
		}
		if(arguments.proyect_tree === false){ // El tree se queda sin tamaño y el panel de propiedades se muestra a todo el alto
			appTree.height=0;
			propertiesPanel.y = appTree.y;
		}
		if(arguments.properties_editor === false ){
			propertiesPanel.visible=false;
		}
			
		this.updateDatasourceColumns = function ( datasourceName,closeFolder){
			/*
			var dsnode;
			jQuery(item_datasources).each(function(idx,node){
				if(node.dsname == datasourceName){
					dsnode = node;
					return false;
				}
			});
			if(dsnode){
				var newDoc = new icc.ui.designer.datasourceDoc(applicationDoc.getVCCName(),applicationDoc.getId(),datasourceName);
				newDoc.load(function(status,result){
					if(status){
						appTree.rmvChilds(dsnode);
						
						var cols = newDoc.getFields();
						jQuery(cols).each(function(idx,col){
							appTree.addItem({caption:col.name,type:"field",_draginfo:{type:'field',field:col,datasourceName:datasourceName}},dsnode)
						});
						if(closeFolder)
							appTree.closeItem(dsnode);
						else{
							if(!appTree.getOpenState(dsnode)){
								appTree.closeItem(dsnode);
							
							}
						}
							
					}
				});
			}
			*/
		};
		var treeItemView = {caption: _T(args.tree_views_caption) || _T("Forms"),items:item_views};
		var treeItemDatasources = {caption:args.tree_datasources_caption || _T("Datasources"),items:item_datasources};
		var treeItemLibraries = {caption:args.tree_libraries_caption || _T("Libraries"),items:item_libs};
		var treeItemReports = {caption:args.tree_reports_caption || _T("Reports"),items:item_reports};

		var loadDatasourceColumns = function(){
			var t,idx
			t = applicationDoc.getDatasources();
			for (idx=0;idx<t.length;idx++){
				var dsnode = {caption:t[idx].name,ptr:t[idx],type:"datasource",icon:'datasource.png',dsname:t[idx].name}
				appTree.addItem(dsnode,treeItemDatasources);
				self.updateDatasourceColumns(t[idx].name,true);
				appTree.closeItem(dsnode);
			}
		}
		
		self.propertiesPanelBackground = propertiesPanel.background;
		if(saveButton!==undefined){
			icc.ui.framework.documentView.stdSaveHandler(mainFrame,saveButton)
		
		}
		var visible = false;
		
		var intervalHandler;
		
		btnMaximize.onClick(function(){
			var tgt =  appExplorer.parent.parent
			var st = appExplorer.parent.parent.parent
			var toggleActivation = function(){
				var self = this;
				if(this.maxState==undefined){
					this.maxState = false;
				}else{
					this.maxState = !this.maxState
					if(this.maxState){
						btnMaximize.setIcon("maximize.gif")
						
					}else{
						btnMaximize.setIcon("minimize.gif")
						
					}
				}
					
				
				var t;
				var parents=[];
				var parentsid={}
				t = st;
				while(t.parent){
					parents.push(t.parent);
					parentsid[t.parent.widgetid]=t.parent;
				
					t = t.parent;
					t._oldpt = t.pt
					if(!this.maxState){
						t._padding = {pt:t.pt,pb:t.pb,pl:t.pl,pr:t.pr}
						t.pt = 0;
						//t.pl=0;
						t.pb=0;
						//t.pr=0;
					
					}else{
						t.pt = t._padding.pt;t.pl = t._padding.pl;t.pr = t._padding.pr;t.pb = t._padding.pb;
					}
					
				}
				jQuery.each(parents,function(idx,p){
					jQuery.each(p.childs,function(idx,c){
						if(!parentsid[c.widgetid] && c!== st)
							c.setVisible(self.maxState);
					});
					p.layout();
				});				
			}
			var show=function(){
				visible = true;
				tgt.setVisible(true);
				tgt.parent.layout();
				
			};
			var hide=function(){
				visible = false;
				tgt.setVisible(false);
				tgt.parent.layout();
				
			
			};
			var toggle = function(){
				if(!visible)
					show();
				else
					hide();
			}
			if(!this.active){
				toggleActivation();
				hide();
				intervalHandler = setInterval(function(){
					var pos = icc.utils.getMousePosition();
					if(pos.x< 20){
						//show();
						tgt.setVisible(true);
						jQuery(tgt.getWnd()).css({
							zIndex:10000
						});
					}
					if(pos.x>appExplorer.parent.parent._w){
						hide();
					}
				},10);
				this.active = true;
			}else{
				
				clearInterval(intervalHandler);
				show();
				toggleActivation();
				this.active = false;
			}
		});
		var deleteItem = function(){
			var item = appTree.getItem();
			if(item){	// asume que el item activo en el tree ya tiene su correspondiente view con su documento asignado
				icc.ui.msgbox(_T('Please, confirm delete this object'),undefined,"question",
					function(status){
						if(status==="ok")
						{
							switch(item.type){
								case "report":
								case "form":
									var viewName = "";
									if (item.view) {
										viewName = item.view.getDocument().name;
									} else {
										viewName = item.ptr.name;
									}
									applicationDoc.deleteForm(viewName,function(status,result){
										if(status){
											if (item.view) {
												mainFrame.rmvView(item.view);
											}
											appTree.rmvItem(item);
										}else{
											icc.ui.displayMessage(result);
										}
									});
								break;
								case "library":
									applicationDoc.deleteResourceFile(item.view.getDocument().getName(),function(status,result){
										if(status){
											mainFrame.rmvView(item.view);
											appTree.rmvItem(item);
										}else{
											icc.ui.displayMessage(result);
										}
									});
								break;
								case "datasource":
									var viewName = "";
									if (item.view) {
										viewName = item.view.getDocument().getName();
									} else {
										viewName = item.ptr.name;
									}
									applicationDoc.deleteDatasource(viewName,function(status,result){
									    if(status){
											if (item.view) {
												mainFrame.rmvView(item.view);
											}
											appTree.rmvItem(item);
									    }else{
											icc.ui.displayMessage(result);
										}
									});
								break;
							}
						}
				});
					
			}
		
		}
		var tree_items = []
		if(args.add_form !== false)
			tree_items.push(treeItemView);
		if(args.add_report !== false)
			tree_items.push(treeItemReports);
		if(args.add_lib !== false)
			tree_items.push(treeItemLibraries);
		if(args.add_datasource !== false)
			tree_items.push(treeItemDatasources)
		if(args.tree_root != false){
			appTree.items = [
				{caption:args.tree_root_caption || applicationDoc.getName(),type:'project',
					items:tree_items
				}
			]
		}else{
			appTree.items = tree_items;
		}
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		appTree.onRightClick(function(item){
			item = this.getItem();// el right puede venir de algo que no esta seleccionado
			
			var parent = this.getParent(item)
			if (parent && (parent ==treeItemView || parent ==treeItemDatasources || parent ==treeItemLibraries || parent ==treeItemReports)){
			
				var items = [];
				if (( args.rename_form !== false && (!args.allow_rename?true:args.allow_rename(item))) )
					items.push({id:'ren',caption:_T('Rename')});
				if((!args.allow_delete?true:args.allow_delete(item)))
					items.push(	{id:'del',caption:_T('Delete')} )
				if(items.length){
					var mnu = new icc.ui.menu({
						items:items
					});
					mnu.popupMenu(icc.utils.getMousePosition(),
						function(mnuItem){
							switch(mnuItem.id){
								case 'ren':
									var dlg = icc.ui.msginput(_T("Enter new name"), item.caption, 270, _T('Rename element'),function(status,text){
										if(status==='ok' && text !== item.caption){
											if (parent == treeItemView || parent ==treeItemReports){
												if(icc.utils.isValidFilename(text) && icc.utils.isValidVariableName(text)){
													applicationDoc.renameForm(item.caption,text,function(status,result){
														if(status){
															item.view.getDocument().setName(text);
															item.ptr.name = text;
															item.caption  = text;
															appTree.updateItem(item);
															mainFrame.renameView(item.view,text);
															dlg.close();
														}else{
															icc.ui.displayMessage(result);
														}
													})
												}else{
													icc.ui.displayMessage(icc.ui.message('invalid_filename'));
												}
											
											}else if(parent == treeItemDatasources){
												if(icc.utils.isValidFilename(text) && icc.utils.isValidVariableName(text)){
													applicationDoc.renameDatasource(item.caption,text,function(status,result){
														if(status){
															item.view.getDocument().setName(text);
															item.ptr.name = text;
															item.caption  = text;
															appTree.updateItem(item);
															mainFrame.renameView(item.view,text);
															dlg.close();
														}else{
															icc.ui.displayMessage(result);
														}
													})
													
												}else{
													
													icc.ui.displayMessage(icc.ui.message('invalid_filename'));
												}
											
											}else if(parent ==	treeItemLibraries){
												if(icc.utils.isValidFilename(text)){
													applicationDoc.renameResource(item.caption,text,function(status,result){
														if(status){
															item.view.getDocument().setName(text);
															item.caption  = text;
															appTree.updateItem(item);
															mainFrame.renameView(item.view,text);
															dlg.close();
														}else{
															icc.ui.displayMessage(result);
														}
													})
												}else{
													icc.ui.displayMessage(icc.ui.message('invalid_filename'));
												}
											}
											return false; 	// nunca cierra el dialogo, luego de completadas las operaciones
															// asincronas se cierra a mano con dlg.close
										}
										
									})
										
								break
								case 'del':
									deleteItem();
								break
							}
						}
					)
				}
			
			}
		});
		////////////////////////////////////////////////////////////////////////////////////////////////////////		
		appTree.onChange(function (item){
			var newDoc,newView;
			var app = self.getDocument();
			delButton.setEnabled(item!==undefined && (!args.allow_delete?true:args.allow_delete(item)));
			var def = {};
			def[item.caption]=true
			var haveCloseButton= (args.close_permissions || def)[item.caption]==false?false:true;
			if(item && item.type){
				if(item.view && self.mainFrame.hasView(item.view)){
					self.mainFrame.setView(item.view);
					self.layout();
				}else{
					switch(item.type){
						case "project":
							if(args.proyectViewFn){
								newView = args.proyectViewFn(app,app);
								newView.haveCloseButton=haveCloseButton;
								newView.create();
								self.mainFrame.addView(newView);
								item.view = newView;
							}
						break;
						case "datasource":
							newDoc = new icc.ui.designer.datasourceDoc(app.vccName,app.appId,item.ptr.name);
							newDoc.load(function(status,result){
								if(status){
									newView = new icc.ui.designer.datasourceView(newDoc,app);
									newView.haveCloseButton=haveCloseButton;
									newView.create();
									self.mainFrame.addView(newView);
									item.view = newView;
								}else{
									icc.ui.displayMessage(result);
								}
								self.layout();
							});
						
						break;

						case "form":
						case "report":
							newDoc = new icc.ui.designer.formDoc(app,item.ptr.name);
							newDoc.load(function(status,result){
								if(status){
									if(newDoc.getFormType() == "report"){
										if (newDoc.getFormSubType() == undefined) 
											newView = new icc.ui.designer.reportView(mainFrame,newDoc);
										else if(newDoc.getFormSubType()=="bireport")
											newView = new icc.ui.designer.biReportView(mainFrame,newDoc);
											
									}else{
										if (newDoc.getFormSubType() == undefined) 
											newView = new icc.ui.designer.formView(mainFrame,newDoc,{withPropertiesPanel:args.in_document_properties_editor,showDocumentProperties:args.showDocumentProperties,propertiesPanelWidth:args.propertiesPanelWidth,propertiesPanelSide:args.in_document_properties_side,
																									 code_editor:args.form_view_code_editor,
																									 preview_window:args.form_view_preview_window});
										else if(newDoc.getFormSubType()=="dialog")
											newView = new icc.ui.designer.dialogView(mainFrame,newDoc);
									}
									newView.haveCloseButton=haveCloseButton;
									newView.create();
									
									if(args.aliases){
										newView.caption = args.aliases[newView.caption] || newView.caption;
									}
									
									self.mainFrame.addView(newView);
									item.view = newView;
								}else{
									icc.ui.displayMessage(result);
								}
								self.layout();
							});
						
						break;
						case "library":
							newDoc = new icc.ui.designer.jslibDoc(app.vccName,app.appId,item.ptr.src,item.ptr.mimeType);
							newDoc.load(function(status,result){
								if(status){
									newView = new icc.ui.designer.jslibView(newDoc);
									newView.haveCloseButton=haveCloseButton;
									newView.create();
									self.mainFrame.addView(newView);
									item.view = newView;
								}else{
									icc.ui.displayMessage(result);
								}
							});
							self.layout();
						break;
					}
				}
			}
			
		});
		var open = arguments.open
		appExplorer.onCreate(function(){
			loadDatasourceColumns();
			if(open){
				jQuery([item_libs,item_datasources,item_views,item_reports]).each(function(idx,items){
					jQuery(items).each(function(idx,item){
						if (item.caption == open){
							appTree.fireEvent("onChange",item);
						}
					})
				})
			}
		});

		////////////////////////////////////////////////////////////////////////////////////////////////////////		
		applicationView.SUPERconstructor.call(this,applicationDoc,{
			fillWidth:true,
			fillHeight:true,
			vs:7,
			childs:[
				appExplorer
			]
		});
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		svrAdrCfgButton.onClick(function(){
			var dlg = new icc.ui.designer.applicationConfigDlg(self.getDocument());
			dlg.create();
			dlg.showModal();
		});
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		imageManagerButton.onClick(function(){
			var dlg = new icc.ui.designer.imageManager(self.getDocument());
			dlg.create();
			dlg.showModal();
		});
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		delButton.onClick(deleteItem);
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		addButton.onClick(function(){
			var app = self.getDocument();
			var items = [
			];
			if(args.add_form !== false && args.mnu_add_form !== false)
				items.push({id:1,caption:_T('Form')});
			if(args.add_report !== false)
				items.push({id:4,caption:_T('Report')});
			if(args.add_lib !== false)
				items.push({id:2,caption:_T('Javascript library')});
			if(args.add_datasource !== false)
				items.push({id:3,caption:_T('Datasource')})
			if(args.custom_menu){
				for (idx in args.custom_menu){
					var entry = args.custom_menu[idx];
					if (entry.show_entry ){
						if(entry.show_entry({
							getApplicationDocument:function(){
								return applicationDoc;
							}
						})){
							items.push(entry);
						}
					}else
						items.push(entry);
				}
			}
				
			var mnu = new icc.ui.menu({items:items});
			
			mnu.popupMenu(addButton.parent.clientToScreen({x:addButton._x,y:addButton._y+addButton._h+2}),
				function(item){
					if(item.handler){
						item.handler({
							getApplicationDocument:function(){
								return applicationDoc;
							},
							addComponent:function(componentType,document,cb){
								var newView;
								switch(componentType){
									case 'view':
										document.content.__code = document.code
										document.content.__layoutcode = document.layoutcode;
										document.setupIds();	
										document.getCtrlsTypes(function(status,ctrls){
											res = status;
											if(status){
												document.controltypes = ctrls;
												applicationDoc.createView(document.name,document.content,function(status,result){
													if(status){
														var item = {caption:document.name,ptr:document,type:"form",icon:'view.png'};
														if(document.getFormSubType()=="dialog") {
															newView = new icc.ui.designer.dialogView(mainFrame,document);
														} else {
															newView = new icc.ui.designer.formView(mainFrame,document,{withPropertiesPanel:args.in_document_properties_editor,propertiesPanelWidth:args.propertiesPanelWidth,in_document_properties_side:args.in_document_properties_side,showDocumentProperties:args.showDocumentProperties});
														}
														appTree.addItem(item,treeItemView);
														appTree.setItem(item);
														newView.create();
														self.mainFrame.addView(newView);
														item.view = newView;
														
													}else
														icc.ui.displayMessage(result);
													cb(status,result);	
												})
											}else{
												cb(status,ctrls);
											}
										});
									
									break;
								}
							}
						})
						
					}
					switch(item.id){
						
						case 1:
							var viewWizard = new icc.ui.designer.viewWizard(applicationDoc,{});
							viewWizard.create();
							viewWizard.showModal(function(status,viewData){
							    if(status){
									var newView;
									applicationDoc.createView(viewData.name,viewData,
										function(status,view){
											if(status){
												var item = {caption:view.name,ptr:view,type:"form",icon:'view.png'};
												if(view.getFormSubType()=="dialog"){
													newView = new icc.ui.designer.dialogView(mainFrame,view);
												}else
													newView = new icc.ui.designer.formView(mainFrame,view,{withPropertiesPanel:args.in_document_properties_editor,propertiesPanelWidth:args.propertiesPanelWidth,showDocumentProperties:args.showDocumentProperties,propertiesPanelSide:args.in_document_properties_side});
												appTree.addItem(item,treeItemView);
												appTree.setItem(item);
												newView.create();
												self.mainFrame.addView(newView);
												item.view = newView;
												viewWizard.close();
											}else{
												var err = view;
												icc.ui.displayMessage(err);
											}
											self.layout();
										}
									);
									
								}
							});
						break;
						case 2:// Javascript
						    var dlg = icc.ui.msginput(_T("Enter javascript library name"), '', 270, _T('New javascript file'),function(status,text){
								if(status==='ok'){
									if(icc.utils.isValidFilename(text)){
										var mimeType;
										var getFileExtension = function (filename){
											var res = (/[.]/.exec(filename)) ? /[^.]+$/.exec(filename) : undefined;
											if(res)
												return res[0];
											
										}
										var ext = getFileExtension(text)
										switch(ext){
											case 'js':
												mimeType = "text/javascript"
											break
											case 'css':
												mimeType = "text/css"
											break
											default:
												mimeType = "text/plain"
										}
										applicationDoc.createResourceFile(text,mimeType,"",function(status,result){
											if(status){
												var item ={caption:text,ptr:result,type:"library",icon:'script.png'};
													appTree.addItem(item,treeItemLibraries);
												appTree.setItem(item);
												dlg.close();// cerramos el msginput y tratamos de cargar la lib
												var newDoc = new icc.ui.designer.jslibDoc(app.vccName,app.appId,text,mimeType);
												
												newDoc.load(function(status,result){
													if(status){
														var newView = new icc.ui.designer.jslibView(newDoc);
														newView.create();
														self.mainFrame.addView(newView);
														item.view = newView;
														
													}else{
														icc.ui.displayMessage(result);
													}
												});
											}else{
												icc.ui.displayMessage(result);
											}
										});
									}else{
										icc.ui.displayMessage(icc.ui.message('invalid_filename'));
									}
									return false; // no cierra, esperamos a que createResourceFile termine
								}
						    });
                        break;
						case 3://Datasource
							var dsWizard = new icc.ui.designer.datasourceWizard(applicationDoc,{});
							dsWizard.create();
							dsWizard.showModal(function(status,datasourceData){
							    if(status){
									applicationDoc.createDataSource(datasourceData.name,datasourceData,function(status,result){
										if(status){
											var newDoc;
											var newView;
											dsWizard.close();
											var item = {caption:datasourceData.name,ptr:{name:datasourceData.name},type:"datasource",icon:'datasource.png',dsname:datasourceData.name};
											appTree.addItem(item,treeItemDatasources);
											appTree.setItem(item);
											newDoc = new icc.ui.designer.datasourceDoc(app.vccName,app.appId,item.ptr.name);
											newDoc.load(function(status,result){
												if(status){
													item.datasourceDoc = newDoc;
													newView = new icc.ui.designer.datasourceView(newDoc,app,item.ptr);
													newView.create();
													self.mainFrame.addView(newView);
													item.view = newView;
													self.updateDatasourceColumns(datasourceData.name);
												}else{
													if(result.code == 1019){
														icc.ui.displayMessage(result);
													}else{
														icc.ui.msgbox(result.errorMessage,undefined,'error');
													}
												}
												self.layout();
											});
										}else{
											if(result.code == 1019){
												icc.ui.displayMessage(result);
											}else{
												icc.ui.msgbox(result.errorMessage,undefined,'error');
											}
										}
									});
							    }
                            });
						break;
						case 4:
							var reportWizard = new icc.ui.designer.reportWizard(applicationDoc,{});
							reportWizard.create();
							reportWizard.showModal(function(status,viewData){
							    if(status){
									var newView;
									applicationDoc.createView(viewData.name,viewData,
										function(status,view){
											if(status){
												var item = {caption:view.name,ptr:view,type:"report",icon:'report.png'};
												if(viewData.formSubType == "bireport"){
													newView = new icc.ui.designer.biReportView(mainFrame,view);
												}else{
													newView = new icc.ui.designer.reportView(mainFrame,view);
												}
												
												appTree.addItem(item,treeItemReports);
												appTree.setItem(item);
												newView.create();
												self.mainFrame.addView(newView);
												item.view = newView;
												reportWizard.close();
											}else{
												var err = view;
												icc.ui.displayMessage(err);
											}
											self.layout();
										}
									);
									
								}
							});
						break;

					}
				}
			);
		});
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		// Maneja los cambios de documento activo del mainFrame
		mainFrame.onDocChanged(function ( currentDoc,currentView) {
//			console.log("arguments "+args.showDocumentProperties);
			if(args.properties_editor!==false){
				if(self.propertiesView){
				
				
					propertiesPanel.rmvChild(self.propertiesView);
					self.propertiesView = undefined;
				}
				if(currentDoc && currentDoc.getProperties && currentDoc.getLayout){// verifica que tenga esos dos metodos
																				  // porque si no no es un dibujo
					console.log(self.propertiesPanelBackground)																			  
					self.propertiesView = new icc.ui.designer.propertiesView(currentDoc,{background:self.propertiesPanelBackground,showDocumentProperties:args.showDocumentProperties,in_document_properties_side:args.in_document_properties_side});
					self.propertiesView.create();
					propertiesPanel.addChild(self.propertiesView);
					if(currentView.getSelection){
						currentDoc.updateAllViews(currentView,"selection",currentView.getSelection());
					}
				}
				propertiesPanel.layout();
			}
			
		});
		////////////////////////
	};
	
	icc.utils.inherit(applicationView,icc.ui.framework.documentView.view);

	applicationView.prototype.onUpdate = function (sender, hint, data) {
		var self = this;
		if(hint == "datasource.saved"){
			self.updateDatasourceColumns(data);
		}
	};

	icc.ui.designer.applicationView = applicationView;
	
	// Screen de configuracion de direcciones ip encontradas en una aplicacion
	
	function applicationConfigDlg (applicationDoc){
		var items;
		var self = this;
		<%FRAME:assets.applicationConfig%>

		var passwordCol = {caption:_T('Password'),width:90};
		
		jQuery.each(acfg_addressGrid.columns,function(idx,col){
			if (col.field == 'userPassword'){
				passwordCol=col;
				passwordCol.field = undefined;
				return false;
			}
		});

		self.mssql_builtin_config = {};
		icc.ui.designer.dsintrospection.mssql_builtin_config(icc.ui.getApplication().getVCCName(), function(success, builtin_config) {
			if(success){
				self.mssql_builtin_config = builtin_config || {};
			}
			
		});

		acfg_cbViews.items = []
		var views = applicationDoc.getViews();
		for (idx=0;idx<views.length;idx++){
			
			acfg_cbViews.items.push({text:views[idx].name,id:views[idx].name});
		}
		acfg_cbViews.item = applicationDoc.getDefaultView();
		afcg_dateformat.items = [
			{	id:'dd/mm/yyyy',
				text:'dd/mm/yyyy'
			},
			{	id:'dd-mm-yyyy',
				text:'dd-mm-yyyy'
			},
			
			{	id:'mm/dd/yyyy',
				text:'mm/dd/yyyy'
			},
			{	id:'mm-dd-yyyy',
				text:'mm-dd-yyyy'
			},
			{	id:'dd-Dec-yyyy',
				text:'dd-Dec-yyyy'
			}
			
		];
		
		afcg_dateformat.item = applicationDoc.getCatalog().dateFormat || 'dd/mm/yyyy';
		afcg_dateformat.onChange(function(idx,text,item){
			applicationDoc.getCatalog().dateFormat = item.id;
		});
		
		afcg_cache.text = applicationDoc.getCatalog().cacheTime;
		afcg_cache.onChange(function(value,valid){
			if(valid){
				applicationDoc.getCatalog().cacheTime = parseInt(value);
			}
		});
		
		afcg_refs.text = applicationDoc.getCatalog().refs;
		afcg_refs.onChange(function(value,valid){
			applicationDoc.getCatalog().refs=value;
		});
		
		
		afcg_decimals.text =  applicationDoc.getCatalog().decimals!=undefined?applicationDoc.getCatalog().decimals:2;
		afcg_decimals.onChange(function(value,valid){
			if(valid){
				applicationDoc.getCatalog().decimals = parseInt(value);
			}
		});
		afcg_applang.items = [
			{id:'default',text:_T('default')},
			{id:'es_ES',text:_T('spanish')}
		]
		afcg_applang.item=applicationDoc.getCatalog().locale || 'default';
		afcg_applang.onChange(function(idx,text,item){
			applicationDoc.getCatalog().locale = item.id;
		});		
		
		applicationConfigDlg.SUPERconstructor.call(this,{
			vs:3,
			caption:_T('Application Settings'),
			name:'designer_app_settings_dlg',
			childs:[
				applicationConfig
			]
		});
		
		acfg_ckPasswords.onChange(function(value){
			var selected = acfg_addressGrid.getItem();
			if(value){
				passwordCol.field ="userPassword";
			}else{
				passwordCol.field =undefined;
			}
			acfg_txPassword.setPassword(!value);
			jQuery.each(items,function(idx,item){
				acfg_addressGrid.updateItem(item);
			});
		});

		const fnChangeBbms = function (sqlDbmsId) {
			if (sqlDbmsId === "builtin") {
				acfg_cboDatabaseName.setVisible(true);
				acfg_txDatabaseName.setVisible(false);
				acfg_txPassword.setReadOnly(true, false);
				acfg_txAddress.setReadOnly(true, false);
				acfg_txUserName.setReadOnly(true, false);
				acfg_txPort.setReadOnly(true, false);
				acfg_cboDbms.setReadOnly(true, false);
			}
			else{
				acfg_txDatabaseName.setVisible(true);
				acfg_cboDatabaseName.setVisible(false);
			}
		};


		acfg_addressGrid.onChange(function(item) {
			let isEnabled = item !== undefined;
			acfg_cboDbms.setReadOnly(!isEnabled, !isEnabled);
			acfg_cboDbms.setEnabled(isEnabled);
			acfg_cboDbms.setItem(item.dbms);
			acfg_txAddress.setEnabled(isEnabled);
			acfg_txAddress.setText(item.serverAddress);
			acfg_txPort.setEnabled(isEnabled);
			acfg_txPort.setText(item.port);
			acfg_txUserName.setEnabled(isEnabled);
			acfg_txUserName.setText(item.userName);
			acfg_txPassword.setEnabled(isEnabled);
			acfg_txPassword.setText(item.userPassword);
			acfg_txDatabaseName.setEnabled(isEnabled);
			acfg_txDatabaseName.setText(item.databaseName);
			acfg_cboDatabaseName.setEnabled(isEnabled);
			acfg_cboDatabaseName.setItem(item.databaseName);
			fnChangeBbms(item.dbms);
		});
		acfg_addressGrid.onBeforeChange(function(newItem,currentItem){
			if(currentItem){
				return  acfg_cboDbms.performValidation(true).code===0 &&
						acfg_txAddress.performValidation(true).code===0 &&
						acfg_txPort.performValidation(true).code===0 &&
						acfg_txUserName.performValidation(true).code===0 &&
						acfg_txPassword.performValidation(true).code===0 &&
						acfg_txDatabaseName.performValidation(true).code===0;
			}
		});
		var updateItems = function(key,value){
			var selected = acfg_addressGrid.getItem();
			if(selected){
			
				var val;
				var compare;
				if (key === "userPassword") {
					val = selected;
					compare = function(item) {
						return	item.userName === val.userName;
					};
				}
				else {
					val = selected[key];
					compare = function(item) {
						return item[key] === val;
					};
				}
				selected[key]=value;
				acfg_addressGrid.updateItem(selected);
				
				if(acfg_ckMatchValues.getChecked()){
					jQuery.each(items,function(idx,item){
						if(item !== selected && selected[key]!==undefined && compare(item)){
							item[key]=value;
							acfg_addressGrid.updateItem(item);
						}
					});
				}
			}
		};
		acfg_cboDbms.items = [
			{id: "sqlserver", text: "SQL Server"},
			{id: "mysql"    , text: "MySQL"     },
			{id: "builtin"    , text: "Built in"     }
		];

		acfg_cboDatabaseName.items = self.mssql_builtin_config.Databases || [];

		acfg_cboDbms.onChange(function(idx,text,item){
			updateItems('dbms',item.id);
			fnChangeBbms(item.id);
		});
		acfg_txAddress.onChange(function(value){
			updateItems('serverAddress',value);
		});
		acfg_txPort.onChange(function(value){
			updateItems('port',value);
		});
		acfg_txUserName.onChange(function(value){
			updateItems('userName',value);
		});
		acfg_txDatabaseName.onChange(function(value){
			updateItems('databaseName',value);
		});
		acfg_cboDatabaseName.onChange(function(value){
			updateItems('databaseName', this.getItem().id);
		});
		acfg_txPassword.onChange(function(value){
			updateItems('userPassword',value);
		});
		acfg_btnCancel.onClick(function(){
			self.close();
		});
		acfg_btnOk.onClick(function(){
			var ok = true;
			var status,result;
			ok = 	acfg_cbViews.performValidation(true).code===0 &&
					afcg_decimals.performValidation(true).code===0 && 
					afcg_dateformat.performValidation(true).code===0;
					
			if(ok && acfg_addressGrid.getItem()){
			
				ok= acfg_cboDbms.performValidation(true).code===0 &&
					acfg_txAddress.performValidation(true).code===0 &&
					acfg_txPort.performValidation(true).code===0 &&
					acfg_txUserName.performValidation(true).code===0 &&
					acfg_txPassword.performValidation(true).code===0 &&
					acfg_txDatabaseName.performValidation(true).code===0 

			}
			if(ok){
				jQuery.each(items,function(idx,row){
					self.data[row.name].dbms = row.dbms;
					self.data[row.name].serverAddress = row.serverAddress;
					self.data[row.name].port = row.port;
					self.data[row.name].userName = row.userName;
					self.data[row.name].userPassword = row.userPassword;
					self.data[row.name].databaseName = row.databaseName;				
					
				});
				applicationDoc.savePrivateData(self.data,function(status,result){
					if (status){
						applicationDoc.setProperties(
							{
								defaultView:acfg_cbViews.getItem().text,
								dateFormat:applicationDoc.getCatalog().dateFormat,
								decimals:applicationDoc.getCatalog().decimals,
								locale:applicationDoc.getCatalog().locale,
								refs:applicationDoc.getCatalog().refs,
								cacheTime:applicationDoc.getCatalog().cacheTime
							},function(status,result){
							if(status){
								self.close();
							}else{
								icc.ui.displayMessage(result);
							}
						});
						
					}else{
						icc.ui.displayMessage(result);
					}
				});
			}
			
		});
		this.onCreate(function(){
			applicationDoc.readPrivateData(function(status,result){
				if(status){
					self.data = result;
					items = []
					jQuery.each(result,function(idx,data){
						items.push({
							name : idx,
							dbms : data.dbms,
							serverAddress : data.serverAddress,
							port : data.port,
							userName : data.userName,
							userPassword : data.userPassword,
							databaseName : data.databaseName
						});
					});
					acfg_addressGrid.addItem(items);
					
				}else{
					icc.ui.displayMessage(result);
				}
			});
		});
		
	}
	
	icc.utils.inherit(applicationConfigDlg,icc.ui.dialog);
	icc.ui.designer.applicationConfigDlg = applicationConfigDlg;
	function imageManager (applicationDoc){
		var self = this;
		var items = [];
		<%FRAME:assets.imageManagerFrame%>
		

		var resourceList = applicationDoc.getResources();
		var rg = new RegExp("image");
		jQuery.each(resourceList,function(idx,res){
			
			if(res.mimeType.match(/image/)){
				items.push(
					{caption:res.src,image:res.src}
				)
			}
				
		});
		var imageContainer = new icc.ui.imagelist({
			_appName:applicationDoc.getName(),// para que tome las imagenes de la aplicacion cargada y no las del designer
			fillWidth:true,fillHeight:true,
			borderWidth:0,
			items:items
		});
		imgr_imgsframe.childs = [imageContainer]
		imageManager.SUPERconstructor.call(this,{
			vs:4,
			caption:_T('Application Images'),
			name:'designer_image_manager_dlg',
			childs:[
				imageManagerFrame
			]
		});
		imageContainer.onChange(function(item){
			imgr_btnDelete.setEnabled(item!==undefined);
		})
		imgr_btnDelete.onClick(function(){
			var self = this;
			icc.ui.msgbox("Sure to delete this image ?","Question","question",function(status){
				if(status === 'ok'){
				
					applicationDoc.deleteResourceFile(imageContainer.getItem().image,function(status,result){
						if(status){
							imageContainer.rmvItem(imageContainer.getItem());
							self.setEnabled(imageContainer.getItem()!==undefined);
						}else{
							icc.ui.displayMessage(result);
						}
					});
				}
			});
		});
		imgr_btnAdd.onProgress(function(filename,value){
			imgr_progbar.setValue(value);
		});
		imgr_btnAdd.onChange(function(filename){
			imgr_progbar.setValue(0);
//			this.setVisible(false);
//			progbar.setVisible(true);
			this.parent.layout();
		});
		imgr_btnAdd.onComplete(function(filename,fileid){
			var self = this;
			setTimeout(function(){
//				self.setVisible(true);
//				progbar.setVisible(false);
				self.parent.layout();
			},500);
			applicationDoc.addResourceFromFile(fileid,function(status,result){
				if(status){
					var newItem = {caption:result.src,image:result.src}
					imageContainer.addItem(newItem);
					imageContainer.setItem(newItem);
					imgr_btnDelete.setEnabled(true);
				}else{
					icc.ui.displayMessage(result);
				}
			})
		});
		imgr_btnClose.onClick(function(){
			self.close();
		});
	}
	icc.utils.inherit(imageManager,icc.ui.dialog);
	icc.ui.designer.imageManager = imageManager;


	function imageSelector (applicationDoc,currentImage){
		var self = this;
		var items = [];
		var modeSystem = false
		if(currentImage){
			if(currentImage.substring(0,1)=='!')
				modeSystem=true;
		}
		<%FRAME:assets.imageSelectorFrame%>

		var imageContainer = new icc.ui.imagelist({
			borderWidth:0,
			_appName:applicationDoc.getName(),// para que tome las imagenes de la aplicacion cargada y no las del designer
			fillWidth:true,fillHeight:true
		});
		imgs_imgsframe.childs =[imageContainer]
		var showApplicationImages = function(){
			var current;
			items = [];
			imgs_btnAdd.setEnabled(true);
			var resourceList = applicationDoc.getResources();
			jQuery.each(resourceList,function(idx,res){
				if(res.mimeType.match(/image/)){
					var item = {caption:res.src,image:res.src}
					items.push(item);
					if(res.src === currentImage){
						current = item;
					}
				}
			});
			imageContainer.clearAll();
			imageContainer.addItem(items);
			if(current){
				imageContainer.setItem(current);
			}
			imgs_btnOk.setEnabled(imageContainer.getItem()!==undefined);

		}
		var showSystemImages = function(){
			var current;
			items = [];
			imageContainer.clearAll();
			imgs_btnAdd.setEnabled(false);
			applicationDoc.readSystemImages(function(status,result){
				if(status){
					jQuery.each(result,function(idx,imageName){
						var item = {caption:imageName,image:"!"+imageName}
						items.push(item);
						if("!"+imageName === currentImage){
							current = item;
						}
					});
					imageContainer.addItem(items);
					if(current){
						imageContainer.setItem(current);
					}
					imgs_btnOk.setEnabled(imageContainer.getItem()!==undefined);
				
				}else{
					icc.ui.displayMessage(result);
				}
			});	
			
		}
		imageSelector.SUPERconstructor.call(this,{
			caption:_T('Select Image'),
			name:'designer_image_selector_dlg',
			vs:4,
			childs:[
				imageSelectorFrame
			]
		});
		imgs_optAppImages.checked = modeSystem === false;
		
		imgs_optAppImages.onChange(function(value){if(value)showApplicationImages()});
		imgs_optSysImages.onChange(function(value){if(value)showSystemImages()});
		imgs_optSysImages.checked = modeSystem === true;
		imageContainer.onChange(function(item){
			imgs_btnOk.setEnabled(item!==undefined);
			
		})
		imageContainer.onDoubleClick(function(item){
			if(item){
				self.close(item);
			}
		});
		imgs_btnCancel.onClick(function(){
			self.close(false);
		});
		imgs_btnOk.onClick(function(){
			var item = imageContainer.getItem();
			if (item){
				self.close(item);
			}
		});
		imgs_btnAdd.onProgress(function(filename,value){
			imgs_progbar.setValue(value);
		});
		imgs_btnAdd.onChange(function(filename){
			imgs_progbar.setValue(0);
			//this.setVisible(false);
			//progbar.setVisible(true);
			this.parent.layout();
		});
		imgs_btnAdd.onComplete(function(filename,fileid){
			var self = this;
			setTimeout(function(){
				//self.setVisible(true);
				//progbar.setVisible(false);
				self.parent.layout();
			},500);
			applicationDoc.addResourceFromFile(fileid,function(status,resinfo){
				if(status){
					var newItem = {caption:resinfo.src,image:resinfo.src}
					imageContainer.addItem(newItem);
					imageContainer.setItem(newItem);
					imgs_btnOk.setEnabled(true);
				}else{
					icc.ui.displayMessage(resinfo);
				}
			})
		});
		self.onCreate(function(){
			if(modeSystem){
				showSystemImages();
			}else{
				showApplicationImages();
			}
		})
	}
	icc.utils.inherit(imageSelector,icc.ui.dialog);
	icc.ui.designer.imageSelector = imageSelector;


	
})(__icc__);




/*jslint evil:true */
/*global jQuery unescape window escape __icc__ setTimeout  alert
*/

(function(icc){
	icc.ui.themes.base.panel.styles['applications/designer.startPage']={
		pr:10,pb:10,pl:10,pt:3,
		vs:7
	};
	var  workspaceDoc;
	
	workspaceDoc = function(vccName){
		this._vccName = vccName;
		workspaceDoc.SUPERconstructor.call(this);
	};
	icc.utils.inherit(workspaceDoc,icc.ui.framework.documentView.document);
	
	workspaceDoc.prototype.deleteApplication=function(name,cb){
	    var self=this;
	    jQuery.ajax({
		    async: true,
		    dataType:"json",
		    url: "designer/applications/delete/"+name,
		    success: function(ajaxResponse){
				if(ajaxResponse.status){
					jQuery.each(self.catalog,function(idx,application){
						if(application.name === name){
							self.catalog.splice(idx,1);
							return false;// rompe el each
						}
					});
					
				}
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
	    });
	};
	workspaceDoc.prototype.createApplication=function(name,parameters,cb){
	    var self=this;
		var err = false;
		// comprobamos que no exista app con ese nombre
		jQuery.each(this.catalog,function(idx,appEntry){
			if(appEntry.name === name && !parameters.overwrite){
				if(cb){
					setTimeout(function(){
						cb(false,icc.ui.message('duplicated_entry',{
							description:_T("The application '{entryName}' already exist!"),
							entryName:name
						}));
					},1);
				}
				err=true;
				return false;//each
			}
		});
		
		if(!err){
			jQuery.ajax({
				async: true,
				dataType:"json",
				url: "designer/applications/create/"+name+"/"+escape(JSON.stringify(parameters)),
				success: function(ajaxResponse){
					if(ajaxResponse.status){
						self.catalog.push(ajaxResponse.result);
					}
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				},
				error:function(ajaxError){
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
				}
			});
		}
	};
	workspaceDoc.prototype.initialize=function(params,cb){
		var self = this;
		if(typeof(params) == "function"){
			cb=params
			params = {}
		}
		if(!self.catalog){
			jQuery.ajax({
				url: "designer/catalog",
				dataType:'json',
				type: 'POST',
				contentType: "application/json",
				beforeSend: function (request) {
					request.setRequestHeader('Content-Encoding', 'utf-8');
				},
				data:JSON.stringify({}),
				success: function(ajaxResponse){
					if (ajaxResponse.status){
						self.catalog = ajaxResponse.result;
						jQuery.ajax({
							url: "designer/templates/"+(params.templateAppClass || "")+ "/" + (params.templateAppSubClass || ""),
							dataType:'json',
							success: function(ajaxResponse){
								if(ajaxResponse.status){
									self.templates = ajaxResponse.result;
								}
								if(cb){
									cb(ajaxResponse.status);
								}
									
							},
							error:function(ajaxError){
								if(cb){
									cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
								}
							}
						});				
					}
				},
				error:function(ajaxError){
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
				}
			});
		}else{
			if(cb){
				setTimeout(cb);
			}
		}
	};
	workspaceDoc.prototype.getAvailableApplications=function(){
		return this.catalog;
	};
	workspaceDoc.prototype.getTemplates = function(){
	    return this.templates;
	};
	workspaceDoc.prototype.loadApplication = function ( appId ,cb) {
		var self = this;
		if(typeof(appId) === "object"){
			appId = appId.id;
		}
		var application = new icc.ui.designer.applicationDoc(this._vccName,appId);
		application.load(function(status,err){
			if(status){
				self.updateAllViews(self,"app-selected",application);
				if(cb){
					cb(status,application);
				}
			}else{
				//icc.ui.displayMessage(err);
				if(cb){
					cb(status,err);
				}
			}
		});
			
	};
	workspaceDoc.prototype.getBundleInfo = function ( fileid,cb){
		
		jQuery.ajax({
			url: "designer/applications/bundle/getinfo/"+fileid,
			dataType:'json',
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
					
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
				
			}
		});
			
	};
	workspaceDoc.prototype.importBundle = function ( fileid,appName,overwrite,hidden,cb){
		// comprobamos que no exista app con ese nombre
	
		var err = false;
		var self = this;
		var m_hidden = hidden || false;
		if(!overwrite){
			jQuery.each(this.catalog,function(idx,appEntry){
				if(appEntry.name === appName){
					if(cb){
						setTimeout(function(){
							cb(false,icc.ui.message('duplicated_entry',{
								description:"The application '{entryName}' already exist!",
								entryName:appName
							}));
						},1);
					}
					err=true;
					return false;//each
				}
			});
		}
		if(!err){

			icc.ui.displayMessage(icc.ui.message('please_wait'));
			jQuery.ajax({
				url: "designer/applications/bundle/import/"+fileid,
				dataType:'json',
				data:'appName='+appName+"&overwrite="+overwrite+"&hidden="+m_hidden,
				type: 'POST',
				async: true,
				success: function(ajaxResponse){
					if(ajaxResponse.status){
						self.catalog.push(ajaxResponse.result);
					}
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				},
				error:function(ajaxError){
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
					
				}
			});
		}
	
	};
	
	workspaceDoc.prototype.getVCCName =function(){
		return this._vccName;
	};
	
	icc.ui.designer.workspaceDoc = workspaceDoc;
})(__icc__);


(function(icc){
	var  workspaceView;

	workspaceView = function(mainFrame,workspaceDoc){
		var self=this;
		this._mainFrame = mainFrame;
		var templates = [];
		var docTemplates = workspaceDoc.getTemplates();
		for (var idx=0;idx<docTemplates.length;idx++){
		    templates.push({caption:docTemplates[idx].caption,type:'new',templateId:docTemplates[idx].id});
		}
		var applicationList = new icc.ui.grid({
			fillWidth:true,
			height:200,

			columns:[
				{caption:_T("Name"),width:320,field:"name"},
				{caption:_T("Version"),width:70,field:"version"},
				{caption:_T("Last modified"),width:120,field:"lastmod"},
				{caption:_T("Status"),width:120,field:"status"}
			]
		});
		var importButton = new icc.ui.button({"caption":_T("Import"),enabled:false,visible:false});
		var updateButton = new icc.ui.button({"caption":_T("Update"),enabled:false,visible:false});
		var commitButton = new icc.ui.button({"caption":_T("Commit"),enabled:false,visible:false});
		var deleteButton = new icc.ui.button({"caption":_T("Delete"),enabled:false});
		var publishButton = new icc.ui.button({"caption":_T("Publish"),enabled:false,visible:false});
		var exportButton = new icc.ui.button({"caption":_T("Export"),enabled:false});
		
		var applicationMenu = new icc.ui.tree({
			borderWidth:1,
			fillWidth:true,
			fillHeight:true,
//			height:180,
			items:[
				{caption:_T("Create new"),
					items:templates
				},
				{caption:_T("Import application bundle"),type:'import'}
//				{caption:_T("workspace.treeMenu.checkoutApp")}
			]
		});
		applicationMenu.onChange(function(item){
			switch(item.type){
				case "import":
					// FORMULARIO DISE�ADO QUE EL RENDER INSERTA AQUI
					var importBundle;
					var fileid; 

					var dlg = new icc.ui.dialog({
						childs:[
							importBundle
						]
					});
					dlg.create();
					dlg.showModal();
					btnCancel.onClick(function(){
						dlg.close();
					});
					btnUpload.onChange(function(fname){
						lbExportedAt.setCaption("----------");
						lbExportedBy.setCaption("----------");
						txAppName.setText("");
						txAppName.setEnabled(false);
						btnOk.setEnabled(false);
						
					});
					btnUpload.onComplete(function(fname,id){
						fileid=id;
						workspaceDoc.getBundleInfo(id,
							function(status,info){
								if (status){
									lbExportedAt.setCaption(info.exportedAt);
									lbExportedBy.setCaption(info.exportedBy);
									txAppName.setText(info.name);
									txAppName.setEnabled(true);
									btnOk.setEnabled(txAppName.performValidation().code === 0);
								}else{
									icc.ui.displayMessage(info);
								}
							}
						);
					});
					btnOk.onClick(function(){
						if(txAppName.performValidation(true).code ===0){
							var name = icc.utils.trim(txAppName.getText());
							workspaceDoc.importBundle(fileid,name,true,false,function(status,result){
								if (!status){
									if(result.code === 1035){
										result.level=3;
										txAppName.displayMessage(result);
									}else{
										icc.ui.displayMessage(result);
									}
								}else{
								
									applicationList.addItem(result);
									applicationList.setItem(result);
									workspaceDoc.loadApplication(name,function(status,data){
										// si hay error no importa ya que loadApplication pone un mensaje
										if(status){
											dlg.close();
											dlg = new icc.ui.designer.applicationConfigDlg(data)
											dlg.create();
											dlg.showModal();
										}
									});
								}
							});
						}
					});
				
				break;
				case "new":
					var dlg = icc.ui.msginput( _T('Enter new application name'),'',240,_T('Create new application'),function(status,text){
						if(status==="ok"){
						
							if(icc.utils.isValidFilename(text)){
							
								workspaceDoc.createApplication(text,{templateId:item.templateId},function(status,application_info){
									if(status){
									   applicationList.addItem(application_info);
									   applicationList.setItem(application_info);
									   workspaceDoc.loadApplication(text);
									   dlg.close();// ahora si cerramos el msginput
									}else{
										var err = application_info;
										if(err.code === 1035){ // duplicated entry es lo unico soft a esta altura
											icc.ui.displayMessage(err);
										}else{
											// error mas grave en el server mandamos un alert o algo
											icc.ui.displayMessage(err);
											
										}
										
									}
								});
							}else{
								// Esta metiendo fruta
								dlg.displayMessage(icc.ui.message('invalid_filename'));
							}
							return false; // evitamos que cierre ya que hay que esperar 
							// que createApplication dispare el callback

						}
					});
				break;
				
			}
		});
		workspaceView.SUPERconstructor.call(this,workspaceDoc,{
			caption:_T('Start page'),
			//pt:10,pl:10,pr:10,pb:10,
			vs:5,
			childs:[
				new icc.ui.panel({
					fillWidth:true,
					fillHeight:true,
					overflow:'auto',
					style:'applications/designer.startPage',
					childs:[
						new icc.ui.label({caption:_T('Available applications')}),
						applicationList,
						new icc.ui.panel({
							fillWidth:true,
							layoutMode:'horizontal',
							childs:[
								new icc.ui.panel({
									uniformWidth:true,
									layoutMode:"horizontal",
									childs:[
										importButton,
										updateButton,
										commitButton
									]
								}),
								new icc.ui.panel({
									layoutMode:"horizontal",
									sideRight:true,
									uniformWidth:true,
									childs:[
										deleteButton,
										publishButton,
										exportButton
									]
								})
							]
						}),
						new icc.ui.hline({fillWidth:true}),
						applicationMenu
						
					]
				})
			]
		});
		////////////////////////
	
		applicationList.addItem(workspaceDoc.getAvailableApplications());
		applicationList.onChange(function (item){
			workspaceDoc.loadApplication(item.name);
			deleteButton.setEnabled(item!==undefined);
			exportButton.setEnabled(item!==undefined);
			
		});
		exportButton.onClick(function(){
			var app = applicationList.getItem();
			if(app){
			
				var url = "designer/applications/export/"+app.name+".bundle";
				window.open(url,"","");
			}
		});
		deleteButton.onClick(function(){
			icc.ui.msgbox(_T("This action delete the selected application.\r\nAre you sure ?\r\n"),_T("Delete application confirmation"),"question",
				function(status){
					if(status === 'ok'){
						workspaceDoc.deleteApplication(applicationList.getItem().name,
							function(status,result){
								if(status){
									applicationList.rmvItem(applicationList.getItem());
									if (applicationList.getItem()){
										workspaceDoc.loadApplication(applicationList.getItem().name);
									}else{
										workspaceDoc.updateAllViews(self,"app-selected");
										deleteButton.setEnabled(false);
									}
									
								}else{
									if(result.code !== 1019){
										icc.ui.msgbox(_T("Error deleting application\n\n")+result.errorMessage,_T("Error"),"error");
									}else{
										icc.ui.displayMessage(result);
									}
								}
							}
						);
					}
						
				}
			);
		});
		////////////////////////
	};
	icc.utils.inherit(workspaceView,icc.ui.framework.documentView.view);
	icc.ui.designer.workspaceView = workspaceView;
})(__icc__);

(function(icc){
	var  applicationExplorer;
	applicationExplorer = function(mainFrame,workspaceDoc){
		this.mainFrame = mainFrame;
		this.viewerContainer = new icc.ui.panel({fillWidth:true,fillHeight:true,borderWidth:1});
		applicationExplorer.SUPERconstructor.call(this,workspaceDoc,{
			//width:290,
			//pt:2,
			vs:4,
			fillHeight:true,
			style:'applications/designer.applicationExplorer',
			childs:[
			/*
				new icc.ui.panel({
				    layoutMode:'horizontal',
					style:"application/toolbar",
					
				    fillWidth:true,
				    childs:[
					new icc.ui.label({caption:_T('Application explorer'),fillWidth:true 
						//,borderWidth:1,backColor:'lightgray',borderColor:'gray'
						})
				    ]
				}),
				*/
				this.viewerContainer
			]
		});
	};
	icc.utils.inherit(applicationExplorer,icc.ui.framework.documentView.view);
	applicationExplorer.prototype.onUpdate=function ( sender,hint,data){
		switch(hint){
			case "app-selected":			// Una nueva aplicacion a sido seleccionada data contiene la aplicacion
									
				if(this.content){			// Borramos el contenido del contenedor
					this.viewerContainer.rmvChild(this.content);
					this.content = null;
				}
				
				if(data){					// Si viene vacio es porque no hay ninguna applicacion seleccionada
					this.content = new icc.ui.designer.applicationView(this.mainFrame,data);// creamos un nuevo view para el contenido
					this.content.create();							
					this.viewerContainer.addChild(this.content);
				}
				this.viewerContainer.layout();
			break;
		}
	};
	icc.ui.designer.applicationExplorer = applicationExplorer;
})(__icc__);



(function(icc){
	var  jslibDoc;
	var undefined;
	jslibDoc = function(vccName,appId,fileName,mimeType){
		this.fileName = fileName;
		this.appId = appId;
		this.vccName = vccName;
		this.mimeType = mimeType;
		jslibDoc.SUPERconstructor.call(this);
	};
	icc.utils.inherit(jslibDoc,icc.ui.framework.documentView.document);
	jslibDoc.prototype.load=function(cb){
		var self = this;
		jQuery.ajax({
			url: "designer/applications/"+this.vccName+"/"+this.appId+"/resources/"+this.fileName,
			success: function(ajaxResponse){
				self.content = ajaxResponse;
				if(cb){
					cb(true);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		})
	}
	jslibDoc.prototype.getContent = function (){
		return this.content;
	}
	jslibDoc.prototype.setContent = function (newContent){
		this.content = newContent;
		this.setDirty(true);
	}
	jslibDoc.prototype.getName = function (){
		return this.fileName
	}
	jslibDoc.prototype.getMimeType = function(){
		return this.mimeType;
	}
	jslibDoc.prototype.setName = function(newName){
		this.fileName = newName
	}
	jslibDoc.prototype.save = function(cb){
		var self = this;
		jQuery.ajax({
			url: "designer/applications/"+this.appId+"/resources/save/"+this.fileName,
			type: 'POST',
			async: true,
			dataType:'json',
			data:''.concat("content=" ,encodeURIComponent(this.content)),
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					self.setDirty(false);
				}
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		})
	}
	icc.ui.designer.jslibDoc = jslibDoc;
})(__icc__);


(function(icc){
	var  jslibView;
	var undefined;

	jslibView = function(jslibDoc){
		var language=''
		switch(jslibDoc.getMimeType()){
			case 'text/javascript':
				language='javascript';
			break;
			case 'text/css':
				language='css';
			break;
		}
		var editor = new icc.ui.codeeditor({fillWidth:true,fillHeight:true,multiLine:true,text:jslibDoc.getContent(),lineNumbers:true,language:language});
		jslibView.SUPERconstructor.call(this,jslibDoc,{
			haveCloseButton:true,
			caption:jslibDoc.getName(),
			fillWidth:true,
			fillHeight:true,
			pt:10,
			pr:10,
			pl:10,
			pb:10,
			childs:[
				editor
			]
		});
		////////////////////////
		editor.onChange(function(text){
			jslibDoc.setContent(text);
		})
		
		
		////////////////////////
	};
	icc.utils.inherit(jslibView,icc.ui.framework.documentView.view);
	icc.ui.designer.jslibView = jslibView;
})(__icc__);





/*jslint evil:true, browser: true*/
/*global jQuery __icc__ window
*/

var currentHost;
(function(icc){
	var designerFrame=function(args,env,uiclass){
		
		designerFrame.SUPERconstructor.call(this,args,env,uiclass);
		this.selectors_map = {};
	};
	icc.utils.inherit(designerFrame,icc.ui.panel);
	designerFrame.prototype.create = function(){
		this.wnd = icc.utils.makeElement("div");
		designerFrame.SUPERclass.create.call(this);
		return this.wnd;
	};
	designerFrame.prototype.displayMessage = function ( err,parentPropagation){
	};
	designerFrame.prototype.findContainerAt = function(position,exclude){
		var idx = 0;
		var child;
		var clientpos = this.screenToClient(position);
		var res; 
		var handlers,handler;
		idx=this.childs.length;
		while(idx){
			child = this.childs[idx-1];
			if(child.findContainerAt && (child !==exclude)){ // es un contenedor
				if(child._x<=clientpos.x && child._x+child._w>=clientpos.x && 
					child._y<=clientpos.y && child._y+child._h>=clientpos.y){
					var t = child.findContainerAt(position,exclude);
					if(t){
						return t;
					}else{
						return child;
					}
				}
			}
			idx--;
		}
		
	};
	designerFrame.prototype.hitTest = function(position,exclude){
		var idx = 0;
		var child;
		var clientpos = this.screenToClient(position);
		var res; 
		var handlers,handler;
		idx=this.childs.length;
		while(idx){
			child = this.childs[idx-1];
			
			if(child.visible && child!==exclude){
			/*
				if(child !== exclude && child.getParentConnectionPoints){
					var cnxpoints = child.getParentConnectionPoints();
					var hto = 0;//icc.utils.browser.is_ie?2:1
					for(var i=0;i<cnxpoints.length;i++){
						cnxpt = cnxpoints[i];
						if(cnxpt.x-hto<=clientpos.x && cnxpt.x+cnxpt.width+2+hto>=clientpos.x && 
							cnxpt.y-hto<=clientpos.y && cnxpt.y+cnxpt.height+2+hto>=clientpos.y){
							return {parent:child.parent,tgt:child,type:cnxpt.type?cnxpt.type:"cnxpoint",nHandle:i,handler:cnxpt,cursorName:cnxpt.cursorName};
						}
					}
				}
			*/
				if( child._x<=clientpos.x && child._x+child._w>=clientpos.x && 
					 child._y<=clientpos.y && child._y+child._h>=clientpos.y && !child.unselectable){
						if(child.hitTest){	
							var t = child.hitTest(position,exclude);
							if(t){
								return t;
							}else{
								if (!child.block){
									return {parent:this,tgt:child,"type":"client"};
								}else{
									return;
								}
							}
						}else{
							return {parent:this,tgt:child,"type":"face"};
						}
				}
			}
			idx--;
		}
		
	};
	designerFrame.prototype.childPositionHasChanged = function(child,xPos,yPos,event){
	};
	
	designerFrame.prototype.drawUnselected = function ( designerHost,child ) {
		var div;
		if(child.div_handlers){
   			for (var idx in child.div_handlers){
			    div = child.div_handlers[idx];
			    designerHost.getFrontFace().removeChild(div);
			}
			child.div_handlers = null;
		}
	}
	designerFrame.prototype.drawSelected = function ( designerHost,child ) {
		var bwidth=child.borderWidth;
		if(!bwidth)
			bwidth=0;
		//bwidth*=2;
		var handlers = child.getHandlers();
		var handler;
		var pos;
		var i;
		var div;
		
		if(child.div_handlers)
			return;
		child.div_handlers = {};
		for ( i=0;i<handlers.length;i++){
			handler = handlers[i];
			pos = designerHost.screenToClient(child.parent.clientToScreen({x:handler.x,y:handler.y}));
			div  = icc.utils.makeElement("div");
			div.innerHTML = "&nbsp;"
			if(handler.type === "front")
			{
				
				jQuery(div).css({
					position:"absolute",
					top: pos.y+"px",
					left:pos.x+"px",
					width:handler.width+"px",
					height:handler.height+"px",
					overflow:'hidden',
					zIndex:600,
					cursor:handler.cursorName
				});
				
				(function(pos,handler){
					div.style.innerHTML="&nbsp;";
					jQuery(div).mouseover(function(){
					
						var mouseMove = function(e){
							var scpos = designerHost.screenToClient({x:e.pageX,y:e.pageY})
							if(!(scpos.x>pos.x && scpos.x < pos.x+handler.width &&
							scpos.y>pos.y && scpos.y < pos.y+handler.height)){
								jQuery(document).unbind("mousemove",mouseMove);
								designerHost.getFrontFace().style.visibility="visible"
								designerHost.topFace.style.visibility="visible"
							}
						}
						
						designerHost.getFrontFace().style.visibility="hidden"
						designerHost.topFace.style.visibility="hidden"
						setTimeout(function(){
							jQuery(document).bind("mousemove",mouseMove);
						},100);
						return true;
					})
				})(pos,handler);
				
			}else{
				jQuery(div).css({
					position:"absolute",
					top: pos.y+"px",
					left:pos.x+"px",
					width:(handler.width+(icc.utils.browser.is_ie?2:0))+"px",
					height:(handler.height+(icc.utils.browser.is_ie?2:0))+"px",
					background:"white",
					border:"1px solid",
					zIndex:601,
					overflow:'hidden',
					cursor:handler.cursorName
				})
			}
			child.div_handlers[i]=div;
			designerHost.getFrontFace().appendChild(div);
		}
		pos = designerHost.screenToClient(child.parent.clientToScreen({x:child._x,y:child._y}));
		div  = icc.utils.makeElement("div");
		jQuery(div).css({
			position:"absolute",
			border:"1px dotted gray",
			top:(pos.y-bwidth-1)+"px",
			left:(pos.x-bwidth-1)+"px",
			width:((child._w+bwidth)+1)+"px",
			height:((child._h+bwidth)+1)+"px",
			overflow:'hidden',
			zIndex:599
		})
		div.innerHTML="&nbsp;";
		designerHost.getFrontFace().appendChild(div);
		child.div_handlers[i]=div;
	}
	
	designerFrame.prototype.startsSelecting = function(designerHost,position){
		var pos = designerHost.screenToClient(position);
		this.selectDiv = icc.utils.makeElement("div");
		this.selectRect = {x:pos.x,y:pos.y,width:0,height:0};
		this.selectStart = position;
		jQuery(this.selectDiv).css({
			position:"absolute",
			top:this.selectRect.y+"px",
			left:this.selectRect.x+"px",
			border:"1px dotted black",
			overflow:'hidden',
			width:"0px",
			height:"0px",
			zIndex:1000
			
		});
		this.selectDiv.innerHTML="&nbsp;";
		designerHost.getFrontFace().appendChild(this.selectDiv);
	
	};
	designerFrame.prototype.stillSelecting = function(designerHost,position){
		var pos = designerHost.screenToClient(position);
		
		this.selectRect.width = pos.x - this.selectRect.x;
		this.selectRect.height= pos.y - this.selectRect.y;
	
		var rect = {x:this.selectRect.x,y:this.selectRect.y,width:this.selectRect.width,height:this.selectRect.height};
		if(rect.width<0){
			rect.width*=-1;
			rect.x -= rect.width;
		}
		if(rect.height<0){
			rect.height*=-1;
			rect.y -= rect.height;
		}
		
		jQuery(this.selectDiv).css({
			top:rect.y+"px",
			left:rect.x+"px",
			width:rect.width+"px",
			height:rect.height+"px"
		});
	};
	designerFrame.prototype.stopsSelecting = function(designerHost,position){
		try{
			designerHost.getFrontFace().removeChild(this.selectDiv);
		}catch(e){
			
		}
		var pos = this.screenToClient(this.selectStart);
		var rect = {x:pos.x,y:pos.y,width:this.selectRect.width,height:this.selectRect.height};
		if(rect.width<0){
			rect.width*=-1;
			rect.x -= rect.width;
		}
		if(rect.height<0){
			rect.height*=-1;
			rect.y -= rect.height;
		}
		this.selectWithRect(designerHost,rect);
	};
	designerFrame.prototype.selectWithRect = function (designerHost,rect){
		var child;
		var selection = [];
		for (var idx=0;idx<this.childs.length;idx++){
			child = this.childs[idx];
			if( child._x >= rect.x && child._x+child._w < rect.x + rect.width && 
				child._x+child._w < rect.x+rect.width &&
				child._y >= rect.y && child._y+child._h < rect.y + rect.height && 
				child._y+child._h < rect.y+rect.height){
					selection.push(child);
			}
		}
		if(selection.length){
			designerHost.addToSelection(selection);
		}
	};
	designerFrame.prototype.startsChildResizing = function(designerHost,child,handler,position){
	};
	designerFrame.prototype.stillChildResizing = function(designerHost,child,handler,position){
	};
	designerFrame.prototype.stopsChildResizing = function(designerHost,child,handler,position){
	};		
	
	
	icc.ui.designerFrame = designerFrame;
})(__icc__);


(function(icc){
	var designerHost=function(args){
		designerHost.SUPERconstructor.call(this,args);
		this.selection = [];
		this.undo = [];
		
		this.line_starts={};  
		this.line_ends={};
		this.lines={};
		
		this.line_start_points={}
		this.line_end_points={}
		
		this.visibleConnectionPoints = {};
	};
	icc.utils.inherit(designerHost,icc.ui.container);
	designerHost.prototype.clearSelection = function (){
		
		for (var idx=0;idx<this.selection.length;idx++){
			this.selection[idx].parent.drawUnselected(this,this.selection[idx]);
		}
		this.selection = [];
		
	};
	designerHost.prototype.isSelected = function ( widget ){
		for (var idx=0;idx<this.selection.length;idx++){
			if(this.selection[idx] === widget){
				return true;
			}
		}
		return false;
	};
	designerHost.prototype.addToSelection = function ( widget, event){
		var self = this;
		var idx;	
		if(!event){
			event = this.lastEvent;
		}
		if(!event){
			event={};
		}
		if(icc.utils.isArray(widget)){
			// Asume que todos los pasados son del mismo parent
			
			if(widget.length){
				var parent = widget[0].parent;
				for (idx=0;idx<this.selection.length;idx++){
					if(this.selection[idx].parent !== parent){
						this.clearSelection();
						break;
					}
				}
			}
			if(!event.ctrlKey){
				this.clearSelection();
			}
			for (idx=0;idx<widget.length;idx++){
				if(!this.isSelected(widget[idx])){
					this.selection.push(widget[idx]);
				}
			}
			this.showSelection();
			
			
		}else{
			if(this.isSelected(widget)){
				if(event.ctrlKey){
					// Lo quitamos de la seleccion
					for (idx=0;idx<this.selection.length;idx++){
						if(this.selection[idx] === widget){
							this.selection.splice(idx,1);
							widget.parent.drawUnselected(this,widget);
							this.hideBoundingBox(widget);
							break;
						}
					}
					return;
				}else{
					return;
				}
			}
			if(!event.ctrlKey){
				this.clearSelection();
			}
			for (idx=0;idx<this.selection.length;idx++){
				if(this.selection[idx].parent !== widget.parent){
					this.clearSelection();
					break;
				}
			}
			this.selection.push(widget);
		}
		this.fireEvent("onSelectionChanged",this.selection);
		//widget.parent.drawSelected(this,widget);
	};
	
	designerHost.prototype.showBoundingBox = function (tgt){
		var bwidth = tgt.borderWidth
		
		if(bwidth===undefined)
			bwidth=0;
			
		var pos = this.screenToClient(tgt.parent.clientToScreen({x:tgt._x-1,y:tgt._y-1}));
		
		tgt._divbbox = icc.utils.makeElement("div");
		tgt._divbbox.innerHTML = "&nbsp;";
		var w = (tgt._w+bwidth);
		var h = (tgt._h+bwidth);
		if(tgt.borderWidth!==undefined){
			w+bwidth*2;
			h+=bwidth*2;
		}
		
		jQuery(tgt._divbbox).css({
			position:"absolute",
			border:"1px solid black",
			overflow:'hidden',
			top:pos.y+"px",
			left:pos.x+"px",
			width:w+"px",
			height:h+"px"
		});
		tgt.parent.drawUnselected(this,tgt);
		this.getFrontFace().appendChild(tgt._divbbox);
		
	};
	designerHost.prototype.updateBoundingBox = function (tgt){
		var bwidth = tgt.borderWidth
		
		if(bwidth===undefined)
			bwidth=0;

		if(tgt._divbbox)
		{
			var pos = this.screenToClient(tgt.parent.clientToScreen({x:tgt._x-1,y:tgt._y-1}));
			var w = (tgt._w+bwidth);
			var h = (tgt._h+bwidth);
			if(tgt.borderWidth!==undefined){
				w+=bwidth*2;
				h+=bwidth*2;
			}
		
			jQuery(tgt._divbbox).css({
			
				top:pos.y+"px",
				left:pos.x+"px",
				width:w+"px",
				height:h+"px"
			});
		}
	};
	
	designerHost.prototype.hideSelection = function(){
		
		for (var idx=0;idx<this.selection.length;idx++){
			this.selection[idx].parent.drawUnselected(this,this.selection[idx]);
		}
		
	};
	designerHost.prototype.showSelection = function(){
		this.hideSelectionBoundingBox();
		for (var idx=0;idx<this.selection.length;idx++){
			this.selection[idx].parent.drawSelected(this,this.selection[idx]);
		}
	};
	
	
	designerHost.prototype.hideBoundingBox = function (tgt){
		if(tgt._divbbox){
			this.getFrontFace().removeChild(tgt._divbbox);
			tgt._divbbox=null;
			
		}
	};
	designerHost.prototype.showSelectionBoundingBox = function(){
		this.hideSelection();
		for (var idx=0;idx<this.selection.length;idx++){
			this.showBoundingBox(this.selection[idx]);
		}
	};
	designerHost.prototype.hideSelectionBoundingBox = function(){
		for (var idx=0;idx<this.selection.length;idx++){
			this.hideBoundingBox(this.selection[idx]);
		}
	};

	designerHost.prototype.moveChildWndToFront = function ( designerFrame,child,position){
		child._inFront=true;
		var wnd = child.getWnd();
		// Remueve la ventana del control del contenedor
		// y la agrega al front
		designerFrame.getClient().removeChild(wnd);
		var frontpos = this.screenToClient(designerFrame.clientToScreen({x:child._x,y:child._y}));
		wnd.style.left = frontpos.x+"px";
		wnd.style.top = frontpos.y+"px";
		child._zIndex = wnd.style.zIndex;
		//jQuery(wnd).css({opacity:0.5})
		this.topFace.appendChild(wnd);
		jQuery(wnd).css({
			zIndex:15000
		})
		
		child._src_wnd = wnd;
		child.parent = designerFrame;
		child._clientpos = {x:child._x,y:child._y};
		child._frontpos = frontpos;
		// crea un cuadrado que va a representar el control dentro del contenedor
		var ctrl_square = icc.utils.makeElement("div");
		ctrl_square.innerHTML = "&nbsp;";	
		ctrl_square.style.border = "1px solid black";
		ctrl_square.style.position = "absolute";
		ctrl_square.style.overflow="hidden";
		ctrl_square.style.left = child._x +"px";
		ctrl_square.style.top = child._y+"px";
		ctrl_square.style.width=child._w+"px";
		ctrl_square.style.height=child._h+"px";
		child._ctrl_square = ctrl_square;
		designerFrame.getClient().appendChild(ctrl_square);
		child.wnd = ctrl_square;	// ahora este cuadrado es la ventana del control ( a quien se le va a dar la info de posicion , durante el layout)

		// crea un borde para acompañar al control en el front
		var ctrl_border = icc.utils.makeElement("div");
		ctrl_border.innerHTML = "&nbsp;";	
		ctrl_border.style.overflow="hidden";
		ctrl_border.style.border = "1px solid black";
		ctrl_border.style.position = "absolute";
		ctrl_border.style.width=child._w+"px";
		ctrl_border.style.height=child._h+"px";
		ctrl_border.style.left = frontpos.x+"px";
		ctrl_border.style.top = frontpos.y+"px";
		jQuery(ctrl_border).css({opacity:0.5});
		child._ctrl_border = ctrl_border;
		this.topFace.appendChild(ctrl_border);
		
	};
	
	designerHost.prototype.restoreChildWnd = function ( designerFrame,child,position){
		
		this.topFace.removeChild(child._src_wnd);
		this.topFace.removeChild(child._ctrl_border);
		child.parent.getClient().removeChild(child._ctrl_square);
		child.parent.getClient().appendChild(child._src_wnd);
		child.wnd = child._src_wnd;
		child.wnd.style.top = child._y+"px";
		child.wnd.style.left = child._x+"px";
		
		//jQuery(child.wnd).css({opacity:1});
		child.wnd.style.zIndex = child._zIndex;//child._ctrl_square.style.zIndex;
		
		//child._zIndex = wnd.style.zIndex;		
		child._crtl_border=null;
		child._ctrl_square=null;
		child._inFront=false;
	};
	designerHost.prototype.startsDragLineHandler = function (designerFrame,line,handler,position){
		
	};
	designerHost.prototype.stillDragLineHandler = function (designerFrame,line,handler,position){
		var client = designerFrame.screenToClient(position);
		line.moveHandler(handler,client)
	};
	
	designerHost.prototype.stopsDragLineHandler = function (designerFrame,line,handler,position){
		var data = line.getData();
		var cnxinfo = this.lines[line.id];
		cnxinfo.aditionalData = data;
		this.fireEvent("onConnectionChanged",line.id,cnxinfo);
	};
	
	designerHost.prototype.startsDrawConnection = function (designerFrame,child,handler,position,outputName){
		var endSide;
		var client={} // = designerFrame.screenToClient(position);
		client.x = parseInt(handler.x+(handler.width/2),10)
		client.y = parseInt(handler.y+(handler.height/2),10)
		
		var tox = client.x;
		var toy = client.y;
		switch(handler.side){
			case icc.ui.line_TOP:
				endSide = icc.ui.line_BOTTOM
				toy-=7;
			break
			case icc.ui.line_RIGHT:
				endSide = icc.ui.line_LEFT
				tox+=7;
			break;
			case icc.ui.line_BOTTOM:
				endSide = icc.ui.line_TOP
				toy+=7;
			break;
			case icc.ui.line_LEFT:
				endSide = icc.ui.line_RIGHT
				tox-=7;
			break;
		}
		
		this.currentLine = new icc.ui.designerLine(designerFrame.getClient(),client.x,client.y,handler.side,tox,toy,endSide,null,null,null,outputName);
		this.currentLine.outputName = outputName;
	};
	designerHost.prototype.stillDrawConnection = function (designerFrame,child,handler,position,tgtPoint,tgtChild){
		var client;
		if(this.currentLine){
		
			if(tgtPoint){
				client={} // = designerFrame.screenToClient(position);
				client.x = parseInt(tgtPoint.x+(tgtPoint.width/2),10)
				client.y = parseInt(tgtPoint.y+(tgtPoint.height/2),10)
			}else {
				client = designerFrame.screenToClient(position);
			}
			var side;
			if(tgtChild!==child){
				side = tgtPoint?tgtPoint.side:undefined
			}else{
				side = tgtPoint && tgtPoint.side!== this.currentLine.from.d?tgtPoint.side:undefined;
			}
			this.currentLine.moveTo(client.x,client.y,side);
		}
	};
	designerHost.prototype.stopsDrawConnection = function(designerFrame,child,handler,position,tgtPoint,tgtChild){
		if(this.currentLine){	
			if(!tgtChild){
				this.currentLine.removeSegments();
				this.currentLine = null;
			}else{
				var cnxinfo = {line:this.currentLine,sourceChild:child.id,sourcePoint:handler.number,targetChild:tgtChild.id,targetPoint:tgtPoint.number,outputName:this.currentLine.outputName};
				this.line_starts[child.id]= this.line_starts[child.id] || {};
				this.line_start_points[cnxinfo.sourceChild+":"+cnxinfo.sourcePoint] = this.line_start_points[cnxinfo.sourceChild+":"+cnxinfo.sourcePoint] || 0
							
				this.line_ends[tgtChild.id]=this.line_ends[tgtChild.id] || {};
				this.line_end_points[cnxinfo.targetChild+":"+cnxinfo.targetPoint] = this.line_end_points[cnxinfo.targetChild+":"+cnxinfo.targetPoint] || 0
				
				this.line_starts[child.id][this.currentLine.id]=cnxinfo;
				this.line_start_points[cnxinfo.sourceChild+":"+cnxinfo.sourcePoint]++;
				
				this.line_ends[tgtChild.id][this.currentLine.id]=cnxinfo;
				this.line_end_points[cnxinfo.targetChild+":"+cnxinfo.targetPoint]++;
				
				
				this.lines[this.currentLine.id]=cnxinfo;
				cnxinfo.aditionalData = this.currentLine.getData();
				this.fireEvent("onNewConnection",this.currentLine.id,cnxinfo);
				this.currentLine.drawSelected(this);
				
			}
		}
		
	};
	
	
	
	
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	designerHost.prototype.startsMoving = function(designerFrame,child,position){
		var startpos = this.screenToClient(position);
		for(var idx=0;idx<this.selection.length;idx++)
		{
			child = this.selection[idx];
			child._startpos = startpos;
			child._clientpos = {x:child._x,y:child._y};
			child._initialpos = {x:child._x,y:child._y,width:child._w,height:child._h};
		}
	};
	designerHost.prototype.stillMoving = function(designerFrame,tgt,position){
		var idx;
		var child;
		var scrpos = this.screenToClient(position);
		var tgt_container;
		var startpos;
		if(!tgt._inFront){
			for(idx=0;idx<this.selection.length;idx++)
			{
				child = this.selection[idx];
				this.moveChildWndToFront(designerFrame,child,scrpos);
			}
		}
		// Mueve los controles hasta la scrposicion que debieran estar en el frontface
		for(idx=0;idx<this.selection.length;idx++)
		{
			child = this.selection[idx];
			
			child._src_wnd.style.top = (child._frontpos.y +(scrpos.y-child._startpos.y))+"px";
			child._src_wnd.style.left = (child._frontpos.x +(scrpos.x-child._startpos.x))+"px";
			child._ctrl_border.style.top =child._src_wnd.style.top;
			child._ctrl_border.style.left =child._src_wnd.style.left;
		}
		// Comprueba si el mouse esta aun dentro del contenedor
		var pos;
		tgt_container = this.findContainerAt(position,tgt);
		if(!tgt_container){
				for(idx=0;idx<this.selection.length;idx++)
				{
					child = this.selection[idx];
					child.getWnd().style.visibility = "hidden";
				}
				return;
		}else{
				for(idx=0;idx<this.selection.length;idx++)
				{
					child = this.selection[idx];
					child.getWnd().style.visibility = "visible";
				}

		}
		if(tgt_container !== designerFrame){
			if(tgt.parent && tgt.parent === designerFrame){		
				// esta dentro del contenedor original
			
				for(idx=0;idx<this.selection.length;idx++)
				{
					child = this.selection[idx];
					if (tgt_container){
					
						pos = tgt_container.screenToClient(child.parent.clientToScreen({x:child._x,y:child._y}));
						child._clientpos=tgt_container.screenToClient(designerFrame.clientToScreen(child._clientpos));
					}
					designerFrame.rmvChild(child,false)
//					designerFrame.getClient().removeChild(child.getWnd());
					
					child.parent = undefined;
					
					if(tgt_container){
						tgt_container.addChild(child);
					
						child.parent.childPositionHasChanged(child,pos.x,pos.y,this.lastEvent);
						child.visible = false;
					}
					

				}
				designerFrame.layout();		
				for(idx=0;idx<this.selection.length;idx++)
				{
					child = this.selection[idx];
					child.visible=true;
				}
			}else{ // esta en otro contenedor
				if(tgt.parent !== tgt_container){
				// esta metido en otro contenedor que no es el original y tampoco es el nuevo
				// hay que sacarlo de uno y meterlo en el otro
				// tengo que convertir x e y a screen y vuelta a client para saber donde va en el nuevo container
					var parent = child.parent;
					for(idx=0;idx<this.selection.length;idx++)
					{
						child = this.selection[idx];
						pos = tgt_container.screenToClient(child.parent.clientToScreen({x:child._x,y:child._y}));
						child._clientpos = tgt_container.screenToClient(child.parent.clientToScreen(child._clientpos));
						child.parent.rmvChild(child,false);
						tgt_container.addChild(child);
						child.parent.childPositionHasChanged(child,pos.x,pos.y,this.lastEvent);
					}
					parent.layout();
					
				}else{

					for(idx=0;idx<this.selection.length;idx++){
						child = this.selection[idx];
						pos = {x:child._clientpos.x +(scrpos.x-child._startpos.x),y:child._clientpos.y +(scrpos.y-child._startpos.y)};
						child.parent.childPositionHasChanged(child,pos.x,pos.y,this.lastEvent);
					}

				}
			}
		
		}else{
			if(tgt.parent!==designerFrame){				// vuelve desde otro container al original
				parent = tgt.parent;

				for(idx=0;idx<this.selection.length;idx++)
				{
					child = this.selection[idx];
					pos = designerFrame.screenToClient(child.parent.clientToScreen({x:child._x,y:child._y}));
					child._clientpos = designerFrame.screenToClient(child.parent.clientToScreen(child._clientpos));
					child.parent.rmvChild(child,false);
					designerFrame.addChild(child);
					child.parent = designerFrame;
					child.parent.childPositionHasChanged(child,pos.x,pos.y,this.lastEvent);

				}
				parent.layout();

			}else{

				for(idx=0;idx<this.selection.length;idx++)
				{
					child = this.selection[idx];
					pos = {x:child._clientpos.x +(scrpos.x-child._startpos.x),y:child._clientpos.y +(scrpos.y-child._startpos.y)};
					child.parent.childPositionHasChanged(child,pos.x,pos.y,this.lastEvent);
				}

			}
		}
		
		// movimiento de lineas
		var selectionMap = {}
		var moved={}
		for(idx=0;idx<this.selection.length;idx++){
			selectionMap[this.selection[idx].id]=this.selection[idx]
		}
		
		for(idx=0;idx<this.selection.length;idx++){	
			var child = this.selection[idx]
			if(child.getParentConnectionPoints){
				var lines = this.line_ends[child.id];
				var handleMap = {};
				var c = child.getParentConnectionPoints()
				for ( var nh =0;nh < c.length;nh++){
					handleMap[c[nh].number]={x:parseInt(c[nh].x+(c[nh].width/2),10),y:c[nh].y+(c[nh].height/2)}
				}
				//{line:this.currentLine,sourceChild:child.id,sourcePoint:handler.number,targetChild:tgtChild.id,targetPoint:tgtPoint.number}
				if(lines){	// hay una linea que termina en este child
					for(var nl in lines){
						var l = lines[nl]
						if(l){
							if(!selectionMap[l.sourceChild]){ // si el origen no esta seleccionado la movemos
								l.line.moveTo(handleMap[l.targetPoint].x,handleMap[l.targetPoint].y)
								
							}else{					// si no la transportamos entera sin recalcular
								if(!moved[l.line.id] && !moved[l.targetChild]){
									// esta no se debe mover mas
									l.line.translateTo(handleMap[l.targetPoint].x,handleMap[l.targetPoint].y);
									moved[l.line.id]=true
								}
							}
						}
					}
				}
				lines = this.line_starts[child.id] // hay una linea que arranca en este child
				if(lines){ // hay una linea que arranca en este child
					for(var nl in lines){
						var l = lines[nl]
						if(l){
							if(!selectionMap[l.targetChild]){ // si el destino no esta seleccionado le movemos el head
								l.line.moveHeadTo(handleMap[l.sourcePoint].x,handleMap[l.sourcePoint].y)
							}else{					// la transportamos y anotamos
								if(!moved[l.line.id]){
									// esta no se debe mover mas
									l.line.translateHeadTo(handleMap[l.sourcePoint].x,handleMap[l.sourcePoint].y);
									moved[l.line.id]=true
								}
							}
						}
					}
				}
			}
		}
		
		
		
		if(tgt.parent)
			tgt.parent.layout();
	};
	
	designerHost.prototype.stopsMoving = function(designerFrame,tgt,position){
		var child;
		var self=this;
		var undo_block = [];
		if(	tgt._initialpos.x !== tgt._x || tgt._initialpos.y !== tgt._y || tgt.parent !== designerFrame){
			for(var idx=0;idx<this.selection.length;idx++){
				child = this.selection[idx];
				undo_block.push({object:child,position:child._initialpos,parent:designerFrame});
			}
			this.addUndoAction(function(){
				var undo_step;
				var selection = [];
				var newParent;
				for ( var idx=0;idx<undo_block.length;idx++){
					undo_step = undo_block[idx];
					if(undo_step.object.parent !== undo_step.parent){
						newParent = undo_step.object.parent;
						undo_step.object.parent.rmvChild(undo_step.object);
						newParent.layout();
						undo_step.parent.addChild(undo_step.object);
						newParent = undo_step.parent;
					}
					selection.push(undo_step.object);
					undo_step.object._x = undo_step.position.x;
					undo_step.object._y = undo_step.position.y;
					undo_step.object._w = undo_step.position.width;
					undo_step.object._h = undo_step.position.height;
					undo_step.object.parent.childPositionHasChanged(undo_step.object,undo_step.position.x,undo_step.position.y,undo_step.position.width,undo_step.position.height,self.lastEvent);
					undo_step.object.parent.layout();
				}
				self.fireEvent("onChangeCtrlPosition",selection,newParent);// Dispara el evento para que se graben las posiciones en el doc
				
			});
		}
		if(tgt._inFront){
			for(idx=0;idx<this.selection.length;idx++)
			{
				child = this.selection[idx];
				this.restoreChildWnd(designerFrame,child,position);
			}
		}
		this.fireEvent("onChangeCtrlPosition",this.selection,tgt.parent !== designerFrame?tgt.parent:null);
	};	

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	designerHost.prototype.startsResizing = function(designerFrame,child,handler,position){
		child._startpos = designerFrame.screenToClient(position);
		
		child._origlocation = {x:child._x,y:child._y,width:child._w,height:child._h};
		child._src_wnd = child.getWnd();
		child.wnd = icc.utils.makeElement("div");
		jQuery(child.wnd).css({
			position:"absolute",
			top:"-1000px",
			left:"-1000px"
		});
		designerFrame.getClient().appendChild(child.wnd);
		designerFrame.startsChildResizing(this,child,handler,designerFrame.screenToClient(position));
					
	};
	designerHost.prototype.stillResizing = function(designerFrame,child,handler,position){
		designerFrame.stillChildResizing(this,child,handler,designerFrame.screenToClient(position));
		this.updateBoundingBox(child);
	};
	
	designerHost.prototype.stopsResizing = function(designerFrame,child,handler,position){
		var undo_block = [];
		designerFrame.getClient().removeChild(child.wnd);
		child.wnd = child._src_wnd;
		var pos = designerFrame.screenToClient(position);
		designerFrame.stopsChildResizing(this,child,handler,designerFrame.screenToClient(position));
		this.updateBoundingBox(child);
	};
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		

	designerHost.prototype.addUndoAction=function(cb){
		var selection = [];
		for (var idx=0;idx<this.selection.length;idx++){
			selection.push(this.selection[idx]);
		}
		this.undo.push({fn:cb,selection:selection});
	};
	
	designerHost.prototype.goUndo = function(){
		var uinfo=this.undo.pop();
		if(uinfo){
			uinfo.fn();
		}
		this.hideSelection();
		this.selection = uinfo.selection;
		this.showSelection();
		this.fireEvent("onSelectionChanged",this.selection);
	};
	designerHost.prototype.setSelection=function(ctrlList){
		this.hideSelection();
		this.selection = ctrlList;
		this.showSelection();
		this.fireEvent("onSelectionChanged",this.selection);
	};
	designerHost.prototype.getSelection=function(){
		return this.selection;
	};
	designerHost.prototype.onNewConnection=function(fn){
		this.addListener("onNewConnection",fn);
	}
	designerHost.prototype.onConnectionDeleted=function(fn){
		this.addListener("onConnectionDeleted",fn);
	}
	designerHost.prototype.onConnectionChanged=function(fn){
		this.addListener("onConnectionChanged",fn);
	}
	
	designerHost.prototype.onSelectionChanged=function(fn){
		this.addListener("onSelectionChanged",fn);
	};
	designerHost.prototype.onRmvControl = function(fn){
		this.addListener("onRmvControl",fn);
	};
	designerHost.prototype.onChangeCtrlPosition = function(fn){
		this.addListener("onChangeCtrlPosition",fn);

	};
	designerHost.prototype.onNewControl = function (fn){
		this.addListener("onNewControl",fn);
	};
	designerHost.prototype.onDrag = function(fn){
		this.addListener("onDrag",fn);
	};
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	designerHost.prototype.removeControls= function (ctrllist){
		var self = this;
		var undo = [];
		var parent;
		// primero recorremos todos los controles recursivamente 
		// buscando algun que tenga erasable == false y si es asi abortamos
		var erasable = true
		var scanErasable = function(list){
			for (k in list){
				var ctrl = list[k]
				if(ctrl.erasable == false){
					erasable = false
					return 
				}
				if (ctrl.childs && erasable){
					scanErasable(ctrl.childs)
				}
				if(erasable)
					return;
			}
		}
		scanErasable(ctrllist)
		if(!erasable)
			return;
		
		
		var rmvControl = function ( ctrl ) {
			undo.push([ctrl,ctrl.parent]);
			ctrl.parent.rmvChild(ctrl);
		};
		this.showNearbyConnectionPoints({x:-1000,y:-1000})
		for ( var idx=0;idx<ctrllist.length;idx++){
			parent = ctrllist[idx].parent;
			rmvControl(ctrllist[idx]);
			
			
			var lines = this.line_starts[ctrllist[idx].id]
			if(lines){
				for( var n in lines){
					var l = lines[n];
					if(l){
						this.line_starts[l.sourceChild][l.line.id]=null;
						this.line_start_points[l.sourceChild+":"+l.sourcePoint]--;
						this.line_ends[l.targetChild][l.line.id]= null;
						this.line_end_points[l.targetChild+":"+l.targetPoint]--;
						this.lines[l.line.id]=null;
						l.line.removeSegments();
						this.fireEvent("onConnectionDeleted",l.line.id);
					}
				}
			}
			var lines = this.line_ends[ctrllist[idx].id]
			if(lines){
				for( var n in lines){
					var l = lines[n];
					if(l){
						this.line_starts[l.sourceChild][l.line.id]=null;
						this.line_start_points[l.sourceChild+":"+l.sourcePoint]--
						this.line_ends[l.targetChild][l.line.id]= null;
						this.line_end_points[l.targetChild+":"+l.targetPoint]--;
						this.lines[l.line.id]=null;
						
						l.line.removeSegments();
						this.fireEvent("onConnectionDeleted",l.line.id);
						
					}
				}
			}
			
		}
		
		if(parent){
			
		
			parent.layout();
			this.addUndoAction(function(){
				for(var idx=0;idx<undo.length;idx++){
					undo[idx][1].addChild(undo[idx][0]);
					undo[idx][1].layout();
				};
				for(var idx=undo.length-1;idx>=0;idx--){
					self.fireEvent("onNewControl",undo[idx][0],undo[idx][1],true);
				}
				
			});
			for(idx=0;idx<undo.length;idx++){
				self.fireEvent("onRmvControl",undo[idx][0],undo[idx][1]);
			}
		}
	};
	designerHost.prototype.destroy = function(){
		designerHost.SUPERclass.destroy.call(this);
		icc.console.log("designerHost.destroy");
		
	}
	designerHost.prototype.create = function(){
		var self=this;
		this.wnd = icc.utils.makeElement("div");
/*		if(self.childs[0].frame){
			this.wnd.style.overflow="hidden";

		}else{
			this.wnd.style.overflow="auto";
		}
		*/
		this.wnd.style.overflow="auto";
		this.wnd.style.background="white";
		this.wnd.style.border="1px solid #d7d7d7"
		
		this.topFace = icc.utils.makeElement("div");
		this.frontFace = icc.utils.makeElement("div");
		this.frontFace.style.position = "absolute";
//		this.frontFace.innerHTML = "&nbsp;";
		
		designerHost.SUPERclass.create.call(this);
		
		this.dragger= new dhtmlDragAndDropObject();
		var s_control = function(){
			//action occures on drag 
			var dragInEvent
			this._drag=function(sourceHtmlObject,dhtmlObject,targetHtmlObject){
				
				if(dhtmlObject.dragReference){
					var d = dhtmlObject.dragReference._draginfo();
					if(d){
						var e =dragInEvent;
					//	var pos = {x:(e.clientX),y:(e.clientY)}
					
						var posx = 0;
						var posy = 0;
						if (!e) var e = window.event;
						if (e.pageX || e.pageY) 	{
							posx = e.pageX;
							posy = e.pageY;
						}
						else if (e.clientX || e.clientY) 	{
							posx = e.clientX + document.body.scrollLeft
								+ document.documentElement.scrollLeft;
							posy = e.clientY + document.body.scrollTop
								+ document.documentElement.scrollTop;
						}
	
						var pos = {x:posx,y:posy}
					//	pos = self.screenToClient(pos);

						var hit = self.hitTest(pos);

						if(hit.tgt)
							self.fireEvent("onDrag",d,pos,hit.tgt,hit.tgt.screenToClient(pos));

						else
							self.fireEvent("onDrag",d,pos);
					}
				}
//				targetHtmlObject.style.backgroundColor="";
				targetHtmlObject.value=sourceHtmlObject.parentObject.label; 
			} 
			//action occures on drag moved in landing zone 
			this._dragIn=function(htmlObject,shtmlObject,clientX, clientY,event){
//				htmlObject.style.backgroundColor="#fffacd";
				dragInEvent=event?event:window.event;
				return htmlObject; 
			} //action occures on drag moved out landing zone 
			this._dragOut=function(htmlObject){
				
//				htmlObject.style.backgroundColor="";
				return this; 
			} 
		}
		
		
		
			
		jQuery(this.topFace).css({
			'z-index':1000,
			'position':'absolute',
			'top':'0px',
			'background':"url("+icc.ui.theApp.getBaseUrl() + "resources/spacer.gif"  + ")",
			'left':'0px'
		});
		
		jQuery(this.frontFace).css({
			'z-index':1001,
			'background':"url("+icc.ui.theApp.getBaseUrl() + "resources/spacer.gif"  + ")"
		});
		
		this.focused = icc.utils.makeElement("input",false,this.frontFace);
		jQuery(this.focused).css({
			position:'absolute',
			top:'1px',
			left:'1px',
			width:'1px',
			height:'1px',
			background:'white',
			zIndex:0,
			opacity:0,
			border:'1px solid',
			overflow:'hidden'
		});
		jQuery(this.wnd).scroll(function(){
			jQuery(self.focused).css({
				top:jQuery(self.wnd).scrollTop()+"px",
				left:jQuery(self.wnd).scrollLeft()+"px"
			});
		});
		jQuery(this.focused).keydown(function(e){
			switch(e.which){
				case 18:
				//	self.frontFace.style.visibility="hidden"
				break;
			}
			
		});

		jQuery(this.focused).keyup(function(e){
			switch(e.which){
				case 18:
				//	self.frontFace.style.visibility="visible"
				break;
			
				case 46:
					if(self.selection.length){
						self.hideSelection();
						var sel = self.selection;
						self.removeControls(sel);
						self.selection = [];
					}else if(self.currentLine){
						var l = self.lines[self.currentLine.id]
						if(l){
							self.lines[self.currentLine.id]=null;
							self.line_starts[l.sourceChild][self.currentLine.id]=null;
							self.line_start_points[l.sourceChild+":"+l.sourcePoint]--;
							self.line_ends[l.targetChild][self.currentLine.id]=null;
							self.line_end_points[l.targetChild+":"+l.targetPoint]--;
							
							self.currentLine.removeSegments();
							self.fireEvent("onConnectionDeleted",self.currentLine.id);
							self.currentLine = null;
							
							
						}
					}

				break;
			}
		});
		this.focused.setAttribute("tabIndex",this.tabIndex);
//		this.frontFace.appendChild(this.focused);
		this.wnd.appendChild(this.frontFace);
		this.wnd.appendChild(this.topFace);
		this.selectionVisible=true;
		var hit,phit;
		var cursor;
		var rect;
		var hitStart = function(e){
			
			//console.log("hit start "+e.pageX+" "+e.pageY)
			if(phit && hit && (phit.tgt === hit.tgt)){
				//console.log("dblclick" + hit.tgt.id)
				self.fireEvent("onDblClick",hit.tgt)
			}else{
				if(hit){
					setTimeout(function(){
						phit = undefined;
					},500)
				}
			}
			phit = hit;
			switch(hit.type){
				case "face":
					if(self.currentLine){
						self.currentLine.drawUnselected(self);
						self.currentLine=null;
					}
					if(!hit.parent){
						self.clearSelection();
						self.fireEvent("onSelectionChanged",self.selection);
					}else{
						self.addToSelection(hit.tgt,e);
					}
					self.showSelectionBoundingBox();
					if (!hit.tgt.immovable){
						self.frontFace.oldZIndex = self.frontFace.style.zIndex
						self.topFace.oldZIndex = self.topFace.style.zIndex
						self.topFace.style.zIndex=50001;
						self.frontFace.style.zIndex=50002;
						
						self.startsMoving(hit.parent,hit.tgt,{x:(e.pageX),y:(e.pageY)});
					}
			
				break;
				case "client":
					if(self.currentLine){
						self.currentLine.drawUnselected(self);
						self.currentLine=null;
					}
				
					self.clearSelection();
					if(e.pageX<rect.x2 && e.pageY<rect.y2){
						hit.tgt.startsSelecting(self,{x:(e.pageX),y:(e.pageY)});
					}else{
						hit=null;
					}
				break;
				case "handler":
					if(self.currentLine){
						self.currentLine.drawUnselected(self);
						self.currentLine=null;
					}
					cursor = self.frontFace.style.cursor;
					self.frontFace.style.cursor = hit.cursorName;
					self.hideSelection();
					self.showBoundingBox(hit.tgt);
					self.startsResizing(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
				break;
/*					case "cnxpoint":
					if(self.currentLine){
						self.currentLine.drawUnselected(self);
						self.currentLine=null;
					}
				
					cursor = self.frontFace.style.cursor;
					self.frontFace.style.cursor = hit.cursorName;
					self.hideSelection();
					self.startsDrawConnection(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
				break;
*/					
				case "line":
					self.clearSelection();
					if(self.currentLine){
						self.currentLine.drawUnselected(self);
					}
					self.currentLine = hit.tgt;
					self.currentLine.drawSelected(self);
				break;
				case "line-handler":
					cursor = self.frontFace.style.cursor;
					self.frontFace.style.cursor = hit.cursorName;
					self.startsDragLineHandler(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
				break;
				
			}
			var mouseMove = function(e){
				self.lastEvent = e;
				var x,y;
				x = e.pageX;
				y = e.pageY;
				if(hit){	
					switch(hit.type){
						case "face":
							self.hideBoundingBox(hit.tgt);
							self.hideSelectionBoundingBox();
							if (!hit.tgt.immovable){
								self.stillMoving(hit.parent,hit.tgt,{x:(e.pageX),y:(e.pageY)});
							}
						break;
						case "client":
							if(x>rect.x2){
								x=rect.x2;
							}
							if(y>rect.y2){
								y=rect.y2;
							}
							hit.tgt.stillSelecting(self,{x:x,y:y});
						break;
						case "cnxpoint":
							if(self.currentLine){
								if(!self.lines[self.currentLine.id]){
									var nh = self.hitTest({x:(e.pageX),y:(e.pageY)});
									var cn
									if(nh){
										if(nh.type == "cnxpoint"){
											cn = nh.handler;
										}
									}
									self.showNearbyConnectionPoints({x:(e.pageX),y:(e.pageY)});
									self.stillDrawConnection(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)},cn,cn?nh.tgt:undefined);
								}else{
									self.currentLine.drawUnselected(self);
									self.currentLine=null;
								}
							}
						break;
						case "line-handler":
							self.stillDragLineHandler(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
						break;
						case "handler":
							self.stillResizing(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
							//return false;
						break;
					}
					if(!self.childs[0].frame){// si es un frame no estiramos ya que no se puede dibujar
					
						var w = self.childs[0].getDefaultWidth()-self.childs[0]._w;
						var h = self.childs[0].getDefaultHeight()-self.childs[0]._h;
						if(w>-20){
							w+=50;
							self.childs[0].width = self.childs[0]._w+w;
						}
						if(h>-20){
							h+=50;
							self.childs[0].height = self.childs[0]._h+h;
						}
						if(h>-20 || w>-20){
							self.layout();
							
							jQuery(self.frontFace).css({
								width:self.childs[0]._w-2+"px",
								height:self.childs[0]._h-2+"px"
							});
							jQuery(self.topFace).css({
								width:self.childs[0]._w-2+"px",
								height:self.childs[0]._h-2+"px"
							});

						}
					}
				}
				return true;


			};
			var mouseUp = function(e){
				self.lastEvent = e;
				if(hit){
			
					switch(hit.type){
						case "face":
							self.hideSelectionBoundingBox();
							if (!hit.tgt.immovable){
								self.frontFace.style.zIndex=self.frontFace.oldZIndex;
								self.topFace.style.zIndex=self.topFace.oldZIndex;

								self.stopsMoving(hit.parent,hit.tgt,{x:(e.pageX),y:(e.pageY)});
							}
							self.showSelection();
							hit=null;
				

						break;
						case "client":
							if(e.pageX>rect.x2){
								e.pageX=rect.x2;
							}
							if(e.pageY>rect.y2){
								e.pageY=rect.y2;
							}
					
							hit.tgt.stopsSelecting(self,{x:(e.pageX),y:(e.pageY)});
							if(self.selection.length===0){
	//							if(hit.parent && hit.parent!= self){
									var tgt = hit.tgt;
									while(!tgt.parent.drawSelected && tgt.parent!==self){
										tgt=tgt.parent;
									}
									if(tgt.parent!==self){
										self.addToSelection(tgt,e);
										self.showSelection();
									}
								//}else
									if (!tgt.notSelectable) {
										self.fireEvent("onSelectionChanged",self.selection);
									}
									else {
										$(".colorPicker").remove();
									}
							}
							hit=null;

						break;
						case "handler":
							self.frontFace.style.cursor = cursor;
							self.stopsResizing(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
							self.showSelection();
							hit=null;

						break;
						case "cnxpoint":
							var nh = self.hitTest({x:(e.pageX),y:(e.pageY)});
							var cn
							if(nh){
								if(nh.type == "cnxpoint"){
									cn = nh.handler;
								}
							}
						
							self.frontFace.style.cursor = cursor;
							self.stopsDrawConnection(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)},cn,cn?nh.tgt:undefined);
							self.showSelection();
							hit=null;
						break;
						case "line-handler":
							self.frontFace.style.cursor = cursor;
							self.stopsDragLineHandler(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)});
							hit=null;
						break;
					}
				}
				hit=null;
				jQuery(document).unbind("mousemove",mouseMove);
				jQuery(document).unbind("mouseup",mouseUp);
				return true;
			
			};
			jQuery(document).bind("mousemove",mouseMove);
			jQuery(document).bind("mouseup",mouseUp);
			return false;

		
		}
		
		
		jQuery(this.frontFace).mousedown(function(e){
			rect = jQuery(self.wnd).offset();
			rect.x2 = rect.left+self._w-16;
			rect.y2 = rect.top+self._h-16;
			self.lastEvent = e;
			self.focused.focus();	
			if(!hit){
				self.showNearbyConnectionPoints({x:-1000,y:-1000})
				hit=self.hitTest({x:(e.pageX),y:(e.pageY)});
				return hitStart(e);
				
			}
		});
		
		var hitover;
		var prevover;
		var outputsDiv;
		var overmenu=false;
		var showTimeout;
	
		jQuery(this.frontFace).bind("mousemove",function(e){
			if(!hit && !overmenu && !dropingMode){
				var hideOutputs = function(){
					if(showTimeout){
						clearTimeout(showTimeout)
						showTimeout = null;
					}
					if(outputsDiv){
						self.frontFace.removeChild(outputsDiv);
						outputsDiv = undefined;
					}
					
				}
				
				var showOutputs = function(activity,handler){
					canceled = false;
					showTimeout = setTimeout(function(){
						if(showTimeout){
							if(!self.line_start_points[activity.id+":"+handler.number] && !self.line_end_points[activity.id+":"+handler.number]){
							
								var outputs = activity.getOutputs();
								var asignedOutputs={}
								var outs = self.line_starts[activity.id] || {}
								var availableOutputs = []
								for(var i in outs){
									asignedOutputs[(outs[i] || {}).outputName]=true;
								}
								for(var i=0;i<outputs.length;i++){
									var tx = outputs[i]
									if(!asignedOutputs[tx]){
										availableOutputs.push(tx)
									}
								}
								
								if(availableOutputs.length){
									var dv = icc.utils.makeElement("div");
									for (var i=0;i<availableOutputs.length;i++){
										var opt = icc.utils.makeElement("div");
										opt.innerHTML = availableOutputs[i];
										opt.txtData = availableOutputs[i];
										jQuery(opt).css({
											fontFamily:'arial,sans-serif',
											fontSize:11,
											fontWeight:'normal',
											color:'#666666',
											background:'white',
											border:'none',
											cursor:'default',
											borderBottom:i<availableOutputs.length-1?'1px solid gray':'none',
											padding:'2px',
											paddingLeft:'3px',
											paddingRight:'3px',
										
										});
										jQuery(opt).mouseover(function(){
											this.style.background = "#eeeeee",
											this.style.color='black'
										});
										jQuery(opt).mouseout(function(){
											this.style.background = "#ffffff",
											this.style.color='#888888'
										});
										
										jQuery(opt).mousedown(function(){
											
											overmenu=false;
											hideOutputs();
											hit = hitover;
											if(self.currentLine){
												self.currentLine.drawUnselected(self);
												self.currentLine=null;
											}
											cursor = self.frontFace.style.cursor;
											self.frontFace.style.cursor = hit.cursorName;
											self.hideSelection();
											self.startsDrawConnection(hit.parent,hit.tgt,hit.handler,{x:(e.pageX),y:(e.pageY)},this.txtData);
											return hitStart(hit,e);
										});
										dv.appendChild(opt);
									}
									
									outputsDiv = dv;
									var x,y;
									x=handler.x+3;
									y=handler.y+3;
									jQuery(outputsDiv).css({
										position:'absolute',
										left:x+"px",
										top:y+"px",
										border:'1px solid gray',
										zIndex:20000
										
									});
									
									jQuery(outputsDiv).mouseover(function(){
										overmenu=true;
									})
									jQuery(outputsDiv).mouseout(function(){
										overmenu=false;
									})
									
									self.frontFace.appendChild(outputsDiv);
									var w = jQuery(outputsDiv).width();
									var h = jQuery(outputsDiv).height();
									x-=w/2
									y-=h/2;
									jQuery(outputsDiv).css({
										left:x+"px",
										top:y+"px",
									});
								
								}
							}
						}
					},100);
				};
				self.showNearbyConnectionPoints({x:(e.pageX),y:(e.pageY)},true);

				hitover = self.hitTest({x:(e.pageX),y:(e.pageY)});
				
				if(hitover.type == "cnxpoint" ){
					if(prevover){
						if(prevover.tgt !== hitover.tgt){
							hideOutputs();
							showOutputs(hitover.tgt,hitover.handler);
							prevover = hitover;
							return true;
						}else if(prevover.handler.number !== hitover.handler.number){
							hideOutputs();
							showOutputs(hitover.tgt,hitover.handler);
							return true;
						}
					}else
						showOutputs(hitover.tgt,hitover.handler);
					prevover = hitover;
				}else if(prevover){
					hideOutputs();
					prevover = null;
				}
			}
			return true;
		});


		jQuery(this.wnd).mouseover(function(e){
			currentHost = self;
		});
	
		jQuery(this.wnd).mouseout(function(e){
			if(currentHost===self){
				currentHost = null;
			}
		});
		if(this.childs[0]){
			this.childs[0].getWnd().style.overflow="visible";
			
		}
		this.dragger.addDragLanding(this.frontFace,new s_control);
		

		
		return this.wnd;
	};
	designerHost.prototype.buildConnections = function(){
		var childMap = {}
		for (var n = 0;n<this.childs[0].childs.length;n++){
			childMap[this.childs[0].childs[n].id]=this.childs[0].childs[n]
		}
		if (this.connections){
			var mapPoints = function (cnxpoints){
				var res = {}
				for (var n = 0;n<cnxpoints.length;n++){
					res[cnxpoints[n].number] = cnxpoints[n]
				}
				return res;
			}
			for (var n in this.connections){
				var l = this.connections[n]
				var from,to
				
				var source = childMap[l.from.child]
				if (source && source.getParentConnectionPoints){
					var cpoints = mapPoints(source.getParentConnectionPoints());
					var cp = cpoints[l.from.point]
					if(cp){
						from = {x:parseInt(cp.x+(cp.width/2),10),y:parseInt(cp.y+(cp.height/2),10),d:cp.side}
					}
				}
				var target = childMap[l.to.child]
				if (target && target.getParentConnectionPoints){
					var cpoints = mapPoints(target.getParentConnectionPoints());
					var cp = cpoints[l.to.point]
					if(cp){
						to = {x:parseInt(cp.x+(cp.width/2),10),y:parseInt(cp.y+(cp.height/2),10),d:cp.side}
					}
				}
				if(from && to){
					var line = new icc.ui.designerLine(this.childs[0].getWnd(),from.x,from.y,from.d,to.x,to.y,to.d,n,null,l.data,l.outputName)
					var cnxinfo = {line:line,sourceChild:l.from.child,sourcePoint:l.from.point,targetChild:l.to.child,targetPoint:l.to.point,outputName:l.outputName};
					
					this.line_starts[l.from.child]= this.line_starts[l.from.child] || {};
					this.line_start_points[l.from.child+":"+l.from.point] = this.line_start_points[l.from.child+":"+l.from.point] || 0
					
					this.line_ends[l.to.child]=this.line_ends[l.to.child] || {};
					this.line_end_points[l.to.child+":"+l.to.point] = this.line_end_points[l.to.child+":"+l.to.point] || 0
					
					this.line_starts[l.from.child][n]=cnxinfo;
					this.line_start_points[l.from.child+":"+l.from.point]++;
					this.line_ends[l.to.child][n]=cnxinfo;
					this.line_end_points[l.to.child+":"+l.to.point]++;
					this.lines[line.id]=cnxinfo;
					
				}
				
			}
		}
	}
	designerHost.prototype.getUndoCount = function(){
		return this.undo.length;
	};
	designerHost.prototype.getFrontFace = function(){
		return this.frontFace;
	};
	designerHost.prototype.findContainerAt = function(position,exclude){
		var res = this.childs[0].findContainerAt(position,exclude);
		if (!res){
			res = this.childs[0];
		}
		if(!res.frame){
			return res;
		}
	};
	/*
	self.line_start_points[activity.id+":"+handler.number] && !self.line_end_points[activity.id+":"+handler.number]){
					
						var outputs = activity.getOutputs();
						var asignedOutputs={}
						var outs = self.line_starts[activity.id] || {}
						var availableOutputs = []
						for(var i in outs){
							asignedOutputs[(outs[i] || {}).outputName]=true;
						}
						for(var i=0;i<outputs.length;i++){
							var tx = outputs[i]
							if(!asignedOutputs[tx]){
								availableOutputs.push(tx)
							}
						}
						
	*/
	designerHost.prototype.showNearbyConnectionPoints = function(position,outputsOnly){
	
		var clientpos = this.childs[0].screenToClient(position);
		for (var idx = 0;idx < this.childs[0].childs.length;idx++){
			child = this.childs[0].childs[idx];
			if( child.getParentConnectionPoints){
				if(outputsOnly){ // si no tiene mas salidas disponibles
								 // no se le resalta los puntos de conexion
					var outputs = child.getOutputs();
					var asignedOutputs={}
					var outs = this.line_starts[child.id] || {}
					var availableOutputs = []
					for(var i in outs){
						asignedOutputs[(outs[i] || {}).outputName]=true;
					}
					for(var i=0;i<outputs.length;i++){
						var tx = outputs[i]
						if(!asignedOutputs[tx]){
							availableOutputs.push(tx)
						}
					}
					if(!availableOutputs.length)
						continue;
				}
			
				var cnxpoints = child.getParentConnectionPoints();
				var hto = icc.utils.browser.is_ie?2:1
				var dist = function (x1,y1,x2,y2){
					return Math.sqrt(Math.pow(x2 - x1,2) + Math.pow(y2 -y1,2))
				}
                
				d = 1e9;
				var pt;
				for (var i =0;i<cnxpoints.length;i++){
					p = cnxpoints[i]
					var dt = dist(clientpos.x,clientpos.y,p.x+(p.width/2),p.y+(p.height/2))
					
					if(dt< d){d = dt;pt=p}
				}
				for(var i=0;i<cnxpoints.length;i++){
					var cnxpt = cnxpoints[i];
					var key = child.id+":"+cnxpt.number
					if(pt && d<10 && pt === cnxpt && (!outputsOnly || (!this.line_start_points[child.id+":"+cnxpt.number] && !this.line_end_points[child.id+":"+cnxpt.number]))){
						if(!this.visibleConnectionPoints[key]){
							var dv = icc.utils.makeElement("div")
							jQuery(dv).css({
								position:'absolute',
								left:cnxpt.x+"px",
								top:cnxpt.y+"px",
								width:cnxpt.width+"px",
								height:cnxpt.height+"px",
								zIndex:20000,
								background:icc.ui.getApplication().backgroundImage('cpointblue.png')
							});
							this.childs[0].getWnd().appendChild(dv);
							this.visibleConnectionPoints[key]=dv;
						}
					}else{
						var dv = this.visibleConnectionPoints[key]
						if(dv){
							this.childs[0].getWnd().removeChild(dv);
							this.visibleConnectionPoints[key]=null;
						}
					}
				}
			}
		}
	}
	designerHost.prototype.hitTest=function(position,exclude){
		var child;
		var clientpos;
		var handlers;
		var handler;
		for (var idx = 0;idx<this.selection.length;idx++){
			child = this.selection[idx];
			if(child!==exclude){
			
				clientpos = child.parent.screenToClient(position);
				handlers = child.getHandlers();
				var hto = icc.utils.browser.is_ie?2:1
				for(var i=0;i<handlers.length;i++){
					handler = handlers[i];
					if(handler.x-hto<=clientpos.x && handler.x+handler.width+2+hto>=clientpos.x && 
						handler.y-hto<=clientpos.y && handler.y+handler.height+2+hto>=clientpos.y){
							return {parent:child.parent,tgt:child,type:handler.type?handler.type:handler.type || "handler",nHandle:i,handler:handler,cursorName:handler.cursorName};
					}
						
				}
			}
		}
		var clientpos = this.screenToClient(position);
		for (var idx = 0;idx < this.childs[0].childs.length;idx++){
			child = this.childs[0].childs[idx];
			if(child !== exclude && child.getParentConnectionPoints){
				var cnxpoints = child.getParentConnectionPoints();
				var hto = 1;//icc.utils.browser.is_ie?2:1
				for(var i=0;i<cnxpoints.length;i++){
					cnxpt = cnxpoints[i];
					if(cnxpt.x-hto<=clientpos.x && cnxpt.x+cnxpt.width+hto>=clientpos.x && 
						cnxpt.y-hto<=clientpos.y && cnxpt.y+cnxpt.height+hto>=clientpos.y){
							return {parent:child.parent,tgt:child,type:cnxpt.type?cnxpt.type:"cnxpoint",nHandle:i,handler:cnxpt,cursorName:cnxpt.cursorName};
					}
				}
			}
		}
		if(this.currentLine){
			var ht =this.currentLine.hitTest(clientpos);
			if(ht){
				ht.parent = this.childs[0];
				return ht;
			}
		}
		for (var idx in this.lines){
			var l = this.lines[idx];
			if(l){
				var ht = l.line.hitTest(clientpos);
				if(ht){
					ht.parent = this.childs[0];
					return ht;
				
				}
			}
		}
		
		
		var res = this.childs[0].hitTest(position,exclude);
		if (!res){
			return {parent:this.parent,tgt:this.childs[0],type:"client"};
		}
		return res;
	};
	designerHost.prototype.onZOrderChanged=function(cb){
	    this.addListener("onZOrderChanged",cb);
	};
	designerHost.prototype.onDblClick = function (cb){
		this.addListener("onDblClick",cb);
	}
	designerHost.prototype.screenToClient=function(position){
		var offset = jQuery(this.wnd).offset();
		offset.top-= this.wnd.scrollTop;
		offset.left-= this.wnd.scrollLeft;
		
		return {x:position.x-offset.left,y:position.y - offset.top};
	};
	designerHost.prototype.clientToScreen=function(position){
		var offset = jQuery(this.wnd).offset();
		offset.top+= this.wnd.scrollTop;
		offset.left+= this.wnd.scrollLeft;
		
		return {x:position.x+offset.left,y:position.y + offset.top};
	};
	designerHost.prototype.position=function(x,y,w,h){
		designerHost.SUPERclass.position.call(this,x,y,w,h);
		
		if(this.childs[0].width == undefined && this.childs[0].getDefaultWidth()<w)
			this.childs[0].width = w;
		if(this.childs[0].height == undefined && this.childs[0].getDefaultHeight()<h)
			this.childs[0].height = h;
			
		
		var cw = this.childs[0].getDefaultWidth()-this.childs[0]._w;
		var ch = this.childs[0].getDefaultHeight()-this.childs[0]._h;
		if(cw>-20){
			cw+=50;
			this.childs[0].width = this.childs[0]._w+cw;
		}
		if(ch>-20){
			ch+=50;
			this.childs[0].height = this.childs[0]._h+ch;
		}
		if(cw>-20 || ch>-20){
			this.layout();
		}
			
		this.frontFace.style.top="0px";
		this.frontFace.style.left="0px";
		this.frontFace.style.width=this.childs[0]._w+"px";
		this.frontFace.style.height=this.childs[0]._h+"px";
		
		
		this.topFace.style.top="0px";
		this.topFace.style.left="0px";
		this.topFace.style.width=this.childs[0]._w+"px";
		this.topFace.style.height=this.childs[0]._h+"px";
		
		var offset = jQuery(this.wnd).offset();
		jQuery(this.focused).css({
			top:offset.top+"px",
			left:offset.left+"px"
		});
		if(this.connections){
			this.buildConnections();
			this.connections = undefined;
		}
	};
	var dropingMode = false; // Usada en el sistema de resaltado de conexiones
	
	designerHost.prototype.Drop = function(ctrl,position){		
		dropingMode = false;
		var self = this;
		var hit = this.hitTest(position,ctrl);
		var designerFrame;
		switch(hit.type)
		{
			case "client":
	//			if(hit.parent)
	//				designerFrame=hit.parent
	//			else
					designerFrame=hit.tgt;
			break;
			default:

				designerFrame=hit.parent;
			break;
		}
		if(ctrl._inFront){
			this.restoreChildWnd(designerFrame,ctrl,position);
		}
		this.fireEvent("onChangeCtrlPosition",[ctrl],null);
			
		this.showSelection();
		this.ctrl = null;
		var sel = this.selection;	
		this.selection = [];	// esto es para que no reviente el undo
		this.addUndoAction(function(){
			self.clearSelection();
			designerFrame.rmvChild(ctrl);
			designerFrame.layout();
			self.fireEvent("onRmvControl",ctrl,designerFrame);
		});
		this.fireEvent("onNewControl",ctrl,designerFrame);
		
		this.selection = sel;
	};
	designerHost.prototype.cancelDrop=function(ctrl,position){
		dropingMode = false;
		var parent = ctrl.parent;
	
		this.clearSelection();
		if(ctrl._inFront){
			this.restoreChildWnd(ctrl.parent,ctrl,position);
		}
		ctrl.parent.rmvChild(ctrl);
		parent.layout();
		this.ctrl = null;
	};
	designerHost.prototype.getDefaultWidth = function(){
		return 1
	};
	designerHost.prototype.getDefaultHeight = function(){
		return 1
	};
	
	designerHost.prototype.previewDrop = function(ctrl,position){
		dropingMode = true;
		var designerFrame = this.findContainerAt(position,ctrl);
		if(!designerFrame)
			return false;
		if(!this.ctrl){
			var pos = designerFrame.screenToClient(position);
			ctrl._x = pos.x+3;
			ctrl._y = pos.y+3;
			jQuery(ctrl.getWnd()).css({
				top:ctrl._y+"px",
				left:ctrl._x+"px"
			});
			designerFrame.addChild(ctrl);
			this.clearSelection();
			this.ctrl = ctrl;
			this.disableEvents();	//para que no dispare el cambio de seleccion
			this.addToSelection(ctrl);
			this.enableEvents();
			this.startsMoving(designerFrame,ctrl,position);
			ctrl.origParent = designerFrame;
		}else if(this.ctrl !== ctrl){
			this.ctrl.parent.rmvChild(this.ctrl);
			this.clearSelection();
			this.ctrl = ctrl;
			this.addToSelection(ctrl);
			this.startsMoving(designerFrame,ctrl,position);
			ctrl.origParent = designerFrame;
		}else{
			this.stillMoving(ctrl.origParent,ctrl,position);
		}
		return true;
	};
	icc.ui.designerHost = designerHost;
})(__icc__);
(function(icc){
	var designerTool=function(args){
		designerTool.SUPERconstructor.call(this,args);
	};
	icc.utils.inherit(designerTool,icc.ui.button);
	designerTool.prototype.create = function(){
		var self = this;
		designerTool.SUPERclass.create.call(this);
//		jQuery(this.wnd).css({
//			position:'absolute',
//			background:"red",
//			border:"1px solid"
//		})

		jQuery(this.wnd).mousedown(function(e)
		{
			var mouseMove = function(e)
			{
				if(self.ctrl._host && self.ctrl._host !== currentHost){
					self.ctrl._host.cancelDrop(self.ctrl);
					self.ctrl._host = null;
				}
				if(currentHost){
					currentHost.lastEvent = e;
					if(self.ctrl._inPageBody){
						document.body.removeChild(self.ctrl.getWnd());
						self.ctrl._inPageBody=false;
					}
					if(currentHost.previewDrop(self.ctrl,{x:e.pageX,y:e.pageY})){
						self.ctrl._host = currentHost;
					}else{
						if(self.ctrl._host){
							self.ctrl._host.cancelDrop(self.ctrl);
							self.ctrl._host = null;
						}
						self.ctrl._inPageBody=true;
						document.body.appendChild(self.ctrl.getWnd());
						jQuery(self.ctrl.getWnd()).css({
							position:'absolute',
							top:(e.pageY+3)+"px",
							left:(e.pageX+3)+"px"
						});
					}
				}
				else{
					if(!self.ctrl._inPageBody){
						self.ctrl._inPageBody=true;
						document.body.appendChild(self.ctrl.getWnd());
					}
					jQuery(self.ctrl.getWnd()).css({
						position:'absolute',
						top:(e.pageY+3)+"px",
						left:(e.pageX+3)+"px"
					});
				}
				return false;
			};

			var mouseUp = function(e)
			{
				if(self.ctrl._inPageBody){
					document.body.removeChild(self.ctrl.getWnd());
					self.ctrl._inPageBody = false;
				}
				jQuery(document).unbind("mousemove",mouseMove);
				jQuery(document).unbind("mouseup",mouseUp);
				if(currentHost && currentHost.previewDrop(self.ctrl,{x:e.pageX,y:e.pageY})){
					currentHost.lastEvent = e;
					currentHost.Drop(self.ctrl,{x:e.pageX,y:e.pageY});
				}
				else {
				}
				if (typeof(self.ctrl.on_moved) === "function") {
					self.ctrl.on_moved();
				}
				self.ctrl = null;
				return false;
			};

			jQuery(document).bind("mousemove",mouseMove);
			jQuery(document).bind("mouseup",mouseUp);

			self.ctrl = self.fireEvent("onRequestDropData");
			self.ctrl.position(e.pageX,e.pageY,self.ctrl.width?self.ctrl.width:self.ctrl.getDefaultWidth(),self.ctrl.height?self.ctrl.height:self.ctrl.getDefaultHeight());
			jQuery(self.ctrl.getWnd()).css({
				position:'absolute',
				top:(e.pageY+3)+"px",
				left:(e.pageX+3)+"px",
				zIndex:1500
			});
			self.ctrl._host = null;
			self.ctrl._inPageBody=true;
			document.body.appendChild(self.ctrl.getWnd());
			return false;
		});

		return this.wnd;
	};

	designerTool.prototype.getDefaultWidth=function (){
		return 32;
	};
	designerTool.prototype.getDefaultHeight=function (){
		return 32;
	};
	designerTool.prototype.onRequestDropData=function(fn){
		this.addListener("onRequestDropData",fn);
	};
	
	icc.ui.designerTool = designerTool;
	
})(__icc__);	



(function(icc){
	icc.ui.themes.base.fixedLayoutDesigner = {
		backColor:'transparent',
		foreColor:'black',
		borderColor:'#a0a0a0',
		borderWidth:1,
		overflow:'hidden',
		opacity:100,
		borderStyle:'solid',
		nc_left:0,
		nc_right:0,
		nc_top:0,
		nc_bottom:0,
		grid_05px_img:"resources/g10.png",
		grid_05px_img:"resources/g05.png"
		
	};
	var fixedLayoutDesigner=function(args,environment){
		fixedLayoutDesigner.SUPERconstructor.call(this,args,environment,'fixedLayoutDesigner');
		this.designerContainer = true;
		this.fixedLayoutDesigner = true;
	}
	icc.utils.inherit(fixedLayoutDesigner,icc.ui.designerFrame);
	fixedLayoutDesigner.prototype.positionToGrid=function(pos,event){
		var res ={}
		if(!event.ctrlKey){
			var gridSize = 5;
			var halfGrid = gridSize/2;
			res.x = parseInt(pos.x/gridSize)*gridSize;
			res.y = parseInt(pos.y/gridSize)*gridSize;
			if(pos.x-res.x > halfGrid)
				res.x+=gridSize;
			if(pos.y-res.y > halfGrid)
				res.y+=gridSize;
			return res;
		}else {
			return pos;
		}
	}
	fixedLayoutDesigner.prototype.create = function(){
		fixedLayoutDesigner.SUPERclass.create.call(this);
		if(this.grid_05px_img && !this.background && !this.slice && this.backColor==="transparent" && this.gridbk!==false){
			this.wnd.style.backgroundImage="url("+icc.ui.theApp.getBaseUrl() + this.grid_05px_img  + ")";
	//		jQuery(this.wnd).css({
	//			backgroundPosition:'1px 1px'
	//		});
			if(this.backColor === "transparent")
				this.wnd.style.backgroundColor="white";
			else
				this.wnd.style.backgroundColor=this.backColor;
		}
		for (idx in this.childs){
			this.instrumentateChildControl(this.childs[idx])
		}
		return this.wnd
	}
	fixedLayoutDesigner.prototype.addChild = function(newChild,index) {
		fixedLayoutDesigner.SUPERclass.addChild.call(this,newChild,index);
		this.instrumentateChildControl(newChild,newChild.uiclass=="panel")
		
	}
	fixedLayoutDesigner.prototype.rmvChild = function(child) {
		fixedLayoutDesigner.SUPERclass.rmvChild.call(this,child);
		icc.console.log(this.id + " rmv child "+ child.id);
		
	}
	
	fixedLayoutDesigner.prototype.childPositionHasChanged = function(child,xPos,yPos,event){
		var pos;
		pos = this.positionToGrid({x:xPos,y:yPos},event);
		child.x = pos.x;			
		child.y = pos.y;
	}	
	fixedLayoutDesigner.prototype.startsChildResizing = function(designerHost,child,handler,position){
		var self=this;
		var undoinfo ={x:child.x,y:child.y,width:child.width,height:child.height}
		designerHost.addUndoAction(function(){
			child.x = undoinfo.x;
			child.y = undoinfo.y;
			child.width = undoinfo.width;
			child.height=undoinfo.height;
			self.layout();
			designerHost.fireEvent("onChangeCtrlPosition",[child],null);// Dispara el evento para que se graben las posiciones en el doc
		});
		child.startsResizing(handler,this.positionToGrid(position,designerHost.lastEvent));
		this.layout();
	}
	fixedLayoutDesigner.prototype.stillChildResizing = function(designerHost,child,handler,position){
		child.stillResizing(handler,this.positionToGrid(position,designerHost.lastEvent));
		this.layout();
	}
	fixedLayoutDesigner.prototype.stopsChildResizing = function(designerHost,child,handler,position){
		child.stopsResizing(handler,this.positionToGrid(position,designerHost.lastEvent));
		this.layout();
		designerHost.fireEvent("onChangeCtrlPosition",[child],null);// Dispara el evento para que se graben las posiciones en el doc
		
	}

	fixedLayoutDesigner.prototype.addUndoInfo=function(designerHost,ctrlList){
		var child;
		var self=this;
		var undo_block = new Array;
		for(var idx=0;idx<ctrlList.length;idx++){
		    child = ctrlList[idx];
		    var pos = {x:child.x,y:child.y,height:child.height,width:child.width};
		    undo_block.push({object:child,position:pos})
		}
		designerHost.addUndoAction(function(){
		    var undo_step;
		    var selection = new Array
		    for ( var idx=0;idx<undo_block.length;idx++){
				undo_step = undo_block[idx];
				undo_step.object._x = undo_step.position.x;
				undo_step.object._y = undo_step.position.y;
				undo_step.object._w = undo_step.position.width;
				undo_step.object._h = undo_step.position.height;
				undo_step.object.parent.childPositionHasChanged(undo_step.object,undo_step.position.x,undo_step.position.y,undo_step.position.width,undo_step.position.height);
				undo_step.object.parent.layout();
		    }
		    self.fireEvent("onChangeCtrlPosition",ctrlList,null);// Dispara el evento para que se graben las posiciones en el doc
		})
	}
	fixedLayoutDesigner.prototype.alignToTop = function (designerHost,ctrlList){
	    this.addUndoInfo(designerHost,ctrlList);
	    var y = 1e6;
	    // busquemos el de mas arriba
	    for (var idx = 0;idx<ctrlList.length;idx++){
			y = ctrlList[idx].y<y?ctrlList[idx].y:y;
	    }

	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawUnselected(designerHost,ctrlList[idx])
			ctrlList[idx].y = y;
	    }
	    this.layout();
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawSelected(designerHost,ctrlList[idx])
	    }
	    designerHost.fireEvent("onChangeCtrlPosition",ctrlList,null);
	};
	fixedLayoutDesigner.prototype.alignToBottom = function (designerHost,ctrlList){
	    this.addUndoInfo(designerHost,ctrlList);
	    var y = 0;
	    // busquemos el de mas abajo ( borde inferior )
	    for (var idx = 0;idx<ctrlList.length;idx++){
			y = (ctrlList[idx].y+ctrlList[idx].height)>y?ctrlList[idx].y+ctrlList[idx].height:y;
	    }
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawUnselected(designerHost,ctrlList[idx])
			ctrlList[idx].y = y-ctrlList[idx].height;
	    }
	    this.layout();
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawSelected(designerHost,ctrlList[idx])
	    }
	    designerHost.fireEvent("onChangeCtrlPosition",ctrlList,null);

	};
	fixedLayoutDesigner.prototype.alignToLeft = function (designerHost,ctrlList){
	    this.addUndoInfo(designerHost,ctrlList);
	    var x = 1e6;
	    // busquemos el de mas a la izquierda
	    for (var idx = 0;idx<ctrlList.length;idx++){
			x = ctrlList[idx].x<x?ctrlList[idx].x:x;
	    }

	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawUnselected(designerHost,ctrlList[idx])
			ctrlList[idx].x = x;
	    }
	    this.layout();
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawSelected(designerHost,ctrlList[idx])
	    }
	    designerHost.fireEvent("onChangeCtrlPosition",ctrlList,null);

	};
	fixedLayoutDesigner.prototype.alignToRight = function (designerHost,ctrlList){
	    this.addUndoInfo(designerHost,ctrlList);
	    var x = 0;
	    // busquemos el de mas a la derecha ( borde derecho )
	    for (var idx = 0;idx<ctrlList.length;idx++){
			x = (ctrlList[idx].x+ctrlList[idx].width)>x?ctrlList[idx].x+ctrlList[idx].width:x;
	    }
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawUnselected(designerHost,ctrlList[idx])
			ctrlList[idx].x = x-ctrlList[idx].width;
	    }
	    this.layout();
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawSelected(designerHost,ctrlList[idx])
	    }
	    designerHost.fireEvent("onChangeCtrlPosition",ctrlList,null);
	};
	fixedLayoutDesigner.prototype.alignToHCenter = function (designerHost,ctrlList){
	    this.addUndoInfo(designerHost,ctrlList);
	    var l = 1e6;
	    var r = -1e6;
	    var x;
	    for (var idx = 0;idx<ctrlList.length;idx++){
			r = (ctrlList[idx].x+ctrlList[idx].width)>r?ctrlList[idx].x+ctrlList[idx].width:r;
			l = (ctrlList[idx].x)<l?ctrlList[idx].x:l;
	    }
	    x = parseInt(((r-l)/2)+l,10);
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawUnselected(designerHost,ctrlList[idx])
			ctrlList[idx].x = x-(ctrlList[idx].width/2);
	    }
	    this.layout();
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawSelected(designerHost,ctrlList[idx])
	    }
	    designerHost.fireEvent("onChangeCtrlPosition",ctrlList,null);
	};
	fixedLayoutDesigner.prototype.alignToVCenter = function (designerHost,ctrlList){
	    this.addUndoInfo(designerHost,ctrlList);
	    var b = -1e6;
	    var t = 1e6;
	    var y;
	    for (var idx = 0;idx<ctrlList.length;idx++){
			b = (ctrlList[idx].y+ctrlList[idx].height)>b?ctrlList[idx].y+ctrlList[idx].height:b;
			t = (ctrlList[idx].y)<t?ctrlList[idx].y:t;
	    }
	    y = parseInt(((b-t)/2)+t,10);
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawUnselected(designerHost,ctrlList[idx])
			ctrlList[idx].y = y-(ctrlList[idx].height/2);
	    }
	    this.layout();
	    for (idx = 0;idx<ctrlList.length;idx++){
			this.drawSelected(designerHost,ctrlList[idx])
	    }
	    designerHost.fireEvent("onChangeCtrlPosition",ctrlList,null);
	};
	fixedLayoutDesigner.prototype.sendToFront = function (designerHost,ctrlList){
	    var childs=new Array;
	    var self = this;
	    designerHost.addUndoAction(function(){
			self.childs = childs;
			self.layout();
			designerHost.fireEvent("onZOrderChanged",self);
	    });
	    for (var idx=0;idx<this.childs.length;idx++){
			childs.push(this.childs[idx]);
			for(var k in ctrlList){
				if(this.childs[idx]===ctrlList[k]){
					this.childs.splice(idx,1);
				}
			}
	    }
	    for (idx=0;idx<ctrlList.length;idx++){
			this.childs.push(ctrlList[idx]);
	    }
	    this.layout();
	    designerHost.fireEvent("onZOrderChanged",this);
	};
	fixedLayoutDesigner.prototype.sendToBack = function (designerHost,ctrlList){
	    var childs=new Array;
	    var self = this;
	    designerHost.addUndoAction(function(){
			self.childs = childs;
			self.layout();
			designerHost.fireEvent("onZOrderChanged",self);
	    });

	    for (var idx=0;idx<this.childs.length;idx++){
			childs.push(this.childs[idx]);

			for(var k in ctrlList){
				if(this.childs[idx]===ctrlList[k]){
				this.childs.splice(idx,1);
				}
			}
	    }
	    for (idx=0;idx<ctrlList.length;idx++){
			this.childs.splice(0,0,ctrlList[idx]);
	    }
	    this.layout();
	    designerHost.fireEvent("onZOrderChanged",this);
	};
	fixedLayoutDesigner.prototype.instrumentateHLineBoundControl = function(ctrl){	
	
		ctrl.getHandlers = function (){
			return [
				{number:0,x:ctrl.x-5,y:ctrl.y+(ctrl._h/2)-3,width:5,height:5,cursorName:"w-resize"},
				{number:1,x:ctrl.x+(ctrl._w),y:ctrl.y+(ctrl._h/2)-3,width:5,height:5,cursorName:"w-resize"}
			]
		}
		ctrl.startsResizing = function(handler,toposition){
			ctrl._srcpos={x:ctrl._x,y:ctrl._y,width:ctrl._w,height:ctrl._h};
			ctrl.stillResizing(handler,toposition);
		}	
		ctrl.stopsResizing = function(handler,toposition){
			ctrl.stillResizing(handler,toposition);
			if (ctrl.__onDesignerResize) {
				ctrl.__onDesignerResize();
			}
		}	
		ctrl.stillResizing = function(handler,toposition){
			ctrl.x = ctrl._srcpos.x
			ctrl.y = ctrl._srcpos.y
			ctrl.width = ctrl._srcpos.width
			ctrl.height = ctrl._srcpos.height
			
			switch(handler.number){
				case 0:
					ctrl.x = ctrl._srcpos.x + (toposition.x -ctrl._srcpos.x);
					ctrl.width =ctrl._srcpos.width-(toposition.x -ctrl._srcpos.x);
				break;

				case 1:
					ctrl.width=ctrl._srcpos.width+ (toposition.x -(ctrl._srcpos.x+ctrl._srcpos.width));
				break;
			}
			if(ctrl.width<0){
				ctrl.width*=-1;			
				ctrl.x-=ctrl.width
			
			}
			if(ctrl.height<0){
				ctrl.height*=-1;
				ctrl.y-=ctrl.height;
			}
		}
		ctrl.getLayoutInfo = function (){
			return {
				x:ctrl.x,
				y:ctrl.y,
				width:ctrl.width,
				height:ctrl.height
			}
		}
	};
	fixedLayoutDesigner.prototype.instrumentateVLineBoundControl = function(ctrl){	
		ctrl.getHandlers = function (){
			return [
				{number:0,x:ctrl._x+(ctrl._w/2)-4,y:ctrl._y-5,width:5,height:5,cursorName:"n-resize"},
				{number:1,x:ctrl.x+(ctrl._w/2)-4,y:ctrl.y+ctrl._h,width:5,height:5,cursorName:"n-resize"}	
			]
		}
		ctrl.startsResizing = function(handler,toposition){
			ctrl._srcpos={x:ctrl._x,y:ctrl._y,width:ctrl._w,height:ctrl._h};
			ctrl.stillResizing(handler,toposition);
		}	
		ctrl.stopsResizing = function(handler,toposition){
			ctrl.stillResizing(handler,toposition);
			if (ctrl.__onDesignerResize) {
				ctrl.__onDesignerResize();
			}
		}	
		ctrl.stillResizing = function(handler,toposition){
			ctrl.x = ctrl._srcpos.x
			ctrl.y = ctrl._srcpos.y
			ctrl.width = ctrl._srcpos.width
			ctrl.height = ctrl._srcpos.height
			
			switch(handler.number){
				case 0:
					ctrl.y = ctrl._srcpos.y + (toposition.y -ctrl._srcpos.y);
					ctrl.height=ctrl._srcpos.height-(toposition.y -ctrl._srcpos.y);
				break;

				case 1:
					ctrl.height=toposition.y -ctrl._srcpos.y;
				break;
			}
			if(ctrl.width<0){
				ctrl.width*=-1;
				ctrl.x-=ctrl.width
			
			}
			if(ctrl.height<0){
				ctrl.height*=-1;
				ctrl.y-=ctrl.height;
			}
		}
		ctrl.getLayoutInfo = function (){
			return {
				x:ctrl.x,
				y:ctrl.y,
				width:ctrl.width,
				height:ctrl.height
			}
		}
		
	}
	fixedLayoutDesigner.prototype.instrumentateFlowActivity = function(ctrl){
		ctrl.getHandlers = function (){
			var res = []
			return res
		}
		ctrl.getParentConnectionPoints = function () {
			var res = this.getConnectionPoints();
			for (var i=0;i<res.length;i++){
				res[i].x += this._x;
				res[i].y += this._y;
			}
			return res;
		};
		ctrl.getLayoutInfo = function (){
			var res = {}
			
			if (ctrl.getExtendedLayoutInfo)
				res = ctrl.getExtendedLayoutInfo();
			res.x = ctrl.x;
			res.y = ctrl.y;
			res.width = ctrl.width;
			res.height = ctrl.height;
			return res;
		}
		
	}
	
	fixedLayoutDesigner.prototype.instrumentateRectBoundControl = function(ctrl){
	
		ctrl.getHandlers = function (){
			var number=0;
			var irw=false;
			var irh=false;
			
			if(ctrl.resizable === false){
				irw=true;
				irh=true;
			}
			if(ctrl['resizable-w']===false)
				irw=true;
			if(ctrl['resizable-h']===false)
				irh=true;
				
			
			var bwidth = ctrl.borderWidth;
			if(!bwidth)
				bwidth=0;
			bwidth*=2;
			var res= [];
			if (!ctrl.immovable){
				if(!irh)
					res.push({number:1,x:ctrl._x+((ctrl._w+bwidth)/2)-5,y:ctrl._y-5,width:5,height:5,cursorName:"n-resize"});
				if(!irw)
					res.push({number:7,x:ctrl._x-5,y:ctrl._y+((ctrl._h+bwidth)/2)-2,width:5,height:5,cursorName:"w-resize"});

				if(!irw && !irh){
					res.push({number:0,x:ctrl._x-5,y:ctrl._y-5,width:5,height:5,cursorName:"nw-resize"});
					res.push({number:2,x:ctrl._x+(ctrl._w+bwidth),y:ctrl._y-5,width:5,height:5,cursorName:"ne-resize"});
					res.push({number:6,x:ctrl._x-5,y:ctrl._y+(ctrl._h+bwidth),width:5,height:5,cursorName:"ne-resize"});
				}
			}else {
				if(ctrl['resizable-1'])
					res.push({number:1,x:ctrl._x+((ctrl._w+bwidth)/2)-5,y:ctrl._y-5,width:5,height:5,cursorName:"n-resize"});
			}
			if(!irw || !irh ){
				if(!irw)
					res.push({number:3,x:ctrl._x+(ctrl._w+bwidth),y:ctrl._y+((ctrl._h+bwidth)/2)-2,width:5,height:5,cursorName:"w-resize"});
				if(!irw && !irh)	
					res.push({number:4,x:ctrl._x+(ctrl._w+bwidth),y:ctrl._y+(ctrl._h+bwidth),width:5,height:5,cursorName:"nw-resize"});
				if(!irh && ctrl['resizable-5']!==false)		
					res.push({number:5,x:ctrl._x+((ctrl._w+bwidth)/2)-5,y:ctrl._y+(ctrl._h+bwidth),width:5,height:5,cursorName:"n-resize"});
			}
			
			if((ctrl.designerContainer || ctrl.tabDesigner )&& !ctrl.immovable)
				res.push({number:8,x:ctrl._x+5,y:ctrl._y+5,width:5,height:5,cursorName:"move",type:"face"})
			
			if(ctrl.getCustomHandlers){
				var t = ctrl.getCustomHandlers();
				for (n in t)
					res.push(t[n]);
			}
			return res
		}
		
		ctrl.startsResizing = function(handler,toposition){
			ctrl._srcpos={x:ctrl._x,y:ctrl._y,width:ctrl._w,height:ctrl._h};
			if(ctrl.borderWidth!=undefined){
				ctrl._srcpos.height+=(ctrl.borderWidth*2);
				ctrl._srcpos.width+=(ctrl.borderWidth*2);
			}
			ctrl.stillResizing(handler,toposition);
		}	
		ctrl.stopsResizing = function(handler,toposition){
			ctrl.stillResizing(handler,toposition);
			if (ctrl.__onDesignerResize) {
				ctrl.__onDesignerResize();
			}
		}	
		ctrl.stillResizing = function(handler,toposition){
			
			if(handler.stillResizing){
				handler.stillResizing(handler,toposition)
				
			}else{
				switch(handler.number){
					case 0:
					
						ctrl.x = ctrl._srcpos.x + (toposition.x -ctrl._srcpos.x);
						ctrl.width =ctrl._srcpos.width-(toposition.x -ctrl._srcpos.x);
						ctrl.y = ctrl._srcpos.y + (toposition.y -ctrl._srcpos.y);
						ctrl.height=ctrl._srcpos.height-(toposition.y -ctrl._srcpos.y);

					break;
					case 1:
						if(ctrl['resizable-rev-1-5']){
							ctrl.height = ctrl._srcpos.height
							ctrl.height-=toposition.y -ctrl._srcpos.y;
						}else{
							ctrl.y = ctrl._srcpos.y + (toposition.y -ctrl._srcpos.y);
							ctrl.height=ctrl._srcpos.height-(toposition.y -ctrl._srcpos.y);
						}

					break;
					case 2:
						ctrl.width=ctrl._srcpos.width+ (toposition.x -(ctrl._srcpos.x+ctrl._srcpos.width));
						ctrl.y = ctrl._srcpos.y + (toposition.y -ctrl._srcpos.y);
						ctrl.height=ctrl._srcpos.height-(toposition.y -ctrl._srcpos.y);
					break;
					case 3:
						ctrl.width=ctrl._srcpos.width+ (toposition.x -(ctrl._srcpos.x+ctrl._srcpos.width));
					break;
					case 4:
						ctrl.width=ctrl._srcpos.width+ (toposition.x -(ctrl._srcpos.x+ctrl._srcpos.width));
						ctrl.height=toposition.y -ctrl._srcpos.y;
					break;
					case 5:
						if(ctrl['resizable-rev-1-5']){
							ctrl.y = ctrl._srcpos.y + (toposition.y -ctrl._srcpos.y);
							ctrl.height=ctrl._srcpos.height-(toposition.y -ctrl._srcpos.y);

						}else{
							ctrl.height=toposition.y -ctrl._srcpos.y;
							if(ctrl._y + ctrl.height <= 0){
								if(ctrl._y<0){
									ctrl.height = (0-ctrl._y) +2;
								}else
									ctrl.height = 1;
							}
							  
						}
					break;
					case 6:
						ctrl.x = ctrl._srcpos.x + (toposition.x -ctrl._srcpos.x);
						ctrl.height=toposition.y -ctrl._srcpos.y;
						ctrl.width =ctrl._srcpos.width-(toposition.x -ctrl._srcpos.x);
					break;
					case 7:
						ctrl.x = ctrl._srcpos.x + (toposition.x -ctrl._srcpos.x);
						ctrl.width =ctrl._srcpos.width-(toposition.x -ctrl._srcpos.x);
					break;
					
				}
			}
			if(ctrl.width<0){
				ctrl.width*=-1;			
				ctrl.x-=ctrl.width
			
			}
			if(ctrl.height<0){
				ctrl.height*=-1;
				ctrl.y-=ctrl.height;
			}
		}
		ctrl.getLayoutInfo = function (){
			var res = {}
			
			if (ctrl.getExtendedLayoutInfo)
				res = ctrl.getExtendedLayoutInfo();

			res.x = ctrl.x;
			res.y = ctrl.y;
			res.width = ctrl.width;
			res.height = ctrl.height;
			return res;
		}
	};
	fixedLayoutDesigner.prototype.replaceChild = function( oldChild,newChild){
		fixedLayoutDesigner.SUPERclass.replaceChild.call(this,oldChild,newChild);
		this.instrumentateChildControl(newChild);
	};
		
	fixedLayoutDesigner.prototype.instrumentateChildControl = function ( child ) {
		if(child.uiclass == "hline"){
			this.instrumentateHLineBoundControl(child)
		
		}else if(child.uiclass == "vline"){
			this.instrumentateVLineBoundControl(child)
		}else if(child.uiclass == "flowactivity") {
			this.instrumentateFlowActivity(child);
		}else{
			this.instrumentateRectBoundControl(child)
		}
	};
	
	icc.ui.fixedLayoutDesigner = fixedLayoutDesigner;


	icc.ui.themes.base.horzLayoutDesigner = {
		backColor:'transparent',
		foreColor:'black',
		borderColor:'#a0a0a0',
		borderWidth:1,
		overflow:'hidden',
		opacity:100,
		borderStyle:'solid',
		nc_left:0,
		nc_right:0,
		nc_top:0,
		nc_bottom:0,
		grid_05px_img:"resources/g10.png",
		grid_05px_img:"resources/g05.png"
		
	};
	var horzLayoutDesigner=function(args,environment){
		horzLayoutDesigner.SUPERconstructor.call(this,args,environment,'horzLayoutDesigner');
		this.horzLayoutDesigner = true;
		this.designerContainer = true;
		this.layoutMode="horizontal";
	}
	icc.utils.inherit(horzLayoutDesigner,icc.ui.fixedLayoutDesigner);

	horzLayoutDesigner.prototype.startsSelecting= function(){
	}
	horzLayoutDesigner.prototype.stopsSelecting= function(){
	}
	horzLayoutDesigner.prototype.stillSelecting = function(){
	}

	horzLayoutDesigner.prototype.rmvChild = function ( child ) {
		horzLayoutDesigner.SUPERclass.rmvChild.call(this,child);
		if ( child.__x !== undefined)
			child.x = child.__x
		if ( child.__y !== undefined)
			child.y = child.__y
		if ( child.__width !== undefined)
			child.width = child.__width
		if ( child.__fillWidth !== undefined)
			child.fillWidth = child.__fillWidth;
		child.fillHeight = child.__fillHeight;
		
	}
	
	horzLayoutDesigner.prototype.instrumentateChildControl = function ( ctrl ) {
		horzLayoutDesigner.SUPERclass.instrumentateChildControl.call(this,ctrl);
		if (ctrl.x !==undefined){
			ctrl.__x = ctrl.x
			ctrl.x = undefined;
		}
		if (ctrl.y !==undefined){
			ctrl.__y = ctrl.y
			ctrl.y = undefined;
		}
		ctrl.__fillWidth = ctrl.fillWidth;
		if (ctrl.height !== undefined){
			ctrl.__height = ctrl.height
			ctrl.height = undefined;
		}
		ctrl.__fillHeight=ctrl.fillHeight;
		ctrl.fillHeight = true;
		
		ctrl.getHandlers = function (){
			var bwidth = ctrl.borderWidth;
			if(!bwidth)
				bwidth=0;
			bwidth*=2;
			var res= [];
			if( ctrl['resizable-3']!==false)
				res.push({number:3,x:ctrl._x+(ctrl._w+bwidth),y:ctrl._y+((ctrl._h+bwidth)/2)-2,width:5,height:5,cursorName:"w-resize"});
			if(ctrl.designerContainer && !ctrl.immovable)
				res.push({number:8,x:ctrl._x+5,y:ctrl._y+5,width:5,height:5,cursorName:"move",type:"face"})
			return res
		}
		ctrl.getLayoutInfo = function (){
			return {
				x:ctrl.__x,
				y:ctrl.__y,
				width:ctrl.width,
				height:ctrl.__height,
				fillWidth:ctrl.__fillWidth,
				fillHeight:ctrl.__fillHeight
			}
		}
		
	}
	horzLayoutDesigner.prototype.childPositionHasChanged = function(child,xPos,yPos,event){
	}
	
	icc.ui.horzLayoutDesigner=horzLayoutDesigner;


	icc.ui.themes.base.vertLayoutDesigner = {
		backColor:'transparent',
		foreColor:'black',
		borderColor:'#a0a0a0',
		borderWidth:1,
		overflow:'hidden',
		opacity:100,
		borderStyle:'solid',
		nc_left:0,
		nc_right:0,
		nc_top:0,
		nc_bottom:0,
		grid_05px_img:"resources/g10.png",
		grid_05px_img:"resources/g05.png"
	};
	var vertLayoutDesigner=function(args,environment){
		vertLayoutDesigner.SUPERconstructor.call(this,args,environment,'vertLayoutDesigner');
		this.vertLayoutDesigner = true;
		this.designerContainer = true;
	}
	icc.utils.inherit(vertLayoutDesigner,icc.ui.fixedLayoutDesigner);
	vertLayoutDesigner.prototype.startsSelecting= function(){
	}
	vertLayoutDesigner.prototype.stopsSelecting= function(){
	}
	vertLayoutDesigner.prototype.stillSelecting = function(){
	}

	fixedLayoutDesigner.prototype.moveDn = function (designerHost,ctrl){
	    var childs=new Array;
	    var self = this;
		var pos;
	    designerHost.addUndoAction(function(){
			self.childs = childs;
			self.layout();
			designerHost.fireEvent("onZOrderChanged",self);
	    });
		var changed = false;
	    for (var idx=0;idx<this.childs.length;idx++){
			childs.push(this.childs[idx]);
			if(this.childs[idx]===ctrl && !changed){
				
				this.childs.splice(idx,1);
				this.childs.splice(idx+1,0,ctrl);
				changed = true;
			}
	    }
		designerHost.hideSelection();
	    this.layout();
		designerHost.showSelection();
		
	    designerHost.fireEvent("onZOrderChanged",this);
	};
	fixedLayoutDesigner.prototype.moveUp = function (designerHost,ctrl){
	    var childs=new Array;
	    var self = this;
		var pos;
	    designerHost.addUndoAction(function(){
			self.childs = childs;
			self.layout();
			designerHost.fireEvent("onZOrderChanged",self);
	    });
	    for (var idx=0;idx<this.childs.length;idx++){
			childs.push(this.childs[idx]);
			if(this.childs[idx]===ctrl){
				this.childs.splice(idx,1);
				this.childs.splice(idx-1,0,ctrl);
			}
	    }
		designerHost.hideSelection();
	    this.layout();
		designerHost.showSelection();
		
	    designerHost.fireEvent("onZOrderChanged",this);
	};
	
	vertLayoutDesigner.prototype.rmvChild = function ( child ) {
		vertLayoutDesigner.SUPERclass.rmvChild.call(this,child);
		if ( child.__x !== undefined)
			child.x = child.__x
		if ( child.__y !== undefined)
			child.y = child.__y
		if ( child.__width !== undefined)
			child.width = child.__width
		if ( child.__fillWidth !== undefined)
			child.fillWidth = child.__fillWidth;
		child.fillHeight = child.__fillHeight;
	}
	vertLayoutDesigner.prototype.instrumentateChildControl = function ( ctrl ) {
		vertLayoutDesigner.SUPERclass.instrumentateChildControl.call(this,ctrl);
		if (ctrl.x !==undefined){
			ctrl.__x = ctrl.x
			ctrl.x = undefined;
		}
		if (ctrl.y !==undefined){
			ctrl.__y = ctrl.y
			ctrl.y = undefined;
		}
		ctrl.__fillWidth = ctrl.fillWidth;
		if (ctrl.width !== undefined){
			ctrl.__width = ctrl.width
			ctrl.width = undefined;
			ctrl.__fillWidth = ctrl.fillWidth;
			ctrl.fillWidth = true;
		}
		ctrl.getHandlers = function (){
			var bwidth = ctrl.borderWidth;
			if(!bwidth)
				bwidth=0;
			bwidth*=2;
			var res= [];
			if(!ctrl.immovable  && ctrl['resizable-5']!==false)
				res.push({number:5,x:ctrl._x+((ctrl._w+bwidth)/2)-5,y:ctrl._y+(ctrl._h+bwidth),width:5,height:5,cursorName:"n-resize"});
				
				
			if(ctrl.designerContainer && !ctrl.immovable)
				res.push({number:8,x:ctrl._x+5,y:ctrl._y+5,width:5,height:5,cursorName:"move",type:"face"})
			return res
		}
		ctrl.getLayoutInfo = function (){
			return {
				x:ctrl.__x,
				y:ctrl.__y,
				width:ctrl.__width,
				height:ctrl.height
			}
		}
		
	}
	vertLayoutDesigner.prototype.childPositionHasChanged = function(child,xPos,yPos,event){
	}
	icc.ui.vertLayoutDesigner=vertLayoutDesigner;

})(__icc__);



(function(icc){
	var undefined;
	var tabDesigner=function(args){
		tabDesigner.SUPERconstructor.call(this,args);
		this.tabDesigner = true;
		/*
		var getHandlers = this.getHandlers
		
		this.getHandlers=function(){
			var res = getHandlers.call(this);
			res.unshift({number:10,x:this._x+12,y:this._y+1,width:this._w,height:20,cursorName:"default",type:"front"});
			return res
		}
		*/

	}
	icc.utils.inherit(tabDesigner,icc.ui.tabpanel);
	tabDesigner.prototype.getCustomHandlers = function(){
		return [{number:10,x:this._x+12,y:this._y+1,width:this._w,height:20,cursorName:"default",type:"front"}]
	}
	tabDesigner.prototype.getActivePanel = function(){
		return this.getItem();
	};
	tabDesigner.prototype.hitTest = function ( position,exclude ) {
		var item = this.getItem()
		if(item){
			var hit = item.hitTest(position,exclude);
			if(!hit){
				var pos = item.clientToScreen({x:0,y:0})
				if(	position.x > pos.x && position.x < pos.x+item._w && 
					position.y > pos.y && position.y < pos.x+item._h)
					 return {parent:this.parent,type:"client",tgt:item}
				else	 
					return {parent:this.parent,type:"face",tgt:this}
				
			}
			return hit;
		}else{
			return {parent:this.parent,type:"face",tgt:this}
		}
	}

	tabDesigner.prototype.findContainerAt = function(position,exclude){
		var res
		var item = this.getItem();
		if(item){
			res = item.findContainerAt(position,exclude);
			if(res)
				return res
			else
				return item;
		}
	}
	icc.ui.tabDesigner=tabDesigner;
})(__icc__);

(function(icc){
	var AlignToolbar;
	AlignToolbar=function(formDoc,args){
		var self = this;
		this.btnAlignTop = new icc.ui.button({enabled:false,tooltip:_T('Align to top'),caption:'',icon:'topAlignIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.btnAlignBottom = new icc.ui.button({enabled:false,tooltip:_T('Align to bottom'),caption:'',icon:'bottomAlignIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.btnAlignLeft = new icc.ui.button({enabled:false,caption:'',tooltip:_T('Align to left'),icon:'leftAlignIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.btnAlignRight = new icc.ui.button({enabled:false,caption:'',tooltip:_T('Align to right'),icon:'rightAlignIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.alignHCenter = new icc.ui.button({enabled:false,caption:'',tooltip:_T('Center horizontally'),icon:'middleVerticalAlignIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.alignVCenter = new icc.ui.button({enabled:false,caption:'',tooltip:_T('Center vertically'),icon:'middleHorizontalAlignIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.sendToFront= new icc.ui.button({enabled:false,caption:'',tooltip:_T('Bring to front'),icon:'bringToFrontIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.sendToBack = new icc.ui.button({enabled:false,caption:'',tooltip:_T('Send to back'),icon:'sendToBackIcon.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		args.layoutMode="horizontal";
		AlignToolbar.SUPERconstructor.call(this,formDoc,args);
		this.pt=2;
		this.pb=2;
		this.pr=4;
		this.hs=2;
		this.uniformWidth=true;
		this.uniformHeight=true;

		this.childs=[
			this.btnAlignTop,
			this.btnAlignBottom,
			this.btnAlignLeft,
			this.btnAlignRight,
			this.alignHCenter,
			this.alignVCenter,
			this.sendToFront,
			this.sendToBack
		]
		this.btnAlignTop.onClick(function(){
			self.data[0].parent.alignToTop(self.designerHost,self.data);
		});
		this.btnAlignBottom.onClick(function(){
			self.data[0].parent.alignToBottom(self.designerHost,self.data);
		});
		this.btnAlignLeft.onClick(function(){
			self.data[0].parent.alignToLeft(self.designerHost,self.data);
		});
		this.btnAlignRight.onClick(function(){
			self.data[0].parent.alignToRight(self.designerHost,self.data);
		});
		this.alignHCenter.onClick(function(){
			self.data[0].parent.alignToHCenter(self.designerHost,self.data);
		});
		this.alignVCenter.onClick(function(){
			self.data[0].parent.alignToVCenter(self.designerHost,self.data);
		});
		this.sendToFront.onClick(function(){
			self.data[0].parent.sendToFront(self.designerHost,self.data);
		});
		this.sendToBack.onClick(function(){
			self.data[0].parent.sendToBack(self.designerHost,self.data);
		});
	}

	icc.utils.inherit(AlignToolbar,icc.ui.framework.documentView.view);
	AlignToolbar.prototype.onUpdate=function(sender,hint,data){

		if(hint == "selection"){
			this.data=data;
			var parentIsCapable = true;
			for (n in data){
				if (data[n] && data[n].parent && (data[n].parent.vertLayoutDesigner || data[n].parent.horzLayoutDesigner)){
					parentIsCapable=false
					break
				}
			}
			this.designerHost = sender;
			this.btnAlignTop.setEnabled(data.length>1 && parentIsCapable );
			this.btnAlignBottom.setEnabled(data.length>1 && parentIsCapable);
			this.btnAlignLeft.setEnabled(data.length>1 && parentIsCapable);
			this.btnAlignRight.setEnabled(data.length>1 && parentIsCapable);
			this.alignHCenter.setEnabled(data.length>1 && parentIsCapable);
			this.alignVCenter.setEnabled(data.length>1 && parentIsCapable);
			this.sendToFront.setEnabled(data.length==1 && data[0]['band-type']==undefined && parentIsCapable);
			this.sendToBack.setEnabled(data.length==1 && data[0]['band-type']==undefined && parentIsCapable);
		}
	}
	icc.ui.designer.AlignToolbar = AlignToolbar;

	var verticalPositionToolbar;
	verticalPositionToolbar=function(formDoc,args){
		var self = this;
		this.moveUp= new icc.ui.button({enabled:false,caption:'',tooltip:_T('Move up'),icon:'!butIcoArrowUp.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		this.moveDn = new icc.ui.button({enabled:false,caption:'',tooltip:_T('Move down'),icon:'!butIcoArrowDown.png',height:22,width:22,style:"applications.designer/toolbarbutton"});
		args.layoutMode="horizontal";
		verticalPositionToolbar.SUPERconstructor.call(this,formDoc,args);
		this.pt=2;
		this.pb=2;
		this.pr=4;
		this.hs=2;
		this.uniformWidth=true;
		this.uniformHeight=true;

		this.childs=[
			this.moveUp,
			this.moveDn
		]
		this.moveUp.onClick(function(){
			self.data[0].parent.moveUp(self.designerHost,self.data[0]);
		});
		this.moveDn.onClick(function(){
			self.data[0].parent.moveDn(self.designerHost,self.data[0]);
		});
	}

	icc.utils.inherit(verticalPositionToolbar,icc.ui.framework.documentView.view);
	verticalPositionToolbar.prototype.onUpdate=function(sender,hint,data){

		if(hint == "selection"){
			this.data=data;
			var parentIsCapable = false;
			for (n in data){
				if (data[n] && data[n].parent && data[n].parent.vertLayoutDesigner){
					parentIsCapable=true
					break
				}
		   }
		   this.designerHost = sender;
		   this.moveUp.setEnabled(data.length==1 && data[0]['band-type']==undefined && parentIsCapable);
		   this.moveDn.setEnabled(data.length==1 && data[0]['band-type']==undefined && parentIsCapable);
		}
	}

	icc.ui.designer.verticalPositionToolbar = verticalPositionToolbar;
})(__icc__);


/* global __icc__ */

(function(icc){

	//*************************************	Chat Form Control
	var chatformdesigner = function (args, environment, uiclass) {
		chatformdesigner.SUPERconstructor.call(this, args, environment, uiclass ? uiclass : 'chatformdesigner');
	};
	icc.utils.inherit(chatformdesigner, icc.ui.fixedLayoutDesigner);
	icc.ui.chatformdesigner = chatformdesigner;
	
	//hierarchy from chatformcontainer
	chatformdesigner.prototype.getProperties = icc.ui.chatformcontainer.prototype.getProperties;
	chatformdesigner.prototype._designer = icc.ui.chatformcontainer.prototype._designer;
	chatformdesigner.prototype._makeUI = icc.ui.chatformcontainer.prototype._makeUI;
	chatformdesigner.prototype._setStyle = icc.ui.chatformcontainer.prototype._setStyle;
	chatformdesigner.prototype.setTitle = icc.ui.chatformcontainer.prototype.setTitle;
	chatformdesigner.prototype.getTitle = icc.ui.chatformcontainer.prototype.getTitle;
	chatformdesigner.prototype._setTopButtons = icc.ui.chatformcontainer.prototype._setTopButtons;
	chatformdesigner.prototype.setCloseButtonVisible = icc.ui.chatformcontainer.prototype.setCloseButtonVisible;
	chatformdesigner.prototype.isCloseButtonVisible = icc.ui.chatformcontainer.prototype.isCloseButtonVisible;
	chatformdesigner.prototype.setMinimizeButtonVisible = icc.ui.chatformcontainer.prototype.setMinimizeButtonVisible;
	chatformdesigner.prototype.isMinimizeButtonVisible = icc.ui.chatformcontainer.prototype.isMinimizeButtonVisible;
	chatformdesigner.prototype.setPopupButtonVisible = icc.ui.chatformcontainer.prototype.setPopupButtonVisible;
	chatformdesigner.prototype.isPopupButtonVisible = icc.ui.chatformcontainer.prototype.isPopupButtonVisible;
	chatformdesigner.prototype._getCustomImagePath = icc.ui.chatformcontainer.prototype._getCustomImagePath;
	chatformdesigner.prototype.setIcon = icc.ui.chatformcontainer.prototype.setIcon;
	chatformdesigner.prototype.getIcon = icc.ui.chatformcontainer.prototype.getIcon;
	chatformdesigner.prototype._bindEvents = icc.ui.chatformcontainer.prototype._bindEvents;
	chatformdesigner.prototype._setPosition = icc.ui.chatformcontainer.prototype._setPosition;
	chatformdesigner.prototype._demoPosition = icc.ui.chatformcontainer.prototype._demoPosition;
	chatformdesigner.prototype._setProperties = icc.ui.chatformcontainer.prototype._setProperties;
	chatformdesigner.prototype._loadDesginer = icc.ui.chatformcontainer.prototype._loadDesginer;
	chatformdesigner.prototype.__makeWnd = icc.ui.chatformcontainer.prototype.__makeWnd;
	chatformdesigner.prototype._show = icc.ui.chatformcontainer.prototype._show;
	chatformdesigner.prototype._hide = icc.ui.chatformcontainer.prototype._hide;
	chatformdesigner.prototype.start = icc.ui.chatformcontainer.prototype.start;
	chatformdesigner.prototype.setBrandHeader = icc.ui.chatformcontainer.prototype.setBrandHeader;
	chatformdesigner.prototype.setBrandFooter = icc.ui.chatformcontainer.prototype.setBrandFooter;
	chatformdesigner.prototype.__setHtmlImages = icc.ui.chatformcontainer.prototype.__setHtmlImages;
	chatformdesigner.prototype.isMobile = icc.ui.chatformcontainer.prototype.isMobile;

	chatformdesigner.prototype.destroy = function () {
		chatformdesigner.SUPERclass.destroy.call(this);
	};
	
	chatformdesigner.prototype.__afterCreate = function() {
		this.wnd.style.backgroundImage = null;
		this.wnd.style.backgroundColor = null;
		$(this.wnd).css({
			background	: this.formBackground	|| ""
		});
	};
	
	chatformdesigner.prototype.create = function () {
		chatformdesigner.SUPERclass.create.call(this);
		this.__afterCreate();
	};
	
})(__icc__);


/* This ffile contain control by control the getProperties prototype method.*/
/*jslint evil:true */
/*global escape,__icc__,_T,jQuery
*/

(function(icc){

	var properties={
		caption:{type: 'literal', caption: 'Caption', name: 'caption'},			
		missingvalue:{type: 'literal', caption: 'Missing field', name: 'missing_field_message'},
		invalidvalue:{type: 'literal', caption: 'Invalid value', name: 'invalid_value_message'},

		tabIndex:{type: 'integer', caption: 'TabIndex', name: 'tabIndex'},			

		foreColor:{caption:'Forecolor',type:'color',name:'foreColor'},
		backColor:{caption:'Backcolor',type:'color',name:'backColor'},
		borderWidth:{caption:'BorderWidth',type:'integer',name:'borderWidth'},
		borderColor:{caption:'BorderColor',type:'color',name:'borderColor'},
		align:{caption:'Align',type:'option',name:'align',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'center' ,caption:'center'},{value:'justify' ,caption:'justify'}]},

		language:{caption:'Language',type:'option',name:'language',values:[{value:'en_US',caption:"English"},{value:'es_ES',caption:"Spanish"}]},

		font:{caption:'Font',type:'font'},
		enabled:{caption:'Enabled',type:'bool-true',name:'enabled'},
		datasource:{caption:'Datasource',type:'datasource',name:'datasource'},
		field:{caption:'Field',type:'field',name:'field'},
		required:{caption:'Required',type:'bool',name:'required','false-is-undefined':true},
		multiLine:{caption:'Multiline',type:'bool',name:'multiLine'},
		image:{caption:'Image',type:'image',name:'image'},
		round:{caption:'Round',type:'integer',name:'round'},
		weight:{caption:'Weight',type:'integer',name:'weight'},
		penstyle:{caption:'PenStyle',type:'option',name:'penStyle',values:[{value:'solid',caption:"Solid"},{value:'dotted',caption:"Dotted"},{value:'dashed',caption:"Dashed"},{value:'ridge',caption:"Ridge"},{value:'groove',caption:"Groove"}]},

		visible:{caption:'Visible',type:'bool-true',name:'visible'},
		style:{caption:'Style',type:'style',name:'style'},
		opacity:{caption:'Opacity %',type:'integer',name:'opacity'},
		readonly:{caption:'ReadOnly',type:'bool',name:'readOnly'},
		icon:{caption:'Icon',type:'image',name:'icon'},
		tooltip:{caption:'Tooltip',type:'string',name:'tooltip'},
		htmlclass:{caption:'className',type:'string',name:'className'},
		checkedval:{caption:'Checked value',type:'string',name:'checkedValue'},
		uncheckedval:{caption:'Unchecked value',type:'string',name:'uncheckedValue'},
		csvexportFormat:{caption:'Export format',type:'custom',name:'exportFormat',customfn:function(document,ctrlData,cb){
			<%FRAME:dataImportExportAssets.csvExport%>
			//csvExportColumnsTree,csvExportAddColumn,csvExportRmvColumn,csvExportColumnsGrid
			//csvExportUpColumn,csvExportDnColumn,csvExportColumnName,csvExportUpColumnFormat,
			//csvExportOk,csvExportCancel
			csvExportColumnsTree.borderColor = "#d6d6d6";
			csvExportColumnsGrid.borderColor = "#d6d6d6";

			var fieldMap = {} ; // hash para saber si un campo del datasource ya esta en la lista de los exportados;
			var gridItems = [];
			var roots = {};
			var propertyData = icc.utils.clone(ctrlData.exportFormat || {});

			if( ctrlData.exportFormat !== undefined ){
				for (var k in propertyData.columns){
					fieldMap[ctrlData.exportFormat.columns[k].id] = ctrlData.exportFormat.columns[k];
				}
			}

			var loadTree = function(cb){
				var dshash={};
				var items=[];
				var app = document.getApplicationDocument();
				var datasources = app.getDatasources();
				for (k in datasources){
					dshash[datasources[k].name]=datasources[k].name;
				}
				var listed_ds={};
				var buildDSTreeData = function(dsName,cb){
					var dsdoc = new icc.ui.designer.datasourceDoc(app.getVCCName(), app.getId(),dsName);
					var ds_node = {caption:dsdoc.getName(),id:dsName,items:[],in_tree:false};
					roots[dsdoc.getName()]=ds_node;

					var addDSFieldsAndChilds = function (dsdoc,ds_node,cb){
						if(!listed_ds[dsName]){
							listed_ds[dsName]=dsName;

							dsdoc.load(function (status) {

								if (status) {
									var fields = dsdoc.getFields();
									if (dsName == ctrlData.datasource && ctrlData.exportFormat === undefined){
										propertyData = {columns:[]};
										
										for (k in fields){
											propertyData.columns.push(
												{	id:dsName +"." +fields[k].name,
													caption:dsName +"." +fields[k].name,
													name:fields[k].name,
													datasource:dsName
												}
											);
											gridItems.push(
												{
													id:dsName +"." + fields[k].name,
													caption:dsName +"." + fields[k].name,
													name:fields[k].name,
													datasource:dsName,
													tree_node:ds_node
												}
											);
											fieldMap[dsName +"." + fields[k].name]=true;
										}
									}
									for (k in fields){
										if(!fieldMap[dsName +"." + fields[k].name]){
											ds_node.items.push({id:dsName +"." + fields[k].name,caption:fields[k].name,name:fields[k].name,datasource:dsName,tree_node:ds_node});
										}
									}
									if(ds_node.items.length>0){
										items.push(ds_node);
										ds_node.in_tree=false;
									}

									var relation_ships = dsdoc.getConfigData().description.relationships;
									var dsstack=[];
									for (k in relation_ships){
										var relation_ship = relation_ships[k];
										if (relation_ship.datasourceName  && dshash[relation_ship.datasourceName]){
											dsstack.push(relation_ship.datasourceName);
										}
									}
									var nextRelationshipDS = function (cb){
										var dsName = dsstack.shift();
										if (dsName){
											buildDSTreeData(dsName,function(node){
												//ds_node.items.push(node);
												//items.push(node);
												nextRelationshipDS(cb);
											});
										}else
											cb();
									};
									nextRelationshipDS(cb);
									
								}else
									cb();
							});
							
						}else
							cb();
					};
					addDSFieldsAndChilds(dsdoc,ds_node,
						function (){
							cb(ds_node);
						}
					);
				};
				if(ctrlData.datasource){
					buildDSTreeData(ctrlData.datasource ,function(dsnode){
						if(ctrlData.exportFormat !== undefined){ // si hay datos agregamos las exporteds a la lista
							for (k in propertyData.columns){
								var item = icc.utils.clone(propertyData.columns[k]);
								item.caption = item.datasource + "." + item.name;
								if (item.alias){
									item.caption += " (" + item.alias + ")";
								}
								item.tree_node= roots[item.datasource];
								gridItems.push(item);
							}
						}
						csvExportColumnsTree.addItem(items);
						csvExportColumnsGrid.addItem(gridItems);
					});
				}
			};

			var dlg = new icc.ui.dialog({
				caption:_T('Export format'),
				childs:[
					csvExport
				]
			});

			optCSVExportDelimiterComa.checked = propertyData.delimiter === undefined || propertyData.delimiter === ',';
			optCSVExportDelimiterTab.checked = propertyData.delimiter === '\t';
			optCSVExportDelimiterSemicolon.checked = propertyData.delimiter === ';';
			if(	propertyData.delimiter != ',' && 
				propertyData.delimiter != '\t' && 
				propertyData.delimiter != ';' && 
				propertyData.delimiter != undefined){
					optCSVExportDelimiterOther.checked = true;
					txCSVExportDelimiterOther.enabled = true;
					txCSVExportDelimiterOther.text = propertyData.delimiter;
			}
			optCSVExportDelimiterComa.onChange(function(value){
				if(value)
					propertyData.delimiter = ',';
			});
			optCSVExportDelimiterTab.onChange(function(value){
				if(value)
					propertyData.delimiter = '\t';
			});
			optCSVExportDelimiterSemicolon.onChange(function(value){
				if(value)
					propertyData.delimiter = ';';
			});
			optCSVExportDelimiterOther.onChange(function(value){
				txCSVExportDelimiterOther.setEnabled(value);
				if(!value){
					propertyData.delimiter = undefined;
					txCSVExportDelimiterOther.setText("");
				}
			});
			txCSVExportDelimiterOther.onChange(function(value){
				propertyData.delimiter = value;
			});
			ckCSVExportBOM.checked = propertyData.withBOM;
			ckCSVExportBOM.onChange(function(value){
				propertyData.withBOM = value;
			});
			ckCSVExportFirstRow.checked = propertyData.firstRowHaveColumnNames === true || propertyData.firstRowHaveColumnNames === undefined;
			ckCSVExportFirstRow.onChange(function(value){
				propertyData.firstRowHaveColumnNames=value;
			});
			csvExportOk.onClick(function(){
				if(txCSVExportDelimiterOther.performValidation(true).code == 0){
					dlg.close();
					cb(propertyData);
				}
			});
			csvExportCancel.onClick(function(){
				dlg.close();
				cb();
			});

			csvExportColumnsGrid.onChange(function(item){
				csvExportRmvColumn.setEnabled(item !== undefined);
				csvExportUpColumn.setEnabled(item!==undefined && this.getIndex()>0);
				csvExportDnColumn.setEnabled(item!==undefined && this.getIndex()<propertyData.columns.length-1);
				csvExportColumnName.setEnabled(item!==undefined);
				csvExportColumnName.setText(item.alias || item.name);
			});
			csvExportColumnName.onChange(function(value){
				var idx = csvExportColumnsGrid.getIndex();
				var item = csvExportColumnsGrid.getItem();
				item.alias = value;
				if(value!=undefined && value != '' && value != item.name){
					item.caption = item.datasource + "." + item.name + " (" +value +")";
					item.alias = value;
					propertyData.columns[idx].alias = value;
				}else{
					item.caption = item.datasource + "." + item.name; 
					item.alias = undefined;
					propertyData.columns[idx].alias = undefined;
				}
				propertyData.columns[idx].alias = value;
				csvExportColumnsGrid.updateItem(item);
			});
			csvExportColumnsTree.onChange(function(item){
				csvExportAddColumn.setEnabled(item !== undefined);
			});
			csvExportRmvColumn.onClick(function(){
				var item = csvExportColumnsGrid.getItem();
				fieldMap[item.id]=undefined;
				if(!item.tree_node.in_tree){
					csvExportColumnsTree.addItem(item.tree_node);
					item.tree_node.in_tree = true;
				}
				csvExportColumnsGrid.rmvItem(item);
				item.caption = item.name;
				csvExportColumnsTree.addItem(item,item.tree_node);
				csvExportRmvColumn.setEnabled(false);
				for (k in propertyData.columns){
					if (propertyData.columns[k].id == item.id)
						propertyData.columns.splice(parseInt(k),1);
				}
				csvExportUpColumn.setEnabled(false);
				csvExportDnColumn.setEnabled(false);
				csvExportColumnName.setEnabled(false);
			});
			csvExportAddColumn.onClick(function(){
				var item = csvExportColumnsTree.getItem();
				var addColumn = function(item){
					fieldMap[item.id]=true;
					item.caption = item.id;
					propertyData.columns.push(
						{	id:item.id,
							alias:item.alias,
							name:item.name,
							datasource:item.datasource
						}
					);
					csvExportColumnsGrid.addItem(item);
				};
				if(item.items){
					for (k in item.items){
						addColumn(item.items[k]);
					}
					item.in_tree = false;
					csvExportColumnsTree.rmvItem(item);
					csvExportAddColumn.setEnabled(csvExportColumnsTree.getItem() !== undefined);
				}else{
					addColumn(item);
					var p = csvExportColumnsTree.getParent(item);
					csvExportColumnsTree.rmvItem(item);
					if(p.items.length == 0){
						p.in_tree = false;
						csvExportColumnsTree.rmvItem(p);
					}
					csvExportAddColumn.setEnabled(csvExportColumnsTree.getItem() !== undefined);
				}
				csvExportDnColumn.setEnabled(csvExportColumnsGrid.getItem() !== undefined);
			});
			var refillGridItems = function(){	// Partiendo de la lista de columnas recarga el grid
												// solo para re ordenar columnas
				for (k in propertyData.columns){
					var item = icc.utils.clone(propertyData.columns[k]);
					item.caption = item.datasource + "." + item.name;
					if (item.alias){
						item.caption += " (" + item.alias + ")";
					}
					
					item.tree_node= roots[item.datasource];
					csvExportColumnsGrid.addItem(item);
				}
			};
			csvExportUpColumn.onClick(function(){
				var item;
				var idx = csvExportColumnsGrid.getIndex();
				if(idx>0){
					item = propertyData.columns[idx];
					propertyData.columns[idx]=propertyData.columns[idx-1];
					propertyData.columns[idx-1]=item;
					csvExportColumnsGrid.clearAll();
					refillGridItems();
					csvExportColumnsGrid.setIndex(idx-1);
					csvExportUpColumn.setEnabled(csvExportColumnsGrid.getIndex()>0);
					csvExportDnColumn.setEnabled(csvExportColumnsGrid.getIndex()<propertyData.columns.length-1);
				}
			});
			csvExportDnColumn.onClick(function(){
				var item;
				var idx = csvExportColumnsGrid.getIndex();
				if(idx<propertyData.columns.length-1){
					item = propertyData.columns[idx];
					propertyData.columns[idx]=propertyData.columns[idx+1];
					propertyData.columns[idx+1]=item;
					csvExportColumnsGrid.clearAll();
					refillGridItems();
					csvExportColumnsGrid.setIndex(idx+1);
					csvExportUpColumn.setEnabled(csvExportColumnsGrid.getIndex()>0);
					csvExportDnColumn.setEnabled(csvExportColumnsGrid.getIndex()<propertyData.columns.length-1);
				}
			});
			dlg.onCreate(function(){
				loadTree();
			});
			dlg.create();
			dlg.showModal();
		}},
		
		geometry2:{caption:'Geometry',type:'group',
			brief_fn:function(data){
				return (data['x']!==undefined?data['x']:0)+';'+(data['y']!==undefined?data['y']:0)+' '+(data['width']!==undefined?data['width']:0)+"X"+(data['height']!==undefined?data['height']:0);
			},
			childs:[
				{caption:'x',type:'geometry',name:'x'},
				{caption:'y',type:'geometry',name:'y'},

				{caption:'Width',type:'geometry',name:'width'},
				{caption:'Height',type:'geometry',name:'height'},
				{
					caption:'Horizontal',type:'option',values:[
						{caption:'Left',name:'sideLeft',value:true},
						{caption:'Centered',name:'centerX',value:true},
						{caption:'Right',name:'sideRight',value:true}
					]
				},
				{
					caption:'Vertical',type:'option',values:[
						{caption:'Top',name:'sideTop',value:true},
						{caption:'Centered',name:'centerY',value:true},
						{caption:'Bottom',name:'sideBottom',value:true}
					]
				},
				{caption:'FillWidth',type:'bool',name:'fillWidth'},
				{caption:'FillHeight',type:'bool',name:'fillHeight'},
//				{caption:'Min Width',type:'integer',name:'minWidth'},
//				{caption:'Min Height',type:'integer',name:'minHeight'},
				
				{caption:'GrowVertically',type:'bool',name:'canGrowVertically'},
				{caption:'ShrinkVertically',type:'bool',name:'canShrinkVertically'},
				{caption:'GrowHorizontally',type:'bool',name:'canGrowHorizontally'},
				{caption:'ShrinkHorizontally',type:'bool',name:'canShrinkHorizontally'},
				{caption:'Padding Left',type:'integer',name:'paddingLeft'},
				{caption:'Padding Top',type:'integer',name:'paddingTop'},
				{caption:'Padding Right',type:'integer',name:'paddingRight'},
				{caption:'Padding Bottom',type:'integer',name:'paddingBottom'},
/*		
				{caption:'Padding',type:'group',
					brief_fn:function(data){
						return (data['paddingLeft'] || 0) + " " + (data['paddingTop'] || 0) + " " + (data['paddingRight'] || 0) + " "+(data['paddingBottom'] || 0)
					},
					childs:[
						{caption:'Left',type:'integer',name:'paddingLeft'},
						{caption:'Top',type:'integer',name:'paddingTop'},
						{caption:'Right',type:'integer',name:'paddingRight'},
						{caption:'Bottom',type:'integer',name:'paddingBottom'},
						{type:'endgroup'}
					]
				},
*/				
				{type:'endgroup'}

			]
		},
		geometry:{caption:'Geometry',type:'group',
			brief_fn:function(data){
				return (data['x']!==undefined?data['x']:0)+';'+(data['y']!==undefined?data['y']:0)+' '+(data['width']!==undefined?data['width']:0)+"X"+(data['height']!==undefined?data['height']:0);
			},
			childs:[
				{caption:'x',type:'geometry',name:'x'},
				{caption:'y',type:'geometry',name:'y'},
				{caption:'Width',type:'geometry',name:'width'},
				{caption:'Height',type:'geometry',name:'height'},
				{type:'endgroup'}
			]
		},
		background:{caption:'Background',type:'group',
			brief_fn:function(data){
				if(!data['background'])
					return ""
				else
					return (data['background']+(data['backgroundRepeat']== undefined?"":" "+data['backgroundRepeat'])+(data['backgroundPosition']== undefined?"":" "+data['backgroundPosition']));
			},
			childs:[
				{caption:'Image',type:'image',name:'background'},
				{caption:'Repeat',type:'option',values:[{value:'no-repeat' ,caption:'no-repeat'},{value:'repeat-x' ,caption:'repeat-x'},{value:'repeat-y' ,caption:'repeat-y'}],name:'backgroundRepeat'},
				{caption:'Position',type:'string',name:'backgroundPosition'},
				{type:'endgroup'}
			]
		},
		listitems:{caption:'Items',type:'custom',name:'items',customfn:function(document,ctrlData,cb){
			<%FRAME:assets.comboItems%>
			var items = icc.utils.clone(ctrlData.items || []);
			var t = [];
			for (i=0;i<items.length;i++){
				t.push(items[i].text);
			}
			comboItemsText.text = t.join("\n");
			var dlg = new icc.ui.dialog({
				caption:_T('Items editor'),
				childs:[
					comboItems
				]
			});
			comboItemsCancel.onClick(function(){
				dlg.close();
				if(cb){
					cb();
				}
			});
			comboItemsOk.onClick(function(){
				dlg.close();
				if(cb){
					t = icc.utils.trim(comboItemsText.getText());
					if(t.length){
						t = t.split("\n");
						items=[];
						for (i=0;i<t.length;i++){
							items.push({id:t[i],text:t[i]})
						}
						cb(items);
					}else{
						cb(null);
					}
				}
			});
			dlg.create();
			dlg.showModal();
		}},
		menuitems:{caption:'Items',type:'custom',name:'items',customfn:function(document,ctrlData,cb){
			<%FRAME:assets.treeItems%>
			var dlg = new icc.ui.dialog({
				caption:_T('Tree editor'),
				childs:[
					treeItems
				]
			});

			dlg.onCreate(function(){
				// rellena la lista de containers
				// 
				var t = [];
				jQuery.each(document.getContainers(),function(idx,cnt){
					t.push({text:cnt.id});
				});
				tree_cb_viewIntoTarget.addItem(t);
				// rellena la lista de views
				// 
				t = [];
				jQuery.each(document.getApplicationDocument().getViews(),function(idx,view){
					t.push({text:view.name});
				});
				jQuery.each(document.getApplicationDocument().getReports(),function(idx,view){
					t.push({text:view.name});
				});

				tree_cb_actView.addItem(t);
			});
			var updateActControlsState = function(){
				var item = tree_treeMnu.getItem();
				tree_opt_actNone.setChecked(item && item._action ===undefined);
				tree_opt_actView.setChecked(item && item._action ==="view");
				tree_opt_viewAsPopup.setChecked(item && item.viewMode === "popup");
				tree_opt_viewIntoTarget.setChecked(item && item.viewMode === "target");

				tree_opt_actNone.setEnabled(item!==undefined);
				tree_opt_actView.setEnabled(item!==undefined );

				tree_cb_actView.setEnabled(item!==undefined && tree_opt_actView.getChecked());
				tree_opt_viewAsPopup.setEnabled(item!==undefined && tree_opt_actView.getChecked());
				tree_opt_viewIntoTarget.setEnabled(item!==undefined && tree_opt_actView.getChecked());
				tree_cb_viewIntoTarget.setEnabled(item!==undefined && tree_opt_actView.getChecked() && tree_opt_viewIntoTarget.getChecked() );

				tree_cb_actView.setItem(item!==undefined && tree_opt_actView.getChecked()?item.view:-1);
				tree_cb_viewIntoTarget.setItem(item!==undefined && tree_opt_actView.getChecked()?item.target:-1);

				tree_btRmv.setEnabled(item!==undefined);
				tree_btAddSubItem.setEnabled(item!==undefined);
				tree_txCaption.setEnabled(item!==undefined);
				tree_txMenuId.setEnabled(item!==undefined);
				tree_txIcon.setEnabled(item!==undefined);
				tree_txIconOpen.setEnabled(item!==undefined);

				if(item){
					tree_txCaption.setText(item.caption);
					tree_txMenuId.setText(item.menu_id);
					tree_itemIcon.setImage(item.icon);
					tree_itemIconOpen.setImage(item.iconOpen);
					tree_txIcon.setText(item.icon);
					tree_txIconOpen.setText(item.iconOpen);
				}else{
					tree_txCaption.setText("");
					tree_txMenuId.setText("");
					tree_itemIcon.setImage(undefined);
					tree_itemIconOpen.setImage(undefined);
					tree_txIcon.setText("");
					tree_txIconOpen.setText("");
				}
			};
			tree_opt_actNone.onChange(function(value){
				if(value){
					tree_treeMnu.getItem()._action = undefined;
					updateActControlsState();
				}
			});
			tree_cb_actView.onChange(function(idx,text,item){
				tree_treeMnu.getItem().view = text;
			});
			tree_cb_viewIntoTarget.onChange(function(idx,text,item){
				tree_treeMnu.getItem().target = text;
			});
			tree_opt_actView.onChange(function(value){
				if(value){
					tree_treeMnu.getItem()._action = "view";
					var item = tree_cb_actView.getItem();
					if(item){
						tree_treeMnu.getItem().view = item.text;
					}else{
						tree_treeMnu.getItem().view = "";
					}
					updateActControlsState();
				}
			});
			tree_opt_viewAsPopup.onChange(function(value){
				if(value){
					tree_treeMnu.getItem().viewMode = "popup";
					updateActControlsState();
				}
			});
			tree_opt_viewIntoTarget.onChange(function(value){
				if(value){
					var item = tree_cb_viewIntoTarget.getItem();
					tree_treeMnu.getItem().viewMode = "target";
					if(item){
						tree_treeMnu.getItem().target = item.text;
					}else{
						tree_treeMnu.getItem().target = "";
					}
					updateActControlsState();
				}
			});
			var mask_items = function(items){
				jQuery(items).each(function(idx,item){
					item.menu_id = item.id;
					item._action = item.action;
					item.action = undefined;
					if(item.items!==undefined)
						mask_items(item.items);
				});
			};
			var t = icc.utils.clone(ctrlData.items);
			mask_items(t);
			tree_treeMnu.items = icc.utils.clone(t);
			tree_treeMnu._appName=document.getApplicationDocument().getName();
			tree_treeMnu.onChange(function(item){
				updateActControlsState();
			});

			tree_txCaption.onChange(function(value){
				tree_treeMnu.getItem().caption = value;
				tree_treeMnu.updateItem(tree_treeMnu.getItem());
			});
			tree_txMenuId.onChange(function(value){
				tree_treeMnu.getItem().menu_id = value;
			});
			tree_btCancel.onClick(function(){
				dlg.close();
				if(cb){
					cb();
				}
			});
			var umask_items = function(items){
				jQuery(items).each(function(idx,item){
					item.id = item.menu_id;
					item.action = item._action;
					if(item.items!==undefined)
						umask_items(item.items);
				});
			};
			tree_btOk.onClick(function(){
				dlg.close();
				if(cb){
					var items =tree_treeMnu.getItems();
					umask_items(items);
					cb(items);
				}
			});
			tree_btApply.onClick(function(){
				if(cb){
					var items =icc.utils.clone(tree_treeMnu.getItems());
					umask_items(items);
					cb(items);
				}
			});
			tree_btAddItem.onClick(function(){
				var item = {caption :_T("New item"),viewMode:"popup"};
				tree_treeMnu.addItem(item,"root");

				tree_txCaption.setFocus();
				tree_treeMnu.setItem(item);
				updateActControlsState();
			});
			tree_btAddSubItem.onClick(function(){
				var item = {caption :_T("New item"),viewMode:"popup"};
				tree_treeMnu.addItem(item,tree_treeMnu.getItem());
				tree_treeMnu.setItem(item);
				tree_txCaption.setFocus();
				updateActControlsState();
			});

			tree_btRmv.onClick(function(){
				var item = tree_treeMnu.getItem();
				if (item){
					tree_treeMnu.rmvItem(item);
				}
				updateActControlsState();
			});
			var selectIcon = function (imageCtrl,inputCtrl,propertyName){
				var item = tree_treeMnu.getItem();
				if(item){
					var dlg = new icc.ui.designer.imageSelector(document.getApplicationDocument(),item[propertyName]);
					dlg.create();
					dlg.showModal(function(value){
						if(value){
							imageCtrl.setImage(value.image);
							inputCtrl.setText(value.image);
							item[propertyName] = value.image;
							tree_treeMnu.updateItem(item);
						}
					});
				}
			};
			tree_itemIcon._appName=document.getApplicationDocument().getName();
			tree_itemIcon.onClick(function(){
				selectIcon(this,tree_txIcon,"icon");
			});
			tree_txIcon.onChange(function(value){
				value = icc.utils.trim(value);
				value = value!==''?value:undefined;
				tree_itemIcon.setImage(value);
				tree_treeMnu.getItem().icon=value;
				tree_treeMnu.updateItem(tree_treeMnu.getItem());
			});
			tree_itemIconOpen._appName=document.getApplicationDocument().getName();
			tree_itemIconOpen.onClick(function(){
				selectIcon(this,tree_txIconOpen,"iconOpen");
			});
			tree_txIconOpen.onChange(function(value){
				value = icc.utils.trim(value);
				value = value!==''?value:undefined;
				tree_itemIconOpen.setImage(value);
				tree_treeMnu.getItem().iconOpen=value;
				tree_treeMnu.updateItem(tree_treeMnu.getItem());
			});
			dlg.create();
			dlg.showModal();
		}}
	}
	
	function cleanProperties(properties) {
		var cleaned = [];
		for (var i = 0; i < properties.length; i++) {
			var property = properties[i];
			if (property) {
				cleaned.push(property);
			}
		}
		return cleaned;
	}
	icc.ui.cleanProperties = cleanProperties;
	
	function getAppClass(formDoc) {
		return formDoc && formDoc.appDoc && formDoc.appDoc.catalog && formDoc.appDoc.catalog.appClass || "";
	}
	
	function addContextInfoProperties(formDoc, properties) {
		var cleaned = [];
		for (var i = 0; i < properties.length; i++) {
			var property = properties[i];
			if (property === "CONTEXT_INFO") {
				var appClass = getAppClass(formDoc);
				if (appClass === "contactform" || appClass === "chatcampaign" || appClass === "webcallcampaign") {
					cleaned.push({ caption: 'Context Info', type: 'group', brief_fn:function(data){ return ""; } });
					cleaned.push({ caption: 'Label', type: 'string', name: 'contextInfoLabel' });
					cleaned.push({ caption: 'Hidden', type: 'bool', name: 'contextInfoHidden' });
					cleaned.push({ type: 'endgroup' });
				}
			}
			else {
				cleaned.push(property);
			}
		}
		return cleaned;
	}
	icc.ui.addContextInfoProperties = addContextInfoProperties;	
	
	icc.ui.controlproperties = properties;
	icc.ui.designer.controlproperties = properties;

	icc.ui.grid.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		{
			caption:'Columns',type:'custom',name:'columns',customfn:function(document,ctrlData,cb){
				var items=  [];
				var fields; // campos del datasource si es que hay
				<%FRAME:assets.gridColumns%>
				var fillItems = function(){
					for (var idx=0;idx<ctrlData.columns.length;idx++){
						columnsGrid.addItem({caption:ctrlData.columns[idx].caption,ptr:ctrlData.columns[idx]});
					}
				}
				var dlg = new icc.ui.dialog({
					caption:_T('Grid columns settings'),
					childs:[
						gridColumns
					]
				});
				columnsGrid.onChange(function(item){
					btRmv.setEnabled(item!==undefined);
					btUp.setEnabled(item!==undefined && this.getIndex()>0);
					btDn.setEnabled(item!==undefined && this.getIndex()<ctrlData.columns.length-1);

					if(item){
						txCaption.setText(item.caption);
						txWidth.setText(item.ptr.width);
						txField.setText(item.ptr.field);
						txCaption.setEnabled(true);
						txWidth.setEnabled(true);
						txField.setEnabled(true);
					}
				});
				txCaption.onChange(function(value){
					columnsGrid.getItem().caption = value;
					columnsGrid.getItem().ptr.caption = value;
					columnsGrid.updateItem(columnsGrid.getItem());
				});
				txWidth.onChange(function(value){
					columnsGrid.getItem().ptr.width = parseInt(value,10);
				});
				txField.onChange(function(value){
					columnsGrid.getItem().ptr.field= value;
				});
				btCancel.onClick(function(){
					dlg.close();
					if(cb){
						cb();
					}
				});
				btOk.onClick(function(){
					dlg.close();
					if(cb){
						cb(ctrlData.columns);
					}
				});
				btApply.onClick(function(){
					if(cb){
						cb(ctrlData.columns);
					}
				});
				btUp.onClick(function(){
					var item;
					var idx = columnsGrid.getIndex();
					if(idx>0){
						item = ctrlData.columns[idx]
						ctrlData.columns[idx]=ctrlData.columns[idx-1]
						ctrlData.columns[idx-1]=item;
						columnsGrid.clearAll();
						fillItems();
						columnsGrid.setIndex(idx-1);
						btUp.setEnabled(columnsGrid.getIndex()>0);
						btDn.setEnabled(columnsGrid.getIndex()<ctrlData.columns.length-1);
					}
				})
				btDn.onClick(function(){
					var item;
					var idx = columnsGrid.getIndex();
					if(idx<ctrlData.columns.length-1){
						item = ctrlData.columns[idx]
						ctrlData.columns[idx]=ctrlData.columns[idx+1]
						ctrlData.columns[idx+1]=item;
						columnsGrid.clearAll();
						fillItems();
						columnsGrid.setIndex(idx+1);
						btUp.setEnabled(columnsGrid.getIndex()>0);
						btDn.setEnabled(columnsGrid.getIndex()<ctrlData.columns.length-1);
					}
				})

				btAdd.onClick(function(){
					var newcol = {caption:_T('New column'),field:'',width:100};
					var newItem = {caption:newcol.caption,ptr:newcol};
					ctrlData.columns.push(newcol);
					columnsGrid.addItem(newItem);
					txCaption.setText(newcol.caption);
					txWidth.setText(newcol.width);
					txField.setText(newcol.field);
					txCaption.setEnabled(true);
					txWidth.setEnabled(true);
					txField.setEnabled(true);
					columnsGrid.setItem(newItem);
					columnsGrid.setItem(newItem);
					btUp.setEnabled(columnsGrid.getIndex()>0);
					btDn.setEnabled(columnsGrid.getIndex()<ctrlData.columns.length-1);
				});
				btRmv.onClick(function(){
					var item = columnsGrid.getItem();
					if(item){
						columnsGrid.rmvItem(item);
						txCaption.setText("");
						txWidth.setText("");
						txField.setText("");
						for (var idx=0;idx<ctrlData.columns.length;idx++){
							if(ctrlData.columns[idx]===item.ptr){
								ctrlData.columns.splice(idx,1);
							}
						}
						txCaption.setEnabled(false);
						txWidth.setEnabled(false);
						txField.setEnabled(false);
						btUp.setEnabled(false);
						btDn.setEnabled(false);
					}
				});
				var colWidth = function(field){
					switch(field.type){
						case 'date':
						case 'datetime':
							return 80
						break;
						
						case 'integer':
							return 70
						break
						case 'currency':
						case 'numeric':
						case 'fixed':
							return 80
						break;
						case 'text':
							return 180
						break;
						case 'string':
							if(field.maxLength==undefined)
								return 180;
							var r = field.maxLength * 8;
							if (r > 380){
								r = 380;
							}
							return r
							
						break
					}
					return 100;
				}
				btFill.onClick(function(){
					columnsGrid.clearAll();
					txCaption.setText("");
					txWidth.setText("");
					txField.setText("");
					txCaption.setEnabled(false);
					txWidth.setEnabled(false);
					txField.setEnabled(false);
					btUp.setEnabled(false);
					btDn.setEnabled(false);
					jQuery(fields).each(function(_,field){
						ctrlData.columns.push(
							{caption:field.name,field:field.name,width:colWidth(field)}
						);
					});
					columnsGrid.clearAll();
					fillItems();
				});
				dlg.onCreate(function(){
					fillItems();
					// al iniciar comprobamos obtenemos los datos del datasource y prendemos el boton
					if (ctrlData.datasource) {
						var app = document.getApplicationDocument();
						var datasources = app.getDatasources({outstreams:true});
						for (var i = 0;i < datasources.length;i++) {
							if (datasources[i].name === ctrlData.datasource) {
								var dsdoc = new icc.ui.designer.datasourceDoc(app.getVCCName(), app.getId(), ctrlData.datasource);
								dsdoc.load(function (status) {
									if (status) {
										fields = dsdoc.getFields();
										btFill.setEnabled(true);
									}
								})
							}
						}
					}
				});
				dlg.create();
				dlg.showModal();
			}
		},
		properties.datasource,
		{caption:'Header',type:'bool-true',name:'haveHeader'},
		properties.borderWidth,
		properties.borderColor,
		properties.enabled,
		properties.visible,
		properties.style,
		properties.htmlclass
	];
};


////////////////////////////////////////////////////////////////////////////////////////////////////////
icc.ui.tabpanel.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		{caption:'Initial tab',type:'integer',name:'item'},
		{caption:'Tabs',type:'custom',name:'childs',customfn:function(document,ctrlData,cb){
			var items=  [];
			<%FRAME:assets.tabItems%>
			var fillItems = function(){
				for (var idx=0;idx<ctrlData.childs.length;idx++){
					tab_grid.addItem({caption:ctrlData.childs[idx].caption,ptr:ctrlData.childs[idx]});
				}
			}
			var dlg = new icc.ui.dialog({
				caption:_T('Tab control config'),
				vs:3,
				childs:[
					tabItems
				]
			});
			tab_grid.onChange(function(item){
				tab_btnDelete.setEnabled(item!==null);
				tab_btnUp.setEnabled(item!==undefined && this.getIndex()>0);
				tab_btnDn.setEnabled(item!==undefined && this.getIndex()<ctrlData.childs.length-1);
				
				if(item){
					tab_caption.setText(item.caption);
					tab_caption.setEnabled(true);
				}
			});
			tab_caption.onChange(function(value){
				tab_grid.getItem().caption = value;
				tab_grid.getItem().ptr.caption = value;
				tab_grid.updateItem(tab_grid.getItem());
			});
			tab_btnCancel.onClick(function(){
				dlg.close();
				if(cb){
					cb();
				}
			});
			tab_btnOk.onClick(function(){
				dlg.close();
				if(cb){
					cb(ctrlData.childs);
				}
			});
			tab_btnApply.onClick(function(){
				if(cb){
					cb(ctrlData.childs);
				}
			});
			tab_btnUp.onClick(function(){
				var item;
				var idx = tab_grid.getIndex();
				if(idx>0){
					item = ctrlData.childs[idx]
					ctrlData.childs[idx]=ctrlData.childs[idx-1]
					ctrlData.childs[idx-1]=item;
					tab_grid.clearAll();
					fillItems();
					tab_grid.setIndex(idx-1);
					tab_btnUp.setEnabled(tab_grid.getIndex()>0);
					tab_btnDn.setEnabled(tab_grid.getIndex()<ctrlData.childs.length-1);
				}
			})
			tab_btnDn.onClick(function(){
				var item;
				var idx = tab_grid.getIndex();
				if(idx<ctrlData.childs.length-1){
					item = ctrlData.childs[idx]
					ctrlData.childs[idx]=ctrlData.childs[idx+1]
					ctrlData.childs[idx+1]=item;
					tab_grid.clearAll();
					fillItems();
					tab_grid.setIndex(idx+1);
					tab_btnUp.setEnabled(tab_grid.getIndex()>0);
					tab_btnDn.setEnabled(tab_grid.getIndex()<ctrlData.childs.length-1);
				}
			});
			tab_btnAdd.onClick(function(){
				var newtab = {caption:_T('New tab'),type:'ui.tabitem',id:document.generateControlId('ui.tabitem',true)};
				var newItem = {caption:newtab.caption,ptr:newtab};
				ctrlData.childs.push(newtab);
				tab_grid.addItem(newItem);
				tab_caption.setText(newtab.caption);
				tab_grid.setItem(newItem);
				tab_btnUp.setEnabled(tab_grid.getIndex()>0);
				tab_btnDn.setEnabled(tab_grid.getIndex()<ctrlData.childs.length-1);
				tab_btnDelete.setEnabled(true);
				tab_caption.setEnabled(true);
			});
			tab_btnDelete.onClick(function(){
				var item = tab_grid.getItem();
				if(item){
					tab_grid.rmvItem(item);
					tab_caption.setText("");
					tab_caption.setEnabled(false);
					for (var idx=0;idx<ctrlData.childs.length;idx++){
						if(ctrlData.childs[idx]===item.ptr){
							ctrlData.childs.splice(idx,1);
						}
					}
					tab_btnUp.setEnabled(false);
					tab_btnDn.setEnabled(false);
					this.setEnabled(false);
				}
			});
			dlg.onCreate(function(){
				fillItems();
			});
			dlg.create();
			dlg.showModal();
		}},
		properties.visible,
		properties.style,
		properties.htmlclass
	];
};

icc.ui.uploader.prototype.getProperties = function (formDoc) {
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		properties.tooltip,
		properties.tabIndex,
		properties.enabled,
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.icon,
		{type: 'option', caption: 'IconSide', name: 'iconSide',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'top' ,caption:'top'},{value:'bottom' ,caption:'bottom'}]},
		properties.round,
		properties.font,
		properties.htmlclass
	];
};

icc.ui.label.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		properties.datasource,
		properties.field,
		properties.multiLine,
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.round,
		properties.align,
		properties.font,
		properties.background,
		properties.htmlclass
	];
};

icc.ui.textinput.prototype.getProperties = function(formDoc){
	return addContextInfoProperties(formDoc, [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		{caption:'Text',type:'mlstring',name:'text'},
		properties.caption,
		{type: 'trigger-group',onproperty:'caption'},
		{type: 'option', caption: 'Caption side', name: 'captionSide',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'top' ,caption:'top'},{value:'bottom' ,caption:'bottom'}]},
		{type: 'integer',caption: 'Spaccing',name:'captionSpaccing'},
		{type: 'color',caption:'Forecolor',name:'captionForeColor'},
		{type: 'color',caption:'Backcolor',name:'captionBackColor'},
		{caption:'Align',type:'option',name:'captionAlign',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'center' ,caption:'center'},{value:'justify' ,caption:'justify'}]},
		{type: 'font',caption: 'Font',name:'captionFont'},
		{type: 'endgroup'},
		properties.tooltip,
		properties.datasource,
		properties.field,
		"CONTEXT_INFO",
		{caption:'Max length',type:'integer',name:'maxLength'},
		properties.tabIndex,
		properties.enabled,
		properties.visible,
		properties.readonly,
		properties.multiLine,
		properties.required,
		properties.missingvalue,
		{caption:'Format',type:'option',name:'format',values:[
			{value:'integer' ,caption:'Integer'},
			{value:'fixed'   ,caption:'Fixed'},
			{value:'currency',caption:'Currency'},
			{value:'date'    ,caption:'Date'},
			{value:'time'    ,caption:'Time'},
			{value:'datetime',caption:'Date & Time'},
			{value:'password',caption:'Password'}
		]},
		{caption:'Decimals',type:'integer',name:'decimals'},
		{caption:'Mask',type:'string',name:'mask'},
		properties.invalidvalue,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.round,
		properties.align,
		properties.font,
		properties.htmlclass
	]);
};

icc.ui.vline.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.penstyle,
		properties.weight,
		properties.htmlclass
	];
};

icc.ui.hline.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.penstyle,
		properties.weight,
		properties.htmlclass
	];
};

icc.ui.progressbar.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		{caption:'Min',type:'integer',name:'min'},
		{caption:'Max',type:'integer',name:'max'},
		{caption:'Value',type:'integer',name:'value'},
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.backColor,
		{caption:'BarColor',type:'color',name:'barColor'},
		{caption:'Orientation',type:'option',name:'orientation',values:[{value:'horizontal' ,caption:'Horizontal'},{value:'vertical' ,caption:'Vertical'}]},
		properties.borderWidth,
		properties.borderColor,
		properties.align,
		properties.font,
		{caption:'Show Percent',type:'bool-true',name:'showPercent'},
		properties.htmlclass
	];
};

icc.ui.imagelist.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.opacity,
		properties.htmlclass
	];
};

icc.ui.image.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.style,
		properties.visible,
		properties.borderWidth,
		properties.borderColor,
		properties.image,
		properties.opacity,
		properties.htmlclass
	];
};

icc.ui.tree.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.tabIndex,
		properties.enabled,
		properties.visible,
		properties.menuitems,
		properties.style,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.font,
		properties.htmlclass
	];
};

icc.ui.menu.prototype.getProperties=function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		{caption:'Vertical',type:'bool',name:'vertical'},
		{caption:'z-index',type:'integer',name:'zIndex'},
		properties.menuitems,
		properties.style,
		properties.htmlclass
	];
};

icc.ui.combobox.prototype.getProperties=function(formDoc){
	return addContextInfoProperties(formDoc, [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.datasource,
		properties.field,
		"CONTEXT_INFO",
		{type: 'mlstring', name:'caption',caption:'Caption'},
		{type: 'trigger-group',onproperty:'caption'},
		{type: 'option', caption: 'Caption side', name: 'captionSide',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'top' ,caption:'top'},{value:'bottom' ,caption:'bottom'}]},
		{type: 'integer',caption: 'Spaccing',name:'captionSpaccing'},
		{type: 'color',caption:'Forecolor',name:'captionForeColor'},
		{type: 'color',caption:'Backcolor',name:'captionBackColor'},
		{caption:'Align',type:'option',name:'captionAlign',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'center' ,caption:'center'},{value:'justify' ,caption:'justify'}]},
		{type: 'font',caption: 'Font',name:'captionFont'},
		{type: 'endgroup'},
		properties.tooltip,
		properties.tabIndex,
		properties.enabled,
		properties.visible,
		properties.readonly,
		properties.required,
		properties.missingvalue,
		properties.listitems,
		{caption:'Source rows',type:'datasource',name:'rowsSource'},
		{caption:'Display field',type:'field',name:'displayField',src:'rowsSource'},
		{caption:'Store field',type:'field',name:'codeField',src:'rowsSource'},
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderColor,
		properties.borderWidth,
		properties.htmlclass
	]);
};
icc.ui.button.prototype.getProperties = function (formDoc) {
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		properties.datasource,
		{type: 'action', caption: 'Action', name: 'action'},
		{type: 'trigger-group',onproperty:'action',value:'export'},
			properties.csvexportFormat,
		{type: 'endgroup'},
		properties.tooltip,
		properties.enabled,
		properties.visible,
		properties.tabIndex,
		properties.style,
		properties.borderWidth,
		
		{caption:'Normal',type:'group',
			brief_fn:function(data){
				return "";
			}
		},
			properties.foreColor,
			properties.backColor,
			{caption:'Gradient',type:'color',name:'background'},
			{caption:'G.Height',type:'integer',name:'gradientHeight'},
			
			properties.borderColor,
		{type:'endgroup'},
		
		{caption:'Hover',type:'group',
			brief_fn:function(data){
				return "";
			}
		},
			{caption:'Forecolor',type:'color',name:'hoverForeColor'},
			{caption:'Backcolor',type:'color',name:'hoverBackColor'},
			{caption:'Gradient',type:'color',name:'hoverBackground'},
			{caption:'G.Height',type:'integer',name:'hoverGradientHeight'},
			{caption:'BorderColor',type:'color',name:'hoverBorder'},
		{type:'endgroup'},
		
		{caption:'Pressed',type:'group',
			brief_fn:function(data){
				return "";
			}
		},
			{caption:'Forecolor',type:'color',name:'pressedForeColor'},
			{caption:'Backcolor',type:'color',name:'pressedBackColor'},
			{caption:'Gradient',type:'color',name:'pressedBackground'},
			{caption:'G.Height',type:'integer',name:'pressedGradientHeight'},
			{caption:'BorderColor',type:'color',name:'pressedBorderColor'},
		{type:'endgroup'},
		{caption:'Disabled',type:'group',
			brief_fn:function(data){
				return "";
			}
		},
		{caption:'Forecolor',type:'color',name:'disabledForeColor'},
		{caption:'Backcolor',type:'color',name:'disabledBackColor'},
		{caption:'Gradient',type:'color',name:'disabledBackground'},
		{caption:'G.Height',type:'integer',name:'disabledGradientHeight'},
		{caption:'BorderColor',type:'color',name:'disabledBorderColor'},
		{type:'endgroup'},
		properties.icon,
		{type: 'option', caption: 'IconSide', name: 'iconSide',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'top' ,caption:'top'},{value:'bottom' ,caption:'bottom'}]},
		properties.round,
		properties.font,
		properties.align,
		properties.htmlclass
	];
};
icc.ui.checkbutton.prototype.getProperties = function (formDoc) {
	return addContextInfoProperties(formDoc, [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		properties.datasource,
		properties.field,
		"CONTEXT_INFO",
		{caption: 'Checked', type: 'bool', name: 'checked'},
		properties.checkedval,
		properties.uncheckedval,
		properties.enabled,
		properties.visible,
		properties.tabIndex,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		{caption:'Align',type:'option',name:'align',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'}]},
		properties.font,
		properties.htmlclass
	]);
};
icc.ui.optionbutton.prototype.getProperties = function (formDoc) {
	return addContextInfoProperties(formDoc, [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		properties.datasource,
		properties.field,
		"CONTEXT_INFO",
		{caption: 'Checked', type: 'bool', name: 'checked'},
		properties.checkedval,
		properties.uncheckedval,
		properties.enabled,
		properties.visible,
		{caption:'Option group',type:'string',name:'group'},
		properties.tabIndex,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.font,
		{caption:'Align',type:'option',name:'align',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'}]},
		properties.htmlclass
	]);
};
icc.ui.optiongroup.prototype.getProperties = function (formDoc) {
	return addContextInfoProperties(formDoc, [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.caption,
		{type: 'trigger-group',onproperty:'caption'},
		{type: 'color',caption:'Forecolor',name:'captionForeColor'},
		{caption:'Align',type:'option',name:'captionAlign',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'},{value:'center' ,caption:'center'},{value:'justify' ,caption:'justify'}]},
		{type: 'font',caption: 'Font',name:'captionFont'},
		{type: 'endgroup'},

		properties.datasource,
		properties.field,
		"CONTEXT_INFO",
		properties.listitems,
		{caption: 'Checked', type: 'string', name: 'checked'},
		{caption: 'Spaccing', type: 'integer', name: 'spaccing'},
		{caption: 'Columns', type: 'integer', name: 'columns'},
		{caption: 'Rows', type: 'integer', name: 'rows'},
		properties.enabled,
		properties.visible,
		properties.tabIndex,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.font,
		{caption:'Align',type:'option',name:'align',values:[{value:'left' ,caption:'left'},{value:'right' ,caption:'right'}]}
	]);
};

icc.ui.panel.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),		
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.round,
		{caption:'Gradient',type:'bool',name:'gradient'},
		{caption:'ReverseGradient',type:'bool',name:'reverseGradient'},
		{caption:'GradientHeight',type:'integer',name:'gradientHeight'},
		properties.opacity,
//		{caption:'Padding',type:'integer',name:'padding'},
		
		{caption:'Slice',type:'string',name:'slice'},
		properties.background,
		properties.htmlclass
	];
};
icc.ui.captcha.prototype.getProperties = function(formDoc)
{
// https://developers.google.com/recaptcha/docs/display#AJAX
	return [
		{caption:'Theme',type:'option', name:'theme',
			values: [
				{value:'light',caption:'Light'},
				{value:'dark' ,caption:'Dark' }
			]
		},
		{caption:'Size',type:'option', name:'size',
			values:[
				{value:'compact',caption:'Compact'},
				{value:'normal' ,caption:'Normal' }
			]
		},
		{caption:'Type',type:'option', name:'captchatype',
			values:[
				{value:'audio',caption:'Audio'},
				{value:'image',caption:'Image'}
			]
		},
	// https://developers.google.com/recaptcha/docs/language
		{caption:'Language',type:'option', name:'lang',
			values:[
				{value:'en'    ,caption:'English (US)'           },
				{value:'en-GB' ,caption:'English (UK)'           },
				{value:'nl'    ,caption:'Dutch'                  },
				{value:'fr'    ,caption:'French'                 },
				{value:'de'    ,caption:'German'                 },
				{value:'pt'    ,caption:'Portuguese'             },
				{value:'pt-BR' ,caption:'Portuguese (Brazil)'    },
				{value:'pt-PT' ,caption:'Portuguese (Portugal)'  },
				{value:'ru'    ,caption:'Russian'                },
				{value:'es'    ,caption:'Spanish'                },
				{value:'es-419',caption:'Spanish (Latin America)'},
				{value:'tr'    ,caption:'Turkish'                }
			]
		},
		properties.visible
	];
};

icc.ui.sdkdispositioncode.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		properties.datasource,
		{caption:'Reschedule',type:'bool-group',name:'reschedule',
			childs:[
				{caption:'Campaign',type:'string',name:'rescheduledToCampaign'},
				{caption:'Same agent',type:'bool',name:'sameagent'},
				{caption:'Force process',type:'string',name:'forceProcessId'},
				{caption:'Force batch',type:'string',name:'forceBatchId'},
				{caption:'Show phone type',type:'bool',name:'showPhoneType'},
				{caption:'Phone type',type:'option',
					values:[
						{value:"HOME",caption:_T('Home')},
						{value:"OFFICE",caption:_T("Office")},
						{value:"CELLULAR",caption:_T("Mobile")},
						{value:"FAX",caption:_T("Fax")}
					],
					'default':'CELLULAR',
					name:'alternatePhoneType'
				},
				{type:'endgroup'}
			]
		},
		properties.language,
		properties.visible,
		properties.style,
		properties.foreColor,
		properties.backColor,
		properties.borderWidth,
		properties.borderColor,
		properties.htmlclass
	];
};
/////////////////////////  PROPIEDADES DE CONTROLES USADOS EN REPORTES ///////////////////////////////////

icc.ui.reportpanel.prototype.getProperties = function(formDoc){
	return [
		(formDoc.getVersion()>1?properties.geometry2:properties.geometry),
		{caption:'Report name',type:'string',name:'reportName'},
		{caption:'Run at start',type:'bool',name:'runAtStart'},
		{caption:'Retrieve params',type:'bool-true',name:'retrieveParams'},
		properties.htmlclass
	];
};

/////////////////////////  PROPIEDADES DE CONTROLES USADOS EN FINALIZATION MAIL ///////////////////////////////////
icc.ui.chatctrl_finalizationmail_address.prototype.getProperties = function(formDoc)
{
	return [
		{ name: 'caption', caption: 'Caption', type: 'literal' },
		properties.htmlclass
	];
};

})(__icc__);




/*jslint evil:true */
/*global jQuery unescape window escape __icc__ _T
*/
(function(icc){
	var formDoc;
	var layoutCode = false; // si es true el codigo recuperado y guardado por setCodeBehind y getCodeBehind es el de layout
							 // util para desarrollar templates
							 
							 
	formDoc = function(appDoc,formId,formData){
		this.lastId=100;
		this.appDoc = appDoc;

		formDoc.SUPERconstructor.call(this);
		this.formId = formId;
		this.appId = appDoc.getId();
		this.vccName = appDoc.getVCCName();
		this.name = formId;
		this.id = formId;
		if(formData){
			this.content = formData;
		}else{
			this.content = {
				name:formId,
				id:formId,
				type:"ui.panel",
				code:"",
				childs:[]
			};
		}
		this.ids = {};
		this.idstemp = {}; // temporal de ids generados que son grabados mediante commitControlIdTransaction
	};
	icc.utils.inherit(formDoc,icc.ui.framework.documentView.document);

	formDoc.prototype.setupIds = function(){
		var self = this;
		this.ids = {};
		var storeControlId = function ( ctrl ){
			if(!self.ids[ctrl.type]){
				self.ids[ctrl.type]={};
			}
			self.ids[ctrl.type][ctrl.id]=true;
			if(ctrl.childs){
				for (var idx=0;idx<ctrl.childs.length;idx++){
					storeControlId(ctrl.childs[idx]);
				}
			}
		};
		storeControlId(this.content);
	};
	formDoc.prototype.getCtrlsTypes = function(cb){
		var self = this;
		var contactTypeProperty = {
			caption:'Contact field',
			type:"option",
			name:"contactFieldType",
			values:[
				{id:'NAME',caption:'Name',value:'NAME'},
				{id:'ID',caption:'Contact Id',value:'ID'},
				{id:'MAIL',caption:'Email',value:'MAIL'},
				{id:'PHONE',caption:'Phone',value:'PHONE'},
				{id:'TWITTER',caption:'Twitter',value:'TWITTER'},
				{id:'REASON',caption:'Reason',value:'REASON'},
			]
		};
		var contactAddressProperties = [
			{caption:'Address type',type:"option",name:"addressType",
				"default":"MAIL",
				"allowBlank":false,
				values:[
					{id:'MAIL',caption:'Email',value:'MAIL'},
					{id:'Cellular',caption:'Cellular',value:'CELLULAR'},
					{id:'Home number',caption:'Home number',value:'HOME'},
					{id:'Office number',caption:'Office number',value:'OFFICE'},
					{id:'TWITTER',caption:'Twitter',value:'TWITTER'}
				]
			},
			{
				caption : "Country Id",
				type : "mlstring",
				name : "countryCode"
			},
			{
				caption : "Area Id",
				type : "mlstring",
				name : "areaCode"
			}
		];
		var contactIdentifierProperties = [
			{
				caption:'Identifier type',
				type:"option",
				name:"identifierType",
				"default":"NAME",
				"allowBlank":false,
				values:[
					{id:'ID',caption:'Contact Id',value:'ID'},
					{id:'NAME',caption:'Name',value:'NAME'}
				]
			},
			{
				type: 'trigger-group',
				onproperty:'identifierType',
				value:'ID',
				childs:[
					{
						caption:'Contact id type',
						type:"option",
						"default":'ANYTHING',
						allowBlank:false,
						name:"contactIdType",
						values:[
							{id:'ANYTHING',caption:'Anything',value:'ANYTHING'},
							{id:'MAIL',caption:'Email',value:'MAIL'},
							{id:'Cellular',caption:'Cellular',value:'CELLULAR'},
							{id:'Home number',caption:'Home number',value:'HOME'},
							{id:'Office number',caption:'Office number',value:'OFFICE'},
							{id:'TWITTER',caption:'Twitter',value:'TWITTER'}
						]
					},
					{
						caption : "Country Id",
						type : "mlstring",
						name : "countryCode"
					},
					{
						caption : "Area Id",
						type : "mlstring",
						name : "areaCode"
					},
					{type: 'endgroup'}
				]
			}
		];

		if (self.content['class'] == "___chat"){ // para los forms de chat 
			cb(true,[
				{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
					defaults:{
						caption:'label',
						overflow:'hidden',
						width:120,
						height:20,
						borderWidth:1
					}
				},
				{icon:'buttonIcon.png',type:"ui.button",tooltip:_T('Button'),constructor:icc.ui.button,
					defaults:{
						caption:'button',
						width:120,
						height:30
					}
				},
				{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
					defaults:{
						width:320,
						height:200,
						borderWidth:1
					}
				},
				{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
				
					defaults:{
						width:90
					}
				},
				{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
					defaults:{
						height:80
					}
				
				},
				{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
					defaults:{
						height:100,
						width:160,
						borderWidth:1,
						borderColor:'gray'
					}
				},
				{icon:'printerIcon.png',tooltip:_T('Print chat button'),type:"ui.chatctrl_printbutton",constructor:icc.ui.chatctrl_printbutton,
					defaults:{
						"width": 20,
						"height": 20
					}
				},
				/* chat components */
				{icon:'chatIcon.png',tooltip:_T('Chat control'),type:"ui.chatctrl",constructor:icc.ui.chatctrl,
					defaults:{
						"image": "!stop.png",
						"bindClass": "chatctrl",
						"borderColor": "lightgray",
						"borderWidth": 1,
						
						"height": 15,
					
						"image": "!stop.png",
						
						"resizable": false,
						
						"visible": false,
						"width": 45
					}
				},
				{icon:'chatSendIcon.png',tooltip:_T('Chat send button'),type:"ui.chatctrl_sendbutton",constructor:icc.ui.chatctrl_sendbutton,
					defaults:	{
						"backColor": "black",
						"background": "#1858a8",
						"borderColor": "gray",
						"borderWidth": 1,
						"caption": "Send",
						"font": {
							"italic": false,
							"size": 14
						},
						"foreColor": "white",
						"gradientHeight": 50,
						"height": 50,
						"paddingRight": 2,
						"round": 4,
						"width": 74
					}
				},
				{icon:'chatInputIcon.png',tooltip:_T('Chat text input'),type:"ui.chatctrl_input",constructor:icc.ui.chatctrl_input,
					defaults:{
						"borderWidth": 1,
						"fillWidth": true,
						"height": 52,
						"multiLine": true,
						"sendWithEnter": true,
						"width": 374
					}
				},
				{icon:'chatHornIcon.png',tooltip:_T('Chat horn'),type:"ui.chatctrl_horn",constructor:icc.ui.chatctrl_horn,
					defaults:{
						"height": 20,
						"width": 20
					}
				},
				{icon:'chatLogoutIcon.png',tooltip:_T('Chat logout button'),type:"ui.chatctrl_logout",constructor:icc.ui.chatctrl_logout,
					defaults:{
						"backColor": "#f8f8f8",
						"background": "#f8f8f8",
						"borderWidth": 0,
						"caption": "Close session",
						"font": {
							"italic": false,
							"weight": "bold"
						},
						"foreColor": "#1858a8",
						"height": 12,
						"width": 115
					}
				},
				{icon:'chatMsgWindow.png',tooltip:_T("Chat message window"),type:"ui.chatctrl_msgwindow",constructor:icc.ui.chatctrl_msgwindow,
					defaults:{
						"avatar_border_color": "gray",
						"avatar_border_style": "groove",
						"avatar_border_width": 0,
						"avatar_height": 16,
						"avatar_width": 16,
						"backColor": "white",
						"bind": "chatctrl",
						"borderColor": "lightgray",
						"borderWidth": 1,
						"childs": [],
						"fillHeight": true,
						"fillWidth": true,
						"gradient": false,
						"gradientHeight": 500,
						"height": 175,
						"message_field_font": {
							"italic": false,
							"size": 11
						},
						"paddingRight": 5,
						"reverseGradient": false,
						"showAvatar": true,
						"showUser": true,
						"showTime":true,
						"timeFormat": "time",
						"time_field_font": {
							"italic": false,
							"size": 11,
							"weight": "bold"
						},
						"time_field_foreColor": "black",
						"user_field_font": {
							"italic": false,
							"weight": "bold"
						},
						"user_field_suffix": "&nbsp;:",
						"width": 460
					}
				},
				{tooltip:_T('Chat message container panel'),
					defaults:{
						"backColor": "white",
						"borderColor": "lightgray",
						"borderWidth": 1,
						"height": 175,
						"width": 460
					},
					type:"ui.chatctrl_msgwindow2",constructor:function(args,env){
					var create,addChild,replaceChild;
					var layoutDesigner = new icc.ui.fixedLayoutDesigner(args,env);
					create =layoutDesigner.create;
					addChild = layoutDesigner.addChild;
					replaceChild = layoutDesigner.replaceChild;
					var ctrl = new icc.ui.chatctrl_msgwindow2(args,env)
					jQuery.extend(layoutDesigner,ctrl);
					layoutDesigner.create = create;
					layoutDesigner.addChild = addChild;
					layoutDesigner.replaceChild = replaceChild;
					return layoutDesigner;
				}},
				{/*icon:'chatAvatarIcon.png'*/tooltip:_T('Chat avatar image'),type:"ui.chatctrl_msgwindow_avatarimage",constructor:icc.ui.chatctrl_msgwindow_avatarimage,
					defaults:{
						width:32,
						height:32
					}
				},
				{tooltip:_T('Chat message field'),type:"ui.chatctrl_msgwindow_messagefield",constructor:icc.ui.chatctrl_msgwindow_messagefield,
					defaults:{
						"align": "justify",
						"height": 15,
						"messageField": "text",
						"multiLine": true,
						"overflow": "hidden",
						"width": 200
					}
				},
				{icon:'chatNotifyIcon.png',tooltip:_T('Chat notify area'),type:"ui.chatctrl_notifier",constructor:icc.ui.chatctrl_notifier,
					defaults:{
						width:200,
						height:15
					}
				},
				{
					icon:'filesharing.png',
					tooltip:_T('File sharing button'),
					type:"ui.chatctrl_filesharing",
					constructor:icc.ui.chatctrl_filesharing,
					defaults:{
						height:22,
						width:22,
						icon: "!attachment-icon.png",
						iconSide: "top",
						caption: ""
					}
				},
				{
					icon:'chatSessionTimerIcon.png',
					tooltip:_T('Chat session timer'),
					type:"ui.chatctrl_session_timer",
					constructor: icc.ui.chatctrl_session_timer,
					defaults:{
						"caption": "00:00:00",
						"borderWidth": 0,
						"height": 15,
						"width": 50,
						"backColor": 'transparent',
						"bind": "chatctrl",
						"type": "ctrlbind"
					}
				}
			]);
		}

		else if (self.content['class'] == "___chatv3"){ // para los forms de chat 
			cb(true,[
				/* chat components */
				{icon:'chatIcon.png',tooltip:_T('Chat control'),type:"ui.chatctrlv3",constructor:icc.ui.chatctrlv3,
					defaults:{}
				}
			]);
		}

		else if (self.content['class'] == "___webcall"){ // para los forms de webcall 
			cb(true,[
				/* webcall components */
				{icon:'webcallIcon.png',tooltip:_T('Webcall control'),type:"ui.webcallctrl",constructor:icc.ui.webcallctrl,
					defaults:{}
				}
			]);
		}
		else if (self.content['class'] == "___login"){ // para los form de login del chat
			cb(true,[
				{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
					defaults:{
						caption:'label',
						overflow:'hidden',
						width:120,
						height:20,
						borderWidth:1
					}
				},
				{icon:'contactIdentifier.png',tooltip:_T('Contact Identifier'),type:"ui.contactidentifier",constructor:icc.ui.textinput,
					defaults:{
						width:150,
						"runtime-type":"ui.textinput",
						height:20,
						identifierType:"NAME"
					},
					getProperties:function(formDoc){
						var res = this._getProperties(formDoc);
						for (var n = res.length-1;n>=0;n--){
							if(res[n].name == "datasource" || res[n].name == "field"){
								res.splice(n,1)
							}
							if(res[n].name == "text"){
								res.splice(n,0,...contactIdentifierProperties);
								
								break;
							}
						}
						return res
					}
				},
				{icon:'contactaddress.png',tooltip:_T('Contact Address'),type:"ui.contactaddress",constructor:icc.ui.textinput,
					defaults:{
						width:150,
						height:20,
						addressType:'MAIL',
						"runtime-type":"ui.textinput"
					},
					getProperties:function(formDoc){
						var res = this._getProperties(formDoc);
						for (var n = res.length-1;n>=0;n--){
							if(res[n].name == "datasource" || res[n].name == "field"){
								res.splice(n,1);
							}
							if(res[n].name == "text"){
								res.splice(n,0,...contactAddressProperties);
								break;
							}
						}
						return res
					}
				},
				{icon:'textInputIcon.png',tooltip:_T('Text input'),type:"ui.textinput",constructor:icc.ui.textinput,
					defaults:{
						width:150,
						height:20
					}
				},
				{icon:'buttonIcon.png',type:"ui.button",tooltip:_T('Button'),constructor:icc.ui.button,
					defaults:{
						caption:'button',
						width:120,
						height:30
					}
				},
				{icon:'checkboxIcon.png',type:"ui.checkbutton",tooltip:_T('Check button'),constructor:icc.ui.checkbutton,
					defaults:{
						caption:'check',
						width:60,
						height:20
					}
				},
				{icon:'radioButtonIcon.png',type:"ui.optionbutton",tooltip:_T('Option button'),constructor:icc.ui.optionbutton,
					defaults:{
						caption:'option',
						width:60,
						height:20
					}
				},
				{icon:'optiongroup.png',type:"ui.optiongroup",tooltip:_T('Option group'),constructor:icc.ui.optiongroup,
					defaults:{
						caption:'option',
						width:150,
						height:60,
						items:[
							{id:"Option 1",text:_T("Option 1")},
							{id:"Option 2",text:_T("Option 2")}
						]
					}
				},
				{icon:'selectIcon.png',type:"ui.combobox",tooltip:_T('Combobox'),constructor:icc.ui.combobox,
					defaults:{
						width:100,
						height:20
					}
				},
				{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
					defaults:{
						width:320,
						height:200,
						borderWidth:1
					}
				},
				{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
				
					defaults:{
						width:90
					}
				},
				{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
					defaults:{
						height:80
					}
				},
				{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
					defaults:{
						height:100,
						width:160,
						borderWidth:1,
						borderColor:'gray'
					}
				},
				{icon:'recaptcha.png', type:"ui.captcha",tooltip:_T('Captcha'),constructor:icc.ui.captcha,
					defaults:{
						theme: "light",       // (light / dark)
						size: "normal",       // (normal / compact)
						captchatype: "image", // (image / audio)
						height:74,
						width:300,
						resizable:false
					}
				},
				{icon:'chatIcon.png',tooltip:_T('Chat container'),type:"ui.chatformcontainer",constructor:icc.ui.chatformdesigner,
					defaults:{
						width:320,
						height:200,
						borderWidth:1
					}
				}
			]);
		}
		else if (self.content['class'] == "___start_button"){ // para los form de login del chat
			cb(true,[
				/* chat components */
				{icon:'chatIcon.png',tooltip:_T('Chat minimized'),type:"ui.chatminimizedctrl",constructor:icc.ui.chatminimizedctrl,
					defaults:{}
				}
			]);
		}
		else if (self.content['class'] == "___pre_survey" || self.content['class'] == "___survey" ){ // para los form de pre_survey del chat
			var controls = [
				{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
					defaults:{
						caption:'label',
						overflow:'hidden',
						width:120,
						height:20,
						borderWidth:1
					}
				},
				{icon:'textInputIcon.png',tooltip:_T('Text input'),type:"ui.textinput",constructor:icc.ui.textinput,
					defaults:{
						width:150,
						height:20
					}
				},
				{icon:'buttonIcon.png',type:"ui.button",tooltip:_T('Button'),constructor:icc.ui.button,
					defaults:{
						caption:'button',
						width:120,
						height:30
					}
				},
				{icon:'checkboxIcon.png',type:"ui.checkbutton",tooltip:_T('Check button'),constructor:icc.ui.checkbutton,
					defaults:{
						caption:'check',
						width:60,
						height:20
					}
				},
				{icon:'radioButtonIcon.png',type:"ui.optionbutton",tooltip:_T('Option button'),constructor:icc.ui.optionbutton,
					defaults:{
						caption:'option',
						width:60,
						height:20
					}
				},
				{icon:'optiongroup.png',type:"ui.optiongroup",tooltip:_T('Option group'),constructor:icc.ui.optiongroup,
					defaults:{
						caption:'option',
						width:150,
						height:60,
						items:[
							{id:"Option 1",text:_T("Option 1")},
							{id:"Option 2",text:_T("Option 2")}
						]
					}
				},
				{icon:'selectIcon.png',type:"ui.combobox",tooltip:_T('Combobox'),constructor:icc.ui.combobox,
					defaults:{
						width:100,
						height:20
					}
				},
				{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
					defaults:{
						width:320,
						height:200,
						borderWidth:1
					}
				},
				{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
					defaults:{
						width:90
					}
				},
				{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
					defaults:{
						height:80
					}
				},
				{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
					defaults:{
						height:100,
						width:160,
						borderWidth:1,
						borderColor:'gray'
					}
				},
				{icon:'recaptcha.png', type:"ui.captcha",tooltip:_T('Captcha'),constructor:icc.ui.captcha,
					defaults:{
						theme: "light",       // (light / dark)
						size: "normal",       // (normal / compact)
						captchatype: "image", // (image / audio)
						height:74,
						width:300,
						resizable:false
					}
				},
				{icon:'chatIcon.png',tooltip:_T('Chat container'),type:"ui.chatformcontainer",constructor:icc.ui.chatformdesigner,
					defaults:{
						width:320,
						height:200,
						borderWidth:1
					}
				}
			];
			if(self.content['class'] == "___pre_survey" || self.content['class'] == "___survey"){
				controls.splice(2,0,
					{icon:'contactIdentifier.png',tooltip:_T('Contact Identifier'),type:"ui.contactidentifier",constructor:icc.ui.textinput,
						defaults:{
							width:150,
							"runtime-type":"ui.textinput",
							height:20,
							identifierType:"NAME"
						},
						getProperties:function(formDoc){
							var res = this._getProperties(formDoc);
							for (var n = res.length-1;n>=0;n--){
								if(res[n].name == "datasource" || res[n].name == "field"){
									res.splice(n,1)
								}
								if(res[n].name == "text"){
									res.splice(n,0,...contactIdentifierProperties);
									break;
								}
							}
							return res
						}
					},
					{icon:'contactaddress.png',tooltip:_T('Contact Address'),type:"ui.contactaddress",constructor:icc.ui.textinput,
						defaults:{
							width:150,
							height:20,
							addressType:'MAIL',
							"runtime-type":"ui.textinput"
						},
						getProperties:function(formDoc){
							var res = this._getProperties(formDoc);
							for (var n = res.length-1;n>=0;n--){
								if(res[n].name == "datasource" || res[n].name == "field"){
									res.splice(n,1);
								}
								if(res[n].name == "text"){
									res.splice(n,0,...contactAddressProperties);
									break;
								}
							}
							return res
						}
					},
					{
						icon:'chatFinalizationIcon.png',
						tooltip:_T('Chat finalization mail address.'),
						type:"ui.chatctrl_finalizationmail_address",
						constructor: icc.ui.chatctrl_finalizationmail_address,
						defaults:{
							"borderWidth": 0,
							"height": 25,
							caption: _T('Finalization Mail'),
							"width": 300,
							"backColor": 'transparent'
						}
					},
					{icon:'printerIcon.png',tooltip:_T('Print chat button'),type:"ui.printchatbutton",constructor:icc.ui.printchatbutton,
						defaults:{
							"width": 20,
							"height": 20
						}
					}
				);
			}
			cb(true,controls);
		}else 
		if(self.content['class'] == "___contact_form_prev" || self.content['class'] == "___contact_form_submit" || self.content['class'] == "___contact_form_final" || self.content['class'] == "___survey_form_submit" || self.content['class'] == "___survey_form_final"){
			if(self.content['class'] == "___contact_form_prev" || self.content['class'] == "___contact_form_submit" || self.content['class'] == "___contact_form_final" || self.content['class'] == "___survey_form_submit" || self.content['class'] == "___survey_form_final"){
				cb(true,[
					{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
						defaults:{
							caption:'label',
							overflow:'hidden',
							width:120,
							height:20,
							borderWidth:1
						}
					},
					{icon:'contactIdentifier.png',tooltip:_T('Contact Identifier'),type:"ui.contactidentifier",constructor:icc.ui.textinput,
						defaults:{
							width:150,
							"runtime-type":"ui.textinput",
							height:20,
							identifierType:"NAME"
						},
						getProperties:function(self){
							var res = this._getProperties(self);
							for (var n = res.length-1;n>=0;n--){
								if(res[n].name == "datasource" || res[n].name == "field"){
									res.splice(n,1)
								}
								if(res[n].name == "text"){
									res.splice(n,0,...contactIdentifierProperties);
									
									break;
								}
							}
							return res
						}
					},
					{icon:'contactaddress.png',tooltip:_T('Contact Address'),type:"ui.contactaddress",constructor:icc.ui.textinput,
						defaults:{
							width:150,
							height:20,
							addressType:'MAIL',
							"runtime-type":"ui.textinput"
						},
						getProperties:function(self){
							var res = this._getProperties(self);
							for (var n = res.length-1;n>=0;n--){
								if(res[n].name == "datasource" || res[n].name == "field"){
									res.splice(n,1);
								}
								if(res[n].name == "text"){
									res.splice(n,0,...contactAddressProperties);
									break;
								}
							}
							return res
						}
					},
					{icon:'textInputIcon.png',tooltip:_T('Text input'),type:"ui.textinput",constructor:icc.ui.textinput,
						defaults:{
							width:150,
							height:20
						}
					},
					{icon:'buttonIcon.png',type:"ui.button",tooltip:_T('Button'),constructor:icc.ui.button,
						defaults:{
							caption:'button',
							width:120,
							height:30
						}
					},
					{icon:'checkboxIcon.png',type:"ui.checkbutton",tooltip:_T('Check button'),constructor:icc.ui.checkbutton,
						defaults:{
							caption:'check',
							width:60,
							height:20
						}
					},
					{icon:'radioButtonIcon.png',type:"ui.optionbutton",tooltip:_T('Option button'),constructor:icc.ui.optionbutton,
						defaults:{
							caption:'option',
							width:60,
							height:20
						}
					},
					{icon:'optiongroup.png',type:"ui.optiongroup",tooltip:_T('Option group'),constructor:icc.ui.optiongroup,
						defaults:{
							caption:'option',
							width:150,
							height:60,
							items:[
								{id:"Option 1",text:_T("Option 1")},
								{id:"Option 2",text:_T("Option 2")}
							]
						}
					},
					{icon:'selectIcon.png',type:"ui.combobox",tooltip:_T('Combobox'),constructor:icc.ui.combobox,
						defaults:{
							width:100,
							height:20
						},
						getProperties:function(self){
							var res = this._getProperties(self);
							for (var n = 0;n<res.length;n++){
								if(res[n].name == "datasource"){
									res.splice(n,0,contactTypeProperty);
									break;
								}
							}
							return res
						}
					},
					{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
						defaults:{
							width:320,
							height:200,
							borderWidth:1
						}
					},
					{icon:'tabPanelIcon.png',type:"ui.tabpanel",tooltip:_T('Tab panel'),constructor:icc.ui.tabDesigner,
						defaults:{
							width:320,
							height:240,
							item:0,
							childs:[
								{type:"ui.tabitem",caption:"tab 1"}
							]
						}
					},
					{type:"ui.tabitem",constructor:icc.ui.fixedLayoutDesigner},
					{icon:'gridIcon.png',type:"ui.grid",tooltip:_T('Grid'),constructor:icc.ui.grid,
						defaults:{
							width:320,
							height:200,
							borderWidth:1,
							mustTranslate: false,
							columns:[
								{caption:_T('column 1'),width:100,field:''},
								{caption:_T('column 2'),width:100,field:''},
								{caption:_T('column 3'),width:100,field:''}
							]
						}
					},
					{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
						defaults:{
							width:90
						}
					},
					{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
						defaults:{
							height:80
						}
					},
					{icon:'progressbar.png',	type:"ui.progressbar",tooltip:_T('Progress bar'),constructor:icc.ui.progressbar,
						defaults:{
							height:20,
							width:100
						}
					},
					{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
						defaults:{
							height:100,
							width:160,
							borderWidth:1,
							borderColor:'gray'
						}
					},
					{icon:'recaptcha.png', type:"ui.captcha",tooltip:_T('Captcha'),constructor:icc.ui.captcha,
						defaults:{
							theme: "light",       // (light / dark)
							size: "normal",       // (normal / compact)
							captchatype: "image", // (image / audio)
							height:74,
							width:300,
							resizable:false
						}
					}
				]);
			}
		}else
		if(self.content['class'] == "flow" ){
			var res = [
				{icon:'Annotation.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
					defaults:{
						"#pragma:hideNameProperty":true,
						caption:'Note',
						multiLine:true,
						width:190,
						height:50,
						borderWidth:0,
						backColor:'lightyellow',
						borderWidth:1,
						borderColor:'lightgray'
					}
				}
			];
			var appDoc = new icc.ui.designer.applicationDoc(icc.ui.getApplication().getVCCName(),"designer");
			appDoc.load(function(status,result){
				if(status){
					var resources = icc.utils.clone(appDoc.getResources());
					var activities=[]
					var getNext = function(){
						var resourceEntry = resources.shift();
						if(resourceEntry){
							if(resourceEntry.mimeType=="x-application/icc-flowactivity"){
								appDoc.readResourceFile(resourceEntry.src,function(data){
									var activityData = JSON.parse(data);

									var enabledToFlowType = function (flowType,flowTypeFilter){
										var s = flowTypeFilter.split(",") || []
										for (i = 0;i< s.length;i++){
											if(s[i] == flowType || (s[i] == "any" || s[i] == "*" || s[i] == "all"))
												return true
										}
										return false
									}
									if (enabledToFlowType(self.content['subclass'],activityData.flowtype)){
										var defaults={
											"#pragma:hideNameProperty": true
										};
										var properties = [];
										var classdefaults={outputs:[],image:activityData.icon,width:33,height:33};
										var toolData = {
											hidden:activityData.hidden,
											icon:activityData.icon,
											tooltip:_T(activityData.tooltip),
											type:"ui.flowactivity."+activityData.name,
											constructor:icc.ui.flowactivity,
											getProperties:function(){
												return properties;
											},
											defaults:defaults,
											classdefaults:classdefaults
										};
										for (var i = 0;i<activityData.outputs.length;i++){
											if(activityData.outputs[i].name && icc.utils.trim(activityData.outputs[i].name)!=="")
												classdefaults.outputs.push(activityData.outputs[i].name);
										}
										for (var i = 0;i< activityData.properties.length;i++){
											var propertyEntry = activityData.properties[i]
											if(propertyEntry.name && propertyEntry.type){
												var property = {
													name:propertyEntry.name,
													caption:propertyEntry.caption,
													type:propertyEntry.type
												}
												switch(property.type){
													case "string":
													case "integer":
														defaults[propertyEntry.name]=propertyEntry['string'];
													break;
													case "bool":
														defaults[propertyEntry.name]=propertyEntry['booleanValue'];
													break;
													case "option":
														property.values = propertyEntry['options'];
														defaults[propertyEntry.name]=propertyEntry['defaultOption'];
													break;
													case "custom-panel":
														property.panelfn=function(propertyWnd,document,ctrlData,cb){
															icc.ui.getApplication().loadForm(activityData.name+".activity.json~"+this.name,function(status,formData){
																if(status){
																	cb(true,formData);
																	
																}else{
																	icc.ui.displayMessage(formData);
																}
															},{arguments:{propertyWnd:propertyWnd,properties:ctrlData,propertyData:icc.utils.clone(ctrlData[this.name] || {}),applicationDoc:self.appDoc,formDoc:self}});
														}
													break;	
													case "custom":
														property.type = "custom_np";
														property.customfn=function(document,ctrlData,cb){
															var dlg = new icc.ui.dialog({caption:""})
															
															icc.ui.getApplication().loadForm(activityData.name+".activity.json~"+this.name,function(status,formData){
																if(status){
																	
																	dlg.childs.push(formData);
																	dlg.create();
																	dlg.showModal(function(pData){
																		if(pData){
																			cb(pData);
																		}
																	});
																}else{
																	icc.ui.displayMessage(formData);
																}
															},{arguments:{propertyDialog:dlg,properties:ctrlData,propertyData:icc.utils.clone(ctrlData[this.name] || {}),applicationDoc:self.appDoc,formDoc:self}});
														}
													break;
												}
												properties.push(property);
											}
										}
										res.push(toolData);
									}
									getNext();
								});
							}else
								getNext();
						}else{
							cb(true,res);
						}
					}
					getNext();
				}else{
					cb(false,result);
				}
			})
		}
		else{
			cb(true,[
				{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
					defaults:{
						//"#pragma:hideNameProperty":true,
						caption:'label',
						overflow:'hidden',
						width:120,
						height:20,
						borderWidth:1
					}
				},
				{icon:'errorBoxIcon.png',tooltip:_T('Error box'),type:"ui.errorbox",constructor:icc.ui.errorbox,
					defaults:{
						caption:'ready',
						width:120,
						height:20,
						borderWidth:1
					}
				},
				{icon:'textInputIcon.png',tooltip:_T('Text input'),type:"ui.textinput",constructor:icc.ui.textinput,
					defaults:{
						width:150,
						height:20
					}
				},
				{icon:'buttonIcon.png',type:"ui.button",tooltip:_T('Button'),constructor:icc.ui.button,
					defaults:{
						caption:'button',
						width:120,
						height:30
					}
				},
				{icon:'checkboxIcon.png',type:"ui.checkbutton",tooltip:_T('Check button'),constructor:icc.ui.checkbutton,
					defaults:{
						caption:'check',
						width:60,
						height:20
					}
				},
				{icon:'radioButtonIcon.png',type:"ui.optionbutton",tooltip:_T('Option button'),constructor:icc.ui.optionbutton,
					defaults:{
						caption:'option',
						width:60,
						height:20
					}
				},
				{icon:'optiongroup.png',type:"ui.optiongroup",tooltip:_T('Option group'),constructor:icc.ui.optiongroup,
					defaults:{
						caption:'option',
						width:150,
						height:60,
						items:[
							{id:"Option 1",text:_T("Option 1")},
							{id:"Option 2",text:_T("Option 2")}
						]
					}
				},
				{icon:'selectIcon.png',type:"ui.combobox",tooltip:_T('Combobox'),constructor:icc.ui.combobox,
					defaults:{
						width:100,
						height:20
					}
				},
				{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
					defaults:{
						width:320,
						height:200,
						borderWidth:1
					}
				},
				{icon:'tabPanelIcon.png',type:"ui.tabpanel",tooltip:_T('Tab panel'),constructor:icc.ui.tabDesigner,
					defaults:{
						width:320,
						height:240,
						item:0,
						childs:[
							{type:"ui.tabitem",caption:"tab 1"}
						]
					}
				},
				/* chat components */
				{type:"ui.chatctrl",constructor:icc.ui.chatctrl},
				{type:"ui.chatctrl_sendbutton",constructor:icc.ui.chatctrl_sendbutton},
				{type:"ui.chatctrl_input",constructor:icc.ui.chatctrl_input},
				{type:"ui.chatctrl_horn",constructor:icc.ui.chatctrl_horn, 
				    defaults:{
						"height": 20,
						"width": 20
					}
				},
				{type:"ui.chatctrl_logout",constructor:icc.ui.chatctrl_logout},
				{type:"ui.chatctrl_msgwindow",constructor:icc.ui.chatctrl_msgwindow,
					defaults:{
						"avatar_border_color": "gray",
						"avatar_border_style": "groove",
						"avatar_border_width": 0,
						"avatar_height": 16,
						"avatar_width": 16,
						"backColor": "white",
						"bind": "chatctrl",
						"borderColor": "lightgray",
						"borderWidth": 1,
						"childs": [],
						"fillHeight": true,
						"fillWidth": true,
						"gradient": false,
						"gradientHeight": 500,
						"height": 175,
						"message_field_font": {
							"italic": false,
							"size": 11
						},
						"paddingRight": 5,
						"reverseGradient": false,
						"showAvatar": true,
						"showUser": true,
						"showTime":true,
						"timeFormat": "time",
						"time_field_font": {
							"italic": false,
							"size": 11,
							"weight": "bold"
						},
						"time_field_foreColor": "black",
						"user_field_font": {
							"italic": false,
							"weight": "bold"
						},
						"user_field_suffix": "&nbsp;:",
						"width": 460
					}
				},
				{type:"ui.chatctrl_msgwindow2",constructor:function(args,env){
					var create,addChild,replaceChild;
					var layoutDesigner = new icc.ui.fixedLayoutDesigner(args,env);
					create =layoutDesigner.create;
					addChild = layoutDesigner.addChild;
					replaceChild = layoutDesigner.replaceChild;
					
					var ctrl = new icc.ui.chatctrl_msgwindow2(args,env)
					jQuery.extend(layoutDesigner,ctrl);
					layoutDesigner.create = create;
					layoutDesigner.addChild = addChild;
					layoutDesigner.replaceChild = replaceChild;
					return layoutDesigner;
				}},
				{type:"ui.chatctrl_msgwindow_avatarimage",constructor:icc.ui.chatctrl_msgwindow_avatarimage},
				{type:"ui.chatctrl_msgwindow_messagefield",constructor:icc.ui.chatctrl_msgwindow_messagefield},
				{type:"ui.chatctrl_notifier",constructor:icc.ui.chatctrl_notifier},

				/* draw a complete chat */  
				
				{/*icon:'chat.png',*/type:"ui.panel",tooltip:_T('Chat'),constructor:icc.ui.fixedLayoutDesigner,
					defaults:function(){
						var chatid = self.getDocument().generateControlId("ui.chatctrl");
						var caption = "";
						return 	{
							"backColor": "#f8f8f8",
							"borderColor": "gray",
							"borderWidth": 1,
							"childs": [
								{
									"avatar_border_color": "gray",
									"avatar_border_style": "groove",
									"avatar_border_width": 0,
									"avatar_height": 16,
									"avatar_width": 16,
									"backColor": "white",
									"bind": "chatctrl",
									"borderColor": "lightgray",
									"borderWidth": 1,
									"childs": [],
									"fillHeight": true,
									"fillWidth": true,
									"gradient": false,
									"gradientHeight": 500,
									"message_field_font": {
										"italic": false,
										"size": 11
									},
									"paddingRight": 5,
									"reverseGradient": false,
									"showAvatar": true,
									"showUser": true,
									"showTime":true,
									"timeFormat": "time",
									"time_field_font": {
										"italic": false,
										"size": 11,
										"weight": "bold"
									},
									"time_field_foreColor": "black",
									"type": "ui.chatctrl_msgwindow",
									"user_field_font": {
										"italic": false,
										"weight": "bold"
									},
									"user_field_suffix": "&nbsp;:",
									"backColor": "white",
									"bind": chatid,
									"borderColor": "lightgray",
									"borderWidth": 1,
									"fillHeight": true,
									"fillWidth": true,
									"height": 175,
									"paddingRight": 5,
									"type": "ui.chatctrl_msgwindow",
									"width": 460,
									"x": 5,
									"y": 20
								},
								{
									"bindClass": "chatctrl",
									"borderColor": "lightgray",
									"borderWidth": 1,
									"height": 15,
									"image": "!stop.png",
									"resizable": false,
									"type": "ui.chatctrl",
									"visible": false,
									"width": 45,
									"x": 0,
									"y": 0
								},
								{
									"bind": chatid,
									"width": 20,
									"height": 20,
									"type": "ui.chatctrl_horn",
									"x": 15,
									"y": 5
								},
								{
									"width": 20,
									"height": 20,
									"type": "ui.chatctrl_printbutton",
									"x": 45,
									"y": 5,
									"bind": chatid
								},
								{
									"backColor": "#f8f8f8",
									"background": "#f8f8f8",
									"bind": chatid,
									"borderWidth": 0,
									"caption": "Close session",
									"font": {
										"italic": false,
										"weight": "bold"
									},
									"foreColor": "#1858a8",
									"height": 12,
									"paddingRight": 5,
									"sideRight": true,
									"type": "ui.chatctrl_logout",
									"width": 115,
									"x": 350,
									"y": 5
								},
								{
									"borderWidth": 1,
									"childs": [
										{
											"backColor": "black",
											"background": "#1858a8",
											"bind": chatid,
											"borderColor": "gray",
											"borderWidth": 1,
											"caption": "Send",
											"font": {
												"italic": false,
												"size": 14
											},
											"foreColor": "white",
											"gradientHeight": 50,
											"height": 50,
											"paddingRight": 2,
											"round": 4,
											"sideRight": true,
											"type": "ui.chatctrl_sendbutton",
											"width": 74,
											"x": 381,
											"y": 2
										},
										{
											"bind": chatid,
											"borderWidth": 0,
											"fillWidth": true,
											"height": 52,
											"multiLine": true,
											"paddingRight": 2,
											"sendWithEnter": true,
											"type": "ui.chatctrl_input",
											"width": 374,
											"x": 1,
											"y": 2
										}
									],
									"fillWidth": true,
									"gradient": false,
									"height": 55,
									"paddingBottom": 5,
									"paddingRight": 5,
									"round": 3,
									"sideBottom": true,
									"type": "ui.panel",
									"width": 455,
									"x": 5,
									"y": 240
								},
								{
									"bind": chatid,
									"borderWidth": 1,
									"font": {
										"italic": false,
										"weight": "bold"
									},
									"foreColor": "#505050",
									"height": 15,
									"overflow": "hidden",
									"sideBottom": true,
									"type": "ui.chatctrl_notifier",
									"width": 455,
									"x": 5,
									"y": 200
								},
								{
									"borderWidth": 1,
									"caption": "Send message",
									"font": {
										"italic": false,
										"size": 12
									},
									"foreColor": "gray",
									"height": 15,
									"sideBottom": true,
									"type": "ui.label",
									"width": 120,
									"x": 5,
									"y": 220
								}
							],
							"gradient": false,
							"height": 305,
							"round": 2,
							"type": "ui.panel",
							"width": 470,
							"x": 0,
							"y": 0
						}
					}
				},
				{type:"ui.tabitem",constructor:icc.ui.fixedLayoutDesigner},
				{icon:'gridIcon.png',type:"ui.grid",tooltip:_T('Grid'),constructor:icc.ui.grid,
					defaults:{
						width:320,
						height:200,
						borderWidth:1,
						mustTranslate: false,
						columns:[
							{caption:_T('column 1'),width:100,field:''},
							{caption:_T('column 2'),width:100,field:''},
							{caption:_T('column 3'),width:100,field:''}
						]
					}
				},
				{icon:'treeIcon.png',type:"ui.tree",tooltip:_T('Tree'),constructor:icc.ui.tree,
					defaults:{
						width:180,
						height:220,
						borderWidth:1
					}
				},
				{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
					defaults:{
						width:90
					}
				},
				{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
					defaults:{
						height:80
					}
				},
				{_icon:'menuIcon.png',	type:"ui.menu",tooltip:_T('Menu'),constructor:icc.ui.menu,
					defaults:{
						height:30,
						width:330,
						items:[
							{caption:_T('File'),
								items:[
									{caption:_T('New')},
									{caption:_T('Open')},
								]
							},
							{caption:_T('Edit'),
								items:[
									{caption:_T('Copy')},
									{caption:_T('Paste')}
								]
							},
							{caption:_T('Help')}
							
						]
					}
				},
				{_icon:'uploader.png',type:"ui.uploader",tooltip:_T('Upload button'),constructor:icc.ui.uploader,
					defaults:{
						height:22,
						width:22,
						caption:'..'
					}
				},
				{icon:'progressbar.png',	type:"ui.progressbar",tooltip:_T('Progress bar'),constructor:icc.ui.progressbar,
					defaults:{
						height:20,
						width:100
						
					}
				},		
				{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
					defaults:{
						height:100,
						width:160,
						borderWidth:1,
						borderColor:'gray'
					}
				},
				{icon:'clock.png',type:"ui.sdkdispositioncode",tooltip:_T('Disposition Code'),constructor:icc.ui.sdkdispositioncode,
					defaults:{
						height:110,
						width:310,
						borderWidth:0,
						borderColor:'gray',
						reschedule:true,
						sameagent:true,
						alternatePhoneType:"HOME"
					}
				},
				{icon:'report.png',type:"ui.reportpanel",tooltip:_T('Report container'),constructor:icc.ui.reportpanel,
					defaults:{
						height:110,
						width:310,
						borderWidth:0,
						borderColor:'gray'
					}
				}
			]);
		}
	}
	formDoc.prototype.load=function(cb){
		var self = this;
		var res ;
		jQuery.ajax({
			async: cb !==undefined,
			dataType:"json",
			cache:false,
			url: "designer/applications/"+this.appId+"/forms/"+this.formId,
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					self.content = ajaxResponse.result;
					self.content.__layoutcode = undefined;
					self.setupIds();
					self.getCtrlsTypes(function(status,ctrls){
						res = status;
						if(status)
							self.controltypes = ctrls;
						if(cb)
							cb(status,status?undefined:ctrls);
					});
				}else{
					if(cb){
						cb(false,ajaxResponse.result);
					}
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
			
		});
		return res;
	};
	formDoc.prototype.deleteFile = function(cb){
		var self = this;
		jQuery.ajax({
			url: "designer/applications/"+this.appId+"/forms/delete/"+this.formId,
			async: true,
			dataType:'json',
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					self.setDirty(true);
				}
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	};
	formDoc.prototype.getContentJSON = function(){
		var res;
		res = JSON.stringify(this.content);
		return res;
	};
	formDoc.prototype.getContent = function(){
		var res;
		res = icc.utils.clone(this.content);
		return res;
	};

	formDoc.prototype.save = function(cb){
		var self = this;
		jQuery.ajax({
			url: "designer/applications/"+this.appId+"/forms/save/"+this.formId,
			type: 'POST',
			async: true,
			dataType:"json",
			data:''.concat("content=" ,encodeURIComponent(JSON.stringify(this.content))),
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					self.setDirty(false);
				}
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	};
	formDoc.prototype.getName = function (){
		return this.formId;
	};
	formDoc.prototype.setName = function (newName){
		this.formId = newName;
		this.name = newName;
	};
	formDoc.prototype.getLayout = function(){
		return icc.utils.clone(this.content);
	};
	formDoc.prototype.getConnections = function(){
		return icc.utils.clone(this.content.connections || {});
	};
	
	
	formDoc.prototype.getFormType = function(){
		return this.content.formType?this.content.formType:"stdform";
	}
	formDoc.prototype.getFormSubType = function(){
		return this.content.formSubType?this.content.formSubType:undefined;
	}
	formDoc.prototype.getVersion = function(){
		return this.content.version || 1;
	}
	// devuelve una lista de los containers existentes
	// usado en la config del menu
	formDoc.prototype.getContainers = function(){
		var containers = []
		var findContainer = function ( childs ) {
			if(childs){
				jQuery.each(childs,function(idx,child){
					if (child.type === "ui.panel"){
						containers.push(child);
					}
					if (child.childs){
						findContainer(child.childs);
					}
				})
			}
		}
		findContainer(this.content.childs)
		return containers;
	}
	formDoc.prototype.getBindableControls = function (bindClass) {
		var result = [];
		var findBindable = function (childs){
			if(childs){
				jQuery.each(childs,function(idx,child){
					if(child.bindClass===bindClass){
						result.push(child)
					}
					findBindable(child.childs);
				});
			}
		}
		findBindable(this.content.childs)
		return result;
	}
	formDoc.prototype.setLayout = function(newLayout){
		this.content = icc.utils.clone(newLayout);
		this.setDirty(true);
	};
	formDoc.prototype.getLayoutCode = function(){
		return this.content.__layoutcode;
	};
	formDoc.prototype.getCodeBehind = function(){
		if(layoutCode){
			return this.content.__layoutcode;
		}else{
			return this.content.__code;
		}
	};
	formDoc.prototype.setCodeBehind = function(text){
		if(layoutCode){
			this.content.__layoutcode = text;
		}else {
			this.content.__code = text;
		}
		this.setDirty(true);
	};
	formDoc.prototype.getExecutionParameters=function (){
		return this.content.testparams!=undefined?this.content.testparams:[];
	};
	formDoc.prototype.setExecutionParameters=function(params,cb){
		this.content.testparams = params;
		var self;
		jQuery.ajax({
			url: "designer/applications/"+this.appId+"/forms/setparams/"+this.formId,
			type: 'POST',
			async: true,
			dataType:"json",
			data:''.concat("content=" ,encodeURIComponent(JSON.stringify(params))),
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});		
	};
	formDoc.prototype.findControlData = function (controlId, parentControl){
	
		if(!parentControl){
			parentControl = this.content;
		}
		if(parentControl.id === controlId){
			return {parent:null,node:parentControl};
		}
		if(parentControl.childs){
			for (var idx = 0;idx<parentControl.childs.length;idx++){
				if(parentControl.childs[idx].id === controlId){
					return {parent:parentControl,node:parentControl.childs[idx]};
				}
				else if(parentControl.childs[idx].childs){
					var t = this.findControlData(controlId,parentControl.childs[idx]);
					if(t){
						return t;
					}
				}
			}
		}else{
			if(parentControl.fields){
				
			}
		}
	};
	formDoc.prototype.changeControlId = function ( id,newid){
		var c = this.findControlData(newid);
		if(c){
			return false;
		}
		c = this.findControlData(id);
		if(!c){
			return false;
		}
		if(!icc.utils.isValidVariableName(newid))
			return false;
		c.node.id = newid;
		this.setupIds();
		
		return true;
	};
	formDoc.prototype.findControl = function ( controlId){
		var n = this.findControlData(controlId);
		if(n){
			return n.node;
		}
	};
	formDoc.prototype.getParent = function ( controlId){
		var n = this.findControlData(controlId);
		if(n){
		    return n.parent;
		}
	};
	formDoc.prototype.addConnection = function (connID,sourceChildId,sourcePointNumber,targetChildId,targetPointNumber,outputName,connectionData){
		this.content.connections = this.content.connections || {}
		connectionData = connectionData || {}
		connectionData.__json_object__ = true;
		this.content.connections[connID]={from:{child:sourceChildId,point:sourcePointNumber},outputName:outputName,to:{child:targetChildId,point:targetPointNumber},data:connectionData}
	};
	formDoc.prototype.setConnection = function (connID,sourceChildId,sourcePointNumber,targetChildId,targetPointNumber,outputName,connectionData){
		this.content.connections = this.content.connections || {}
		connectionData = connectionData || {}
		connectionData.__json_object__ = true;
		this.content.connections[connID]={from:{child:sourceChildId,point:sourcePointNumber},outputName:outputName,to:{child:targetChildId,point:targetPointNumber},data:connectionData}
	};
	formDoc.prototype.deleteConnection = function (connID){
		this.content.connections = this.content.connections || {}
		this.content.connections[connID] = undefined;
		var c = 0;
		for (k in this.content.connections){
			var v = this.content.connections[k]
			if (v)
			  c++
		}
		if(!c)
			this.content.connections=undefined;
	}
	
	formDoc.prototype.addControl = function ( controlId,data,parentControl,position){
		if (!parentControl.childs){
			parentControl.childs=[];
		}
		data.id = controlId;
		if(position!==undefined)
			parentControl.childs.splice(position,0,data);
		else
			parentControl.childs.push(data);
		
		this.setupIds();
	};

	formDoc.prototype.rmvControl = function ( controlId,parentControl){
		if(!parentControl){
			var n = this.findControlData(controlId);
			this.ids[n.node.type][n.node.id]=null;
			parentControl = n.parent;
		}
			
		if (parentControl.childs){
			for (var idx = 0;idx<parentControl.childs.length;idx++){
				if(parentControl.childs[idx].id === controlId){
					parentControl.childs.splice(idx,1);
				}
			}
		}
		this.setupIds();

	};
	
	formDoc.prototype.setControlData = function (controlId,data){
		var n = this.findControl(controlId);
		if(n){
			for (var idx in data){
				if(data.hasOwnProperty(idx)){
					n[idx] = data[idx];
				}
			}
		}
	};
	formDoc.prototype.beginControlIdTransaction = function(){
		this.idstemp = {}
	}
	formDoc.prototype.commitControlIdTransaction = function(){
		for (ctrlType in this.idstemp){
			for (id in this.idstemp[ctrlType]){
				this.ids[ctrlType][id] = this.idstemp[ctrlType][id]
			}
		}
		this.idstemp = {}
	}
	formDoc.prototype.cancelControlIdTransaction = function(){
		this.idstemp = {}
	}
	
	formDoc.prototype.generateControlId = function(ctrlType,allocate){
		var count = 1;
		var id = ctrlType;
		id=id.replace("ui.","");
		if(!this.ids[ctrlType]){
			this.ids[ctrlType]={};
		}
		if(!this.idstemp[ctrlType]){
			this.idstemp[ctrlType]={};
		}
		
			
		while (this.ids[ctrlType][id+count]){
			count++;
		}
		while (this.idstemp[ctrlType][id+count]){
			count++;
		}
		
		if(allocate===true){
			this.ids[ctrlType][id+count]=true;	// especialmente el configurador del tab necesita esto para 
												// obtener un nuevo id sin haber agregado el control al formulario}
			icc.console.log("new allocated id "+id+count)
		}
		this.idstemp[ctrlType][id+count]=true;	
		
		return id+count;
	};
	formDoc.prototype.checkControlId = function(ctrlType,controlId){
		return 	this.ids[ctrlType] && this.ids[ctrlType][controlId];
	};
	
	formDoc.prototype.getApplicationDocument = function(){
		return this.appDoc;
	};
	
	formDoc.prototype.getProperties = function () {
		if ( this.getVersion() > 1){
			return [
				{type: 'string', caption: 'BackColor', name: 'backColor'},
				{caption:'Style',type:'style',name:'style'}
//				{type: 'bool', caption:'FillWidth',name: 'fillWidth'},
//				{type: 'bool', caption:'FillHeight',name: 'fillHeight'}
			];

		}else{
			return [
				{type: 'string', caption: 'BackColor', name: 'backColor'},
				{caption:'Style',type:'style',name:'style'}
			];
		}
	};
	icc.ui.designer.formDoc = formDoc;
})(__icc__);


(function(icc){
	var  formView;
	
	
	formView = function(mainFrame,formDoc,options){
		var self = this;
		options = options || {}
		//options.withPropertiesPanel=true
		var controls = formDoc.controltypes;
		this.controls_map = {};
		
		var toolBoxButtons = [];
		var tool;
		var ctrlInfo;
		this.codeEditor = new icc.ui.codeeditor({fillWidth:true,fillHeight:true,multiLine:true,text:formDoc.getCodeBehind(),lineNumbers:true,language:"javascript",borderColor:'#dedede'});
		
		var editorTab = new icc.ui.panel({
			fillWidth:true,fillHeight:true,
			caption: _T("Code"),
			backColor:'#f4f4f4',
			pt:26,
			childs:[
				new icc.ui.hline({fillWidth:true,foreColor:'lightGray'}),
				
				this.codeEditor
			]
		})
		this.previewWindow = this.previewWindow();
		this.previewWindow.caption = _T("Preview");
		
//		var optionCode=new icc.ui.optionbutton({caption:_T('Code')});
//		var optionLayout=new icc.ui.optionbutton({caption:_T('Layout'),checked:true});
//		var optionRun = new icc.ui.optionbutton({caption:_T('Preview'),checked:true});
		for (var idx=0;idx<controls.length;idx++){
			
			ctrlInfo = controls[idx];
			this.controls_map[ctrlInfo.type]=ctrlInfo; 
			if (typeof ctrlInfo.icon == "function")
				ctrlInfo.icon = ctrlInfo.icon();

			if(ctrlInfo.icon && ctrlInfo.hidden !== true){
				tool = new icc.ui.designerTool({
					style:"applications.designer/toolbarbutton",
					icon:ctrlInfo.icon,
					tooltip:ctrlInfo.tooltip
				});
				tool.onRequestDropData((function(info){
					return function(){
						// crea una nueva instancia del control usando un el info de tipo
						var ctrldata ;
						if(typeof(info.defaults) == "function"){
							ctrldata = info.defaults(info)
						}else{
							ctrldata = info.defaults;
						}

						if(!ctrldata){
							ctrldata = {};
						}else{
							ctrldata = icc.utils.clone(ctrldata);
						}
						ctrldata.type = info.type;
						//-------------------
						// Aca se traducen siempre los labels de los controles mientras 
						// a los mismos se les realiza "drag & drop" desde la barra de herramientas hacia el formulario.
						if (ctrldata.caption) {
							ctrldata.caption = _T(ctrldata.caption);
						}
						if (ctrldata.type === "ui.tabpanel") {
							$.each(ctrldata.childs || [], function(_, tab) {
								if (tab.caption) {
									tab.caption = _T(tab.caption);
								}
							});
						}
						//-----------------
						self.getDocument().beginControlIdTransaction();
						var ctrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName());

						ctrl.create();
						return ctrl;
					};
				})(ctrlInfo));
				toolBoxButtons.push(tool);
			}
		}
		icc.ui.designer = icc.ui.designer || {};
		icc.ui.designer.extensions = icc.ui.designer.extensions || {}
		icc.ui.designer.extensions.formview = icc.ui.designer.extensions.formview || {}
		icc.ui.designer.extensions.formview.controls =  icc.ui.designer.extensions.formview.controls || []

		for (var idx=0;idx<icc.ui.designer.extensions.formview.controls.length;idx++){
			
			ctrlInfo = icc.ui.designer.extensions.formview.controls[idx];
			this.controls_map[ctrlInfo.type]=ctrlInfo; 
			if (typeof ctrlInfo.icon == "function")
				ctrlInfo.icon = ctrlInfo.icon();
				
			if(ctrlInfo.icon){
				tool = new icc.ui.designerTool({
					_appName:formDoc.getApplicationDocument().getName(),
					style:"applications.designer/toolbarbutton",
				    icon:ctrlInfo.icon,
					tooltip:ctrlInfo.tooltip
				});
				tool.onRequestDropData((function(info){
					return function(){
						// crea una nueva instancia del control usando un el info de tipo
						var ctrldata = info.defaults;// data a guardar en el doc
						if(!ctrldata){
							ctrldata = {};
						}else{
							ctrldata = icc.utils.clone(ctrldata);
						}
						ctrldata.type = info.type;
						//-------------------
						// Aca se traducen siempre los labels de los controles mientras 
						// a los mismos se les realiza "drag & drop" desde la barra de herramientas hacia el formulario.
						if (ctrldata.caption) {
							ctrldata.caption = _T(ctrldata.caption);
						}
						if (ctrldata.type === "ui.tabpanel") {
							$.each(ctrldata.childs || [], function(_, tab) {
								if (tab.caption) {
									tab.caption = _T(tab.caption);
								}
							});
						}
						//-----------------
						var ctrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName());
						ctrl.create();
						return ctrl;
					};
				})(ctrlInfo));
				toolBoxButtons.push(tool);

			}
		}

		var args = formDoc.getLayout();
		
		args.fillWidth=true;
		args.fillHeight=true;
	//	args.borderWidth=1;
	//	args.borderColor="#d7d7d7";
		
		if(args.childs !==undefined){
		
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],formDoc.getApplicationDocument().getName());
			}
		}
		
		this.mainPanel =new icc.ui.fixedLayoutDesigner(args);
		this.goUserCode(formDoc.getLayoutCode(),c,formDoc);
		var connections = formDoc.getConnections();
		this.designerHost = new icc.ui.designerHost({
			fillWidth:true,
			fillHeight:true,
			borderWidth:0,
			childs:[
				this.mainPanel
			],
			connections:connections
		});
		// Cambio de la seleccion actual , recibe una array
		this.designerHost.onSelectionChanged(function(newselection){

			formDoc.updateAllViews(this,"selection",newselection);
			
		});
		// Cuando se presiona delete el designerHost borra el control y dispara este evento
		this.designerHost.onRmvControl(function(ctrl,parent){
			formDoc.rmvControl(ctrl.id);
			formDoc.setDirty(true);
			formDoc.updateAllViews(this,"selection",[]);// con esto logra que la ventana de propiedades se borre

		});
		this.designerHost.onNewConnection(function(connectionID,connection){
			formDoc.addConnection(connectionID,connection.sourceChild,connection.sourcePoint,connection.targetChild,connection.targetPoint,connection.outputName,connection.aditionalData);
			formDoc.setDirty(true);
		})
		this.designerHost.onConnectionDeleted(function(connectionID){
			formDoc.deleteConnection(connectionID);
			formDoc.setDirty(true);
		});
		
		this.designerHost.onConnectionChanged(function(connectionID,connection){
			formDoc.setConnection(connectionID,connection.sourceChild,connection.sourcePoint,connection.targetChild,connection.targetPoint,connection.outputName,connection.aditionalData);
			formDoc.setDirty(true);
			
		});
		this.designerHost.onDblClick(function(ctrl){
			var properties = ctrl.getProperties(formDoc)
			for (var i = 0;i<properties.length;i++){
				var prop = properties[i]
				if(prop.type == "custom" || prop.type == "custom_np"){
					var data;
					var ctrlData = formDoc.findControlData(ctrl.id);
					if (ctrlData){			
						data = ctrlData.node
						
					}else{			// si no esta en el doc vemos si tiene el metodo getData y setData
									// si es asi es porque algo tiro un evento de cambio de seleccion que no
									// fue el documento , esto es una adaptacion retorcida para mostrar propiedades
									// de los botones correspontdientes a campos del reporte
									
						data = ctrl.getData();			
					}
					//(function(prop,data){
					var res = prop.customfn(formDoc, data,
						function (res) {
							if (res !== undefined) {	// undefined vale cuando por ejemplo el dialogo es cerrado desde la X
								var t = data[prop.name];
								data[prop.name]=res
								formDoc.setControlData(ctrl.id, data);
								formDoc.updateAllViews(self, "control-properties", {ctrl: ctrl, properties: data, name: prop.name,prevValue:t,Value:res});
								formDoc.setDirty(true);
								
							}
						}
					);
					//})(prop,data);
					break;
				}
			}
			
		});
		
		// Luego de que el usuario suelta el control se dispara este evento 
		// y se agrega efectivamente al documento.
		this.designerHost.onNewControl(function(ctrl,parent,undo){
			var node,parentNode;
			var properties = ctrl.getProperties(formDoc);
			var pr;
			
			parentNode = formDoc.findControl(parent.id);
			formDoc.addControl(ctrl.id,ctrl.persistentData,parentNode);
			formDoc.commitControlIdTransaction();
			// agrega la info de layout,en caso de ser un tabitem no tiene, porque no esta wrapeado
			if(typeof ctrl.getLayoutInfo === "function")
				formDoc.setControlData(ctrl.id,ctrl.getLayoutInfo());
			else
				formDoc.setControlData(ctrl.id,{});
			formDoc.setDirty(true);
			if(typeof undo === "undefined" || undo === false)
				formDoc.updateAllViews(this,"selection",[ctrl]);

		});
		// Cuando cambia de position se updatea el documento, recibe la lista
		// de controles movidos y el nuevo contenedor si es que hubo cambio.
		this.designerHost.onChangeCtrlPosition(function(ctrllist,newParent){
			var node,parentNode;
			for (var idx =0;idx < ctrllist.length;idx++){
				if(newParent){
					parentNode = formDoc.findControl(newParent.id);
					node = formDoc.findControl(ctrllist[idx].id);
					formDoc.rmvControl(ctrllist[idx].id);
					formDoc.addControl(ctrllist[idx].id,node,parentNode);
					formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
				}else{
					formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
				}
			}
			formDoc.updateAllViews(this,"poschanged",ctrllist);
			self.getDocument().setDirty(true);
		});
		// Se produjo un cambio en el zOrder de algun/os controles
		// dentro de un contenedor , los quita todos y los vuelve a inserar acorde
		// al orden de parent.childs
		this.designerHost.onZOrderChanged(function(parent){
		    // obtenemos todos los hijos del nodoparent correspondiente al parent
		    var nchilds = {};
		    var node,parentNode;
		    parentNode= formDoc.findControl(parent.id);
		    for (var idx=0;idx<parent.childs.length;idx++){
			nchilds[parent.childs[idx].id]=formDoc.findControl(parent.childs[idx].id,parentNode);
			formDoc.rmvControl(parent.childs[idx].id);
		    }
		    for (idx=0;idx<parent.childs.length;idx++){
				formDoc.addControl(parent.childs[idx].id,nchilds[parent.childs[idx].id],parentNode);
		    }
		    self.getDocument().setDirty(true);

		});
		var leftPanel = new icc.ui.panel({fillHeight:true,
			vs:10,
			childs:[
				new icc.ui.panel({layoutMode:'matrix',columns:options.withPropertiesPanel&&options.propertiesPanelSide!=="right"?7:2,pr:3,vs:3,hs:3,fillHeight:options.withPropertiesPanel?false:true,borderWidth:0,childs:toolBoxButtons}),
			
			]
		})
		var rightPanel = new icc.ui.panel({fillHeight:true,
			childs:[
			]
		}); 
		
		
		if(options.withPropertiesPanel){
			propertiesPanel = new icc.ui.designer.propertiesView(formDoc,{width:options.propertiesPanelWidth||243,background:'propertySheet3.png',showDocumentProperties:options.showDocumentProperties,in_document_properties_side:options.in_document_properties_side,borderWidth:1,borderColor:'lightgray'});
			if(options.propertiesPanelSide === "right"){
				rightPanel.childs.push(propertiesPanel)
			}else{
				leftPanel.childs.push(propertiesPanel)
				
			}
			
		}
		var designerPanel = new icc.ui.panel({
		    fillWidth:true,
		    fillHeight:true,
		    x:0,y:0,
		    pl:2,pr:6,pb:6,pt:2,
			caption:_T('Design'),
		    backColor:'#f4f4f4',
		    borderWidth:0,
		    childs:[
				new icc.ui.panel({
				   fillWidth:true,
				   layoutMode:'horizontal',
				   pl:options.withPropertiesPanel&& options.propertiesPanelSide !== "right"?248:74,
				   
				   childs:[
					new icc.ui.panel({
						pt:2,
						layoutMode:'horizontal',
						childs:[
							new icc.ui.framework.documentView.stdButtonCopy(mainFrame,{caption:'',tooltip:_T('Copy'),icon:'copyIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonPaste(mainFrame,{caption:'',tooltip:_T('Paste'),icon:'pasteIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonUndo(mainFrame,{caption:'',tooltip:_T('Undo'),icon:'undoIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"})
						]
					}),
					new icc.ui.designer.AlignToolbar(formDoc,{})
				   ]

				}),
				new icc.ui.panel({

					fillWidth:true,
					fillHeight:true,
					pl:1,
					pr:2,
					hs:2,
					
					backColor:'#f4f4f4',
					borderColor:'#dedede',

					layoutMode:'horizontal',
					childs:[
						leftPanel,
						this.designerHost,
						rightPanel
					]

				})/*,
				new icc.ui.hline({fillWidth:true})*/
		    ]
		});
		var cntx
		if(formDoc.content['class'] == "flow" ){
			cntx = designerPanel;
		}else{
			var _childs = []
			
			if(options.preview_window !== false)
				_childs.push(this.previewWindow)

			if(options.code_editor !== false)
				_childs.push(editorTab);
				
			_childs.push(designerPanel);

			cntx= new icc.ui.tabpanel({
				fillWidth:true,
				fillHeight:true,
				align:'right',
				childs:_childs,
				item:1
			});
			cntx.onChange(function(index,item){
				if(item === self.previewWindow)
					self.previewWindow.start();
			});
			jQuery(cntx.childs).each(function(idx,cl){
				cl.captionWidth=70;
			});
			cntx.onCreate(function(){
				setTimeout(function(){
					if(_childs.length == 1){
						cntx.setItem(0);
					}else
						cntx.setItem(2);
				},300);
			});
			
		}
		formView.SUPERconstructor.call(this,formDoc,{
			haveCloseButton:true,
			caption:formDoc.getName(),
			fillWidth:true,
			fillHeight:true,
			layoutMode:'horizontal',
			style:'applications/designer.designerFrame',
			backColor:'#f4f4f4',
			
			pt:2,
			pr:2,
			pl:5,
			pb:2,
			childs:[
			    new icc.ui.panel({fillHeight:true,borderWidth:0,fillWidth:true,
				
				vs:5,
				childs:[
//				    new icc.ui.panel({layoutMode:'horizontal',sideRight:true,childs:[optionLayout,optionCode]}),
				    cntx

				]
			    })
			]
		});
		this.codeEditor.onChange(function(text){
			formDoc.setCodeBehind(text);
		});
	

	
	};
	icc.utils.inherit(formView,icc.ui.framework.documentView.view);
	formView.prototype.getSelection = function() {
		// traslada la seleccion del designerHost
		return this.designerHost.getSelection();
	};
	formView.prototype.buildControl = function(ctrlData,appName){
		var map_data = this.controls_map[ctrlData.type];
		var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true}
		if(!ctrlData.id){
			ctrlData.id = this.getDocument().generateControlId(ctrlData.type);
		}

		var args = {};
		for (var idx in ctrlData){
			if(ctrlData.hasOwnProperty(idx)){
				args[idx]= ctrlData[idx];
			}
		}
		args._appName =appName;
		if(ctrlData.childs){
			var childs = [];
			for ( idx=0;idx<ctrlData.childs.length;idx++){
				childs.push(this.buildControl(ctrlData.childs[idx],appName));
			}
			args.childs = childs;
		}
		args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
		var res ;
		if(map_data){
			if(map_data.classdefaults){
				for(k in map_data.classdefaults){
					args[k]=map_data.classdefaults[k];
				}
			}
			res = new map_data.constructor(args,env);
			if(map_data.getProperties){
				res._getProperties = res.getProperties; // :>
				res.getProperties = map_data.getProperties;
				
			}
		}else{
			res = new icc.ui.panel(args);
		}
		
		return res;
	};
	formView.prototype.haveCopyPasteInfo=function(){
		return this.designerHost.getSelection().length!==0;
	};
	formView.prototype.getCopyPasteInfo=function(){
		var res;
		if(this.designerHost.getSelection().length!==0){
			var doc = this.getDocument();
			res = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				node = doc.findControl(ctrl.id);
				res.push(icc.utils.clone(node));
			});
		}
		return res;
	};
	formView.prototype.acceptCopyPasteInfo = function(info){
		// de momento solo se puede copiar dibujos asi que esto es siempre true
		
		return true;
	};
	// paste

	// paste
	formView.prototype.setCopyPasteInfo = function(info){
		var self = this;
		var doc = self.getDocument();
		info = icc.utils.clone(info);
		var fixPastedId = function(node){
			icc.console.log(" pasted node "+node.id)
			if(doc.checkControlId(node.type,node.id)){
				node.id = doc.generateControlId(node.type,true);
				icc.console.log("reallocated to "+node.id);

			}
			if(node.childs){
				jQuery.each(node.childs,function(idx,node){
					fixPastedId(node);
				});
			}
			
		}
		var build_pasted_control_tree = function (ctrlData,appName){
			
			var map_data = self.controls_map[ctrlData.type];
			var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true}

			var args = {};
			for (var idx in ctrlData){
				if(ctrlData.hasOwnProperty(idx)){
					args[idx]= ctrlData[idx];
				}
			}
			args._appName =appName;
			if(ctrlData.childs){
				var childs = [];
				for ( idx=0;idx<ctrlData.childs.length;idx++){
					childs.push(build_pasted_control_tree(ctrlData.childs[idx],appName));
				}
				args.childs = childs;
			}
			args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
			if(map_data){
				return new map_data.constructor(args,env);
			}else{
				return new icc.ui.panel(args);
			}
		};
			
		var ctrls = [];
		var pasteContainer = self.mainPanel;
		var currentSelection = self.designerHost.getSelection();
		if(currentSelection.length == 1){
			if(currentSelection[0].designerContainer || currentSelection[0].tabDesigner)
				pasteContainer = currentSelection[0];
			
				
		}
		if(pasteContainer.getActivePanel)
			pasteContainer = pasteContainer.getActivePanel();
			
		var minx=10e9
		var miny =10e9;
		
		jQuery.each(info,function(idx,nodeinfo){
			if(nodeinfo.x != undefined)minx = nodeinfo.x<minx?nodeinfo.x:minx;
			if(nodeinfo.y != undefined)miny = nodeinfo.y<miny?nodeinfo.y:miny;
		});
		var build_pasted_control= function(ctrlData,appName){
			self.getDocument().addControl(ctrlData.id,ctrlData,self.getDocument().findControl(pasteContainer.id));
			return build_pasted_control_tree(ctrlData,appName);
		};
		
		jQuery.each(info,function(idx,nodeinfo){
			fixPastedId(nodeinfo);
			if(nodeinfo.x !== undefined)
				nodeinfo.x = nodeinfo.x + ( 10 - minx);
			if(nodeinfo.y !== undefined)
				nodeinfo.y = nodeinfo.y + ( 10 - miny);
			var c = build_pasted_control(nodeinfo,self.getDocument().getApplicationDocument().getName());
			ctrls.push(c);
			c.create();
			
			pasteContainer.addChild(c);
			// esto es medio contra mano pero ...
			self.designerHost.addUndoAction(function(){
				self.designerHost.clearSelection();
				pasteContainer.rmvChild(c);
				pasteContainer.layout();
				self.designerHost.fireEvent("onRmvControl",c,pasteContainer);
			});
			
		});
		pasteContainer.layout();
		this.designerHost.setSelection(ctrls);
		self.getDocument().setDirty(true);// Esto se hace al final para que se prenda correctamente el boton deshacer
		return true;
	};
		
	formView.prototype.getUndoCount = function(){
		return this.designerHost.getUndoCount();
	};
	formView.prototype.goUndo = function(){
		this.designerHost.goUndo();
		this.getDocument().setDirty(true);
	};
	formView.prototype.goUserCode = function (src,layout,docInstance){
		var self = this;
		var maskedEval = function (scr,ctx) { 
				// set up an object to serve as the context for the code 
				// being evaluated.  
				var mask = {}; 
				// mask global properties  
		//		for (p in this) 
		//			mask[p] = undefined; 
				for (p in ctx){
					mask[p] = ctx[p];
				}
				// execute script in private context 
				try{
				(new Function( "with(this) { " + scr + "}")).call(mask); 
				}catch(e){
					alert(e);
				}
				
		} 		
		var mapControl = function (control,ctx){
			ctx[control.id] = control;
			if (control.childs){
				jQuery.each(control.childs,function(idx,control){
					mapControl(control,ctx);
				})
			}
		}
		var ctx = {
			thisForm:layout,
			designer:true,
			docInstance:docInstance
		}
		mapControl(layout,ctx)
		maskedEval(src,ctx);
	};
	formView.prototype.previewWindow = function(){
		var cntx;
		var self = this;
		var started = false;
		var params = [];
		var btnStart = new icc.ui.button({
			width:22,
			height:22,
			icon:'refresh_icon.png',
			style:'applications.designer/toolbarbutton'
		});
		var btnParams = new icc.ui.button({
			width:22,
			height:22,
			style:'applications.designer/toolbarbutton',
			icon:'settings.png'
		});
		var res = new icc.ui.panel({
			fillWidth:true,
			fillHeight:true,
			pr:3,
			backColor:'white',
			childs:[
				
				new icc.ui.panel({
					backColor:'#f4f4f4',
					layoutMode:'horizontal',
					fillWidth:true,
					pl:3,
					hs:2,
					pt:2,
					pb:2,
					pr:2,
					childs:[
						btnStart,
						btnParams
					]
				}),
				new icc.ui.hline({fillWidth:true,foreColor:'lightGray'})
				
			]
		});
		
		res.refresh = function(){
			var args =[];
			var url = location.href.split("/")
			url.pop();
			url.push(self.getDocument().getApplicationDocument().getName()+"."+self.getDocument().getName());
			url = url.join("/");
			jQuery.each(params,function(idx,param){
				args.push(param.name+"="+param.value);
			});
			args.push("debug=true");
			if(icc.utils.browser.is_ie)
				args.push("__tmstmp__="+new Date().getTime())
			url = url +"?"+args.join("&");
			

			
			if(cntx)
				res.rmvChild(cntx);
				
			cntx =  new icc.ui.iframe({
				offsetx:2,
				fillWidth:true,
				fillHeight:true,
				src:url
			});
			cntx.create();
			res.addChild(cntx);
			res.layout();

		};
		res.start = function(){
			if(!started)
				res.refresh();
			started=true;
		};
		btnStart.onClick(function(){
			res.refresh();
		});
		btnParams.onClick(function(){
			<%FRAME:assets.dlgLaunchParameters%>
			var dlg = new icc.ui.dialog({
				childs:[
					dlgLaunchParameters
				]
			});
			var t = []
			jQuery.each(params,function(idx,param){
				t.push({name:param.name,value:param.value,param:param});
			});			
			gdParams.items = t;
			dlg.create();
			dlg.showModal();

			
			params_cancel.onClick(function(){
				dlg.close(false);
			});
			
			
			params_ok.onClick(function(){
				self.getDocument().setExecutionParameters(params,function(status,result){
					if(status){
						dlg.close(true);
					}else{
						icc.ui.displayMessage(result);
					}
				})
				
			});
			var updateParamData = function(){
				var it = gdParams.getItem();
				var vname = icc.utils.trim(txParamName.getText());
				var vvalue = icc.utils.trim(txParamValue.getText());
				
				if(vname!=='' && vvalue!==''){
					btn_rmvParam.setEnabled(true);
					btn_addParam.setEnabled(true);
					if(it){
						it.name = vname;
						it.value = vvalue;
						it.param.value = vvalue
						it.param.name = vname
						gdParams.updateItem(it);
					}
				}else{
					btn_rmvParam.setEnabled(false);
					btn_addParam.setEnabled(false);
				}
		

			}
			txParamName.onChange(updateParamData)
			txParamValue.onChange(updateParamData)
			
			btn_addParam.onClick(function(){
				if(!gdParams.getItem()){
					var param = {name:txParamName.getText(),value:txParamValue.getText()};
					params.push(param);
					gdParams.addItem({name:param.name,value:param.value,param:param});
				}
				txParamName.setText("");
				txParamValue.setText("");
				btn_rmvParam.setEnabled(false);
				btn_addParam.setEnabled(false);
				gdParams.setItem({});
			});
			btn_rmvParam.onClick(function(){
				var it = gdParams.getItem();
				if(it){
					jQuery.each(params,function(idx,param){
						if(it.param === param){
							params.splice(idx,1);
							return false;
						}
					});
					gdParams.rmvItem(it);
					btn_rmvParam.setEnabled(false);
					btn_addParam.setEnabled(false);
					txParamName.setText("");
					txParamValue.setText("");
					
				}
				
			});
			gdParams.onChange(function(item){
				txParamName.setText(item.name);
				txParamValue.setText(item.value);
				btn_addParam.setEnabled(true);
				btn_rmvParam.setEnabled(true);
				
			});
		});
		res.onCreate(function(){
			params = self.getDocument().getExecutionParameters();
		});
		return res;
	};
	
	formView.prototype.onUpdate = function(sender,hint,data){
		var self = this;
		if(hint==="control-properties"){				// fueron seteadas las propiedades de un control
											// data tiene la forma de {ctrl:ctrl,properties:nuevosdatos}
			var newCtrl;						// No tenemos manera de que todos los controles dispongan de sus propiedades en tiempo de ejecucion
			var selection;					// por lo tanto destruimos el control y lo volvemos a crear en el lugar
			var childs =  [];
			var tchilds;
			var ctrl = data.ctrl.visibleControl?data.ctrl.visibleControl:data.ctrl;
			if(data.name === "childs"){
				// aca hay que hacer algo para optimizar , solo regenerar los childs sin regenerar todo
			}else{
				if(ctrl.childs && data.properties.childs){						// las sacamos del control
					for(var idx=ctrl.childs.length-1;idx>=0;idx--){	// hacia atras porque data.ctrl.childs se va alterando al remover
					
						childs.unshift(ctrl.childs[idx]);				// guarda una copia del control que saca
																			// unshift para mantener el mismo orden en que estaban
						ctrl.rmvChild(ctrl.childs[idx],false);	
						
					}
				}
				tchilds = data.properties.childs;// guardamos los childs para restorear despues
				data.properties.childs = null;		// no queremos que regenere todos los controles hijos de nuevo

			}
			newCtrl = this.buildControl(data.properties,this.getDocument().getApplicationDocument().getName());
			if(tchilds!==undefined)
				data.properties.childs = tchilds;// mantenemos la identidad del doc .
			newCtrl.create();
			if(childs.length){						// las agregamos al nuevo control
				for(idx=0;idx<childs.length;idx++){
					newCtrl.addChild(childs[idx]);
				}
				newCtrl.layout();
			}
			//Cuando seleccionamos un control y vamos tocando sus propiedades 
			// el control que viene en data siempre es el mismo
			// llevamos un track en visibleWidget del control que tenemos realmente insertado en el dibujo
			// que despues de la primera vez es distinto al que viene en data
			// como el control tocado esta seleccionado, borramos el dibujo de los handlers
			ctrl.parent.drawUnselected(this.designerHost,ctrl);
			// Cambiamos el control original por el nuevo
			ctrl.parent.replaceChild(ctrl,newCtrl);
			var sel = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				sel.push(ctrl);
			});
			this.designerHost.addUndoAction(function(){
				var d={};
				d[data.name]=data.prevValue;
				self.designerHost.selection = sel;
				self.getDocument().setControlData(ctrl.id,d);
				newCtrl.parent.drawUnselected(self.designerHost,newCtrl);
				newCtrl.parent.replaceChild(newCtrl,ctrl);
				ctrl.parent.drawSelected(self.designerHost,ctrl);
			});
			
			// obtenemos el array de seleccion del dibujador y cambiamos tambien ahi el control
			selection = this.designerHost.getSelection();
			for (idx = 0;idx<selection.length;idx++){
				if(selection[idx] === ctrl){
					selection[idx]=newCtrl;
				}
			}
			// este es el que tenemos insertado
			data.ctrl.visibleControl = newCtrl;
			// redibujamos todo y volvemos a prender los handlers que pueden estar ahora en distinta posicion
			// si el control cambio de tamaño por algo
			newCtrl.parent.layout();
			newCtrl.parent.drawSelected(this.designerHost,newCtrl);
			
		}else if (hint === "document-properties") {
			// propiedades del documento cambiaron lo creamos de nuevo
			this.designerHost.clearSelection();
			this.getDocument().updateAllViews(this,"selection",[]);
			var args = this.getDocument().getLayout();
			args.fillWidth=true;
			args.fillHeight=true;
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],this.getDocument().getApplicationDocument().getName())
			}			
			
			var cl = new icc.ui.fixedLayoutDesigner(args)
			cl.onCreate(function(){	// con esto evitamos que se ejecute el onCreate normal del form
				cl.fireEvent("onInitialize");
				return false;
			});
			cl.onInitialize = function(cb){
				cl.addListener("onInitialize",cb);
			}

			this.goUserCode(this.getDocument().getLayoutCode(),cl,this.getDocument());

			cl.create();
			this.designerHost.rmvChild(this.designerHost.childs[0])
			this.designerHost.addChild(cl);
			this.designerHost.layout();
		}
	};
	icc.ui.designer.formView = formView;
})(__icc__);





/*jslint evil:true */
/*global jQuery unescape window escape __icc__ setTimeout _T
*/

(function (icc) {
	var propertiesView;
	propertiesView = function (formDoc, args) {
		
		propertiesView.SUPERconstructor.call(this, formDoc, args);
		var self = this;
		
		this.propertySheetBackground = args.background;
		this.lineHeight = 18;
		this.captionWidth= 170;
		this.inputWidth = 50;

		this.objectProperties = new icc.ui.panel({
			background: args.background,
			fillHeight: true,
			fillWidth: true,
			caption:"selection",
			captionWidth:100,
			mustTranslate: true
		});
//		this.docProperties = this.buildPropertyWnd(undefined,formDoc,self.captionWidth,self.inputWidth,self.lineHeight);
		if(this.showDocumentProperties!==false){
			this.docProperties = new icc.ui.panel({
				background: args.background,
				fillHeight: true,
				fillWidth: true,
				caption:"document",
				captionWidth:100,
				mustTranslate: true
			});

			this.tabPanel = new icc.ui.tabpanel({
				fillWidth:true,
				fillHeight:true,
				tabStyle:'winDflt',
				borderColor:'#dedede',
				item:1,
				childs:[
					this.objectProperties,
					this.docProperties
				]
			});

			this.childs = [
				this.tabPanel
			];			
		}else{

			this.childs = [
				this.objectProperties			
			];			
		}
		
		
		//this.pl=2;
		//this.pt=2;
		this.fillHeight=true;
		this.fillWidth=true
		this.backColor="white";
		this.background=undefined;
			
		var posit = this.position;
		this.position = function (x,y,w,h){
			posit.call(this,x,y,w,h);
			this.inputWidth = w - this.captionWidth-22;
			
			if(this.docProperties && this.docProperties.childs.length == 0){
				
				var docprop = this.buildPropertyWnd(undefined, this.getDocument(),this.captionWidth,this.inputWidth,this.lineHeight);
				docprop.offsety=1;
				docprop.create();
				this.docProperties.addChild(docprop);
			}else{
				this.inputWidth+=5;
			}			
		}
	};
	icc.utils.inherit(propertiesView, icc.ui.framework.documentView.view);
	propertiesView.prototype.buildPropertyWnd = function (ctrl, formDoc,captionWidth,inputWidth,lineHeight) {
		var self = this;
		var properties;
		this.geometry_properties = [];
		this.brief_list = [];
		var stack = [];
		var callbacks = [];// callbacks a ejecutar cuando una propiedad cambia , ejemplo cambia el datasource y hay que actualizar los fields disponibles
		var ox=2;
		var oy=2;
		oy=1;
		var res = new icc.ui.panel({fillWidth:true, fillHeight: true,overflowy:'scroll',pl:0,pb:-5,
			//background:'propertySheet3.png'
			
			background: this.propertySheetBackground
		});
		
		var copyAndExpandProperties = function ( propertyList){
			var res = [];
			jQuery.each(propertyList,function(idx,prop){
				
				res.push(prop);
				if (prop.childs){
					var t = copyAndExpandProperties(prop.childs);
					jQuery.each(t,function(idx,prop){
						res.push(prop);
					});
				}
			});
			return res;
		};
		var cntx = new icc.ui.panel({
			fillWidth: true, 
			layoutMode: 'matrix', 
			pl:0,
			hs: 2, 
			vs: 0//, 
		//	pb: 2
			//background: this.propertySheetBackground
		});
		var data;
		if	(ctrl===undefined){
			properties = copyAndExpandProperties(formDoc.getProperties());
			var d = formDoc.getLayout();
			data = {type:"ui.panel"}; // para que la propiedad style pueda encontrar los estilos disponibles.
			jQuery.each(properties,function(idx,property){
				data[property.name]=d[property.name];
			});
		} else {
			properties = copyAndExpandProperties(ctrl.getProperties(formDoc));
			var ctrlData = formDoc.findControlData(ctrl.id);
			if (ctrlData){			
				data = ctrlData.node
				
			}else{			// si no esta en el doc vemos si tiene el metodo getData y setData
							// si es asi es porque algo tiro un evento de cambio de seleccion que no
							// fue el documento , esto es una adaptacion retorcida para mostrar propiedades
							// de los botones correspontdientes a campos del reporte
							
				data = ctrl.getData();
			}
		}
		var prop, input, panel,lb;

		if(ctrl){
			if (!data['#pragma:hideNameProperty']){
				cntx.childs.push(new icc.ui.label({height: lineHeight, caption: 'Name', width: captionWidth,offsetx:2, mustTranslate: true}));
				var txName = new icc.ui.textinput({height: lineHeight+2,y:-1, borderWidth: 0, text: data.id, width: inputWidth, backColor: 'transparent',readOnly:data.nameable == false,enabled:ctrl!==formDoc});
				cntx.childs.push(txName);
				txName.onBlur(function () {
					
					var self = this;
					var value = self.getText();
					if (value !== ctrl.id) {
						if (formDoc.changeControlId(ctrl.id, value)) {
							ctrl.id = value;
							data.id = value;
							formDoc.setDirty(true);
						} else {
							icc.ui.msgbox(_T("Invalid control name!"), null, null, function () {
								self.setText(ctrl.id);
								self.setFocus();
							});
						}
					}
				});
			}else{
				cntx.childs.push(new icc.ui.label({height: 2, caption: '', width: captionWidth,offsetx:2, mustTranslate: true}));
				cntx.childs.push(new icc.ui.label({height: 2, caption: '', width: inputWidth, mustTranslate: true}));
			}
		}
		var update = function (propertyName, propertyValue) {
			var t = data[propertyName];
			data[propertyName] = propertyValue;
			if(ctrl !== undefined){
				formDoc.setControlData(ctrl.id, data);
				formDoc.updateAllViews(self, "control-properties", {ctrl: ctrl, properties: data, name: propertyName,prevValue:t,Value:propertyValue});
			}else {
				var d = formDoc.getLayout();
				jQuery.each(data,function(idx,value){
					d[idx] = value;
				});
				formDoc.setLayout(d);
				formDoc.updateAllViews(self, "document-properties", {properties: data, name: propertyName});				
			}
			formDoc.setDirty(true);
			for (var i = 0;i < callbacks.length;i++) {
				callbacks[i]();
			}
			for ( var i = 0;i < self.brief_list.length;i++){
				if(self.brief_list[i].brief_fn){
				
					self.brief_list[i].brief_label.setCaption(self.brief_list[i].brief_fn(data));
					self.brief_list[i].brief_label.setTooltip(self.brief_list[i].brief_fn(data));
				}
			}
		};
		var fieldProperty=function(cntx,datasourcePropertyName,fieldPropertyName){
			
			items = [];	
			var buildfieldList = function (cb) {
				var items = [{text: icc.utils.combobox_nbsp}];
				if (data[datasourcePropertyName]) {
					var app = formDoc.getApplicationDocument();
					var datasources = app.getDatasources({outstreams:true});
					var found=false;
					for (var i = 0;i < datasources.length;i++) {
						if (datasources[i].name === data[datasourcePropertyName]) {
							found = true;
							var dsdoc = new icc.ui.designer.datasourceDoc(app.getVCCName(), app.getId(), data[datasourcePropertyName]);
							dsdoc.load(function (status) {
								if (status) {
									var fields = dsdoc.getAllFields();
									for (var n = 0;n < fields.length;n++) {
										items.push({text: fields[n].name, id: fields[n].name});
									}
									cb(items);
								} else {
									cb(items);
								}
							});
						}
					}
					/*
					if(!found){	// si no pudo encontrar el datasource puede ser un outstream
						// aca si exploramos todos los ds hasta encontrarlo ya que estan todos los datos cargados por el combo de datasources
						for (var i = 0;i < datasources.length;i++) {
								var dsdoc = new icc.ui.designer.datasourceDoc(app.getVCCName(), app.getId(), datasources[i].name);
								dsdoc.load(function (status) {
									if(status){
										var dsdata = dsdoc.getConfigData();
										if(dsdata.description.outstreams){
											for (i = 0;i<dsdata.description.outstreams.length;i++){
												var outstream = dsdata.description.outstreams[i]
												if(outstream.name===data[datasourcePropertyName]){
													for (var n = 0;n < outstream.indicators.length;n++) {
														items.push({text: outstream.indicators[n].name, id: outstream.indicators[n].name});
													}
													cb(items);
												}
											}
										}
									}
								})
						}
					}
					*/
				} else {
					setTimeout(function () {
						cb(items);
					});
				}
			};
			
			var input = new icc.ui.combobox({borderColor:'transparent',height: lineHeight, borderWidth: 0, width: inputWidth-2, items: items, item: data[prop.name]});
			var panel = new icc.ui.panel({height: lineHeight-2, offsety:-1,borderWidth: 0, width: inputWidth, pl: -1, pr: -1, pt: -2, overflow: 'hidden', backColor: 'transparent', childs: [input]});
			cntx.childs.push(panel);
			(
				function (input) {
					var currentds;
					input.onChange(function (idx, text, item) {
						update(fieldPropertyName, idx > 0 ? item.id:undefined);
					});
					var refreshFieldList = function () {
						if (data[datasourcePropertyName] !== currentds) {
							currentds = data[datasourcePropertyName]
							buildfieldList(function (items) {
								input.clearAll();
								input.addItem(items);
								input.setItem(data[fieldPropertyName]);
							});
						}
					};
					refreshFieldList();
					callbacks.push(refreshFieldList);
				}
			)(input);
		}		
		for (var idx = 0;idx < properties.length;idx++) {
			prop = properties[idx];
			if (!data['#hide:'+prop.name]){
				
				if(prop.type !== "endgroup" && prop.type !== "trigger-group" && prop.type !== "custom-panel"){
					cntx.childs.push(new icc.ui.label({height: lineHeight, caption: prop.caption, width: captionWidth,offsetx:ox, mustTranslate: true}));
				}
				switch (prop.type) {

				case "group":
					var btn = new icc.ui.button({caption: "", icon:'plus.gif',background:'white',hoverBackColor:'white',pressedBackColor:'white',backColor:'white',width: lineHeight, height: lineHeight,borderWidth:0,iconSide:'top'});
					var briefLabel = new icc.ui.label({width: inputWidth,height: lineHeight});
					var t = new icc.ui.panel({width: inputWidth,borderWidth:0,offsetx:-18,overflow:'visible',
						childs:[
							new icc.ui.panel({height: lineHeight,width: inputWidth,borderWidth:0,layoutMode:'horizontal',hs:4,
								childs:[
									btn,
									briefLabel
								]
							})
						]
					})
					cntx.childs.push(t);
					stack.push(cntx)
					cntx = new icc.ui.panel({visible:false,borderWidth:0,layoutMode:'matrix',pt:0,hs:2,vs:0,pb:0,offsetx:-155});
					t.childs.push(cntx);

					if(prop.brief_fn){
						briefLabel.caption = prop.brief_fn(data);
						briefLabel.tooltip = prop.brief_fn(data);
					};
					this.brief_list.push({brief_fn:prop.brief_fn,brief_label:briefLabel});
					ox+=10;
					oy+=3;
					(function (prop, data,cntx,topFrame) {
						btn.onClick(function () {
							cntx.setVisible(!cntx.getVisible());
							topFrame.layout();
							res.layout();
							if(cntx.getVisible()){
								this.setIcon("minus.gif");
								
							}else{
								this.setIcon("plus.gif");
							}
						});
					})(prop, data,cntx,t);
					
				break;
				case "bool-group":
					var btn = new icc.ui.button({caption: "", icon:'plus.gif',background:'white',hoverBackColor:'white',pressedBackColor:'white',backColor:'white',width: lineHeight, height: lineHeight,borderWidth:0,iconSide:'top'});
					var briefLabel = new icc.ui.label({width: inputWidth-14,height: lineHeight,offsetx:-3});
					var input = new icc.ui.checkbutton({offsety:-1,offsetx:icc.utils.browser.is_ie?0:-2,height: lineHeight, borderWidth: 0, width: 16, sideRight:true,checked:data[prop.name]});
					var t = new icc.ui.panel({width: inputWidth,borderWidth:0,offsetx:-18,overflow:'visible',
						childs:[
							new icc.ui.panel({height: lineHeight,width: inputWidth+18,borderWidth:0,layoutMode:'horizontal',hs:1,
								childs:[
									btn,
									briefLabel,
									input
								]
							})
						]
					});
					cntx.childs.push(t);
					stack.push(cntx)
					cntx = new icc.ui.panel({visible:false,borderWidth:0,layoutMode:'matrix',pt:0,hs:2,vs:0,pb:0,offsetx:-155});
					t.childs.push(cntx);

					ox+=10;
					oy+=2;
					(function (prop, data,input,btn,cntx,topFrame) {
						input.onChange(function (value) {
	//						cntx.setVisible(!cntx.getVisible());
							res.layout();
							/*
							if(cntx.getVisible()){
								btn.setIcon("minus.gif");
								
							}else{
								btn.setIcon("plus.gif");
							}
							*/
							if (value === false && prop['false-is-undefined']){
								update(prop.name, undefined);	
							}else{
								update(prop.name, value);	
							}
						});
						btn.onClick(function () {
							cntx.setVisible(!cntx.getVisible());
							topFrame.layout();
							res.layout();
							if(cntx.getVisible()){
								this.setIcon("minus.gif");
								
							}else{
								this.setIcon("plus.gif");
							}
						});
						
					})(prop, data,input,btn,cntx,t);
					
				break;
				case "trigger-group":
					res.childs.push(cntx)
					cntx = new icc.ui.panel({visible:(prop.value && data[prop.onproperty]==prop.value) || (prop.value == undefined && data[prop.onproperty]!=undefined),borderWidth:0,layoutMode:'matrix',pt:-1,hs:2,vs:0,pb:3});
					stack.push("trigger-group");
					ox+=10;
					oy+=3;
					(function (prop, data,input,cntx) {
						var upd = update;
						var myUpdate=function (propertyName, propertyValue) {
							if(propertyValue === "")
								propertyValue = undefined;
							upd(propertyName,propertyValue);
							if(propertyName == prop.onproperty){
							
								if(	(prop.value && data[prop.onproperty]==prop.value) || 
									(prop.value == undefined && data[prop.onproperty]!=undefined)){
									
									if(!cntx.getVisible()){
										cntx.setVisible(true);
										res.layout();
									}
								}else{
									if(cntx.getVisible()){
										cntx.setVisible(false);
										res.layout();
									}
								}
							}
						}
						update = myUpdate;
						setTimeout(function(){
						//	myUpdate(prop.name,data[prop.name]);
						},100);
					})(prop, data,input,cntx);
					
				break;
				
				case "endgroup":
					var t =stack.pop();
					if (t=="trigger-group"){
						res.childs.push(cntx);
						cntx = new icc.ui.panel({borderWidth:0,layoutMode:'matrix',hs:2,vs:0});
					}else{
						cntx = t;
					}
					ox-=10;
					oy-=3;
				break;
				
				case "style":
					var uiclass = prop['designer-style'] || data['designer-style'] || data['runtime-type'] || data.type
					uiclass = uiclass.substring(3);
					var appName = formDoc.getApplicationDocument().getName();
					input = new icc.ui.combobox({height: lineHeight, borderWidth: 0, width: inputWidth-(icc.utils.browser.is_ie?0:2),borderColor:'transparent'});
					panel = new icc.ui.panel({height: lineHeight-2, borderWidth: 0, offsety:-2,width: inputWidth, pl: -1, pr: -1, pt: -2, overflow: 'hidden', backColor: 'transparent', childs: [input]});
					cntx.childs.push(panel);
					var items =[{id:"__undefined",text:icc.utils.combobox_nbsp,value:undefined}];
					var t = icc.ui.themes[icc.ui.themeName][uiclass] || {}
					jQuery.each([
						icc.ui.themeName && icc.ui.themes[icc.ui.themeName] && icc.ui.themes[icc.ui.themeName][uiclass] ?icc.ui.themes[icc.ui.themeName][uiclass]:undefined,
						icc.ui.themeName && icc.ui.themes[icc.ui.themeName] && icc.ui.themes[icc.ui.themeName].apps && icc.ui.themes[icc.ui.themeName].apps[appName] && icc.ui.themes[icc.ui.themeName].apps[appName][uiclass] ?icc.ui.themes[icc.ui.themeName].apps[appName][uiclass]:undefined
						],function(idx,t){
							if(t){
								var o = t.styles || {}
								for (k in o){
									var st = o[k];
									items.push({
										id: k,
										text: _T(st._style_name || k),
										value: k
									});
								}
							}
						}
					)
					items.sort(function(item1,item2){
						return item1.text.localeCompare(item2.text);
					})
					input.items=items;
					input.item = data[prop.name];
					(function (prop, data) {
						input.onChange(function (idx,text,value) {
							update(prop.name,value.value);	
						});
					})(prop, data);
				break;
				case "option":
					
					input = new icc.ui.combobox({height: lineHeight, borderWidth: 0, width: inputWidth-(icc.utils.browser.is_ie?0:2),borderColor:'transparent'});
					panel = new icc.ui.panel({height: lineHeight-2, borderWidth: 0, offsety:-2,width: inputWidth, pl: -1, pr: -1, pt: -2, overflow: 'hidden', backColor: 'transparent', childs: [input]});
					cntx.childs.push(panel);
					if (prop.values){
						var items = [];
						if ( prop.allowBlank !== false ){
							items.push (
								{id:"__undefined",text:icc.utils.combobox_nbsp,value:undefined}
							);
						}
						var item =  data[prop.name] || prop['default'];
						jQuery.each(prop.values,function(idx,value){
							if (typeof(value) !== "object"){
								items.push({id:value,text:_T(value),value:value});
							}else{
								if(value.name){
									if(data[value.name] === value.value){
										item = value.name + value.value;
									}
								}
								items.push({
									id: value.name ? value.name + value.value : value.value,
									text: value.caption ? _T(value.caption) : _T(value.value),
									value: value.value,
									name: value.name
								});
							}
						});
						input.items=items;
						input.item = item;
						(function (prop, data) {
							input.onChange(function (idx,text,value) {
								for (idx = 0;idx<this.items.length;idx++){
									var item = this.items[idx];
									if (item.name){
										update(item.name,undefined);
									}
								}
								if(value.name)
									update(value.name,value.value);
								else
									update(prop.name,value.value);	
							});
						})(prop, data);
						
					}
					break;
				case "bool-true":	// es para valores que por defecto es true
					var enabled;
					if (data[prop.name] !== undefined) {
						enabled = data[prop.name];
					} else {
						enabled = true;
					}	
					input = new icc.ui.checkbutton({offsety:-1,offsetx:icc.utils.browser.is_ie?0:-2,height: lineHeight, borderWidth: 0, width: inputWidth, checked: enabled});
					(function (prop, data) {
						input.onChange(function (value) {
							update(prop.name, value === false ? value: undefined);	
						});
					})(prop, data);
					cntx.childs.push(input);
					break;				
				case "bool":
					input = new icc.ui.checkbutton({offsety:-1,offsetx:icc.utils.browser.is_ie?0:-2,height: lineHeight, borderWidth: 0, width: inputWidth, checked: data[prop.name]});
					(function (prop, data) {
						input.onChange(function (value) {
							if (value === false && prop['false-is-undefined']){
								update(prop.name, undefined);	
							}else{
								update(prop.name, value);	
							}
						});
					})(prop, data);
					cntx.childs.push(input);
					break;
					
				case "custom":
					var btn = new icc.ui.image({image:'property-select.png',iconSide:'top', width: 13, height: 16,offsetx:-2,offsety:-1, sideRight: true});
					panel = new icc.ui.panel({height: lineHeight, offsety:-1,borderWidth: 0, width: inputWidth, pr: 1, overflow: 'visible', backColor: 'transparent', childs: [btn]});
					cntx.childs.push(panel);
					(function (prop, data) {
						btn.onClick(function () {
							var res = prop.customfn(formDoc, icc.utils.clone(data),
								function (res) {
									if (res !== undefined) {	// undefined vale cuando por ejemplo el dialogo es cerrado desde la X
										update(prop.name, res);
									}
								}
							);
						});
					})(prop, data);
				break;
				
				case "custom-panel":
					res.childs.push(cntx)
					panel = new icc.ui.panel({offsety:-4,custom_panel:true,borderWidth: 0,fillWidth: true, pr: 15, overflow: 'visible', childs: []});
					res.childs.push(panel);
					cntx = new icc.ui.panel({borderWidth:0,layoutMode:'matrix',pt:0,hs:2,vs:0,pb:2});
					(function (prop, data,panel,topFrame) {
						
						prop.panelfn({
							set:function(name,value){
								if(name=="scroll"){
									res.overflowy=value==true?"scroll":"hidden"
									res.pr = value==true?0:-16;
									jQuery(res.getWnd()).css({
										overflowY:value==true?"scroll":"hidden"
									})
								}
							},
							update:function(propertyData){
								update(prop.name,propertyData)
							},
							layout:function(){
								panel.height=undefined;
								if(panel.fillHeight || panel._fillHeight){
									panel._fillHeight=true;
									var h = panel.getDefaultHeight()
									if(h>panel._h){
										panel.height=h;
										panel.fillHeight=undefined;
										var h = panel.height !== undefined ?panel.height:panel.getDefaultHeight()
										while((h % 18))h++;
										panel.height = h;
									}else{
										panel.height = undefined;
										panel.fillHeight=true
									
									}
								}else{
									var h = panel.height !== undefined ?panel.height:panel.getDefaultHeight()
									while((h % 18))h++;
									panel.height = h;
									
								}
								res.layout();

							}
						},formDoc, data,function(status,wnd){
							if(status){
								wnd.create();
								if(!panel.fillHeight){
									var h = wnd.height !== undefined ?wnd.height:wnd.getDefaultHeight()
									while((h % 18))h++;
									panel.height=h;
								
								}else {
									panel.height=undefined;
									panel.fillHeight=true;
								}
								wnd.height = undefined;
								wnd.fillHeight=true;

								// console.log(wnd.height)
								panel.addChild(wnd);
								panel.layout();
								//topFrame.layout();
								res.layout();
							}
						})
					})(prop, data,panel,t);
				break;
				case "custom_np": // custom no protejida ,igual que la otra pero no hace clone de los datos del control
						// usada para los custom dialogs del designer de flows
					var btn = new icc.ui.image({image:'property-select.png',iconSide:'top', width: 13, height: 16,offsetx:-2,offsety:-1, sideRight: true});
					panel = new icc.ui.panel({height: lineHeight, offsety:-1,borderWidth: 0, width: inputWidth, pr: 1, overflow: 'visible', backColor: 'transparent', childs: [btn]});
					cntx.childs.push(panel);
					(function (prop, data) {
						btn.onClick(function () {
							var res = prop.customfn(formDoc, data,
								function (res) {
									if (res !== undefined) {	// undefined vale cuando por ejemplo el dialogo es cerrado desde la X
										update(prop.name, res);
									}
								}
							);
						});
					})(prop, data);
					break;
				
				break;
				case "font":
					var fontText = function (font){
						var res = ""
						if (font === undefined){
							return _T("default")
						}
						if(font.family!==undefined){
							res +=font.family
						}
						if(font.size !== undefined){
							if(res.length){
								res+=","+font.size
							}else{
								res +=font.size
							}
						}
						if(font.weight!==undefined){
							if(res.length){
								res+=","+font.weight;
							}else{
								res+=font.weight;
							}
						}
						if(font.italic){
							if(res.length){
								res+=",Italic";
							}else{
								res+="Italic";
							}
						}
						if(res=== '')
							res = _T("default")
						return res;
					}
					btn = new icc.ui.image({image:'property-select.png',iconSide:'bottom', width: 13, height: 16, offsetx:-2,offsety:-1,sideRight: true});
					lb = new icc.ui.label({caption:fontText(data[prop.name || "font"]),height:lineHeight,fillWidth:true, mustTranslate: true})
					panel = new icc.ui.panel({layoutMode:'horizontal',offsety:-1,height: lineHeight, borderWidth: 0, width: inputWidth, pr: 1, overflow: 'visible', backColor: 'transparent', childs: [btn,lb]});
					cntx.childs.push(panel);
					(function (prop, data,lb) {
					
						btn.onClick(function () {
							<%FRAME:assets.fontConfig%>
							var face = "default";
							var size = "default";
							var weight = "default";
							var italic = false;
							var font;
							var df = data[prop.name || 'font']
							if (df) {
								face = df.family ? df.family:face;
								size = ''.concat(df.size ? parseInt(df.size, 10):size);
								weight = df.weight ? df.weight:weight;
								italic = df.italic ? df.italic:italic;
							}
							
							font_cbFace.item = face;
							font_cbFace.items = [
								{text: "default", id: "default"},
								{text: "arial", id: "arial"},
								{text: "arial black", id: "arial black"},
								{text: "comic sans ms", id: "comic sans ms"},
								{text: "courier", id: "courier"},
								{text: "courier new", id: "courier new"},
								{text: "cursive", id: "cursive"},
								{text: "georgia", id: "georgia"},
								{text: "helvetica", id: "helvetica"},
								{text: "impact", id: "impact"},
								{text: "palatino", id: "palatino"},
								{text: "times new roman", id: "times new roman"},
								{text: "trebuchet ms", id: "trebuchet ms"},
								{text: "verdana", id: "verdana"}
								
							];
							font_cbSize.item = size;
							font_cbSize.items = [
									{text: "default", id: "default"},
									{text: "8", id: "8"},
									{text: "9", id: "9"},
									{text: "10", id: "10"},
									{text: "11", id: "11"},
									{text: "12", id: "12"},
									{text: "13", id: "13"},
									
									{text: "14", id: "14"},
									{text: "15", id: "15"},
									
									{text: "16", id: "16"},
									{text: "17", id: "17"},
									
									{text: "18", id: "18"},
									{text: "19", id: "19"},
									
									{text: "20", id: "20"},
									{text: "22", id: "22"},
									{text: "24", id: "24"},
									{text: "26", id: "26"},
									{text: "30", id: "30"},
									{text: "32", id: "32"},
									{text: "36", id: "36"},
									{text: "40", id: "40"},
									{text: "48", id: "48"},
									{text: "52", id: "52"}
							];
							font_cbWeight.item = weight;
							font_cbWeight.items = [
									{text: "default", id: "default"},
									{text: "normal", id: "normal"},
									{text: "bold", id: "bold"}
							];
							font_ckItalic.checked=italic;
							var dlg = new icc.ui.dialog({
								caption: _T('Font selection'),
								childs: [
									fontConfig
								]
							});
							var updateData = function(){
								var item;
								font = {};
								item = font_cbFace.getItem();
								if (item.id !== "default") {
									font.family = item.id;
								}
								item = font_cbSize.getItem();
								if (item.id !== "default") {
									font.size = parseInt(item.id, 10);
								}
									
								item = font_cbWeight.getItem();
								if (item.id !== "default") {
									
									font.weight = item.id;
								}
								font.italic = font_ckItalic.getChecked();
							};
							font_btnOk.onClick(function () {
								updateData();
								dlg.close();
								update(prop.name || "font", font);
								lb.setCaption(fontText(font))
									
							});
							font_btnApply.onClick(function (){
								updateData();
								update(prop.name || "font",font);
								lb.setCaption(fontText(font));
							});
							font_btnCancel.onClick(function () {
								dlg.close();
							});
							dlg.create();
							dlg.showModal();
						});
					
					})(prop,data,lb);
					break;
				case "integer":
					input = new icc.ui.textinput({height: lineHeight, borderWidth: 0, text: parseInt(data[prop.name], 10),format:'fixed',decimals:0,align:'left', width: inputWidth, backColor: 'transparent'});
					(
						function (prop) {
							input.onChange(function (value) {
								var val = parseInt(value, 10)
								if(isNaN(val))
									val = undefined;
								update(prop.name,val);
							});
						}
					)(prop);
					cntx.childs.push(input);
					break;
				case "image":
					input = new icc.ui.textinput({height: lineHeight, borderWidth: 0, text: data[prop.name], width: inputWidth-lineHeight-1, backColor: 'transparent'});
					btn = new icc.ui.image({image:'property-select.png',iconSide:'bottom', width: 13, height: 16,offsety:-1, sideRight: true,offsetx:-2});
					panel = new icc.ui.panel({layoutMode:'horizontal',offsety:-1,height: lineHeight, borderWidth: 0, width: inputWidth, pr: 1,overflow: 'visible', backColor: 'transparent', childs: [input,btn]});
					cntx.childs.push(panel);
					(
						function (prop,input,btn) {
							input.onChange(function (value) {
								if (value === "") {
									value = undefined;
								}	
								update(prop.name, value);
							});
							btn.onClick(function(){
								var dlg = new icc.ui.designer.imageSelector(formDoc.getApplicationDocument(),data[prop.name]);
								dlg.create();
								dlg.showModal(function(item){
									if(item){
										input.setText(item.image);
										update(prop.name, item.image);
									}
								});
							});
						}
					)(prop,input,btn);
					
				break;
				case "color":
				
					input = new icc.ui.textinput({
						height: lineHeight, 
						borderWidth: 0, 
						text: data[prop.name], 
						width: inputWidth, 
						backColor: 'transparent',
						colorPicker: {
							required	: false,
							refine		: false,
							hash		: true
						}
					});
					(
						function (prop) {
							input.onChange(function (value) {
								if (value === "") {
									value = undefined;
								}else{
									if(!icc.utils.validateColor(value))
										value = undefined;
								}
								update(prop.name, value);
							});
						}
					)(prop);
					cntx.childs.push(input);
					break;
			
				case "string":
					input = new icc.ui.textinput({height: lineHeight, borderWidth: 0, text: data[prop.name], width: inputWidth, backColor: 'transparent'});
					(
						function (prop) {
							input.onChange(function (value) {
								
								if (value === "") {
									value = undefined;
								}else
									value.replace(/\\\\n/, '\n');							
								update(prop.name, value);
							});
						}
					)(prop);
					cntx.childs.push(input);
					break;					
				case "mlstring":
					var vl = data[prop.name];
					if (vl!==undefined)
						vl = vl.replace(/\n/g, '\\n');
					input = new icc.ui.textinput({height: lineHeight, borderWidth: 0, text: vl, width: inputWidth, backColor: 'transparent'});
					(
						function (prop) {
							input.onChange(function (value) {
								
								if (value === "") {
									value = undefined;
								}else
									value = value.replace(/\\n/g, '\n');							
								update(prop.name, value);
							});
						}
					)(prop);
					cntx.childs.push(input);
					break;
					
				case "literal":
					input = new icc.ui.textinput({height: lineHeight, borderWidth: 0, text: data[prop.name] ? data[prop.name]:ctrl[prop.name], width: inputWidth, backColor: 'transparent'});
					(
						function (prop) {
							input.onChange(function (value) {
								update(prop.name, value);
							});
						}
					)(prop);
					cntx.childs.push(input);
				break;
				case "ctrlbind":
					var items = [{text: icc.utils.combobox_nbsp}];
					var ctrls = formDoc.getBindableControls(prop.bindClass);
					for (var i = 0;i < ctrls.length;i++) {
						// Este no pasa por la _T
						items.push({id: ctrls[i].id, text: ctrls[i].id});
					}
					var input = new icc.ui.combobox({height: lineHeight, borderWidth: 0, width: inputWidth-(icc.utils.browser.is_ie?2:2),borderColor:'transparent', items: items, item: data[prop.name]});
					var panel = new icc.ui.panel({height: lineHeight-1, borderWidth: 0, width: inputWidth, offsety:-2,pl: -1, pr: -1, pt: -1, overflow: 'hidden', backColor: 'transparent', childs : [input]});
					cntx.childs.push(panel);
					(
						function (prop, data) {
							input.onChange(function (idx, text, item) {
								update(prop.name, idx > 0 ? item.id:undefined);
							});
						}
					)(prop, data);
				break;
				case "datasource":{
					var items = [{text: icc.utils.combobox_nbsp}];
					var app = formDoc.getApplicationDocument();
					var datasources = app.getDatasources({outstreams:true});
					for (var i = 0;i < datasources.length;i++) {
						// Este no pasa por la _T
						items.push({id: datasources[i].name, text: datasources[i].name});
					}
					var input = new icc.ui.combobox({height: lineHeight, borderWidth: 0, width: inputWidth-(icc.utils.browser.is_ie?2:2),borderColor:'transparent', items: items, item: data[prop.name]});
					var panel = new icc.ui.panel({height: lineHeight-2, borderWidth: 0, width: inputWidth, offsety:-2,pl: -1, pr: -1, pt: -1, overflow: 'hidden', backColor: 'transparent', childs : [input]});
	/*				
					(
						function(app,datasources,input,prop){
							setTimeout(function(){
								var loadNext = function(){
									var dsentry = datasources.shift();
									if(dsentry){
										var dsdoc = new icc.ui.designer.datasourceDoc(app.getVCCName(), app.getId(), dsentry.name);
										dsdoc.load(function (status) {
											if (status) {
												var dsdata = dsdoc.getConfigData();
												if (dsdata.description.outstreams){
													for (var i = 0;i<dsdata.description.outstreams.length;i++){
														input.addItem({id: dsdata.description.outstreams[i].name, text: dsdata.description.outstreams[i].name})
													}									
												}
											}
											loadNext();	
										})
										
									}else{
										input.setItem(data[prop.name]);
									}
								}
								loadNext();
							},50)
							
						}
					)(app,datasources,input,prop);
	*/				
					cntx.childs.push(panel);
					(
						function (prop, data) {
							input.onChange(function (idx, text, item) {
								update(prop.name, idx > 0 ? item.id:undefined);
							});
						}
					)(prop, data);
					}
					break;
				case "field":
					fieldProperty(cntx,prop.src!==undefined?prop.src:"datasource",prop.name)
				break;
				
				
				case "geometry":
				
					input = new icc.ui.textinput({height: lineHeight, borderWidth: 0, text: parseInt(data[prop.name], 10),format:'integer',align:'left', width: inputWidth, backColor: 'transparent'});
					(
						function (prop) {
							var tmout;
							input.onChange(function (value) {
								var val = parseInt(value, 10)
								if(isNaN(val))
									val = undefined;
								if(tmout!==undefined)
									clearTimeout(tmout);
								tmout = setTimeout(function(){
									update(prop.name,val);
									tmout = undefined;
								},1000);
							});
						}
					)(prop);
					cntx.childs.push(input);
				
					this.geometry_properties.push({name:prop.name,property:prop,input:input});
					
				break;
				case "action":
					var templateDefaultItems = [
						{text: icc.utils.combobox_nbsp},
						{text:_T('Ok')              , id:'ok'          , include_in_project_type: null              },
						{text:_T('Close')           , id:'close'       , include_in_project_type: {"generic": false}},
						{text:_T('Save all')        , id:'save-all'    , include_in_project_type: null              },
						{text:_T('Save and close')  , id:'save-close'  , include_in_project_type: {"generic": false}},
						{text:_T('Cancel all')      , id:'cancel-all'  , include_in_project_type: null              },
						{text:_T('Cancel and close'), id:'cancel-close', include_in_project_type: {"generic": false}}
					];
					/* ----------------------------------------------------------------
						Clean up de los elementos default a cargar en el combo "Action".
						En si, lo que se realiza es NO cargar los items de tipo "close", para los proyectos de tipo genericos.
					*/
					var defaultItems = [];
					var app = formDoc.getApplicationDocument();
					var catalog = app ? app.getCatalog() : undefined;

					for (var i = 0; i < templateDefaultItems.length; i++) {
						var can_include = true;
						var t = templateDefaultItems[i];
						if (t.include_in_project_type) {
							for (var project_id in t.include_in_project_type) {
								if (t.include_in_project_type.hasOwnProperty(project_id)) {
									if ((catalog.appClass || "").toLowerCase() === project_id.toLowerCase()) {
										can_include = t.include_in_project_type[project_id];
										break;
									}
								}
							}
						}
						if (can_include) {
							defaultItems.push(t);
						}
					}
					//---------------------------------------------------------------

					items = defaultItems;
					var buildActionList = function (cb) {
						var items = [{text: icc.utils.combobox_nbsp}];
						if (data.datasource) {
							var datasources = app.getDatasources({outstreams:true});
							for (var i = 0;i < datasources.length;i++) {
								if (datasources[i].name === data.datasource) {
									var dsdoc = new icc.ui.designer.datasourceDoc(app.getVCCName(), app.getId(), data.datasource);
									dsdoc.load(function (status) {
										if (status) {
											var actions = dsdoc.getActions();
											for (var n = 0;n < actions.length;n++) {
												items.push({text: _T(actions[n].caption), id: actions[n].name});
											}
											items.push({text:_T('Search using'),id:'search-',caption:_T('Search using')});
											items.push({text:_T('Add using'),id:'add-',caption:_T('Add using')});
											items.push({text:_T('Edit using'),id:'edit-',caption:_T('Edit using')});
											items.push({text:_T('View using'),id:'view-',caption:_T('View using')});
											items.push({text:_T('Browse using'),id:'browse-',caption:_T('Browse using')});
											
											cb(items);
										} else {
											cb(items);
										}
									});
								}
						
							}
						} else {
							setTimeout(function () {
								jQuery.each(defaultItems,function(idx,item){
									items.push(item);
								});
								cb(items);
							});
						}
					};
					input = new icc.ui.combobox({borderColor:'transparent',height: lineHeight, borderWidth: 0, width: inputWidth-2, items: items, item: data[prop.name]});
					panel = new icc.ui.panel({height: lineHeight-2, borderWidth: 0,offsety:-2, width: inputWidth, pl: -1, pr: -1, pt: -2, overflow: 'hidden', backColor: 'transparent', childs: [input]});
					cntx.childs.push(panel);
					(
						function (prop,input) {
							var currentds;
							input.onChange(function (idx, text, item) {
								if(item.id == "search-" || item.id == "edit-" || item.id == "add-" || item.id == "view-" || item.id == "browse-"){
									<%FRAME:assets.actionUsingDlg%>
									var items = []
									jQuery(formDoc.getApplicationDocument().getViews()).each(function(idx,view){
										items.push({text:_T(view.name)});
									});
									jQuery(formDoc.getApplicationDocument().getReports()).each(function(idx,view){
										items.push({text:_T(view.name)});
									});
									
									cbActDlgName.items = items;
									var dlg = new icc.ui.dialog({
										caption:_T("Select form to use"),
										childs:[actionUsingDlg]
									})
									dlg.create();
									btnOkActDlg.beforeClick(function(){
										var r = cbActDlgName.performValidation(true);
										return r.code ==0;
									});
									dlg.onClose(function(result){
										
										if(result){
											var i = cbActDlgName.getItem();
											update(prop.name, item.id+i.text);
											input.setText(item.caption+i.text);
										}else{
											update(prop.name,undefined)
											input.setItem(-1);

										}
									
									});
									/*
									icc.ui.msginput("dialog name",'',140,'Enter dialog name',function(status,text){
										
										if(status=="ok"){
										
											update(prop.name, item.id+text);
											input.setItem(-1);
											input.setText(item.caption+text);
										}else{
											update(prop.name,undefined)
											input.setItem(-1);
										}
									});
									*/
									dlg.showModal();
								}else
									update(prop.name, idx > 0 ? item.id:undefined);
							});
							var refreshActionsList = function () {
								if (data.datasource !== currentds) {
									currentds = data.datasource;
									buildActionList(function (items) {
										input.clearAll();
										input.addItem(items);
										input.setItem(data[prop.name]);
										if (!input.getItem() && data[prop.name]!==undefined){
											input.setText(data[prop.name]);
											var r = new RegExp("[^-]+-");
											var act = data[prop.name].match(r)
											if(act){
												input.setItem(act[0]);
												var it = input.getItem();
												if(it){
													input.setText(it.caption + data[prop.name].substr(act[0].length));
												}
											}else{
												input.setText("");
											}
										}
										
									});
								}
							};
							refreshActionsList();
							callbacks.push(refreshActionsList);
						}
					)(prop,input);
					break;
				}
			}
		}
		
		if (res.childs.length && res.childs[res.childs.length-1].custom_panel && !cntx.childs.length){
			res.childs[res.childs.length-1].height=undefined;
			res.childs[res.childs.length-1].fillHeight = true;
		}//else
		
		
		res.childs.push(cntx);
			
		//cntx.fillHeight = true;
		res.onCreate(function(){
			if(!icc.utils.browser.is_ie){
				jQuery(this.getWnd()).scroll(function(){
				
					jQuery(res.getWnd()).css({
						backgroundPosition: (-jQuery(res.getWnd()).scrollLeft())+"px " + (-jQuery(res.getWnd()).scrollTop())+"px " 
					});
				})
			}
		});
		return res;
	};
	propertiesView.prototype.onUpdate = function (sender, hint, data) {
		var self = this;
		window.setTimeout(function() {
			if (hint === "selection") {
				$(".colorPicker").remove();
				if (self.currentWnd) {
					if (data.length === 1 && data[0].id === self.currentId) {
						return;
					}
					self.objectProperties.rmvChild(self.currentWnd);
					self.currentWnd = null;
				}
				if (data.length === 1) {
					self.currentId = data[0].id;
					self.currentWnd = self.buildPropertyWnd(data[0], self.getDocument(),self.captionWidth,self.inputWidth,self.lineHeight);
					self.currentWnd.create();
					self.objectProperties.addChild(self.currentWnd);
					if(self.tabPanel)
						self.tabPanel.setItem(0);

				}else{

					self.currentId=undefined;
					if(self.tabPanel)
						self.tabPanel.setItem(1);
				}
				self.objectProperties.layout();	
				if(self.docProperties)
					self.docProperties.layout();
			}
			else if(hint === "poschanged"){
				// se movio el control que estamos mostrando sus propiedades ?
				if(data.length === 1 && data[0].id === self.currentId){
					ctrl_data = self.getDocument().findControlData(data[0].id).node;
					jQuery.each(self.geometry_properties,function(idx,data){
						data.input.setText(ctrl_data[data.property.name]);
					});
					jQuery.each(self.brief_list,function(idx,data){
						if(data.brief_fn){
							data.brief_label.setCaption(data.brief_fn(ctrl_data));
							data.brief_label.setTooltip(data.brief_fn(ctrl_data));
						}

					});

				}
			}
		}, 10);
	};
	icc.ui.designer.propertiesView = propertiesView;
})(__icc__);


/*jslint evil:true */
/*global jQuery unescape window escape __icc__
*/

(function(icc){
	icc.ui.designer.dsintrospection = {};
	//Obtengo los nombres de las db para el vcc
	icc.ui.designer.dsintrospection.mssql_builtin_config  = function(vcc, callback = $.noop){
		jQuery.ajax({
			url: 'designer/datasources/introspect/builtin_config',
			type: 'POST',
			data: JSON.stringify({vcc : vcc}),
			contentType: "application/json",
			async:false,
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				callback(true, ajaxResponse.data)
			},
			error:function(ajaxError){
				callback(false)
			}
		});
	};
	
	
	// obtiene los parametros de un stored procedure ,enviando los datos de conexion al sql server y su nombre
	icc.ui.designer.dsintrospection.mssql_proc_params= function (privateData,spName,cb){
		// arma un post que envia los private data para autentificar en el sql y en la url pone el nombre del procedimiento
		jQuery.ajax({
			url: 'designer/datasources/introspect/mssql/proc/'+spName,
			type: 'POST',
			async: true,
			dataType:'json',
			data: JSON.stringify(privateData),
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});

	};
	icc.ui.designer.dsintrospection.mssql_proc_columns = function (privateData,spName,cb){
		// obtiene los parametros del stored procedure 
		// si tiene se muestra un dialogo para que el usuario complete los mismos
		// manda a su contraparte del server los parametros y este ejecuta el procedimiento.
		// cualquier resultado es descartado devolviendo la lista de columnas obtenidas con sus tipos
		// ejecuta el callback con la data obtenida

		var dlg;
		var retrieveStoredOutput = function(privateData,spName,params,cb) {
			jQuery.ajax({
				url: 'designer/datasources/introspect/mssql/proc_columns/'+spName,
				type: 'POST',
				async: true,
				dataType:'json',
				data: JSON.stringify({'private':privateData,'params':params}),
				contentType: "application/json",
				beforeSend: function (request) {
					request.setRequestHeader('Content-Encoding', 'utf-8');
				},
				success: function(ajaxResponse){
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				},
				error:function(ajaxError){
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
				}
			});
			
		};
		icc.ui.designer.dsintrospection.mssql_proc_params(privateData,spName,function(status,result){
		
			if (status){
				var childs = [];
				
				if (result.length>0){
					var btnOk = new icc.ui.button({caption:_T('Ok')});
					var btnCancel = new icc.ui.button({caption:_T('Cancel')});
					var paramsInputs = [];
					jQuery.each(result,function(idx,param){
						var w,tmp;
						switch(param.typeName){
							case "int":
								w = 50;
							break;
							case "datetime":
								w = 80;
							break;
							default:
								w = param.MaxLength * 9;// no hay manera de limitar un textinput 
								w = w>220?220:w;		// asi que damos un ancho +o- no mayor a 220
							
						}
						
						
						childs.push(new icc.ui.label({caption:param.ParamName}));
						tmp = new icc.ui.textinput({width:w});
						childs.push(tmp);
						paramsInputs.push(tmp);
						childs.push(new icc.ui.label({caption:icc.utils.sprintf("%s (%d) ",param.typeName,param.MaxLength)}));
					});
					
					dlg = new icc.ui.dialog({
						vs:4,
						caption:_T('Stored procedure execution parameters'),
						childs:[
							new icc.ui.panel({
								hs:3,vs:3,
								pl:4,pt:4,pb:4,pr:4,
								layoutMode:'matrix',
								columns:3,
								childs:childs
							}),
							new icc.ui.hline({fillWidth:true}),
							new icc.ui.panel({
								layoutMode:'horizontal',
								hs:4,
								uniformWidth:true,
								centerX:true,
								childs:[
									btnOk,
									btnCancel
								]
							})
						]
					});
					btnCancel.onClick(function(){
						dlg.close();
						if(cb){
							cb(false);
						}
					});
					btnOk.onClick(function(){
						var params = []
						jQuery.each(paramsInputs,function(idx,textbox){
							params.push(textbox.getText());
						});
						retrieveStoredOutput(privateData,spName,params,function(status,result){
							if(status){
								// retorna en data las columnas
								dlg.close();
								if(cb){
									cb(true,result);
								}
							}else{
								if(result.code !== 1019){
									icc.ui.msgbox(result.description);
								}else{
									icc.ui.displayMessage(result);
								}
							}
						});
					});
					dlg.create();
					dlg.showModal();
				}else{
					retrieveStoredOutput(privateData,spName,[],function(status,result){
						if(status){
							// retorna en data las columnas
							if(cb){
								cb(true,result);
							}
						}else{
							if(result.code !== 1019){
								icc.ui.msgbox(result.description);
							}else{
								icc.ui.displayMessage(result);
							}
						}
					});
				

				}
				
			}else{
				if(cb){
					cb(false,result);
				}
			}
		});
		
		
	};
	
	
	// obtiene las columnas de una tabla ,enviando los datos de conexion al sql server y su nombre
	icc.ui.designer.dsintrospection.mssql_table_columns = function (privateData,tableName,cb){
		
		const private_columns = {
			builtin: {
				ic_timestamp : true
			}
		};
		
		const removePrivateColumns = function( status, list) {

			if (!status) {
				return result;
			}

			let result = []
			jQuery.each(list,function(idx,column){

				if(!(private_columns[privateData.dbms] && private_columns[privateData.dbms][column.ColumnName]))
				{
					result.push(column);
				}

			});
			return result;
		};
		
		// arma un post que envia los private data para autentificar en el sql y en la url pone el nombre de la tabla
	    jQuery.ajax({
			url: 'designer/datasources/introspect/mssql/table/'+tableName,
			type: 'POST',
			async: true,
			data: JSON.stringify(privateData),
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,removePrivateColumns(ajaxResponse.status, ajaxResponse.result));
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});

	};
	// obtiene la lista de stored procedures y tablas de un sql server , enviando los datos de conexion
	icc.ui.designer.dsintrospection.mssql_list= function (privateData,cb){
		// arma un post que envia los private data para autentificar en el sql
	    jQuery.ajax({
			url: 'designer/datasources/introspect/mssql/lista',
			type: 'POST',
			async: true,
			data: JSON.stringify(privateData),
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	};
})(__icc__);

/*jslint evil:true */
/*global jQuery  __icc__
*/

(function(icc){
    var  datasourceDoc;
	var dscache={};
    datasourceDoc = function(vccName,appId,sourceName){
        this.sourceName =sourceName;
        this.vccName = vccName;
        this.appId = appId;

        datasourceDoc.SUPERconstructor.call(this);
    };
	datasourceDoc.clearDSCache = function(appId,dsName){
		if (appId && dsName){
			dscache[appId+dsName]=undefined;
		}else{
			dscache={};
		}

	};
    icc.utils.inherit(datasourceDoc,icc.ui.framework.documentView.document);
    datasourceDoc.prototype.getName = function(){
        return this.sourceName;
    };
	datasourceDoc.prototype.setName = function(newName){
        this.sourceName = newName;
    };
	datasourceDoc.prototype.getOutStreams = function(){
		if(this.content.description.outstreams){
			return icc.utils.clone(this.content.description.outstreams);
		}else
			return [];
	};
	datasourceDoc.prototype.loadFromCache = function(){
		var c = dscache[this.appId+this.sourceName];
		if(c){
			this.content = c;
			if(this.content.description.filters === undefined)
				this.content.description.filters = [];
		}
		return c != undefined;
	};
    datasourceDoc.prototype.load=function(cb){
        var self = this;
		var result = false;
		var c = dscache[this.appId+this.sourceName];
		if(!c){
			// recorremos el cache buscando un datasource que tenga outstreams
			jQuery.each(dscache,function(idx,dsdata){
				if(dsdata && dsdata.description.outstreams){
					for (var i = 0;i<dsdata.description.outstreams.length;i++){
						var outstream = dsdata.description.outstreams[i];
						if(outstream.name == self.sourceName){
							c = dsdata;
							return false; // break the each
						}
					}
				}
			});
		}
		if(!c){

			jQuery.ajax({
				async:cb!==undefined,
				url: "designer/applications/"+this.appId+"/datasources/"+this.sourceName,
				dataType:"json",
				success: function(ajaxResponse){
					if(ajaxResponse.status){
						dscache[self.appId+self.sourceName]=icc.utils.clone(ajaxResponse.result);
						self.content = ajaxResponse.result;
						if(self.content.description.filters === undefined)
							self.content.description.filters = [];
						result = true;
					}
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}

				},
				error:function(ajaxError){
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
				}
			});
		}else{
			result = true;
			self.content = c;
			if(self.content.description.filters === undefined)
				self.content.description.filters = [];

			if(cb){
				setTimeout(function(){
					cb(true,c);
				},100);
			}
		}
		return result;

    };
    datasourceDoc.prototype.getActions=function(){
        var res = [];
		if(this.content.name == this.sourceName){

			if(this.content.description.retrieve.enabled){
				res.push({
					name:"move-prev",
					caption:"Prev"
				});
				res.push({
					name:"move-next",
					caption:"Next"
				});
				res.push({
					name:'refresh',
					caption:'Refresh'
				});
				res.push({
					name:'export',
					caption:'Export'
				});

			}
			if(this.content.description.store.enabled){
				res.push({
					name:"add",
					caption:"New"
				});
				res.push({
					name:"save",
					caption:"Save"
				});

				res.push({
					name:"cancel",
					caption:"Cancel"
				});
			}
			if(this.content.description.update.enabled){
				res.push({
					name:"edit",
					caption:"Edit"
				});
				if(!this.content.description.store.enabled){
					res.push({
						name:"save",
						caption:"Save"
					});

					res.push({
						name:"cancel",
						caption:"Cancel"
					});
				}
			}
			if(this.content.description['delete'].enabled){
				res.push({
					name:"delete",
					caption:"Delete"
				});
			}
		}else{
			if(this.content.description.outstreams){
				for(var i = 0;i< this.content.description.outstreams.length;i++){
					var outstream = this.content.description.outstreams[i];
					if (outstream.name == this.sourceName){
						res.push({
							name:"move-prev",
							caption:"Prev"
						});
						res.push({
							name:"move-next",
							caption:"Next"
						});
						res.push({
							name:'refresh',
							caption:'Refresh'
						});
						res.push({
							name:'export',
							caption:'Export'
						});
					}
				}
			}
		}
		return res;
    };
    datasourceDoc.prototype.getFields=function(){
		var res = [];
		if(this.content.name == this.sourceName){
			var temp = icc.utils.clone(this.content.description.columns);
			jQuery.each(temp,function(idx,column){
				if (!column.hidden){
					res.push(column);
				}
			});

		}else{/*
			if(this.content.description.outstreams){
				for(var i = 0;i< this.content.description.outstreams.length;i++){
					var outstream = this.content.description.outstreams[i];
					if (outstream.name == this.sourceName){
						if(outstream.type == "summary"){

							// devolvemos los campos del outstream
							var indicators = outstream.description.indicators || []
							for (j = 0;j< indicators.length;j++){
								if(!indicators[j].hidden)
									res.push(indicators[j])
							}
						}else
						if(outstream.type == "details"){
							var projectedColumns = outstream.description.projectedcolumns || []
							for (j = 0;j< projectedColumns.length;j++){
								if(!projectedColumns[j].hidden)
									res.push(projectedColumns[j])
							}
						}
					}
				}
			}*/
		}
        return res;
    };
    datasourceDoc.prototype.getAllFields=function(){
		var res = [];
		var fhash = {};
		var params = {};

		if(this.sourceName === this.content.name){

			var temp = icc.utils.clone(this.content.description.columns);
			jQuery.each(temp,function(idx,column){
				if (!column.hidden){
					res.push(column);
				}
			});
			jQuery.each(this.content.description.filters,function(idx,filter){
				jQuery.each(filter.criteria,function(idx,segment){
					if(segment.expr!==undefined && /[@]/.test(segment.expr)){
						if (!fhash[segment.expr]){
							res.push({name:segment.expr});
							fhash[segment.expr]=true;
						}
					}
				});
			});

		}else{
			/*
			if(this.content.description.outstreams){
				for(var i = 0;i< this.content.description.outstreams.length;i++){
					var outstream = this.content.description.outstreams[i];
					if (outstream.name == this.sourceName){
						// devolvemos los campos del outstream
						if(outstream.type == "summary"){
							var indicators = outstream.description.indicators || []
							for (j = 0;j< indicators.length;j++){
								if(!indicators[j].hidden)
									res.push(indicators[j]);
							}
						}else
						if(outstream.type == "details"){
							var projectedColumns = outstream.description.projectedcolumns || []
							for (j = 0;j< projectedColumns.length;j++){
								if(!projectedColumns[j].hidden)
									res.push(projectedColumns[j])
							}
						}

						jQuery.each(outstream.description.filters,function(idx,filter){
							jQuery.each(filter.criteria,function(idx,segment){
								if(segment.expr!==undefined && /[@]/.test(segment.expr)){
									if (!fhash[segment.expr]){
										res.push({name:segment.expr})
										fhash[segment.expr]=true;
									}
								}
							});
						});

					}
				}
			}*/
		}
		return res;
    };

	datasourceDoc.prototype.getFilters=function(){
		var filters = this.content.description.filters;
		if (!filters){
			this.content.description.filters = [];
			filters = [];
		}
		return filters;
	};
    datasourceDoc.prototype.getType = function(){
        return this.content.type;
    };
    datasourceDoc.prototype.setConfigData = function(configData){
        this.content = icc.utils.clone(configData);
        this.setDirty(true);

    };

    datasourceDoc.prototype.getConfigData = function(configData){
        return icc.utils.clone(this.content);
    };

    datasourceDoc.prototype.deleteFile = function(cb){
        var self = this;
        this.content.__code = self.code;
        jQuery.ajax({
            url: "designer/applications/"+this.appId+"/datasources/delete/"+this.sourceName,
            async: true,
			dataType:'json',
            success: function(ajaxResponse){
				if(ajaxResponse.status){
					dscache[self.appId+self.sourceName]=undefined;
					self.setDirty(true);
				}
                if(cb){
                    cb(ajaxResponse.status,ajaxResponse.result);
				}
            },
            error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
        });
    };
    datasourceDoc.prototype.truncateData = function(cb){
        var self = this;

        jQuery.ajax({
            url: "designer/applications/"+this.appId+"/datasources/truncate/"+this.sourceName,
            type: 'POST',

            async: true,
			dataType:'json',
            success: function(ajaxResponse){
                if(cb){
                    cb(ajaxResponse.status,ajaxResponse.result);
				}
            },
            error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
        });
    };

    datasourceDoc.prototype.getContentJSON = function(){
        var res;
        res = JSON.stringify(this.content);
        return res;
    };

    datasourceDoc.prototype.save = function(cb){
        var self = this;

        jQuery.ajax({
            url: "designer/applications/"+this.appId+"/datasources/save/"+this.sourceName,
            type: 'POST',
            async: true,
            dataType:"json",
            data:''.concat("content=" ,encodeURIComponent(JSON.stringify(this.content))),
            success: function(ajaxResponse){
				if(ajaxResponse.status){
					dscache[self.appId+self.sourceName]=icc.utils.clone(self.content);

					self.setDirty(false);
				}
                if(cb){
                    cb(ajaxResponse.status,ajaxResponse.result);
				}
            },
            error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
        });
    };
    icc.ui.designer.datasourceDoc = datasourceDoc;
})(__icc__);


(function(icc){
    var  datasourceView;
    datasourceView = function(datasourceDoc,appDoc){
        var self = this;
        datasourceView.SUPERconstructor.call(this,datasourceDoc,{
            haveCloseButton:true,
            caption:datasourceDoc.getName(),
            fillWidth:true,
            fillHeight:true,
            overflow:'auto',
//			slice:'sample1',
			style:'applications/designer.datasourceView',
            pt:2,
            pr:20,
            pl:2,
            pb:10,
			vs:10,
            childs:[
			]
        });
        self.appDoc = appDoc;
    };
    icc.utils.inherit(datasourceView,icc.ui.framework.documentView.view);

	datasourceView.prototype.map_comboDatasourceNameField=function(ctrl,doc,data,tgt,fldName){
		var i;
		var dshash={};
        var sourceItems = [];
        var d =tgt?tgt:{};
        var datasources = this.appDoc.getDatasources();
        for (i=0;i<datasources.length;i++){
			dshash[datasources[i].name] = datasources[i].name;
            sourceItems.push({
				id:datasources[i].name,
                text:datasources[i].name
            });
		}
		if(d[fldName]!==undefined && icc.utils.trim(d[fldName])!== '' && !dshash[d[fldName]]){
			ctrl.properties({
				items:sourceItems,
				enabled:tgt!==undefined,
				text:_T("-- Missing --") + " " +d[fldName]
			});

		}else{
			ctrl.properties({
				items:sourceItems,
				item:d[fldName],
				enabled:tgt!==undefined

			});
		}
        ctrl.onChange(function(idx,text,item){
            d[fldName]=item.id;
            doc.setConfigData(data);
        });
        ctrl.setTgt =function(vtgt){
            tgt = vtgt;
            d = tgt?tgt:{};
            ctrl.setEnabled(tgt!==undefined);
			if (d[fldName]!==undefined && icc.utils.trim(d[fldName])!== '' && !dshash[d[fldName]]){
				ctrl.setItem(-1);
				ctrl.setText(_T("-- Missing --")+d[fldName]);
			}else
				ctrl.setItem(d[fldName]);

        };

    };
    datasourceView.prototype.map_comboDatasourceFieldNameField=function(ctrl,doc,data,tgt,dsfldName,fldName){
		var self = this;
        var d = tgt?tgt:{};
        ctrl.properties({
            enabled:tgt!==undefined
        });
        var fillData = function (datasourceName){
			var n;
            var dsdoc = new icc.ui.designer.datasourceDoc(self.appDoc.getVCCName(),self.appDoc.getId(),datasourceName);
            dsdoc.load(function(status){
                if(status){
                    var items = [];

                    var fields = dsdoc.getFields();
                    for (n =0;n<fields.length;n++){
                        items.push({
                            text:fields[n].name,
                            id:fields[n].name
                        });
					}
                    ctrl.clearAll();
                    ctrl.addItem(items);
                    ctrl.setItem(d[fldName]);
                }else{
                    ctrl.clearAll();
                }
            });
        };

        ctrl.onChange(function(idx,text,item){
            d[fldName]=item.id;
			if(fldName == "displayField")
				d['codeField'] = item.id;
            doc.setConfigData(data);

        });
        ctrl.setTgt = function (tgt){
            d = tgt?tgt:{};
            ctrl.setEnabled(tgt!==undefined);
            if (d[dsfldName]!==undefined && d[dsfldName]!==''){
                fillData(d[dsfldName]);
            }else{
                ctrl.clearAll();
			}
        };

		if (d[dsfldName]!==undefined && d[dsfldName]!==''){

			fillData(d[dsfldName]);
		}else{
			ctrl.clearAll();
		}

    };
    datasourceView.prototype.map_parentDatasourceField=function(cbDatasource,cbField,pbClear,doc,data,tgt){
		var ctrl;
        pbClear.properties({
            enabled:tgt!==undefined
		});
        this.map_comboDatasourceNameField(cbDatasource,doc,data,tgt,'parentDatasource');
        this.map_comboDatasourceFieldNameField(cbField,doc,data,tgt,'parentDatasource','parentDatasourceField');
        pbClear.onClick(function(){
            tgt.parentDatasource = undefined;
            tgt.parentDatasourceField=undefined;
            cbDatasource.setItem(-1);
            cbField.setItem(-1);
            doc.setConfigData(data);
        });
        cbDatasource.onChange(function(idx,text,item){
            cbField.setTgt(tgt);
        });

    };
    datasourceView.prototype.map_whenDatasourceField=function(
			/*cbDatasource,*/
				optField,cbField,cbOp,txValue,
				optExpr,txExpr,
				ckRequired,ckEnabled,pbClear,doc,data,tgt,app){
 //       this.map_comboDatasourceNameField(cbDatasource,doc,data,tgt,'whenDatasource',app);
		if(tgt){
			tgt['whenIsField'] =  tgt['whenIsField']==undefined?true:tgt['whenIsField'];
			tgt['whenIsExpr'] =  tgt['whenIsExpr']==undefined?false:tgt['whenIsExpr'];
			tgt.whenDatasource=doc.getName();

		}
		this.map_optionField(optField,doc,data,tgt,'whenIsField');
		this.map_optionField(optExpr,doc,data,tgt,'whenIsExpr');
		this.map_textField(txExpr,doc,data,tgt,'whenExpr');

        this.map_comboDatasourceFieldNameField(cbField,doc,data,tgt,'whenDatasource','whenDatasourceField',app);
		this.map_comboField(cbOp,doc,data,tgt,'whenOperator');
		cbOp.items=[
			{id:'==',text:'=='},
			{id:'!=',text:'!='},
			{id:'>',text:'>'},
			{id:'>=',text:'>='},
			{id:'<',text:'&lt;'},
			{id:'<=',text:'<='}

		];

		this.map_textField(txValue,doc,data,tgt,'whenValue');



		txExpr.enabled = tgt && tgt['whenIsExpr'];
		optExpr.Checked =tgt && tgt['whenIsExpr'];

		txValue.enabled = tgt && tgt['whenIsField'];
		cbOp.enabled = tgt && tgt['whenIsField'];
		cbField.enabled = tgt && tgt['whenIsField'];
		optField.Checked =tgt && tgt['whenIsField'];
        pbClear.enabled = tgt && tgt['whenIsField'];

		optField.onChange(function(value){
			pbClear.setEnabled(value);
			cbField.setEnabled(value);
			cbOp.setEnabled(value);
			txValue.setEnabled(value);

		});
		optExpr.onChange(function(value){
			txExpr.setEnabled(value);
		});

		this.map_checkField(ckRequired,doc,data,tgt,'whenRequired');
		this.map_checkField(ckEnabled,doc,data,tgt,'whenEnabled');
        pbClear.onClick(function(){
            tgt.whenDatasourceField=undefined;
			tgt.whenOperator=undefined;
			tgt.whenValue=undefined;
			tgt.whenRequired=undefined;
			tgt.whenEnabled=undefined;
			tgt.whenIsField = true;
			tgt.whenIsExpr = false;
			tgt.whenExpr = undefined;
            cbField.setItem(-1);
			cbOp.setItem(-1);
			txValue.setText("");
			txExpr.setText("");
			ckRequired.setChecked(false);
			ckEnabled.setChecked(false);
			optField.setChecked(true);
            doc.setConfigData(data);
        });

    };
   datasourceView.prototype.map_textField=function(ctrl,doc,data,tgt,fieldName){
        var d =tgt?tgt:{};
        ctrl.text = d[fieldName];
        ctrl.enabled =tgt!==undefined;
        ctrl.onChange(function(value){
            value = icc.utils.trim(value);
            if(value === ''){
				value = undefined;
			}
            tgt[fieldName]=value;
            doc.setConfigData(data);
        });
        ctrl.setTgt =function(vtgt){
            tgt = vtgt;
            d = tgt?tgt:{};
            ctrl.setText(d[fieldName]);
            ctrl.setEnabled(vtgt!==undefined);
        };

    };
   datasourceView.prototype.map_checkField=function(ctrl,doc,data,tgt,fieldName){
        var d =tgt?tgt:{};
        ctrl.checked = d[fieldName];
        ctrl.enabled =tgt!==undefined;
        ctrl.onChange(function(value){
            if(!value){
                value=undefined;
			}
            tgt[fieldName]=value;
            doc.setConfigData(data);
        });
        ctrl.setTgt =function(vtgt){
            tgt = vtgt;
            d = tgt?tgt:{};
            ctrl.setChecked(d[fieldName]);
            ctrl.setEnabled(vtgt!==undefined);
        };
    };
    datasourceView.prototype.map_optionField=function(ctrl,doc,data,tgt,fieldName){
        var d =tgt?tgt:{};
        ctrl.checked = d[fieldName];
        ctrl.enabled =tgt!==undefined;
        ctrl.onChange(function(value){
			tgt[fieldName]=value;
			doc.setConfigData(data);
        });
        ctrl.setTgt =function(vtgt){
            tgt = vtgt;
            d = tgt?tgt:{};
            ctrl.setChecked(d[fieldName]);
            ctrl.setEnabled(vtgt!==undefined);
        };
    };
    datasourceView.prototype.map_comboField=function(ctrl,doc,data,tgt,fieldName, onChangeCallback = $.noop){
        var d =tgt?tgt:{};
		ctrl.properties({
			enabled:tgt!==undefined,
			item:d[fieldName]
		});
        ctrl.onChange(function(index,item_text,item){
	        tgt[fieldName]=item.id;
			onChangeCallback();
            doc.setConfigData(data);
        });

        ctrl.setTgt =function(vtgt){
            tgt = vtgt;
            d = tgt?tgt:{};
            ctrl.setItem(d[fieldName]);
            ctrl.setEnabled(vtgt!==undefined);
        };
	};

	datasourceView.prototype.map_ctrlFieldType = function(cbType,doc,data,tgt){
		var vtgt = tgt;
        this.map_comboField(cbType,doc,data,tgt,"type");
		cbType.properties({
            items:[
				{id:'integer',	text:_T('integer')},
				{id:'numeric',	text:_T('numeric')},
				{id:'string',	text:_T('string')},
				{id:'datetime', text:_T('datetime')},
				{id:'date', text:_T('date')},
				{id:'time', text:_T('time')},
				{id:'boolean', text:_T('boolean')}
            ]
        });
		if(doc.getType() == "icc_contact_ds"){
			cbType.items.push({id:'phone', text:'phone'});
		}
		if(doc.getType() == "icc6_contact_ds"){
			cbType.items.push({id:'phone', text:'phone'});
			cbType.items.push({id:'mail', text:'mail'});
			cbType.items.push({id:'twitter', text:'twitter'});
		}
		return {
			setTgt:function (tgt){
				vtgt=tgt;

				cbType.setTgt(tgt);
				if(tgt && (tgt.type == "phonelist" || tgt.type == "dataitems" || tgt.type =="addresseslist" || tgt.type =="skilllist" )){
					cbType.setText(tgt.type);
					cbType.setEnabled(false);
				}

			},
			performValidation:function(){
				return true;
			}
		};
	};

	datasourceView.prototype.phoneSelectorPanel = function(doc,data,param){
		<%FRAME:dsDesignerAssets.phoneSettings%>

        this.map_comboField(cbPhoneType,doc,data,param,"phoneType");

		this.map_textField(txCountryId,doc,data,param,"phoneCountryId");
		this.map_textField(txAreaId,doc,data,param,"phoneAreaId");
		this.map_textField(txIndex,doc,data,param,"phoneIndex");
		this.map_comboField(cbPhoneValueType,doc,data,param,"phoneValueType");

		cbPhoneType.properties({
            items:[
				{id:'FAX',	text:'Fax'},
				{id:'HOME',	text:'Home'},
				{id:'CELLULAR',	text:'Mobile'},
				{id:'OFFICE', text:'Office'}
            ]
        });

		phoneSettings.properties({
			setItem:function(item){

			},
			performValidation:function(waserrors){
				var selarray =[];
				if(param.phoneType)
					selarray.push("phoneType="+param.phoneType);

				if(param.phoneCountryId)
					selarray.push("countryId="+param.phoneCountryId);

				if(param.phoneAreaId)
					selarray.push("areaId="+param.phoneAreaId);

				if(param.phoneIndex)
					selarray.push("Index="+param.phoneIndex);

				if(param.phoneSelector !== selarray.join(",")){

					param.phoneSelector=selarray.join(",");
					doc.setConfigData(data);
					icc.console.log(param.phoneSelector);
				}

				return true;
			}
		});
		return phoneSettings;
	};


	datasourceView.prototype.valuePanel = function (doc,data,param){
		<%FRAME:dsDesignerAssets.valuePanel%>
        var lnkfield = this.map_parentDatasourceField(field_cbParentDatasource,field_cbParentDatasourceField,field_btnParentDatasourceClear,doc,data,param);
	    this.map_textField(field_txDefault,doc,data,param,'default',{width:130});
	    this.map_textField(field_txMaxLength,doc,data,param,'maxLength',{});


		this.map_checkField(field_ckBlank,doc,data,param,'blank',{caption:'blank',align:'right'});
		field_txDefault.setEnabled(!param.blank);
		field_ckBlank.onChange(function(value){
			field_txDefault.setEnabled(!value);
		});
		return valuePanel;
	};
	datasourceView.prototype.searchValuePanel = function (doc,data,param){
		<%FRAME:dsDesignerAssets.searchValuePanel%>
	    this.map_textField(field_search_txDefault,doc,data,param,'default',{width:130});
	//	this.map_checkField(field_search_ckBlank,doc,data,param,'blank',{caption:'blank',align:'right'});
		field_search_txDefault.setEnabled(!param.blank);
//		field_search_ckBlank.onChange(function(value){
//			field_search_txDefault.setEnabled(!value);
//		});

		return searchValuePanel;
	};

	datasourceView.prototype.requiredPanel = function (doc,data,param){
		<%FRAME:dsDesignerAssets.requiredPanel%>

		var whenfield = this.map_whenDatasourceField(
				opt_whenField,field_cb_whenField,field_cb_whenOperator,field_tx_whenValue,
				opt_whenExpr,tx_whenExpr,
				field_ck_whenRequired,field_ck_whenEnabled,field_btn_whenClear,doc,data,param,this.appDoc);

		this.map_checkField(field_ckRequired,doc,data,param,"required");
		return requiredPanel;
	};
	datasourceView.prototype.requiredPanel2 = function (doc,data,param,combo_items){
		<%FRAME:dsDesignerAssets.requiredPanelNew%>


		param['requiredCondDatasource']=doc.getName(),
		this.map_checkField(ckReqConRequired,doc,data,param,'requiredCondition');
//		if(param.requiredCondition && !param.requiredCondIsField && !param.requiredCondIsExpr)
//			param.required = true


		this.map_optionField(opReqConAlways,doc,data,param['requiredCondition']?param:undefined,'required');

		this.map_optionField(opReqConField,doc,data,param['requiredCondition']?param:undefined,'requiredCondIsField');
		if(combo_items){
			cbReqConField.items = combo_items;
			this.map_comboField(cbReqConField,doc,data,param['requiredCondition'] && param['requiredCondIsField']?param:undefined,'requiredCondDatasourceField');
		}else
			this.map_comboDatasourceFieldNameField(cbReqConField,doc,data,param['requiredCondition'] && param['requiredCondIsField']?param:undefined,'requiredCondDatasource','requiredCondDatasourceField',this.appDoc);

		this.map_comboField(cbReqConOperator,doc,data,param['requiredCondition'] && param['requiredCondIsField']?param:undefined,'requiredCondOperator');
		this.map_textField(txReqConFieldExpr,doc,data,param['requiredCondition'] && param['requiredCondIsField']?param:undefined,'requiredCondFieldExpr');


		this.map_optionField(opReqConExpr,doc,data,param['requiredCondition']?param:undefined,'requiredCondIsExpr');
		this.map_textField(txReqConExpr,doc,data,param['requiredCondition'] && param['requiredCondIsExpr']?param:undefined,'requiredCondExpresion');



		cbReqConOperator.items=[
			{id:'==',text:'=='},
			{id:'!=',text:'!='},
			{id:'>',text:'>'},
			{id:'>=',text:'>='},
			{id:'<',text:'&lt;'},
			{id:'<=',text:'<='}

		];
		var update=function(){

			jQuery([opReqConAlways,opReqConField,opReqConExpr]).each(function(){
			//	if(sender != this)
					this.setTgt(param['requiredCondition']?param:undefined);
			});
			ckReqConRequired.setTgt(param);
			cbReqConField.setTgt(param['requiredCondition'] && param['requiredCondIsField']?param:undefined);
			cbReqConOperator.setTgt(param['requiredCondition'] && param['requiredCondIsField']?param:undefined);
			txReqConFieldExpr.setTgt(param['requiredCondition'] && param['requiredCondIsField']?param:undefined);

			txReqConExpr.setTgt(param['requiredCondition'] && param['requiredCondIsExpr']?param:undefined);
		};
		jQuery([ckReqConRequired,opReqConAlways,opReqConField,opReqConExpr]).each(function(){
			this.onChange(function(value){
				if(value||this == ckReqConRequired)
					update();
			});
		});

		ckReqConRequired.onChange(function(value){
			if(value){
				// si no hay nada pone required

				if (!param['requiredCondIsExpr'] && !param['requiredCondIsField'])
					param['required']=true;
			}else{
				param['required']=false;
				param['requiredCondIsExpr']=false;
				param['requiredCondIsField']=false;
			}
			doc.setConfigData(data);
			update();
		});
		pbReqConClear.onClick(function(){
			param['required']=false;
			param['requiredCondition']=undefined;
			param['requiredCondIsField']=undefined;
			param['requiredCondDatasourceField']=undefined;
			param['requiredCondOperator']=undefined;
			param['requiredCondFieldExpr']=undefined;

			param['requiredCondIsExpr']=undefined;
			param['requiredCondExpresion']=undefined;

			update();
			doc.setConfigData(data);
		});


		return requiredPanelNew;
	};

	datasourceView.prototype.enabledPanel = function (doc,data,param,combo_items){
		<%FRAME:dsDesignerAssets.enabledPanel%>

		if(!param['enabledCondIsField'] && !param['enabledCondIsExpr'])
			param['alwaysEnabled']=true;
		param['enabledCondDatasource']=doc.getName();


		this.map_optionField(opEnabledConAlways,doc,data,param,'alwaysEnabled');

		this.map_optionField(opEnabledConField,doc,data,param,'enabledCondIsField');
		if(combo_items){
			cbEnabledConField.items = combo_items;
			this.map_comboField(cbEnabledConField,doc,data,param['enabledCondIsField']?param:undefined,'enabledCondDatasourceField');
		}else
			this.map_comboDatasourceFieldNameField(cbEnabledConField,doc,data,param['enabledCondIsField']?param:undefined,'enabledCondDatasource','enabledCondDatasourceField',this.appDoc);
//        this.map_comboDatasourceFieldNameField(cbEnabledConField,doc,data,param['enabledCondIsField']?param:undefined,'enabledCondDatasource','enabledCondDatasourceField',this.appDoc);
		this.map_comboField(cbEnabledConOperator,doc,data,param['enabledCondIsField']?param:undefined,'enabledCondOperator');
		this.map_textField(txEnabledConFieldExpr,doc,data,param['enabledCondIsField']?param:undefined,'enabledCondFieldExpr');


		this.map_optionField(opEnabledConExpr,doc,data,param,'enabledCondIsExpr');
		this.map_textField(txEnabledConExpr,doc,data,param['enabledCondIsExpr']?param:undefined,'enabledCondExpresion');



		cbEnabledConOperator.items=[
			{id:'==',text:'=='},
			{id:'!=',text:'!='},
			{id:'>',text:'>'},
			{id:'>=',text:'>='},
			{id:'<',text:'&lt;'},
			{id:'<=',text:'<='}

		];
		var update=function(){

			cbEnabledConField.setTgt(param['enabledCondIsField']?param:undefined);
			cbEnabledConOperator.setTgt(param['enabledCondIsField']?param:undefined);
			txEnabledConFieldExpr.setTgt(param['enabledCondIsField']?param:undefined);

			txEnabledConExpr.setTgt(param['enabledCondIsExpr']?param:undefined);
		};
		jQuery([opEnabledConAlways,opEnabledConField,opEnabledConExpr]).each(function(){
			this.onChange(function(value){
				update();
			});
		});

		pbEnabledConClear.onClick(function(){
			opEnabledConAlways.setChecked(true);
			param['alwaysEnabled']=true;
			param['enabledCondIsField']=undefined;
			param['enabledCondDatasourceField']=undefined;
			param['enabledCondOperator']=undefined;
			param['enabledCondFieldExpr']=undefined;

			param['enabledCondIsExpr']=undefined;
			param['enabledCondExpresion']=undefined;

			update();
			doc.setConfigData(data);
		});


		return enabledPanel;
	};
	datasourceView.prototype.messagingPanel = function (doc,data,param){
		<%FRAME:dsDesignerAssets.messagingPanel%>

		this.map_textField(field_txTooltip,doc,data,param,"tooltip");
//        this.map_textField(field_txDisplayName,doc,data,param,"displayName");
        this.map_textField(field_txMissingMessage,doc,data,param,"missingMessage");
        this.map_textField(field_txValidationMessage,doc,data,param,"validationMessage");

		return messagingPanel;
	};

	datasourceView.prototype.validationPanelWithoutRange = function (doc,data,param){
		<%FRAME:dsDesignerAssets.validationPanelWRange%>

        var m_item = param;
        if (!m_item){
            m_item = {};
		}
        if(!m_item.validate){
            m_item.validate={
                type:"auto"
            };
		}
		ckAutoWRange.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="auto"
		});
        ckSimpleWRange.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="simple"
        });
        this.map_textField(txSimpleWRange,doc,data,m_item.validate.type==="simple"?m_item.validate:undefined,"lstOptions");

        ckDatasourceWRange.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="datasource"
        });
        this.map_comboDatasourceNameField(cbDatasourceWRange,doc,data,m_item.validate.type==="datasource"?m_item.validate:undefined,'datasourceName',this.appDoc);
        this.map_comboDatasourceFieldNameField(cbDisplayFieldWRange,doc,data,m_item.validate.type==="datasource"?m_item.validate:undefined,'datasourceName',"displayField",this.appDoc);

		var validateInfo = function(waserrors){
			var err = icc.ui.message('noerror');
			txSimpleWRange.displayMessage(err,false);
			var res = true;
			switch(m_item.validate.type){
				case 'simple':
					res = res && txSimpleWRange.performValidation(waserrors).code==0;
				break;
				case 'datasource':
				break;
			}
			return res;

		};

        ckAutoWRange.onChange(function(value){
			if(value){
				m_item.validate.type="auto";

				validationPanelWRange.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
        ckSimpleWRange.onChange(function(value){
			if(value){
				m_item.validate.type="simple";
				validationPanelWRange.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
        ckDatasourceWRange.onChange(function(value){
			if(value){
				m_item.validate.type="datasource";
				validationPanelWRange.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
       cbDatasourceWRange.onChange(function(idx,text,item){
            cbDisplayFieldWRange.setTgt(m_item.validate);
			validateInfo();
        });
		validationPanelWRange.setTgt = function(vtgt){
            m_item = vtgt;

            var enableState = vtgt!==undefined;
			if(vtgt && (vtgt.type === "phonelist" || vtgt.type=="dataitems" || vtgt.type == "addresseslist" || vtgt.type =="skilllist")){	// No se pueden validar tipos que no mapean a texto como arrays
				enableState = false;
			}
            if (!m_item){
                m_item = {};
			}
            if(!m_item.validate){
                m_item.validate={
                    type:"auto"
                };
			}
            ckAutoWRange.setEnabled(enableState);
            ckAutoWRange.setChecked(m_item.validate.type==="auto");

            ckSimpleWRange.setEnabled(enableState);
            ckSimpleWRange.setChecked(m_item.validate.type==="simple");

            ckDatasourceWRange.setEnabled(enableState);
            ckDatasourceWRange.setChecked(m_item.validate.type==="datasource");

            txSimpleWRange.setTgt(vtgt && m_item.validate.type==="simple"?vtgt.validate:undefined);
            cbDatasourceWRange.setTgt(vtgt && m_item.validate.type==="datasource"?vtgt.validate:undefined);
            cbDisplayFieldWRange.setTgt(vtgt && m_item.validate.type==="datasource"?vtgt.validate:undefined);
//            cbCodeFieldWRange.setTgt(vtgt && m_item.validate.type==="datasource"?vtgt.validate:undefined);
			validateInfo();

        };
		validationPanelWRange.performValidation = function(waserrors){
			return validateInfo(waserrors);
		};
		return validationPanelWRange;
	};

	datasourceView.prototype.validationPanel = function (doc,data,param){
		<%FRAME:dsDesignerAssets.validationPanel%>

        var m_item = param;
        if (!m_item){
            m_item = {};
		}
        if(!m_item.validate){
            m_item.validate={
                type:"auto"
            };
		}
		ckAuto.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="auto"
		});
        ckSimple.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="simple"
        });
        this.map_textField(txSimple,doc,data,m_item.validate.type==="simple"?m_item.validate:undefined,"lstOptions");

        ckRange.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="range"
        });
        this.map_textField(txRangeFrom,doc,data,m_item.validate.type==="range"?m_item.validate:undefined,"from");
        this.map_textField(txRangeTo,doc,data,m_item.validate.type==="range"?m_item.validate:undefined,"to");
        ckDatasource.properties({
            enabled:param!==undefined,
            checked:m_item.validate.type==="datasource"
        });
        this.map_comboDatasourceNameField(cbDatasource,doc,data,m_item.validate.type==="datasource"?m_item.validate:undefined,'datasourceName',this.appDoc);
        this.map_comboDatasourceFieldNameField(cbDisplayField,doc,data,m_item.validate.type==="datasource"?m_item.validate:undefined,'datasourceName',"displayField",this.appDoc);

		var validateInfo = function(waserrors){
			var err = icc.ui.message('noerror');
			txSimple.displayMessage(err,false);
			txRangeFrom.displayMessage(err,false);
			txRangeTo.displayMessage(err,false);
			var res = true;
			switch(m_item.validate.type){
				case 'simple':
					res = res && txSimple.performValidation(waserrors).code==0;
				break;
				case 'range':
					var rf = txRangeFrom.performValidation(waserrors).code==0;
					var rt = txRangeTo.performValidation(waserrors).code==0;
					res = res && rf && rt;
					if (res){

						if(parseInt(txRangeFrom.getText(),10)>parseInt(txRangeTo.getText(),10)){
							res=false;
							err = icc.ui.message('invalid_field_value',{description:_T('This value must be greater than {value}'),value:txRangeFrom.getText()});
							if(waserrors){
								err.level=3;
							}
							txRangeTo.displayMessage(err,false);
						}
					}
				break;
				case 'datasource':
				break;
			}
			return res;

		};

        ckAuto.onChange(function(value){
			if(value){
				m_item.validate.type="auto";

				validationPanel.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
        ckSimple.onChange(function(value){
			if(value){
				m_item.validate.type="simple";
				validationPanel.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
        ckRange.onChange(function(value){
			if(value){
				m_item.validate.type="range";
				validationPanel.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
        ckDatasource.onChange(function(value){
			if(value){
				m_item.validate.type="datasource";
				validationPanel.setTgt(m_item);
				doc.setConfigData(data);
				validateInfo();
			}
        });
        cbDatasource.onChange(function(idx,text,item){
            cbDisplayField.setTgt(m_item.validate);
//            cbCodeField.setTgt(m_item.validate);
			validateInfo();
        });
		txRangeFrom.onChange(function(){
			validateInfo();
		});
		txRangeTo.onChange(function(){
			validateInfo();
		});
		validationPanel.setTgt = function(vtgt){
            m_item = vtgt;

            var enableState = vtgt!==undefined;
			if(vtgt && (vtgt.type === "phonelist" || vtgt.type=="dataitems" || vtgt.type == "addresseslist" || vtgt.type =="skilllist" )){	// No se pueden validar tipos que no mapean a texto como arrays
				enableState = false;
			}
            if (!m_item){
                m_item = {};
			}
            if(!m_item.validate){
                m_item.validate={
                    type:"auto"
                };
			}
            ckAuto.setEnabled(enableState);
            ckAuto.setChecked(m_item.validate.type==="auto");

            ckSimple.setEnabled(enableState);
            ckSimple.setChecked(m_item.validate.type==="simple");

            ckRange.setEnabled(enableState);
            ckRange.setChecked(m_item.validate.type==="range");
            ckDatasource.setEnabled(enableState);
            ckDatasource.setChecked(m_item.validate.type==="datasource");

            txSimple.setTgt(vtgt && m_item.validate.type==="simple"?vtgt.validate:undefined);
            txRangeFrom.setTgt(vtgt && m_item.validate.type==="range"?vtgt.validate:undefined);
            txRangeTo.setTgt(vtgt && m_item.validate.type==="range"?vtgt.validate:undefined);
            cbDatasource.setTgt(vtgt && m_item.validate.type==="datasource"?vtgt.validate:undefined);
            cbDisplayField.setTgt(vtgt && m_item.validate.type==="datasource"?vtgt.validate:undefined);
 //           cbCodeField.setTgt(vtgt && m_item.validate.type==="datasource"?vtgt.validate:undefined);
			validateInfo();

        };
		validationPanel.performValidation = function(waserrors){
			return validateInfo(waserrors);
		};


		return validationPanel;
	};

	datasourceView.prototype.phonePanel = function (doc,data,param){
		<%FRAME:dsDesignerAssets.phonePanel%>

        this.map_comboField(cbPhoneType,doc,data,param,"phoneType");
	    this.map_comboField(cbPhoneValueType,doc,data,param,"phoneValueType");

		this.map_textField(txCountryId,doc,data,param,"phoneCountryId");
		this.map_textField(txAreaId,doc,data,param,"phoneAreaId");
		this.map_textField(txIndex,doc,data,param,"phoneIndex");

		cbPhoneType.properties({
            items:[
				{id:'FAX',	text:'Fax'},
				{id:'HOME',	text:'Home'},
				{id:'CELLULAR',	text:'Mobile'},
				{id:'OFFICE', text:'Office'}
            ]
        });
		cbPhoneValueType.properties({
			items:[
				{id:'phoneNumber',text:'Number'},
				{id:'countryId',text:'Country'},
				{id:'areaId',text:'Area'},
				{id:'phoneExtension',text:'Extension'},
				{id:'fullNumber',text:'Full number'}
			],
			item:param['phoneValueType'] || 'phoneNumber'
		});
		var buildSelector = function(){
			var selarray =[];
			if(param.phoneType)
				selarray.push("phoneType="+param.phoneType);

			if(param.phoneCountryId)
				selarray.push("countryId="+param.phoneCountryId);

			if(param.phoneAreaId)
				selarray.push("areaId="+param.phoneAreaId);

			if(param.phoneIndex)
				selarray.push("Index="+param.phoneIndex);

//			if(param.phoneSelector !== selarray.join(",")){

			param.phoneSelector=selarray.join(",");
			doc.setConfigData(data);
			icc.console.log(param.phoneSelector);
//			}

		};
		cbPhoneType.onChange(buildSelector);
		txCountryId.onChange(buildSelector);
		txAreaId.onChange(buildSelector);
		txIndex.onChange(buildSelector);

		phonePanel.properties({
			setItem:function(item){

			},
			performValidation:function(waserrors){

				return true;
			}
		});

		return phonePanel;
	};

    datasourceView.prototype.fieldSettings = function(doc,data,param){
		var fieldTypeSettings;
		var self = this;
		var wnd;
		var currentPanel;
		var childs;
		<%FRAME:dsDesignerAssets.fieldSettings%>

		fieldSettings.properties({
			width:undefined,
			height:undefined,
			fillWidth:true,
			fillHeight:true,
			vs:4
		});
		container.properties({
			nc_right:20,
			x:undefined,
			y:undefined,
			width:undefined,
			height:undefined,
			fillWidth:true,
			fillHeight:true,
			overflow:'auto'
		});
		/*
		fieldTypeHeader.properties({
			y:undefined,
			x:undefined,
			fillWidth:true,
			width:undefined
		});
		*/
		var buildPanel;
		var reloadPanel = function(){
			container.rmvChild(currentPanel);
			currentPanel = buildPanel();
			currentPanel.create();
			container.addChild(currentPanel);
			container.layout();

		};

		buildPanel = function (){
			childs=[];
			var res = new icc.ui.panel({childs:childs});
			if (param !=undefined){
				<%FRAME:dsDesignerAssets.fieldTypePanel%>
				childs.push(fieldTypePanel);
				var cbType = self.map_ctrlFieldType(field_cbType,doc,data,param);
				field_cbType.onChange(function(index,text,item){
					reloadPanel();
				});

				switch(param.type){
					case "time":
					case "datetime":
					case "date":
					case "string":
					case "mail":
					case "twitter":
						childs.push(self.valuePanel(doc,data,param));
//						childs.push(self.requiredPanel(doc,data,param))
						childs.push(self.enabledPanel(doc,data,param));
						childs.push(self.requiredPanel2(doc,data,param));
						childs.push(self.messagingPanel(doc,data,param));
						childs.push(self.validationPanelWithoutRange(doc,data,param));
					break;
					case "numeric":
					case "integer":
						childs.push(self.valuePanel(doc,data,param));
						childs.push(self.enabledPanel(doc,data,param));
						childs.push(self.requiredPanel2(doc,data,param));
						childs.push(self.messagingPanel(doc,data,param));
						childs.push(self.validationPanel(doc,data,param));
					break;
					case "boolean":
						childs.push(self.valuePanel(doc,data,param));
						childs.push(self.enabledPanel(doc,data,param));
						childs.push(self.requiredPanel2(doc,data,param));
						childs.push(self.messagingPanel(doc,data,param));
					break;
					case "phone":
						childs.push(self.valuePanel(doc,data,param));
						childs.push(self.enabledPanel(doc,data,param));
						childs.push(self.requiredPanel2(doc,data,param));
						childs.push(self.messagingPanel(doc,data,param));
						childs.push(self.phonePanel(doc,data,param));


					break;
				}
				self.map_checkField(field_ckSearchable,doc,data,param,'searchable',{caption:'searchable',align:'right'});
			}
			return res;
		};
		currentPanel = buildPanel();
		container.childs.push(currentPanel);

		fieldSettings.properties({
			performValidation:function(waserrors){
				var res = true;
				jQuery.each(childs,function(idx,cl){
					if(cl.performValidation){
						if(res && !cl.performValidation())
							res = false;
					}
				});
				//alert(res);
				return res;
			},
			setItem:function(item){
				param = item;
				//cbType.setTgt(param);

				reloadPanel();
//				fieldTypeHeader.setVisible(item!=undefined);
				fieldSettings.layout();
			}

		});
		return fieldSettings;
    };
    datasourceView.prototype.databasePanel = function(doc,data){
		<%FRAME:dsDesignerAssets.databaseConnectionPanel%>
		const fnChangeDbms = function(data) {

			const change_visibility= function(flag) {
				database_txServerAddress.setReadOnly(flag);
				database_txPort.setReadOnly(flag);
				database_txUserName.setReadOnly(flag);
				database_txUserPassword.setReadOnly(flag);
		};
			if(data.dbms === "builtin")
			{
				database_cboDatabaseName.setVisible(true);
				database_txDatabaseName.setVisible(false);
				database_cboDatabaseName.setRequired(true);
				database_txDatabaseName.setRequired(false);

				database_txServerAddress.setText("");
				database_txPort.setText("");
				database_txUserName.setText("");
				database_txUserPassword.setText("");
				change_visibility(true);
			}
			else{
				database_cboDatabaseName.setVisible(false);
				database_txDatabaseName.setVisible(true);
				database_txDatabaseName.setRequired(true);
				database_cboDatabaseName.setRequired(false);
				database_txDatabaseName.setText("");
				change_visibility(false);
			}
		};

		this.map_comboField(database_cboDbms,doc,data,data['private'],"dbms", function () {
			fnChangeDbms(data['private']);
		});
		this.map_textField(database_txServerAddress,doc,data,data['private'],"serverAddress");
		this.map_textField(database_txPort,doc,data,data['private'],"port");
		this.map_textField(database_txUserName,doc,data,data['private'],"userName");
		this.map_textField(database_txUserPassword,doc,data,data['private'],"userPassword");
        this.map_textField(database_txDatabaseName ,doc,data,data['private'],"databaseName");
		this.map_comboField(database_cboDatabaseName,doc,data,data['private'],"databaseName");
//		this.map_checkField(ckEnableCacheSQL,doc,data,data.description,"enableCache");

		database_cboDbms.properties({
			items:[
				{id: "sqlserver", text: "SQL Server"},
				{id: "mysql"    , text: "MySQL"     },
				{id: "builtin"    , text: "Built in"}
			]
		});

		database_cboDatabaseName.properties({
			items: self.mssql_builtin_config.Databases || []
		});

		if (data['private'].dbms === "builtin") {
			fnChangeDbms(data['private']);
		}

     	databaseConnectionPanel.performValidation = function(){
			return 	database_cboDbms.performValidation(true).code==0 &&
					database_txServerAddress.performValidation(true).code==0 &&
					database_txPort.performValidation(true).code==0 &&
					database_txUserName.performValidation(true).code==0 &&
					database_txDatabaseName.performValidation(true).code==0 &&
					database_txUserPassword.performValidation(true).code==0;
		}
		return databaseConnectionPanel;
    };
    datasourceView.prototype.specialSettingsPanel = function(doc,data){
		<%FRAME:dsDesignerAssets.specialSettingsPanel%>
		this.map_checkField(ckEnableCache,doc,data,data.description,"enableCache");
		return specialSettingsPanel;
    };

	datasourceView.prototype.SQLserverObjectSetup = function (doc,data,key,tgt,cb) {
		var self=this;
		<%FRAME:dsDesignerAssets.serverObjectMap%>

		var newColumns = [];
		var columns_map = {}; // guardamos las columnas por nombre para comprobar si existen aun
		var dlg_caption;
		var item;
		jQuery.each(data.description.columns,function(idx,column){
			columns_map[column.name]=column;
		});
		// carga el combo de columnas
		var fillColumns = function(){
			var item = srvobj_cbColumn.getItem();
			srvobj_cbColumn.clearAll();
			jQuery.each(data.description.columns,function(idx,column){
				srvobj_cbColumn.addItem({text:column.name,id:column.name});
			});
			if(item){
				srvobj_cbColumn.setItem(item.id);
			}
		};
		switch(key){
			case 'retrieve':
				dlg_caption = _T("SELECT configuration");
				break;
			case 'store':
				dlg_caption = _T("INSERT configuration");
				break;
			case 'update':
				dlg_caption = _T("UPDATE configuration");
				break;
			case 'delete':
				dlg_caption = _T("DELETE configuration");
				break;
		}
		var grid_items = [];
		var map_hash = {};
		jQuery.each(tgt.inputParams,function(idx,param){

			item = {
				id:param.name,
				text:param.name,
				name:param.name,
				type:param.type,
				column:param.column,
				colcaption:param.column?(columns_map[param.column]?param.column:_T("(missing)")+" "+param.column):''
			};
			map_hash[item.id]=item;
			grid_items.push(item);
		});
		srvobj_grFieldMap.items = grid_items;
		var fillObjectList = function(cb){
			data['private'].datasourceName = data.name;// Al quitar las claves de sql del gui , no hay mas remedio que
														// mandar el nombre del datasource al server para ahi obtener la clave
														// si la que va == 11*
			data['private'].applicationName = self.appDoc.getName();
			icc.ui.designer.dsintrospection.mssql_list(data['private'],function(status,list){
				if(status){
					srvobj_cbObjectList.clearAll();
					var items = [];
					jQuery.each(list,
						function(idx,objectData){
							var txt;
							var item = {};
							if(objectData.objectType === "USER_TABLE" ){
								item.text = "(table)&nbsp;" + objectData.objectName;
							}else{
								item.text = "(proc)&nbsp;&nbsp;" + objectData.objectName;
							}
							item.id = objectData.objectName;
							item.type = objectData.objectType;
							items.push(item);
						}
					);
					srvobj_cbObjectList.addItem(items);
					switch(tgt.type){
						case 'msqltable':
							srvobj_cbObjectList.setItem(tgt.tableName);
						break;
						case 'msqlproc':
							srvobj_cbObjectList.setItem(tgt.spName);
						break;
					}
				}
				if(cb){
					cb(status);
				}

			});
		};
		var mergeObjectInfo = function(cb){

			var item = srvobj_cbObjectList.getItem();
			if(item){
				data['private'].datasourceName = data.name;// Al quitar las claves de sql del gui , no hay mas remedio que
													// mandar el nombre del datasource al server para ahi obtener la clave
													// si la que va == 11*
				data['private'].applicationName = self.appDoc.getName();
				if(item.type === 'USER_TABLE'){

					icc.ui.designer.dsintrospection.mssql_table_columns(data['private'],item.id,function(status,list){
						if(status){
							var items = [];
							var lst_hash = {};
							jQuery.each(list,function(idx,column){
								var t = column.typeName;
								var tmpItem;
								var iskey,identity;
								var info = [];
								if ($.isArray(column.MiscInfo)) {
									info.push(column.MiscInfo);
									if(column.MiscInfo.indexOf('identity')){
										identity=true;
									}
								}
								if (column.PK_Position){
									info.push(_T("primary key"));
									iskey = true;
								}
								if (column.Nullable === 'NULL'){
									info.push(_T("null"));
								}

								switch(t){
									case 'int':
										t='integer';
										break;
									case 'nchar':
									case 'nvarchar':
										column.maxLength /= 2;

									case 'char':
									case 'varchar':
										t='string'
									break;
									case 'text':
										column.maxLength = undefined;
										t='string';
									break;
									case 'adDBTimeStamp':
										t='datetime'
									break;

									case 'bit':
										t="boolean";
									break;
								}

								tmpItem = {
									id:column.ColumnName,
									key:iskey,
									identity:identity,
									maxLength:column.maxLength,
									text:column.ColumnName,
									name:column.ColumnName,
									type:t,
									info:info.join(","),
									dbType:column.typeName
								};
								if(key==='retrieve'){	// como esto es de una tabla para hacer una select no se
														// requiere ningun campo
									tmpItem.allowNull = true;
								}else{
									tmpItem.allowNull = column.Nullable === 'NULL';
								}
								lst_hash[tmpItem.id] = tmpItem;
								items.push(tmpItem);
							});
							jQuery.each(tgt.inputParams,function(idx,param){
								if (!lst_hash[param.name]){
									items.push({text:_T("(missing)")+" " + param.name,name:param.name,id:param.name,type:param.type,column:param.column,colcaption:param.column,missing:true});
								}else{
									lst_hash[param.name].column = param.column;
									lst_hash[param.name].colcaption =param.column?(columns_map[param.column]?param.column:_T("(missing)")+" "+param.column):'';
								}
							});

							grid_items = items;
							srvobj_grFieldMap.clearAll();
							srvobj_grFieldMap.addItem(items);

						}
						if(cb){
							cb(status);
						}
					});
				}else{
					icc.ui.designer.dsintrospection.mssql_proc_params(data['private'],item.id,function(status,list){
						if(status){
							var items = [];
							var lst_hash = {};
							jQuery.each(list,function(idx,param){
								var t = param.typeName;
								var tmpItem;
								var info = [];
								if (param.HasDefaultValue)
									info.push("default")

								switch(t){
									case 'int':
										t='integer';
									break;
									case 'nchar':
									case 'nvarchar':
										param.maxLength/=2;
									case 'char':
									case 'varchar':
										t='string';
									break;
									case 'ntext':
									case 'text':
										param.maxLength=undefined;
										t='string';
									break;
									case 'adDBTimeStamp':
										t='datetime';
									break;

									case 'bit':
										t='boolean';
									break;
								}
								tmpItem = {
									id:param.ParamName,
									text:param.ParamName,
									name:param.ParamName,
									maxLength:param.maxLength,
									type:t,
									info:info.join(","),
									allowNull:param.HasDefaultValue,
									dbType:param.typeName
								};
								lst_hash[tmpItem.id] = tmpItem;
								items.push(tmpItem);
							});
							jQuery.each(tgt.inputParams,function(idx,param){
								if (!lst_hash[param.name]){
									items.push({text:_T("(missing)")+" " + param.name,name:param.name,id:param.name,type:param.type,column:param.column,colcaption:param.column,missing:true});
								}else{
									lst_hash[param.name].column = param.column;
									lst_hash[param.name].colcaption =param.column?(columns_map[param.column]?param.column:_T("(missing)")+" "+param.column):'';
								}
							});

							grid_items = items;
							srvobj_grFieldMap.clearAll();
							srvobj_grFieldMap.addItem(items);

						}
						if(cb){
							cb(status);
						}
					});
				}
			}
		};
		var dlg = new icc.ui.dialog({
			caption:dlg_caption,
			childs:[
				serverObjectMap
			]
		});
		srvobj_cbObjectList.onChange(function(idx,text,item){
			mergeObjectInfo();
		});

		srvobj_btnDelete.onClick(function(){
			var item;
			srvobj_cbColumn.setItem(-1);
			item = srvobj_grFieldMap.getItem();
			if(item){
				item.column = undefined;
				item.colcaption=undefined;
				srvobj_grFieldMap.updateItem(item);
			}

		});
		srvobj_grFieldMap.onChange(function(item){
			if (item){
				srvobj_cbColumn.setItem(item.column);
				srvobj_lbFieldName.setText(item.name);

			}else{
				srvobj_cbColumn.setItem(-1);
			}

			srvobj_btnDelete.setEnabled(item!==undefined);
			srvobj_btnAddColumn.setEnabled(item!==undefined);
			srvobj_cbColumn.setEnabled(item!==undefined);

		});
		srvobj_cbColumn.onChange(function(index,text){
			item = srvobj_grFieldMap.getItem();
			if(item){
				item.column = text;
				item.colcaption = text;
				srvobj_grFieldMap.updateItem(item);
			}

		});
		srvobj_btnAddColumn.onClick(function(){
			var item = srvobj_grFieldMap.getItem();
			if(item){
				icc.ui.msginput(_T("Add column"),item.name,240,_T("Add column for field")+" "+item.name+"'",
					function(result,text){

						if(result === "ok"){
							text = icc.utils.trim(text);
							if (text!==''){
								var res=true;
								jQuery.each([data.description.columns,newColumns],function(idx,list){

									jQuery.each(list,
										function(idx,column){
											if (column.name === text ){
												icc.ui.msgbox(_T("Duplicate column name"),_T("Error"),"error");
												res = false;
												return false;
											}
										}
									);
								});
								if(res){
									var column = {name:text,type:item.type,maxLength:item.maxLength};
									newColumns.push(column);
									srvobj_cbColumn.addItem({text:text,id:text});
									item.column = text;
									item.colcaption =text;
									srvobj_cbColumn.setItem(text);
									srvobj_grFieldMap.updateItem(item);

								}

								return res;
							}else {
								icc.ui.msgbox(_T("Please enter a column name"),_T("Error"),"error");
								return false;
							}

						}
					}
				);
			}
		});
		srvobj_btnCancel.onClick(function(){
			dlg.close();
			if(cb){
				cb(false);
			}
		});
		srvobj_btnOk.onClick(function(){
			var item = srvobj_cbObjectList.getItem();
			tgt.enabled = true;
			switch(item.type){
				case 'USER_TABLE':
					tgt.type = "msqltable";
					tgt.tableName = item.id;
					break;
				case 'SQL_STORED_PROCEDURE':

					tgt.type = "msqlproc";
					tgt.spName = item.id;
					break;
			}
			jQuery.each(newColumns,function(idx,column){
				data.description.columns.push(column);
			});
			doc.fireEvent("columns.added",newColumns);


			tgt.inputParams= [];
			jQuery.each(grid_items,function(idx,item){
				// como viene del grid puede tener algun campo basura
				// copiamos solo los que nos interesan
				var t={
					name:item.name,
					column:item.column,
					key:item.key,
					identity:item.identity,
					allowNull:item.allowNull,
					type:item.type,
					maxLength:item.maxLength,
					dbType:item.dbType
				};
				jQuery.each(data.description.columns,function(idx,col){
					if (col.name == item.column){
						if(col.maxLength == undefined)
							col.maxLength = item.maxLength;
					}
				});

				if(item.missing){ // si es missing , la guardamos si tiene columna asignada , dara error luego
					if(item.column !==undefined){
						tgt.inputParams.push(t);
					}
				}else{
					tgt.inputParams.push(t);
				}
			});
			dlg.close();
			doc.setConfigData(data);
			if(cb){
				cb(true);
			}
		});
		/////////////
		dlg.create();
		dlg.showModal();
		dlg.onCreate(function(){
			fillColumns();
			fillObjectList(function(){
//				setTimeout(function(){
					mergeObjectInfo();
//				},10000)
			});
		});
	};

	datasourceView.prototype.InputFieldSettingsDlg = function (doc,data,filter,segment,cb) {
		var self=this;
		<%FRAME:dsDesignerAssets.filterSegmentSettingsPanel%>
		if (segment.settings == undefined)
			segment.settings = {}
		var field_items = []
		for (k in filter.criteria){
			var seg = filter.criteria[k];
			if (seg != segment && segment.column && seg.expr && seg.expr.substr(0,1)=='@' ){
				field_items.push({id:seg.column+seg.expr,text:seg.expr})
			}
		}
		var valuePanel = self.searchValuePanel(doc,data,segment.settings);
		var requiredPanel = self.requiredPanel2(doc,data,segment.settings,field_items);
		var enabledPanel = self.enabledPanel(doc,data,segment.settings,field_items);
		flsContentPanel.childs=[
			valuePanel,
			enabledPanel,
			requiredPanel
		];
		var dlg = new icc.ui.dialog({
			//caption:dlg_caption,
			childs:[
				filterSegmentSettingsPanel
			]
		});
		flsBtnCancel.onClick(function(){
			dlg.close();
			if(cb){
				cb(false);
			}
		});
		flsBtnOk.onClick(function(){
			dlg.close();
			doc.setConfigData(data);
			if(cb){
				cb(true);
			}
		});
		/////////////
		dlg.create();
		dlg.showModal();
		dlg.onCreate(function(){
		});
	};


	datasourceView.prototype.iccFlowSrvOperativeSetup = function (doc,data,key,tgt,cb) {
		var self=this;
		<%FRAME:dsDesignerAssets.iccFlowsrvOpPanel%>

		var newColumns = [];
		var columns_map = {}; // guardamos las columnas por nombre para comprobar si existen aun
		var dlg_caption;
		var item;


		jQuery.each(data.description.columns,function(idx,column){
			columns_map[column.name]=column;
		});
		iccFlowcbSrvOpParamType.properties({
            items:[
				{id:'integer',	text:_T('integer')},
				{id:'numeric',	text:_T('numeric')},
				{id:'string',	text:_T('string')},
				{id:'datetime', text:_T('datetime')},
				{id:'date', text:_T('date')},
				{id:'boolean', text:_T('boolean')}
            ]
        });

		// carga el combo de columnas
		var fillColumns = function(){
			var item = iccFlowcbSrvOpColumn.getItem();
			iccFlowcbSrvOpColumn.clearAll();
			jQuery.each(data.description.columns,function(idx,column){
				iccFlowcbSrvOpColumn.addItem({text:column.name,id:column.name});
			});
			if(item){
				iccFlowcbSrvOpColumn.setItem(item.id);
			}
		};
		switch(key){
			case 'retrieve':
				dlg_caption = _T("SELECT configuration");
				break;
			case 'store':
				dlg_caption = _T("INSERT configuration");
				break;
			case 'update':
				dlg_caption = _T("UPDATE configuration");
				break;
			case 'delete':
				dlg_caption = _T("DELETE configuration");
				break;
		}
		var grid_items = [];
		jQuery.each(tgt.inputParams,function(idx,param){

			item = {
				id:param.name,
				text:param.name,
				name:param.name,
				type:param.type,
				column:param.column,
				colcaption:param.column

			};
			grid_items.push(item);
		});
		iccFlowgrSrvOpParams.items = grid_items;
		iccFlowtxSrvOpName.text = tgt.idOperativa;
		iccFlowtxSrvOpXPathRow.text = tgt.XPathRow;
		var dlg = new icc.ui.dialog({
			caption:dlg_caption,
			childs:[
				iccFlowsrvOpPanel
			]
		});

		iccFlowbtnSrvOpClearCol.onClick(function(){
			var item;
			iccFlowcbSrvOpColumn.setItem(-1);
			item = iccFlowgrSrvOpParams.getItem();
			if(item){
				item.column = undefined;
				item.colcaption=undefined;
				iccFlowgrSrvOpParams.updateItem(item);
			}

		});
		iccFlowcbSrvOpColumn.onChange(function(index,text){
			item = iccFlowgrSrvOpParams.getItem();
			if(item){
				item.column = text;
				item.colcaption = text;
				iccFlowgrSrvOpParams.updateItem(item);
			}

		});
		iccFlowbtnSrvOpAddCol.onClick(function(){
			var item = iccFlowgrSrvOpParams.getItem();
			icc.ui.msginput(_T("Add column"),item?item.name:"",240,_T("Add column "),
				function(result,text){

					if(result === "ok"){
						text = icc.utils.trim(text);
						if (text!==''){
							var res=true;
							jQuery.each([data.description.columns,newColumns],function(idx,list){

								jQuery.each(list,
									function(idx,column){
										if (column.name === text ){
											icc.ui.msgbox(_T("Duplicate column name"),_T("Error"),"error");
											res = false;
											return false;
										}
									}
								);
							});
							if(res){
								var column = {name:text};
								newColumns.push(column);
								iccFlowcbSrvOpColumn.addItem({text:text,id:text});

								iccFlowcbSrvOpColumn.setItem(text);
								if(item){
									item.column = text;
									item.colcaption =text;
									iccFlowgrSrvOpParams.updateItem(item);
								}

							}

							return res;
						}else {
							icc.ui.msgbox(_T("Please enter a column name"),_T("Error"),"error");
							return false;
						}

					}
				}
			)
		});
		iccFlowtxSrvOpParamName.onChange(function(value,valid){
			var item = iccFlowgrSrvOpParams.getItem();
			if(item && valid){
				item.text = value;
				name:iccFlowtxSrvOpParamName.getText(),
				iccFlowgrSrvOpParams.updateItem(item);
			}
		});
		iccFlowtxSrvOpName.onChange(function(value,valid){
			iccFlowbtnSrvOpOk.setEnabled(valid && iccFlowtxSrvOpXPathRow.isValid() )
		});

		iccFlowtxSrvOpXPathRow.onChange(function(value,valid){
			iccFlowbtnSrvOpOk.setEnabled(valid && iccFlowtxSrvOpName.isValid())

		});
		iccFlowbtnSrvOpRmvParam.onClick(function(){
			var item = iccFlowgrSrvOpParams.getItem();
			if(item){
				iccFlowgrSrvOpParams.rmvItem(item);
				iccFlowcbSrvOpColumn.setItem(-1);
				iccFlowtxSrvOpParamName.setText("");
				iccFlowcbSrvOpParamType.setItem(-1);
				iccFlowbtnSrvOpRmvParam.setEnabled(false);

			}
		});

		iccFlowbtnSrvOpAddParam.onClick(function(){
			if(iccFlowgrSrvOpParams.getItem()){

				iccFlowcbSrvOpColumn.setItem(-1);
				iccFlowgrSrvOpParams.setItem(-1);
				iccFlowcbSrvOpParamType.setItem(-1);
				iccFlowtxSrvOpParamName.setText("");

			}else{
				var t = iccFlowcbSrvOpParamType.getItem();
				var c = iccFlowcbSrvOpColumn.getItem();
				if (t){
					if(c){
						c = c.text;

					}else
						c=undefined;
					t = t.id;
					var newItem = {
						text:iccFlowtxSrvOpParamName.getText(),
						name:iccFlowtxSrvOpParamName.getText(),
						type:t,
						column:c,
						colcaption:c
					};
					iccFlowgrSrvOpParams.addItem(newItem);
					iccFlowgrSrvOpParams.setItem(newItem);
					iccFlowbtnSrvOpRmvParam.setEnabled(true);
				}

			}

/*			if(iccFlowgrSrvOpParams.getItem()){
				iccFlowcbSrvOpColumn.setItem(-1);
			}else{
				iccFlowcbSrvOpColumn.setItem(-1);
			}
*/
		});
		iccFlowcbSrvOpParamType.onChange(function(idx,text){
			var item =iccFlowgrSrvOpParams.getItem();
			if(item){
				item.type = text;
				iccFlowgrSrvOpParams.updateItem(item);
			}

		});
		iccFlowgrSrvOpParams.onChange(function(item){
			if (item){
				iccFlowcbSrvOpColumn.setItem(item.column);
				iccFlowtxSrvOpParamName.setText(item.name);
				iccFlowcbSrvOpParamType.setItem(item.type);
				iccFlowbtnSrvOpRmvParam.setEnabled(true);
			}else{
				iccFlowcbSrvOpColumn.setItem(-1);
				iccFlowbtnSrvOpRmvParam.setEnabled(false);
			}

			iccFlowbtnSrvOpClearCol.setEnabled(item!==undefined);
			iccFlowbtnSrvOpRmvParam.setEnabled(item!==undefined);

			iccFlowcbSrvOpColumn.setEnabled(item!==undefined);

		});

		iccFlowbtSrvOpCancel.onClick(function(){
			dlg.close();
			if(cb){
				cb(false);
			}
		});
		iccFlowbtnSrvOpOk.onClick(function(){


			tgt.type = "icc_flow_ws";
			tgt.idOperativa=icc.utils.trim(iccFlowtxSrvOpName.getText());
			tgt.XPathRow = icc.utils.trim(iccFlowtxSrvOpXPathRow.getText());
			tgt.enabled = true;
			tgt.inputParams= [];

			jQuery.each(iccFlowgrSrvOpParams.getItems(),function(idx,item){
				// como viene del grid puede tener algun campo basura
				// copiamos solo los que nos interesan
				var t={
					name:item.name,
					column:item.column,
					allowNull:true,
					type:item.type
				};
				tgt.inputParams.push(t);
			});
			// las nuevas columnas creadas son recorridas
			// si se encuentra un parametro al que esten mapeadas
			// se les asigna el tipo y se agregan a las columnas del datasource
			jQuery.each(newColumns,function(idx,column){
				jQuery.each(tgt.inputParams,function(idx,param){
					if(param.column == column.name){
						column.type = param.type;
						data.description.columns.push(column);
						return false;
					}

				});
			});
			doc.fireEvent("columns.added",newColumns);

			dlg.close();
			doc.setConfigData(data);
			if(cb){
				cb(true);
			}
		});
		/////////////
		dlg.create();
		dlg.showModal();
		dlg.onCreate(function(){
			fillColumns();
		});

	};


	datasourceView.prototype.serverObjectLine = function (doc,data,tgt,key,caption){
		<%FRAME:dsDesignerOperationsPanel.rowTemplate%>
		var info;
		var self = this;


		var buildResume = function(){
			var tx;
			tgt[key]= tgt[key] ? tgt[key]:{'':''};

			info = tgt[key];
			if(info.enabled){

				switch(info.type){
					case 'icc_flow_ws':
						tx = _T('calling flow operative') + _T(':') + info.idOperativa;
					break;
					case 'msqltable':
						switch(key){
							case 'retrieve':
							case 'delete':
								tx = _T('directly from table') + _T(':') + info.tableName;
							break;
							case 'store':
							case 'update':
								tx = _T('directly into table') + _T(':') + info.tableName;
							break;

						}
					break;
					case 'msqlproc':
						tx = _T('calling store procedure') + _T(':') +info.spName;
					break;
					default:
						tx = _T("operation is unavailable");
				}
			}else{
				tx = _T('operation is unavailable');
			}
			return tx;
		};
		srvop_lbInfo.caption = buildResume();
		srvop_lbTitle.caption = caption;
		srvop_btnSet.onClick(function(){
			if (data.type == "mssql"){
				self.SQLserverObjectSetup(doc,data,key,tgt[key],function(status){
					if(status){
						srvop_lbInfo.setCaption(buildResume());
					}
				});
			}else if (data.type == "icc_flow_ws" || data.type == "icc_flow_ws_inner_ds" ){

				self.iccFlowSrvOperativeSetup(doc,data,key,tgt[key],function(status){
					if(status){
						srvop_lbInfo.setCaption(buildResume());
					}
				});

			}
		});
		srvop_btnUnset.onClick(function(){
			info = tgt[key];
			info.enabled = false;
			srvop_lbInfo.setCaption(buildResume());
			doc.setConfigData(data);
		});

		return rowTemplate;
	};
	datasourceView.prototype.srvOperationsPanel = function(doc,data){
		<%VIEW:dsDesignerOperationsPanel%>

		dsDesignerOperationsPanel.caption =_T("Operations and settings");
		var gralSettings;
		gralSettingsFrame.properties({
			height:undefined

		})
		switch(doc.getType()){
			case "mssql":
				gralSettings = new icc.ui.panel({
					fillWidth:true,
					childs:[
						this.databasePanel(doc,data),
						this.specialSettingsPanel(doc,data)


					]
				});
			break;
			case "icc_flow_ws_inner_ds":
				gralSettings = new icc.ui.panel({
					fillWidth:true,
					childs:[
						this.iccFlowSecondarysRetrieveSettings(doc,data),
						this.specialSettingsPanel(doc,data)
					]
				});
			break;
			default:
				gralSettings = new icc.ui.panel({
					fillWidth:true,
					childs:[
						this.specialSettingsPanel(doc,data)
					]
				});
			break;
		}
		if(gralSettings!=undefined){
			gralSettingsFrame.childs.push(gralSettings);
		}else
			gralSettingsFrame.visible = false;

		rowContainer.childs=[]
		if(data.type != "icc_flow_ws_inner_ds")
			rowContainer.childs.push(this.serverObjectLine(doc,data,data.description,'retrieve',"Select"));

		rowContainer.childs.push(this.serverObjectLine(doc,data,data.description,'store',"Insert"));
		rowContainer.childs.push(this.serverObjectLine(doc,data,data.description,'update',"Update"));
		rowContainer.childs.push(this.serverObjectLine(doc,data,data.description,'delete',"Delete"));

		return dsDesignerOperationsPanel;
	}
    datasourceView.prototype.mssqlPanel = function(doc,data){
		var self = this;
		var bcols = true;
		data['private'] = data['private'] ? data['private']:{'':''};
		data.description = data.description ? data.description:{'':''};


		data.description.columns = data.description.columns ? data.description.columns : [];

		data.description.retrieve = data.description.retrieve ? data.description.retrieve : {'':''};
		data.description.retrieve.inputParams = data.description.retrieve.inputParams ? data.description.retrieve.inputParams : [];
		data.description.store = data.description.store ? data.description.store : {'':''};
		data.description.store.inputParams = data.description.store.inputParams ? data.description.store.inputParams : [];

		data.description.update = data.description.update ? data.description.update : {'':''};
		data.description.update.inputParams = data.description.update.inputParams ? data.description.update.inputParams : [];

		data.description['delete'] = data.description['delete'] ? data.description['delete'] : {'':''};
		data.description['delete'].inputParams = data.description['delete'].inputParams ? data.description['delete'].inputParams : [];
		if (data.description.retrieve.outputColumns){
			jQuery.each(data.description.retrieve.outputColumns,function(idx,column){

				data.description.columns.push(column);
			});
			data.description.retrieve.outputColumns = undefined;

			jQuery.each([data.description.retrieve.inputParams,data.description.store.inputParams,data.description.update.inputParams,data.description['delete'].inputParams],function(idx,list){
				jQuery.each(list,function(idx,column){
					column.column = column.name;
				});
			});
			data.description.retrieve.enabled = data.description.retrieve.enabled;
			data.description.store.enabled = data.description.store.enabled;
			data.description.update.enabled = data.description.update.enabled;
			data.description['delete'].enabled = data.description['delete'].enabled;
			data.description.retrieve.enabled = undefined;
			data.description.store.enabled = undefined;
			data.description.update.enabled = undefined;
			data.description['delete'].enabled = undefined;



		}
		this.mssql_builtin_config = {};
		icc.ui.designer.dsintrospection.mssql_builtin_config(icc.ui.getApplication().getVCCName(), function(success, builtin_config) {
			if (success) {
				this.mssql_builtin_config = builtin_config || {};
			}
		});
		
		var tabPanel;
		var srvOperationsPanel;
		var filtersPanel;
		var databasePanel = this.databasePanel(doc,data)
		var filterContainer = new icc.ui.panel({caption:_T('Filter/Trigger')})
		var relationshipsPanel = this.relationshipsPanel(doc,data);
		var fieldsPanel = this.fieldsPanel(doc,data);
		var srvOperationsPanel = this.srvOperationsPanel(doc,data);
		tabPanel = new icc.ui.tabpanel({
			childs:[
				fieldsPanel,
				relationshipsPanel,
				filterContainer,
				srvOperationsPanel
			]
		})

		tabPanel.onChange(function(cindex){
			if(data.description.retrieve.type == "msqlproc"){
				filterPanel = self.triggerPanel(doc,data,self.appDoc);
			}else{
				filterPanel = self.filterPanel(doc,data,self.appDoc);
			}
			filterPanel.create();
			filterContainer.rmvAll();
			filterContainer.addChild(filterPanel);
			filterContainer.layout();
		});
		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;

		};

        return tabPanel;
    };

	datasourceView.prototype.filterPanel = function (doc,data,appDoc,showSortSection){
		var self = this;
		<%VIEW:dsDesignerFilterPanel%>
		dsDesignerFilterPanel.caption =_T("Filter/Trigger");
		var items = [];
		var filters = data.description.filters;
		segmentsPanel.childs = [];
		segmentsPanel.overflowy="scroll";
		orderPanel.childs = [];
		orderPanel.overflowy="scroll";
		if(showSortSection==undefined)
			showSortSection=true;
		sortPanel.visible = showSortSection;
		var cbColumnsItems = function(){
			var res = [];

			jQuery.each(data.description.columns,function(idx,column){
				if(!column.hidden)
					res.push({text:column.name});
			});
			return res;
		}
		var updateWhereLabel = function(filter){
			tx = ""
			var t = []
			var pcount = 0;
			filter.unbalancedParenthesis = false;
			var inspectForward = function(idx){
				var res = false;
				while (idx<filter.criteria.length && !res){
					if(	filter.criteria[idx].column !== undefined &&
						filter.criteria[idx].comparator !== undefined &&
						filter.criteria[idx].expr !== undefined &&
						filter.criteria[idx].expr !== '')
						res=true
					else
						idx++
				}
				return res;
			}
			jQuery.each(filter.criteria,function(idx,segment){
				if (segment.column !== undefined  && segment.comparator !== undefined && segment.expr !== undefined  && segment.expr !== ''){
					segment.open = segment.open == undefined ?"":segment.open;
					segment.close = segment.close == undefined ?"":segment.close;

					if (segment.open === "(" )
						pcount+=1
					else if(segment.open == "((")
						pcount+=2
					else if(segment.open == "(((")
						pcount+=3


					tx+=segment.open +" ";
					if (segment.nullable)
						tx+= "["

					tx+=segment.column +" ";
					var c= segment.comparator
					if (c == "%"){
						tx+='LIKE %'+segment.expr+"% ";

					}else{
						tx+=c+" ";
						tx+=segment.expr+" ";
					}


					tx+=segment.close;
					if (segment.close === ")" )
						pcount-=1
					else if(segment.close == "))")
						pcount-=2
					else if(segment.close == ")))")
						pcount-=3


					if (segment.nullable && segment.close !== '')
						tx+= "]"

					if(inspectForward(idx+1))
						tx+=" "+segment.combinator+" ";

					if (segment.nullable && segment.close == '')
						tx+= "]"
				}
			});
			if (pcount != 0){
				tx += _T(" -  Unbalanced parentheses");
				filter.unbalancedParenthesis = true;
			}

			lbFilterWhere.setCaption(tx);

		}
		var showFilter = function ( filter) {
			var criteria_controls = [];
			var order_controls= [];
			var enable_criteria_buttons = function(){
				if(filter){
					jQuery.each(criteria_controls,function(pos,criteria_entry){
						criteria_entry.rmv.setEnabled(pos>0 ||filter.criteria.length>1 );
						criteria_entry.add.setEnabled(true);
					});
				}
			}
			var enable_order_buttons = function(){
				if(filter){
					jQuery.each(order_controls,function(pos,order_entry){
						order_entry.rmv.setEnabled(pos>0 ||filter.order.length>1 );
						order_entry.add.setEnabled(true);
					});
				}
			}

			var buildOrderColumnWnd = function (order_column,pos){
				<%FRAME:dsDesignerFilterPanel.orderColumn%>
				cbSortOrder.items = [
					{text:'ASC'},
					{text:'DESC'}
				];

				cbSortColumn.items = cbColumnsItems();
				cbSortColumn.item = 1;
				orderColumn.setColumn = function (column){
					if (column){
						cbSortColumn.setItem(column.column);
						cbSortOrder.setItem(column.order);
					}else{
						cbSortColumn.setItem(-1);
						cbSortOrder.setItem(-1);
					}
					cbSortColumn.setEnabled(column !== undefined);
					cbSortOrder.setEnabled(column !== undefined);
				}
				orderColumn.onCreate(function(){
					this.setColumn(order_column);
				});
				cbSortColumn.onChange(function(idx,text,item){
					order_column.column = text;
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});

				cbSortOrder.onChange(function(idx,text,item){
					order_column.order = text;
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});

				btnAddOrderColumn.onClick(function(){
					var w;
					var pos = 0;
					var newCol = {order:'ASC'};
					while (filter.order[pos]!==order_column)pos++;
					pos++;
					filter.order.splice(pos,0,newCol);
					w = buildOrderColumnWnd(newCol,pos);
					w.create();
					orderPanel.addChild(w,pos);
					orderPanel.layout();
					enable_order_buttons();
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});
				btnRmvOrderColumn.onClick(function(){
					var pos = 0;
					while (filter.order[pos]!==order_column)pos++;

					filter.order.splice(pos,1);
					order_controls.splice(pos,1);
					orderPanel.rmvChild(orderColumn);
					orderPanel.layout();
					enable_order_buttons();
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});
				order_controls.splice(pos,0,{add:btnAddOrderColumn,rmv:btnRmvOrderColumn});
				return orderColumn;
			};

			var buildFilterCriteriaWnd=function (segment,pos){
				var m_segment = segment;
				<%FRAME:dsDesignerFilterPanel.filterSegment%>
				filterFrameColumn.borderWidth=0;
				filterFrameControls.borderWidth=0;
				cbfilterParamOpen.items = [
					{id:"",text:'&nbsp'},
					{id:"(",text:'('},
					{id:"((",text:'(('},
					{id:"(((",text:'((('}

				]
				cbfilterParamClose.items = [
					{id:"",text:'&nbsp'},
					{id:")",text:')'},
					{id:"))",text:'))'},
					{id:")))",text:')))'}
				]

				cbSegmentComparator.items = [
					{id:"==",text:'=='},
					{id:"!=",text:'!='},

					{id:">",text:'>'},
					{id:">=",text:'>='},
					{id:"<",text:'<'},
					{id:"<=",text:'<='},
					{id:"%",text:'Like'}
				];
				cbSegmentCombinator.items = [
					{text:'AND'},
					{text:'OR'}
				];
				var posColumnFrame = function(){
					if(filterFrameColumn._identBase == undefined){
						filterFrameColumn._identBase = filterFrameColumn.x
					}
					filterFrameColumn.x = filterFrameColumn._identBase + (segment.ident * 30)
					if (filterSegment.getWnd()){
						filterSegment.layout();
					}
				}

				filterColumnName.items = cbColumnsItems();
				filterColumnName.item = filterColumnName.items[1];
				filterSegment.setSegment = function(segment){
					m_segment = segment;
					if (segment){
						filterColumnName.setItem(segment.column);
						cbSegmentComparator.setItem(segment.comparator);
						txFilterExpr.setText(segment.expr);
						ckSegmentNullable.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
						ckSegmentNullable.setChecked(segment.nullable && segment.expr !== undefined && segment.expr.substr(0,1)=='@' )
						btnSegmentProperties.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
						cbSegmentCombinator.setItem(segment.combinator);

					}else{
						filterColumnName.setItem(-1);
						cbSegmentComparator.setItem(-1);
						txFilterExpr.setText("");
						ckSegmentNullable.setChecked(false);
						ckSegmentNullable.setEnabled(false);
						btnSegmentProperties.setEnabled(false)
						cbSegmentCombinator.setItem(-1);
					}
					filterColumnName.setEnabled(segment !== undefined);
					cbSegmentComparator.setEnabled(segment !== undefined);
					txFilterExpr.setEnabled(segment !== undefined);
					cbSegmentCombinator.setEnabled(segment !== undefined);
				};
				cbfilterParamOpen.item = segment.open;
				cbfilterParamOpen.onChange(function(idx,text,item){
					segment.open = item.id;
					updateWhereLabel(filter);
					doc.setConfigData(data);

				});
				cbfilterParamClose.item = segment.close;
				cbfilterParamClose.onChange(function(idx,text,item){
					segment.close = item.id;
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});
				txFilterExpr.onChange(function(value){
					segment.expr=value;
					ckSegmentNullable.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
					btnSegmentProperties.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
					ckSegmentNullable.setChecked(segment.nullable && segment.expr !== undefined && segment.expr.substr(0,1)=='@')
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});
				filterColumnName.onChange(function(idx,text,item){
					segment.column = text;
					updateWhereLabel(filter);
					doc.setConfigData(data);

				});
				cbSegmentComparator.onChange(function(idx,text,item){
					segment.comparator = item.id;
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});
				cbSegmentCombinator.onChange(function(idx,text,item){
					segment.combinator = text;
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});
				ckSegmentNullable.onChange(function(value){
					segment.nullable = value;
					updateWhereLabel(filter);
					doc.setConfigData(data);
				});

				btnAddSegment.onClick(function(){
					var w;
					var pos = 0;
					var newSeg = {combinator:'AND',open:'',close:'',
						settings:{
						}
					};
					while (filter.criteria[pos]!==segment)pos++;
					pos++;
					filter.criteria.splice(pos,0,newSeg);
					w = buildFilterCriteriaWnd(newSeg,pos);
					w.create();
					segmentsPanel.addChild(w,pos);
					segmentsPanel.layout();
					enable_criteria_buttons();
					doc.setConfigData(data);
					updateWhereLabel(filter);

				});

				btnRemoveSegment.onClick(function(){
					var pos = 0;
					while (filter.criteria[pos]!==segment)pos++;

					filter.criteria.splice(pos,1);
					criteria_controls.splice(pos,1);
					segmentsPanel.rmvChild(filterSegment);
					segmentsPanel.layout();
					enable_criteria_buttons();
					doc.setConfigData(data);
					updateWhereLabel(filter);

				});
				btnSegmentProperties.onClick(function(){

					self.InputFieldSettingsDlg(doc,data,filter,segment,function(status,result){

					})
				});
				filterSegment.onCreate(function(){
					this.setSegment(m_segment);
				});
				criteria_controls.splice(pos,0,{seg:segment,add:btnAddSegment,rmv:btnRemoveSegment});
				return filterSegment;
			};
			segmentsPanel.rmvAll();
			orderPanel.rmvAll();
			if (filter){
				jQuery.each(filter.criteria,function(idx,segment){
					var w = buildFilterCriteriaWnd(segment,idx);
					w.create();
					segmentsPanel.addChild(w);
				});
				jQuery.each(filter.order,function(idx,column){
					var w = buildOrderColumnWnd(column,idx);
					w.create();
					orderPanel.addChild(w);
				});
				updateWhereLabel(filter);
			}else{
				var w = buildFilterCriteriaWnd(undefined,0);
				w.create();
				segmentsPanel.addChild(w);
				var w = buildOrderColumnWnd(undefined,0);
				w.create();
				orderPanel.addChild(w);
			}
			orderPanel.layout();
			segmentsPanel.layout();
			enable_criteria_buttons();
			enable_order_buttons();

		}
		btnClearFilterCriteria.onClick(function(){
			data.description.filters[0].criteria = [{comparator:'==',combinator:'AND',open:'',close:''}];
			showFilter(data.description.filters[0]);
			doc.setConfigData(data);

		});
		btnClearOrderColumns.onClick(function(){
			data.description.filters[0].order = [{order:'ASC'}];
			showFilter(data.description.filters[0]);
			doc.setConfigData(data);

		});

		dsDesignerFilterPanel.onCreate(function(){
			if (!data.description.filters)
				data.description.filters = [];
			if(!data.description.filters[0])
				data.description.filters[0]={name:'default',isDefault:true,criteria:[{comparator:'==',combinator:'AND',open:'',close:''}],order:[{order:'ASC'}]};

			showFilter(data.description.filters[0]);
		});
		return dsDesignerFilterPanel;
	};
	// Es una copia de filterPanel que setea la misma estructura del filtro
	// setear a estos datasources (sql stored procedure,webservice ) el filtro
	// solo afecta el lado del cliente donde se evalua si estan todos los
	//parametros para disparar un query

	datasourceView.prototype.triggerPanel = function (doc,data,appDoc){
		<%VIEW:dsDesignerTriggerPanel%>
		var self = this;
		dsDesignerTriggerPanel.caption = _T("Trigger");
		var items = [];
		var filters = data.description.filters;
		segmentsPanel.childs = [];
		segmentsPanel.overflowy="scroll";
		var cbColumnsItems = function(){
			var res = [];

			jQuery.each(data.description.columns,function(idx,column){
				if (!column.hidden && column.searcheableCriteria !== false){
					res.push({text:column.name});
				}
			});
			return res;
		}
		var showFilter = function ( filter) {
			var criteria_controls = [];
			var order_controls= [];
			var enable_criteria_buttons = function(){
				if(filter){
					jQuery.each(criteria_controls,function(pos,criteria_entry){
						criteria_entry.rmv.setEnabled(pos>0 ||filter.criteria.length>1 );
						criteria_entry.add.setEnabled(true);
					});
				}
			}

			var buildFilterCriteriaWnd=function (segment,pos){
				var m_segment = segment;
				<%FRAME:dsDesignerTriggerPanel.filterSegment%>
				filterFrameColumn.borderWidth=0;
				filterFrameControls.borderWidth=0;
				var posColumnFrame = function(){
					if(filterFrameColumn._identBase == undefined){
						filterFrameColumn._identBase = filterFrameColumn.x
					}
					filterFrameColumn.x = filterFrameColumn._identBase + (segment.ident * 30)
					if (filterSegment.getWnd()){
						filterSegment.layout();
					}
				}

				filterColumnName.items = cbColumnsItems();
				filterColumnName.item = filterColumnName.items[1];
				filterSegment.setSegment = function(segment){
					m_segment = segment;
					if (segment){
						filterColumnName.setItem(segment.column);
						txFilterExpr.setText(segment.expr);
						ckSegmentNullable.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
						btnSegmentProperties.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')

						ckSegmentNullable.setChecked(segment.nullable && segment.expr !== undefined && segment.expr.substr(0,1)=='@' )


					}else{
						filterColumnName.setItem(-1);
						txFilterExpr.setText("");
						ckSegmentNullable.setChecked(false);
						ckSegmentNullable.setEnabled(false);
						btnSegmentProperties.setEnabled(false);
					}
					filterColumnName.setEnabled(segment !== undefined);
					txFilterExpr.setEnabled(segment !== undefined);
				};
				txFilterExpr.onChange(function(value){
					segment.expr=value;
					ckSegmentNullable.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
					btnSegmentProperties.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
					ckSegmentNullable.setChecked(segment.nullable && segment.expr !== undefined && segment.expr.substr(0,1)=='@')

					doc.setConfigData(data);
				});
				filterColumnName.onChange(function(idx,text,item){
					segment.column = text;
					doc.setConfigData(data);

				});
				ckSegmentNullable.onChange(function(value){
					segment.nullable = value;
					doc.setConfigData(data);
				});

				btnAddSegment.onClick(function(){
					var w;
					var pos = 0;
					var newSeg = {combinator:'AND',open:'',close:''};
					while (filter.criteria[pos]!==segment)pos++;
					pos++;
					filter.criteria.splice(pos,0,newSeg);
					w = buildFilterCriteriaWnd(newSeg,pos);
					w.create();
					segmentsPanel.addChild(w,pos);
					segmentsPanel.layout();
					enable_criteria_buttons();
					doc.setConfigData(data);

				});
				btnRemoveSegment.onClick(function(){
					var pos = 0;
					while (filter.criteria[pos]!==segment)pos++;

					filter.criteria.splice(pos,1);
					criteria_controls.splice(pos,1);
					segmentsPanel.rmvChild(filterSegment);
					segmentsPanel.layout();
					enable_criteria_buttons();
					doc.setConfigData(data);

				});
				btnSegmentProperties.onClick(function(){
					self.InputFieldSettingsDlg(doc,data,filter,segment,function(status,result){

					})
				});

				filterSegment.onCreate(function(){
					this.setSegment(m_segment);
				});
				criteria_controls.splice(pos,0,{seg:segment,add:btnAddSegment,rmv:btnRemoveSegment});
				return filterSegment;
			};
			segmentsPanel.rmvAll();
			if (filter){
				jQuery.each(filter.criteria,function(idx,segment){
					var w = buildFilterCriteriaWnd(segment,idx);
					w.create();
					segmentsPanel.addChild(w);
				});
			}else{
				var w = buildFilterCriteriaWnd(undefined,0);
				w.create();
				segmentsPanel.addChild(w);
			}
			segmentsPanel.layout();
			enable_criteria_buttons();

		}
		btnClearFilterCriteria.onClick(function(){
			data.description.filters[0].criteria = [{comparator:'==',combinator:'AND',open:'',close:''}];
			showFilter(data.description.filters[0]);
			doc.setConfigData(data);

		});

		dsDesignerTriggerPanel.onCreate(function(){
			if (!data.description.filters)
				data.description.filters = [];
			if(!data.description.filters[0])
				data.description.filters[0]={name:'default',isDefault:true,criteria:[{comparator:'==',combinator:'AND',open:'',close:''}],order:[{order:'ASC'}]};

			showFilter(data.description.filters[0]);
		});
		return dsDesignerTriggerPanel;
	};


	datasourceView.prototype.indexPanel = function (doc,data,appDoc){
		<%VIEW:dsDesignerIndexPanel%>
		dsDesignerIndexPanel.caption = _T("Indexes");
		var items = [];
		var indexes = data.description.indexes;

		columnsPanel.childs = [];
		columnsPanel.overflowy="scroll";
		var cbColumnsItems = function(){
			var res = [];

			jQuery.each(data.description.columns,function(idx,column){
				res.push({text:column.name});
			});
			return res;
		}
		var showIndex = function ( index) {
			var columns_controls= [];
			var enable_columns_buttons = function(){
				if(index){
					jQuery.each(columns_controls,function(pos,column_entry){
						column_entry.rmv.setEnabled(pos>0 ||index.columns.length>1 );
						column_entry.add.setEnabled(true);
					});
				}
			}

			var buildIndexColumnWnd = function (order_column,pos){
				<%FRAME:dsDesignerIndexPanel.indexColumn%>
				cbColumnSortOrder.items = [
					{text:'ASC'},
					{text:'DESC'}
				];

				cbIndexColumn.items = cbColumnsItems();
				cbIndexColumn.item = 1;
				indexColumn.setColumn = function (column){
					if (column){
						cbIndexColumn.setItem(column.column);
						cbColumnSortOrder.setItem(column.order);
					}else{
						cbIndexColumn.setItem(-1);
						cbColumnSortOrder.setItem(-1);
					}
					cbIndexColumn.setEnabled(column !== undefined);
					cbColumnSortOrder.setEnabled(column !== undefined);
				}
				indexColumn.onCreate(function(){
					this.setColumn(order_column);
				});
				cbIndexColumn.onChange(function(idx,text,item){
					order_column.column = text;
					doc.setConfigData(data);
				});

				cbColumnSortOrder.onChange(function(idx,text,item){
					order_column.order = text;
					doc.setConfigData(data);
				});

				btnAddIndexColumn.onClick(function(){
					var w;
					var pos = 0;
					var newCol = {order:'ASC'};
					while (index.columns[pos]!==order_column)pos++;
					pos++;
					index.columns.splice(pos,0,newCol);
					w = buildIndexColumnWnd(newCol,pos);
					w.create();
					columnsPanel.addChild(w,pos);
					columnsPanel.layout();
					enable_columns_buttons();
					doc.setConfigData(data);

				});
				btnRmvIndexColumn.onClick(function(){
					var pos = 0;
					while (index.columns[pos]!==order_column)pos++;

					index.columns.splice(pos,1);
					columns_controls.splice(pos,1);
					columnsPanel.rmvChild(indexColumn);
					columnsPanel.layout();
					enable_columns_buttons();
					doc.setConfigData(data);

				});
				columns_controls.splice(pos,0,{add:btnAddIndexColumn,rmv:btnRmvIndexColumn});
				return indexColumn;
			};
			columnsPanel.rmvAll();
			if (index){
				txIndexName.setText(index.name);
				txIndexName.setEnabled(true);
				ckIndexUnique.setChecked(index.unique);
				ckIndexUnique.setEnabled(true);
				jQuery.each(index.columns,function(idx,column){
					var w = buildIndexColumnWnd(column,idx);
					w.create();
					columnsPanel.addChild(w);
				});

			}else{
				// ponemos una entrada disabled para que no quede vacio el panel
				txIndexName.setText("");
				txIndexName.setEnabled(false);
				ckIndexUnique.setChecked(false);
				ckIndexUnique.setEnabled(false);
				var w = buildIndexColumnWnd(undefined,0);
				w.create();
				columnsPanel.addChild(w);
			}
			dsDesignerIndexPanel.layout();
			columnsPanel.layout();
			enable_columns_buttons();
		}
		jQuery.each(indexes,function(idx,index){
			items.push({name:index.name,index:index})
		});

		gdIndexList.items = items;
		gdIndexList.onChange(function(item){
			showIndex(item.index);
			btnRmvIndex.setEnabled(true);
			btnClearIndexColumns.setEnabled(true);
		});
		txIndexName.onChange(function(value){
			var it=gdIndexList.getItem();
			it.index.name = value;
			it.name = value;
			gdIndexList.updateItem(it);
			doc.setConfigData(data);
		});
		ckIndexUnique.onChange(function(value){
			var it=gdIndexList.getItem();
			it.index.unique = value;
			doc.setConfigData(data);
		});
		btnAddIndex.onClick(function(){
			var newIndex = {name:'new index',columns:[{order:'ASC'}]}
			var newItem = {name:newIndex.name,index:newIndex};
			indexes.push(newIndex);
			gdIndexList.addItem(newItem);
			gdIndexList.setItem(newItem);
			showIndex(newItem.index);
			btnRmvIndex.setEnabled(true);
			btnClearIndexColumns.setEnabled(true);
			doc.setConfigData(data);

		});
		btnRmvIndex.onClick(function(){
			var it = gdIndexList.getItem();
			gdIndexList.rmvItem(it);
			jQuery.each(indexes,function(idx,index){
				if(index === it.index){
					indexes.splice(idx,1);
					return false;
				}
			});
			showIndex();
			this.setEnabled(false);
			btnClearIndexColumns.setEnabled(false);
			doc.setConfigData(data);

		});
		btnClearIndexColumns.onClick(function(){
			var it = gdIndexList.getItem();
			it.index.columns = [{order:'ASC'}];
			showIndex(it.index);
			doc.setConfigData(data);

		});
		dsDesignerIndexPanel.onCreate(function(){
			showIndex();
		});
		return dsDesignerIndexPanel;
	};

	datasourceView.prototype.nativeDsMaintenancePanel = function(doc,data,appDoc){
		var self = this;
		<%VIEW:dsDesignerNativeDSMaintenancePanel%>
		dsDesignerNativeDSMaintenancePanel.caption = _T("Maintenance and settings");
		this.map_checkField(ckEnableCache,doc,data,data.description,"enableCache");
		btnMaintenanceImport.onClick(function(){
			var dsNativeDataImport= new icc.ui.designer.dsNativeDataImport(appDoc,{},data);
			dsNativeDataImport.create();
			dsNativeDataImport.showModal(function(){
				//dsNativeDataImport.close();
			});
		});
		btnMaintenanceExport.onClick(function(){
			var dsNativeDataExport= new icc.ui.designer.dsNativeDataExport(appDoc,{},data);
			dsNativeDataExport.create();
			dsNativeDataExport.showModal(function(){
			});
		});
		btnMaintenanceDelete.onClick(function(){
			icc.ui.msgbox(_T("This action delete all datasource data"),_T("Please confirm"),"question",function(result){
				if(result == "ok"){

					doc.truncateData(function(status,result){
						if(status){
							icc.ui.msgbox("The datasource was successfully truncated.");
						}else{
							icc.ui.msgbox(result.message);
						}
					});
				}

			});
		});

		return dsDesignerNativeDSMaintenancePanel;
	}
	datasourceView.prototype.relationshipsPanel = function (doc,data){
		var self = this;
		<%VIEW:dsDesignerRelationshipsPanel%>
		dsDesignerRelationshipsPanel.caption = _T("Relationships");
		var items = [];
		var dsfields = [];
		var field_controls= [];
		var current_relationship;
		var relationships = data.description.relationships;
		relationshipFields.childs = [];
		relationshipFields.overflowy="scroll";
		var cbFieldsItems = function(){
			var res = [];

			jQuery.each(data.description.columns,function(idx,column){
				res.push({text:column.name});
			});
			return res;
		}
		// crea un array para un combo con los datasources de la aplicacion DEBERIA EXCLUIR el ds que estamos editando
		var cbDatasourcesItems = function(){
			var res = [];
			var datasources = self.appDoc.getDatasources();
			for (i=0;i<datasources.length;i++){
				res.push({
					id:datasources[i].name,
					text:datasources[i].name
				});
			}

			return res;
		};

		cbRelationshipDs.items = cbDatasourcesItems();
		var loadDatasourceFields=function(datasourceName){
			var update_combos = function(){
				jQuery.each(field_controls,function(pos,field_entry){
					field_entry.combo.clearAll();
					field_entry.combo.addItem(dsfields);
					field_entry.combo.setItem(field_entry.combo.__fieldName);
				});
			}

            var dsdoc = new icc.ui.designer.datasourceDoc(self.appDoc.getVCCName(),self.appDoc.getId(),datasourceName);
            dsdoc.load(function(status){
				dsfields = [];
                if(status){
                    var fields = dsdoc.getFields();
                    for (n =0;n<fields.length;n++){
                        dsfields.push({
                            text:fields[n].name,
                            id:fields[n].name
                        });
					}
                }
				update_combos();
            });

		}
		cbRelationshipDs.onChange(function(index,text,item){
			current_relationship.datasourceName = text;
			loadDatasourceFields(text);
			doc.setConfigData(data);
		});
		var showRelationship = function ( relationship) {
			field_controls= [];

			current_relationship = relationship;
			var enable_field_buttons = function(){
				if(relationship){
					jQuery.each(field_controls,function(pos,field_entry){
						field_entry.rmv.setEnabled(pos>0 ||relationship.fields.length>1 );
						field_entry.add.setEnabled(true);
					});
				}
			}
			var buildRelationshipFieldWnd = function (relationship_field,pos){
				<%FRAME:dsDesignerRelationshipsPanel.relationshipFieldTemplate%>



				cbRelationshipFromFieldName.items = cbFieldsItems();
				cbRelationshipFromFieldName.item = 1;
				cbRelationshipToFieldName.items = dsfields;
				relationshipFieldTemplate.setField = function (field){
					if (field){
						cbRelationshipFromFieldName.setItem(field.source);
						cbRelationshipToFieldName.setItem(field.target);
						cbRelationshipToFieldName.__fieldName = field.target;
					}else{
						cbRelationshipFromFieldName.setItem(-1);
						cbRelationshipToFieldName.setItem(-1);
						cbRelationshipToFieldName.__fieldName = undefined;
					}
					cbRelationshipFromFieldName.setEnabled(field !== undefined);
					cbRelationshipToFieldName.setEnabled(field !== undefined);
				}
				relationshipFieldTemplate.onCreate(function(){
					this.setField(relationship_field);
				});
				cbRelationshipFromFieldName.onChange(function(idx,text,item){
					relationship_field.source = text;
					doc.setConfigData(data);
				});

				cbRelationshipToFieldName.onChange(function(idx,text,item){
					relationship_field.target = text;
					doc.setConfigData(data);
				});

				btnRelationshipAddField.onClick(function(){
					var w;
					var pos = 0;
					var newField = {};
					while (relationship.fields[pos]!==relationship_field)pos++;
					pos++;
					relationship.fields.splice(pos,0,newField);
					w = buildRelationshipFieldWnd(newField,pos);
					w.create();
					relationshipFields.addChild(w,pos);
					relationshipFields.layout();
					enable_field_buttons();
					doc.setConfigData(data);
				});
				btnRelationshipRmvField.onClick(function(){
					var pos = 0;
					while (relationship.fields[pos]!==relationship_field)pos++;

					relationship.fields.splice(pos,1);
					field_controls.splice(pos,1);
					relationshipFields.rmvChild(relationshipFieldTemplate);
					relationshipFields.layout();
					enable_field_buttons();
					doc.setConfigData(data);
				});
				field_controls.splice(pos,0,{add:btnRelationshipAddField,rmv:btnRelationshipRmvField,combo:cbRelationshipToFieldName});
				return relationshipFieldTemplate;
			};
			relationshipFields.rmvAll();
			if (relationship){
				loadDatasourceFields(relationship.datasourceName);
				txRelationshipName.setText(relationship.name);
				txRelationshipName.setEnabled(true);
//				cbRelationshipType.setItem(relationship.type);
//				cbRelationshipType.setEnabled(true);
				ckPreventDeletion.setEnabled(true);
				ckPreventDeletion.setChecked(relationship.preventDeletion)
				cbRelationshipDs.setEnabled(true);
				cbRelationshipDs.setItem(relationship.datasourceName);

				jQuery.each(relationship.fields,function(idx,field){
					var w = buildRelationshipFieldWnd(field,idx);
					w.create();
					relationshipFields.addChild(w);
				});

			}else{
				// ponemos una entrada disabled para que no quede vacio el panel
				ckPreventDeletion.setEnabled(false);
				txRelationshipName.setText("");
				txRelationshipName.setEnabled(false);
//				cbRelationshipType.setItem(-1);
//				cbRelationshipType.setEnabled(false);
				cbRelationshipDs.setItem(-1);
				cbRelationshipDs.setEnabled(false);
				var w = buildRelationshipFieldWnd(undefined,0);
				w.create();
				relationshipFields.addChild(w);
			}
			dsDesignerRelationshipsPanel.layout();
			relationshipFields.layout();
			enable_field_buttons();
		}
		jQuery.each(relationships,function(idx,relationship){
			items.push({name:relationship.name,relationship:relationship})
		});

		gdRelationships.items = items;

		ckPreventDeletion.onChange(function(value){
			var it=gdRelationships.getItem();
			it.relationship.preventDeletion = value;
			doc.setConfigData(data);

		});
		gdRelationships.onChange(function(item){
			showRelationship(item.relationship);
			btnRmvRelationship.setEnabled(true);
			var it=gdRelationships.getItem();
		});
		txRelationshipName.onChange(function(value){
			var it=gdRelationships.getItem();
			it.relationship.name = value;
			it.name = value;
			gdRelationships.updateItem(it);
			doc.setConfigData(data);
		});

		btnAddRelationship.onClick(function(){
			var newRelationship = {name:'new relationship',type:'hasmany',preventDeletion:true,fields:[{}]}
			var newItem = {name:newRelationship.name,relationship:newRelationship};
			relationships.push(newRelationship);
			gdRelationships.addItem(newItem);
			gdRelationships.setItem(newItem);
			showRelationship(newItem.relationship);
			doc.setConfigData(data);
			btnRmvRelationship.setEnabled(true);
		});
		btnRmvRelationship.onClick(function(){
			var it = gdRelationships.getItem();
			gdRelationships.rmvItem(it);
			jQuery.each(relationships,function(idx,relationship){
				if(relationship === it.relationship){
					relationships.splice(idx,1);
					return false;
				}
			});
			showRelationship();
			this.setEnabled(false);
			doc.setConfigData(data);
		});

		dsDesignerRelationshipsPanel.onCreate(function(){
			showRelationship();
		});
		return dsDesignerRelationshipsPanel;
	};


	datasourceView.prototype.fieldsPanel = function (doc,data){
		<%VIEW:dsDesignerFieldsPanel%>
		var self = this;
/*		fieldsPanel.properties({
			layoutMode:'horizontal',
			width:undefined,
			height:undefined,
			fillWidth:undefined,
			fillHeight:undefined,
			pr:5,
			pb:3,
			pl:5,
			pt:3
		})
		*/
		dsDesignerFieldsPanel.caption = _T("Fields");
		var fieldSettings = this.fieldSettings(doc,data,undefined);

		fieldSettingsContainer.childs.push(fieldSettings);
		var columns = data.description.columns;
		var grid_rows;
		var build_rows = function(){
			grid_rows = [];
			for (var idx = 0;idx<columns.length;idx++){
				if(!columns[idx].hidden){
					grid_rows.push({
						name:columns[idx].name,
						ptr:columns[idx]
					});
				}
			}
		};
		build_rows();
        fieldList_grid.properties({
            items:grid_rows
        });

		doc.addListener("columns.added",function(){
			fieldList_grid.clearAll();
			build_rows();
			fieldList_grid.addItem(grid_rows);
			self.appDoc.updateAllViews(self,"columns.updated",{datasourceName:doc.getName(),columns:columns});
		});


        fieldList_grid.onBeforeChange(function(item){
			var res = true;
			res = fieldSettings.performValidation();
			return res;

        });
		fieldList_grid.onChange(function(item){
			fieldSettings.setItem(item.ptr);
			fieldList_btnDelete.setEnabled(item.ptr.allowDelete!==false);
			fieldList_txFieldName.setEnabled(item.ptr.allowRename!==false);
			fieldList_txFieldName.setText(item.name);
		});
		fieldList_txFieldName.enabled = false;

//		fieldList_txFieldName.onChange(function(value,valid){
//			fieldList_btnAdd.setEnabled(valid);
//		});
//		fieldList_txFieldName.onEnterKey(function(value,valid){
//			if(valid)
//				fieldList_btnAdd.fireEvent("onClick");
//		});

        fieldList_btnAdd.onClick(function(){
			var found;
			var c=1
			do{
				found = false;
				text = _T("new_field")+c;
				jQuery.each(columns,function(idx,column){
					if(text==column.name){
						found = true;
						c++;
						return false;
					}
				})

			}while(found)

			var column ={type:'string',name:text,validate:{type:'auto'}};
			var nr = {name:text,ptr:column};
			columns.push(column);
			fieldList_grid.addItem(nr);
			fieldList_grid.setItem(nr);
			fieldList_btnDelete.setEnabled(true);
			prev = nr;
			fieldSettings.setItem(nr.ptr);
			doc.setConfigData(data);
			self.appDoc.updateAllViews(self,"columns.updated",{datasource:doc.getName(),columns:columns});
			fieldList_txFieldName.setText(text);
			fieldList_txFieldName.setEnabled(true);
		});
		fieldList_txFieldName.onChange(function(text,valid){
			text = icc.utils.trim(text)
			var isDuplicatedEntry = function(name){
				var res = false;
				jQuery.each(columns,function(idx,col){
					if(col.name == name && fieldList_grid.getItem().ptr !==col){
						res = true;
						return false;
					}
				});
				return res;
			}
			if(text !== '' && icc.utils.isValidVariableName(text)){

				if(!isDuplicatedEntry(text)){
					var it = fieldList_grid.getItem()
					var col = it.ptr
					jQuery.each([data.description.retrieve,data.description.store,data.description.update,data.description['delete']],function(idx,operation){
						jQuery.each(operation.inputParams,function(idx,param){
							if (param.column == col.name )
								param.column = text;
						});
					})
					col.name = text;
					it.name = text;
					fieldList_grid.updateItem(it);


					doc.setConfigData(data);

					self.appDoc.updateAllViews(self,"columns.updated",{datasource:doc.getName(),columns:columns});
				}else{
					fieldList_txFieldName.displayMessage(icc.ui.message('duplicated_entry',{description:_T('Duplicated field name')}),false);
				}
			}else{
				fieldList_txFieldName.displayMessage(icc.ui.message('invalid_fieldname'),false);
			}
		});
        fieldList_btnDelete.onClick(function(){
			var item =fieldList_grid.getItem()
			var index;
            fieldList_grid.rmvItem(item);
			jQuery.each(columns,function(idx,column){
				if (column.name == item.name){
					index = idx;
					return false;
				}
			});

            columns.splice(index,1);
            doc.setConfigData(data);
            fieldList_btnDelete.setEnabled(false);
			fieldList_txFieldName.setText("");
			fieldList_txFieldName.setEnabled(false);
			prev = undefined;
//            fieldList.fireEvent("onChange",undefined);
			self.appDoc.updateAllViews(self,"columns.updated",{datasource:doc.getName(),columns:columns});

        });


		return dsDesignerFieldsPanel;
	}

    datasourceView.prototype.iccNativePanel = function(doc,data){
		var tabPanel;

		/* Crea un objeto con el metodo setConfigData en el cual utilizando la info de columnas
		   updatea store.inputParams,update.InputParams */
		var myDoc ={

			setConfigData:function(configData){
				configData.description.retrieve.inputParams = [];
				configData.description.store.inputParams = [];
				configData.description.update.inputParams = [];

				jQuery.each(configData.description.columns,function(idx,col){
					var ncol = {
						key:col.name == "_id"?true:undefined,
						name:col.name,
						type:col.type,
						allowNull:col.allowNull==undefined?true:col.allowNull,
						column:col.name

					};
					configData.description.retrieve.inputParams.push(ncol);
					configData.description.update.inputParams.push(ncol);
					configData.description.store.inputParams.push(ncol);
				});
				doc.setConfigData(configData);
			},
			addListener:function(){
				doc.addListener.apply(doc,arguments);
			},
			fireEvent:function(){
				doc.fireEvent.apply(doc,arguments);
			},
			getType:function(){
				return doc.getType();
			},
			truncateData:function(cb){
				return doc.truncateData(cb);
			},
			getName:function(){
				return doc.getName();
			}

		}
		var maintenancePanel = this.nativeDsMaintenancePanel(myDoc,data,undefined);
		var relationshipsPanel = this.relationshipsPanel(myDoc,data,undefined);
		var filterPanel = this.filterPanel(myDoc,data,this.appDoc);
		var indexPanel = this.indexPanel(myDoc,data,this.appDoc);
		var fieldsPanel = this.fieldsPanel(myDoc,data);
		tabPanel = new icc.ui.tabpanel({
//			tabStyle:'winDflt',
			childs:[
				fieldsPanel,
				relationshipsPanel,
				filterPanel,
				indexPanel,
				maintenancePanel

			]
		})

		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;

		};
        return tabPanel;
    };

    datasourceView.prototype.iccSummarizerPanel = function(doc,data){
		var tabPanel;
		var self = this;
		/* Crea un objeto con el metodo setConfigData en el cual utilizando la info de columnas
		   updatea store.inputParams,update.InputParams */
		var myDoc ={

			setConfigData:function(configData){
				configData.description.dataType = self.appDoc.catalog["icc-summarizer-dataType"] || self.appDoc.catalog["appClass"];;
				configData.description.retrieve.inputParams = [];
				configData.description.store.inputParams = [];
				configData.description.update.inputParams = [];

				jQuery.each(configData.description.columns,function(idx,col){
					var ncol = {
						key:col.name == "_id"?true:undefined,
						name:col.name,
						type:col.type,
						allowNull:col.allowNull==undefined?true:col.allowNull,
						column:col.name

					};
					configData.description.retrieve.inputParams.push(ncol);
					configData.description.update.inputParams.push(ncol);
					configData.description.store.inputParams.push(ncol);
				});
				jQuery.each(configData.description.store.inputParams,function(idx,col){
					if(col.name == "ID" || col.name == "timeStamp"){
						col.allowNull = false;
					}
				})
				jQuery.each(configData.description.update.inputParams,function(idx,col){
					if(col.name == "ID"){
						col.allowNull = false;
					}
				})
				doc.setConfigData(configData);
			},
			addListener:function(){
				doc.addListener.apply(doc,arguments);
			},
			fireEvent:function(){
				doc.fireEvent.apply(doc,arguments);
			},
			getFields:function(){
				return doc.getFields();
			},
			getType:function(){
				return doc.getType();
			},
			truncateData:function(cb){
				return doc.truncateData(cb);
			},
			getName:function(){
				return doc.getName();
			},
			getDirty:function(){
				return doc.getDirty();
			}

		}
		var fieldsPanel = this.fieldsPanel(myDoc,data);
		fieldsPanel.caption=_T("Fields/Inputs");
		tabPanel = new icc.ui.tabpanel({
			childs:[
				fieldsPanel
			]
		})

		tabPanel.performValidation = function(waserrors){
			return true;

		};
        return tabPanel;
    };



   datasourceView.prototype.iccContactDsPanel = function(doc,data){
		var tabPanel;
		/* Crea un objeto con el metodo setConfigData en el cual utilizando la info de columnas
		   updatea store.inputParams,update.InputParams */
		var fixedFields={
			contactId:true,
			name:true,
			accountOfficer:true,
			externalId:true,
			accountGroup:true,
			category:true,
			campaign:true,
			lastManagementResult:true,
			importation:true,
			phones:true,
			dataitems:true,
			isVIP:true,
			isClient:true
		}

		var myDoc ={

			setConfigData:function(configData){
				configData.description.update.inputParams=[];
				configData.description.store.inputParams=[];
				configData.description.retrieve.inputParams=[];
				jQuery.each(configData.description.columns,function(idx,col){
					var name = col.oldName==undefined?col.name:col.oldName;

					var ncol = {
						name:col.oldName==undefined?fixedFields[col.oldName]?col.oldName:col.name:col.name,
						type:col.type,
						allowNull:(col.name=="contactId"||col.name=="name")?false:true,
						key:(col.name=="contactId")?true:false,
						column:col.name

					};
					configData.description.retrieve.inputParams.push(icc.utils.clone(ncol));
					configData.description.update.inputParams.push(ncol);
					configData.description.store.inputParams.push(ncol);

				});
				// Para retrieve son todos opcionales
				jQuery.each(configData.description.retrieve.inputParams,function(idx,col){
					col.allowNull = true;
					col.key=false
				});
				doc.setConfigData(configData);
			},
			addListener:function(){
				doc.addListener.apply(doc,arguments);
			},
			fireEvent:function(){
				doc.fireEvent.apply(doc,arguments);
			},
			getType:function(){
				return doc.getType();
			},
			getName:function(){
				return doc.getName();
			}

		}
		var relationshipsPanel = this.relationshipsPanel(myDoc,data,undefined);
		var fieldsPanel = this.fieldsPanel(myDoc,data);
		var filterPanel = this.filterPanel(myDoc,data,this.appDoc,false);
		tabPanel = new icc.ui.tabpanel({
			childs:[
				fieldsPanel,
				relationshipsPanel,
				filterPanel
			]
		})

		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;

		};
        return tabPanel;

    };
   datasourceView.prototype.icc6ContactDsPanel = function(doc,data){
		var tabPanel;
		/* Crea un objeto con el metodo setConfigData en el cual utilizando la info de columnas
		   updatea store.inputParams,update.InputParams */
		var fixedFields={
			contactId:true,
			contactName:true,
			companyName:true,
			addresses:true,
			campaigns:true
		}

		var myDoc ={

			setConfigData:function(configData){
				doc.setConfigData(configData);
			},
			addListener:function(){
				doc.addListener.apply(doc,arguments);
			},
			fireEvent:function(){
				doc.fireEvent.apply(doc,arguments);
			},
			getType:function(){
				return doc.getType();
			},
			getName:function(){
				return doc.getName();
			}

		}
		var relationshipsPanel = this.relationshipsPanel(myDoc,data,undefined);
		var fieldsPanel = this.fieldsPanel(myDoc,data);
		var triggerPanel = this.triggerPanel(myDoc,data,this.appDoc,false);
		tabPanel = new icc.ui.tabpanel({
			childs:[
				fieldsPanel,
				relationshipsPanel,
				triggerPanel
			]
		})

		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;

		};
        return tabPanel;

    };

	datasourceView.prototype.iccInteractionGralSettings = function (doc,data){
		<%VIEW:dsInteractionGralSettings%>
		dsInteractionGralSettings.caption = _T("Integration");
		this.map_checkField(ckAutomaticWrapup,doc,data,data.description,"automaticWrapUp");
		return dsInteractionGralSettings;
	};
	datasourceView.prototype.iccInteractionDsPanel = function(doc,data){
		var tabPanel;
		var relationshipsPanel = this.relationshipsPanel(doc,data,undefined);
		var fieldsPanel = this.fieldsPanel(doc,data);
		var iccInteractionGralSettings = this.iccInteractionGralSettings(doc,data);
		tabPanel = new icc.ui.tabpanel({
			childs:[
				fieldsPanel,
				relationshipsPanel,
				iccInteractionGralSettings
			]
		});
		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;

		};
        return tabPanel;

	};

 datasourceView.prototype.iccFlowDsPanel = function(doc,data){
		var tabPanel;
		var relationshipsPanel = this.relationshipsPanel(doc,data,undefined);
		var fieldsPanel = this.fieldsPanel(doc,data);
		var trigerPanel = this.triggerPanel(doc,data);
		var srvOperationsPanel = this.srvOperationsPanel(doc,data);
		tabPanel = new icc.ui.tabpanel({
			childs:[
				fieldsPanel,
				relationshipsPanel,
				trigerPanel,
				srvOperationsPanel
			]
		});
		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;
		};
        return tabPanel;
 };
datasourceView.prototype.iccFlowSecondarysRetrieveSettings = function(doc,data){

		<%FRAME:dsDesignerAssets.flowSecondaryRetrieveSettings%>
		this.map_comboDatasourceNameField(cb_iccFlowSecondaryRetrieveSource,doc,data,data.description.retrieve,'srcName',this.appDoc);
		this.map_textField(tx_iccFlowSecondaryRetrieveXPathRow,doc,data,data.description.retrieve,"XPathRow");
		return flowSecondaryRetrieveSettings;
}
datasourceView.prototype.iccFlowSecondaryRetrievePanel = function(doc,data){
//		this.map_comboDatasourceNameField(cb_iccFlowSecondaryRetrieveSource,doc,data,data.description.retrieve,'srcName',this.appDoc);
//		this.map_textField(tx_iccFlowSecondaryRetrieveXPathRow,doc,data,data.description.retrieve,"XPathRow");
		var tabPanel;
		var relationshipsPanel = this.relationshipsPanel(doc,data,undefined);
		var fieldsPanel = this.fieldsPanel(doc,data);
		var trigerPanel = this.triggerPanel(doc,data);
		var srvOperationsPanel = this.srvOperationsPanel(doc,data);
		tabPanel = new icc.ui.tabpanel({
			fillWidth:true,
			fillHeight:true,
			width:undefined,
			height:undefined,
			childs:[
				fieldsPanel,
				relationshipsPanel,
				trigerPanel,
				srvOperationsPanel
			]
		});
		tabPanel.performValidation = function(waserrors){
			var res=true;
			return 	res;
		};
        return tabPanel;


    };


	datasourceView.prototype.updateDocumentState = function(datasourceDoc,dirty){
		var self = this;
		if(!dirty){
			self.appDoc.updateAllViews(self,"datasource.saved",datasourceDoc.getName());
		}
	};




    datasourceView.prototype.create = function (){
        var self = this;
        var wnd;
        var doc = this.getDocument();
        var data = doc.getConfigData();
		data.description.relationships = data.description.relationships?data.description.relationships:[];
		self.pl=10;
		self.pb=0;
		self.pr=0;
		self.pt=10;
        datasourceView.SUPERclass.create.call(this);
        switch(this.getDocument().getType()){
            case "mssql":
                wnd = self.mssqlPanel(doc,data);
            break;
			case "icc-native":
				wnd = self.iccNativePanel(doc,data);
			break;
			case "icc-summarizer":
				wnd = self.iccSummarizerPanel(doc,data);
			break;
			case "icc_contact_ds":
				wnd = self.iccContactDsPanel(doc,data);
			break
			case "icc6_contact_ds":
				wnd = self.icc6ContactDsPanel(doc,data);
			break

			case "icc_interaction_ds":
				wnd = self.iccInteractionDsPanel(doc,data);
			break
			case "icc_flow_ws":
				wnd = self.iccFlowDsPanel(doc,data);

			break;
			case "icc_flow_ws_inner_ds":
				wnd = self.iccFlowSecondaryRetrievePanel(doc,data);
			break;
        }
        if (wnd){
			wnd.properties({
				width:undefined,
				height:undefined,
				x:undefined,
				y:undefined,
				fillWidth:true,
				fillHeight:true
			});
            wnd.create();
            self.addChild(wnd);
            self.layout();
        }
		this.performValidation = function(){
			return wnd.performValidation(true);
		}
    };
    icc.ui.designer.datasourceView = datasourceView;
})(__icc__);


/*jslint evil:true */
/*global jQuery  __icc__ _T
*/
/*
OUTBOUNDBATCH
OUTBOUNDPROCESS
VIRTUALCC
AGENTID
*/
(function(icc){

    var  datasourceWizard;
    datasourceWizard = function(appDoc, args) {

		args.backColor='#f9f9f9';
		args.caption = _T("New Datasource");
		args.name = _T('designer_datasource_wizard_dlg');
		this.data = {
		    'private':{},
		    description:{
				indexes:[
				],
				filters:[
				],
				columns:[
				],
				retrieve:{
				    inputParams:[]
				},
				store:{
				    inputParams:[]
				},
				update:{
				    inputParams:[]
				},
				'delete':{
				    inputParams:[]
				}
		    }
		};
		this.appDoc = appDoc;
		const self = this;
		this.mssql_builtin_config = {};
		icc.ui.designer.dsintrospection.mssql_builtin_config(icc.ui.getApplication().getVCCName(), function(success, builtin_config) {
			if(success){
				self.mssql_builtin_config = builtin_config || {};
			}
		});
	    datasourceWizard.SUPERconstructor.call(this,args);
		this.setStartPage(this.pageTechnologySelection);

	};
	icc.utils.inherit(datasourceWizard, icc.ui.wizardDialog);
	
	var m_lastSql = {};
	
    datasourceWizard.prototype.pageSQLServer = function(){
		var self = this;
		self.setNext(undefined);
		<%FRAME:datasourceWizard.pageSQLServer%>
		
		var defaultPorts = {
			sqlserver	: 1433,
			mysql		: 3306,
		};
		
		const getDatabaseName = function (sqlDbmsId) {
			if (sqlDbmsId === "builtin") {
				return (sqlcboDatabase.getItem() && sqlcboDatabase.getItem().id) || ""
			}

			return sqlDatabase.getText() || "";
		};

		const change_visibility= function(flag) {
			sqlServerPort.setReadOnly(flag);
			sqlPassword.setReadOnly(flag);
			sqlServerAddress.setReadOnly(flag);
			sqlUserName.setReadOnly(flag);
	};

	const fnChangeBbms = function (sqlDbmsId) {
		if (sqlDbmsId === "builtin") {
			
			sqlDatabase.setVisible(false);
			sqlcboDatabase.setVisible(true);
			sqlcboDatabase.setRequired(true);
			sqlDatabase.setRequired(false);
			sqlServerPort.setText("");
			sqlPassword.setText("");
			sqlServerAddress.setText("");
			sqlUserName.setText("");
			sqlServerPort.setRequired(false);
			sqlServerAddress.setRequired(false);
			sqlUserName.setRequired(false);
			change_visibility(true);
		}
		else{
			
			sqlcboDatabase.setVisible(false);
			sqlDatabase.setVisible(true);
			sqlcboDatabase.setRequired(false);
			sqlDatabase.setRequired(true);
			sqlServerPort.setRequired(true);
			sqlServerAddress.setRequired(true);
			sqlUserName.setRequired(true);
			change_visibility(false);
		}
	};

		var updateData = function(bSave) {
		    if(bSave || bSave === undefined){
				const dbmsId = sqlDbms.getItem().id;
				self.data['private'].dbms = icc.utils.trim(sqlDbms.getItem().id);
				self.data['private'].serverAddress = icc.utils.trim(sqlServerAddress.getText());
				self.data['private'].port = icc.utils.trim(sqlServerPort.getText());
				self.data['private'].userName = icc.utils.trim(sqlUserName.getText());
				self.data['private'].userPassword = icc.utils.trim(sqlPassword.getText());
				self.data['private'].databaseName = icc.utils.trim(getDatabaseName(dbmsId));
				if( (self.data['private'].serverAddress==='' ||
				    self.data['private'].userName==='' ||
				    self.data['private'].databaseName==='') && dbmsId !== "builtin")
				{
				    self.setNext(undefined);
				}else{
				    self.setNext(self.pageSQLServerObjectSelection);
				}
				m_lastSql = self.data['private'];
		    }else {
				var currentSql = self.data['private'];
				if ($.isEmptyObject(currentSql)) {
					currentSql = m_lastSql;
				}
				sqlDbms.setItem(currentSql.dbms || "sqlserver");
				sqlServerAddress.setText(currentSql.serverAddress);
				sqlServerPort.setText(currentSql.port || 
					defaultPorts[currentSql.dbms || "sqlserver"]);
				sqlUserName.setText(currentSql.userName);
				sqlPassword.setText(currentSql.userPassword);
				fnChangeBbms(currentSql.dbms || "sqlserver");
				updateData(true);
		    }
		};

		
		sqlDbms.clearAll();
		sqlDbms.addItem({id: "sqlserver", text: "SQL Server"});
		sqlDbms.addItem({id: "mysql"    , text: "MySQL"     });
		sqlDbms.addItem({id: "builtin"    , text: "Built In"     });

		sqlcboDatabase.properties({
			items: self.mssql_builtin_config.Databases || {},
		});

		sqlDbms.onChange(function() {
			const sqlDbmsId = sqlDbms.getItem().id;
			fnChangeBbms(sqlDbmsId);
			sqlServerPort.setText(defaultPorts[sqlDbmsId] || "");
			updateData(true);
		});
		sqlServerAddress.onChange(function(){updateData(true)});
		sqlUserName.onChange(function(){updateData(true)});
		sqlPassword.onChange(function(){updateData(true)});
			
		sqlDatabase.onChange(function(){
			
		sqlcboDatabase.setItem(getDatabaseName(sqlDbms.getItem().id));
		updateData(true)
		});
		sqlcboDatabase.onChange(function () {

		sqlDatabase.setText(getDatabaseName(sqlDbms.getItem().id));
		updateData(true)
		});
		pageSQLServer.onCreate(function () {
			self.data = {
				'private': {
					__keep: true
				},
				type: "mssql",
				description:{
					indexes:[
					],
					filters:[
					],
					columns:[
					],
					retrieve:{
						inputParams:[]
					},
					store:{
						inputParams:[]
					},
					update:{
						inputParams:[]
					},
					'delete':{
						inputParams:[]
					}
				}
			}
			updateData(false);
		});
		return pageSQLServer;
	};
	
	datasourceWizard.prototype.pageDatasourceName = function(){
		var self = this;
		<%FRAME:datasourceWizard.pageDatasourceName%>
		txDatasourceName.text = self.data.name
		txDatasourceName.onChange(function(value){
			
			if(icc.utils.isValidFilename(value) && icc.utils.isValidVariableName(value)){
				self.data.name = icc.utils.trim(value);
			}else{
				self.data.name = ''
				if(icc.utils.trim(value)!==''){
					txDatasourceName.displayMessage(icc.ui.message('invalid_filename',{description:_T('Invalid datasource name')}));
				}
			}
			self.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		});
		this.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		return pageDatasourceName;
    };
	datasourceWizard.prototype.pageSQLServerProcedureBindingType=function(){
		var self=this;
		<%FRAME:datasourceWizard.pageSQLServerProcedureBindingType%>
		
		opt_retrieve.checked=this.bindingType ==="retrieve";
		opt_store.checked=this.bindingType ==="store";
		opt_inup.checked = this.bindingType ==="inup";
		
		
		var generateStructure = function(){
			var hash_columns={};
			self.data.description.columns = [];
			self.data.description.retrieve.inputParams = [];
			self.data.description.store.inputParams = [];
			self.data.description.update.inputParams = [];
			self.data.description['delete'].inputParams = [];
			
			self.data.description.retrieve.enabled=false;
			self.data.description.retrieve.type=undefined;
			self.data.description.retrieve.spName=undefined;

			self.data.description.store.enabled=false;
			self.data.description.store.type=undefined;
			self.data.description.store.tableName=undefined;
			self.data.description.store.spName=undefined;
			
			self.data.description.update.enabled=false;
			self.data.description.update.type=undefined;
			self.data.description.update.tableName=undefined;
			self.data.description.update.spName=undefined;
			
			self.data.description['delete'].enabled=false;
			self.data.description['delete'].type=undefined;
			self.data.description['delete'].tableName=undefined;
			self.data.description['delete'].spName=undefined;
		
			// toma tanto los parametros como las columnas y hace
			
			// y rellena la estructura colums
			
			jQuery.each([self.param_list,self.column_list],function(idx,list){
				jQuery.each(list,function(idx,column){
					if(!hash_columns[column.name]){	// evitamos nombres duplicados en parametros con igual nombre que las columnas
						self.data.description.columns.push({name:column.name,type:column.type,allowNull:column.allowNull,maxLength:column.maxLength,validate:{type:'auto'}});
						hash_columns[column.name]=true;
					}
				});
			});
			
		};
		var generateBindingForRetrieve = function(){
			generateStructure();
			self.data.description.retrieve.enabled = true;
			self.data.description.retrieve.type = "msqlproc";
			self.data.description.retrieve.spName = self.serverObject;
			jQuery.each(self.param_list,function(idx,column){
				self.data.description.retrieve.inputParams.push({name:column.name,type:column.type,column:column.name,allowNull:column.allowNull});
			});
		};
		
		var generateBindingForStore = function(){
			generateStructure();
			self.data.description.store.enabled = true;
			self.data.description.store.type = "msqlproc";
			self.data.description.store.spName = self.serverObject;
			jQuery.each(self.param_list,function(idx,column){
				self.data.description.store.inputParams.push({name:column.name,type:column.type,column:column.name,allowNull:column.allowNull});
			});
		};
		
		var generateBindingForInUp = function(){
			generateBindingForStore();
			self.data.description.update.enabled = true;
			self.data.description.update.type = "msqlproc";
			self.data.description.update.spName = self.serverObject;
			jQuery.each(self.param_list,function(idx,column){
				self.data.description.update.inputParams.push({name:column.name,type:column.type,column:column.name,allowNull:column.allowNull});
			});		
		};
		
		var updateNextPage = function(){
		    switch(self.bindingType){
				case "retrieve":
					generateBindingForRetrieve();
					self.setNext(self.pageDatasourceName);
				break;
				case "store":
					generateBindingForStore();
					self.setNext(self.pageDatasourceName);
				break;
				case "inup":
					generateBindingForInUp();
					self.setNext(self.pageDatasourceName);
				break;
				default:
					self.setNext(undefined);
		    }
		};
		opt_retrieve.onChange(function(value){
			if(value){
			   self.bindingType = "retrieve";
			   updateNextPage();
			}
		});
		
		opt_store.onChange(function(value){
			if(value){
			   self.bindingType = "store";
			   updateNextPage();
			}
		});

		opt_inup.onChange(function(value){
			if(value){
				self.bindingType = "inup";
				updateNextPage();
			}
		});
		pageSQLServerProcedureBindingType.onCreate(function(){
		    updateNextPage();
		});
		
		return pageSQLServerProcedureBindingType;
	};
	datasourceWizard.prototype.pageSQLServerProcedure=function(){
		var self = this;
		self.setNext(undefined);
		<%FRAME:datasourceWizard.pageSQLServerProcedure%>
//		var btnDetect = new icc.ui.button({caption:_T('Detect output'),sideRight:true,sideBottom:true});
		self.param_list=[];
		self.column_list=[];
/*		
		var sqlproc_grid_params = new icc.ui.grid({
			
			fillWidth:true,
			height:120,
			columns: [
				{caption:_T('Name'),width:210,field:'name'},
				{caption:_T('Type'),width:60,field:'type'},
				{caption:_T('Misc info'),width:80,field:'info'}
			]
		});
		var sqlproc_grid_columns = new icc.ui.grid({
			
			fillWidth:true,
			fillHeight:true,
			columns: [
				{caption:_T('Name'),width:290,field:'name'},
				{caption:_T('Type'),width:60,field:'type'}
			]
		});
		

		var wnd = new icc.ui.panel({
		    vs : 3,
			fillWidth:true,
			fillHeight:true,
		    childs : [
				new icc.ui.label({caption : _T('Stored procedure parameters')}),
				grid_params,
				new icc.ui.label({caption : _T('Returned columns')}),
				btnDetect,
				grid_columns
		    ]
		});
*/
		btnDetect.onClick(function(){
			icc.ui.designer.dsintrospection.mssql_proc_columns(self.data['private'],self.serverObject,
				function(status,result){
					// aca rellena la grilla de columnas
					if(status){
						jQuery.each(result,function(idx,column){
							var t = column.typeName;
							switch(t){
								case 'int':
									t='integer';
									break;
								case 'nchar':
								case 'nvarchar':
									column.maxLength/=2;
									t = 'string'
								break;
								case 'text':
									column.maxLength=undefined;
									t = 'string';
								break;	
								case 'char':
								case 'varchar':
									t='string';
								break;
								case 'adDBTimeStamp':
									t='datetime'
								break;
								case 'bit':
									t="boolean";
								break;
							}
							self.column_list.push({
								__id:column.ColumnName,
								text:column.ColumnName,
								name:column.ColumnName,
								type:t,
								dbType:column.typeName
							});
							sqlproc_grid_columns.clearAll();
							sqlproc_grid_columns.addItem(self.column_list);
						});
					}else{
						if(result.code!==1019){
							icc.ui.msgbox(result.description,undefined,"error");
						}else{
							icc.ui.displayMessage(result);
						}
					}
				}
			);
		});
		pageSQLServerProcedure.onCreate(function(){
			// rellena la grilla de parametros
			icc.ui.designer.dsintrospection.mssql_proc_params(self.data['private'],self.serverObject,
				function(status,result){
					if(status){
						self.setNext(self.pageSQLServerProcedureBindingType);

						jQuery.each(result,function(idx,param){
							var t = param.typeName;
							var tmpItem;
							var info = [];
							if (param.HasDefaultValue)
								info.push("default")
							switch(t){
								case 'int':
									t='integer';
								break;
								case 'nchar':
								case 'nvarchar':
									param.maxLength /= 2;
									t='string';
								break;
								case 'char':
								case 'varchar':
									t='string';
								break;
								case 'ntext':
								case 'text':
									param.maxLength = undefined;
									t='string';
								break;
								case 'adDBTimeStamp':
									t='datetime'
								break;
								
								case 'bit':
									t="boolean";
								break;
							}
							self.param_list.push({
								__id:param.ParamName,
								text:param.ParamName,
								name:param.ParamName,
								type:t,
								info:info.join(","),
								maxLength:param.maxLength,
								allowNull:param.HasDefaultValue,
								dbType:param.typeName
							});
							
						});
						
						sqlproc_grid_params.clearAll();
						sqlproc_grid_params.addItem(self.param_list);
					}else{
						if(result.code !==1019){
							icc.ui.msgbox(result.description,undefined,"error");
						}else{
							icc.ui.displayMessage(result);
						}
					}
				}
			);
		});
		return pageSQLServerProcedure;
	};
	datasourceWizard.prototype.pageSQLServerObjectSelection=function(){
		var self = this;
		<%FRAME:datasourceWizard.pageSQLServerObjectSelection%>
		var generateTableBindings = function (tableName,cb){
			self.data.description.columns = [];
			self.data.description.retrieve.inputParams = [];
			self.data.description.store.inputParams = [];
			self.data.description.update.inputParams = [];
			self.data.description['delete'].inputParams = [];
			
			self.data.description.retrieve.enabled=true;
			self.data.description.retrieve.type="msqltable";
			self.data.description.retrieve.tableName=tableName;
			
			
			
			self.data.description.store.enabled=true;
			self.data.description.store.type="msqltable";
			self.data.description.store.tableName=tableName;
			
			self.data.description.update.enabled=true;
			self.data.description.update.type="msqltable";
			self.data.description.update.tableName=tableName;
			
			self.data.description['delete'].enabled=true;
			self.data.description['delete'].type="msqltable";
			self.data.description['delete'].tableName=tableName;
			
			
			
			icc.ui.designer.dsintrospection.mssql_table_columns(self.data['private'],tableName,function(status,result){
				if(status){
					jQuery.each(result,
						function(idx,column){
								var t = column.typeName;
								var tmpItem;
								var iskey,identity;
								var info = [];
								var newCol = {};
								if ($.isArray(column.MiscInfo)) {
									info.push(column.MiscInfo);
									if(column.MiscInfo.indexOf('identity')){
										identity=true;
									}
								}
								if (column.PK_Position){
									info.push("primary key");
									iskey = true;
								}
									
								switch(t){
									case 'int':
										t='integer';
									break;
									case 'nchar':
									case 'nvarchar':
										t='string';
										column.maxLength/=2;
									break;
									case 'char':
									case 'varchar':
										t='string';
									break;
									case 'text':
										t='string';
										column.maxLength=undefined;
									break;
									case 'adDBTimeStamp':
										t='datetime'
									break;
									
									case 'bit':
										t='boolean'
									break;
								}
								
								self.data.description.columns.push({
									name:column.ColumnName,
									type:t,
									maxLength:column.maxLength,
									validate:{type:"auto"},
									dbType:column.typeName
									
								});
								self.data.description.retrieve.inputParams.push({
									name:column.ColumnName,
									key:iskey,
									identity:identity,
									type:t,
									allowNull:true,
									column:column.ColumnName
								});
								self.data.description.update.inputParams.push({
									name:column.ColumnName,
									key:iskey,
									identity:identity,
									type:t,
									allowNull:column.Nullable === 'NULL',
									column:column.ColumnName
								});
								self.data.description.store.inputParams.push({
									name:column.ColumnName,
									key:iskey,
									identity:identity,
									type:t,
									allowNull:column.Nullable === 'NULL',
									column:column.ColumnName
								});
								self.data.description['delete'].inputParams.push({
									name:column.ColumnName,
									key:iskey,
									identity:identity,
									type:t,
									allowNull:column.Nullable === 'NULL',
									column:iskey?column.ColumnName:undefined
								});
							
						}
					);
					if(cb){
						cb(true,result);
					}
				}else {
					if(cb){
						cb(false,result);
					}
				}
			});
		};
		var updateNextPage = function(cb){
			self.setNext(undefined);
			icc.ui.designer.dsintrospection.mssql_list(self.data['private'],function(status,result){
				if(status){
						
						var items = [];
						jQuery.each(result,
							function(idx,objectData){
								var txt;
								var item = {};
								if(objectData.objectType === "USER_TABLE" ){
									item.text = "(table)&nbsp;" + objectData.objectName;
								}else{
									item.text = "(proc)&nbsp;&nbsp;" + objectData.objectName;
								}
								
								item.__id = objectData.objectName;
								item.objectType = objectData.objectType;
								items.push(item);
							}
						);
						serverObjectsGrid.clearAll();
						serverObjectsGrid.addItem(items);
						serverObjectsGrid.setItem(self.serverObject);		
						if(cb){
							cb(true);
						}
						
				}else{
					if(cb){
						cb(false,result);
					}
				}
		    });
			
		};
		serverObjectsGrid.onChange(function(item){
			if (item){
				self.serverObject = item.__id;
				self.serverObjectType = item.objectType;
				if(item.objectType === 'USER_TABLE'){
					generateTableBindings(item.__id,function(status,result){
						if(status){
							self.setNext(self.pageDatasourceName);
						}else{
							self.setNext(undefined);
							if(result.code !== 1019){
								icc.ui.msgbox(result.description,undefined,"error")
							}else{
								icc.ui.displayMessage(result);
							}							
						}
					});
					
					
				}else{
				
					self.setNext(self.pageSQLServerProcedure);
				}						
				
			}else{
				self.setNext(undefined);
			}
		});
		
		pageSQLServerObjectSelection.onCreate(function(){
			updateNextPage(function(status,result){
				var item;
				if(status){
					item = serverObjectsGrid.getItem();
					if(item){
						if(item.objectType === 'USER_TABLE'){
						
							self.setNext(self.pageDatasourceName);
							
						}else{
						
							self.setNext(self.pageSQLServerProcedure);
						
						}						
					}
				}else{
					if(result.code !== 1019){
						icc.ui.msgbox(result.description,undefined,'error');
					}else{
						icc.ui.displayMessage(result);
					}
				}
			});
		});
		return pageSQLServerObjectSelection;
	};
	datasourceWizard.prototype.pageDialerContact = function(){
		var self = this;
		<%FRAME:datasourceWizard.pageDialerContact%>
		txtDialerContactDsName.onChange(function(value){
			
			if(icc.utils.isValidFilename(value) && icc.utils.isValidVariableName(value)){
				self.data.name = icc.utils.trim(value);
			}else{
				self.data.name = ''
				if(icc.utils.trim(value)!==''){
					icc.ui.displayMessage(icc.ui.message('invalid_filename',{description:_T('Invalid datasource name')}));
				}
			}
			self.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		});
		
		pageDialerContact.onCreate(function(){
			self.data={
				'private':{
					__keep:true

				},
				type: "icc_contact_ds",
				description:{

					type:'icc_contact_ds',
					filters:[
					],
					indexes:[
					],
					columns:[
						{name:'contactId',type:'string'},
						{name:'name',type:'string'},
						{name:'campaign',type:'string'},
						{name:'accountOfficer',type:'string'},
						{name:'externalId',type:'string'},
						{name:'accountGroup',type:'string'},
						{name:'category',type:'string'},
						{name:'isVIP',type:'boolean'},
						{name:'isClient',type:'boolean'},
						{name:'lastManagementResult',type:'string'},
						{name:'importation',type:'string'},
						{name:'Home',type:'phone',phoneIndex:'1',phoneType:'HOME',phoneSelector:'phoneType=HOME,Index=1'},
						{name:'Mobile',type:'phone',phoneIndex:'1',phoneType:'CELLULAR',phoneSelector:'phoneType=CELLULAR,Index=1'},
						{name:'Fax',type:'phone',phoneIndex:'1',phoneType:'FAX',phoneSelector:'phoneType=FAX,Index=1'},
						{name:'Office',type:'phone',phoneIndex:'1',phoneType:'OFFICE',phoneSelector:'phoneType=OFFICE,Index=1'},
						{name:'phones',type:'phonelist',hidden:true},
						{name:'dataitems',type:'dataitems',hidden:true},
						{name:'skills',type:'skilllist',hidden:true}
					],
					retrieve:{
						type:'icc_contact_ds',
						enabled:true,
						inputParams:[
							{name:'contactId',type:'string',allowNull:true,column:'contactId'},
							{name:'name',column:'name',type:'string',allowNull:true},
							{name:'campaign',column:'campaign',type:'string',allowNull:true},

							{name:'accountOfficer',column:'accountOfficer',type:'string',allowNull:true},
							{name:'externalId',column:'externalId',type:'string',allowNull:true},
							{name:'accountGroup',column:'accountGroup',type:'string',allowNull:true},
							{name:'category',column:'category',type:'string',allowNull:true},
							{name:'isVIP',column:'isVIP',type:'boolean',allowNull:true},
							{name:'isClient',column:'isClient',type:'boolean',allowNull:true},
							{name:'lastManagementResult',column:'lastManagementResult',type:'string',allowNull:true},
							{name:'importation',column:'importation',type:'string',allowNull:true},
							{name:'Home',type:'phone',allowNull:true,column:'Home'},
							{name:'Mobile',type:'phone',allowNull:true,column:'Mobile'},
							{name:'Fax',type:'phone',allowNull:true,column:'Fax'},
							{name:'Office',type:'phone',allowNull:true,column:'Office'}
						]
					},
					store:{
						type:'icc_contact_ds',
						enabled:true,
						inputParams:[

							{name:'contactId',column:'contactId',type:'string',key:true,allowNull:false},
							{name:'name',column:'name',type:'string',allowNull:false},
							{name:'campaign',column:'campaign',type:'string',allowNull:true},

							{name:'accountOfficer',column:'accountOfficer',type:'string',allowNull:true},
							{name:'externalId',column:'externalId',type:'string',allowNull:true},
							{name:'accountGroup',column:'accountGroup',type:'string',allowNull:true},
							{name:'category',column:'category',type:'string',allowNull:true},
							{name:'isVIP',column:'isVIP',type:'boolean',allowNull:true},
							{name:'isClient',column:'isClient',type:'boolean',allowNull:true},
							{name:'lastManagementResult',column:'lastManagementResult',type:'string',allowNull:true},
							{name:'importation',column:'importation',type:'string',allowNull:true},

							{name:'phones',column:'phones',type:'phonelist',allowNull:true},
							{name:'dataitems',column:'dataitems',type:'dataitems',allowNull:true},
							{name:'skills',column:'skills',type:'skilllist',allowNull:true},

							{name:'Home',type:'phone',allowNull:true,column:'Home'},
							{name:'Mobile',type:'phone',allowNull:true,column:'Mobile'},
							{name:'Fax',type:'phone',allowNull:true,column:'Fax'},
							{name:'Office',type:'phone',allowNull:true,column:'Office'}
						]
					},
					update:{
						type:'icc_contact_ds',
						enabled:true,
						inputParams:[

							{name:'contactId',column:'contactId',type:'string',key:true},
							{name:'name',column:'name',type:'string',allowNull:false},
							{name:'campaign',column:'campaign',type:'string',allowNull:true},
							{name:'accountOfficer',column:'accountOfficer',type:'string',allowNull:true},
							{name:'externalId',column:'externalId',type:'string',allowNull:true},
							{name:'accountGroup',column:'accountGroup',type:'string',allowNull:true},
							{name:'category',column:'category',type:'string',allowNull:true},
							{name:'isVIP',column:'isVIP',type:'boolean',allowNull:true},
							{name:'isClient',column:'isClient',type:'boolean',allowNull:true},
							{name:'lastManagementResult',column:'lastManagementResult',type:'string',allowNull:true},
							{name:'importation',column:'importation',type:'string',allowNull:true},
							{name:'phones',column:'phones',type:'phonelist',allowNull:true},
							{name:'dataitems',column:'dataitems',type:'dataitems',allowNull:true},
							{name:'skills',column:'skills',type:'skilllist',allowNull:true},
							{name:'Home',type:'phone',allowNull:true,column:'Home'},
							{name:'Mobile',type:'phone',allowNull:true,column:'Mobile'},
							{name:'Fax',type:'phone',allowNull:true,column:'Fax'},
							{name:'Office',type:'phone',allowNull:true,column:'Office'}


						]
					},
					'delete':{
						type:'icc_contact_ds',
						enabled:false,
						inputParams:[
							{name:'contactId',column:'contactId',type:'string',key:true}
						]
					}
				}
			};
			self.setNext(undefined,true,false);

		});
		return pageDialerContact;
	};
	datasourceWizard.prototype.pageInconcertContact = function(){
		var self = this;
		<%FRAME:datasourceWizard.pageInconcertContact%>
		txtContactDsName.onChange(function(value){
			
			if(icc.utils.isValidFilename(value) && icc.utils.isValidVariableName(value)){
				self.data.name = icc.utils.trim(value);
			}else{
				self.data.name = ''
				if(icc.utils.trim(value)!==''){
					icc.ui.displayMessage(icc.ui.message('invalid_filename',{description:_T('Invalid datasource name')}));
				}
			}
			self.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		});
		
		pageInconcertContact.onCreate(function(){
			self.data={
				'private':{
					__keep:true

				},
				type: "icc6_contact_ds",
				description:{

					type:'icc6_contact_ds',
					filters:[
					],
					indexes:[
					],
					columns:[
						{name:'contactId',type:'string', 
							'default':'= icc.ui.getApplication().getNewContactId()'},
						{name:'name',type:'string'},
						{name:'externalId',type:'string'},
						{name:'company',type:'string'},
						{name:'creationDate',type:'datetime',readOnly:true},
						{name:'lastUpdate',type:'datetime',readOnly:true},
						{name:'Home',type:'phone',phoneIndex:'1',phoneType:'HOME',phoneSelector:'phoneType=HOME,Index=1'},
						{name:'Mobile',type:'phone',phoneIndex:'1',phoneType:'CELLULAR',phoneSelector:'phoneType=CELLULAR,Index=1'},
						{name:'Fax',type:'phone',phoneIndex:'1',phoneType:'FAX',phoneSelector:'phoneType=FAX,Index=1'},
						{name:'Office',type:'phone',phoneIndex:'1',phoneType:'OFFICE',phoneSelector:'phoneType=OFFICE,Index=1'},
						{name:'Mail',type:'mail'},
						{name:'Twitter',type:'twitter'},
						{name:'addresses',type:'addresseslist',hidden:true}
					],
					retrieve:{
						type:'icc6_contact_ds',
						enabled:true,
						inputParams:[
							{name:'contactId',type:'string',allowNull:true,column:'contactId'},
							{name:'name',column:'name',type:'string',allowNull:true},
							{name:'company',column:'company',type:'string',allowNull:true},
							{name:'externalId',column:'externalId',type:'string',allowNull:true},
							{name:'Home',type:'phone',allowNull:true,column:'Home'},
							{name:'Mobile',type:'phone',allowNull:true,column:'Mobile'},
							{name:'Fax',type:'phone',allowNull:true,column:'Fax'},
							{name:'Office',type:'phone',allowNull:true,column:'Office'},
							{name:'Mail',column:'Mail',type:'mail',allowNull:true},
							{name:'Twitter',column:'Twitter',type:'twitter',allowNull:true}
						]
					},
					store:{
						type:'icc6_contact_ds',
						enabled:true,
						inputParams:[
							{name:'contactId',column:'contactId',type:'string',key:true,allowNull:false,
								'default':'= icc.ui.getApplication().getNewContactId()'},
							{name:'name',column:'name',type:'string',allowNull:false},
							{name:'company',column:'company',type:'string',allowNull:true},
							{name:'externalId',column:'externalId',type:'string',allowNull:true},
							{name:'Home',type:'phone',allowNull:true,column:'Home'},
							{name:'Mobile',type:'phone',allowNull:true,column:'Mobile'},
							{name:'Fax',type:'phone',allowNull:true,column:'Fax'},
							{name:'Office',type:'phone',allowNull:true,column:'Office'},
							{name:'Mail',column:'Mail',type:'mail',allowNull:true},
							{name:'Twitter',column:'Twitter',type:'twitter',allowNull:true},
							{name:'addresses',column:'addresses',type:'addresseslist',allowNull:true},
						]
					},
					update:{
						type:'icc6_contact_ds',
						enabled:true,
						inputParams:[
							{name:'contactId',column:'contactId',type:'string',key:true},
							{name:'name',column:'name',type:'string',allowNull:false},
							{name:'company',column:'company',type:'string',allowNull:true},
							{name:'externalId',column:'externalId',type:'string',allowNull:true},
							{name:'Home',type:'phone',allowNull:true,column:'Home'},
							{name:'Mobile',type:'phone',allowNull:true,column:'Mobile'},
							{name:'Fax',type:'phone',allowNull:true,column:'Fax'},
							{name:'Office',type:'phone',allowNull:true,column:'Office'},
							{name:'Mail',column:'Mail',type:'mail',allowNull:true},
							{name:'Twitter',column:'Twitter',type:'twitter',allowNull:true},
							{name:'addresses',column:'addresses',type:'addresseslist',allowNull:true},
						]
					},
					'delete':{
						type:'icc6_contact_ds',
						enabled:true,
						inputParams:[
							{name:'contactId',column:'contactId',type:'string',key:true}
						]
					}
				}
			};			
			
			self.setNext(undefined,true,false);

		});
		return pageInconcertContact;
	};
	datasourceWizard.prototype.setupInconcertSummarizer = function(){
		var self = this;
		self.data = {
			"description": {
				"columns": [
					{
						"alwaysEnabled": true,
						"name": "ID",
						"required": true,
						"type": "string",
						"hidden":true,
						"default":"=args.interaction_id || args.INTERACTIONID"
					},
					{
						"alwaysEnabled": true,
						"default": "=now(true,true)",
						"name": "timeStamp",
						"hidden":true,
						"required": true,
						"type": "datetime"
					},
					{
						"alwaysEnabled": true,
						"name": "DateFrom",
						"type": "date",
						"hidden":true
					},
					{
						"alwaysEnabled": true,
						"name": "DateTo",
						"type": "date",
						"hidden":true
					},
					{
						"alwaysEnabled": true,
						"name":"_HasLogin",
						"type":"boolean",
						"hidden":true
					},
					{
						"alwaysEnabled": true,
						"name":"_HasPreSurvey",
						"type":"boolean",
						"hidden":true
					},
					
					{
						"alwaysEnabled": true,
						"name":"_HasPostSurvey",
						"type":"boolean",
						"hidden":true
					},
					{
						"alwaysEnabled": true,
						"name":"_survey_data",
						"hidden":true
					}
					
				],
				"delete": {
					"enabled": false,
					"inputParams": [],
					"type": "icc_summarizer_ds"
				},
				"filters": [],
				"indexes": [],
				"outstreams": [],
				"relationships": [],
				"retrieve": {
					"enabled": true,
					"inputParams": [
						{
							"allowNull": false,
							"column": "ID",
							"name": "ID",
							"type": "string"
						}
					],
					"type": "icc_summarizer_ds"
				},
				"store": {
					"enabled": true,
					"inputParams": [
						{
							"allowNull": false,
							"column": "ID",
							"name": "ID",
							"type": "string"
						},
						{
							"allowNull": false,
							"column": "timeStamp",
							"name": "timeStamp",
							"type": "datetime"
						},
						{
							"allowNull":true,
							"column":"_survey_data",
							"name":"_survey_data",
							"type":"string"
						}
						
					],
					"type": "icc_summarizer_ds"
				},
				"tableName": "survey1_1370291366",
				"update": {
					"enabled": true,
					"inputParams": [
						{
							"allowNull": false,
							"column": "ID",
							"name": "ID",
							"type": "string"
						},
						{
							"allowNull": true,
							"column": "timeStamp",
							"name": "timeStamp",
							"type": "datetime"
						},
						{
							"allowNull":true,
							"column":"_survey_data",
							"name":"_survey_data",
							"type":"string"
						}
						
					],
					"type": "icc_summarizer_ds"
				}
			},
			"private": [],
			"type": "icc-summarizer",
			"version": 23
		}		
		self.data.description.dataType = self.appDoc.catalog["icc-summarizer-dataType"] || self.appDoc.catalog["appClass"];
		self.setNext(self.pageDatasourceName);
		return ;//pageInconcertInteraction;		
	};
	datasourceWizard.prototype.setupInconcertInteraction = function(){
		var self = this;
		self.data={
			'private':{
				__keep:true
			},
			type: "icc_interaction_ds",
			description:{
				type:'icc_interaction_ds',
				classname:'interaction',
				automaticWrapUp:true,
				filters:[
				],
				indexes:[
				],
				columns:[
					//basic info
					{name:'Id',type:'string',readOnly:true},
					{name:'VirtualCC',type:'string',readOnly:true},
					{name:'Campaign',type:'string',readOnly:true},
					{name:'Account',type:'string',readOnly:true},
					{name:'AttentionLevel',type:'string',readOnly:true},
					{name:'Type',type:'string',readOnly:true},
					{name:'WorkitemType',type:'string',readOnly:true},
					{name:'Initiative',type:'string',readOnly:true},
					{name:'Sections',type:'integer',readOnly:true},
					{name:'Agent',type:'string',readOnly:true},
					{name:'State',type:'string',readOnly:true},
					{name:'Subtype',type:'string',readOnly:true},
					{name:'PostId',type:'string',readOnly:true},
					{name:'ProcessFlow',type:'string',readOnly:true},
					//dates
					{name:'CreationDate',type:'datetime',readOnly:true},
					{name:'StartDate',type:'datetime',readOnly:true},
					{name:'EndDate',type:'datetime',readOnly:true},
					{name:'LastUpdate',type:'datetime',readOnly:true},
					//contact
					{
						"name": "Contact",
						"alwaysEnabled": true,
						"enabledCondIsExpr": false,
						"readOnly": false,
						"required": false,
						"type": "string"
					},
					{name:'ContactAddress',type:'string',readOnly:true},
					{name:'ContactName',type:'string',readOnly:false},
					//Transfer
					{name:'Transfer',type:'string',readOnly:true},
					{name:'TransferrerCampaign',type:'string',readOnly:true},
					{name:'TransferredCampaign',type:'string',readOnly:true},
					{name:'TransferrerAgent',type:'string',readOnly:true},
					{name:'TransferredAgent',type:'string',readOnly:true},
					{name:'TransferrerAttLevel',type:'string',readOnly:true},
					{name:'TransferredAttLevel',type:'string',readOnly:true},
					//Call specific
					{name:'Dnis',type:'string',readOnly:true},
					{name:'CallerId',type:'string',readOnly:true},
					{name:'CalledId',type:'string',readOnly:true},
					{name:'IsAppointment',type:'boolean'},
					{name:'processId',type:'string',readOnly:true},
					{name:'batchId',type:'string',readOnly:true},
					{
						"name": "DialerContact",
						"alwaysEnabled": true,
						"enabledCondIsExpr": false,
						"readOnly": false,
						"required": false,
						"requiredCondExpresion": "schedule || ContactCode!=null",
						"requiredCondIsExpr": true,
						"requiredCondition": true,
						"type": "string"
					},
					//Facebook specific
					{name:'FacebookPageId',type:'string',readOnly:true},
					//Management result
					{name:'ManagementResult',type:'string',readOnly:true},
					{name:'ContactCode',type:'string'},
					{name:'ResultCode',type:'string'},
					{name:'ResultCodeDescription',type:'string'},
					{name:'ResultTreePath',type:'string'},
					{name:'ResultComment',type:'string'},
					//Reschedule
					{name:'RescheduledToPhone',type:'string'},
					{name:'RescheduledToPhoneType',type:'string',
						"required": false,
						"requiredCondExpresion": "RescheduledToPhone != undefined",
						"requiredCondIsExpr": true,
						"requiredCondition": true
					},
					{name:'RescheduledToDate',type:'date',

						"required": false,
						"requiredCondExpresion": "schedule == true",
						"requiredCondIsExpr": true,
						"requiredCondition": true

					},
					{name:'RescheduledToTime',type:'time',
						"required": false,
						"requiredCondExpresion": "schedule == true",
						"requiredCondIsExpr": true,
						"requiredCondition": true
					},
					{name:'RescheduledToAgent',type:'string'},
					{name:'RescheduledToCampaign',type:'string'},
					{name:'RescheduledAgentIsSame',type:'boolean'},
					{name:'schedule',type:'boolean'}
				],
				retrieve:{
					type:'icc6_interaction_ds',
					enabled:true,
					inputParams:[
						{name:'Id',type:'string',allowNull:false,column:'Id','default':'=params.INTERACTIONID'}
					]
				},
				store:{
					type:'icc6_interaction_ds',
					enabled:false,
					inputParams:[
					]
				},
				update:{
					type:'icc6_interaction_ds',
					enabled:true,
					inputParams:[
						{name:'Id',type:'string',allowNull:false,column:'Id'},
						{name:'Campaign',type:'string',allowNull:false,column:'Campaign'},
						{name:'Type',type:'string',allowNull:false,column:'Type'},
						{name:'processId',type:'string',allowNull:true,column:'processId'},
						{name:'batchId',type:'string',allowNull:true,column:'batchId',
							validate:{
								type:'expresion',
								expresion:"schedule == (RescheduledToDate!==undefined && RescheduledToTime!==undefined)"
							}
						},
						{name:'Agent',type:'string',allowNull:true,column:'Agent'},
						{name:'ResultCode',type:'string',allowNull:false,column:'ResultCode'},
						{name:'ResultCodeDescription',type:'string',allowNull:false,column:'ResultCodeDescription'},
						{name:'ResultTreePath',type:'string',allowNull:false,column:'ResultTreePath'},
						{name:'ResultComment',type:'string',allowNull:true,column:'ResultComment'},
						{name:'ContactCode',type:'string',allowNull:true,column:'ContactCode'},
						{name:'Contact',type:'string',allowNull:true,column:'Contact'},
						{name:'ContactName',allowNull:true,type:'string',column:'ContactName'},
						{name:'ContactAddress',type:'string',allowNull:true,column:'ContactAddress'},
						{name:'CallerId',type:'string',allowNull:true,column:'CallerId'},
						{name:'DialerContact',type:'string',allowNull:true,column:'DialerContact'},
						{name:'RescheduledToPhone',type:'string',allowNull:true,column:'RescheduledToPhone'},
						{name:'RescheduledToType',type:'string',allowNull:true,column:'RescheduledToPhoneType'},
						{name:'RescheduledToDate',type:'datetime',allowNull:true,column:'RescheduledToDate'},
						{name:'RescheduledToTime',type:'time',allowNull:true,column:'RescheduledToTime'},
						// con este campo validamos que si el disposition code tienen un ContactCode
						// exista processId y batchId
						{name:'dialer',type:'boolean',value:false,allowNull:true,
							validationMessage:_T('Missing dialer data, please set another code'),
							validate:{
								type:'expresion',
								expresion:'!(ContactCode !== undefined && batchId===undefined) && !(ContactCode !== undefined && processId===undefined)'
							}
						},
						{name:'schedule',type:'boolean',allowNull:false,column:'schedule',
							validate:{
								type:'expresion',
								expresion:"schedule == (RescheduledToDate!==undefined && RescheduledToTime!==undefined)"
							}
						},
						{name:'RescheduledToAgent',type:'string',allowNull:true,column:'RescheduledToAgent'},
						{name:'RescheduledToCampaign',type:'string',allowNull:true,column:'RescheduledToCampaign'},
						{name:'RescheduledAgentIsSame',type:'boolean',allowNull:true,column:'RescheduledAgentIsSame'}
					]
				},
				'delete':{
					type:'icc6_interaction_ds',
					enabled:false,
					inputParams:[
					]
				}
			}
		};
			
		self.setNext(self.pageDatasourceName);
		return ;//pageInconcertInteraction;
	};
	
	
	datasourceWizard.prototype.pageICCNativeStorageFields = function(){
		var self = this;
		this.setNext(undefined);
		<%FRAME:datasourceWizard.pageICCNativeStorageFields%>
		cbColumnType.items = [
			{id:'integer',	text:'integer'},
			{id:'numeric',	text:'numeric'},
			{id:'string',	text:'string'},
			{id:'datetime', text:'datetime'},
			{id:'date', text:'date'},
			{id:'boolean', text:'boolean'}
		];

		
		var updateNextPage = function(){
			self.setNext((
				self.data.description.columns.length >0 			
			)?self.pageDatasourceName:undefined);
		};		
		var updateData = function(){
			self.data.description.columns = [];
			self.data.type = "icc-native";
			
			self.data.description.retrieve.enabled=true;
			self.data.description.retrieve.type="icc_mongodb_ds";
			
			
			
			self.data.description.update.enabled = true;
			self.data.description.update.type="icc_mongodb_ds";
			
			
			
			
			self.data.description.store.enabled = true;
			self.data.description.store.type="icc_mongodb_ds";

			
			self.data.description['delete'].enabled = true;
			self.data.description['delete'].type="icc_mongodb_ds";
			
			self.data.description['retrieve'].inputParams = [
				{
					type: "string",
					name: "_id",
					allowNull:true,
					column:"_id"
				}

			];


			self.data.description['delete'].inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					identity: true,
					column:"_id"
				}
			];

			self.data.description.store.inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					identity:true,
					column:"_id"
				}
 			];
		
			self.data.description.update.inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					identity:true,
					column:"_id"
				}
            
			];
			self.data.description.columns.push(
			{
					key:true,
					type:"string",
					name:"_id",
					hidden:true
			})
			jQuery.each(self.icc_columns,function(idx,col){
				self.data.description.columns.push(col);
				self.data.description.retrieve.inputParams.push(col);
				
				self.data.description.update.inputParams.push(col);
				self.data.description.store.inputParams.push(col);
				
			});
			
		};
		var loadData = function(){
			if (self.icc_columns === undefined){
				self.icc_columns = [];
			}
			updateData();
			self.data.description.columns = [];
			jQuery.each(self.icc_columns,function(idx,column){
				self.data.description.update.inputParams.push(column);
				self.data.description.store.inputParams.push(column);
				self.data.description.columns.push(column);
				gdColumns.addItem({name:column.name,type:column.type,column:column});
			});
			
		}

		gdColumns.onChange(function(item){
			txColumnName.setText(item.name);
			cbColumnType.setItem(item.type);
			fieldList_btnRmv.setEnabled(true);
			fieldList_btnAdd.setEnabled(true);
			
		});
		fieldList_btnAdd.onClick(function(){
			if(!gdColumns.getItem()){
				var col = {column:txColumnName.getText(),name:txColumnName.getText(),type:cbColumnType.getItem().id,allowNull:true};
				self.icc_columns.push(col);
				gdColumns.addItem({name:col.name,type:col.type,column:col});
				updateData();
			}
			txColumnName.setText("");
			cbColumnType.setItem(-1);
			fieldList_btnRmv.setEnabled(false);
			fieldList_btnAdd.setEnabled(false);
			gdColumns.setItem({});
			updateNextPage();
		});
		fieldList_btnRmv.onClick(function(){
			var it = gdColumns.getItem();
			if(it){
				jQuery.each(self.icc_columns,function(idx,column){
					if(it.column === column){
						self.icc_columns.splice(idx,1);
						return false;
					}
				});
				gdColumns.rmvItem(it);
				fieldList_btnRmv.setEnabled(false);
				fieldList_btnAdd.setEnabled(false);
				txColumnName.setText("");
				cbColumnType.setItem(-1);
				
			}
			updateData();
			updateNextPage();
			
		});
		
		cbColumnType.onChange(function(idx,text,item){
			var it = gdColumns.getItem();
			
			if(icc.utils.trim(txColumnName.getText()) !== ''){
				fieldList_btnRmv.setEnabled(true);
				fieldList_btnAdd.setEnabled(true);
				if(it){
					it.type = item.id;
					it.column.type = item.id;
					gdColumns.updateItem(it);
				
				}
				
			}else{
				fieldList_btnRmv.setEnabled(false);
				fieldList_btnAdd.setEnabled(false);			
			
			}
		});
		txColumnName.onChange(function(value){
			var it = gdColumns.getItem();
			var v = icc.utils.trim(value);
			if(v!=='' && cbColumnType.getItem()){
				fieldList_btnRmv.setEnabled(true);
				fieldList_btnAdd.setEnabled(true);
				if(it){
					it.name = value;
					it.column.name = value;
					it.column.column = value;
					gdColumns.updateItem(it);
				}
			}else{
				fieldList_btnRmv.setEnabled(false);
				fieldList_btnAdd.setEnabled(false);			
			}
		});
		pageICCNativeStorageFields.onCreate(function(){
			loadData();
			updateNextPage();
		});
		return pageICCNativeStorageFields;
	};
	datasourceWizard.prototype.pageCSVImportProcess=function(){
		<%FRAME:dataImportExportAssets.pageCSVImportProcessNewDS%>
		var self = this;
		txCSVImportNameNewDS.text = self.data.name;
		
		txCSVImportNameNewDS.onChange(function(value){
			
			if(icc.utils.isValidFilename(value) && icc.utils.isValidVariableName(value)){
				var err = self.appDoc.checkDatasourceName(value)
				if(err.code == 0){
					self.data.name = icc.utils.trim(value);
					var tmstamp = Math.round(+new Date()/1000);
					self.data.tableName = self.data.name+"_"+tmstamp;
					self.data.description.tableName = self.data.tableName;
				}else{
					self.data.name='';
					txCSVImportName.displayMessage(err);
				}
			}else{
				self.data.name = ''
				if(icc.utils.trim(value)!==''){
					txCSVImportNameNewDS.displayMessage(icc.ui.message('invalid_filename',{description:_T('Invalid datasource name')}));
				}
				
			}
			btnCSVStartProcessNewDS.setEnabled(self.data.name !== '' && self.data.name !== undefined);
		});
		btnCSVStartProcessNewDS.enabled = self.data.name !== '' && self.data.name !== undefined;
		
		this.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		btnCSVStartProcessNewDS.onClick(function(){
			var msgs={}
			txCSVProcessLogNewDS.setText("");
			btnCSVStartProcessNewDS.setEnabled(false);
			icc.ui.designer.csvutils.beginImportProcess(self.csvData.fileid,self.csvData.delimiter,self.csvData.firstRowHaveColumnNames,
				self.csvData.duplicatedBehavior,
				self.data.tableName,
				true,
				self.csvData.columns,
				function(status,result){	// aca voy recibiendo los datos para el progress
					if(status){
						pgCSVProcessNewDS.setValue(result.processCompletion);
											// llevo un hash con los mensajes mostrados, entonces
											//puedo detectar uno nuevo
						if(result.messages && result.messages.length){
							txCSVProcessLogNewDS.setText(txCSVProcessLogNewDS.getText()+"\n"+result.messages.join("\n"));
						}					// fin del proceso , todo se importo ok prendo el boton finish
						if(result.isCompleted){
							pgCSVProcessNewDS.setValue(100);
							self.CSVimport=true;
							self.setNext(undefined,true,true);
							btnCSVStartProcessNewDS.setEnabled(true);
						}
					}else{
						icc.ui.displayMessage(result);
						btnCSVStartProcessNewDS.setEnabled(true);
					}					
				}
			)
		});
		var updateData = function(){
			self.data.description.columns = [
				{
					type: "string",
					name: "_id",
					identity: true,
					hidden:true
					
				}
		
			];
			self.data.type = "icc-native";
			
			self.data.description.retrieve.enabled=true;
			self.data.description.retrieve.type="icc_mongodb_ds";
			
			
			
			self.data.description.update.enabled = true;
			self.data.description.update.type="icc_mongodb_ds";
			
			
			
			
			self.data.description.store.enabled = true;
			self.data.description.store.type="icc_mongodb_ds";

			
			self.data.description['delete'].enabled = true;
			self.data.description['delete'].type="icc_mongodb_ds";
			
			self.data.description['retrieve'].inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					identity: true,
					column:"_id",
					allowNull:true
					
				}

			];


			self.data.description['delete'].inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					identity: true,
					column:"_id"
				}
			];

			self.data.description.store.inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					column:"_id",
					identity:true
				}
 			];
		
			self.data.description.update.inputParams = [
				{
					key: true,
					type: "string",
					name: "_id",
					column:"_id",
					identity:true
				}
            
			];
			
			jQuery.each(self.csvData.columns,function(idx,col){
				var c = {name:col.alias,column:col.alias,allowNull:true,type:col.type};
				self.data.description.columns.push(c);
				self.data.description.retrieve.inputParams.push(c);
				
				self.data.description.update.inputParams.push(c);
				self.data.description.store.inputParams.push(c);
				
			});
			
		};
		
		pageCSVImportProcessNewDS.onCreate(function(){
			updateData();
			self.setNext(undefined,true,false);
		});
		return pageCSVImportProcessNewDS;

	};
	datasourceWizard.prototype.pageCSVImportPreview = function(){
		<%FRAME:dataImportExportAssets.pageCSVImportPreview%>
		var self = this;		
		
		
		pageCSVImportPreview.onCreate(function(){
			self.setNext(undefined);
			icc.ui.designer.csvutils.getRows(self.csvData.fileid,self.csvData.delimiter,self.csvData.firstRowHaveColumnNames,
				self.csvData.duplicatedBehavior,
				50,
				self.csvData.columns,
				function(status,result){
					if(status){
						var cols = []
						
						jQuery(result.colnames).each(function(idx,name){
							var l;
							switch(result.coltypes[idx]){
								case 'integer':l = 80;break;
								case 'string':l = 140;break;
								
								case 'date':l = 140;break;
								case 'datetime':l=100;break;
								case 'numeric':l=90;break;
								default:l=80;break;
								
							}
							cols.push({caption:name,type:result.coltypes[idx],width:l,field:idx})
						});
						var grid = new icc.ui.grid({
							fillWidth:true,
							fillHeight:true,
							columns:cols
						});
						grid.create();
						grid.addItem(result.rows);
						cntCSVImportPreview.addChild(grid);
						cntCSVImportPreview.layout();
						self.setNext(self.pageCSVImportProcess);
						
					}else{
						icc.ui.displayMessage(result);
					}
				}
			)
		});
		return pageCSVImportPreview;

	};
	datasourceWizard.prototype.pageCSVImportFieldMappings = function(){
		<%FRAME:dataImportExportAssets.pageCSVImportFieldMappingsNewDS%>
		var self = this;	
		var datatypes =[
				{text:'string'},
				{text:'integer'},
				{text:'numeric'},
				{text:'date',
					formats:[
						{text:'dd/mm/yyyy'},
						{text:'mm/dd/yyyy'},
						{text:'yyyymmdd'},
						{text:'yyyy-mm-dd'}
					]
				},
				{text:'datetime',
					formats:[
						{text:'dd/mm/yyyy hh:mm:ss.mmm'},
						{text:'mm/dd/yyyy hh:mm:ss.mmm'},
						{text:'yyyymmddhhmmssmmm'},
						{text:'yyyy-mm-dd hh:mm:ss.mmm'}
					]
				
				},
				{text:'boolean'}
		]
		cbCSVDataTypeNewDS.items = datatypes;
		pageCSVImportFieldMappingsNewDS.onCreate(function(){
			icc.ui.designer.csvutils.retrieveCSVColumns(self.csvData.fileid,self.csvData.delimiter,self.csvData.firstRowHaveColumnNames,
				function(status,result){
				
					if(status){
						self.csvData.columns = result;
						self.setNext(self.pageCSVImportPreview);
						gdCSVFieldMapNewDS.addItem(result);
					}else{
						icc.ui.displayMessage(result);
					}
				}
			);
			self.setNext(undefined);
		});
		gdCSVFieldMapNewDS.onChange(function(item){
			ckCSVFieldEnabledNewDS.setEnabled(item!== undefined);
			ckCSVFieldEnabledNewDS.setChecked(item!== undefined && item.enabled !==false);
			txCSVFieldNameNewDS.setEnabled(item !== undefined && item.enabled !==false)
			cbCSVDataTypeNewDS.setEnabled(item !== undefined && item.enabled !==false);
			ckCSVCheckThisFieldNewDS.setEnabled(item !== undefined && item.enabled !==false);
			txCSVFieldNameNewDS.setText(item.alias);
			cbCSVDataTypeNewDS.setItem(item.type);
			ckCSVCheckThisFieldNewDS.setChecked(item.key);
			var it = cbCSVDataTypeNewDS.getItem();
			if (it && it.formats){
				cbCSVFormatNewDS.setEnabled(true && item.enabled !==false);
				cbCSVFormatNewDS.clearAll();
				cbCSVFormatNewDS.addItem(it.formats);
				cbCSVFormatNewDS.setItem(item.format);
			}else{
				cbCSVFormatNewDS.setEnabled(false);
				cbCSVFormatNewDS.setItem(-1);
				
			}
			
		});
		ckCSVFieldEnabledNewDS.onChange(function(value){
			gdCSVFieldMapNewDS.getItem().enabled = value;
			gdCSVFieldMapNewDS.fireEvent("onChange",gdCSVFieldMapNewDS.getItem());
		});
		
		txCSVFieldNameNewDS.onChange(function(value){
			gdCSVFieldMapNewDS.getItem().alias = value;
			gdCSVFieldMapNewDS.updateItem(gdCSVFieldMapNewDS.getItem());
		});
		cbCSVDataTypeNewDS.onChange(function(idx,text,item){
			gdCSVFieldMapNewDS.getItem().type = text;
			cbCSVFormatNewDS.setEnabled(item.formats !==undefined);
			if(item.formats){
				cbCSVFormatNewDS.clearAll();
				cbCSVFormatNewDS.addItem(item.formats);
			}else{
				cbCSVFormatNewDS.setItem(-1);
			}
		});
		cbCSVFormatNewDS.onChange(function(idx,text,item){
			gdCSVFieldMapNewDS.getItem().format = text;
		});
		
		ckCSVCheckThisFieldNewDS.onChange(function(value){
			gdCSVFieldMapNewDS.getItem().key = value;
		});
		optCSVKeepCurrentNewDS.onChange(function(value){
			self.csvData.duplicatedBehavior = "keep";
			
		});
		optCSVOverwriteNewDS.onChange(function(value){
			self.csvData.duplicatedBehavior = "overwrite";
		});
		return pageCSVImportFieldMappingsNewDS;
	
	}
	datasourceWizard.prototype.pageCSVImportConfig = function(){
		<%FRAME:dataImportExportAssets.pageCSVImportConfig%>
		var self = this;		
		if(self.csvData.delimiter == undefined)
			self.csvData.delimiter = ',';
			
		optCSVCommaDelimiter.checked = self.csvData.delimiter == ",";	
		optCSVTabDelimiter.checked = self.csvData.delimiter == "\t";
		optCSVSemicolonDelimiter.checked = self.csvData.delimiter == ";";
		optCSVCustomDelimiter.checked =  self.csvData.delimiter !== ';' && self.csvData.delimiter !== '\t'  && self.csvData.delimiter !== ',';
		txCustomDelimiter.enabled =	optCSVCustomDelimiter.checked;
		txCustomDelimiter.text = self.csvData.delimiter;
		pgCSVFile.caption = self.csvData.csvFilename;
		pgCSVFile.value =self.csvData.csvFilename!==undefined?100:0;

		optCSVCommaDelimiter.onChange(function(){
			self.csvData.delimiter=','
			txCustomDelimiter.setEnabled(false);
			
		});
		
		optCSVTabDelimiter.onChange(function(){
			self.csvData.delimiter='\t';
			txCustomDelimiter.setEnabled(false);
			
		});
		optCSVSemicolonDelimiter.onChange(function(){
			self.csvData.delimiter=';'
			txCustomDelimiter.setEnabled(false);
			
		});

		optCSVCustomDelimiter.onChange(function(){
			
			txCustomDelimiter.setEnabled(true);
			
		});	
		txCustomDelimiter.onChange(function(value){
			self.csvData.delimiter = value;
		});
		ckFirstRowNames.onChange(function(value){
			self.csvData.firstRowHaveColumnNames = value;
		});
		
		uplCSVFile.onProgress(function(filename,value){
		  pgCSVFile.setValue(value);
		});
		uplCSVFile.onChange(function(fname){
			self.csvData.csvFilename = fname;
			pgCSVFile.setCaption(fname);
			self.setNext(undefined);
		});
		uplCSVFile.onComplete(function(fname,id){
			self.csvData.fileid=id;
			self.setNext(self.pageCSVImportFieldMappings);
			
		});
		
		pageCSVImportConfig.onCreate(function(){
			txCustomDelimiter.setEnabled(optCSVCustomDelimiter.getChecked());
			self.setNext(self.csvData.fileid ===undefined ?undefined:self.pageCSVImportFieldMappings);
		});
		
		return pageCSVImportConfig;
	};
	datasourceWizard.prototype.pageICFlowParameters = function(){
		<%FRAME:datasourceWizard.pageICFlowParameters%>
		var self = this;

		icc_flow_params_txOperationId.text = self.tempData.idOperativa;
		icc_flow_params_gdParams.items = self.tempData.params;
		self.setNext(undefined);
		icc_flow_params_cbColumnType.items = [
			{id:'integer',	text:'integer'},
			{id:'numeric',	text:'numeric'},
			{id:'string',	text:'string'},
			{id:'datetime', text:'datetime'},
			{id:'date', text:'date'},
			{id:'boolean', text:'boolean'}
		];

		
		var updateNextPage = function(){
/*			self.setNext((
				self.data.description.columns.length >0 			
			)?self.pageDatasourceName:undefined);
*/			self.setNext(self.tempData.idOperativa && self.tempData.idOperativa != ''?self.pageICFlowColumns:undefined);
		};		
		var loadData = function(){
			
			updateNextPage();
		}

		icc_flow_params_gdParams.onChange(function(item){
			icc_flow_params_txColumnName.setText(item.name);
			icc_flow_params_cbColumnType.setItem(item.type);
			icc_flow_params_fieldList_btnRmv.setEnabled(true);
			icc_flow_params_fieldList_btnAdd.setEnabled(true);
			
		});
		icc_flow_params_fieldList_btnAdd.onClick(function(){
			if(!icc_flow_params_gdParams.getItem()){
				var col = {column:icc_flow_params_txColumnName.getText(),name:icc_flow_params_txColumnName.getText(),type:icc_flow_params_cbColumnType.getItem().id,allowNull:true};
				self.tempData.params.push(col);
				icc_flow_params_gdParams.addItem({name:col.name,type:col.type,column:col});
			}
			icc_flow_params_txColumnName.setText("");
			icc_flow_params_cbColumnType.setItem(-1);
			icc_flow_params_fieldList_btnRmv.setEnabled(false);
			icc_flow_params_fieldList_btnAdd.setEnabled(false);
			icc_flow_params_gdParams.setItem({});
			updateNextPage();
		});
		icc_flow_params_fieldList_btnRmv.onClick(function(){
			var it = icc_flow_params_gdParams.getItem();
			if(it){
				jQuery.each(self.tempData.params,function(idx,column){
					if(it.column === column){
						self.tempData.params.splice(idx,1);
						return false;
					}
				});
				icc_flow_params_gdParams.rmvItem(it);
				icc_flow_params_fieldList_btnRmv.setEnabled(false);
				fieldList_btnAdd.setEnabled(false);
				icc_flow_params_txColumnName.setText("");
				icc_flow_params_cbColumnType.setItem(-1);
				
			}
			updateNextPage();
			
		});
		
		icc_flow_params_cbColumnType.onChange(function(idx,text,item){
			var it = icc_flow_params_gdParams.getItem();
			
			if(icc.utils.trim(icc_flow_params_txColumnName.getText()) !== ''){
				icc_flow_params_fieldList_btnRmv.setEnabled(true);
				icc_flow_params_fieldList_btnAdd.setEnabled(true);
				if(it){
					it.type = item.id;
					it.column.type = item.id;
					icc_flow_params_gdParams.updateItem(it);
				
				}
				
			}else{
				icc_flow_params_fieldList_btnRmv.setEnabled(false);
				icc_flow_params_fieldList_btnAdd.setEnabled(false);			
			
			}
		});
		icc_flow_params_txColumnName.onChange(function(value){
			var it = icc_flow_params_gdParams.getItem();
			var v = icc.utils.trim(value);
			if(v!=='' && icc_flow_params_cbColumnType.getItem()){
				icc_flow_params_fieldList_btnRmv.setEnabled(true);
				icc_flow_params_fieldList_btnAdd.setEnabled(true);
				it.name = value;
				it.column.name = value;
				it.column.column = value;
				icc_flow_params_gdParams.updateItem(it);
			}else{
				icc_flow_params_fieldList_btnRmv.setEnabled(false);
				icc_flow_params_fieldList_btnAdd.setEnabled(false);			
			}
		});
		icc_flow_params_txOperationId.onChange(function(value){
			self.tempData.idOperativa = icc.utils.trim(value);
			updateNextPage();
		});
		pageICFlowParameters.onCreate(function(){
			loadData();
			updateNextPage();
		});
		
		
		return pageICFlowParameters;
	};
	datasourceWizard.prototype.pageSecondaryRetrieve = function(){
		var self = this;
		self.setNext(undefined);
		<%FRAME:datasourceWizard.pageSecondaryRetrieve%>
		var updateNextPage = function(){
			if(	txSecondaryXPath.isValid() && 
				cbSecondarySource.isValid()){
				
					self.data = {
						type:"icc_flow_ws_inner_ds",
						description:{
							filters:[],
							columns:[
								{name:'rowid',type:'integer'}
							],
							retrieve:{
								type: "ws_inner_ds",
								srcName:self.tempData.srcName,
								XPathRow:self.tempData.XPathRow,
								enabled:true,
								inputParams:[
									{name:'rowid',type:'integer',column:'rowid',allowNull:false}
								]
							},
							store:{
								type: "ws_inner_ds",
								enabled:false,
								inputParams:[]
							},
							update:{
								type: "ws_inner_ds",
								enabled:false,
								inputParams:[]
							},
							"delete":{
								type: "ws_inner_ds",
								enabled:false,
								inputParams:[]
							}
						}
						
					}
					jQuery.each(grSecondaryColumns.getItems(),function(idx,item){
						self.data.description.columns.push({
							name:item.name,
							type:item.type
						});
					});
					
					self.setNext(self.pageDatasourceName);
			}
			
				
		};
		cbSecondaryColumnType.items = [
			{id:'integer',	text:'integer'},
			{id:'numeric',	text:'numeric'},
			{id:'string',	text:'string'},
			{id:'datetime', text:'datetime'},
			{id:'date', text:'date'},
			{id:'boolean', text:'boolean'}
		];
		grSecondaryColumns.items = self.tempData.columns;
		txSecondaryXPath.text = self.tempData.XPathRow;
		txSecondaryXPath.onChange(function(value,valid){
			self.tempData.XPathRow = icc.utils.trim(value);
			updateNextPage();
		});
		
		var dslist = self.appDoc.getDatasources();
		var items = []
		jQuery(dslist).each(function(idx,dsEntry){
			items.push({id: dsEntry.name, text: dsEntry.name});
		});	
		cbSecondarySource.items=items;
		cbSecondarySource.item = self.tempData.srcName
		cbSecondarySource.onChange(function(idx,text,item){
			self.tempData.srcName = text;
			updateNextPage();
		});
		grSecondaryColumns.onChange(function(item){
			txSecondaryColumnName.setText(item.name);
			cbSecondaryColumnType.setItem(item.type);
			btnSecondaryRmvCol.setEnabled(true);
			btnSecondaryAddCol.setEnabled(true);
			
		});
		txSecondaryColumnName.onChange(function(value){
			var it = grSecondaryColumns.getItem();
			var v = icc.utils.trim(value);
			if(v!=='' && cbSecondaryColumnType.getItem()){
				btnSecondaryRmvCol.setEnabled(true);
				btnSecondaryAddCol.setEnabled(true);
				it.name = value;
				it.column.name = value;
				it.column.column = value;
				grSecondaryColumns.updateItem(it);
			}else{
				btnSecondaryRmvCol.setEnabled(false);
				btnSecondaryAddCol.setEnabled(false);			
			}
			updateNextPage();
		});
		cbSecondaryColumnType.onChange(function(idx,text,item){
			var it = grSecondaryColumns.getItem();
			
			if(icc.utils.trim(txSecondaryColumnName.getText()) !== ''){
				btnSecondaryRmvCol.setEnabled(true);
				btnSecondaryAddCol.setEnabled(true);
				if(it){
					it.type = item.id;
					it.column.type = item.id;
					grSecondaryColumns.updateItem(it);
				
				}
				
			}else{
				btnSecondaryRmvCol.setEnabled(false);
				btnSecondaryAddCol.setEnabled(false);			
			
			}
			updateNextPage();
			
		});
		btnSecondaryAddCol.onClick(function(){
			if(!grSecondaryColumns.getItem()){
				var col = {column:txSecondaryColumnName.getText(),name:txSecondaryColumnName.getText(),type:cbSecondaryColumnType.getItem().id,allowNull:true};
				self.tempData.columns.push(col);
				grSecondaryColumns.addItem({name:col.name,type:col.type,column:col});
			}
			txSecondaryColumnName.setText("");
			cbSecondaryColumnType.setItem(-1);
			btnSecondaryRmvCol.setEnabled(false);
			btnSecondaryAddCol.setEnabled(false);
			grSecondaryColumns.setItem({});
			updateNextPage();
		
		});
		btnSecondaryRmvCol.onClick(function(){
			var it = grSecondaryColumns.getItem();
			if(it){
				jQuery.each(self.tempData.columns,function(idx,column){
					if(it.column === column){
						self.tempData.columns.splice(idx,1);
						return false;
					}
				});
				grSecondaryColumns.rmvItem(it);
				btnSecondaryRmvCol.setEnabled(false);
				btnSecondaryAddCol.setEnabled(false);
				txSecondaryColumnName.setText("");
				cbSecondaryColumnType.setItem(-1);
			}
			updateNextPage();
		});
		
		pageSecondaryRetrieve.onCreate(function(){
			updateNextPage();
		});
		
		return pageSecondaryRetrieve;
	};
	datasourceWizard.prototype.pageIccFlowSourceData = function(){
		var self = this;
		if (self.tempData == undefined ){
			self.tempData = {
				params:[],
				columns:[]
			}
		};
			
		<%FRAME:datasourceWizard.pageIccFlowSourceData%>
		opt_iccFlowCall.checked = self.tempData.sourceDataMode == "flowcall";
		opt_iccFlowSecondary.checked = self.tempData.sourceDataMode == "secondary";
		
		opt_iccFlowCall.onChange(function(value){
			if(value){
				self.tempData.sourceDataMode = "flowcall";
				self.setNext(self.pageICFlowParameters);
			}
		});
		
		opt_iccFlowSecondary.onChange(function(value){
			if(value){
				self.tempData.sourceDataMode = "secondary";
				self.setNext(self.pageSecondaryRetrieve);
			
			}
		
		});
		pageIccFlowSourceData.onCreate(function(){
			switch(self.tempData.sourceDataMode){
				case "flowcall":
					self.setNext(self.pageICFlowParameters);
				break;
				case "secondary":
					self.setNext(self.pageSecondaryRetrieve);
				break;
			}
		});
		
		
		return pageIccFlowSourceData;
	}
	
	datasourceWizard.prototype.pageIccFlowBind = function(){
		var self = this;
		<%FRAME:datasourceWizard.pageIccFlowBind%>
		var fullColumns = icc.utils.clone(self.tempData.columns)
		var columnsHash = {}
		jQuery.each(fullColumns,function(idx,col){
			columnsHash[col.name] = col;
		});
		jQuery.each(self.tempData.params,function(idx,col){
			col.column = col.name
			if (columnsHash[col.name] == undefined){
				columnsHash[col.name] = col;
				fullColumns.push(col)
			}
		});
		opt_icc_flow_bind_retrieve.Checked = self.tempData.bindingType == "retrieve"
		opt_icc_flow_bind_store.Checked = self.tempData.bindingType == "store"
		opt_icc_flow_bind_inup.Checked = self.tempData.bindingType == "inup"
		var resetData = function(){
		
			self.data = {
				type:"icc_flow_ws",
				description:{
					filters:[],
					columns:fullColumns,
					retrieve:{
						type: "icc_flow_ws",
						enabled:false,
						inputParams:[]
					},
					store:{
						type: "icc_flow_ws",
						enabled:false,
						inputParams:[]
					},
					update:{
						type: "icc_flow_ws",
						enabled:false,
						inputParams:[]
					},
					"delete":{
						type: "icc_flow_ws",
						enabled:false,
						inputParams:[]
					}
				}
				
			}
		}
		opt_icc_flow_bind_retrieve.onChange(function(value){
		
			if(value){
				resetData();
				self.data.description.retrieve.idOperativa=self.tempData.idOperativa;
				self.data.description.retrieve.XPathRow=self.tempData.XPathRow;
				
				self.data.description.retrieve.enabled = true;
				self.data.description.retrieve.inputParams = self.tempData.params;
				self.setNext(self.pageDatasourceName);
			}
		});
		opt_icc_flow_bind_store.onChange(function(value){
			if(value){
				resetData();
				self.data.description.store.idOperativa=self.tempData.idOperativa;
				self.data.description.store.XPathRow=self.tempData.XPathRow;
				
				self.data.description.store.enabled = true;
				self.data.description.store.inputParams = self.tempData.params;
				self.setNext(self.pageDatasourceName);
			}
		});
		opt_icc_flow_bind_inup.onChange(function(value){
			if(value){
				resetData();
				self.data.description.store.enabled = true;
				self.data.description.store.idOperativa=self.tempData.idOperativa;
				self.data.description.store.inputParams = self.tempData.params;
				self.data.description.store.XPathRow=self.tempData.XPathRow;
				
				self.data.description.update.enabled = true;
				self.data.description.update.idOperativa=self.tempData.idOperativa;
				self.data.description.update.inputParams = self.tempData.params;
				self.data.description.update.XPathRow=self.tempData.XPathRow;
				
				self.setNext(self.pageDatasourceName);
			}
		});

		
		var self=this;
		return pageIccFlowBind;
	};
	datasourceWizard.prototype.pageICFlowColumns = function(){
		<%FRAME:datasourceWizard.pageICFlowColumns%>
		var self = this;
		self.setNext(undefined);

		if (self.tempData == undefined ){
			self.tempData = {
				params:[],
				columns:[]
			}
		};
		icc_flow_columns_txXPathRow.text = self.tempData.XPathRow;
		icc_flow_columns_gdColumns.items = self.tempData.columns;
		self.setNext(undefined);
		icc_flow_columns_cbColumnType.items = [
			{id:'integer',	text:'integer'},
			{id:'numeric',	text:'numeric'},
			{id:'string',	text:'string'},
			{id:'datetime', text:'datetime'},
			{id:'date', text:'date'},
			{id:'boolean', text:'boolean'}
		];

		
		var updateNextPage = function(){
/*			self.setNext((
				self.data.description.columns.length >0 			
			)?self.pageDatasourceName:undefined);
*/
			
			self.setNext(self.tempData.XPathRow && self.tempData.XPathRow != ''?self.pageIccFlowBind:undefined);
		};		
		var loadData = function(){
			
			updateNextPage();
		}

		icc_flow_columns_gdColumns.onChange(function(item){
			icc_flow_columns_txColumnName.setText(item.name);
			icc_flow_columns_cbColumnType.setItem(item.type);
			icc_flow_columns_fieldList_btnRmv.setEnabled(true);
			icc_flow_columns_fieldList_btnAdd.setEnabled(true);
			
		});
		icc_flow_columns_fieldList_btnAdd.onClick(function(){
			if(!icc_flow_columns_gdColumns.getItem()){
				var col = {column:icc_flow_columns_txColumnName.getText(),name:icc_flow_columns_txColumnName.getText(),type:icc_flow_columns_cbColumnType.getItem().id,allowNull:true};
				self.tempData.columns.push(col);
				icc_flow_columns_gdColumns.addItem({name:col.name,type:col.type,column:col});
			}
			icc_flow_columns_txColumnName.setText("");
			icc_flow_columns_cbColumnType.setItem(-1);
			icc_flow_columns_fieldList_btnRmv.setEnabled(false);
			icc_flow_columns_fieldList_btnAdd.setEnabled(false);
			icc_flow_columns_gdColumns.setItem({});
			updateNextPage();
		});
		icc_flow_columns_fieldList_btnRmv.onClick(function(){
			var it = icc_flow_columns_gdColumns.getItem();
			if(it){
				jQuery.each(self.tempData.columns,function(idx,column){
					if(it.column === column){
						self.tempData.columns.splice(idx,1);
						return false;
					}
				});
				icc_flow_columns_gdColumns.rmvItem(it);
				icc_flow_columns_fieldList_btnRmv.setEnabled(false);
				icc_flow_columns_fieldList_btnAdd.setEnabled(false);
				icc_flow_columns_txColumnName.setText("");
				icc_flow_columns_cbColumnType.setItem(-1);
				
			}
			updateNextPage();
			
		});
		
		icc_flow_columns_cbColumnType.onChange(function(idx,text,item){
			var it = icc_flow_columns_gdColumns.getItem();
			
			if(icc.utils.trim(icc_flow_columns_txColumnName.getText()) !== ''){
				icc_flow_columns_fieldList_btnRmv.setEnabled(true);
				icc_flow_columns_fieldList_btnAdd.setEnabled(true);
				if(it){
					it.type = item.id;
					it.column.type = item.id;
					icc_flow_columns_gdColumns.updateItem(it);
				
				}
				
			}else{
				icc_flow_columns_fieldList_btnRmv.setEnabled(false);
				icc_flow_columns_fieldList_btnAdd.setEnabled(false);			
			
			}
		});
		icc_flow_columns_txColumnName.onChange(function(value){
			var it = icc_flow_columns_gdColumns.getItem();
			var v = icc.utils.trim(value);
			if(v!=='' && icc_flow_columns_cbColumnType.getItem()){
				icc_flow_columns_fieldList_btnRmv.setEnabled(true);
				icc_flow_columns_fieldList_btnAdd.setEnabled(true);
				it.name = value;
				it.column.name = value;
				it.column.column = value;
				icc_flow_columns_gdColumns.updateItem(it);
			}else{
				icc_flow_columns_fieldList_btnRmv.setEnabled(false);
				icc_flow_columns_fieldList_btnAdd.setEnabled(false);			
			}
		});
		icc_flow_columns_txXPathRow.onChange(function(value){
			self.tempData.XPathRow = icc.utils.trim(value);
			updateNextPage();
		});
		pageICFlowColumns.onCreate(function(){
			loadData();
			updateNextPage();
		});
		


		return pageICFlowColumns;
	};
	datasourceWizard.prototype.pageDataEntityBuildOption = function(){
		<%FRAME:datasourceWizard.pageDataEntityBuildOption%>
		var self = this;
		self.setNext(undefined);
		optBuildManually.checked = this.mode == "manually";
		optBuildFromCSV.checked = this.mode == "fromcsv";
		
		optBuildManually.onChange(function(value){
			if(value){
				self.mode = "manually";
				self.setNext(self.pageICCNativeStorageFields);
			}
		});
		
		optBuildFromCSV.onChange(function(value){
			if(value){
				self.mode = "fromcsv";
				self.csvData = self.csvData || {emptyCollection:true,duplicatedBehavior:'keep',firstRowHaveColumnNames:true,delimiter:','};
				self.setNext(self.pageCSVImportConfig);
			
			}
		
		});
		pageDataEntityBuildOption.onCreate(function(){
			switch(self.mode){
				case "manually":
					self.setNext(self.pageICCNativeStorageFields);
				break;
				case "fromcsv":
					self.setNext(self.pageCSVImportConfig);
				break;
			}
		});
		return pageDataEntityBuildOption;
	};
    datasourceWizard.prototype.pageTechnologySelection = function(){
		var self=this;
		<%FRAME:datasourceWizard.pageTechnologySelection%>
		opt_icc_native.checked = this.data.type === "icc_native" && !this.clone;
		opt_mssql.checked = this.data.type === "mssql" && !this.clone;
		opt_icc_interaction.checked = this.data.type === "icc_interaction" && !this.clone;
		opt_icc_contact.checked = this.data.type === "icc6_contact" && !this.clone;
		opt_icc_dialercontact.checked = this.data.type === "icc_contact" && !this.clone;
		opt_icc_flow.checked = this.data.type === "icc_flow" && !this.clone;
		opt_icc_summarizer.checked = this.data.type === "icc_summarizer:ds" && !this.clone;
		opt_clone.checked = this.clone!=undefined;
			
		var updateNextPage = function(){
		    switch(self.data.type){
				case "mssql":
					
		    	    self.setNext(self.pageSQLServer);
					break;
				case "icc_native":
					
		    	   self.setNext(self.pageDataEntityBuildOption);
					break;
				case "icc_interaction":
					self.setNext(self.setupInconcertInteraction);
					break;
				case "icc_summarizer":
					self.setNext(self.setupInconcertSummarizer);
					break;
				case "icc6_contact":
					self.setNext(self.pageInconcertContact);
					break;
				case "icc_contact":
					self.setNext(self.pageDialerContact);
					break;
				case "icc_flow":
					self.setNext(self.pageIccFlowSourceData);
					break;
				default:
					self.setNext(undefined);
		    }
		};
		
		opt_clone.onChange(function(value){
			if(value){
			
				self.clone = true;
				cbCloneDS.setEnabled(true);
				var dslist = self.appDoc.getDatasources();
				var items = []
				jQuery(dslist).each(function(idx,dsEntry){
					items.push({id: dsEntry.name, text: dsEntry.name});
				});	
				cbCloneDS.clearAll();
				cbCloneDS.addItem(items);
				self.setNext(undefined);
			}
		});
		cbCloneDS.onChange(function(idx,text,item){
			var dsdoc = new icc.ui.designer.datasourceDoc(self.appDoc.getVCCName(), self.appDoc.getId(), item.id);
			dsdoc.load(function (status,result) {
				if (status) {
					self.data =dsdoc.getConfigData();
					self.data.name = undefined;
					self.setNext(self.pageDatasourceName);
				}else{
					icc.ui.displayMessage(result);
				}
			});
		});
		opt_icc_summarizer.onChange(function(value){
			if(value){
			   self.data.type = "icc_summarizer";
			   self.clone = undefined;
			   cbCloneDS.setEnabled(false);	   
			   updateNextPage();
			}
		});
		
		opt_mssql.onChange(function(value){
			if(value){
			   self.data.type = "mssql";
			   self.clone = undefined;
			   cbCloneDS.setEnabled(false);	   
			   updateNextPage();
			
			}
		});
		
		opt_icc_native.onChange(function(value){
			if(value){
			   self.data.type = "icc_native";
			   self.clone = undefined;
			   cbCloneDS.setEnabled(false);	   

			   updateNextPage();
			}
		});

		opt_icc_interaction.onChange(function(value){
			if(value){
				self.data.type = "icc_interaction";
				self.clone = undefined;
				cbCloneDS.setEnabled(false);	   
				updateNextPage();
			}
		});
		
		opt_icc_contact.onChange(function(value){
			if(value){
				self.data.type = "icc6_contact";
				self.clone = undefined;
				cbCloneDS.setEnabled(false);	   
				updateNextPage();
			}
		});
		opt_icc_dialercontact.onChange(function(value){
			if(value){
				self.data.type = "icc_contact";
				self.clone = undefined;
				cbCloneDS.setEnabled(false);	   
				updateNextPage();
			}
		});
		opt_icc_flow.onChange(function(value){
			if(value){
				self.data.type = "icc_flow";
				self.clone = undefined;
				cbCloneDS.setEnabled(false);	   
				updateNextPage();
			}
		});
		pageTechnologySelection.onCreate(function(){
			if( !self.clone)
				updateNextPage();
				
		});
		
		return pageTechnologySelection;
    };
	
 	

    datasourceWizard.prototype.finishPressed = function(){
	
		if((this.data.type == "icc-native" || this.data.type == "icc-summarizer") && !this.clone && !this.CSVimport){
																		// si es CSVimport necesito el nombre
																		// de la tabla antes,y no vengo desde pageDatasourceName
			var tmstamp = Math.round(+new Date()/1000);
			this.data.description.tableName = this.data.name+"_"+tmstamp;
		}
		this.data.version = 23
		this.cb(true,this.data);
    };
	
    datasourceWizard.prototype.showModal = function(cb){
		var self=this;
		
		this.cb = cb;
		datasourceWizard.SUPERclass.showModal.call(this);
		this.onClose(function(){
			self.cb(false);
		});
    };
	
    icc.ui.designer.datasourceWizard = datasourceWizard;
})(__icc__);



/*jslint evil:true */
/*global jQuery  __icc__ _T
*/

(function(icc){

    var  viewWizard;

    viewWizard = function(appDoc, args) {
		args.backColor='#f9f9f9';
		args.caption = _T("View wizard");
		args.name = _T('designer_view_wizard_dlg');

		this.appDoc = appDoc;
		viewWizard.SUPERconstructor.call(this,args);
		
		this.emptyView ={"formType":"form","version":2,"fillWidth":true,"fillHeight":true,"type":"ui.panel","overflow":"visible","childs":[],"id":"template1","__code":"","name":"template1"};
		this.dialogView={"formSubType":"dialog","version":2,"fillWidth":true,"fillHeight":true,"childs":[{"#pragma:hideNameProperty":true,"childs":[],"fillWidth":true,"id":"band1","gridbk":false,"borderWidth":0,"resizable-w":false,"pb":2,"runtime-type":"ui.panel","height":70,"band-type":"dialogHeader","caption":"Header","immovable":true,"icon":"!pageheader.png","type":"ui.designer.dlgband"},{"type":"ui.hline","offsety":-2,"fillWidth":true,"id":"hsep19292","immovable":true,"penStyle":"dashed","weight":2,"height":3,"frame":true,"foreColor":"#6060a0","unselectable":true},{"type":"ui.dlgmain","childs":[{"rules":[{"target":"optionbutton1","pageName":"pito","__seed":true,"operator":"=="}],"childs":[],"fillWidth":true,"id":"pageStart","borderWidth":0,"resizable":false,"defaultNextScreen":"pagina2","immovable":true,"background":"!spacer.gif","type":"ui.panel","fillHeight":true}],"fillWidth":true,"id":"panel__220220220200220333032","gridbk":false,"borderWidth":0,"#pragma:hideNameProperty":true,"immovable":true,"band-type":"dialogMain","resizable":false,"runtime-type":"ui.panel","fillHeight":true}],"id":"temp1","runtimeMode":"wizard","name":"temp1","overflow":"visible","type":"ui.panel","formType":"form"}
		this.data={
			viewType:"single",
			formData:this.emptyView
		};
		
		this.options = [
			{
				name:_T('Single frame'),
				description:_T('This view have a optional panel at top and a menu bar.'),
				image:'vwz1.png',
				data:{"formType":"form","type":"ui.panel","childs":[{"height":65,"type":"ui.panel","childs":[],"fillWidth":true,"id":"topPanel","backGround":"lightgray","immovable":true,"resizable-w":false},{"type":"ui.panel","childs":[{"items":[{"caption":"File","items":[{"caption":"New"},{"caption":"Open"},{"caption":"Save"}]}],"vertical":false,"type":"ui.menu","fillWidth":true,"height":30,"immovable":true,"resizable":false,"id":"mainMenu"},{"type":"ui.panel","childs":[],"fillWidth":true,"id":"mainView","immovable":true,"reverseGradient":false,"resizable":false,"borderWidth":0,"overflow":"visible","frame":true,"padding":30,"gradient":false,"fillHeight":true}],"fillWidth":true,"id":"panel2","borderWidth":0,"layoutMode":"vertical","backGround":"lightgray","overflow":"visible","resizable":false,"frame":true,"immovable":true,"fillHeight":true}],"fillWidth":true,"__properties":[{"caption":"topPanel","type":"bool","name":"haveTopPanel"}],"id":"index","pt":5,"haveTopPanel":true,"pb":10,"pr":10,"__layoutcode":"/******************************************************\u000a     CODIGO DEL TEMPLATE\u000a*******************************************************/\u000avar self = thisForm;\u000aif(!designer){\u000a  mainMenu.zIndex = 10000;\u000a  var addChild = mainView.addChild\u000a     mainView.addChild = function (cl,index){\u000a     addChild.call(this,cl,index);\u000a     icc.ui.getApplication().getMainWindow().autofit();\u000a  }\u000a}else{\u000a  var layoutData = docInstance.getLayout();\u000a  layoutData.haveTopPanel = layoutData.haveTopPanel===undefined?true:layoutData.haveTopPanel;\u000a  docInstance.setLayout(layoutData);\u000a  \u000a  //alert(topPanel.visible);\u000a  docInstance.getProperties = function () {\u000a    return [\u000a       {caption:'TopPanel',type:'bool',name:'haveTopPanel'} \u000a    ];\u000a  }\u000a    \u000a}\u000atopPanel.visible = self.haveTopPanel;\u000a    \u000a\u000a /******************************************************/\u000a  \u000a  \u000a","overflow":"visible","__code":"\u000a  \u000a   \u000a","frame":true,"name":"index","fillHeight":true}
			}
			
	
			
		];
		this.setStartPage(this.viewTypeSelection);
		
	};
	icc.utils.inherit(viewWizard, icc.ui.wizardDialog);

    viewWizard.prototype.finishPressed = function(){
		this.data = icc.utils.clone(this.data);
		this.data.formData.name = this.data.name;
		this.data.formData.id = this.data.name;
		this.cb(true,this.data.formData);
    };
	
    viewWizard.prototype.showModal = function(cb){
		var self=this;
		
		this.cb = cb;
		viewWizard.SUPERclass.showModal.call(this);
		this.onClose(function(){
			self.cb(false);
		});
    };
	viewWizard.prototype.pageViewName = function(){
		var self = this;
		
		<%FRAME:viewWizard.pageViewName%>
		
		txName.text = self.data.name;
										   
		
		txName.onChange(function(value){
		    
			if(icc.utils.isValidFilename(value) && icc.utils.isValidVariableName(value)){
				self.data.name = icc.utils.trim(value);
			}else{
				self.data.name = '';
				txName.displayMessage(icc.ui.message('invalid_filename',{description:_T('Invalid view name')}));
			}
				
			self.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		});
		this.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		pageViewName.onCreate(function(){
			txName.setFocus();
		});
		return pageViewName;
    };
	viewWizard.prototype.fullPageView = function(){
		var self = this;
		var chkbuttons = [];
		<%FRAME:viewWizard.fullPageView%>
		
		var updateNextPage = function(){
			var r;
			jQuery.each(self.options,function(idx,optionData){
				if ( optionData.data && optionData.data === self.data.formData)
				{
						r = true;
						
				}
			});
			if (r){
				self.setNext(self.pageViewName);
			}else{
				self.setNext(undefined);
			}
			
		};
		
		var buildOption = function (optionData){
			<%FRAME:viewWizard.rowTemplate%>
			rowSelector.onChange(function(value){
				var thisCheck = this;
				if (value){
					jQuery.each(chkbuttons,function(idx,btn){
						if(btn !== thisCheck){
							btn.setChecked(false);
						}
					});
					self.data.formData = optionData.data;
				}else{
					self.data.formData = undefined;
				}
				updateNextPage();
				
			});
			chkbuttons.push(rowSelector);
			
			
			rowImage.image = optionData.image;
			rowTemplateName.caption = optionData.name;
			rowTemplateDescription.caption = optionData.description;
			return rowTemplate;
		};
		var childs = [];
		jQuery.each(self.options,function(idx,option){
			childs.push(buildOption(option));
			
		});
		templateList.childs = childs;
		templateList.overflowy = "auto";
		fullPageView.onCreate(function(){
			updateNextPage();
		});
		
		return fullPageView;
	};
	viewWizard.prototype.viewTypeSelection = function(){
		var self = this;
		self.setNext(undefined);
		<%FRAME:viewWizard.viewTypeSelection%>
		
		
		optEmptyView.checked = self.data.viewType === 'single';
		optDialogView.checked = self.data.viewType === 'dialog';
		optFullPageView.checked = self.data.viewType === 'fullPage';
		
		
		var updateNextPage = function(){
			
			switch(self.data.viewType){
				case 'dialog':
				case 'single':
					self.setNext(self.pageViewName);
				break;
				case 'fullPage':
					self.setNext(self.fullPageView);

				break;
				
				default:
					self.setNext(undefined);	
			}
		};
		optFullPageView.onChange(function(value){
			if(value){
				self.data.viewType = 'fullPage';
				self.data.formData = undefined;
				updateNextPage();
			}
		});
		optDialogView.onChange(function(value){
			if(value){
				self.data.viewType = 'dialog';
				self.data.formData = self.dialogView;
				updateNextPage();
			}
		});		
		optEmptyView.onChange(function(value){
			if(value){
				self.data.viewType = 'single';
				self.data.formData = self.emptyView;
				updateNextPage();
			}
		});		
		
		viewTypeSelection.onCreate(function(){
			updateNextPage();
		});
		return viewTypeSelection;
	};
	
    icc.ui.designer.viewWizard = viewWizard;
})(__icc__);




(function(icc){
	icc.ui.designer.csvutils = {};
		
	icc.ui.designer.csvutils.exportData = function(fileName,tableName,firstRowHaveColumnNames,columns){
		var exportParams ={
			tableName:tableName,
			firstRowHaveColumnNames:firstRowHaveColumnNames,
			columns:columns
		}
		var url = 'designer/csv/exportdata/'+encodeURIComponent(JSON.stringify(exportParams))+"/"+fileName;
		window.open(url);
	};
	icc.ui.designer.csvutils.beginImportProcess=function(fileId,delimiter,firstRowHaveColumnNames,duplicatedBehavior,tableName,emptyCollection,columns,cb){
		var finished = false;
		var data ={
			fileId:fileId,
			delimiter:delimiter,
			firstRowHaveColumnNames:firstRowHaveColumnNames,
			duplicatedBehavior:duplicatedBehavior,
			columns:columns,
			emptyCollection:emptyCollection,
			tableName:tableName
		};
		
		var checkProcess = function(processId){
			jQuery.ajax({
				url: 'runtime/check_process',
				type: 'POST',
				async: true,
				dataType:'json',
				data: JSON.stringify({processId:processId}),
				contentType: "application/json",
				beforeSend: function (request) {
					request.setRequestHeader('Content-Encoding', 'utf-8');
				},
				dataType:"json",
				success: function(ajaxResponse){
					if(!finished){
						if(ajaxResponse.status && cb){
							cb(ajaxResponse.status,ajaxResponse.result);
						}
						if(ajaxResponse.status && !ajaxResponse.result.isCompleted && !ajaxResponse.result.haveError){
							setTimeout(function(){
								checkProcess(processId);
							},200);
						}
					}
				},
				error:function(ajaxError){
					finished=true;
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
				}
			});
		};
		var startProcess = function(processId){
			jQuery.ajax({
				url: 'designer/csv/startprocess_async',
				type: 'POST',
				async: true,
				dataType:'json',
				data: JSON.stringify({processId:processId}),
				contentType: "application/json",
				beforeSend: function (request) {
					request.setRequestHeader('Content-Encoding', 'utf-8');
				},
				dataType:"json",
				success: function(ajaxResponse){
		//			finished=true;
		//			if(cb){
		//				cb(ajaxResponse.status,ajaxResponse.result);
		//			}
				},
				error:function(ajaxError){
					finished=true;
					if(cb){
						cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
					}
				}
			});
			setTimeout(function(){
				checkProcess(processId);
			},100);
		}
    	jQuery.ajax({
			url: 'runtime/create_process',
			type: 'POST',
			async: true,
			dataType:'json',
			data: JSON.stringify(data),
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				if(ajaxResponse.status){
					setTimeout(function(){
						startProcess(ajaxResponse.result.processId);
					},100);
				}else{
					if(cb){
						cb(ajaxResponse.status,ajaxResponse.result);
					}
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	}
	
	icc.ui.designer.csvutils.getRows=function(fileId,delimiter,firstRowHaveColumnNames,ignoreDuplicates,nrows,columns,cb){
		var data ={
			fileId:fileId,
			delimiter:delimiter,
			firstRowHaveColumnNames:firstRowHaveColumnNames,
			ignoreDuplicates:ignoreDuplicates,
			columns:columns,
			rows:nrows
		};
    	jQuery.ajax({
			url: 'designer/csv/get',
			type: 'POST',
			async: true,
			dataType:'json',
			data: JSON.stringify(data),
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});


	};
	icc.ui.designer.csvutils.retrieveCSVColumns=function(fileId,delimiter,firstRowHaveColumnNames,cb){
		var data ={
			fileId:fileId,
			delimiter:delimiter,
			firstRowHaveColumnNames:firstRowHaveColumnNames
		};
    	jQuery.ajax({
			url: 'designer/csv/columns',
			type: 'POST',
			async: true,
			dataType:'json',
			data: JSON.stringify(data),
			contentType: "application/json",
			beforeSend: function (request) {
				request.setRequestHeader('Content-Encoding', 'utf-8');
			},
			dataType:"json",
			success: function(ajaxResponse){
				if(cb){
					cb(ajaxResponse.status,ajaxResponse.result);
				}
			},
			error:function(ajaxError){
				if(cb){
					cb(false,icc.ui.message('ajax_error',{status:ajaxError.status,statusText:ajaxError.statusText}));
				}
			}
		});
	
	}
})(__icc__);


(function(icc){

	var  dsNativeDataImport;
	dsNativeDataImport = function(appDoc, args,datasourceData) {
		this.appDoc = appDoc;
		this.datasourceData= datasourceData;
		args.backColor='white';
		args.caption = _T("Data import wizard");
		args.name = _T('datasource_data_import_wizard_dlg');
		
	    dsNativeDataImport.SUPERconstructor.call(this,args);
		this.csvData = {duplicatedBehavior:'keep',firstRowHaveColumnNames:true,delimiter:','};
		this.setStartPage(this.pageCSVImportConfig);
		
	};
	icc.utils.inherit(dsNativeDataImport, icc.ui.wizardDialog);

	dsNativeDataImport.prototype.pageCSVImportProcess=function(){
		<%FRAME:dataImportExportAssets.pageCSVImportProcess%>
		var self = this;
		ckCSVEmptyInformation.checked = self.csvData.emptyCollection;
		this.setNext(undefined, true, false);
		btnCSVStartProcess.onClick(function(){
			var msgs={}
			txCSVProcessLog.setText("");
			btnCSVStartProcess.setEnabled(false);
			icc.ui.designer.csvutils.beginImportProcess(self.csvData.fileid,self.csvData.delimiter,self.csvData.firstRowHaveColumnNames,
				self.csvData.duplicatedBehavior,
				self.datasourceData.description.tableName,
				self.csvData.emptyCollection,
				self.csvData.columns,
				function(status,result){	// aca voy recibiendo los datos para el progress
					if(status){
						pgCSVProcess.setValue(result.processCompletion);
											// llevo un hash con los mensajes mostrados, entonces
											//puedo detectar uno nuevo
						if(result.messages && result.messages.length){
							txCSVProcessLog.setText(txCSVProcessLog.getText()+"\n"+result.messages.join("\n"));
						}					// fin del proceso , todo se importo ok prendo el boton finish
						if(result.isCompleted){
							self.CSVimport=true;
							pgCSVProcess.setValue(100);
							self.setNext(undefined,true,true);
							btnCSVStartProcess.setEnabled(true);
						}
					}else{
						icc.ui.displayMessage(result);
						btnCSVStartProcess.setEnabled(true);
					}					
				}
			)
		});

		ckCSVEmptyInformation.onChange(function(value){
			self.csvData.emptyCollection=value;
		});
		
		pageCSVImportProcess.onCreate(function(){
			self.setNext(undefined,true,false);
		});
		return pageCSVImportProcess;

	};
	dsNativeDataImport.prototype.pageCSVImportPreview = function(){
		<%FRAME:dataImportExportAssets.pageCSVImportPreview%>
		var self = this;		
		
		
		pageCSVImportPreview.onCreate(function(){
			self.setNext(undefined);
			icc.ui.designer.csvutils.getRows(self.csvData.fileid,self.csvData.delimiter,self.csvData.firstRowHaveColumnNames,
				self.csvData.duplicatedBehavior,
				50,
				self.csvData.columns,
				function(status,result){
					if(status){
						var cols = []
						
						jQuery(result.colnames).each(function(idx,name){
							var l;
							switch(result.coltypes[idx]){
								case 'integer':l = 80;break;
								case 'string':l = 140;break;
								
								case 'date':l = 140;break;
								case 'datetime':l=100;break;
								case 'numeric':l=90;break;
								default:l=80;break;
								
							}
							cols.push({caption:name,type:result.coltypes[idx],width:l,field:idx})
						});
						var grid = new icc.ui.grid({
							fillWidth:true,
							fillHeight:true,
							columns:cols
						});
						grid.create();
						grid.addItem(result.rows);
						cntCSVImportPreview.addChild(grid);
						cntCSVImportPreview.layout();
						self.setNext(self.pageCSVImportProcess);
						
					}else{
						icc.ui.displayMessage(result);
					}
				}
			)
		});
		return pageCSVImportPreview;

	};
	dsNativeDataImport.prototype.pageCSVImportFieldMappings = function(){
		<%FRAME:dataImportExportAssets.pageCSVImportFieldMappings%>
		var self = this;	
		var datatypes ={	// solo los que tienen algun tipo de conversion
				date:[
					{id:'dd/mm/yyyy',text:'dd/mm/yyyy'},
					{id:'mm/dd/yyyy',text:'mm/dd/yyyy'},
					{id:'yyyymmdd',text:'yyyymmdd'},
					{id:'yyyy-mm-dd',text:'yyyy-mm-dd'}
				],
				datetime:[
					{id:'dd/mm/yyyy hh:mm:ss.mmm',text:'dd/mm/yyyy hh:mm:ss.mmm'},
					{id:'mm/dd/yyyy hh:mm:ss.mmm',text:'mm/dd/yyyy hh:mm:ss.mmm'},
					{id:'yyyymmddhhmmssmmm',text:'yyyymmddhhmmssmmm'},
					{id:'yyyy-mm-dd hh:mm:ss.mmm',text:'yyyy-mm-dd hh:mm:ss.mmm'}
				]
		}
//		txtCSVDataType.items = datatypes;
		pageCSVImportFieldMappings.onCreate(function(){
			icc.ui.designer.csvutils.retrieveCSVColumns(self.csvData.fileid,self.csvData.delimiter,self.csvData.firstRowHaveColumnNames,
				function(status,result){
				
					if(status){
						self.csvData.columns = result;
						self.setNext(self.pageCSVImportPreview);
						jQuery.each(result,function(idx,csvcol){
							csvcol.enabled = false;
							var found = false;
							
							jQuery.each(self.datasourceData.description.columns,function(idx,col){
								if(col.name == csvcol.alias){
									found = true;
									csvcol.enabled = true;
									csvcol.type = col.type;
									if(datatypes[csvcol.type])
										csvcol.format = datatypes[csvcol.type][0].id;
									return false;
								}
							});
							if(!found){
								csvcol.alias = undefined;
								csvcol.type = undefined;
								
							}
						})
						gdCSVFieldMap.addItem(result);
					}else{
						icc.ui.displayMessage(result);
					}
				}
			);
			self.setNext(undefined);
		});
		gdCSVFieldMap.onChange(function(item){
			var column_item;
			ckCSVFieldEnabled.setEnabled(item!== undefined);
			ckCSVFieldEnabled.setChecked(item!== undefined && item.enabled !==false);
			cbCSVFieldName.setEnabled(item !== undefined && item.enabled !==false)
			ckCSVCheckThisField.setEnabled(item !== undefined && item.enabled !==false);
			cbCSVFieldName.clearAll();
			var items = []
			jQuery.each(self.datasourceData.description.columns,function(idx,col){
				items.push({id:col.name,text:col.name,type:col.type});
			});
			cbCSVFieldName.addItem(items);
			cbCSVFieldName.setItem(item.alias);
			column_item = cbCSVFieldName.getItem();
			if(column_item ){
				txCSVDataType.setText(column_item.type);
				txCSVDataType.setEnabled(true);
			}else{
				txCSVDataType.setText('');
				txCSVDataType.setEnabled(false);
				
			}
			ckCSVCheckThisField.setChecked(item.key);
			if (column_item && datatypes[column_item.type]){
				cbCSVFormat.setEnabled(true && item.enabled !==false);
				cbCSVFormat.clearAll();
				cbCSVFormat.addItem(datatypes[column_item.type]);
				cbCSVFormat.setItem(item.format);
//				if(!cbCSVFormat.getItem()){
//					cbCSVFormat.setItem(1);
//					item.format = cbCSVFormat.getItem().text;
//				}
			}else{
				cbCSVFormat.setEnabled(false);
				cbCSVFormat.setItem(-1);
				
			}
			
		});
		ckCSVFieldEnabled.onChange(function(value){
			gdCSVFieldMap.getItem().enabled = value;
			gdCSVFieldMap.fireEvent("onChange",gdCSVFieldMap.getItem());
		});
		
		cbCSVFieldName.onChange(function(idx,text,item){
			gdCSVFieldMap.getItem().alias = text;
			gdCSVFieldMap.getItem().type = item.type;
			if(datatypes[item.type]){
				gdCSVFieldMap.getItem().format = datatypes[item.type][0].id;
			}
			gdCSVFieldMap.updateItem(gdCSVFieldMap.getItem());
			gdCSVFieldMap.fireEvent("onChange",gdCSVFieldMap.getItem());
		});
		cbCSVFormat.onChange(function(idx,text,item){
			gdCSVFieldMap.getItem().format = text;
		});
		
		ckCSVCheckThisField.onChange(function(value){
			gdCSVFieldMap.getItem().key = value;
		});
		optCSVKeepCurrent.onChange(function(value){
			if(value)
				self.csvData.duplicatedBehavior = "keep";
			
		});
		optCSVOverwrite.onChange(function(value){
			if(value)
				self.csvData.duplicatedBehavior = "overwrite";
		});
		return pageCSVImportFieldMappings;
	
	}
	dsNativeDataImport.prototype.pageCSVImportConfig = function(){
		<%FRAME:dataImportExportAssets.pageCSVImportConfig%>
		var self = this;		
		if(self.csvData.delimiter == undefined)
			self.csvData.delimiter = ',';
			
		optCSVCommaDelimiter.checked = self.csvData.delimiter == ",";	
		optCSVTabDelimiter.checked = self.csvData.delimiter == "\t";
		optCSVSemicolonDelimiter.checked = self.csvData.delimiter == ";";
		optCSVCustomDelimiter.checked =  self.csvData.delimiter !== ';' && self.csvData.delimiter !== '\t'  && self.csvData.delimiter !== ',';
		txCustomDelimiter.enabled =	optCSVCustomDelimiter.checked;
		txCustomDelimiter.text = self.csvData.delimiter;
		pgCSVFile.caption = self.csvData.csvFilename;
		pgCSVFile.value =self.csvData.csvFilename!==undefined?100:0;

		optCSVCommaDelimiter.onChange(function(value){
			if(value){
				self.csvData.delimiter=','
				txCustomDelimiter.setEnabled(false);
			}
		});
		
		optCSVTabDelimiter.onChange(function(value){
			if(value){
				self.csvData.delimiter='\t';
				txCustomDelimiter.setEnabled(false);
			}
		});
		optCSVSemicolonDelimiter.onChange(function(value){
			if(value){
				self.csvData.delimiter=';'
				txCustomDelimiter.setEnabled(false);
			}
		});

		optCSVCustomDelimiter.onChange(function(value){
			if(value){
				txCustomDelimiter.setEnabled(true);
			}
			
			
		});	
		txCustomDelimiter.onChange(function(value){
			self.csvData.delimiter = value;
		});
		ckFirstRowNames.onChange(function(value){
			self.csvData.firstRowHaveColumnNames = value;
		});
		
		uplCSVFile.onProgress(function(filename,value){
		  pgCSVFile.setValue(value);
		});
		uplCSVFile.onChange(function(fname){
			self.csvData.csvFilename = fname;
			pgCSVFile.setCaption(fname);
			self.setNext(undefined);
		});
		uplCSVFile.onComplete(function(fname,id){
			self.csvData.fileid=id;
			self.setNext(self.pageCSVImportFieldMappings);
			
		});
		
		pageCSVImportConfig.onCreate(function(){
			txCustomDelimiter.setEnabled(optCSVCustomDelimiter.getChecked());
			self.setNext(self.csvData.fileid ===undefined ?undefined:self.pageCSVImportFieldMappings);
		});
		
		return pageCSVImportConfig;
	};
	
    icc.ui.designer.dsNativeDataImport = dsNativeDataImport;
	var dsNativeDataExport;
	dsNativeDataExport = function(appDoc, args,datasourceData) {
		
		<%FRAME:dataImportExportAssets.dsExportDialog%>
		this.appDoc = appDoc;
		
		this.datasourceData= datasourceData;
		args.backColor='white';
		args.caption = _T("Data export");
		args.name = _T('datasource_data_export_wizard_dlg');
		exportDataPanel.overflowy="scroll";
		exportDataPanel.childs=[];
	
		args.childs=[
			dsExportDialog
		]
		var exportedColumns = []
		var buildColumnWnd = function ( col ) {
			<%FRAME:dataImportExportAssets.exportDataRow%>
			lbExportRowColumnName.caption = col.name
			if(exportedColumns.length%2 == 0)
				exportDataRow.backColor = "white"
			else
				exportDataRow.backColor = "#f4f4f4"
			exportedColumns.push({col:col,checkBtn:ckExportRowColumnSelector});
			return exportDataRow;
		}
		jQuery.each(datasourceData.description.columns,function(idx,col){
			exportDataPanel.childs.push(buildColumnWnd(col));
		});

	    dsNativeDataExport.SUPERconstructor.call(this,args);
		var self = this;
		btnExport.onClick(function(){
			var cols = []
			jQuery.each(exportedColumns,function(idx,row){
				cols.push({name:row.col.name,type:row.col.type,enabled:row.checkBtn.getChecked()})
			})
			
			
			icc.ui.designer.csvutils.exportData(datasourceData.name+".csv",datasourceData.description.tableName,ckExportColumnNames.getChecked(),cols)
			self.close();
		});
	};
	icc.utils.inherit(dsNativeDataExport, icc.ui.dialog);
	icc.ui.designer.dsNativeDataExport = dsNativeDataExport;
	
})(__icc__);


(function(icc){
    var  applicationWizard;
    applicationWizard = function( args) {
		
	    applicationWizard.SUPERconstructor.call(this,args);
		this.setStartPage(this.pageAppWizard);
    };
	
	icc.utils.inherit(applicationWizard, icc.ui.wizardDialog);
	applicationWizard.prototype.pageAppWizard = function (){
		var self = this;
		<%FRAME:assets.pageAppWizard%>
		
		optNewFromTemplate.onChange(function(value){
			if(value)
				self.setNext(self.pageAppFromTemplate);
		});
		optNewFromBundle.onChange(function(value){
			if(value)
				self.setNext(self.pageAppFromBundle);
		});
		
		this.setNext(undefined);
		return pageAppWizard;
	};
	applicationWizard.prototype.pageAppFromTemplate = function(){
		var self=this;
		var selfWizard=self;
		<%FRAME:assets.pageAppFromTemplate%>
		

		var workspace = new icc.ui.designer.workspaceDoc(icc.ui.getApplication().getVCCName());
		templateList.childs=[];
		templateList.overflowy="auto";
		var selectors = [];
		var selectedTemplate;
		function buildItem(template){
			var rowTemplate;
			<%FRAME:assets.rowTemplate%>
			templateName.caption = template.caption;
			templateDescription.caption = template.description;
			templateImage.image = template.image;
			selectors.push(ck_selector);
			ck_selector.onChange(function(value){
				
				var self=this;
				if(value){
					jQuery.each(selectors,function(idx,sel){
						if(sel !== self){
							sel.setChecked(false);
						}
					});
					selectedTemplate = template;
				}else{
					selectedTemplate = undefined;
					
				}
				txAppName.setEnabled(selectedTemplate!==undefined);
				selfWizard.setNext(undefined,true,selectedTemplate!==undefined);
				
			});
			return rowTemplate;
		}
		self.onFinish(function(){
			if(icc.utils.isValidFilenameAgtMens(txAppName.getText()) && icc.utils.isValidVariableName(txAppName.getText())){
				workspace.createApplication(txAppName.getText(),{templateId:selectedTemplate.id},function(status,result){
					if(status){
						icc.ui.displayMessage(icc.ui.message('save_operation_succesful',{description:'The application was created successfully'}));                
						if(window.parentSandboxBridge && window.parentSandboxBridge.onNewProject){
							window.parentSandboxBridge.onNewProject(true,{
								id: txAppName.getText(),
								description: txAppName.getText()
							});
						}
						self.loadDesigner(txAppName.getText());
					}else{
						if(result.code==1035){
								result.level = 3;
								txAppName.displayMessage(result,false)
						}else
							icc.ui.displayMessage(result,false);
					}
				});
			}else{
				txAppName.displayMessage(icc.ui.message('invalid_filename',{level:3}),false);
			}
		});
		pageAppFromTemplate.onCreate(function(){
			workspace.initialize({templateAppClass:self.templateAppClass,templateAppSubClass:self.templateAppSubClass},function(status){
				if(status){
					var templates = workspace.getTemplates();
					var r;
					for(var i = 0;i<templates.length;i++){
						r = buildItem(templates[i]);
						r.create();
						templateList.addChild(r);
					}
					templateList.layout();
				}
			});

		});
		this.setNext(undefined,true,false);
		return pageAppFromTemplate;	
	};
	applicationWizard.prototype.loadDesigner = function ( appId ){
		icc.ui.getApplication().show("init",{cmd:'open',value:appId});
	};
	applicationWizard.prototype.pageAppFromBundle = function(){
		var self = this;
		<%FRAME:assets.pageAppFromBundle%>
		var workspace = new icc.ui.designer.workspaceDoc(icc.ui.getApplication().getVCCName());
		workspace.initialize(function(){
		});
		btnUpload.onProgress(function(filename,value){
		  pbar.setValue(value);
		});
		var fileid;
		var emptyPrompt = "----------------------------------------------";

		btnUpload.onChange(function(fname){
			pbar.setCaption(fname);
			lbExportedAt.setCaption(emptyPrompt);
			lbExportedBy.setCaption(emptyPrompt);
			txImportBundleAppName.setText("");
			txImportBundleAppName.setEnabled(false);
			self.setNext(undefined,true,false);
			
		});
		btnUpload.onComplete(function(fname,id){
			fileid=id;
			
			workspace.getBundleInfo(id,
				function(status,info){
					if (status){
						lbExportedAt.setCaption(info.exportedAt);
						lbExportedBy.setCaption(info.exportedBy);
						txImportBundleAppName.setText(info.name);
						
						txImportBundleAppName.setEnabled(true);
						self.setNext(undefined,true,txImportBundleAppName.performValidation().code === 0);
					}else{
						icc.ui.displayMessage(info);
					}
				}
			);
		});
		txImportBundleAppName.onChange(function(){
			if(txImportBundleAppName.performValidation(true).code ===0 && fileid!==undefined){
				self.setNext(undefined,true,true);
			}
		});
		self.onFinish(function(){
			if(txImportBundleAppName.performValidation(true).code ===0){
				var name = icc.utils.trim(txImportBundleAppName.getText());
				
//				self.setNext(undefined,true,false)
				if(icc.utils.isValidFilenameAgtMens(name) && icc.utils.isValidVariableName(name)){

					workspace.importBundle(fileid,name,ckOverwrite.getChecked(),false,function(status,result){
						if (!status){
							if(result.code === 1035 || result.code === 1036){
								result.level=3;
								txImportBundleAppName.displayMessage(result,false);
							}else{
								fileid=undefined;
								txImportBundleAppName.setEnabled(false);
								icc.ui.displayMessage(result);
							}
						}else{
							fileid=undefined;
							icc.ui.displayMessage(icc.ui.message('save_operation_succesful',{description:_T('The application bundle was  imported successfully')}),true);;
							self.loadDesigner(txImportBundleAppName.getText());
						}
					});

				}else{
					txImportBundleAppName.displayMessage(icc.ui.message('invalid_filename',{level:3}),false);
				}
			}else{
					txImportBundleAppName.displayMessage(icc.ui.message('invalid_filename',{level:3}),false);
			}
		});
		this.setNext(undefined,true,false);
		return pageAppFromBundle;	
	};
	
	icc.ui.designer.applicationWizard = applicationWizard;	
	
})(__icc__);



/*jslint evil:true */
/*global jQuery  __icc__ _T
*/

(function(icc){

    var  reportWizard;

    reportWizard = function(appDoc, args) {
		args.backColor='#f9f9f9';
		args.caption = _T("Report wizard");
		args.name = _T('designer_view_wizard_dlg');

		this.appDoc = appDoc;
		reportWizard.SUPERconstructor.call(this,args);
		
		this.listReport ={
	"type": "ui.panel",
	"childs": [
	{
		"type": "ui.pageheader",
		"childs": [
			{
				"type": "ui.panel",
				"childs": [
					{
						"image": "!pageheader.png",
						"type": "ui.image",
						"id": "image1",
						"height": 16,
						"borderWidth": 0,
						"width": 16
					},
					{
						"type": "ui.label",
						"caption": "Page header",
						"height": 20,
						"borderWidth": 1,
						"id": "label1",
						"mustTranslate": true
					}
				],
				"backColor": "#fafafa",
				"id": "panel1",
				"hs": 4,
				"borderWidth": 1,
				"bandDecoration": true,
				"layoutMode": "horizontal",
				"resizable": false,
				"pt": 2,
				"height": 20,
				"frame": true,
				"fillWidth": true,
				"unselectable": true
			},
			{
				"type": "ui.hline",
				"fillWidth": true,
				"id": "hline1",
				"immovable": true,
				"bandDecoration": true,
				"sideBottom": true,
				"penStyle": "dashed",
				"weight": 2,
				"foreColor": "darkblue",
				"resizable": false,
				"unselectable": true
			}
		],
		"id": "pageheader1",
		"borderWidth": 0,
		"width": 895,
		"pb": 2,
		"x": 0,
		"resizable-w": false,
		"borderColor": "darkblue",
		"height": 70,
		"immovable": true,
		"#pragma:hideNameProperty": true,
		"band-type": "pageheader"
	},
	{
	  "type": "ui.reportdetails",
	  "childs": [
		{
		  "type": "ui.panel",
		  "childs": [
			{
			  "image": "!reportdetails.png",
			  "type": "ui.image",
			  "id": "image2",
			  "height": 16,
			  "borderWidth": 0,
			  "width": 16
			},
			{
			  "type": "ui.label",
			  "caption": "Details",
			  "height": 20,
			  "borderWidth": 1,
			  "id": "label2",
			  "mustTranslate": true
			}
		  ],
		  "backColor": "#fafafa",
		  "id": "panel2",
		  "hs": 4,
		  "borderWidth": 1,
		  "bandDecoration": true,
		  "layoutMode": "horizontal",
		  "resizable": false,
		  "pt": 2,
		  "height": 20,
		  "frame": true,
		  "fillWidth": true,
		  "unselectable": true
		},
		{
		  "type": "ui.hline",
		  "fillWidth": true,
		  "id": "hline2",
		  "immovable": true,
		  "bandDecoration": true,
		  "sideBottom": true,
		  "penStyle": "dashed",
		  "weight": 2,
		  "foreColor": "darkblue",
		  "resizable": false,
		  "unselectable": true
		}
	  ],
	  "id": "reportdetails1",
	  "borderWidth": 0,
	  "width": 895,
	  "pb": 2,
	  "x": 0,
	  "resizable-w": false,
	  "borderColor": "darkblue",
	  "height": 75,
	  "immovable": true,
	  "#pragma:hideNameProperty": true,
	  "band-type": "reportdetails"
	},
	{
	  "type": "ui.pagefooter",
	  "childs": [
		{
		  "type": "ui.panel",
		  "childs": [
			{
			  "image": "!pagefooter.png",
			  "type": "ui.image",
			  "id": "image3",
			  "height": 16,
			  "borderWidth": 0,
			  "width": 16
			},
			{
			  "type": "ui.label",
			  "caption": "Page footer",
			  "height": 20,
			  "borderWidth": 1,
			  "id": "label3",
			  "mustTranslate": true
			}
		  ],
		  "backColor": "#fafafa",
		  "id": "panel3",
		  "hs": 4,
		  "borderWidth": 1,
		  "bandDecoration": true,
		  "layoutMode": "horizontal",
		  "resizable": false,
		  "pt": 2,
		  "height": 20,
		  "frame": true,
		  "fillWidth": true,
		  "unselectable": true
		},
		{
		  "type": "ui.hline",
		  "fillWidth": true,
		  "id": "hline3",
		  "immovable": true,
		  "bandDecoration": true,
		  "sideBottom": true,
		  "penStyle": "dashed",
		  "weight": 2,
		  "foreColor": "darkblue",
		  "resizable": false,
		  "unselectable": true
		}
	  ],
	  "id": "pagefooter1",
	  "borderWidth": 0,
	  "width": 895,
	  "pb": 2,
	  "x": 0,
	  "resizable-w": false,
	  "borderColor": "darkblue",
	  "height": 60,
	  "immovable": true,
	  "#pragma:hideNameProperty": true,
	  "band-type": "pagefooter"
	}
	],
	"id": "reporte20",
	"__layoutcode": "",
	"overflow": "visible",
	"frame": true,
	"name": "reporte20",
	"formType": "report"
}
		this.crossTable = {
  "formSubType": "bireport",
  "childs": [
    {
      "#pragma:hideNameProperty": true,
      "childs": [
        {
          "type": "ui.panel",
          "childs": [
            {
              "image": "!pageheader.png",
              "height": 16,
              "id": "image1",
              "type": "ui.image",
              "borderWidth": 0,
              "width": 16
            },
            {
              "type": "ui.label",
              "height": 20,
              "caption": "Header",
              "borderWidth": 1,
              "id": "label1",
			  "mustTranslate": true
            }
          ],
          "backColor": "#fafafa",
          "id": "panel1",
          "hs": 4,
          "borderWidth": 1,
          "bandDecoration": true,
          "fillWidth": true,
          "resizable": false,
          "pt": 2,
          "height": 20,
          "frame": true,
          "layoutMode": "horizontal",
          "unselectable": true
        },
        {
          "type": "ui.hline",
          "fillWidth": true,
          "id": "hline1",
          "immovable": true,
          "bandDecoration": true,
          "sideBottom": true,
          "penStyle": "dashed",
          "weight": 2,
          "foreColor": "darkblue",
          "resizable": false,
          "unselectable": true
        }
      ],
      "id": "pageheader1",
      "borderWidth": 0,
      "resizable-w": false,
      "pb": 2,
      "x": 0,
      "width": 1500,
      "borderColor": "darkblue",
      "height": 60,
      "type": "ui.pageheader",
      "immovable": true,
      "band-type": "pageheader"
    },
    {
      "monthlyTotals": false,
      "#pragma:hideNameProperty": true,
      "childs": [
        {
          "#pragma:hideNameProperty": true,
          "childs": [],
          "fillWidth": true,
          "id": "rowcontainer1",
          "isRowDesigner": true,
          "borderWidth": 1,
          "y": 0,
          "vs": 0,
          "type": "rowcontainer",
          "immovable": true,
          "borderRight": true,
          "fillHeight": true
        }
      ],
      "yearlyTotals": true,
      "daily": true,
      "yearly": false,
      "x": 0,
      "unselectable": false,
      "width": 1500,
      "monthName": true,
      "type": "ui.bireportdetails",
      "dayOfWeek": true,
      "id": "bireportdetails1",
      "rowWidth": 175,
      "immovable": true,
      "resizable-w": false,
      "monthly": true,
      "dailyTotals": true,
      "pb": 2,
      "hourly": false,
      "height": 130,
      "frame": false,
      "borderWidth": 0,
      "band-type": "reportdetails"
    },
    {
      "#pragma:hideNameProperty": true,
      "childs": [
        {
          "type": "ui.panel",
          "childs": [
            {
              "image": "!pagefooter.png",
              "height": 16,
              "id": "image2",
              "type": "ui.image",
              "borderWidth": 0,
              "width": 16
            },
            {
              "type": "ui.label",
              "height": 20,
              "caption": "Footer",
              "borderWidth": 1,
              "id": "label2",
			  "mustTranslate": true
            }
          ],
          "backColor": "#fafafa",
          "id": "panel2",
          "hs": 4,
          "borderWidth": 1,
          "bandDecoration": true,
          "fillWidth": true,
          "resizable": false,
          "pt": 2,
          "height": 20,
          "frame": true,
          "layoutMode": "horizontal",
          "unselectable": true
        },
        {
          "type": "ui.hline",
          "fillWidth": true,
          "id": "hline2",
          "immovable": true,
          "bandDecoration": true,
          "sideBottom": true,
          "penStyle": "dashed",
          "weight": 2,
          "foreColor": "darkblue",
          "resizable": false,
          "unselectable": true
        }
      ],
      "id": "pagefooter1",
      "borderWidth": 0,
      "resizable-w": false,
      "pb": 2,
      "x": 0,
      "width": 1500,
      "borderColor": "darkblue",
      "height": 80,
      "type": "ui.pagefooter",
      "immovable": true,
      "band-type": "pagefooter"
    }
  ],
  "id": "bir1",
  "__layoutcode": "",
  "overflow": "visible",
  "type": "vert",
  "frame": true,
  "name": "bir1",
  "formType": "report"
};

		
		this.data={
			reportCreationType:"list",
			reportData:this.listReport
		};
		
	
		this.setStartPage(this.reportCreationTypeSelection);
		
	};
	icc.utils.inherit(reportWizard, icc.ui.wizardDialog);

    reportWizard.prototype.finishPressed = function(){
		this.data = icc.utils.clone(this.data);
		this.data.reportData.name = this.data.name;
		this.data.reportData.id = this.data.name;
		this.cb(true,this.data.reportData);
    };
	
    reportWizard.prototype.showModal = function(cb){
		var self=this;
		
		this.cb = cb;
		reportWizard.SUPERclass.showModal.call(this);
		this.onClose(function(){
			self.cb(false);
		});
    };
	reportWizard.prototype.pageReportName = function(){
		var self = this;
		
		<%FRAME:reportWizard.pageReportName%>
		
		txName.text = self.data.name;
										   
		
		txName.onChange(function(value){
		    
			if(icc.utils.isValidFilename(value) && icc.utils.isValidVariableName(value)){
				self.data.name = icc.utils.trim(value);
			}else{
				self.data.name = '';
				txName.displayMessage(icc.ui.message('invalid_filename',{description:_T('Invalid report name')}));
			}
			self.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		});
		this.setNext(undefined, true, self.data.name !== '' && self.data.name !== undefined);
		pageReportName.onCreate(function(){
			txName.setFocus();
		});
		return pageReportName;
    };
	reportWizard.prototype.reportCreationTypeSelection = function(){
		var self = this;
		self.setNext(undefined);
		<%FRAME:reportWizard.reportCreationTypeSelection%>
		
		
		optListReport.checked = self.data.reportCreationType === 'list';
		optCrossTable.checked = self.data.reportCreationType === 'crosstb';
		
		
		var updateNextPage = function(){
			
			switch(self.data.reportCreationType){
				case 'list':
					
					self.setNext(self.pageReportName);
				break;
				case 'crosstb':
				
					self.setNext(self.pageReportName);

				break;
				default:
					self.setNext(undefined);	
			}
		};
		optCrossTable.onChange(function(value){
			if(value){
				self.data.reportCreationType = 'crosstb';
				self.data.reportData = self.crossTable;
				updateNextPage();
			}
		});

		optListReport.onChange(function(value){
			if(value){
				self.data.reportCreationType = 'list';
				self.data.reportData = self.listReport;
				updateNextPage();
			}
		});		
		
		reportCreationTypeSelection.onCreate(function(){
			updateNextPage();
		});
		return reportCreationTypeSelection;
	};
	
    icc.ui.designer.reportWizard = reportWizard;
})(__icc__);




(function(icc){

	var reportFilterDialog = function (formDoc,appDoc){
		<%FRAME:rptDesignerAssets.filtersPanel%>
		var items = [];
		var dsitems = [];
		var filter;
		data = formDoc.getLayout();
		var filters = data.filters;
		segmentsPanel.childs = [];
		segmentsPanel.overflowy="scroll";
		orderPanel.childs = [];
		orderPanel.overflowy="scroll";
		var criteria_controls = [];
		var order_controls= [];
		
		

		var updateWhereLabel = function(){
			tx = ""
			var t = []
			var pcount = 0;
			var inspectForward = function(idx){
				var res = false;
				while (idx<filter.criteria.length && !res){
					if(	filter.criteria[idx].column !== undefined && 
						filter.criteria[idx].comparator !== undefined && 
						filter.criteria[idx].expr !== undefined && 
						filter.criteria[idx].expr !== '')
						res=true
					else
						idx++
				}
				return res;
			}
			jQuery.each(filter.criteria,function(idx,segment){
				if (segment.column !== undefined  && segment.comparator !== undefined && segment.expr !== undefined  && segment.expr !== ''){
					segment.open = segment.open == undefined ?"":segment.open;
					segment.close = segment.close == undefined ?"":segment.close;
					
					if (segment.open === "(" )
						pcount+=1
					else if(segment.open == "((")
						pcount+=2
					else if(segment.open == "(((")
						pcount+=3
						
						
					tx+=segment.open +" ";
//					if (segment.nullable)
//						tx+= "["

					tx+=segment.column +" ";
					var c= segment.comparator
					if (c == "%"){
						tx+='LIKE %'+segment.expr+"% ";
						
					}else{
						tx+=c+" ";
						tx+=segment.expr+" ";
					}
			
					
					tx+=segment.close;
					if (segment.close === ")" )
						pcount-=1
					else if(segment.close == "))")
						pcount-=2
					else if(segment.close == ")))")
						pcount-=3
						
					
//					if (segment.nullable && segment.close !== '')
//						tx+= "]"		

					if(inspectForward(idx+1))
						tx+=" "+segment.combinator+" ";
						
					if (segment.nullable && segment.close == '')
						tx+= "]"		
				}
			});
			if (pcount != 0){
				tx += _T(" -  Unbalanced parentheses");
			}
				
			lbFilterWhere.setCaption(tx);
			
		}		
		var cbColumnsItems = function(){
			var res = [];
			var item = cbFilterPanelDatasource.getItem();
			if(item){
				var dsdoc = new icc.ui.designer.datasourceDoc(appDoc.getVCCName(),appDoc.getId(),item.text);
				if (dsdoc.load()){
					jQuery.each(dsdoc.getFields(),function(idx,column){
						res.push({id:column.name,text:column.name,type:column.type});
					});
				}
			}
			return res;
		}
		cbFilterPanelDatasource.onChange(function(idx,text,item){
			jQuery.each(criteria_controls,function(idx,entry){
				var item = entry.cbcolumns.getItem();
				entry.cbcolumns.clearAll();
				entry.cbcolumns.addItem(cbColumnsItems());
				if(item){
					entry.cbcolumns.setItem(item.id);
					item = entry.cbcolumns.getItem();
					if (item){
						entry.seg.column = item.text;
						entry.seg.coltype = item.type;
					}else
						entry.seg.column=undefined;
					
				}
			});
			jQuery.each(order_controls,function(idx,entry){
				var item = entry.cbcolumns.getItem();
				entry.cbcolumns.clearAll();
				entry.cbcolumns.addItem(cbColumnsItems());
				if(item){
					entry.cbcolumns.setItem(item.id);
					item = entry.cbcolumns.getItem();
					if (item)
						entry.order_column.column = item.text;
					else
						entry.order_column.column=undefined;
				}
			});
			filter.datasource = item.text;
		});
		var showFilter = function ( ) {
			criteria_controls = [];
			order_controls= [];
	
			var enable_criteria_buttons = function(){
				if(filter){
					jQuery.each(criteria_controls,function(pos,criteria_entry){
						criteria_entry.rmv.setEnabled(pos>0 ||filter.criteria.length>1 );
						criteria_entry.add.setEnabled(true);
					});
				}
			}
			var enable_order_buttons = function(){
				if(filter){
					jQuery.each(order_controls,function(pos,order_entry){
						order_entry.rmv.setEnabled(pos>0 ||filter.order.length>1 );
						order_entry.add.setEnabled(true);
					});
				}
			}
			
			var buildOrderColumnWnd = function (order_column,pos){
				<%FRAME:rptDesignerAssets.orderColumn%>
				cbSortOrder.items = [
					{text:'ASC'},
					{text:'DESC'}
				];
			
				cbSortColumn.items = cbColumnsItems();
				cbSortColumn.item = 1;
				orderColumn.setColumn = function (column){
					if (column){
						cbSortColumn.setItem(column.column);
						cbSortOrder.setItem(column.order);
					}else{
						cbSortColumn.setItem(-1);
						cbSortOrder.setItem(-1);
					}
					cbSortColumn.setEnabled(column !== undefined);
					cbSortOrder.setEnabled(column !== undefined);
				}
				orderColumn.onCreate(function(){
					this.setColumn(order_column);
				});
				cbSortColumn.onChange(function(idx,text,item){
					order_column.column = text;
					updateWhereLabel(filter);
				});
	
				cbSortOrder.onChange(function(idx,text,item){
					order_column.order = text;
					updateWhereLabel(filter);
				});			
					
				btnAddOrderColumn.onClick(function(){
					var w;
					var pos = 0;
					var newCol = {order:'ASC'};
					while (filter.order[pos]!==order_column)pos++;
					pos++;
					filter.order.splice(pos,0,newCol);
					w = buildOrderColumnWnd(newCol,pos);
					w.create();
					orderPanel.addChild(w,pos);
					orderPanel.layout();
					enable_order_buttons();
					updateWhereLabel(filter);
				});
				btnRmvOrderColumn.onClick(function(){
					var pos = 0;
					while (filter.order[pos]!==order_column)pos++;
					
					filter.order.splice(pos,1);
					order_controls.splice(pos,1);
					orderPanel.rmvChild(orderColumn);
					orderPanel.layout();
					enable_order_buttons();
					updateWhereLabel(filter);
				});
				order_controls.splice(pos,0,{order_column:order_column,cbcolumns:cbSortColumn,add:btnAddOrderColumn,rmv:btnRmvOrderColumn});
				
				return orderColumn;
			};
			
			var buildFilterCriteriaWnd=function (segment,pos){
				var m_segment = segment;
				<%FRAME:rptDesignerAssets.filterSegment%>
				filterFrameColumn.borderWidth=0;
				filterFrameControls.borderWidth=0;
				cbfilterParamOpen.items = [
					{id:"",text:'&nbsp'},
					{id:"(",text:'('},
					{id:"((",text:'(('},
					{id:"(((",text:'((('}
				
				]
				cbfilterParamClose.items = [
					{id:"",text:'&nbsp'},
					{id:")",text:')'},
					{id:"))",text:'))'},
					{id:")))",text:')))'}
				]

				cbSegmentComparator.items = [
					{id:"==",text:'=='},
					{id:">",text:'>'},
					{id:">=",text:'>='},
					{id:"<",text:'<'},
					{id:"<=",text:'<='},
					{id:"%",text:'Like'}
				];
				cbSegmentCombinator.items = [
					{text:'AND'},
					{text:'OR'}
				];
				var posColumnFrame = function(){
					if(filterFrameColumn._identBase == undefined){
						filterFrameColumn._identBase = filterFrameColumn.x
					}
					filterFrameColumn.x = filterFrameColumn._identBase + (segment.ident * 30)
					if (filterSegment.getWnd()){
						filterSegment.layout();
					}
				}

				filterColumnName.items = cbColumnsItems();
				filterColumnName.item = filterColumnName.items[1];
				filterSegment.setSegment = function(segment){
					m_segment = segment;
					if (segment){
						filterColumnName.setItem(segment.column);
						cbSegmentComparator.setItem(segment.comparator);
						txFilterExpr.setText(segment.expr);
//						ckSegmentNullable.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
//						ckSegmentNullable.setChecked(segment.nullable && segment.expr !== undefined && segment.expr.substr(0,1)=='@' )

						cbSegmentCombinator.setItem(segment.combinator);
						
					}else{
						filterColumnName.setItem(-1);
						cbSegmentComparator.setItem(-1);
						txFilterExpr.setText("");
//						ckSegmentNullable.setChecked(false);
//						ckSegmentNullable.setEnabled(false);
						
						cbSegmentCombinator.setItem(-1);
					}
					filterColumnName.setEnabled(segment !== undefined);
					cbSegmentComparator.setEnabled(segment !== undefined);
					txFilterExpr.setEnabled(segment !== undefined);
					cbSegmentCombinator.setEnabled(segment !== undefined);
				};
				cbfilterParamOpen.item = segment.open;
				cbfilterParamOpen.onChange(function(idx,text,item){
					segment.open = item.id;
					updateWhereLabel(filter);
				});
				cbfilterParamClose.item = segment.close;
				cbfilterParamClose.onChange(function(idx,text,item){
					segment.close = item.id;
					updateWhereLabel(filter);
				});
				txFilterExpr.onChange(function(value){
					segment.expr=value;
//					ckSegmentNullable.setEnabled(segment.expr !== undefined && segment.expr.substr(0,1)=='@')
//					ckSegmentNullable.setChecked(segment.nullable && segment.expr !== undefined && segment.expr.substr(0,1)=='@')
					
					updateWhereLabel(filter);
				});
				filterColumnName.onChange(function(idx,text,item){
					segment.column = text;
					segment.coltype = item.type;
					updateWhereLabel(filter);

				});
				cbSegmentComparator.onChange(function(idx,text,item){
					segment.comparator = item.id;
					updateWhereLabel(filter);
				});
				cbSegmentCombinator.onChange(function(idx,text,item){
					segment.combinator = text;
					updateWhereLabel(filter);
				});
//				ckSegmentNullable.onChange(function(value){
//					segment.nullable = value;
//					updateWhereLabel(filter);
//				});
				
				btnAddSegment.onClick(function(){
					var w;
					var pos = 0;
					var newSeg = {combinator:'AND',open:'',close:'',nullable:true};
					while (filter.criteria[pos]!==segment)pos++;
					pos++;
					filter.criteria.splice(pos,0,newSeg);
					w = buildFilterCriteriaWnd(newSeg,pos);
					w.create();
					segmentsPanel.addChild(w,pos);
					segmentsPanel.layout();
					enable_criteria_buttons();
					updateWhereLabel(filter);
					
				});
				btnRemoveSegment.onClick(function(){
					var pos = 0;
					while (filter.criteria[pos]!==segment)pos++;
					
					filter.criteria.splice(pos,1);
					criteria_controls.splice(pos,1);
					segmentsPanel.rmvChild(filterSegment);
					segmentsPanel.layout();
					enable_criteria_buttons();
					updateWhereLabel(filter);

				});
				filterSegment.onCreate(function(){
					this.setSegment(m_segment);
				});
			
				criteria_controls.splice(pos,0,{seg:segment,cbcolumns:filterColumnName,add:btnAddSegment,rmv:btnRemoveSegment});
				return filterSegment;
			};
			segmentsPanel.rmvAll();
			orderPanel.rmvAll();
			if (filter){
				jQuery.each(filter.criteria,function(idx,segment){
					var w = buildFilterCriteriaWnd(segment,idx);
					w.create();
					segmentsPanel.addChild(w);
				});
				jQuery.each(filter.order,function(idx,column){
					var w = buildOrderColumnWnd(column,idx);
					w.create();
					orderPanel.addChild(w);
				});
				updateWhereLabel(filter);
			}else{
				var w = buildFilterCriteriaWnd(undefined,0);
				w.create();
				segmentsPanel.addChild(w);
				var w = buildOrderColumnWnd(undefined,0);
				w.create();
				orderPanel.addChild(w);
			}
			orderPanel.layout();
			segmentsPanel.layout();
			enable_criteria_buttons();
			enable_order_buttons();
			
		}
		btnClearFilterCriteria.onClick(function(){
			data.filters[0].criteria = [{comparator:'==',combinator:'AND',open:'',close:'',nullable:true}];
			showFilter(data.filters[0]);
			
		});
		btnClearOrderColumns.onClick(function(){
			data.filters[0].order = [{order:'ASC'}];
			showFilter(data.filters[0]);
			
		});
		
		filtersPanel.onCreate(function(){
			jQuery.each(appDoc.getDatasources({outstreams:true}),function(idx,dsEntry){
				dsitems.push({id:dsEntry.name,text:dsEntry.name})
			});
			cbFilterPanelDatasource.addItem(dsitems);
		
			if (!data.filters)
				data.filters = [];
			if(!data.filters[0])
				data.filters[0]={name:'default',isDefault:true,criteria:[{nullable:true,comparator:'==',combinator:'AND',open:'',close:''}],order:[{order:'ASC'}]};
			filter = data.filters[0]
			cbFilterPanelDatasource.setItem(filter.datasource);
			showFilter();
		});
		
		var dlg = new icc.ui.dialog({
			caption:_T('Report filter and parameters'),
			childs:[
				filtersPanel
			]
		})
		filterPanelOk.onClick(function(){
			formDoc.setLayout(data);
			dlg.close();
		});
		filterPanelCancel.onClick(function(){
			dlg.close();
		});
		
		return dlg;
	};


	var  reportView;
	var controls = [
		{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
			defaults:{
				"#pragma:hideNameProperty": true,
				caption:'label',
				width:120,
				height:20,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,		
				icc.ui.designer.controlproperties.caption,		
				{caption:'Print condition',type:'string',name:'printCondition'},				
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.align,
				icc.ui.designer.controlproperties.font,
				icc.ui.designer.controlproperties.multiLine
			]
		},
		{icon:'grandtotal.png',tooltip:_T('Grand total'),type:"grandtotal",constructor:icc.ui.reportgrandtotal,
			defaults:{
				
				caption:'{ xxxx }',
				width:120,
				height:20,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				
				icc.ui.designer.controlproperties.datasource,		
				icc.ui.designer.controlproperties.field,		
				{caption:'Format',type:'option',name:'format',values:[
					"integer",
					"fixed",
					"currency"
				]},
				{caption:'Print condition',type:'string',name:'printCondition'},				
				
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.align,
				icc.ui.designer.controlproperties.font,
				icc.ui.designer.controlproperties.multiLine
			]
		},
		{icon:'formula.png',tooltip:_T('Formula'),type:"formula",constructor:icc.ui.reportformula,
			defaults:{
				
				caption:'{ formula }',
				width:120,
				height:20,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				{caption:'Expresion',type:'string',name:'expresion'},
				{caption:'Initial value',type:'string',name:'initialValue'},
				{caption:'Print condition',type:'string',name:'printCondition'},
				{caption:'Format',type:'option',name:'format',values:[
					"integer",
					"fixed",
					"currency",
					"date",
					"datetime"
				]},
				
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.align,
				icc.ui.designer.controlproperties.font,
				icc.ui.designer.controlproperties.multiLine
			]
		},
		
		{icon:'app_icon.png',tooltip:_T("Datasource field"),type:"ui.reportfield",constructor:icc.ui.reportfield,
			defaults:{
				"#pragma:hideNameProperty": true,
				width:130,
				height:20
			},
			properties:[
				icc.ui.designer.controlproperties.datasource,		
				icc.ui.designer.controlproperties.field,		
				{caption:'Format',type:'option',name:'format',values:[
					"integer",
					"fixed",
					"currency",
					"date",
					"datetime"
				]},
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.geometry,		
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.align,
				icc.ui.designer.controlproperties.font,
				icc.ui.designer.controlproperties.multiLine
				
				
			]


		},
		
		
		{type:"ui.reportheader",constructor:icc.ui.fixedLayoutDesigner
		,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'},
			    {caption:'Page break',type:'bool',name:'breakAfter','false-is-undefined':true}
			]
			
		},
		{type:"ui.pageheader",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'}

			]
			
		},
		{type:"ui.pagefooter",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'}

			]
			
		},
		{type:"ui.groupheader",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[

				{caption:'Group by',type:'custom',name:'groupBy',customfn:function(document,ctrlData,cb){
					<%FRAME:assets.groupColumns%>
					var items = icc.utils.clone(ctrlData.groupBy?ctrlData.groupBy.columns:[])
					var applicationDoc = document.getApplicationDocument()
					var loadDatasources = function(){
					
						jQuery(applicationDoc.getDatasources()).each(function(idx,dsEntry){
							var p = {id:dsEntry.name,text:dsEntry.name}
							gDatasourcesCombo.addItem(p)
						});
					
						if(ctrlData.groupBy){
							var hcolumns = {}
							jQuery(ctrlData.groupBy.columns).each(function(idx,name){
								hcolumns[name]=true;
							})
							gDatasourcesCombo.setItem(ctrlData.groupBy.datasourceName?ctrlData.groupBy.datasourceName:"");
							if(gDatasourcesCombo.getItem()){
							
								var newDoc = new icc.ui.designer.datasourceDoc(applicationDoc.getVCCName(),applicationDoc.getId(),ctrlData.groupBy.datasourceName);
								newDoc.load(function(status,result){
									if(status){
										jQuery(newDoc.getFields()).each(function(idx,fld){
											if(!hcolumns[fld.name]){
											
												gSrcColumns.addItem({
													caption:fld.name,
													field:fld,
													fieldName:newDoc.getName() + "." + fld.name,field:fld})
											}
										});
									}
									gSrcColumns.setEnabled(true);
									gColumnsGrid.setEnabled(true);
									gDatasourcesCombo.setEnabled(true);
									
								});			
								jQuery(ctrlData.groupBy.columns).each(function(idx,name){
									gColumnsGrid.addItem({caption:name});
								});
							}else{
								gSrcColumns.setEnabled(true);
								gColumnsGrid.setEnabled(true);
								gDatasourcesCombo.setEnabled(true);
								
							}
						}else{
							gSrcColumns.setEnabled(true);
							gColumnsGrid.setEnabled(true);
							gDatasourcesCombo.setEnabled(true);
						}
					}
					
					var dlg = new icc.ui.dialog({
						childs:[
							groupColumns
						]
					});
					dlg.create();
					dlg.showModal();
					dlg.onCreate(function(){
						loadDatasources();
					});
					gDatasourcesCombo.onChange(function(index,text,item){
						gSrcColumns.clearAll();
						gColumnsGrid.clearAll();
						var newDoc = new icc.ui.designer.datasourceDoc(applicationDoc.getVCCName(),applicationDoc.getId(),text);
						newDoc.load(function(status,result){
							if(status){
								
								jQuery(newDoc.getFields()).each(function(idx,fld){
									gSrcColumns.addItem({
										caption:fld.name,
										field:fld,
										fieldName:newDoc.getName() + "." + fld.name,field:fld})
								});

							}
						});			
						
					});
					
					gSrcColumns.onChange(function(item){
						gColumnsAdd.setEnabled(item !== undefined);
					});
					gColumnsGrid.onChange(function(item){
						gColumnsDelete.setEnabled(item !==undefined);
						gColumnsMoveUp.setEnabled(gColumnsGrid.getIndex()>0);
						gColumnsMoveDown.setEnabled(gColumnsGrid.getIndex()<gColumnsGrid.getItems().length-1);
					
					});
					
					gColumnsAdd.onClick(function(){
						gColumnsGrid.addItem(gSrcColumns.getItem())
						gSrcColumns.rmvItem(gSrcColumns.getItem());
						gColumnsAdd.setEnabled(false);
						gColumnsMoveUp.setEnabled(gColumnsGrid.getIndex()>0);
						gColumnsMoveDown.setEnabled(gColumnsGrid.getIndex()<gColumnsGrid.getItems().length-1);
						
					});
					gColumnsDelete.onClick(function(){
						gSrcColumns.addItem(gColumnsGrid.getItem())
						gColumnsGrid.rmvItem(gColumnsGrid.getItem());
						gColumnsDelete.setEnabled(false);
						gColumnsMoveUp.setEnabled(gColumnsGrid.getIndex()>0);
						gColumnsMoveDown.setEnabled(gColumnsGrid.getIndex()<gColumnsGrid.getItems().length-1);
						
					});
					gColumnsCancel.onClick(function(){
						dlg.close();
					});
					gColumnsOk.onClick(function(){
						var res = {columns:[]}
						if(gDatasourcesCombo.getItem()){
							res.datasourceName = gDatasourcesCombo.getItem().text;
							jQuery.each(gColumnsGrid.getItems(),function(idx,item){
								res.columns.push(item.caption);
							});
						}
						cb(res);
						dlg.close();
					});
					gColumnsMoveUp.onClick(function(){
					
						var item;
						var idx = gColumnsGrid.getIndex();
						if(idx>0){
							var items = icc.utils.clone(gColumnsGrid.getItems());
							item = items[idx]
							items[idx]=items[idx-1]
							items[idx-1]=item;
							gColumnsGrid.clearAll();
							gColumnsGrid.addItem(items);
							gColumnsGrid.setIndex(idx-1);
							gColumnsMoveUp.setEnabled(gColumnsGrid.getIndex()>0);
							gColumnsMoveDown.setEnabled(gColumnsGrid.getIndex()<items.length-1);
						}
					
					});
					gColumnsMoveDown.onClick(function(){
						var items = icc.utils.clone(gColumnsGrid.getItems());

						var item;
						var idx = gColumnsGrid.getIndex();
						if(idx<items.length-1){
							item = items[idx]
							items[idx]=items[idx+1]
							items[idx+1]=item;
							gColumnsGrid.clearAll();
							gColumnsGrid.addItem(items);
							gColumnsGrid.setIndex(idx+1);
							
							gColumnsMoveUp.setEnabled(gColumnsGrid.getIndex()>0);
							gColumnsMoveDown.setEnabled(gColumnsGrid.getIndex()<items.length-1);
							
						}
						
					});
					
				}},
				{caption:'Print condition',type:'string',name:'printCondition'}

				
			]
			
		},
		{type:"ui.reportdetails",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Odd color',type:'color',name:'oddColor'},
				{caption:'Even color',type:'color',name:'evenColor'},
				{caption:'Print condition',type:'string',name:'printCondition'}
			]
			
		},

		{type:"ui.groupfooter",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'},
			    {caption:'Page break',type:'bool',name:'breakAfter','false-is-undefined':true}
			]
			
		},
		
		
		{type:"ui.reportfooter",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'}
			]
			
		},
		
	
		{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
				"#pragma:hideNameProperty": true,
				width:320,
				height:200,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,		
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor
		
			]
		},
		
		{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
		
			defaults:{
				"#pragma:hideNameProperty": true,

				width:90
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.style,
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.penstyle,
				icc.ui.designer.controlproperties.weight			
			]
			
		},
		{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
			defaults:{
				"#pragma:hideNameProperty": true,

				height:80
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.style,
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.penstyle,
				icc.ui.designer.controlproperties.weight			
			]
			
		
		},
		{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
			defaults:{
				"#pragma:hideNameProperty": true,
				height:100,
				width:160,
				borderWidth:1,
				borderColor:'gray'
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,		
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.image
				
			]
		}
	];
	reportView = function(mainFrame,formDoc){
		
		// crea el mapa para acceder rapidamente por type
		var self = this;
		this.controls_map = {};
		
		var toolBoxButtons = [];
		var tool;
		var ctrlInfo;
		
//		this.codeEditor = new icc.ui.codeeditor({x:-10000,fillWidth:true,fillHeight:true,multiLine:true,text:formDoc.getCodeBehind(),lineNumbers:true,language:"javascript",borderColor:'#dedede'});
/*		
		var dataTab = new icc.ui.panel({
			fillWidth:true,fillHeight:true,
			caption:'Data',
			backColor:'#f4f4f4',
			pt:26,
			childs:[
				new icc.ui.hline({fillWidth:true,foreColor:'lightGray'}),
				
//				this.codeEditor
			]
		})
*/		
		this.previewWindow = this.previewWindow(formDoc.getName());
		this.previewWindow.caption = _T("Preview");
		
		for (var idx=0;idx<controls.length;idx++){
			
			ctrlInfo = controls[idx];
			this.controls_map[ctrlInfo.type]=ctrlInfo; 

			if(ctrlInfo.icon){
				tool = new icc.ui.designerTool({
					style:"applications.designer/toolbarbutton",
				    icon:ctrlInfo.icon,
					tooltip:ctrlInfo.tooltip
				});
				tool.onRequestDropData((function(info){
					return function(){
						// crea una nueva instancia del control usando un el info de tipo
						var ctrldata = info.defaults;// data a guardar en el doc
						if(!ctrldata){
							ctrldata = {};
						}else{
							ctrldata = icc.utils.clone(ctrldata);
						}
						ctrldata.type = info.type;
						//-------------------
						// Aca se traducen siempre los labels de los controles mientras 
						// a los mismos se les realiza "drag & drop" desde la barra de herramientas hacia el formulario.
						if (ctrldata.caption) {
							ctrldata.caption = _T(ctrldata.caption);
						}
						if (ctrldata.type === "ui.tabpanel") {
							$.each(ctrldata.childs || [], function(_, tab) {
								if (tab.caption) {
									tab.caption = _T(tab.caption);
								}
							});
						}
						//-----------------
						var ctrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName());
						ctrl.create();
						return ctrl;
					};
				})(ctrlInfo));
				toolBoxButtons.push(tool);

			}
		}
		var args = formDoc.getLayout();
		
		args.fillWidth=true;
		args.fillHeight=true;
	//	args.borderWidth=1;
	//	args.borderColor="#d7d7d7";
		
		if(args.childs !==undefined){
		
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],formDoc.getApplicationDocument().getName());
			}
		}
		
		this.mainPanel =new icc.ui.fixedLayoutDesigner(args)
		this.goUserCode(formDoc.getLayoutCode(),c,formDoc);
		this.designerHost = new icc.ui.designerHost({
			fillWidth:true,
			fillHeight:true,
			borderWidth:0,
			childs:[
				this.mainPanel
				//new icc.ui.panel(args)
			]
		});
		// Cambio de la seleccion actual , recibe una array
		this.designerHost.onSelectionChanged(function(newselection){

			formDoc.updateAllViews(this,"selection",newselection);
			
		});
		// Cuando se presiona delete el designerHost borra el control y dispara este evento
		this.designerHost.onRmvControl(function(ctrl,parent){
			formDoc.rmvControl(ctrl.id);
			formDoc.setDirty(true);
			formDoc.updateAllViews(this,"selection",[]);// con esto logra que la ventana de propiedades se borre

		});
		
		// Luego de que el usuario suelta el control se dispara este evento 
		// y se agrega efectivamente al documento.
		this.designerHost.onNewControl(function(ctrl,parent,undo){
			var node,parentNode;
			var properties = ctrl.getProperties(formDoc);
			var pr;
			
			parentNode = formDoc.findControl(parent.id);
			formDoc.addControl(ctrl.id,ctrl.persistentData,parentNode);
			// agrega la info de layout,en caso de ser un tabitem no tiene, porque no esta wrapeado
			if(typeof ctrl.getLayoutInfo === "function")
				formDoc.setControlData(ctrl.id,ctrl.getLayoutInfo());
			else
				formDoc.setControlData(ctrl.id,{});
			formDoc.setDirty(true);
			if(typeof undo === "undefined" || undo === false)
				formDoc.updateAllViews(this,"selection",[ctrl]);

		});
		this.designerHost.onDrag(function(data,pos,tgt){
			if(tgt && data.type == "field"){
				var d = tgt.childs?tgt:tgt.parent
				var	parentNode = formDoc.findControl(d.id);

				var pos = d.screenToClient(pos);
				var ctrl = {
					type:'ui.reportfield',
					field:data.field.name,
					datasource:data.datasourceName,
					"#pragma:hideNameProperty": true,
					caption:"{ "+data.field.name + " }",
					x:pos.x,
					y:pos.y,
					width:120,
					height:15
					
				}
				var ctrl = self.buildControl(ctrl,self.getDocument().getApplicationDocument().getName());
				ctrl.create();
				d.addChild(ctrl);
				formDoc.addControl(ctrl.id,ctrl.persistentData,parentNode);
				self.designerHost.clearSelection();
				self.designerHost.addToSelection(ctrl);
				formDoc.updateAllViews(self,"selection",[ctrl]);
				d.layout();
				self.designerHost.showSelection();
				formDoc.setDirty(true);
				
				
			}
		});
		// Cuando cambia de position se updatea el documento, recibe la lista
		// de controles movidos y el nuevo contenedor si es que hubo cambio.
		this.designerHost.onChangeCtrlPosition(function(ctrllist,newParent){
			var node,parentNode;
			for (var idx =0;idx < ctrllist.length;idx++){
				if(newParent){
					parentNode = formDoc.findControl(newParent.id);
					node = formDoc.findControl(ctrllist[idx].id);
					formDoc.rmvControl(ctrllist[idx].id);
					formDoc.addControl(ctrllist[idx].id,node,parentNode);
					formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
				}else{
					formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
				}
			}
			formDoc.updateAllViews(this,"poschanged",ctrllist);
			self.getDocument().setDirty(true);
		});
		// Se produjo un cambio en el zOrder de algun/os controles
		// dentro de un contenedor , los quita todos y los vuelve a inserar acorde
		// al orden de parent.childs
		this.designerHost.onZOrderChanged(function(parent){
		    // obtenemos todos los hijos del nodoparent correspondiente al parent
		    var nchilds = {};
		    var node,parentNode;
		    parentNode= formDoc.findControl(parent.id);
		    for (var idx=0;idx<parent.childs.length;idx++){
			nchilds[parent.childs[idx].id]=formDoc.findControl(parent.childs[idx].id,parentNode);
			formDoc.rmvControl(parent.childs[idx].id);
		    }
		    for (idx=0;idx<parent.childs.length;idx++){
				formDoc.addControl(parent.childs[idx].id,nchilds[parent.childs[idx].id],parentNode);
		    }
		    self.getDocument().setDirty(true);

		});
		
		// crea el panel de campos y lo rellena con designerTools 
		
		var addReportBand =function(caption,height,icon, bandType, pos ){
			var newCtrl;
			var ctrldata = {
				type:"ui."+bandType,
				"band-type":bandType,
				"borderWidth": 0,
				"width": 895,
				"x": 0,
				"#pragma:hideNameProperty": true,
				"borderColor": "darkblue",
				"height": height,
				"immovable": true,
				"resizable-w": false,
				"pb":2,
				childs:[
					{
						"type": "ui.panel",
						"bandDecoration":true,
						"layoutMode":"horizontal",
						"hs":4,
						"pt":2,
						"childs": [
						{
							"type": "ui.image",
							"borderWidth": 0,
							"image": "!"+icon,
							"height": 16,
							"width":16
							
						},						
						{
							"type": "ui.label",
							"borderWidth": 1,
							"caption": caption,
							"height": 20
						}],
						"backColor": "#fafafa",
						"borderWidth": 1,
						"fillWidth":true,
						"height": 20,
						"frame":true,
						"resizable": false,
						"unselectable": true
						
					},				
				
					{
						"type": "ui.hline",
						"bandDecoration":true,
						"fillWidth": true,
						"sideBottom":true,
						"immovable": true,
						"penStyle": "dashed",
						"weight": 2,
						"foreColor": "darkblue",
						"resizable": false,
						"unselectable": true
					}
				]
			};
			newCtrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName());
			newCtrl.create();
			formDoc.addControl(newCtrl.id,ctrldata,formDoc.content,pos);
			self.mainPanel.addChild(newCtrl,pos);
			self.mainPanel.layout();
			self.designerHost.setSelection(newCtrl);
			self.getDocument().setDirty(true);// Esto se hace al final para que se prenda correctamente el boton deshacer

		
		}		
		
		btnaddReportHeader = new icc.ui.button({caption:'',tooltip:_T('Add report header'),icon:'!reportheader.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnaddPageHeader = new icc.ui.button({caption:'',tooltip:_T('Add page header'),icon:'!pageheader.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnaddGroupHeader = new icc.ui.button({caption:'',tooltip:_T('Add group header'),icon:'!groupheader.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnaddDetails = new icc.ui.button({caption:'',tooltip:_T('Add Report details band'),icon:'!reportdetails.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnaddGroupFooter = new icc.ui.button({caption:'',tooltip:_T('Add group footer'),icon:'!groupfooter.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnaddPageFooter = new icc.ui.button({caption:'',tooltip:_T('Add page footer'),icon:'!pagefooter.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnaddReportFooter = new icc.ui.button({caption:'',tooltip:_T('Add report footer'),icon:'!reportfooter.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		btnsetFilterCriteria = new icc.ui.button({caption:'',tooltip:_T('Set filter and sort criteria'),icon:'filter.png',width:22,height:22,style:"applications.designer/toolbarbutton"});

		btnaddReportHeader.onClick(function(){
			addReportBand("Report header",80,"reportheader.png","reportheader",0);
		});
		btnsetFilterCriteria.onClick(function(){
			var dlg = new reportFilterDialog(formDoc,formDoc.getApplicationDocument());
			dlg.create();
			dlg.showModal();
		});
	
		
		btnaddPageHeader.onClick(function(){
			var c = formDoc.content.childs;
			var pos;
			jQuery(c).each(function(idx,cl){
				if(	cl['band-type'] == "reportfooter" || 
					cl['band-type'] == "groupfooter"  ||
					cl['band-type'] == "groupheader"  ||
					cl['band-type'] == "reportdetails" ){
					pos = idx;
					return false;
				}
			});
			addReportBand("Page header",60,"pageheader.png","pageheader",pos);
		});

		btnaddGroupHeader.onClick(function(){
			var c = formDoc.content.childs;
			var pos;
			jQuery(c).each(function(idx,cl){
				if(	cl['band-type'] == "reportfooter" || 
					cl['band-type'] == "groupfooter"  ||
					cl['band-type'] == "reportdetails" ){
					pos = idx;
					return false;
				}
			});
			addReportBand("Group header",80,"groupheader.png","groupheader",pos);
		});
		btnaddDetails.onClick(function(){
			var c = formDoc.content.childs;
			var pos;
			jQuery(c).each(function(idx,cl){
				if(	cl['band-type'] == "reportfooter" || 
					cl['band-type'] == "pagefooter"  ||
					cl['band-type'] == "groupfooter" 
				){
					pos = idx;
					return false;
				}
					
			});
			addReportBand("Details",80,"reportdetails.png","reportdetails",pos);
		});

		btnaddGroupFooter.onClick(function(){
			var c = formDoc.content.childs;
			var pos;
			jQuery(c).each(function(idx,cl){
				if(	
					cl['band-type'] == "pagefooter" ||
					cl['band-type'] == "reportfooter" 
					
				){
				
					pos = idx;
					return false;
				}
			});
			addReportBand("Group footer",80,"groupfooter.png","groupfooter",pos);
		});
		

		btnaddPageFooter.onClick(function(){
			var c = formDoc.content.childs;
			var pos;
			
			jQuery(c).each(function(idx,cl){
				if(cl['band-type'] == "reportfooter"){
					pos = idx;
					return false;
				}
			});
			addReportBand("Page footer",60,"pagefooter.png","pagefooter",pos);
		});
		
		btnaddReportFooter.onClick(function(){
			var c = formDoc.content.childs;
			var pos;
			jQuery(c).each(function(idx,cl){
				if(	
					cl['band-type'] == "pagefooter" 
				){
				
					pos = idx;
					return false;
				}
			});
	
			addReportBand("Report footer",80,"reportfooter.png","reportfooter",pos);
		});
		
		var designerPanel = new icc.ui.panel({
		    fillWidth:true,
		    fillHeight:true,
		    x:0,y:0,
		    pl:2,pr:6,pb:6,pt:2,
			caption:_T('Design'),
		    backColor:'#f4f4f4',
		    borderWidth:0,
		    childs:[
				new icc.ui.panel({
				   fillWidth:true,
				   layoutMode:'horizontal',
				   pl:45,
				   
				   childs:[
					new icc.ui.panel({
						pt:2,
						layoutMode:'horizontal',
						childs:[
							new icc.ui.framework.documentView.stdButtonCopy(mainFrame,{caption:'',tooltip:_T('Copy'),icon:'copyIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonPaste(mainFrame,{caption:'',tooltip:_T('Paste'),icon:'pasteIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonUndo(mainFrame,{caption:'',tooltip:_T('Undo'),icon:'undoIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"})
						]
					}),
					new icc.ui.designer.AlignToolbar(formDoc,{}),
					
					new icc.ui.panel({
						pt:2,
						pl:4,
						hs:2,
						layoutMode:'horizontal',
						childs:[
							btnaddReportHeader,
							btnaddPageHeader,
							btnaddGroupHeader,
							btnaddDetails,
							btnaddGroupFooter,
							btnaddPageFooter,
							btnaddReportFooter,
							btnsetFilterCriteria
						]
					})
				   ]

				}),
				new icc.ui.panel({

					fillWidth:true,
					fillHeight:true,
					pl:1,
					pr:2,
					hs:2,
					
					backColor:'#f4f4f4',
					borderColor:'#dedede',

					layoutMode:'horizontal',
					childs:[
						new icc.ui.panel({
							fillHeight:true,
							vs:3,
							childs:[
								new icc.ui.panel({layoutMode:'matrix',pr:3,vs:3,hs:3,columns:1,borderWidth:0,childs:toolBoxButtons})
							]
						
						}),
						this.designerHost
					]

				})/*,
				new icc.ui.hline({fillWidth:true})*/
		    ]
		});
		var cntx = new icc.ui.tabpanel(	{
		    fillWidth:true,
		    fillHeight:true,
			align:'right',
		    childs:[
				this.previewWindow,
//				dataTab,
				designerPanel
				
		    ],
			item:1
		});
		cntx.onChange(function(index,item){
			if(item === self.previewWindow)
				self.previewWindow.start();
		});
		jQuery(cntx.childs).each(function(idx,cl){
			cl.captionWidth=70;
		});
		reportView.SUPERconstructor.call(this,formDoc,{
			haveCloseButton:true,
			caption:formDoc.getName(),
			fillWidth:true,
			fillHeight:true,
			layoutMode:'horizontal',
			style:'applications/designer.designerFrame',
			backColor:'#f4f4f4',
			
			pt:2,
			pr:2,
			pl:5,
			pb:2,
			childs:[
			    new icc.ui.panel({fillHeight:true,borderWidth:0,fillWidth:true,
				
				vs:5,
				childs:[
//				    new icc.ui.panel({layoutMode:'horizontal',sideRight:true,childs:[optionLayout,optionCode]}),
				    cntx

				]
			    })
			]
		});
		/*
		this.codeEditor.onChange(function(text){
			formDoc.setCodeBehind(text);
		});
	*/
		cntx.onCreate(function(){
			self.designerHost.childs[0].getWnd().background = "red";
//			setTimeout(function(){
				
				//self.codeEditor.x=0;
				//self.codeEditor.parent.layout();
//				cntx.setItem(2);
//			},300);
		});

	
	};
	icc.utils.inherit(reportView,icc.ui.framework.documentView.view);
	reportView.prototype.getSelection = function() {
		// traslada la seleccion del designerHost
		return this.designerHost.getSelection();
	};
	reportView.prototype.buildControl = function(ctrlData,appName){
		var map_data = this.controls_map[ctrlData.type];
		var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true}
		if(!ctrlData.id){
			ctrlData.id = this.getDocument().generateControlId(ctrlData.type);
		}

		var args = {};
		for (var idx in ctrlData){
			if(ctrlData.hasOwnProperty(idx)){
				args[idx]= ctrlData[idx];
			}
		}
		args._appName =appName;
		if(ctrlData.childs){
			var childs = [];
			for ( idx=0;idx<ctrlData.childs.length;idx++){
				childs.push(this.buildControl(ctrlData.childs[idx],appName));
			}
			args.childs = childs;
		}
		args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
		if(map_data){
			var ctrl = new map_data.constructor(args,env);
			// hay que pisar el getProperties ya que no hay manera de tener paneles con 
			// propiedades diferentes
			// solo para los que tienen band-type = algo
			if (map_data.properties){
				ctrl.getProperties = function(){
					return map_data.properties
				}
			}else{
				if (!ctrl.getProperties){
					ctrl.getProperties = function(){
						return []
					}
				}
			}
			/*
			if(args['band-type']){
				ctrl.getProperties = function(){
						return [
							icc.ui.controlproperties.backColor
						//	{caption:'Background',type:'image',name:'background'}
						];
				}
			}
			*/
			return ctrl;
		}else{
			return new icc.ui.panel(args);
		}
	};
	reportView.prototype.haveCopyPasteInfo=function(){
		return this.designerHost.getSelection().length!==0;
	};
	reportView.prototype.getCopyPasteInfo=function(){
		var res;
		if(this.designerHost.getSelection().length!==0){
			var doc = this.getDocument();
			res = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				node = doc.findControl(ctrl.id);
				res.push(icc.utils.clone(node));
			});
		}
		return res;
	};
	reportView.prototype.acceptCopyPasteInfo = function(info){
		// de momento solo se puede copiar dibujos asi que esto es siempre true
		
		return true;
	};
	// paste
	reportView.prototype.setCopyPasteInfo = function(info){
		var self = this;
		var doc = self.getDocument();
		info = icc.utils.clone(info);
		var fixPastedId = function(node){
			if(doc.checkControlId(node.type,node.id)){
				node.id = doc.generateControlId(node.type,true);

			}
			if(node.childs){
				jQuery.each(node.childs,function(idx,node){
					fixPastedId(node);
				});
			}
			
		}
		var build_pasted_control_tree = function (ctrlData,appName){
			
			var map_data = self.controls_map[ctrlData.type];
			var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true}

			var args = {};
			for (var idx in ctrlData){
				if(ctrlData.hasOwnProperty(idx)){
					args[idx]= ctrlData[idx];
				}
			}
			args._appName =appName;
			if(ctrlData.childs){
				var childs = [];
				for ( idx=0;idx<ctrlData.childs.length;idx++){
					childs.push(build_pasted_control_tree(ctrlData.childs[idx],appName));
				}
				args.childs = childs;
			}
			args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
			if(map_data){
				return new map_data.constructor(args,env);
			}else{
				return new icc.ui.panel(args);
			}
		};
		var build_pasted_control= function(ctrlData,appName){
			self.getDocument().addControl(ctrlData.id,ctrlData,self.getDocument().findControl(self.getDocument().getName()));
			return build_pasted_control_tree(ctrlData,appName);
		};
			
		var ctrls = [];
		jQuery.each(info,function(idx,nodeinfo){
			fixPastedId(nodeinfo);
			var c = build_pasted_control(nodeinfo,self.getDocument().getApplicationDocument().getName());
			ctrls.push(c);
			c.create();
			self.mainPanel.addChild(c);
			// esto es medio contra mano pero ...
			self.designerHost.addUndoAction(function(){
				self.designerHost.clearSelection();
				self.mainPanel.rmvChild(c);
				self.mainPanel.layout();
				self.designerHost.fireEvent("onRmvControl",c,self.mainPanel);
			});
			
		});
		self.mainPanel.layout();
		this.designerHost.setSelection(ctrls);
		self.getDocument().setDirty(true);// Esto se hace al final para que se prenda correctamente el boton deshacer
		return true;
	};
	
	reportView.prototype.getUndoCount = function(){
		return this.designerHost.getUndoCount();
	};
	reportView.prototype.goUndo = function(){
		this.designerHost.goUndo();
		this.getDocument().setDirty(true);
	};
	reportView.prototype.goUserCode = function (src,layout,docInstance){
		var self = this;
		var maskedEval = function (scr,ctx) { 
				// set up an object to serve as the context for the code 
				// being evaluated.  
				var mask = {}; 
				// mask global properties  
		//		for (p in this) 
		//			mask[p] = undefined; 
				for (p in ctx){
					mask[p] = ctx[p];
				}
				// execute script in private context 
				try{
				(new Function( "with(this) { " + scr + "}")).call(mask); 
				}catch(e){
					alert(e);
				}
				
		} 		
		var mapControl = function (control,ctx){
			ctx[control.id] = control;
			if (control.childs){
				jQuery.each(control.childs,function(idx,control){
					mapControl(control,ctx);
				})
			}
		}
		var ctx = {
			thisForm:layout,
			designer:true,
			docInstance:docInstance
		}
		mapControl(layout,ctx)
		maskedEval(src,ctx);
	};
	reportView.prototype.previewWindow = function(reportName){
		var cntx;
		var self = this;
		var started = false;
		var params;
		var res = new icc.ui.panel({
			fillWidth:true,
			fillHeight:true,
			pr:6,
			pl:2,
			pb:4,
			backColor:'#f4f4f4',
			pt:3,
			childs:[
				
				
			]
		});
		
		res.refresh = function(){
			if(cntx)
				res.rmvChild(cntx);
				
			cntx =  new icc.ui.reportpanel({
				fillWidth:true,
				fillHeight:true,
				reportName:reportName,
				runAtStart:true,
				_appName:self.getDocument().getApplicationDocument().getName()
			});
			cntx.create();
			res.addChild(cntx);
			res.layout();

		};
		res.start = function(){
			if(!started)
				res.refresh();
			started=true;
		};
		res.onCreate(function(){
			params = self.getDocument().getExecutionParameters();
		});
		return res;
	};
	
	reportView.prototype.onUpdate = function(sender,hint,data){
		var self = this;
		if(hint==="control-properties"){				// fueron seteadas las propiedades de un control
											// data tiene la forma de {ctrl:ctrl,properties:nuevosdatos}
			var newCtrl;						// No tenemos manera de que todos los controles dispongan de sus propiedades en tiempo de ejecucion
			var selection;					// por lo tanto destruimos el control y lo volvemos a crear en el lugar
			var childs =  [];
			var tchilds;
			var ctrl = data.ctrl.visibleControl?data.ctrl.visibleControl:data.ctrl;
			if(data.name === "childs"){
				// aca hay que hacer algo para optimizar , solo regenerar los childs sin regenerar todo
			}else{
				if(ctrl.childs && data.properties.childs){						// las sacamos del control
					for(var idx=ctrl.childs.length-1;idx>=0;idx--){	// hacia atras porque data.ctrl.childs se va alterando al remover
					
						childs.unshift(ctrl.childs[idx]);				// guarda una copia del control que saca
																			// unshift para mantener el mismo orden en que estaban
						ctrl.rmvChild(ctrl.childs[idx],false);	
						
					}
				}
				tchilds = data.properties.childs;// guardamos los childs para restorear despues
				data.properties.childs = null;		// no queremos que regenere todos los controles hijos de nuevo

			}
			newCtrl = this.buildControl(data.properties,this.getDocument().getApplicationDocument().getName());
			if(tchilds!==undefined)
				data.properties.childs = tchilds;// mantenemos la identidad del doc .
			newCtrl.create();
			if(childs.length){						// las agregamos al nuevo control
				for(idx=0;idx<childs.length;idx++){
					newCtrl.addChild(childs[idx]);
				}
				newCtrl.layout();
			}
			//Cuando seleccionamos un control y vamos tocando sus propiedades 
			// el control que viene en data siempre es el mismo
			// llevamos un track en visibleWidget del control que tenemos realmente insertado en el dibujo
			// que despues de la primera vez es distinto al que viene en data
			// como el control tocado esta seleccionado, borramos el dibujo de los handlers
			ctrl.parent.drawUnselected(this.designerHost,ctrl);
			// Cambiamos el control original por el nuevo
			ctrl.parent.replaceChild(ctrl,newCtrl);
			var sel = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				sel.push(ctrl);
			});
			this.designerHost.addUndoAction(function(){
				var d={};
				d[data.name]=data.prevValue;
				self.designerHost.selection = sel;
				self.getDocument().setControlData(ctrl.id,d);
				newCtrl.parent.drawUnselected(self.designerHost,newCtrl);
				newCtrl.parent.replaceChild(newCtrl,ctrl);
				ctrl.parent.drawSelected(self.designerHost,ctrl);
			});
			
			// obtenemos el array de seleccion del dibujador y cambiamos tambien ahi el control
			selection = this.designerHost.getSelection();
			for (idx = 0;idx<selection.length;idx++){
				if(selection[idx] === ctrl){
					selection[idx]=newCtrl;
				}
			}
			// este es el que tenemos insertado		
			data.ctrl.visibleControl = newCtrl;
			// redibujamos todo y volvemos a prender los handlers que pueden estar ahora en distinta posicion
			// si el control cambio de tamaño por algo
			newCtrl.parent.layout();
			newCtrl.parent.drawSelected(this.designerHost,newCtrl);		
			
		}else if (hint === "document-properties") {
			// propiedades del documento cambiaron lo creamos de nuevo
			this.designerHost.clearSelection();
			this.getDocument().updateAllViews(this,"selection",[]);
			var args = this.getDocument().getLayout();
			args.fillWidth=true;
			args.fillHeight=true;
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],this.getDocument().getApplicationDocument().getName())
			}			
			
			var cl = new icc.ui.fixedLayoutDesigner(args)
			cl.onCreate(function(){	// con esto evitamos que se ejecute el onCreate normal del form
				cl.fireEvent("onInitialize");
				return false;
			});
			cl.onInitialize = function(cb){
				cl.addListener("onInitialize",cb);
			}

			this.goUserCode(this.getDocument().getLayoutCode(),cl,this.getDocument());

			cl.create();
			this.designerHost.rmvChild(this.designerHost.childs[0])
			this.designerHost.addChild(cl);
			this.designerHost.layout();
		}
	};
	icc.ui.designer.reportView = reportView;
})(__icc__);



/*jslint evil:true */
/*global __icc__:true,_T:true */

(function(icc){

	var sourceItemDlg = function(document,ctrlData,cb){
		var applicationDatasources = function (){
			var i;
			var sourceItems = [];
			var datasources = document.getApplicationDocument().getDatasources();
			for (i=0;i<datasources.length;i++){
				sourceItems.push({
					id:datasources[i].name,
					text:datasources[i].name
				}); 
			}
			return sourceItems;
		}
		var getAvailableDatasources = function (cb){
			var items = applicationDatasources();
			document.getApplicationDocument().readSystemDatasources(function(status,result){
				if(status && result.length > 0 ){	
					items.push({id:'inConcert',text:"    --  inConcert -- "})
					for (n in result){
						items.push({id:result[n],text:result[n]});
					}
				}
				cb(true,items);
			});

			
		}
		<%FRAME:rptDesignerAssets.sourceDataPanel%>
		var source = icc.utils.clone(ctrlData.source || {sourceType:"recordCount",dataValid:'always',fieldDataOperation:'sum'});
		var comboFields = [[cbTimeScaleField,"timeStamp"],[cbSubcategoryField,"subCategoryField"],[cbFieldName,"fieldName"],[cbValidField,"validFieldName"]];
        var fillFields = function (datasourceName){
			var n;
            var dsdoc = new icc.ui.designer.datasourceDoc(document.getApplicationDocument().getVCCName(),document.getApplicationDocument().getId(),datasourceName);
            dsdoc.load(function(status){
                if(status){
                    var items = [];

                    var fields = dsdoc.getFields();
                    for (n =0;n<fields.length;n++){
                        items.push({
                            text:fields[n].name,
                            id:fields[n].name
                        });
					}
					jQuery.each(comboFields,
						function(){
							this[0].clearAll();
							this[0].addItem(items);
							this[0].setItem(source[this[1]]);
						}
					)
                }else{
					jQuery.each(comboFields,
						function(){
							this[0].clearAll();
						}
					)

                }
            });
        };
		var mapcomboField = function ( combo, propertyName){
			combo.onChange(function(idx,text,item){
				source[propertyName]=text;
			})
		}
		jQuery.each(comboFields,function(){
			mapcomboField(this[0],this[1])
		});
		var updateDlgStatus = function(){
			var item = cb_sourceDataDatasource.getItem() != undefined;
			
			opRecordCount.setEnabled(item );
			opFieldData.setEnabled(item );
			cbFieldName.setEnabled(item && source.sourceType == "fieldData");
			opSum.setEnabled(item && source.sourceType == "fieldData");
			opMin.setEnabled(item && source.sourceType == "fieldData");
			opMax.setEnabled(item && source.sourceType == "fieldData");
			opAverage.setEnabled(item && source.sourceType == "fieldData");
			opAlways.setEnabled(item);
			opField.setEnabled(item);
			opExpr.setEnabled(item);
			cbValidField.setEnabled(item && source.dataValid == "field");
			cbValidFieldOp.setEnabled(item && source.dataValid == "field");
			txValidFieldExpr.setEnabled(item && source.dataValid == "field");
			txValidExpr.setEnabled(item && source.dataValid == "expr");
			
			cbTimeScaleField.setEnabled(item);
			cbSubcategoryField.setEnabled(item);
			btsubCatClear.setEnabled(item);
			btDatasourceClear.setEnabled(item);
			
			
			
		}
		
		var mapfieldDataOperation = function (option,operationName){
			option.checked = source.fieldDataOperation == operationName ;
			option.onChange(function(value){
				if(value)
					source.fieldDataOperation = operationName;
			})
		};
		
//		cb_sourceDataDatasource.items = applicationDatasources();
		
		opRecordCount.checked = source.sourceType == "recordCount";
		opRecordCount.onChange(function(value){
			if(value){
				source.sourceType = "recordCount";	
				updateDlgStatus();
			}
		});
		opFieldData.checked = source.sourceType == "fieldData";
		opFieldData.onChange(function(value){
			if(value){
				source.sourceType = "fieldData";	
				updateDlgStatus();
			}
		});
		opAlways.checked = source.dataValid == "always";
		opAlways.onChange(function(value){
			if(value){
				source.dataValid = "always"
				updateDlgStatus();
			}
		});
		opField.checked = source.dataValid == "field"
		opField.onChange(function(value){
			if(value){
				source.dataValid = "field"
				updateDlgStatus();
			}
		});
		opExpr.checked = source.dataValid == "expr"
		opExpr.onChange(function(value){
			if(value){
				source.dataValid = "expr"
				updateDlgStatus();
			}
		});
		cbValidFieldOp.items = [
			{id:"==",text:'=='},
			{id:"!=",text:'!='},
			
			{id:">",text:'>'},
			{id:">=",text:'>='},
			{id:"<",text:'<'},
			{id:"<=",text:'<='},
			{id:"%",text:'Like'}
		];
		cbValidFieldOp.item = source.dataValidFieldOperator;
		cbValidFieldOp.onChange(function(idx,text,item){
			source.dataValidFieldOperator = item.id;
		});
		txValidFieldExpr.text = source.dataValidFieldExpr;
		txValidFieldExpr.onChange(function(value){
			source.dataValidFieldExpr = value;
		});
		txValidExpr.text = source.dataValidExpr;
		txValidExpr.onChange(function(value){
			source.dataValidExpr = value;
		});
		
		mapfieldDataOperation(opSum,"sum");
		mapfieldDataOperation(opMax,"max");
		mapfieldDataOperation(opMin,"min");
		mapfieldDataOperation(opAverage,"avg");
		
		btsubCatClear.onClick(function(){
			source.subCategoryField = undefined;
			cbSubcategoryField.setItem(-1);
			updateDlgStatus();
		});
		
		btDatasourceClear.onClick(function(){
			source.datasource = undefined;
			cb_sourceDataDatasource.setItem(-1);
			updateDlgStatus();
		})
		cb_sourceDataDatasource.onChange(function(idx,text,item){
			if (item.id != "inConcert"){
				source.datasource = text;
				fillFields(text);
				updateDlgStatus();
			}else{
				cb_sourceDataDatasource.setItem(idx+1);
				source.datasource = undefined;
				updateDlgStatus();
			}
		});
		
		var dlg = new icc.ui.dialog({
			caption:_T('Source data'),
			childs:[
				sourceDataPanel
			]
		});	
		
		bt_sourceDataOK.onClick(function(){
			source.scaleFields = {timeStamp:source.timeStamp}
			dlg.close();
			cb(source)
		});
		bt_sourceDataCancel.onClick(function(){
			dlg.close();
			cb()
		});
		dlg.onCreate(function(){
			getAvailableDatasources(function(status,result){
				if(status){
					
					cb_sourceDataDatasource.addItem(result);
					cb_sourceDataDatasource.setItem(source.datasource);
					if(cb_sourceDataDatasource.getItem()==undefined){
						updateDlgStatus();
						if(source.datasource){
							cb_sourceDataDatasource.setText(_T("(missing) ") +  source.datasource);
						}
					}else{
						fillFields(cb_sourceDataDatasource.getText());
						updateDlgStatus();
					}
							
				}
			})
		});
		dlg.create();
		dlg.showModal();
	}
	
	var reportParamsDialog = function (formDoc,appDoc){
		<%FRAME:rptDesignerAssets.paramsDialog%>
		var inputParams = [];
		
		var dlg = new icc.ui.dialog({
			caption:_T(''),
			childs:[
				paramsDialog
			]
		})
		gdParams.onChange(function(item){
			btUp.setEnabled(item!==undefined && this.getIndex()>0);
			btDn.setEnabled(item!==undefined && this.getIndex()<this.getItems().length-1);
		
			if(item){
				txCaption.setEnabled(true);
				txCaption.setText(item.caption || "");
				txWidth.setEnabled(true);
				txWidth.setText(item.width || "");
				txInitialValue.setEnabled(true);
				txInitialValue.setText(item.initialValue || "");
				cbFormat.setEnabled(true);
				cbFormat.setItem(item.format || "");
				if(item.nullable){
					ckHidden.setEnabled(true);
					ckHidden.setChecked(item.hidden || false);
				}else{
					ckHidden.setEnabled(item.initialValue != undefined);
					ckHidden.setChecked(item.initialValue != undefined && (item.hidden || false));
				}
			}
		});
		btUp.onClick(function(){
			var item;
			var idx = gdParams.getIndex();
			if(idx>0){
				item = inputParams[idx]
				inputParams[idx]=inputParams[idx-1]
				inputParams[idx-1]=item;
				gdParams.clearAll();
				gdParams.addItem(inputParams);
				gdParams.setIndex(idx-1);
				btUp.setEnabled(gdParams.getIndex()>0);
				btDn.setEnabled(gdParams.getIndex()<inputParams.length-1);
			}
		})
		btDn.onClick(function(){
			var item;
			var idx = gdParams.getIndex();
			if(idx<inputParams.length-1){
				item = inputParams[idx]
				inputParams[idx]=inputParams[idx+1]
				inputParams[idx+1]=item;
				gdParams.clearAll();
				gdParams.addItem(inputParams);
				gdParams.setIndex(idx+1);
				btUp.setEnabled(gdParams.getIndex()>0);
				btDn.setEnabled(gdParams.getIndex()<inputParams.length-1);
			}
		})

		txCaption.onChange(function(value){
			gdParams.getItem().caption = value.length?value:undefined;
		});
		txWidth.onChange(function(value){
			gdParams.getItem().width = value.length?parseInt(value):undefined;
		});
		txInitialValue.onChange(function(value){
			var item = gdParams.getItem()
			item.initialValue = value.length?value:undefined;
			if (!item.nullable){
				if(item.initialValue == undefined){
					item.hidden = false;
					ckHidden.setChecked(false);
					ckHidden.setEnabled(false);
				}else{
					ckHidden.setEnabled(true);
				}
			}
			
		});
		cbFormat.items = [
			{id:"__undefined",text:icc.utils.combobox_nbsp},
			{id:"integer",text:"integer"},
			{id:"date",text:"date"},
			{id:"datetime",text:"datetime"},
			{id:"fixed",text:"fixed"},
			{id:"currency",text:"currency"}
		];
		cbFormat.onChange(function(idx,text,item){
			
			gdParams.getItem().format = item.id!="__undefined"?text:undefined;

		});
		ckHidden.onChange(function(value){
			gdParams.getItem().hidden = value;
		});
		btnParamsOk.onClick(function(){
			var data = formDoc.getLayout();
			data.paramsSettings = {}
			var items = gdParams.getItems();
			for ( n in items){
				var item = items[n]
				data.paramsSettings[items[n].expr] = {
					index:parseInt(n),
					caption:item.caption,
					width:item.width,
					format:item.format,
					hidden:item.hidden,
					initialValue:item.initialValue
				}
			}
			
			formDoc.setLayout(data);
			dlg.close();
		});
		btnParamsCancel.onClick(function(){
			dlg.close();
		});
		dlg.onCreate(function(){

			var datasources = [];
			var paramKey = {}
			var formData = formDoc.getLayout();
			for (n in formData.childs) {
				var band = formData.childs[n];
				if (band['band-type'] ==  "reportdetails"){

					for (n in band.childs[0].childs){
						var row = band.childs[0].childs[n];
						if  (row.source && row.source.datasource){
							datasources.push(row.source.datasource);
						}
					}
				}
			}
			var loadNextDatasource = function(){
				var dsname = datasources.shift();
				if(dsname){
				
					var dsdoc = new icc.ui.designer.datasourceDoc(appDoc.getVCCName(),appDoc.getId(),dsname);
					dsdoc.load(function(status,dsdata){
						if (status){
							if (dsdata.description.retrieve.enabled){
								//-- buscamos los parametros de retrieve que
								//-- sean obligatorios
								for (n in dsdata.description.retrieve.inputParams){
									var param = dsdata.description.retrieve.inputParams[n];
									var found = false;

									if (param.column){
										
										for (n in
											(((dsdata.description.filters || [{}])[0] || {}).criteria || {})
											)
										{
											var criteria =(((dsdata.description.filters || [{}])[0] || {}).criteria || {})[n];
											if (param.column == criteria.column){
												if (criteria.expr && criteria.expr.substr(0,1) == "@" && !paramKey[criteria.expr]){ 
													paramKey[criteria.expr]=true;
													inputParams.push({column:"",nullable:param.allowNull && criteria.nullable,coltype:param.type,comparator:"==",expr:criteria.expr,index:inputParams.length})
												}
												found = true;
											}
										}
									}
									if (!found && !param.allowNull){
										if  (!paramKey[param.name]) {
											paramKey[param.name] = true
											inputParams.push({column:"",coltype:param.type,nullable:false,comparator:"==",expr:param.name,index:inputParams.length})
										}
									}
								}
							}
						}
						loadNextDatasource();
					})
					
				}else{
					if(formData.paramsSettings){
						for(n in inputParams){
							var param = inputParams[n];
							var paramData = formData.paramsSettings[param.expr];
							if (paramData){
								for(n in paramData)
									param[n] = paramData[n];
							}
						}
						
					}
					inputParams.sort(function (a,b){
						return a.index - b.index
					})
					gdParams.addItem(inputParams)

				}
			
			}
			loadNextDatasource();
			
		});
		return dlg;
	};

	


	

	//"Hourly","Daily","Weekly","Fortnight","Monthly","Bimonthly","Quarterly","Semiannually","Yearly"
	var days = [_T("Sunday"),_T("Monday"),_T("Tuesday"),_T("Wednesday"),_T("Thursday"),_T("Friday"),_T("Saturday")];
	var months = [_T("January"),_T("February"),_T("March"),_T("April"),_T("May"),_T("June"),_T("July"),_T("August"),_T("September"),_T("October"),_T("November"),_T("December")];

	var daysInMonth = function (y,m){
		return new Date(y,m,0).getDate();
	};
	var dayOfYear = function(dt){
		var onejan = new Date(dt.getFullYear(),0,1);
		return Math.ceil((dt - onejan) / 86400000);
	};
	icc.ui.themes.base.timeLineControl = {
		backColor:'transparent',
		foreColor:'black',
		borderColor:'#a0a0a0',
		borderWidth:1,
		overflow:'hidden',
		opacity:100,
		borderStyle:'solid',
		nc_left:0,
		nc_right:0,
		nc_top:0,
		nc_bottom:0,
		
		daysOddColor:'white',
		daysEvenColor:'lightgray',
		dailyTotalBackColor:'#fafffa',
		hoursOddColor:'white',
		hoursEvenColor:'lightgray',

		monthsOddColor:'white',
		monthsEvenColor:'lightgray',
		monthlyTotalBackColor:'lightgray',
		yearsOddColor:'white',
		yearsEvenColor:'lightgray'
		
	};
	var timeLineControl = function (args,environment){

		timeLineControl.SUPERconstructor.call(this,args,environment,"timeLineControl");
		if(!this.hourly && !this.daily && !this.monthly && !this.yearly)
			this.daily = true;
		this.columns = [];
		this.ts = this.timeScale(300);
		this.childs=[
			this.ts
//			new icc.ui.hline({foreColor:'lightGray',fillWidth:true,offsetY:-1})
		]
	}
	icc.utils.inherit(timeLineControl,icc.ui.panel);
	
	timeLineControl.prototype.create = function(){
		var res = timeLineControl.SUPERclass.create.call(this);
		return res;
	}
	
	timeLineControl.prototype.layout = function(){
	
		if(this.prevWidth != this._w ){
			//console.log("LAYOUT "+this._w);
			var newts = this.timeScale(this._w)
			newts.create();
			if(this.ts)
				this.replaceChild(this.ts,newts)
			else
				this.addChild(newts)
				
				
			this.ts = newts;
			timeLineControl.SUPERclass.layout.call(this);			
			this.prevWidth = this._w;	
		}else
			timeLineControl.SUPERclass.layout.call(this);
	}
	
	
	
	timeLineControl.prototype.getHeaderHeight = function(){
		var t = 0
		for (n in this.ts.childs){
			if (n < this.ts.childs.length-1)
				t+= this.ts.childs[n]._h
		}
		return t;
	}
//	timeLineControl.prototype.getDefaultHeight = function(){
//		
//	};	
	timeLineControl.prototype.getColumns = function(){
		return this.columns;
	}
	timeLineControl.prototype.timeScale = function (maxWidth,startTime){
		var self = this;
		var spaceLeft;
		var hourCellWidth = 40;
		var dayCellWidth = 40;
		var dailyTotalCellWidth = 70;
		var dayOfWeekCellWidth = 80; // para cuando es dayOfWeek
		var monthCellWidth=40;
		var monthlyTotalCellWidth=70;
		var yearCellWidth=40;
		var yearlyTotalCellWidth=70;
		var monthCellWidthWithName=80;
		var grandTotalCellWidth=70;

		var hoursCount=0;
		var daysCount=0;
		var monthsCount=0;
		var yearsCount=0;
		var bandHeight=14;
		var hoursPanel;
		var daysPanel;
		var monthsPanel;
		var yearsPanel;
		var firstMonthCellWidth; // para calcular el desplazamiento de la linea de tiempo en años
		var insertTotal = function(w,a){
			var tg
			for (n in a){
				if(a[n]!==undefined)
					tg = a[n];
			}
			tg.childs.push(w);
			for (n in a){
				if(tg!=a[n] && a[n]!=undefined){
					a[n].childs.push(new icc.ui.label({caption:_T("."),sideBottom:true,align:'center',width:w.width,foreColor:w.backColor,backColor:w.backColor}));
				}
			}
		}
		if (startTime == undefined)
			startTime = new Date();//icc.utils.ISO2Date("2012-02-25 22:30:00");
		var dateCounter = new Date(startTime.getTime())
		var res = new icc.ui.panel({fillWidth:true,fillHeight:true,borderBottom:true,borderWidth:1,offsety:-1,borderColor:'lightGray'});
		
		if(this.yearly)
			yearsPanel = new icc.ui.panel({hs:0,pl:0,height:bandHeight,width:maxWidth,borderWidth:0,layoutMode:'horizontal'})			
		if (this.monthly)
			monthsPanel = new icc.ui.panel({hs:0,pl:0,height:bandHeight,width:maxWidth,borderWidth:0,layoutMode:'horizontal'})
		if(this.daily)
			daysPanel = new icc.ui.panel({pl:0,hs:0,height:bandHeight,width:maxWidth,borderWidth:0,layoutMode:'horizontal'})
		if(this.hourly)
			hoursPanel = new icc.ui.panel({hs:0,pl:0,height:bandHeight,width:maxWidth,borderWidth:0,layoutMode:'horizontal'});

		spaceLeft = maxWidth;
		var dateCounter = new Date(startTime.getTime())
		var pd,pm,py;
		var dayCol,monthCol,yearCol;
		var firstHourOfDay = true;
		var firstDayOfMonth=true;
		if(this.grandTotal){
			insertTotal(
				new icc.ui.label({caption:_T("Total"),multiLine:true,sideBottom:true,align:'center',width:grandTotalCellWidth,backColor:'white'}),
				[yearsPanel,monthsPanel,daysPanel,hoursPanel]
			)
		}
		
		while(spaceLeft>0){
			var y = dateCounter.getFullYear();
			var m = dateCounter.getMonth();
			var d = dateCounter.getDate();
			var h = dateCounter.getHours();
			
			if((this.daily || this.hourly || this.monthly) && this.yearlyTotals && py != y){
				
				insertTotal(
					new icc.ui.label({caption:_T("Total of the year"),multiLine:true,sideBottom:true,align:'center',width:yearlyTotalCellWidth,backColor:yearsCount%2==0?this.yearsOddColor:this.yearsEvenColor}),
					[yearsPanel,monthsPanel,daysPanel,hoursPanel]
				)
				if(!this.yearly)
					py=y;
			}				

			if(this.yearly && py != y){
				py=y;
				if(this.hourly || this.daily || this.monthly)
					yearCellWidth=0;
				yearCol = new icc.ui.label({caption:''+y,align:'center',sideBottom:true,width:yearCellWidth,backColor:yearsCount%2==0?this.yearsOddColor:this.yearsEvenColor})
				
				
				yearsPanel.childs.push(yearCol)		
				yearsCount++;
			}

			if((this.daily || this.hourly) && this.monthlyTotals && pm != m){
				insertTotal(
					new icc.ui.label({caption:_T("Total of the month"),multiLine:true,align:'center',sideBottom:true,width:monthlyTotalCellWidth,backColor:monthsCount%2==0?this.monthsOddColor:this.monthsEvenColor}),
					[monthsPanel,daysPanel,hoursPanel]
				)
				if(!this.monthly)
					pm=m;
			}				
			
			if(this.monthly && pm != m){
				pm=m;
				if(this.hourly || this.daily)
					monthCellWidth=0;
				else
					if(this.monthName)
						monthCellWidth=monthCellWidthWithName;
				if (this.monthName){
					monthCol = new icc.ui.label({caption:months[m],align:'center',sideBottom:true,width:monthCellWidth,backColor:monthsCount%2==0?this.monthsOddColor:this.monthsEvenColor})
				}else{
					monthCol = new icc.ui.label({caption:''+(m+1),align:'center',sideBottom:true,width:monthCellWidth,backColor:monthsCount%2==0?this.monthsOddColor:this.monthsEvenColor})
				}	
				monthsPanel.childs.push(monthCol)		
				monthsCount++;
			}

			if(this.hourly && this.dailyTotals && pd!=d){
				insertTotal(new icc.ui.label({caption:_T("Total of the day"),multiLine:true,sideBottom:true,align:'center',width:dailyTotalCellWidth,backColor:daysCount%2==0?this.daysOddColor:this.daysEvenColor}),
					[daysPanel,hoursPanel]
				)
				if(!this.daily)
					pd=d;
			}				
			
			if(this.daily && pd != d){
				pd=d;
				if(this.hourly)
					dayCellWidth=0;
				else
					if(this.dayOfWeek)
						dayCellWidth=dayOfWeekCellWidth;
						
				if (this.dayOfWeek){
					var dw = dateCounter.getDay();
					dayCol = new icc.ui.label({toolTip:days[dw]+ " "+d,sideBottom:true,caption:days[dw]+ " "+d,align:'center',width:dayCellWidth,backColor:daysCount%2==0?this.daysOddColor:this.daysEvenColor});
				}else{
					dayCol =  new icc.ui.label({caption:''+d,align:'center',sideBottom:true,width:dayCellWidth,backColor:daysCount%2==0?this.daysOddColor:this.daysEvenColor});
				}	
				
				
				daysPanel.childs.push(dayCol)
				daysCount++;
			}
			
			
			
			if(this.hourly){
				hoursPanel.childs.push(new icc.ui.label({caption:''+h,align:'center',sideBottom:true,width:hourCellWidth,backColor:hoursCount%2==0?this.hoursOddColor:this.hoursEvenColor}));
				if(dayCol)
					dayCol.width+=hourCellWidth;
					
				if(monthCol){
					monthCol.width+=hourCellWidth;
					if(this.dailyTotals && firstHourOfDay)
						monthCol.width+=dailyTotalCellWidth;
				}
				if(yearCol){
					yearCol.width+=hourCellWidth;
					if(this.dailyTotals && firstHourOfDay)
						yearCol.width+=dailyTotalCellWidth;
						
					if(this.monthlyTotals && firstHourOfDay)
						yearCol.width+=monthlyTotalCellWidth;
					
				}
				hoursCount++;
				spaceLeft-=hourCellWidth;
				dateCounter.setHours(h+1);
				firstHourOfDay=dateCounter.getHours()==0;
				
			}else if(this.daily){
			
				if(monthCol){
					monthCol.width+=dayCellWidth;
				}
				
				if(yearCol){
					yearCol.width+=dayCellWidth;
					if(this.monthly && this.monthlyTotals && firstDayOfMonth)
						yearCol.width +=monthlyTotalCellWidth;
				}
				
				spaceLeft-=dayCellWidth;
				dateCounter.setDate(d+1);
				firstDayOfMonth=dateCounter.getDate()==1;
			}else if(this.monthly){
				if(yearCol){
					yearCol.width+=monthCellWidth;
					//if(this.yearlyTotals && firstMonthOfYear)
					
				}
				spaceLeft-=monthCellWidth;
				dateCounter.setMonth(m+1);
				firstMonthOfYear = dateCounter.getMonth()==0;
			}else if(this.yearly){
				spaceLeft-=yearCellWidth;
				dateCounter.setFullYear(y+1);
			}
				
		}
		
		if(yearsPanel)
			res.childs.push(yearsPanel)
		
		if(monthsPanel)
			res.childs.push(monthsPanel)
			
		
			
		if(daysPanel)
			res.childs.push(daysPanel);
			
		if(hoursPanel)
			res.childs.push(hoursPanel);
		var reslayout = res.layout 
		var linePanel = new icc.ui.panel({
			fillWidth:true,
			fillHeight:true
		})

		res.childs.push (
			linePanel
		);
		
		res.layout = function (){
			reslayout.call(this);
			var lines = [];
			var coords = {};
			
			for (idx in res.childs){
				var row = res.childs[idx]
				for (c in row.childs){
					var cell = row.childs[c]
					if(cell._x > 0){
						if(!coords[cell._x])
							coords[cell._x]=1;
						else
							coords[cell._x]++;
						
					}
				}
			};
			var columns=[];
			for (n in coords){
				columns.push(parseInt(n));
			}
			self.columns = columns.sort(function(a,b){ return a-b});
			
/*			
			var colors = ['#f0f0f0','#D0D0D0','#B0B0B0','#909090']
			for (x in coords){
				lines.push(new icc.ui.vline({fillHeight:true,x:parseInt(x)-3,y:0,foreColor:colors[coords[x]-1]}));
			}
			var p = new icc.ui.panel({
				fillWidth:true,
				fillHeight:true,
				childs:lines
			});
			p.create();
			if (linePanel.childs[0]){
				linePanel.replaceChild(linePanel.childs[0],p);
			}else
				linePanel.addChild(p);
			
			linePanel.layout();
			*/
		}
		
		return res;
	}
	var biRow = function (args){
		biRow.SUPERconstructor.call(this,args)
		this.isRow = true;
	};
	icc.utils.inherit(biRow,icc.ui.label);
	biRow.prototype.getProperties = function(formDoc){
		var res=[
			icc.ui.designer.controlproperties.geometry,
			{caption:'Column Data',type:'custom',name:'source',customfn:sourceItemDlg},
			
			icc.ui.designer.controlproperties.caption,
			{caption:'Expresion',type:'string',name:'expresion'},
			
			{caption:'Format',type:'option',name:'format',values:[
				"integer",
				"fixed",
				"currency",
				"percent"
			]},
			{caption:'Decimals',type:'integer',name:'decimals'},
			{caption:'Group settings',type:'group',
				brief_fn:function(data){
					var res = "";
					if (data['grandTotal'])
						res = res +"grandtotal"
					if (data['showPercent']){
						if (res.length)
							res = res +";";
						res = res + "percent";	
					}
					if (data['header']){
						if (res.length)
							res = res +";";
						res = res + "header";	
					}
					
					return res;
				},
				childs:[
					{caption:'Grand total',type:'bool',name:'grandTotal'},
					{caption:'Percent ',type:'bool',name:'showPercent'},
					{type:'endgroup'}
				]
			},
			{caption:'Header ',type:'bool',name:'header'},
			{caption:'Visible',type:'bool-true',name:'rowvisibility'},
			icc.ui.designer.controlproperties.foreColor,
			icc.ui.designer.controlproperties.backColor,
			icc.ui.designer.controlproperties.font,
		]
		
		return res;
		
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	var rowContainer = function(args){
		args.overflow = "visible";
		args.pl = 1;
		rowContainer.SUPERconstructor.call(this,args);
		this.hlines = []
	}
	
	icc.utils.inherit(rowContainer,icc.ui.vertLayoutDesigner);
	rowContainer.prototype.setScale = function (newScale,captionWidth){
		this.m_scale = newScale;
		this.m_captionWidth = captionWidth;
		icc.console.log("SET SCALE " + this.m_scale);
	}
	rowContainer.prototype.layout = function(){
		icc.console.log("LAYOUT ");
		rowContainer.SUPERclass.layout.call(this);
		var cols=this.m_scale.getColumns();
		cols.splice(0,1,0);
		for (n in this.hlines){
			this.wnd.removeChild(this.hlines[n]);
		}
		this.hlines = [];
		
		var box = icc.utils.makeElement("div",true);
		box.style.position = "absolute";
		box.style.top = -1 +"px";
		box.style.height = this.pt +"px";
		box.style.left = "-20px";
		box.style.width = "20px";
		
//		box.style.borderTop = "1px solid lightGray";
		box.style.borderRight = "1px solid lightGray";
		box.style.background = "#fafafa";
		this.wnd.appendChild(box);
		
		
		var ln = icc.utils.makeElement("div",true);
		ln.innerHTML = "&nbsp;"
		ln.style.position = "absolute";
		ln.style.height = "1px";
		ln.style.background = "lightGray";
		ln.style.width =  (this._w+20)+"px";
		ln.style.left = "-20px";
		ln.style.top = this.pt-1  +"px";
		
		this.wnd.appendChild(ln);
		
		this.hlines.push(ln);
		var lastY = this.pt;
		for (n in this.childs) {
			var child = this.childs[n]
			if(child.uiclass != 'hline'){
			
				ln = icc.utils.makeElement("div",true);
				ln.innerHTML = "&nbsp;"
				ln.style.position = "absolute";
				ln.style.height = "1px";
				ln.style.background = "lightGray";
				ln.style.width =  (child._w +20)+ "px";
				ln.style.left = "-20px";
				ln.style.top = child._y+child._h;
				ln.style.zIndex=10000;

				this.wnd.appendChild(ln);
				this.hlines.push(ln);
				
				var box = icc.utils.makeElement("div",true);
				box.style.position = "absolute";
				box.style.fontFamily = "arial,sans-serif";
				box.style.textAlign = "center";
				box.style.fontSize = "10px";
				box.style.color = "black";
				
				box.innerHTML = "R"+(parseInt(n)+1);
				box.style.top = child._y-1 +"px";
				box.style.height = child._h +"px";
				box.style.left = "-20px";
				box.style.width = "20px";
				if(n==0)
					box.style.borderTop = "1px solid lightGray";
				else
					box.style.borderTop = "1px solid #fafafa";
				box.style.borderBottom = "1px solid lightGray";
				box.style.borderRight = "1px solid lightGray";
				
				box.style.background = "#fafafa";
				
				this.wnd.appendChild(box);
				this.hlines.push(box);
				if(child.isRow){
					for (n in cols){
						x = cols[n]+this.m_captionWidth-20;
						ln = icc.utils.makeElement("div",true);
						ln.innerHTML = "&nbsp;"
						ln.style.position = "absolute";
						ln.style.width = "1px";
						ln.style.background = "lightGray";
						ln.style.height =  (child._h)+ "px";
						ln.style.zIndex=10000;
						ln.style.left = x+"px";
						ln.style.top = child._y + "px";
						this.wnd.appendChild(ln);
						this.hlines.push(ln);
						
					}
					
				}
				 
				lastY = child._y+child._h;
				
			}
		}
		var box = icc.utils.makeElement("div",true);
		box.style.position = "absolute";
		box.style.top = lastY+1 +"px";
		box.style.height = (this._h-lastY) +"px";
		box.style.left = "-20px";
		box.style.width = "20px";
		box.style.borderRight = "1px solid lightGray";
		box.style.background = "#fafafa";
		this.wnd.appendChild(box);
		
	}
	
	var biDesigner=function(args){
	
		biDesigner.SUPERconstructor.call(this,args,"biDesigner");
		var self = this;
		this.rowWidth = this.rowWidth!=undefined?this.rowWidth:150;
		this.rowContainer = this.childs[0]
		
		if(!this.rowContainer){
			this.rowContainer = new icc.ui.panel({});
			this.rowContainer.setScale = function(){}
		}
			
		this.bandDecoration=new icc.ui.panel({fillWidth:true,pt:2,backColor:'#fafafa',borderWidth:1,layoutMode:'horizontal',hs:4,
			childs:[
				new icc.ui.image({height:16,width:16,image: "!reportdetails.png"}),
				new icc.ui.label({caption: _T("Details")})
				
				
			]
		})
		this.rowContainer.y = 21;
		this.rowContainer.x = 0;

//		this.rowContainer.childs.splice(0,0,new icc.ui.hline({x:-21,fillWidth:true,frame:true,unselectable:true,foreColor:'lightGray',offsety:-1}));
		this.ts = new timeLineControl({
			x:this.rowWidth+3,
			y:21,
			borderWidth:0,
			hourly:this.hourly,

			daily:this.daily,
			monthly:this.monthly,
			yearly:this.yearly,
			monthlyTotals:this.monthlyTotals,
			dailyTotals:this.dailyTotals,
			yearlyTotals:this.yearlyTotals,
			dayOfWeek:this.dayOfWeek,
			monthName:this.monthName,
			grandTotal:this.grandTotal,
			fillWidth:true
			
		})
		this.bottomLine = new icc.ui.hline({fillWidth:true,weight:2,foreColor:'darkBlue',penStyle:'dashed',sideBottom:true})
		var tslayout = this.ts.layout;
		this.rowContainer.setScale(this.ts,this.rowWidth);
		this.ts.layout = function(){
			tslayout.call(this)
			self.vline.height = self.ts.getHeaderHeight();
			self.rowContainer.pt = self.ts.getHeaderHeight();
			self.rowContainer.layout();
			
		}
		this.vline = new icc.ui.vline({height:100,y:21,x:this.rowWidth,foreColor:'lightGray'})
		
		this.layoutChilds = [
			this.bandDecoration,
			
			this.rowContainer,
			this.ts,
			this.vline,

			this.bottomLine
		]
		this.documentChilds =[
			this.rowContainer
		]
		this.childs = this.layoutChilds
	}
	icc.utils.inherit(biDesigner,icc.ui.panel);
	
	
	biDesigner.prototype.create = function (){
		biDesigner.SUPERclass.create.call(this)
		this.childs = this.documentChilds;
	}

	biDesigner.prototype.hitTest = function ( position,exclude ) {
		var item = this.rowContainer;
		var hit = item.hitTest(position,exclude);
		return hit?hit:{parent:this.parent,type:"client",tgt:item}
	}

	biDesigner.prototype.findContainerAt = function(position,exclude){
		var res
		var item = this.rowContainer;
		if(item){
			res = item.findContainerAt(position,exclude);
			if(res)
				return res
			else
				return item;
		}
	}
	
	biDesigner.prototype.getCustomHandlers = function(){
		var self = this;
		return [{number:10,x:this._x+self.rowWidth-1,y:this._y+12,width:3,height:14,cursorName:"w-resize",
			
			stillResizing:function(handler,toposition){
				if(Math.abs(self.rowWidth -toposition.x)>5){
					self.rowWidth = toposition.x,
					self.vline.x = self.rowWidth;
					self.ts.x = self.rowWidth+3;
					self.rowContainer.setScale(self.ts,self.rowWidth);
					self.layout();
				}
			}
			
		}]
	}
	
	biDesigner.prototype.layout = function(){
		this.childs = this.layoutChilds;
		this.vline.height = this.rowContainer.pt//-21;
		this.rowContainer.height = this._h;
		this.rowContainer.x = 22;
		this.rowContainer.y = 21;
		this.rowContainer.width = this._w-22;
		this.ts.height = this._h-21;
		this.ts.width = this._w - this.rowWidth;
		
		biDesigner.SUPERclass.layout.call(this);
		this.childs = this.documentChilds;
	}
	biDesigner.prototype.getExtendedLayoutInfo = function(){
		return { rowWidth:this.rowWidth };
	}
	biDesigner.prototype.addChild = function(newChild,idx) {
		biDesigner.SUPERclass.addChild.call(this,newChild,idx)
		this.rowContainer = newChild;
		this.rowContainer.setScale(this.ts,this.rowWidth);
		this.layoutChilds = [
			this.bandDecoration,
			this.rowContainer,
			this.ts,
			this.vline,
			this.bottomLine
		]
	}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	var groupDesigner=function(args){
		groupDesigner.SUPERconstructor.call(this,args,"groupDesigner");
		this.rowContainer = this.childs[0]
		
		if(!this.rowContainer)
			this.rowContainer = new icc.ui.panel({});
		this.pl=3;
		this.pb=2;
		this.borderWidth=0;
		this.layoutMode="vertical";
		
		this.layoutChilds = [
			new icc.ui.label({caption:this.caption,fillWidth:true,font:this.font}),
			this.rowContainer
		]
		this.documentChilds = [
			this.rowContainer
		]
		this.childs = this.layoutChilds
	}
	icc.utils.inherit(groupDesigner,icc.ui.panel);
	
	
	groupDesigner.prototype.create = function (){
		groupDesigner.SUPERclass.create.call(this)
		this.childs = this.documentChilds;
	}
	
	groupDesigner.prototype.layout = function (){
		this.childs = this.layoutChilds
		groupDesigner.SUPERclass.layout.call(this);
		this.childs = this.documentChilds;
	}

	groupDesigner.prototype.hitTest = function ( position,exclude ) {
		var item = this.rowContainer;
		if(item){
			var hit = item.hitTest(position,exclude);
			if(hit)
				return hit;
		}		
		return {parent:this.parent,type:"face",tgt:this}
	}

	groupDesigner.prototype.findContainerAt = function(position,exclude){
		var res
		var item = this.rowContainer;
		if(item){
			res = item.findContainerAt(position,exclude);
			if(res)
				return res
			else
				return item;
		}
	}

	


/////////////////////////////////////////////////////////////////////////////////////////////////////////////	



	var  biReportView;
	var controls = [
		{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
			defaults:{
				"#pragma:hideNameProperty": true,
				caption:'label',
				width:120,
				height:20,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				icc.ui.designer.controlproperties.caption,
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				
				icc.ui.designer.controlproperties.align,
				icc.ui.designer.controlproperties.font,
				
			]
		},
		{icon:'drow.png',tooltip:_T('Table row'),type:"ui.row",constructor:biRow,
			defaults:{
				//"#pragma:hideNameProperty": true,
				caption:'row',
				width:120,
				height:20,
				borderWidth:1
			}
		},
		
		{icon:'formula.png',tooltip:_T('Formula'),type:"formula",constructor:biRow,
			defaults:{
				
				caption:'{ formula }',
				width:120,
				height:20,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				icc.ui.designer.controlproperties.caption,
				{caption:'Expresion',type:'string',name:'expresion'},
				{caption:'Format',type:'option',name:'format',values:[
					"integer",
					"fixed",
					"currency",
					"date",
					"datetime",
					"percent"
				]},
				{caption:'Decimals',type:'integer',name:'decimals'},
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.font
			]
		},
		
		{type:"ui.reportheader",constructor:icc.ui.fixedLayoutDesigner,
		
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'},
			    {caption:'Page break',type:'bool',name:'breakAfter','false-is-undefined':true}
			]
			
		},
		
		{type:"ui.pageheader",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'}

			]
			
		},
		{type:"ui.bireportdetails",constructor:biDesigner,
			defaults:{
			},
			properties:[
				{caption:'Hourly scale',type:'bool',name:'hourly'},
				{caption:'Daily scale',type:'bool',name:'daily'},
				{caption:'Show day of week',type:'bool',name:'dayOfWeek'},
				{caption:'Daily totals',type:'bool',name:'dailyTotals'},
				
				{caption:'Monthly scale',type:'bool',name:'monthly'},
				{caption:'Show month name',type:'bool',name:'monthName'},
				{caption:'Monthly totals',type:'bool',name:'monthlyTotals'},
				
				{caption:'Yearly scale',type:'bool',name:'yearly'},
				{caption:'Yearly totals',type:'bool',name:'yearlyTotals'},
				{caption:'Grand totals',type:'bool',name:'grandTotal'}
			]
			
		},
		{type:"rowcontainer",constructor:rowContainer,
			defaults:{
			},
			properties:[
			]
		},		
		
		
		{type:"groupdesigner",constructor:groupDesigner,
			defaults:{
			},
			properties:[
				icc.ui.designer.controlproperties.caption,
//				{caption:'Source',type:'custom',name:'source',customfn:sourceItemDlg},
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.font,
				
				
			]
			
		},		
		
		
		{type:"ui.pagefooter",constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
			},
			properties:[
				{caption:'Print condition',type:'string',name:'printCondition'}
			]
			
		},
		
		
		{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
				"#pragma:hideNameProperty": true,
				width:320,
				height:200,
				borderWidth:1
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,		
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.backColor,
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor
		
			]
		},
		
		{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
		
			defaults:{
				"#pragma:hideNameProperty": true,

				width:90
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.style,
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.penstyle,
				icc.ui.designer.controlproperties.weight			
			]
			
		},
		{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
			defaults:{
				"#pragma:hideNameProperty": true,

				height:80
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.style,
				icc.ui.designer.controlproperties.foreColor,
				icc.ui.designer.controlproperties.penstyle,
				icc.ui.designer.controlproperties.weight			
			]
			
		
		},
		
		{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
			defaults:{
				"#pragma:hideNameProperty": true,
				height:100,
				width:160,
				borderWidth:1,
				borderColor:'gray'
			},
			properties:[
				icc.ui.designer.controlproperties.geometry,		
				{caption:'Print condition',type:'string',name:'printCondition'},
				icc.ui.designer.controlproperties.borderWidth,
				icc.ui.designer.controlproperties.borderColor,
				icc.ui.designer.controlproperties.image
				
			]
		}
	];
	biReportView = function(mainFrame,formDoc){
		var btnaddReportPage;
		var btnParamsSettings = new icc.ui.button({caption:'',tooltip:_T('Params settings'),icon:'filter.png',width:22,height:22,style:"applications.designer/toolbarbutton"});

		// crea el mapa para acceder rapidamente por type
		var self = this;
		var idx;
		
		
		this.controls_map = {};
		
		var toolBoxButtons = [];
		var tool;
		var ctrlInfo;
		
		this.previewWindow = this.previewWindow(formDoc.getName());
		this.previewWindow.caption = _T("Preview");
		
		for (idx=0;idx<controls.length;idx++){
			
			ctrlInfo = controls[idx];
			this.controls_map[ctrlInfo.type]=ctrlInfo; 

			if(ctrlInfo.icon){
				tool = new icc.ui.designerTool({
					style:"applications.designer/toolbarbutton",
				    icon:ctrlInfo.icon,
					tooltip:ctrlInfo.tooltip
				});
				tool.onRequestDropData((function(info){
					return function(){
						// crea una nueva instancia del control usando un el info de tipo
						var ctrldata = info.defaults;// data a guardar en el doc
						if(!ctrldata){
							ctrldata = {};
						}else{
							ctrldata = icc.utils.clone(ctrldata);
						}
						ctrldata.type = info.type;
						//-------------------
						// Aca se traducen siempre los labels de los controles mientras 
						// a los mismos se les realiza "drag & drop" desde la barra de herramientas hacia el formulario.
						if (ctrldata.caption) {
							ctrldata.caption = _T(ctrldata.caption);
						}
						if (ctrldata.type === "ui.tabpanel") {
							$.each(ctrldata.childs || [], function(_, tab) {
								if (tab.caption) {
									tab.caption = _T(tab.caption);
								}
							});
						}
						//-----------------
						var ctrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName(),self.getDocument());
						ctrl.create();
						return ctrl;
					};
				})(ctrlInfo));
				toolBoxButtons.push(tool);

			}
		}
		var args = formDoc.getLayout();
		
		args.fillWidth=true;
		args.fillHeight=true;
		if(args.childs !==undefined){
		
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],formDoc.getApplicationDocument().getName(),formDoc);
			}
		}
		
		this.mainPanel =new icc.ui.fixedLayoutDesigner(args);
		
		this.designerHost = new icc.ui.designerHost({
			fillWidth:true,
			fillHeight:true,
			borderWidth:0,
			childs:[
				this.mainPanel
				//new icc.ui.panel(args)
			]
		});
		// Cambio de la seleccion actual , recibe una array
		this.designerHost.onSelectionChanged(function(newselection){

			formDoc.updateAllViews(this,"selection",newselection);
			
		});
		// Cuando se presiona delete el designerHost borra el control y dispara este evento
		this.designerHost.onRmvControl(function(ctrl,parent){
			var pos,posband
			if(ctrl['band-type']){
				var node = formDoc.findControl(parent.id);
				for (n in node.childs){
					if (node.childs[n].id == ctrl.id){
						pos = n;
						break;
					}
				}
				switch(ctrl['band-type']){
					case "pageheader":
						posband = pos;
					break;
					case "reportdetails":
						posband = pos-1;
					break;
					case "pagefooter":
						posband = pos-2;
					break;
				}
				for (i=1;i<=2;i++){
					formDoc.rmvControl(parent.childs[posband].id);
					parent.rmvChild(parent.childs[posband]);
				}
				parent.layout();
			}
				
			formDoc.rmvControl(ctrl.id);
			formDoc.setDirty(true);
			formDoc.updateAllViews(this,"selection",[]);// con esto logra que la ventana de propiedades se borre

		});
		
		// Luego de que el usuario suelta el control se dispara este evento 
		// y se agrega efectivamente al documento.
		this.designerHost.onNewControl(function(ctrl,parent,undo){
			var node,parentNode;
			var properties = ctrl.getProperties(formDoc);
			var pr;
			
			parentNode = formDoc.findControl(parent.id);
			formDoc.addControl(ctrl.id,ctrl.persistentData,parentNode);
			// agrega la info de layout,en caso de ser un tabitem no tiene, porque no esta wrapeado
			if(typeof ctrl.getLayoutInfo === "function"){
				formDoc.setControlData(ctrl.id,ctrl.getLayoutInfo());
			}else{
				formDoc.setControlData(ctrl.id,{});
			}
			formDoc.setDirty(true);
			if(typeof undo === "undefined" || undo === false){
				formDoc.updateAllViews(this,"selection",[ctrl]);
			
			}

		});
		this.designerHost.onDrag(function(data,pos,tgt){
			if(tgt && data.type == "field"){
				var d = tgt.childs?tgt:tgt.parent;
				var	parentNode = formDoc.findControl(d.id);

				pos = d.screenToClient(pos);
				var ctrl = {
					type:'ui.reportfield',
					field:data.field.name,
					datasource:data.datasourceName,
					"#pragma:hideNameProperty": true,
					caption:"{ "+data.field.name + " }",
					x:pos.x,
					y:pos.y,
					width:120,
					height:15
					
				};
				ctrl = self.buildControl(ctrl,self.getDocument().getApplicationDocument().getName(),self.getDocument());
				ctrl.create();
				d.addChild(ctrl);
				formDoc.addControl(ctrl.id,ctrl.persistentData,parentNode);
				self.designerHost.clearSelection();
				self.designerHost.addToSelection(ctrl);
				formDoc.updateAllViews(self,"selection",[ctrl]);
				d.layout();
				self.designerHost.showSelection();
				formDoc.setDirty(true);
				
				
			}
		});
		// Cuando cambia de position se updatea el documento, recibe la lista
		// de controles movidos y el nuevo contenedor si es que hubo cambio.
		this.designerHost.onChangeCtrlPosition(function(ctrllist,newParent){
			var node,parentNode,idx;
			for (idx =0;idx < ctrllist.length;idx++){
				if(ctrllist[idx].id){ // si no tiene id puede ser un control interno a un control
									// que no aparece en el documento.
					if(newParent){
						parentNode = formDoc.findControl(newParent.id);
						node = formDoc.findControl(ctrllist[idx].id);
						formDoc.rmvControl(ctrllist[idx].id);
						formDoc.addControl(ctrllist[idx].id,node,parentNode);
						formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
					}else{
						formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
					}
				}
			}
			formDoc.updateAllViews(this,"poschanged",ctrllist);
			self.getDocument().setDirty(true);
		});
		// Se produjo un cambio en el zOrder de algun/os controles
		// dentro de un contenedor , los quita todos y los vuelve a inserar acorde
		// al orden de parent.childs
		this.designerHost.onZOrderChanged(function(parent){
		    // obtenemos todos los hijos del nodoparent correspondiente al parent
		    var nchilds = {};
		    var node,parentNode,idx;
		    parentNode= formDoc.findControl(parent.id);
		    for (idx=0;idx<parent.childs.length;idx++){
			nchilds[parent.childs[idx].id]=formDoc.findControl(parent.childs[idx].id,parentNode);
			formDoc.rmvControl(parent.childs[idx].id);
		    }
		    for (idx=0;idx<parent.childs.length;idx++){
				formDoc.addControl(parent.childs[idx].id,nchilds[parent.childs[idx].id],parentNode);
		    }
		    self.getDocument().setDirty(true);

		});
		
		// crea el panel de campos y lo rellena con designerTools 
		
		var addReportBand =function(caption,height,icon, bandType, uiType,pos){
			var newCtrl;
			var ctrldata = {
				"type":uiType,
				"band-type":bandType,
				"borderWidth": 0,
				"width": 1500,
				"x": 0,
				"#pragma:hideNameProperty": true,
				"borderColor": "darkblue",
				"height": height,
				"immovable": true,
				"resizable-w": false,
				"pb":2,
				childs:[
					{
						"type": "ui.panel",
						"bandDecoration":true,
						"layoutMode":"horizontal",
						"hs":4,
						"pt":2,
						"childs": [
						{
							"type": "ui.image",
							"borderWidth": 0,
							"image": "!"+icon,
							"height": 16,
							"width":16
							
						},						
						{
							"type": "ui.label",
							"borderWidth": 1,
							"caption": caption,
							"height": 20
						}],
						"backColor": "#fafafa",
						"borderWidth": 1,
						"fillWidth":true,
						"height": 20,
						"frame":true,
						"resizable": false,
						"unselectable": true
						
					},
				
					{
						"type": "ui.hline",
						"bandDecoration":true,
						"fillWidth": true,
						"sideBottom":true,
						"immovable": true,
						"penStyle": "dashed",
						"weight": 2,
						"foreColor": "darkblue",
						"resizable": false,
						"unselectable": true
					}
				]
			};
			newCtrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName(),self.getDocument());
			newCtrl.create();
			formDoc.addControl(newCtrl.id,ctrldata,formDoc.content,pos);
			self.mainPanel.addChild(newCtrl,pos);
			self.mainPanel.layout();
			self.designerHost.setSelection(newCtrl);
			self.getDocument().setDirty(true);// Esto se hace al final para que se prenda correctamente el boton deshacer
			return newCtrl;
		
		};
		btnParamsSettings.onClick(function(){
			var dlg = new reportParamsDialog(formDoc,formDoc.getApplicationDocument());
			dlg.create();
			dlg.showModal();
			
		});
		btnaddReportPage = new icc.ui.button({caption:'',tooltip:_T('Add report page'),icon:'!reportheader.png',width:22,height:22,style:"applications.designer/toolbarbutton"});
		
		btnaddReportPage.onClick(function(){
		
			var header = addReportBand("Header",60,"pageheader.png","pageheader","ui.pageheader");
			ctrldata = {
				"#pragma:hideNameProperty": true,
				"band-type": "reportdetails",
				"borderWidth": 0,
				"childs": [
					{
						"#pragma:hideNameProperty": true,
						"borderRight": true,
						"borderWidth": 1,
						"childs": [],
						"fillHeight": true,
						"fillWidth": true,
						"immovable": true,
						"isrowContainer": true,
						"type": "rowcontainer",
						"vs": 0,
						"y": 0
					}
				],
				"daily": true,
				"dailyTotals": true,
				"dayOfWeek": true,
				"frame": false,
				"height": 130,
				"hourly": false,
				"immovable": true,
				"monthName": true,
				"monthly": true,
				"monthlyTotals": false,
				"pb": 2,
				"resizable-w": false,
				"rowWidth": 175,
				"type": "ui.bireportdetails",
				"unselectable": false,
				"width": 1500,
				"x": 0,
				"yearly": false,
				"yearlyTotals": true
			}
			var details = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName(),self.getDocument());			
			details.create();
			formDoc.addControl(details.id,ctrldata,formDoc.content);
			self.mainPanel.addChild(details);
			self.mainPanel.layout();
			self.designerHost.setSelection(details);
			self.getDocument().setDirty(true);
			
			
			
			var footer = addReportBand("Footer",80,"pagefooter.png","pagefooter","ui.pagefooter");
		});
		
		var designerPanel = new icc.ui.panel({
		    fillWidth:true,
		    fillHeight:true,
		    x:0,y:0,
		    pl:2,pr:6,pb:6,pt:2,
			caption:_T('Design'),
		    backColor:'#f4f4f4',
		    borderWidth:0,
		    childs:[
				new icc.ui.panel({
				   fillWidth:true,
				   layoutMode:'horizontal',
				   pl:45,
				   
				   childs:[
					new icc.ui.panel({
						pt:2,
						layoutMode:'horizontal',
						childs:[
							new icc.ui.framework.documentView.stdButtonCopy(mainFrame,{caption:'',tooltip:_T('Copy'),icon:'copyIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonPaste(mainFrame,{caption:'',tooltip:_T('Paste'),icon:'pasteIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonUndo(mainFrame,{caption:'',tooltip:_T('Undo'),icon:'undoIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"})
						]
					}),
					new icc.ui.designer.AlignToolbar(formDoc,{}),
					
					new icc.ui.panel({
						pt:2,
						pl:4,
						hs:2,
						layoutMode:'horizontal',
						childs:[
							btnaddReportPage,
							btnParamsSettings
						]
					}),
					new icc.ui.designer.verticalPositionToolbar(formDoc,{})
					
				   ]

				}),
				new icc.ui.panel({

					fillWidth:true,
					fillHeight:true,
					pl:1,
					pr:2,
					hs:2,
					
					backColor:'#f4f4f4',
					borderColor:'#dedede',

					layoutMode:'horizontal',
					childs:[
						new icc.ui.panel({
							fillHeight:true,
							vs:3,
							childs:[
								new icc.ui.panel({layoutMode:'matrix',pr:3,vs:3,hs:3,columns:1,borderWidth:0,childs:toolBoxButtons})
							]
						
						}),
						this.designerHost
					]

				})
		    ]
		});
		var cntx = new icc.ui.tabpanel(	{
		    fillWidth:true,
		    fillHeight:true,
			align:'right',
		    childs:[
				this.previewWindow,
				designerPanel
				
		    ],
			item:1
		});
		cntx.onChange(function(index,item){
			if(item === self.previewWindow)
				self.previewWindow.start();
		});
		jQuery(cntx.childs).each(function(idx,cl){
			cl.captionWidth=70;
		});
		biReportView.SUPERconstructor.call(this,formDoc,{
			haveCloseButton:true,
			caption:formDoc.getName(),
			fillWidth:true,
			fillHeight:true,
			layoutMode:'horizontal',
			style:'applications/designer.designerFrame',
			backColor:'#f4f4f4',
			
			pt:2,
			pr:2,
			pl:5,
			pb:2,
			childs:[
			    new icc.ui.panel({fillHeight:true,borderWidth:0,fillWidth:true,
				
				vs:5,
				childs:[
				    cntx
				]
			    })
			]
		});
	
	};
	icc.utils.inherit(biReportView,icc.ui.framework.documentView.view);
	biReportView.prototype.getSelection = function() {
		// traslada la seleccion del designerHost
		return this.designerHost.getSelection();
	};
	biReportView.prototype.buildControl = function(ctrlData,appName,document){
		var map_data = this.controls_map[ctrlData.type];
		var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true,document:document}
		if(!ctrlData.id){
			ctrlData.id = this.getDocument().generateControlId(ctrlData.type);
		}

		var args = {};
		for (var idx in ctrlData){
			if(ctrlData.hasOwnProperty(idx)){
				args[idx]= ctrlData[idx];
			}
		}
		args._appName =appName;
		if(ctrlData.childs){
			var childs = [];
			for ( idx=0;idx<ctrlData.childs.length;idx++){
				childs.push(this.buildControl(ctrlData.childs[idx],appName,document));
			}
			args.childs = childs;
		}
		args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
		if(map_data){
			var ctrl = new map_data.constructor(args,env);
			// hay que pisar el getProperties ya que no hay manera de tener paneles con 
			// propiedades diferentes
			// solo para los que tienen band-type = algo
			if (map_data.properties){
				ctrl.getProperties = function(){
					return map_data.properties
				}
			}else{
				if (!ctrl.getProperties){
					ctrl.getProperties = function(){
						return []
					}
				}
			}
			/*
			if(args['band-type']){
				ctrl.getProperties = function(){
						return [
							icc.ui.controlproperties.backColor
						//	{caption:'Background',type:'image',name:'background'}
						];
				}
			}
			*/
			return ctrl;
		}else{
			return new icc.ui.panel(args);
		}
	};
	biReportView.prototype.haveCopyPasteInfo=function(){
		return this.designerHost.getSelection().length!==0;
	};
	biReportView.prototype.getCopyPasteInfo=function(){
		var res;
		if(this.designerHost.getSelection().length!==0){
			var doc = this.getDocument();
			res = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				node = doc.findControl(ctrl.id);
				res.push(icc.utils.clone(node));
			});
		}
		return res;
	};
	biReportView.prototype.acceptCopyPasteInfo = function(info){
		// de momento solo se puede copiar dibujos asi que esto es siempre true
		
		return true;
	};
	// paste
	biReportView.prototype.setCopyPasteInfo = function(info){
		var self = this;
		var doc = self.getDocument();
		info = icc.utils.clone(info);
		var fixPastedId = function(node){
			if(doc.checkControlId(node.type,node.id)){
				node.id = doc.generateControlId(node.type,true);

			}
			if(node.childs){
				jQuery.each(node.childs,function(idx,node){
					fixPastedId(node);
				});
			}
			
		}
		var build_pasted_control_tree = function (ctrlData,appName){
			
			var map_data = self.controls_map[ctrlData.type];
			var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true}

			var args = {};
			for (var idx in ctrlData){
				if(ctrlData.hasOwnProperty(idx)){
					args[idx]= ctrlData[idx];
				}
			}
			args._appName =appName;
			if(ctrlData.childs){
				var childs = [];
				for ( idx=0;idx<ctrlData.childs.length;idx++){
					childs.push(build_pasted_control_tree(ctrlData.childs[idx],appName));
				}
				args.childs = childs;
			}
			args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
			if(map_data){
				return new map_data.constructor(args,env);
			}else{
				return new icc.ui.panel(args);
			}
		};
		var build_pasted_control= function(ctrlData,appName){
			self.getDocument().addControl(ctrlData.id,ctrlData,self.getDocument().findControl(self.getDocument().getName()));
			return build_pasted_control_tree(ctrlData,appName);
		};
			
		var ctrls = [];
		jQuery.each(info,function(idx,nodeinfo){
			fixPastedId(nodeinfo);
			var c = build_pasted_control(nodeinfo,self.getDocument().getApplicationDocument().getName());
			ctrls.push(c);
			c.create();
			self.mainPanel.addChild(c);
			// esto es medio contra mano pero ...
			self.designerHost.addUndoAction(function(){
				self.designerHost.clearSelection();
				self.mainPanel.rmvChild(c);
				self.mainPanel.layout();
				self.designerHost.fireEvent("onRmvControl",c,self.mainPanel);
			});
			
		});
		self.mainPanel.layout();
		this.designerHost.setSelection(ctrls);
		self.getDocument().setDirty(true);// Esto se hace al final para que se prenda correctamente el boton deshacer
		return true;
	};
	
	biReportView.prototype.getUndoCount = function(){
		return this.designerHost.getUndoCount();
	};
	biReportView.prototype.goUndo = function(){
		this.designerHost.goUndo();
		this.getDocument().setDirty(true);
	};
	biReportView.prototype.goUserCode = function (src,layout,docInstance){
		var self = this;
		var maskedEval = function (scr,ctx) { 
				// set up an object to serve as the context for the code 
				// being evaluated.  
				var mask = {}; 
				// mask global properties  
		//		for (p in this) 
		//			mask[p] = undefined; 
				for (p in ctx){
					mask[p] = ctx[p];
				}
				// execute script in private context 
				try{
				(new Function( "with(this) { " + scr + "}")).call(mask); 
				}catch(e){
					alert(e);
				}
				
		} 		
		var mapControl = function (control,ctx){
			ctx[control.id] = control;
			if (control.childs){
				jQuery.each(control.childs,function(idx,control){
					mapControl(control,ctx);
				})
			}
		}
		var ctx = {
			thisForm:layout,
			designer:true,
			docInstance:docInstance
		}
		mapControl(layout,ctx)
		maskedEval(src,ctx);
	};
	biReportView.prototype.previewWindow = function(reportName){
		var cntx;
		var self = this;
		var started = false;
		var params;
		var res = new icc.ui.panel({
			fillWidth:true,
			fillHeight:true,
			pr:6,
			pl:2,
			pb:4,
			backColor:'#f4f4f4',
			pt:3,
			childs:[
				
				
			]
		});
		
		res.refresh = function(){
			if(cntx)
				res.rmvChild(cntx);
				
			cntx =  new icc.ui.reportpanel({
				fillWidth:true,
				fillHeight:true,
				reportName:reportName,
				runAtStart:true,
				_appName:self.getDocument().getApplicationDocument().getName()
			});
			cntx.create();
			res.addChild(cntx);
			res.layout();

		};
		res.start = function(){
			if(!started)
				res.refresh();
			started=true;
		};
		res.onCreate(function(){
			params = self.getDocument().getExecutionParameters();
		});
		return res;
	};
	
	biReportView.prototype.onUpdate = function(sender,hint,data){
		var self = this;
		if(hint==="control-properties"){				// fueron seteadas las propiedades de un control
											// data tiene la forma de {ctrl:ctrl,properties:nuevosdatos}
			var newCtrl;						// No tenemos manera de que todos los controles dispongan de sus propiedades en tiempo de ejecucion
			var selection;					// por lo tanto destruimos el control y lo volvemos a crear en el lugar
			var childs =  [];
			var tchilds;
			var ctrl = data.ctrl.visibleControl?data.ctrl.visibleControl:data.ctrl;
			if(data.name === "childs"){
				// aca hay que hacer algo para optimizar , solo regenerar los childs sin regenerar todo
			}else{/*
				if(ctrl.uiclass == "biDesigner"){
					var c = ctrl.getChilds();
					for(var idx=c.length-1;idx>=0;idx--){	// hacia atras porque data.ctrl.childs se va alterando al remover
					
						childs.unshift(c[idx]);				// guarda una copia del control que saca
																			// unshift para mantener el mismo orden en que estaban
						ctrl.rmvChild(c[idx],false);	
						
					}
					
				}else
				*/
				if(ctrl.childs && data.properties.childs ){						// las sacamos del control
					for(var idx=ctrl.childs.length-1;idx>=0;idx--){	// hacia atras porque data.ctrl.childs se va alterando al remover
					
						childs.unshift(ctrl.childs[idx]);				// guarda una copia del control que saca
																			// unshift para mantener el mismo orden en que estaban
						ctrl.rmvChild(ctrl.childs[idx],false);	
						
					}
				}
				tchilds = data.properties.childs;// guardamos los childs para restorear despues
				data.properties.childs = null;		// no queremos que regenere todos los controles hijos de nuevo

			}
			newCtrl = this.buildControl(data.properties,this.getDocument().getApplicationDocument().getName(),this.getDocument());
			if(tchilds!==undefined)
				data.properties.childs = tchilds;// mantenemos la identidad del doc .
			newCtrl.create();
			if(childs.length){						// las agregamos al nuevo control
				for(idx=0;idx<childs.length;idx++){
					newCtrl.addChild(childs[idx]);
				}
				newCtrl.layout();
			}
			//Cuando seleccionamos un control y vamos tocando sus propiedades 
			// el control que viene en data siempre es el mismo
			// llevamos un track en visibleWidget del control que tenemos realmente insertado en el dibujo
			// que despues de la primera vez es distinto al que viene en data
			// como el control tocado esta seleccionado, borramos el dibujo de los handlers
			ctrl.parent.drawUnselected(this.designerHost,ctrl);
			// Cambiamos el control original por el nuevo
			ctrl.parent.replaceChild(ctrl,newCtrl);
			var sel = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				sel.push(ctrl);
			});
			this.designerHost.addUndoAction(function(){
				var d={};
				d[data.name]=data.prevValue;
				self.designerHost.selection = sel;
				self.getDocument().setControlData(ctrl.id,d);
				newCtrl.parent.drawUnselected(self.designerHost,newCtrl);
				newCtrl.parent.replaceChild(newCtrl,ctrl);
				ctrl.parent.drawSelected(self.designerHost,ctrl);
			});
			
			// obtenemos el array de seleccion del dibujador y cambiamos tambien ahi el control
			selection = this.designerHost.getSelection();
			for (idx = 0;idx<selection.length;idx++){
				if(selection[idx] === ctrl){
					selection[idx]=newCtrl;
				}
			}
			// este es el que tenemos insertado		
			data.ctrl.visibleControl = newCtrl;
			// redibujamos todo y volvemos a prender los handlers que pueden estar ahora en distinta posicion
			// si el control cambio de tamaño por algo
			newCtrl.parent.layout();
			newCtrl.parent.drawSelected(this.designerHost,newCtrl);		
			
		}else if (hint === "document-properties") {
			// propiedades del documento cambiaron lo creamos de nuevo
			this.designerHost.clearSelection();
			this.getDocument().updateAllViews(this,"selection",[]);
			var args = this.getDocument().getLayout();
			args.fillWidth=true;
			args.fillHeight=true;
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],this.getDocument().getApplicationDocument().getName(),this.getDocument())
			}			
			
			var cl = new icc.ui.fixedLayoutDesigner(args)
			cl.onCreate(function(){	// con esto evitamos que se ejecute el onCreate normal del form
				cl.fireEvent("onInitialize");
				return false;
			});
			cl.onInitialize = function(cb){
				cl.addListener("onInitialize",cb);
			}

			this.goUserCode(this.getDocument().getLayoutCode(),cl,this.getDocument());

			cl.create();
			this.designerHost.rmvChild(this.designerHost.childs[0])
			this.designerHost.addChild(cl);
			this.designerHost.layout();
		}
	};
	icc.ui.designer.biReportView = biReportView;
})(__icc__);





(function(icc){
	var  dialogView;
	var dialogBand = function ( args ) {
		dialogBand.SUPERconstructor.call(this,args,"panel");
		var self = this;

	}
	icc.utils.inherit(dialogBand,icc.ui.fixedLayoutDesigner);
	dialogBand.prototype.layout = function(){
		dialogBand.SUPERclass.layout.call(this);
	}
	dialogBand.prototype.create = function(){
		dialogBand.SUPERclass.create.call(this);
	}
	dialogBand.prototype.getProperties = function(){
		return [
			icc.ui.designer.controlproperties.backColor,
			icc.ui.designer.controlproperties.background,
			icc.ui.designer.controlproperties.style
			
		]
	}

	var dialogMainBandDesigner=function(args,env){
		this.formDoc = env.document;
		this.formView = env.view;
		
		dialogMainBandDesigner.SUPERconstructor.call(this,args,"panel");
		this.currentSelection = this.childs[0]

	}
	icc.utils.inherit(dialogMainBandDesigner,icc.ui.panel);
	
	
	dialogMainBandDesigner.prototype.create = function (){
		var self = this;
		
		for (k in this.childs){
			var child = this.childs[k]
			child.x = -10000;
			child.y = 0;
			child.fillWidth=undefined;
		}
		if(this.currentSelection){
			this.currentSelection.x = 0;
			this.currentSelection.fillWidth = true;
		}
		dialogMainBandDesigner.SUPERclass.create.call(this);
	};
	dialogMainBandDesigner.prototype.getActivePanel = function(){
		return this.currentSelection;
	}
	/*
	dialogMainBandDesigner.prototype.addChild = function (newChild,pos){
		var self = this;
		if(newChild['band-type'] != undefined){ // cuando el control es regenerado al setear una propiedad
												// se le agregan las bandas de nuevo.
			dialogMainBandDesigner.SUPERclass.addChild.call(this,newChild.pos);
		}else									// si no son bandas el addChild se produce al pastear 
												// por eso agregamos a la pagina actual
			self.currentSelection.addChild(newChild,pos);
	}
	*/
	
	dialogMainBandDesigner.prototype.selectPage = function(pageName){
		for (k in this.childs){
			var child = this.childs[k];
			child.fillHeight=true;
			if(child.id == pageName){
				child.x = 0;
				child.fillWidth =true;
				
				this.currentSelection = child;
			}else{
				child.x = -10000;
				child.fillWidth=undefined;
			}
		}
		this.layout();
		this.parent.layout();
	};
	dialogMainBandDesigner.prototype.layout = function(){
		dialogMainBandDesigner.SUPERclass.layout.call(this);
		if(!this.currentSelection){
			for (k in this.childs){
				var child = this.childs[k];
				if(child.x == 0){
					this.currentSelection = child;
					break;
				}
			}
		}else
			this.currentSelection.layout();
	}
	

	dialogMainBandDesigner.prototype.getProperties = function (){
		return [
			icc.ui.designer.controlproperties.backColor,
			icc.ui.designer.controlproperties.background,
			icc.ui.designer.controlproperties.style
		]

	}

	dialogMainBandDesigner.prototype.hitTest = function ( position,exclude ) {
		var item = this.currentSelection;
		if(item){
			var hit = item.hitTest(position,exclude);
			if(!hit){
				 return {parent:this.parent,type:"client",tgt:item}
			}
			return hit;
		}else{
			return {parent:this.parent,type:"face",tgt:this}
		}
	}

	dialogMainBandDesigner.prototype.findContainerAt = function(position,exclude){
		var res
		var item = this.currentSelection;
		if(item){
			res = item.findContainerAt(position,exclude);
			if(res)
				return res
			else
				return item;
		}
	}
	icc.ui.dialogMainBandDesigner =  dialogMainBandDesigner;

	var dialogToolbar=function(args,env,document,view,dlgMain,hostDesigner){
		this.formDoc = document;
		this.formView = view;
		this.dlgMain = dlgMain;
		this.hostDesigner = hostDesigner;
		dialogToolbar.SUPERconstructor.call(this,args);
		this.pages = []
		var self = this;
	}
	icc.utils.inherit(dialogToolbar,icc.ui.panel);
	
	dialogToolbar.prototype.updateDlgMain = function (dlgMain){
		this.dlgMain = dlgMain;
	}
	dialogToolbar.prototype.create = function (){
		var self = this;
		<%FRAME:assets.dlgDesignerToolbar%>
		var page_name = {}
		var items = []
		for (k in this.dlgMain.childs){
			page_name[this.dlgMain.childs[k].id] = this.dlgMain.childs[k].id
			items.push({id:this.dlgMain.childs[k].id ,text:this.dlgMain.childs[k].id });
		}
		
		self.currentSelection =self.dlgMain.currentSelection;
		this.childs=[
			dlgDesignerToolbar
		]
		var storeRules = function (){
			self.formDoc.setControlData(self.currentSelection.id,{rules:self.currentSelection.rules});
			self.formDoc.setDirty(true);
		}
		
		cbDlgPage.items = items;
		
		cbDlgPage.item=self.currentSelection.id;
		// cambio de screen
		
		cbDlgPage.onChange(function(index,text,item){
			self.hostDesigner.clearSelection();
			self.dlgMain.selectPage(text);
			self.currentSelection = self.dlgMain.currentSelection;
		});
		// agregar screen
		btnDlgAddPage.onClick(function(){
		
			var dlg = icc.ui.msginput(_T("Enter screen name"), '', 270, _T('New screen'),function(status,text){
				if(status==='ok'){
					if(icc.utils.isValidVariableName(text) && !page_name[text]){
						parentNode = self.formDoc.findControl(self.dlgMain.id);

						var newCtrl;
						var ctrldata = {
							"borderWidth": 0,
							"childs": [],
							"fillHeight": true,
							"fillWidth": true,
							"id": text,
							"immovable": true,
							"resizable": false,
							"rules": [],
							"type": "ui.panel",
							"gridbk": false

						};
						newCtrl = self.formView.buildControl(ctrldata,self.formDoc.getApplicationDocument().getName(),self.formDoc);
						newCtrl.y = 0;
						newCtrl.create();
						self.formDoc.addControl(newCtrl.id,ctrldata,parentNode);
						
						self.hostDesigner.clearSelection();
						
						page_name[text]=text;
						self.dlgMain.addChild(newCtrl);
						self.dlgMain.selectPage(text);
						self.currentSelection = newCtrl;
						self.formDoc.setDirty(true);
						cbDlgPage.addItem({id:text,text:text})
						cbDlgPage.setItem(text);
						return true;
					}else{
						dlg.displayMessage(icc.ui.message('invalid_filename',{description:_T("Invalid page name")}));
					}
					return false; // no cierra, esperamos a que createResourceFile termine
				}
			});
		});
		// Remover screen
		btnDlgRmvPage.onClick(function(){
			icc.ui.msgbox(_T('Please, confirm delete this object'),undefined,"question",
				function(status){
					if(status==="ok")
					{
						self.formDoc.rmvControl(self.currentSelection.id);
						self.formDoc.setDirty(true);
						self.formDoc.updateAllViews(this,"selection",[]);// con esto logra que la ventana de propiedades se borre
						self.dlgMain.rmvChild(self.currentSelection);
						page_name[self.currentSelection.id]=null;
						cbDlgPage.rmvItem(self.currentSelection.id);
						var item = cbDlgPage.getItem();
						if (!item){
							cbDlgPage.setItem(self.dlgMain.childs[0].id);
							item = cbDlgPage.getItem();
						}
						self.dlgMain.selectPage(item.id);
						self.currentSelection = self.dlgMain.currentSelection;
					}
				}
			)
		});
		// popup de reglas
		btnTransitionRules.onClick(function(){
			<%FRAME:assets.dlgRulesPanel%> 
			dlgRulesPanel.borderWidth=1;
			var wnd = dlgRulesPanel;
			wnd.parent = p;
			self.currentSelection.rules = self.currentSelection.rules || [];
			ckFinish.checked = self.currentSelection.enableFinish;
			ruleEntriesPanel.overflowy="scroll"
			ckFinish.onChange(function(value){
				self.currentSelection.enableFinish = value;
				self.formDoc.setControlData(self.currentSelection.id,{enableFinish:value});
				self.formDoc.setDirty(true);
				
			});
			for (k in self.dlgMain.childs){
				if(self.dlgMain.childs[k].id != self.currentSelection.id){
					cbDefaultNextScreen.items.push({id:self.dlgMain.childs[k].id,text:self.dlgMain.childs[k].id});
				}
			}
			cbDefaultNextScreen.item = self.currentSelection.defaultNextScreen;
			pbClearDefaultScreen.onClick(function(){
				cbDefaultNextScreen.setItem(-1);
				self.currentSelection.defaultNextScreen=undefined;
				self.formDoc.setControlData(self.currentSelection.id,{defaultNextScreen:undefined});
				self.formDoc.setDirty(true);		
				
			});
			cbDefaultNextScreen.onChange(function(idx,text,item){
				self.currentSelection.defaultNextScreen=text;
				self.formDoc.setControlData(self.currentSelection.id,{defaultNextScreen:text});
				self.formDoc.setDirty(true);		
			});
			var buildRuleEntry = function (index){
				var res = new icc.ui.panel({fillWidth:true,layoutMode:'horizontal'});
				<%FRAME:assets.dlgruletemplate%> 
				<%FRAME:assets.dlgruletemplateexpr%>
				var buildAvailableRules = function (){
					var res = []
					self.currentSelection.eachCtrl(function(ctrl){
						if(ctrl.id != self.currentSelection.id &&
						   (ctrl.uiclass == "textinput"  ||
							ctrl.uiclass == "optionbutton" ||
							ctrl.uiclass == "checkbutton" || 
							ctrl.uiclass == "combobox")
						){
							res.push({id:ctrl.id,text:_T(ctrl.caption) || ctrl.id,target:ctrl.id})
						}
					});
					return res;
				}
				
				// Agregar otra regla
				var addRuleClick=function(){
					var ruleEntry = {__seed:true}
					
					self.currentSelection.rules.splice(index+1,0,ruleEntry);
					var newEntry = buildRuleEntry(index+1)
					newEntry.create();
					ruleEntriesPanel.addChild(newEntry,index+1);
					ruleEntriesPanel.layout();
					storeRules();
				};
				btnAddRule.onClick(addRuleClick)
				btnAddRule2.onClick(addRuleClick)
				
				// Remover la regla actual
				var rmvRuleClick = function(){
					self.currentSelection.rules.splice(index,1);
					ruleEntriesPanel.rmvChild(ruleEntriesPanel.childs[index]);
					ruleEntriesPanel.layout();
					storeRules();
				};
				btnRmvRule.onClick(rmvRuleClick);
				btnRmvRule2.onClick(rmvRuleClick);
				
				cbControl.items = buildAvailableRules();
				cbOperator.items = [
					{id:'==',text:'=='},
					{id:'!=',text:'!='},
					{id:'>',text:'>'},
					{id:'>=',text:'>='},
					{id:'<',text:'&lt;'},
					{id:'<=',text:'<='}
				],
				cbRuleScreen.items = [];
				cbRuleScreen2.items =[];
				for (k in self.dlgMain.childs){
					if(self.dlgMain.childs[k].id != self.currentSelection.id){
						cbRuleScreen.items.push({id:self.dlgMain.childs[k].id,text:self.dlgMain.childs[k].id});
						cbRuleScreen2.items.push({id:self.dlgMain.childs[k].id,text:self.dlgMain.childs[k].id});
					}
				}
				cbControl.item = self.currentSelection.rules[index].target;
				cbOperator.item = self.currentSelection.rules[index].operator;
				txRuleExpr.text = self.currentSelection.rules[index].expr;
				cbRuleScreen.item = self.currentSelection.rules[index].pageName;
				cbRuleScreen2.item = self.currentSelection.rules[index].pageName;
				
				cbControl.onChange(function(idx,text,item){
					self.currentSelection.rules[index].target = item.id;
					storeRules();
				});
				cbOperator.onChange(function(idx,text,item){
					self.currentSelection.rules[index].operator = item.id;
					storeRules();
				});
				txRuleExpr.onChange(function(value){
					self.currentSelection.rules[index].expr = value;
					storeRules();
				})
				
				cbRuleScreen.onChange(function(idx,text,item){
					self.currentSelection.rules[index].pageName = item.id;
					storeRules();
				});
				cbRuleScreen2.onChange(function(idx,text,item){
					self.currentSelection.rules[index].pageName = item.id;
					storeRules();
				});
				txRuleExpresion.text =self.currentSelection.rules[index].expresion;
				self.currentSelection.rules[index].isExpr = self.currentSelection.rules[index].isExpr || false;
				dlgruletemplate.visible = self.currentSelection.rules[index].isExpr ==  false;
				
				dlgruletemplateexpr.visible = self.currentSelection.rules[index].isExpr == true;
				var ckisExp = new icc.ui.checkbutton({width:16,height:16,y:2,checked:self.currentSelection.rules[index].isExpr==true})
				ckisExp.onChange(function(value){
					self.currentSelection.rules[index].isExpr = value;
					dlgruletemplateexpr.setVisible(value);
					dlgruletemplate.setVisible(!value);
					res.layout();
					storeRules();

				});
				txRuleExpresion.onChange(function(value){
					self.currentSelection.rules[index].expresion = value;
					storeRules();
				});
				res.childs = [
					ckisExp,
					dlgruletemplate,
					dlgruletemplateexpr,
					
				]
				return res;
			}
			ruleEntriesPanel.vs = 1;
			if(self.currentSelection.rules.length){
				for (k in self.currentSelection.rules )
					ruleEntriesPanel.childs.push(buildRuleEntry(parseInt(k)));
			}else{
				
				if(self.currentSelection.rules.length == 0){
					self.currentSelection.rules.push({__seed:true});
					ruleEntriesPanel.childs.push(buildRuleEntry(0));
					
				}			
			}
			var dlg = new icc.ui.dialog({
				childs:[
					wnd
				]
			})
			dlg.create();
			
			btnDlgCloseRules.onClick(function(){
				dlg.close();
			});
			dlg.showModal();
		});
		dialogToolbar.SUPERclass.create.call(this)
	}

	
	
	var controls = [
	
		{type:"ui.dlgmain",constructor:icc.ui.dialogMainBandDesigner,
			defaults:{
			}
		
		},
		{type:"ui.designer.dlgband",constructor:dialogBand,
			defaults:{
			}
		
		},
		
		{icon:'labelIcon.png',tooltip:_T('Label'),type:"ui.label",constructor:icc.ui.label,
			defaults:{
				caption:'label',
				width:120,
				height:20,
				borderWidth:1
			}
		},
		{icon:'errorBoxIcon.png',tooltip:_T('Error box'),type:"ui.errorbox",constructor:icc.ui.errorbox,
			defaults:{
				caption:'ready',
				
				width:120,
				height:20,
				borderWidth:1
			}
		},		
		{icon:'textInputIcon.png',tooltip:_T('Text input'),type:"ui.textinput",constructor:icc.ui.textinput,
			defaults:{
				width:150,
				height:20
			}
		},
		

		
		{icon:'buttonIcon.png',type:"ui.button",tooltip:_T('Button'),constructor:icc.ui.button,
			defaults:{
				caption:'button',
				width:120,
				height:30
			}
		},
		{icon:'checkboxIcon.png',type:"ui.checkbutton",tooltip:_T('Check button'),constructor:icc.ui.checkbutton,
			defaults:{
				caption:'check',
				width:60,
				height:20
				
			}
		},
		{icon:'radioButtonIcon.png',type:"ui.optionbutton",tooltip:_T('Option button'),constructor:icc.ui.optionbutton,
			defaults:{
				caption:'option',
				width:60,
				height:20
			}

		},
		{icon:'selectIcon.png',type:"ui.combobox",tooltip:_T('Combobox'),constructor:icc.ui.combobox,
			defaults:{
				width:100,
				height:20
			}
		},
		{icon:'panelIcon.png',type:"ui.panel",tooltip:_T('Panel'),constructor:icc.ui.fixedLayoutDesigner,
			defaults:{
				width:320,
				height:200,
				borderWidth:1
			}
		},
		{icon:'tabPanelIcon.png',type:"ui.tabpanel",tooltip:_T('Tab panel'),constructor:icc.ui.tabDesigner,
			defaults:{
				width:320,
				height:240,
				item:0,
				childs:[
					{type:"ui.tabitem",caption:"tab 1"}
				]
			}
		},
		{type:"ui.tabitem",constructor:icc.ui.fixedLayoutDesigner},
		{icon:'gridIcon.png',type:"ui.grid",tooltip:_T('Grid'),constructor:icc.ui.grid,
			defaults:{
				width:320,
				height:200,
				borderWidth:1,
				mustTranslate: false,
				columns:[
					{caption: _T('column 1'),width:100,field:''},
					{caption:_T('column 2'),width:100,field:''},
					{caption:_T('column 3'),width:100,field:''}
				]
			}
		},
		{icon:'treeIcon.png',type:"ui.tree",tooltip:_T('Tree'),constructor:icc.ui.tree,
		
			defaults:{
				
				width:180,
				height:220,
				borderWidth:1
			}
		
		},
		{icon:'horizontalLineIcon.png',type:"ui.hline",tooltip:_T('Horizontal line'),constructor:icc.ui.hline,
		
			defaults:{
				width:90
			}
		},
		{icon:'verticalLineIcon.png',type:"ui.vline",tooltip:_T('Vertical line'),constructor:icc.ui.vline,
			defaults:{
				height:80
			}
		
		},
		{icon:'menuIcon.png',	type:"ui.menu",tooltip:_T('Menu'),constructor:icc.ui.menu,
			defaults:{
				height:30,
				width:330,
				items:[
					{caption:_T('File'),
						items:[
							{caption:_T('New')},
							{caption:_T('Open')},
						]
					},
					{caption:_T('Edit'),
						items:[
							{caption:_T('Copy')},
							{caption:_T('Paste')}
						]
					},
					{caption:_T('Help')}
					
				]
			}
		},
		{icon:'uploader.png',type:"ui.uploader",tooltip:_T('Upload button'),constructor:icc.ui.uploader,
			defaults:{
				height:22,
				width:22,
				caption:'..'
			}
		},

		{icon:'progressbar.png',	type:"ui.progressbar",tooltip:_T('Progress bar'),constructor:icc.ui.progressbar,
			defaults:{
				height:20,
				width:100
				
			}
		},		
		{icon:'picturebox.png',	type:"ui.image",tooltip:_T('Image'),constructor:icc.ui.image,
			defaults:{
				height:100,
				width:160,
				borderWidth:1,
				borderColor:'gray'
			}
		},

		{icon:'clock.png',type:"ui.sdkdispositioncode",tooltip:_T('Disposition Code'),constructor:icc.ui.sdkdispositioncode,
			defaults:{
				height:110,
				width:310,
				borderWidth:0,
				borderColor:'gray',
				reschedule:true,
				sameagent:true
			}
		},		
		{icon:'report.png',type:"ui.reportpanel",tooltip:_T('Report container'),constructor:icc.ui.reportpanel,
			defaults:{
				height:110,
				width:310,
				borderWidth:0,
				borderColor:'gray'
			}
		}
		
		

	];
	dialogView = function(mainFrame,formDoc){
		formDoc.getProperties = function(){
			return [
				{caption:'Runtime mode',type:'option',name:'runtimeMode',values:[{value:'wizard', caption: _T('wizard')}, {value:'page', caption: _T('page')}]},
				{type: 'bool', caption: 'Centered', name: 'centered'},
				
				{type: 'string', caption: 'BackColor', name: 'backColor'},
				icc.ui.designer.controlproperties.style				
			]
		}
		// crea el mapa para acceder rapidamente por type
		var self = this;
		this.controls_map = {};
		
		var toolBoxButtons = [];
		var tool;
		var ctrlInfo;
		this.codeEditor = new icc.ui.codeeditor({fillWidth:true,fillHeight:true,multiLine:true,text:formDoc.getCodeBehind(),lineNumbers:true,language:"javascript",borderColor:'#dedede'});
		
		var editorTab = new icc.ui.panel({
			fillWidth:true,fillHeight:true,
			caption: _T("Code"),
			backColor:'#f4f4f4',
			pt:26,
			childs:[
				new icc.ui.hline({fillWidth:true,foreColor:'lightGray'}),
				
				this.codeEditor
			]
		})
		this.previewWindow = this.previewWindow();
		this.previewWindow.caption = _T("Preview");
		
		for (var idx=0;idx<controls.length;idx++){
			
			ctrlInfo = controls[idx];
			this.controls_map[ctrlInfo.type]=ctrlInfo; 

			if(ctrlInfo.icon){
				tool = new icc.ui.designerTool({
					style:"applications.designer/toolbarbutton",
				    icon:ctrlInfo.icon,
					tooltip:ctrlInfo.tooltip
				});
				tool.onRequestDropData((function(info){
					return function(){
						// crea una nueva instancia del control usando un el info de tipo
						var ctrldata = info.defaults;// data a guardar en el doc
						if(!ctrldata){
							ctrldata = {};
						}else{
							ctrldata = icc.utils.clone(ctrldata);
						}
						ctrldata.type = info.type;
						//-------------------
						// Aca se traducen siempre los labels de los controles mientras 
						// a los mismos se les realiza "drag & drop" desde la barra de herramientas hacia el formulario.
						if (ctrldata.caption) {
							ctrldata.caption = _T(ctrldata.caption);
						}
						if (ctrldata.type === "ui.tabpanel") {
							$.each(ctrldata.childs || [], function(_, tab) {
								if (tab.caption) {
									tab.caption = _T(tab.caption);
								}
							});
						}
						//-----------------
						var ctrl = self.buildControl(ctrldata,self.getDocument().getApplicationDocument().getName(),self.getDocument());
						ctrl.create();
						return ctrl;
					};
				})(ctrlInfo));
				toolBoxButtons.push(tool);

			}
		}
		var args = formDoc.getLayout();
		
		args.fillWidth=true;
		args.fillHeight=true;
		if(args.childs !==undefined){
		
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],formDoc.getApplicationDocument().getName(),formDoc);
				if(args.childs[idx]["band-type"]== "dialogMain")
					this.dlgMain = args.childs[idx];
				
			}
		}
		
		this.mainPanel =new icc.ui.fixedLayoutDesigner(args);
		
		
		this.goUserCode(formDoc.getLayoutCode(),c,formDoc);
		this.designerHost = new icc.ui.designerHost({
			fillWidth:true,
			fillHeight:true,
			borderWidth:0,
			childs:[
				this.mainPanel
			]
		});
		
		this.dlgToolbar = new dialogToolbar({},{},formDoc,this,this.dlgMain,this.designerHost);
		
		// Cambio de la seleccion actual , recibe una array
		this.designerHost.onSelectionChanged(function(newselection){

			formDoc.updateAllViews(this,"selection",newselection);
			
		});
		// Cuando se presiona delete el designerHost borra el control y dispara este evento
		this.designerHost.onRmvControl(function(ctrl,parent){
			formDoc.rmvControl(ctrl.id);
			formDoc.setDirty(true);
			formDoc.updateAllViews(this,"selection",[]);// con esto logra que la ventana de propiedades se borre

		});
		
		// Luego de que el usuario suelta el control se dispara este evento 
		// y se agrega efectivamente al documento.
		this.designerHost.onNewControl(function(ctrl,parent,undo){
			var node,parentNode;
			var properties = ctrl.getProperties(formDoc);
			var pr;
			
			parentNode = formDoc.findControl(parent.id);
			formDoc.addControl(ctrl.id,ctrl.persistentData,parentNode);
			// agrega la info de layout,en caso de ser un tabitem no tiene, porque no esta wrapeado
			if(typeof ctrl.getLayoutInfo === "function")
				formDoc.setControlData(ctrl.id,ctrl.getLayoutInfo());
			else
				formDoc.setControlData(ctrl.id,{});
			formDoc.setDirty(true);
			if(typeof undo === "undefined" || undo === false)
				formDoc.updateAllViews(this,"selection",[ctrl]);

		});
		// Cuando cambia de position se updatea el documento, recibe la lista
		// de controles movidos y el nuevo contenedor si es que hubo cambio.
		this.designerHost.onChangeCtrlPosition(function(ctrllist,newParent){
			var node,parentNode;
			for (var idx =0;idx < ctrllist.length;idx++){
				if(newParent){
					parentNode = formDoc.findControl(newParent.id);
					node = formDoc.findControl(ctrllist[idx].id);
					formDoc.rmvControl(ctrllist[idx].id);
					formDoc.addControl(ctrllist[idx].id,node,parentNode);
					formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
				}else{
					formDoc.setControlData(ctrllist[idx].id,ctrllist[idx].getLayoutInfo());
				}
			}
			formDoc.updateAllViews(this,"poschanged",ctrllist);
			self.getDocument().setDirty(true);
		});
		// Se produjo un cambio en el zOrder de algun/os controles
		// dentro de un contenedor , los quita todos y los vuelve a inserar acorde
		// al orden de parent.childs
		this.designerHost.onZOrderChanged(function(parent){
		    // obtenemos todos los hijos del nodoparent correspondiente al parent
		    var nchilds = {};
		    var node,parentNode;
		    parentNode= formDoc.findControl(parent.id);
		    for (var idx=0;idx<parent.childs.length;idx++){
			nchilds[parent.childs[idx].id]=formDoc.findControl(parent.childs[idx].id,parentNode);
			formDoc.rmvControl(parent.childs[idx].id);
		    }
		    for (idx=0;idx<parent.childs.length;idx++){
				formDoc.addControl(parent.childs[idx].id,nchilds[parent.childs[idx].id],parentNode);
		    }
		    self.getDocument().setDirty(true);

		});

		var designerPanel = new icc.ui.panel({
		    fillWidth:true,
		    fillHeight:true,
		    x:0,y:0,
		    pl:2,pr:6,pb:6,pt:2,
			caption:_T('Design'),
		    backColor:'#f4f4f4',
		    borderWidth:0,
		    childs:[
				new icc.ui.panel({
				   fillWidth:true,
				   layoutMode:'horizontal',
				   pl:65,
				   
				   childs:[
					new icc.ui.panel({
						pt:2,
						layoutMode:'horizontal',
						childs:[
							new icc.ui.framework.documentView.stdButtonCopy(mainFrame,{caption:'',tooltip:_T('Copy'),icon:'copyIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonPaste(mainFrame,{caption:'',tooltip:_T('Paste'),icon:'pasteIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"}),
							new icc.ui.framework.documentView.stdButtonUndo(mainFrame,{caption:'',tooltip:_T('Undo'),icon:'undoIcon.png',width:22,height:22,style:"applications.designer/toolbarbutton"})
						]
					}),
					new icc.ui.designer.AlignToolbar(formDoc,{}),
					this.dlgToolbar
					
				   ]

				}),
				new icc.ui.panel({

					fillWidth:true,
					fillHeight:true,
					pl:1,
					pr:2,
					hs:2,
					
					backColor:'#f4f4f4',
					borderColor:'#dedede',

					layoutMode:'horizontal',
					childs:[
						new icc.ui.panel({layoutMode:'matrix',pr:3,vs:3,hs:3,fillHeight:true,borderWidth:0,childs:toolBoxButtons}),
						this.designerHost
					]

				})
		    ]
		});
		var cntx = new icc.ui.tabpanel({
		    fillWidth:true,
		    fillHeight:true,
			align:'right',
		    childs:[
				this.previewWindow,
				editorTab,
				designerPanel
				
		    ],
			item:1
		});
		cntx.onChange(function(index,item){
			if(item === self.previewWindow)
				self.previewWindow.start();
		});
		jQuery(cntx.childs).each(function(idx,cl){
			cl.captionWidth=70;
		});
		dialogView.SUPERconstructor.call(this,formDoc,{
			haveCloseButton:true,
			caption:formDoc.getName(),
			fillWidth:true,
			fillHeight:true,
			layoutMode:'horizontal',
			style:'applications/designer.designerFrame',
			backColor:'#f4f4f4',
			
			pt:2,
			pr:2,
			pl:5,
			pb:2,
			childs:[
			    new icc.ui.panel({fillHeight:true,borderWidth:0,fillWidth:true,
				vs:5,
				childs:[
					cntx
				]
			    })
			]
		});
		this.codeEditor.onChange(function(text){
			formDoc.setCodeBehind(text);
		});
	
		cntx.onCreate(function(){
			setTimeout(function(){
				
				//self.codeEditor.x=0;
				//self.codeEditor.parent.layout();
				cntx.setItem(2);
			},300);
		});

	
	};
	icc.utils.inherit(dialogView,icc.ui.framework.documentView.view);
	dialogView.prototype.getSelection = function() {
		// traslada la seleccion del designerHost
		return this.designerHost.getSelection();
	};
	dialogView.prototype.buildControl = function(ctrlData,appName,document){
		var map_data = this.controls_map[ctrlData.type];
		var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true,document:document,view:this}
		if(!ctrlData.id){
			ctrlData.id = this.getDocument().generateControlId(ctrlData.type);
		}

		var args = {};
		for (var idx in ctrlData){
			if(ctrlData.hasOwnProperty(idx)){
				args[idx]= ctrlData[idx];
			}
		}
		args._appName =appName;
		if(ctrlData.childs){
			var childs = [];
			for ( idx=0;idx<ctrlData.childs.length;idx++){
				childs.push(this.buildControl(ctrlData.childs[idx],appName,document));
			}
			args.childs = childs;
		}
		args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
		if(map_data){
			return new map_data.constructor(args,env);
		}else{
			return new icc.ui.panel(args);
		}
	};
	dialogView.prototype.haveCopyPasteInfo=function(){
		return this.designerHost.getSelection().length!==0;
	};
	dialogView.prototype.getCopyPasteInfo=function(){
		var res;
		if(this.designerHost.getSelection().length!==0){
			var doc = this.getDocument();
			res = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				node = doc.findControl(ctrl.id);
				res.push(icc.utils.clone(node));
			});
		}
		return res;
	};
	dialogView.prototype.acceptCopyPasteInfo = function(info){
		// de momento solo se puede copiar dibujos asi que esto es siempre true
		
		return true;
	};
	// paste
	dialogView.prototype.setCopyPasteInfo = function(info){
		var self = this;
		var doc = self.getDocument();
		info = icc.utils.clone(info);
		var fixPastedId = function(node){
			icc.console.log(" pasted node "+node.id)
			if(doc.checkControlId(node.type,node.id)){
				node.id = doc.generateControlId(node.type,true);
				icc.console.log("reallocated to "+node.id);

			}
			if(node.childs){
				jQuery.each(node.childs,function(idx,node){
					fixPastedId(node);
				});
			}
			
		}
		var build_pasted_control_tree = function (ctrlData,appName){
			
			var map_data = self.controls_map[ctrlData.type];
			var env = {arguments:{},datasources:{},controls:{},forms:{},designer:true}

			var args = {};
			for (var idx in ctrlData){
				if(ctrlData.hasOwnProperty(idx)){
					args[idx]= ctrlData[idx];
				}
			}
			args._appName =appName;
			if(ctrlData.childs){
				var childs = [];
				for ( idx=0;idx<ctrlData.childs.length;idx++){
					childs.push(build_pasted_control_tree(ctrlData.childs[idx],appName));
				}
				args.childs = childs;
			}
			args.persistentData=ctrlData;// esto se usan en onNewControl y es lo que va al documento 
			if(map_data){
				return new map_data.constructor(args,env);
			}else{
				return new icc.ui.panel(args);
			}
		};
			
		var ctrls = [];
		var pasteContainer = self.dlgMain;
		var currentSelection = self.designerHost.getSelection();
		if(currentSelection.length == 1){
			if(currentSelection[0].designerContainer || currentSelection[0].tabDesigner)
				pasteContainer = currentSelection[0];
			
				
		}
		if(pasteContainer.getActivePanel)
			pasteContainer = pasteContainer.getActivePanel();
			
		var minx=10e9
		var miny =10e9;
		
		jQuery.each(info,function(idx,nodeinfo){
			if(nodeinfo.x != undefined)minx = nodeinfo.x<minx?nodeinfo.x:minx;			
			if(nodeinfo.y != undefined)miny = nodeinfo.y<miny?nodeinfo.y:miny;
		});
		var build_pasted_control= function(ctrlData,appName){
			self.getDocument().addControl(ctrlData.id,ctrlData,self.getDocument().findControl(pasteContainer.id));
			return build_pasted_control_tree(ctrlData,appName);
		};
		
		jQuery.each(info,function(idx,nodeinfo){
			fixPastedId(nodeinfo);
			if(nodeinfo.x !== undefined)
				nodeinfo.x = nodeinfo.x + ( 10 - minx);
			if(nodeinfo.y !== undefined)
				nodeinfo.y = nodeinfo.y + ( 10 - miny);
			var c = build_pasted_control(nodeinfo,self.getDocument().getApplicationDocument().getName());
			ctrls.push(c);
			c.create();
			
			pasteContainer.addChild(c);
			// esto es medio contra mano pero ...
			self.designerHost.addUndoAction(function(){
				self.designerHost.clearSelection();
				pasteContainer.rmvChild(c);
				pasteContainer.layout();
				self.designerHost.fireEvent("onRmvControl",c,pasteContainer);
			});
			
		});
		pasteContainer.layout();
		this.designerHost.setSelection(ctrls);
		self.getDocument().setDirty(true);// Esto se hace al final para que se prenda correctamente el boton deshacer
		return true;
	};
	
	dialogView.prototype.getUndoCount = function(){
		return this.designerHost.getUndoCount();
	};
	dialogView.prototype.goUndo = function(){
		this.designerHost.goUndo();
		this.getDocument().setDirty(true);
	};
	dialogView.prototype.goUserCode = function (src,layout,docInstance){
		var self = this;
		var maskedEval = function (scr,ctx) { 
				// set up an object to serve as the context for the code 
				// being evaluated.  
				var mask = {}; 
				// mask global properties  
		//		for (p in this) 
		//			mask[p] = undefined; 
				for (p in ctx){
					mask[p] = ctx[p];
				}
				// execute script in private context 
				try{
				(new Function( "with(this) { " + scr + "}")).call(mask); 
				}catch(e){
					alert(e);
				}
				
		} 		
		var mapControl = function (control,ctx){
			ctx[control.id] = control;
			if (control.childs){
				jQuery.each(control.childs,function(idx,control){
					mapControl(control,ctx);
				})
			}
		}
		var ctx = {
			thisForm:layout,
			designer:true,
			docInstance:docInstance
		}
		mapControl(layout,ctx)
		maskedEval(src,ctx);
	};
	dialogView.prototype.previewWindow = function(){
		var cntx;
		var self = this;
		var started = false;
		var params = [];
		var btnStart = new icc.ui.button({
			width:22,
			height:22,
			icon:'refresh_icon.png',
			style:'applications.designer/toolbarbutton'
		});
		var btnParams = new icc.ui.button({
			width:22,
			height:22,
			style:'applications.designer/toolbarbutton',
			icon:'settings.png'
		});
		var res = new icc.ui.panel({
			fillWidth:true,
			fillHeight:true,
			pr:3,
			backColor:'white',
			childs:[
				
				new icc.ui.panel({
					backColor:'#f4f4f4',
					layoutMode:'horizontal',
					fillWidth:true,
					pl:3,
					hs:2,
					pt:2,
					pb:2,
					pr:2,
					childs:[
						btnStart,
						btnParams
					]
				}),
				new icc.ui.hline({fillWidth:true,foreColor:'lightGray'})
				
			]
		});
		
		res.refresh = function(){
			var args =[];
			var url = location.href.split("/")
			url.pop();
			url.push(self.getDocument().getApplicationDocument().getName()+"."+self.getDocument().getName());
			url = url.join("/");
			jQuery.each(params,function(idx,param){
				args.push(param.name+"="+param.value);
			});
			args.push("debug=true");
			if(icc.utils.browser.is_ie)
				args.push("__tmstmp__="+new Date().getTime())
			url = url +"?"+args.join("&");
			

			
			if(cntx)
				res.rmvChild(cntx);
				
			cntx =  new icc.ui.iframe({
				fillWidth:true,
				fillHeight:true,
				src:url
			});
			cntx.create();
			res.addChild(cntx);
			res.layout();

		};
		res.start = function(){
			if(!started)
				res.refresh();
			started=true;
		};
		btnStart.onClick(function(){
			res.refresh();
		});
		btnParams.onClick(function(){
			<%FRAME:assets.dlgLaunchParameters%>
			var dlg = new icc.ui.dialog({
				childs:[
					dlgLaunchParameters
				]
			});
			var t = []
			jQuery.each(params,function(idx,param){
				t.push({name:param.name,value:param.value,param:param});
			});			
			gdParams.items = t;
			dlg.create();
			dlg.showModal();

			
			params_cancel.onClick(function(){
				dlg.close(false);
			});
			
			
			params_ok.onClick(function(){
				self.getDocument().setExecutionParameters(params,function(status,result){
					if(status){
						dlg.close(true);
					}else{
						icc.ui.displayMessage(result);
					}
				})
				
			});
			var updateParamData = function(){
				var it = gdParams.getItem();
				var vname = icc.utils.trim(txParamName.getText());
				var vvalue = icc.utils.trim(txParamValue.getText());
				
				if(vname!=='' && vvalue!==''){
					btn_rmvParam.setEnabled(true);
					btn_addParam.setEnabled(true);
					if(it){
						it.name = vname;
						it.value = vvalue;
						it.param.value = vvalue
						it.param.name = vname
						gdParams.updateItem(it);
					}
				}else{
					btn_rmvParam.setEnabled(false);
					btn_addParam.setEnabled(false);
				}
		

			}
			txParamName.onChange(updateParamData)
			txParamValue.onChange(updateParamData)
			
			btn_addParam.onClick(function(){
				if(!gdParams.getItem()){
					var param = {name:txParamName.getText(),value:txParamValue.getText()};
					params.push(param);
					gdParams.addItem({name:param.name,value:param.value,param:param});
				}
				txParamName.setText("");
				txParamValue.setText("");
				btn_rmvParam.setEnabled(false);
				btn_addParam.setEnabled(false);
				gdParams.setItem({});
			});
			btn_rmvParam.onClick(function(){
				var it = gdParams.getItem();
				if(it){
					jQuery.each(params,function(idx,param){
						if(it.param === param){
							params.splice(idx,1);
							return false;
						}
					});
					gdParams.rmvItem(it);
					btn_rmvParam.setEnabled(false);
					btn_addParam.setEnabled(false);
					txParamName.setText("");
					txParamValue.setText("");
					
				}
				
			});
			gdParams.onChange(function(item){
				txParamName.setText(item.name);
				txParamValue.setText(item.value);
				btn_addParam.setEnabled(true);
				btn_rmvParam.setEnabled(true);
				
			});
		});
		res.onCreate(function(){
			params = self.getDocument().getExecutionParameters();
		});
		return res;
	};
	
	dialogView.prototype.onUpdate = function(sender,hint,data){
		var self = this;
		if(hint==="control-properties"){				// fueron seteadas las propiedades de un control
											// data tiene la forma de {ctrl:ctrl,properties:nuevosdatos}
			var newCtrl;						// No tenemos manera de que todos los controles dispongan de sus propiedades en tiempo de ejecucion
			var selection;					// por lo tanto destruimos el control y lo volvemos a crear en el lugar
			var childs =  [];
			var tchilds;
			var ctrl = data.ctrl.visibleControl?data.ctrl.visibleControl:data.ctrl;
				
			if(data.name === "childs"){
				// aca hay que hacer algo para optimizar , solo regenerar los childs sin regenerar todo
			}else{
				if(ctrl.childs && data.properties.childs){						// las sacamos del control
					for(var idx=ctrl.childs.length-1;idx>=0;idx--){	// hacia atras porque data.ctrl.childs se va alterando al remover
					
						childs.unshift(ctrl.childs[idx]);				// guarda una copia del control que saca
																			// unshift para mantener el mismo orden en que estaban
						ctrl.rmvChild(ctrl.childs[idx],false);	
						
					}
				}
				tchilds = data.properties.childs;// guardamos los childs para restorear despues
				data.properties.childs = null;		// no queremos que regenere todos los controles hijos de nuevo

			}
			newCtrl = this.buildControl(data.properties,this.getDocument().getApplicationDocument().getName(),this.getDocument());
			if(ctrl == self.dlgMain){
				self.dlgMain = newCtrl;
				self.dlgToolbar.updateDlgMain(self.dlgMain);
			}
			if(tchilds!==undefined)
				data.properties.childs = tchilds;// mantenemos la identidad del doc .
			newCtrl.parent = ctrl.parent;
			newCtrl.create();
			if(childs.length){						// las agregamos al nuevo control
				for(idx=0;idx<childs.length;idx++){
					newCtrl.addChild(childs[idx]);
				}
				newCtrl.layout();
			}
			//Cuando seleccionamos un control y vamos tocando sus propiedades 
			// el control que viene en data siempre es el mismo
			// llevamos un track en visibleWidget del control que tenemos realmente insertado en el dibujo
			// que despues de la primera vez es distinto al que viene en data
			// como el control tocado esta seleccionado, borramos el dibujo de los handlers
			ctrl.parent.drawUnselected(this.designerHost,ctrl);
			// Cambiamos el control original por el nuevo
			ctrl.parent.replaceChild(ctrl,newCtrl);
			var sel = [];
			jQuery.each(this.designerHost.getSelection(),function(idx,ctrl){
				sel.push(ctrl);
			});
			this.designerHost.addUndoAction(function(){
				var d={};
				d[data.name]=data.prevValue;
				self.designerHost.selection = sel;
				self.getDocument().setControlData(ctrl.id,d);
				newCtrl.parent.drawUnselected(self.designerHost,newCtrl);
				newCtrl.parent.replaceChild(newCtrl,ctrl);
				ctrl.parent.drawSelected(self.designerHost,ctrl);
			});
			
			// obtenemos el array de seleccion del dibujador y cambiamos tambien ahi el control
			selection = this.designerHost.getSelection();
			for (idx = 0;idx<selection.length;idx++){
				if(selection[idx] === ctrl){
					selection[idx]=newCtrl;
				}
			}
			// este es el que tenemos insertado		
			data.ctrl.visibleControl = newCtrl;
			// redibujamos todo y volvemos a prender los handlers que pueden estar ahora en distinta posicion
			// si el control cambio de tamao por algo
			newCtrl.parent.layout();
			newCtrl.parent.drawSelected(this.designerHost,newCtrl);		
			
		}else if (hint === "document-properties") {
			// propiedades del documento cambiaron lo creamos de nuevo
			this.designerHost.clearSelection();
			this.getDocument().updateAllViews(this,"selection",[]);
			var args = this.getDocument().getLayout();
			args.fillWidth=true;
			args.fillHeight=true;
			var sel = this.dlgMain.currentSelection.id;
			for (idx =0;idx<args.childs.length;idx++){
				args.childs[idx]= this.buildControl(args.childs[idx],this.getDocument().getApplicationDocument().getName(),this.getDocument())
				if(args.childs[idx]["band-type"]== "dialogMain"){
					this.dlgMain = args.childs[idx];
					this.dlgToolbar.updateDlgMain(this.dlgMain);
				}
			}			
			
			var cl = new icc.ui.fixedLayoutDesigner(args)
			cl.onCreate(function(){	// con esto evitamos que se ejecute el onCreate normal del form
				cl.fireEvent("onInitialize");
				return false;
			});
			cl.onInitialize = function(cb){
				cl.addListener("onInitialize",cb);
			}

			this.goUserCode(this.getDocument().getLayoutCode(),cl,this.getDocument());

			cl.create();
			
			this.designerHost.rmvChild(this.designerHost.childs[0])
			this.designerHost.addChild(cl);
			this.mainPanel = c;
			
			this.dlgMain.selectPage(sel);
			
			this.designerHost.layout();
		}
	};
	icc.ui.designer.dialogView = dialogView;
})(__icc__);


(function (icc) {
	var flowactivity;
	icc.ui.themes.base.flowactivity = {
		font: {
			family: 'arial,sans-serif',
			size: 11,
			weight: 'normal'
		},
		backColor: 'white',
		foreColor: 'black',
	};
	
	flowactivity = function (args, environment,uiclass) {
		args.borderWidth=1;
		args.borderColor="lightgray";
		args._appName=undefined;
		flowactivity.SUPERconstructor.call(this, args,environment,uiclass?uiclass:'flowactivity');
		this.cnpxDivs=[]
	};
	icc.utils.inherit(flowactivity, icc.ui.image);
	
	flowactivity.prototype.getOutputs = function(){
		var res = []
		this.dynamicOutputs = this.dynamicOutputs || []
		for (var i = 0;i<this.dynamicOutputs.length;i++){
			res.push(this.dynamicOutputs[i])
		}
		this.outputs = this.outputs || []
		for (var i = 0;i<this.outputs.length;i++){
			res.push(this.outputs[i])
		}
		return res;
	};
	flowactivity.prototype.getProperties=function(){
		return [];
	};
	flowactivity.prototype.getConnectionPoints = function () {
		var self = this;
		var bwidth=2
		var res = [];
		var p = 1;
		for (var x=5;x<=self._w+1;x+=4){
			res.push({number:p++,x:x-3,y:-2,width:5,height:5,side:icc.ui.line_TOP});
		}
		for (var y=5;y<=self._h+1;y+=4){
			res.push({number:p++,x:this._w,y:y-3,width:5,height:5,side:icc.ui.line_RIGHT});
		}
		for (var x=5;x<=self._w+1;x+=4){
			res.push({number:p++,x:x-3,y:(this._h),width:5,height:5,side:icc.ui.line_BOTTOM});
		}
		for (var y=5;y<=self._h+1;y+=4){
			res.push({number:p++,x:-3,y:y-3,width:5,height:5,side:icc.ui.line_LEFT});
		}
		
		return res
	};
	
	icc.ui.flowactivity = flowactivity;
})(__icc__);




(function(icc){
    var line;
	var lcount=0;
    function line(divParent,x1,y1,dfrom,x2,y2,dto,id,color,data,startLabel){
	
		data = data || {}
		this.id = id || ++lcount;
		lcount = Math.max(this.id,lcount);
		
	    this.from={x:x1,y:y1,d:dfrom}
	    this.to={x:x2,y:y2,d:dto}
	    this.color = color || "black"
		this.delta=data.delta || {__json_object__:true};
	    this.segments = this.lineSegments()
	    this.segmentsNodes = this.lineSegmentsNodes();
	    this.divParent = divParent;
		if(startLabel){
			this.startLabelDv = icc.utils.makeElement("div");
			this.startLabelDv.innerHTML = startLabel;
			jQuery(this.startLabelDv).css({
				position:'absolute',
				fontFamily:'arial,sans-serif',
				fontSize:11,
				fontWeight:'normal',
				color:'#666666'
			})
			divParent.appendChild(this.startLabelDv);
		}
	    for(var i = 0;i<this.segmentsNodes.length;i++){
		    divParent.appendChild(this.segmentsNodes[i])
	    }
		this.updateStartLabel();
	    this.handlers={};
    }
    line_arrow_length=20;
    line_start_length=2;
    line_BOTTOM = 1
    line_LEFT = 3
    line_TOP = 5
    line_RIGHT = 7
	
	
	line.prototype.lineSegmentScreenCoords = function(ls,number){
		var vert = ls.vert;l = ls.l;var x = ls.from.x;var y = ls.from.y;
		var dp = this.delta[this.lineMode+number-1] || 0
		var d = this.delta[this.lineMode+number] || 0;
		var dn = this.delta[this.lineMode+number+1] || 0;
		var arrow = ls.arrow;
		if(vert){
			x+=d;
			var r = false;
			if(number){
				r = this.segments[number-1].from.y !=y
			}else{
				if(this.segments[number+1]){
					r = this.segments[number+1].from.y ==y
				}
			}
			if(!r){
				l+=dn+-dp;
				y+=dp;
			}else{
				l+=-dn+dp;				
				y+=dn;
			}
		}else{
			y+=d;
			var r = false;
			if(number){
				r = this.segments[number-1].from.x !=x
			}else{
				if(this.segments[number+1]){
					r = this.segments[number+1].from.x ==x
				}
			}
			if(!r){
				l+=dn+-dp;
				x+=dp;
			}else{
				l+=-dn+dp;				
				x+=dn;
			}
		}
		if(l<0){
			if(vert){
				y+=l;
				if(arrow){
					if(arrow == "up")
						arrow = "down"
					else
						arrow = "up"
					}
			}else{
				x+=l;
				if(arrow){
					if(arrow == "left")
						arrow = "right"
					else
						arrow = "left"
					}
				
			}
			l*=-1;
		}
			
		
		return {x:x,y:y,l:l,vert:vert,arrow:arrow}
	
	}
    
	line.prototype.updateStartLabel = function(){
		var x,y
		if(this.startLabelDv){
			if(this.segments[0].vert){
				x = this.from.x + 3;
				if(this.segments[0].from.y == this.from.y){ // hacia abajo
					y = this.from.y + 3
				}else{										// hacia arriba
					y = this.from.y - 16
				}
			}else{
				y = this.from.y - 16;
				if(this.segments[0].from.x == this.from.x){ // hacia derecha
					x = this.from.x + 3
				}else{										// hacia izquierda
					x = this.from.x - 3 - jQuery(this.startLabelDv).width();
				}
				
			}
			jQuery(this.startLabelDv).css({
				left:x+"px",
				top:y+"px"
			});
		}
		
	}
    line.prototype.lineSegmentNode = function (ls,number){
		var sc = this.lineSegmentScreenCoords(ls,number)
	    var color = ls.color; 
		var vert = ls.vert;l = sc.l;var x = sc.x;var y = sc.y;var arrow = sc.arrow;
	    var dv = icc.utils.makeElement("div");
	    jQuery(dv).css({
		    position:'absolute',
		    left:(vert?x-3:x)+"px",
		    top:(vert?y:y-3)+"px",
		    zIndex:1000,
		    width:(vert?7:l)+"px",
		    height:(vert?l:7)+"px"
		});
	    var ln = icc.utils.makeElement("div");
	    jQuery(ln).css({
		    position:'absolute',
		    left:(vert?3:(arrow=="left"?7:0))+"px",
		    top:(vert?(arrow=="up"?7:0):3)+"px",
		    background:color || 'black',
		    width:(vert?1:(arrow?l-7:l))+"px",
		    height:(vert?(arrow?l-7:l):1)+"px"
	    })
	    dv.appendChild(ln);
	    if(arrow){
		    var arr = icc.utils.makeElement("div");
		    jQuery(arr).css({
			    position:'absolute',
			    width:"7px",
			    height:"7px",
			    background:icc.ui.getApplication().backgroundImage("arrow_"+arrow+".png"),
			    top:(vert?(arrow=="up"?0:l-7):0)+"px",
			    left:(vert?0:(arrow=="left"?0:l-7))+"px"
		    })	
		    dv.appendChild(arr);
	    }
			    
	    return dv;
    
    }
    line.prototype.lineSegmentsNodes = function(){
	    var res = []
	    for (var i = 0;i<this.segments.length;i++)
		    res.push(this.lineSegmentNode(this.segments[i],i));
	    return res;
    }
    
    line.prototype.lineSegment = function (vert,x,y,l,color,arrow){
	    if(l<0){
		    if(vert)
			    y+=l;
		    else
			    x+=l;
		    l*=-1;
	    }
	    return {
		    vert:vert,
		    from:{x:x,y:y},
		    l:l,
		    arrow:arrow,
		    color:color
	    }
			    
	    return dv;
    }
    line.prototype.removeSegments=function(){
	    for(var i = 0;i<this.segmentsNodes.length;i++){
		    this.divParent.removeChild(this.segmentsNodes[i]);		
	    }
		for(var i in this.handlers){
			this.handlers[i].dv.parentNode.removeChild(this.handlers[i].dv)
		}
		if(this.startLabelDv){
			this.divParent.removeChild(this.startLabelDv);
		}
		
    }
	
    line.prototype.refresh = function(){
	    this.removeSegments();
	    this.segments = this.lineSegments()
	    this.segmentsNodes = this.lineSegmentsNodes();
	    for(var i = 0;i<this.segmentsNodes.length;i++){
		    this.divParent.appendChild(this.segmentsNodes[i])
	    }
		if(this.startLabelDv){
			this.divParent.appendChild(this.startLabelDv);
		}
		this.updateStartLabel();
    }
    line.prototype.lineSegmentsBT = function(){
	    var res=[]
		if(this.to.y - this.from.y >=7){
			if(this.from.x == this.to.x ){
				this.lineMode = 100;
				
				res.push(this.lineSegment(true,this.from.x,this.from.y,this.to.y-this.from.y,this.color,"down"));
				return res;
			}
		}
		if(this.to.y - this.from.y > line_arrow_length){
			this.lineMode = 200;
			
			res.push(this.lineSegment(true,this.from.x,this.from.y,this.to.y-line_arrow_length-this.from.y,this.color));
			res.push(this.lineSegment(false,this.from.x,this.to.y-line_arrow_length,this.to.x-this.from.x,this.color));
			res.push(this.lineSegment(true,this.to.x,this.to.y-line_arrow_length,line_arrow_length,this.color,"down"));
			return res;					
			
		}else{
			if(	this.to.x - this.from.x > line_arrow_length ||
				this.from.x - this.to.x > line_arrow_length){
				this.lineMode = 300;
				res.push(this.lineSegment(true,this.from.x,this.from.y,line_arrow_length,this.color));						
				res.push(this.lineSegment(false,this.from.x,this.from.y+line_arrow_length,this.to.x - this.from.x - line_arrow_length,this.color));	
				res.push(this.lineSegment(true,this.from.x+(this.to.x - this.from.x - line_arrow_length),this.from.y+line_arrow_length,this.to.y-line_arrow_length- (this.from.y+line_arrow_length),this.color));						
				res.push(this.lineSegment(false,this.from.x+(this.to.x - this.from.x - line_arrow_length),this.to.y-line_arrow_length,line_arrow_length,this.color));						
				res.push(this.lineSegment(true,this.to.x,this.to.y-line_arrow_length,line_arrow_length,this.color,"down"));						
				return res;
			}else{
				this.lineMode = 400;
				var l = line_arrow_length;
				if(Math.abs(this.from.x - this.to.x) <= line_arrow_length)
					l*=2;
				res.push(this.lineSegment(true,this.from.x,this.from.y,line_arrow_length,this.color));						
				res.push(this.lineSegment(false,this.from.x,this.from.y+line_arrow_length,- l,this.color));	
				res.push(this.lineSegment(true,this.from.x-l,this.from.y+line_arrow_length,this.to.y-line_arrow_length- (this.from.y+line_arrow_length),this.color));						
				res.push(this.lineSegment(false,this.from.x-l,this.to.y-line_arrow_length,this.to.x- (this.from.x-l),this.color));						
				res.push(this.lineSegment(true,this.to.x,this.to.y-line_arrow_length,line_arrow_length,this.color,"down"));						
				return res;
		
		
			}
		}
    }
    line.prototype.lineSegmentsLT = function(){
	    var res = [];
	    if(this.to.x <= (this.from.x - line_arrow_length)){
		    if(this.to.y - line_arrow_length < this.from.y){
				this.lineMode=500;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,-line_arrow_length,this.color));
			    res.push(this.lineSegment(true,this.from.x-line_arrow_length,this.from.y,(this.to.y-line_arrow_length) - this.from.y ,this.color));
			    res.push(this.lineSegment(false,this.from.x-line_arrow_length,this.to.y-line_arrow_length,this.to.x - (this.from.x-line_arrow_length) ,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y-line_arrow_length,line_arrow_length ,this.color,"down"));			
			    
		    }else { 
				this.lineMode=600;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,this.to.x - this.from.x,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y,this.from.y - this.to.y,this.color,"down"));
		    }
    
	    }else{ 
		    if((this.to.y - line_arrow_length) < this.from.y){ // 5
				this.lineMode=700;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,-line_arrow_length,this.color));
			    res.push(this.lineSegment(true,this.from.x-line_arrow_length,this.from.y, (this.to.y-line_arrow_length) - this.from.y ,this.color));
			    res.push(this.lineSegment(false,this.from.x-line_arrow_length,this.to.y-line_arrow_length,-((this.from.x - line_arrow_length) - this.to.x)  ,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y,-line_arrow_length,this.color,"down"));
		    }else{	
				this.lineMode=800;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,-line_arrow_length,this.color));
			    res.push(this.lineSegment(true,this.from.x-line_arrow_length,this.from.y,-((this.from.y+line_arrow_length) - this.to.y),this.color));
			    res.push(this.lineSegment(false,this.to.x,this.to.y-line_arrow_length, (this.from.x-line_arrow_length) - this.to.x  ,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y,-line_arrow_length ,this.color,"down"));			
		    }
	    }
	    return res;
    } 
    line.prototype.lineSegmentsRT = function(){
	    var res = [];
	    if(this.to.x >= (this.from.x + line_arrow_length)){
		    if(this.to.y - line_arrow_length < this.from.y){
				this.lineMode=900;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,line_arrow_length,this.color));
			    res.push(this.lineSegment(true,this.from.x+line_arrow_length,this.from.y,(this.to.y-line_arrow_length) - this.from.y ,this.color));
			    res.push(this.lineSegment(false,this.from.x+line_arrow_length,this.to.y-line_arrow_length,this.to.x - (this.from.x+line_arrow_length) ,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y-line_arrow_length,line_arrow_length ,this.color,"down"));			
			    
		    }else { 
				this.lineMode=1000;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,this.to.x - this.from.x,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y,this.from.y - this.to.y,this.color,"down"));
		    }
    
	    }else{ 
		    if((this.to.y - line_arrow_length) < this.from.y){ 
				this.lineMode=1100;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,line_arrow_length,this.color));
			    res.push(this.lineSegment(true,this.from.x+line_arrow_length,this.from.y, (this.to.y-line_arrow_length) - this.from.y ,this.color));
			    res.push(this.lineSegment(false,this.from.x+line_arrow_length,this.to.y-line_arrow_length,-((this.from.x + line_arrow_length) - this.to.x)  ,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y,-line_arrow_length,this.color,"down"));
		    }else{	
				this.lineMode=1200;
			    res.push(this.lineSegment(false,this.from.x,this.from.y,line_arrow_length,this.color));
			    res.push(this.lineSegment(true,this.from.x+line_arrow_length,this.from.y,-((this.from.y+line_arrow_length) - this.to.y),this.color));
			    res.push(this.lineSegment(false,this.to.x,this.to.y-line_arrow_length, (this.from.x+line_arrow_length) - this.to.x  ,this.color));
			    res.push(this.lineSegment(true,this.to.x,this.to.y,-line_arrow_length ,this.color,"down"));			
		    }
	    }
	    return res;
    }
    
    line.prototype.lineSegmentsTT = function(){
	    var res = [];
	    if( this.to.y - this.from.y >= line_arrow_length){
	    
		if(	Math.abs(this.to.x - this.from.x)< line_arrow_length
		){
			this.lineMode=1300;
			res.push(this.lineSegment(true,this.from.x,this.from.y,-line_arrow_length,this.color))
			res.push(this.lineSegment(false,this.from.x,this.from.y-line_arrow_length,line_arrow_length,this.color))
	
			res.push(this.lineSegment(true,this.from.x+line_arrow_length,this.from.y-line_arrow_length,(this.to.y-line_arrow_length)-(this.from.y-line_arrow_length),this.color))
			res.push(this.lineSegment(false,this.to.x,this.to.y-line_arrow_length,this.from.x+line_arrow_length-this.to.x,this.color))
			res.push(this.lineSegment(true,this.to.x,this.to.y,-line_arrow_length,this.color,"down"))
		}else{
			this.lineMode=1400;
			res.push(this.lineSegment(true,this.from.x,this.from.y,-line_arrow_length,this.color))
			res.push(this.lineSegment(false,this.to.x,this.from.y-line_arrow_length,this.from.x - this.to.x,this.color))
			res.push(this.lineSegment(true,this.to.x,this.to.y,(this.from.y-line_arrow_length)-this.to.y,this.color,"down"))
	
		}
	    }else{
			this.lineMode=1500;
			res.push(this.lineSegment(true,this.from.x,this.from.y,(this.to.y-line_arrow_length)-this.from.y,this.color))
			res.push(this.lineSegment(false,this.to.x,this.to.y-line_arrow_length,this.from.x - this.to.x,this.color))
			res.push(this.lineSegment(true,this.to.x,this.to.y,-line_arrow_length,this.color,"down"))
	    }
	    return res;
    }
    
    line.prototype.rtTo90 = function(){
	    var dx = this.to.x - this.from.x
	    var dy = this.to.y - this.from.y
	    this.to.y = this.from.y + dx
	    this.to.x = this.from.x + -dy;
    
    }
    line.prototype.rtPoint90 = function(point){
	    var dx = point.x - this.from.x
	    var dy = point.y - this.from.y
	    point.y = this.from.y + dx
	    point.x = this.from.x + -dy;
    
    
    
    }
    line.prototype.rtLineSegments90 = function(lsar){
	    for(var i = 0;i<lsar.length;i++)
		    this.rtLineSegment90(lsar[i])
    }
    line.prototype.rtLineSegment90 = function(ls){
	    // rotacion de la flecha
	    if(!ls.vert){
		    if(ls.arrow == "right")
			    ls.arrow = "down"
		    else if(ls.arrow == "left")
			    ls.arrow = "up"
		    var dx = (ls.from.x + ls.l) - this.from.x;
		    var dy = this.from.y - (ls.from.y + ls.l);
		    this.rtPoint90(ls.from);
	    }else{
		    if(ls.arrow == "up")
			    ls.arrow = "right"
		    else if(ls.arrow == "down")
			    ls.arrow = "left"
		    var dx = ls.from.x  - this.from.x
		    var dy = this.from.y - (ls.from.y + ls.l);
		    ls.l *= -1
		    this.rtPoint90(ls.from);
		    
	    }
	    ls.vert = !ls.vert
	    if(ls.l < 0){
		    if(ls.vert)
			    ls.from.y+=ls.l;
		    else
			    ls.from.x+=ls.l;
		    ls.l*=-1;
	    }
    
    }
    
    line.prototype.lineSegments= function(){
	    var res = [];
		var mprev = this.lineMode;
	    switch(this.from.d){
		    case line_BOTTOM:
			    switch(this.to.d){
				    case line_TOP:
						res = this.lineSegmentsBT();
						return res;
				    break;
				    case line_LEFT:
					    this.rtTo90();
					    
					    res = this.lineSegmentsLT();
					    
					    this.rtTo90();
					    this.rtTo90();
					    this.rtTo90();
    
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    return res;					
				    break;
				    case line_BOTTOM:
					    this.rtTo90();
					    this.rtTo90();
					    res = this.lineSegmentsTT();
					    this.rtTo90();
					    this.rtTo90();
    
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    return res;
				    break;
				    case line_RIGHT:
					    this.rtTo90();
					    this.rtTo90();
					    this.rtTo90();
					    res = this.lineSegmentsRT();
					    this.rtTo90();
					    this.rtLineSegments90(res);
					    return res;
				    break;
    
    
			    }
		    break;
		    case line_LEFT:
			    switch(this.to.d){
				    case line_RIGHT:
					    this.rtTo90();		
					    this.rtTo90();		
					    this.rtTo90();		
					    res = this.lineSegmentsBT();
					    this.rtTo90();		
					    this.rtLineSegments90(res);
					    return res;
				    break;
				    case line_TOP:
					    res = this.lineSegmentsLT();
					    return res;
				    break;
				    case line_LEFT:
					    this.rtTo90();
					    res = this.lineSegmentsTT();
					    this.rtTo90();
					    this.rtTo90();
					    this.rtTo90();
    
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    return res;
				    break;
				    case line_BOTTOM:
					    this.rtTo90();
					    this.rtTo90();
					    
					    res = this.lineSegmentsRT();
					    this.rtTo90();
					    this.rtTo90();
    
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    return res;
				    break;
    
    
    
			    }
		    break;
		    case line_TOP:
			    switch(this.to.d){
				    case line_BOTTOM:
					    this.rtTo90();
					    this.rtTo90();
					    res = this.lineSegmentsBT();
					    this.rtTo90();
					    this.rtTo90();
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    return res;
				    break;
				    case line_RIGHT:
    
					    this.rtTo90();
					    this.rtTo90();
					    this.rtTo90();
					    res = this.lineSegmentsLT();
					    this.rtTo90();
					    this.rtLineSegments90(res);
					    
					    return res;
				    break;
				    case line_TOP:
					    res = this.lineSegmentsTT();
					    return res;
				    break;
				    case line_LEFT:
    
					    this.rtTo90();
					    
					    res = this.lineSegmentsRT();
					    this.rtTo90();
					    this.rtTo90();
					    this.rtTo90();
    
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
    
					    return res;
				    break;
				    
    
    
			    }
			    
		    break;	
		    case line_RIGHT:
			    switch(this.to.d){
				    case line_LEFT:
					    this.rtTo90();
					    
					    res = this.lineSegmentsBT();
					    this.rtTo90();
					    this.rtTo90();		
					    this.rtTo90();		
    
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
					    return res;
				    break;
				    case line_BOTTOM:
					    this.rtTo90();
					    this.rtTo90();
					    res = this.lineSegmentsLT();
					    
					    this.rtTo90();
					    this.rtTo90();
					    this.rtLineSegments90(res);
					    this.rtLineSegments90(res);
						
					    return res;
				    break;
				    case line_RIGHT:
					    this.rtTo90();
					    this.rtTo90();
					    this.rtTo90();
					    res = this.lineSegmentsTT();
					    this.rtTo90();
					    this.rtLineSegments90(res);
					    return res;
				    break;
				    case line_TOP:
					    res = this.lineSegmentsRT();
					    return res;
				    break;
    
			    }
    
		    break;
		    
	    }
	    alert(false);
	    
    }
	line.prototype.moveHandler = function ( handler,position){
		var dx = position.x - (handler.x);
		var dy = position.y - (handler.y);
		if(handler.segment.vert)
			dx+=(handler.x-handler.segment.from.x)
		else
			dy+=(handler.y-handler.segment.from.y)
		
		var dv = this.segmentsNodes[handler.number];
		var self = this;
		var substseg = function(number,s){
			dv = self.lineSegmentNode(s,number)
			if(self.selected){
				jQuery(dv).css({
					background:"yellow",
					opacity:0.4
				});
			}
			var p = self.segmentsNodes[number].parentNode
			p.removeChild(self.segmentsNodes[number])
			self.segmentsNodes[number]=dv;
			p.appendChild(dv);
			var sc = self.lineSegmentScreenCoords(s,number);
			var h = self.handlers[number];
			if(h){
				if(!s.vert){
					h.dv.style.left = sc.x+parseInt(sc.l /2)-3;
				}else{
					h.dv.style.top = sc.y+parseInt(sc.l /2)-3;
				}
				
			}
		}
		if(handler.segment.vert){
			this.delta[this.lineMode+handler.number]=dx-4;
			var sc = this.lineSegmentScreenCoords(handler.segment,handler.number)
			dv.style.left = sc.x-3  + "px";
			handler.dv.style.left = sc.x-3  + "px"
			// Redibuja los segmentos adyacentes considerando el delta
			var s = icc.utils.clone(this.segments[handler.number-1]);
			substseg(handler.number-1,s);
			s = icc.utils.clone(this.segments[handler.number+1]);
			substseg(handler.number+1,s);
		}else{
			this.delta[this.lineMode+handler.number] = dy;
			var sc = this.lineSegmentScreenCoords(handler.segment,handler.number)
			dv.style.top = sc.y-3  + "px";
			handler.dv.style.top = sc.y -3 + "px"
			// Redibuja los segmentos adyacentes considerando el delta
			var s = icc.utils.clone(this.segments[handler.number-1]);
			substseg(handler.number-1,s);
			s = icc.utils.clone(this.segments[handler.number+1]);
			substseg(handler.number+1,s);
		}
		
		
	}
    line.prototype.moveTo = function (x,y,dto){
		
	    this.to={x:x,y:y,d:dto!==undefined?dto:this.to.d}	
		
	    this.refresh();
	    
    }
	line.prototype.translateTo = function(x,y){
		
		if(this.segments.length){
			var vert = this.segments[this.segments.length-1].vert
			var l = this.segments[this.segments.length-1].l
			var dx = x - this.segments[this.segments.length-1].from.x + (!vert?-l:0)
			var dy = y - this.segments[this.segments.length-1].from.y + (vert?-l:0)
			this.from.x +=dx;
			this.from.y +=dy;
			this.to.x +=dx;
			this.to.y +=dy;
			
			for (var i = 0;i<this.segments.length;i++){
				this.segments[i].from.x+=dx;
				this.segments[i].from.y+=dy;
			}
			this.removeSegments();
			this.segmentsNodes = this.lineSegmentsNodes();
			for(var i = 0;i<this.segmentsNodes.length;i++){
				this.divParent.appendChild(this.segmentsNodes[i])
			}
			if(this.startLabelDv){
				this.divParent.appendChild(this.startLabelDv);
			}
			this.updateStartLabel();
			
			
		}
	}
	line.prototype.translateHeadTo = function(x,y){
		if(this.segments.length){
			var dx = x - this.segments[0].from.x
			var dy = y - this.segments[0].from.y
			this.from.x +=dx;
			this.from.y +=dy;
			this.to.x +=dx;
			this.to.y +=dy;
			
			for (var i = 0;i<this.segments.length;i++){
				this.segments[i].from.x+=dx;
				this.segments[i].from.y+=dy;
			}
			this.removeSegments();
			this.segmentsNodes = this.lineSegmentsNodes();
			for(var i = 0;i<this.segmentsNodes.length;i++){
				this.divParent.appendChild(this.segmentsNodes[i])
			}
			if(this.startLabelDv){
				this.divParent.appendChild(this.startLabelDv);
			}
			this.updateStartLabel();
			
		}
	}
	
    line.prototype.moveHeadTo = function (x,y,dfrom){
	    this.from={x:x,y:y,d:dfrom!==undefined?dfrom:this.from.d}	
	    this.refresh();
    }

    line.prototype.stepTo = function (dx,dy){
	    this.to.x+=dx
	    this.to.y+=dy
	    this.refresh();
    }
	line.prototype.hitTest = function (point){
		for(var i in this.handlers){
			var h = this.handlers[i];
			if(point.x >=h.x && point.x <= (h.x+7) && 
				point.y >=h.y && point.y <= (h.y+7)){
					return {type:'line-handler',handler:h,tgt:this,cursorName:h.cursorName}
			}
		}
		for (var i = 0;i<this.segments.length;i++){
			var s = this.segments[i]
			var sc = this.lineSegmentScreenCoords(s,i);
			if(s.vert){
				if(Math.abs(sc.x - point.x) <=6 &&
					point.y >= sc.y && (point.y <= sc.y + sc.l)){
					return {type:'line',tgt:this}
				}
			}else{
				if(Math.abs(sc.y - point.y) <=6 &&
					point.x >= sc.x && (point.x <= sc.x + sc.l)){
					return {type:'line',tgt:this}
				}
			}
		}
	}
	line.prototype.drawSelected = function(designerHost){
		this.selected=true;
		for (var i = 0;i<this.segmentsNodes.length;i++){
			if(i>0 && i<this.segmentsNodes.length-1){
				var dv = icc.utils.makeElement("div");
				var s = this.segments[i];
				var sc = this.lineSegmentScreenCoords(s,i)
				var x = !s.vert?parseInt(sc.x + (sc.l/2)):sc.x;
				var y = !s.vert?sc.y:parseInt(sc.y +(sc.l/2));
				x-=3;
				y-=3;
				var cursor = s.vert?"ew-resize":"ns-resize"
				jQuery(dv).css({
					position:'absolute',
					left:x +"px",
					top:y +"px",
					background:'white',
					cursor:cursor,
					width:"7px",
					height:"7px",
					border:"1px solid gray"
				})
				this.handlers[i]={dv:dv,segment:s,index:i,x:x,y:y,number:i,cursorName:cursor}
				designerHost.getFrontFace().appendChild(dv);
			}
			jQuery(this.segmentsNodes[i]).css({
				background:"yellow",
				opacity:0.4
			});
		}
	}
	
	line.prototype.drawUnselected = function(designerHost){
		this.unselected=true;
		for (var i = 0;i<this.segmentsNodes.length;i++){
			this.segmentsNodes[i].style.background = "";
			jQuery(this.segmentsNodes[i]).css({
				background:"",
				opacity:1
			})
			
		}
		for(var i in this.handlers){
			designerHost.getFrontFace().removeChild(this.handlers[i].dv)
		}
		this.handlers={};
		
	}
	line.prototype.getData = function(){
		return {
			delta:this.delta
		}
	}
    icc.ui.line_BOTTOM = line_BOTTOM;
    icc.ui.line_LEFT = line_LEFT;
    icc.ui.line_TOP = line_TOP;
    icc.ui.line_RIGHT = line_RIGHT;
   	
    icc.ui.designerLine = line;
})(__icc__);	

    

(function(icc){
	icc.ui.designer.showVarSelector = function(formDoc,c,tgt,cb){
		
		var varList = [{
			varname:"__empty__"
		}
		]
		var varHash={
			__empty__:true
		}
		
		var scanVar = function(ctrl){
			if(ctrl.variables ){
				for (var i = 0;i< ctrl.variables.varlist.length;i++){
					var variableData = ctrl.variables.varlist[i]
					if(variableData.varname && !varHash[variableData.varname]){
						varList.push({varname:variableData.varname});
						varHash[variableData.varname]=true;
					}	
				}
			}
			if(ctrl.childs){
				for(var i = 0;i<ctrl.childs.length;i++)
					scanVar(ctrl.childs[i]);
			}
		}
		scanVar(formDoc.getContent())
		var isEscaped = function(str,index){
			var s,e;
			s = str.indexOf("${");
			e = str.lastIndexOf("}");
			return s!==-1 && e!== -1 && s+1< index && e >= index
		}
		
		var pos = c.parent.clientToScreen({x:c.x,y:c.y})
		var width = 270;
		var grid = new icc.ui.grid({

			width:width-2,
			y:-30,
			borderWidth:0,
			columns:[
				{width:width-16,caption:'var name',field:'varname'}
			],
			items:varList,
			height:200
		})
		var cn = new icc.ui.panel({
			borderWidth:1,
			borderColor:'lightgray',
			childs:[
				grid
			]
		})

		grid.onChange(function(item){
			var text = tgt.getText();
			var caret = tgt.getCaretPos();
			var t
			if (isEscaped(text,caret)){
				t = item.varname;
			}else
				t = "${ "+item.varname+" }"
			text = text.substring(0,caret)+t+text.substring(caret);
			tgt.setText(text)
			tgt.setCaretToPos(caret+t.length);
			cn.closePopup();
			cb(true,item.varname)
			
		})
		cn.create();
		cn.showPopup({x:pos.x,y:pos.y+c.height-1})
	}
	
	var promptsCtrl;
	promptsCtrl = function (args,environment,uiclass){
		promptsCtrl.SUPERconstructor.call(this, args,environment,uiclass);
		this.promptList = args.promptList || []
		this.overflowy="scroll";
		//this.layoutMode = "scalable"
	};
	icc.utils.inherit(promptsCtrl,icc.ui.panel);
	var obindex = function (o,a){
		for(var i = 0;i<a.length;i++)
			if(a[i] === o)
				return i;
	};

	promptsCtrl.prototype.create = function (){
		var self = this;
		promptsCtrl.SUPERclass.create.call(this);
		var promptEntryWnd = function ( index,promptData){
			<%FRAME:flowAssets.promptEntryTemplate%>
			promptEntryTemplate.fillWidth=true;
			promptEntryTemplate.width=undefined;
			promptEntryTemplate.layoutMode = "scalable";
			promptEntryTemplate.pr = 20;
			promptEntryTemplate.pb = 5;
			promptEntryTemplate.height = undefined;
			promptDataContainer.height = undefined;
			var promptTTS = function(promptData){
				<%FRAME:flowAssets.promptTTSTemplate%>
				promptTTSTemplate.fillWidth=true;
				promptTTSTemplate.width = undefined;
				promptTTSTemplate.layoutMode = "scalable";
				txTTS.text = promptData.TTSText;
				txTTS.onChange(function(value){
					promptData.TTSText = value;
					self.fireEvent("onChange")
					
				});
				btnSelectVariable.onClick(function(){
					icc.ui.designer.showVarSelector(self.formDoc,btnSelectVariable,txTTS,function(status,varname){
						promptData.TTSText = txTTS.getText();
						self.fireEvent("onChange")
					});
				});
				return promptTTSTemplate;
			}
			var promptAudio = function (promptData){
				<%FRAME:flowAssets.promptAudioTemplate%>
				promptAudioTemplate.fillWidth=true;
				promptAudioTemplate.width = undefined;
				promptAudioTemplate.layoutMode = "scalable";
				
				pbar.caption = promptData.fileName?promptData.fileName:"";
				if(promptData.fileName)
					pbar.value = 100;
				btnUpload.onChange(function(fname){
					pbar.setCaption(fname);
					
				});
				btnUpload.onComplete(function(fname,id){
					var resName = self.formDoc.getName()+"~"+id+"_"+fname;
					self.applicationDoc.addResourceFromFileEx(id,{overwrite:true,filename:resName},function(status,resinfo){
						if(!status){
							icc.ui.displayMessage(resinfo);
						}else{
							promptData.resourceFile = resName;    
							promptData.fileId = id
							promptData.fileName = fname;
							self.fireEvent("onChange")
						}
					});
				});
				btnUpload.onProgress(function(filename,value){
					pbar.setValue(value);
				});
				
				return promptAudioTemplate
			}
			var promptPreload = function (promptDat){
				<%FRAME:flowAssets.promptPreloadTemplate%>
				promptPreloadTemplate.fillWidth=true;
				promptPreloadTemplate.width = undefined;
				promptPreloadTemplate.layoutMode = "scalable";
				txPreloaded.text = promptData.preloadedText;
				txPreloaded.onChange(function(value){
					promptData.preloadedText = value;
					self.fireEvent("onChange")
				});				
				btnSelectVariable2.onClick(function(){
					icc.ui.designer.showVarSelector(self.formDoc,btnSelectVariable2,txPreloaded,function(status,varname){
						promptData.preloadedText = txPreloaded.getText();
						self.fireEvent("onChange")
					});
				});
				
				return promptPreloadTemplate
			}
			
			btnAddPrompt.onClick(function(){
				index = obindex(promptData,self.promptList);
				self.promptList.splice(index+1,0,{_o_:true});
				var c = promptEntryWnd(index+1,self.promptList[index+1]);
				c.create();
				self.addChild(c,index+1);
				self.layout();
				self.childs[0].btnRmvPrompt.setEnabled(self.childs.length>1)
			});
			promptEntryTemplate.btnRmvPrompt = btnRmvPrompt;
			btnRmvPrompt.setEnabled(index>0);
			btnRmvPrompt.onClick(function(){
				index = obindex(promptData,self.promptList);
				self.promptList.splice(index,1);
				self.rmvChild(promptEntryTemplate);
				self.layout();
				self.childs[0].btnRmvPrompt.setEnabled(self.childs.length>1)
				self.fireEvent("onChange")
				
			});
			optTTS.checked = promptData.promptType == "TTS";
			optTTS.onChange(function(value){
				if(value){
					promptData.promptType="TTS";
					var c = promptTTS(promptData);
					c.create();
					if(promptDataContainer.childs[0])
						promptDataContainer.replaceChild(promptDataContainer.childs[0],c)
					else
						promptDataContainer.addChild(c)
					promptDataContainer.layout();
					self.layout();
					self.fireEvent("onChange")
					
				}
			});
			optAudio.checked = promptData.promptType == "AUDIO";
			optAudio.onChange(function(value){
				if(value){
					promptData.promptType="AUDIO";
					var c = promptAudio(promptData);
					c.create();
					if(promptDataContainer.childs[0])
						promptDataContainer.replaceChild(promptDataContainer.childs[0],c)
					else
						promptDataContainer.addChild(c)
					promptDataContainer.layout();
					self.layout();
					self.fireEvent("onChange")
				}
				
			});
			optPreloaded.checked = promptData.promptType == "PRELOAD";
			optPreloaded.onChange(function(value){
				if(value){
					promptData.promptType="PRELOAD";
					var c = promptPreload(promptData);
					c.create();
					if(promptDataContainer.childs[0])
						promptDataContainer.replaceChild(promptDataContainer.childs[0],c)
					else
						promptDataContainer.addChild(c)
					promptDataContainer.layout();
					self.layout();
					self.fireEvent("onChange")
				}
					
			});
			
			
			switch(promptData.promptType){
				case "TTS":
					promptDataContainer.childs.push(promptTTS(promptData));
				break;					
				case "AUDIO":
					promptDataContainer.childs.push(promptAudio(promptData));
				break;					
				case "PRELOAD":
					promptDataContainer.childs.push(promptPreload(promptData));
				break;
			}
			
			
			return promptEntryTemplate
		}
		for (var i = 0;i<this.promptList.length;i++){
			var c = promptEntryWnd(i,this.promptList[i])
			c.create()
			this.addChild(c)
		}
	}
	promptsCtrl.prototype.onChange = function(cb){
		this.addListener("onChange",cb)
	}
	icc.ui.designer.promptsCtrl = promptsCtrl;

})(__icc__);
